var $protobuf = window.protobuf;
$protobuf.roots.default=window;
// Common aliases
var $Reader = $protobuf.Reader, $Writer = $protobuf.Writer, $util = $protobuf.util;

// Exported root namespace
var $root = $protobuf.roots["default"] || ($protobuf.roots["default"] = {});

$root.pattern = (function() {

    /**
     * Namespace pattern.
     * @exports pattern
     * @namespace
     */
    var pattern = {};

    pattern.ActionEvent = (function() {

        /**
         * Properties of an ActionEvent.
         * @memberof pattern
         * @interface IActionEvent
         * @property {string|null} [Id] ActionEvent Id
         * @property {string|null} [Type] ActionEvent Type
         * @property {Array.<string>|null} [NextEvent] ActionEvent NextEvent
         * @property {Array.<string>|null} [CompleteReward] ActionEvent CompleteReward
         * @property {string|null} [SCompleteReward] ActionEvent SCompleteReward
         * @property {number|null} [IntimacyUp] ActionEvent IntimacyUp
         * @property {number|null} [LimitIntimacy] ActionEvent LimitIntimacy
         */

        /**
         * Constructs a new ActionEvent.
         * @memberof pattern
         * @classdesc Represents an ActionEvent.
         * @implements IActionEvent
         * @constructor
         * @param {pattern.IActionEvent=} [properties] Properties to set
         */
        function ActionEvent(properties) {
            this.NextEvent = [];
            this.CompleteReward = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ActionEvent Id.
         * @member {string} Id
         * @memberof pattern.ActionEvent
         * @instance
         */
        ActionEvent.prototype.Id = "";

        /**
         * ActionEvent Type.
         * @member {string} Type
         * @memberof pattern.ActionEvent
         * @instance
         */
        ActionEvent.prototype.Type = "";

        /**
         * ActionEvent NextEvent.
         * @member {Array.<string>} NextEvent
         * @memberof pattern.ActionEvent
         * @instance
         */
        ActionEvent.prototype.NextEvent = $util.emptyArray;

        /**
         * ActionEvent CompleteReward.
         * @member {Array.<string>} CompleteReward
         * @memberof pattern.ActionEvent
         * @instance
         */
        ActionEvent.prototype.CompleteReward = $util.emptyArray;

        /**
         * ActionEvent SCompleteReward.
         * @member {string} SCompleteReward
         * @memberof pattern.ActionEvent
         * @instance
         */
        ActionEvent.prototype.SCompleteReward = "";

        /**
         * ActionEvent IntimacyUp.
         * @member {number} IntimacyUp
         * @memberof pattern.ActionEvent
         * @instance
         */
        ActionEvent.prototype.IntimacyUp = 0;

        /**
         * ActionEvent LimitIntimacy.
         * @member {number} LimitIntimacy
         * @memberof pattern.ActionEvent
         * @instance
         */
        ActionEvent.prototype.LimitIntimacy = 0;

        /**
         * Creates a new ActionEvent instance using the specified properties.
         * @function create
         * @memberof pattern.ActionEvent
         * @static
         * @param {pattern.IActionEvent=} [properties] Properties to set
         * @returns {pattern.ActionEvent} ActionEvent instance
         */
        ActionEvent.create = function create(properties) {
            return new ActionEvent(properties);
        };

        /**
         * Encodes the specified ActionEvent message. Does not implicitly {@link pattern.ActionEvent.verify|verify} messages.
         * @function encode
         * @memberof pattern.ActionEvent
         * @static
         * @param {pattern.IActionEvent} message ActionEvent message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ActionEvent.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.Type != null && message.hasOwnProperty("Type"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.Type);
            if (message.NextEvent != null && message.NextEvent.length)
                for (var i = 0; i < message.NextEvent.length; ++i)
                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.NextEvent[i]);
            if (message.CompleteReward != null && message.CompleteReward.length)
                for (var i = 0; i < message.CompleteReward.length; ++i)
                    writer.uint32(/* id 4, wireType 2 =*/34).string(message.CompleteReward[i]);
            if (message.SCompleteReward != null && message.hasOwnProperty("SCompleteReward"))
                writer.uint32(/* id 5, wireType 2 =*/42).string(message.SCompleteReward);
            if (message.IntimacyUp != null && message.hasOwnProperty("IntimacyUp"))
                writer.uint32(/* id 6, wireType 1 =*/49).double(message.IntimacyUp);
            if (message.LimitIntimacy != null && message.hasOwnProperty("LimitIntimacy"))
                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.LimitIntimacy);
            return writer;
        };

        /**
         * Encodes the specified ActionEvent message, length delimited. Does not implicitly {@link pattern.ActionEvent.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.ActionEvent
         * @static
         * @param {pattern.IActionEvent} message ActionEvent message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ActionEvent.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an ActionEvent message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.ActionEvent
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.ActionEvent} ActionEvent
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ActionEvent.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.ActionEvent();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.Type = reader.string();
                    break;
                case 3:
                    if (!(message.NextEvent && message.NextEvent.length))
                        message.NextEvent = [];
                    message.NextEvent.push(reader.string());
                    break;
                case 4:
                    if (!(message.CompleteReward && message.CompleteReward.length))
                        message.CompleteReward = [];
                    message.CompleteReward.push(reader.string());
                    break;
                case 5:
                    message.SCompleteReward = reader.string();
                    break;
                case 6:
                    message.IntimacyUp = reader.double();
                    break;
                case 7:
                    message.LimitIntimacy = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an ActionEvent message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.ActionEvent
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.ActionEvent} ActionEvent
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ActionEvent.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an ActionEvent message.
         * @function verify
         * @memberof pattern.ActionEvent
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ActionEvent.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.Type != null && message.hasOwnProperty("Type"))
                if (!$util.isString(message.Type))
                    return "Type: string expected";
            if (message.NextEvent != null && message.hasOwnProperty("NextEvent")) {
                if (!Array.isArray(message.NextEvent))
                    return "NextEvent: array expected";
                for (var i = 0; i < message.NextEvent.length; ++i)
                    if (!$util.isString(message.NextEvent[i]))
                        return "NextEvent: string[] expected";
            }
            if (message.CompleteReward != null && message.hasOwnProperty("CompleteReward")) {
                if (!Array.isArray(message.CompleteReward))
                    return "CompleteReward: array expected";
                for (var i = 0; i < message.CompleteReward.length; ++i)
                    if (!$util.isString(message.CompleteReward[i]))
                        return "CompleteReward: string[] expected";
            }
            if (message.SCompleteReward != null && message.hasOwnProperty("SCompleteReward"))
                if (!$util.isString(message.SCompleteReward))
                    return "SCompleteReward: string expected";
            if (message.IntimacyUp != null && message.hasOwnProperty("IntimacyUp"))
                if (typeof message.IntimacyUp !== "number")
                    return "IntimacyUp: number expected";
            if (message.LimitIntimacy != null && message.hasOwnProperty("LimitIntimacy"))
                if (!$util.isInteger(message.LimitIntimacy))
                    return "LimitIntimacy: integer expected";
            return null;
        };

        return ActionEvent;
    })();

    pattern.Building = (function() {

        /**
         * Properties of a Building.
         * @memberof pattern
         * @interface IBuilding
         * @property {string|null} [Id] Building Id
         * @property {string|null} [Source] Building Source
         * @property {string|null} [ShopItems] Building ShopItems
         * @property {number|null} [Limit] Building Limit
         * @property {number|null} [Cost] Building Cost
         * @property {number|null} [StarReward] Building StarReward
         * @property {number|null} [AutoIncome] Building AutoIncome
         * @property {Array.<string>|null} [CustomerInvite] Building CustomerInvite
         * @property {Array.<string>|null} [CatFavors] Building CatFavors
         * @property {Array.<string>|null} [SupportActions] Building SupportActions
         * @property {number|null} [PointCount] Building PointCount
         * @property {string|null} [PointSetting] Building PointSetting
         * @property {number|null} [BelongScene] Building BelongScene
         * @property {number|null} [SpecialTpye] Building SpecialTpye
         * @property {string|null} [SpecialValue] Building SpecialValue
         * @property {number|null} [Magnification] Building Magnification
         * @property {string|null} [SeriesType] Building SeriesType
         * @property {number|null} [OpenOrder] Building OpenOrder
         */

        /**
         * Constructs a new Building.
         * @memberof pattern
         * @classdesc Represents a Building.
         * @implements IBuilding
         * @constructor
         * @param {pattern.IBuilding=} [properties] Properties to set
         */
        function Building(properties) {
            this.CustomerInvite = [];
            this.CatFavors = [];
            this.SupportActions = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Building Id.
         * @member {string} Id
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.Id = "";

        /**
         * Building Source.
         * @member {string} Source
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.Source = "";

        /**
         * Building ShopItems.
         * @member {string} ShopItems
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.ShopItems = "";

        /**
         * Building Limit.
         * @member {number} Limit
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.Limit = 0;

        /**
         * Building Cost.
         * @member {number} Cost
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.Cost = 0;

        /**
         * Building StarReward.
         * @member {number} StarReward
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.StarReward = 0;

        /**
         * Building AutoIncome.
         * @member {number} AutoIncome
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.AutoIncome = 0;

        /**
         * Building CustomerInvite.
         * @member {Array.<string>} CustomerInvite
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.CustomerInvite = $util.emptyArray;

        /**
         * Building CatFavors.
         * @member {Array.<string>} CatFavors
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.CatFavors = $util.emptyArray;

        /**
         * Building SupportActions.
         * @member {Array.<string>} SupportActions
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.SupportActions = $util.emptyArray;

        /**
         * Building PointCount.
         * @member {number} PointCount
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.PointCount = 0;

        /**
         * Building PointSetting.
         * @member {string} PointSetting
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.PointSetting = "";

        /**
         * Building BelongScene.
         * @member {number} BelongScene
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.BelongScene = 0;

        /**
         * Building SpecialTpye.
         * @member {number} SpecialTpye
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.SpecialTpye = 0;

        /**
         * Building SpecialValue.
         * @member {string} SpecialValue
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.SpecialValue = "";

        /**
         * Building Magnification.
         * @member {number} Magnification
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.Magnification = 0;

        /**
         * Building SeriesType.
         * @member {string} SeriesType
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.SeriesType = "";

        /**
         * Building OpenOrder.
         * @member {number} OpenOrder
         * @memberof pattern.Building
         * @instance
         */
        Building.prototype.OpenOrder = 0;

        /**
         * Creates a new Building instance using the specified properties.
         * @function create
         * @memberof pattern.Building
         * @static
         * @param {pattern.IBuilding=} [properties] Properties to set
         * @returns {pattern.Building} Building instance
         */
        Building.create = function create(properties) {
            return new Building(properties);
        };

        /**
         * Encodes the specified Building message. Does not implicitly {@link pattern.Building.verify|verify} messages.
         * @function encode
         * @memberof pattern.Building
         * @static
         * @param {pattern.IBuilding} message Building message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Building.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.Source != null && message.hasOwnProperty("Source"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.Source);
            if (message.ShopItems != null && message.hasOwnProperty("ShopItems"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.ShopItems);
            if (message.Limit != null && message.hasOwnProperty("Limit"))
                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.Limit);
            if (message.Cost != null && message.hasOwnProperty("Cost"))
                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.Cost);
            if (message.StarReward != null && message.hasOwnProperty("StarReward"))
                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.StarReward);
            if (message.AutoIncome != null && message.hasOwnProperty("AutoIncome"))
                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.AutoIncome);
            if (message.CustomerInvite != null && message.CustomerInvite.length)
                for (var i = 0; i < message.CustomerInvite.length; ++i)
                    writer.uint32(/* id 8, wireType 2 =*/66).string(message.CustomerInvite[i]);
            if (message.CatFavors != null && message.CatFavors.length)
                for (var i = 0; i < message.CatFavors.length; ++i)
                    writer.uint32(/* id 9, wireType 2 =*/74).string(message.CatFavors[i]);
            if (message.SupportActions != null && message.SupportActions.length)
                for (var i = 0; i < message.SupportActions.length; ++i)
                    writer.uint32(/* id 10, wireType 2 =*/82).string(message.SupportActions[i]);
            if (message.PointCount != null && message.hasOwnProperty("PointCount"))
                writer.uint32(/* id 11, wireType 0 =*/88).int32(message.PointCount);
            if (message.PointSetting != null && message.hasOwnProperty("PointSetting"))
                writer.uint32(/* id 12, wireType 2 =*/98).string(message.PointSetting);
            if (message.BelongScene != null && message.hasOwnProperty("BelongScene"))
                writer.uint32(/* id 13, wireType 0 =*/104).int32(message.BelongScene);
            if (message.SpecialTpye != null && message.hasOwnProperty("SpecialTpye"))
                writer.uint32(/* id 14, wireType 0 =*/112).int32(message.SpecialTpye);
            if (message.SpecialValue != null && message.hasOwnProperty("SpecialValue"))
                writer.uint32(/* id 15, wireType 2 =*/122).string(message.SpecialValue);
            if (message.Magnification != null && message.hasOwnProperty("Magnification"))
                writer.uint32(/* id 16, wireType 1 =*/129).double(message.Magnification);
            if (message.SeriesType != null && message.hasOwnProperty("SeriesType"))
                writer.uint32(/* id 17, wireType 2 =*/138).string(message.SeriesType);
            if (message.OpenOrder != null && message.hasOwnProperty("OpenOrder"))
                writer.uint32(/* id 18, wireType 0 =*/144).int32(message.OpenOrder);
            return writer;
        };

        /**
         * Encodes the specified Building message, length delimited. Does not implicitly {@link pattern.Building.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.Building
         * @static
         * @param {pattern.IBuilding} message Building message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Building.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Building message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.Building
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.Building} Building
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Building.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.Building();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.Source = reader.string();
                    break;
                case 3:
                    message.ShopItems = reader.string();
                    break;
                case 4:
                    message.Limit = reader.int32();
                    break;
                case 5:
                    message.Cost = reader.int32();
                    break;
                case 6:
                    message.StarReward = reader.int32();
                    break;
                case 7:
                    message.AutoIncome = reader.int32();
                    break;
                case 8:
                    if (!(message.CustomerInvite && message.CustomerInvite.length))
                        message.CustomerInvite = [];
                    message.CustomerInvite.push(reader.string());
                    break;
                case 9:
                    if (!(message.CatFavors && message.CatFavors.length))
                        message.CatFavors = [];
                    message.CatFavors.push(reader.string());
                    break;
                case 10:
                    if (!(message.SupportActions && message.SupportActions.length))
                        message.SupportActions = [];
                    message.SupportActions.push(reader.string());
                    break;
                case 11:
                    message.PointCount = reader.int32();
                    break;
                case 12:
                    message.PointSetting = reader.string();
                    break;
                case 13:
                    message.BelongScene = reader.int32();
                    break;
                case 14:
                    message.SpecialTpye = reader.int32();
                    break;
                case 15:
                    message.SpecialValue = reader.string();
                    break;
                case 16:
                    message.Magnification = reader.double();
                    break;
                case 17:
                    message.SeriesType = reader.string();
                    break;
                case 18:
                    message.OpenOrder = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Building message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.Building
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.Building} Building
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Building.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Building message.
         * @function verify
         * @memberof pattern.Building
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Building.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.Source != null && message.hasOwnProperty("Source"))
                if (!$util.isString(message.Source))
                    return "Source: string expected";
            if (message.ShopItems != null && message.hasOwnProperty("ShopItems"))
                if (!$util.isString(message.ShopItems))
                    return "ShopItems: string expected";
            if (message.Limit != null && message.hasOwnProperty("Limit"))
                if (!$util.isInteger(message.Limit))
                    return "Limit: integer expected";
            if (message.Cost != null && message.hasOwnProperty("Cost"))
                if (!$util.isInteger(message.Cost))
                    return "Cost: integer expected";
            if (message.StarReward != null && message.hasOwnProperty("StarReward"))
                if (!$util.isInteger(message.StarReward))
                    return "StarReward: integer expected";
            if (message.AutoIncome != null && message.hasOwnProperty("AutoIncome"))
                if (!$util.isInteger(message.AutoIncome))
                    return "AutoIncome: integer expected";
            if (message.CustomerInvite != null && message.hasOwnProperty("CustomerInvite")) {
                if (!Array.isArray(message.CustomerInvite))
                    return "CustomerInvite: array expected";
                for (var i = 0; i < message.CustomerInvite.length; ++i)
                    if (!$util.isString(message.CustomerInvite[i]))
                        return "CustomerInvite: string[] expected";
            }
            if (message.CatFavors != null && message.hasOwnProperty("CatFavors")) {
                if (!Array.isArray(message.CatFavors))
                    return "CatFavors: array expected";
                for (var i = 0; i < message.CatFavors.length; ++i)
                    if (!$util.isString(message.CatFavors[i]))
                        return "CatFavors: string[] expected";
            }
            if (message.SupportActions != null && message.hasOwnProperty("SupportActions")) {
                if (!Array.isArray(message.SupportActions))
                    return "SupportActions: array expected";
                for (var i = 0; i < message.SupportActions.length; ++i)
                    if (!$util.isString(message.SupportActions[i]))
                        return "SupportActions: string[] expected";
            }
            if (message.PointCount != null && message.hasOwnProperty("PointCount"))
                if (!$util.isInteger(message.PointCount))
                    return "PointCount: integer expected";
            if (message.PointSetting != null && message.hasOwnProperty("PointSetting"))
                if (!$util.isString(message.PointSetting))
                    return "PointSetting: string expected";
            if (message.BelongScene != null && message.hasOwnProperty("BelongScene"))
                if (!$util.isInteger(message.BelongScene))
                    return "BelongScene: integer expected";
            if (message.SpecialTpye != null && message.hasOwnProperty("SpecialTpye"))
                if (!$util.isInteger(message.SpecialTpye))
                    return "SpecialTpye: integer expected";
            if (message.SpecialValue != null && message.hasOwnProperty("SpecialValue"))
                if (!$util.isString(message.SpecialValue))
                    return "SpecialValue: string expected";
            if (message.Magnification != null && message.hasOwnProperty("Magnification"))
                if (typeof message.Magnification !== "number")
                    return "Magnification: number expected";
            if (message.SeriesType != null && message.hasOwnProperty("SeriesType"))
                if (!$util.isString(message.SeriesType))
                    return "SeriesType: string expected";
            if (message.OpenOrder != null && message.hasOwnProperty("OpenOrder"))
                if (!$util.isInteger(message.OpenOrder))
                    return "OpenOrder: integer expected";
            return null;
        };

        return Building;
    })();

    pattern.CatPhotos = (function() {

        /**
         * Properties of a CatPhotos.
         * @memberof pattern
         * @interface ICatPhotos
         * @property {string|null} [Id] CatPhotos Id
         * @property {string|null} [Type] CatPhotos Type
         * @property {string|null} [Background] CatPhotos Background
         * @property {string|null} [Cat] CatPhotos Cat
         * @property {string|null} [Catroute] CatPhotos Catroute
         * @property {number|null} [Order] CatPhotos Order
         * @property {number|null} [SpecialFunctionType] CatPhotos SpecialFunctionType
         * @property {string|null} [SpecialValue] CatPhotos SpecialValue
         */

        /**
         * Constructs a new CatPhotos.
         * @memberof pattern
         * @classdesc Represents a CatPhotos.
         * @implements ICatPhotos
         * @constructor
         * @param {pattern.ICatPhotos=} [properties] Properties to set
         */
        function CatPhotos(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CatPhotos Id.
         * @member {string} Id
         * @memberof pattern.CatPhotos
         * @instance
         */
        CatPhotos.prototype.Id = "";

        /**
         * CatPhotos Type.
         * @member {string} Type
         * @memberof pattern.CatPhotos
         * @instance
         */
        CatPhotos.prototype.Type = "";

        /**
         * CatPhotos Background.
         * @member {string} Background
         * @memberof pattern.CatPhotos
         * @instance
         */
        CatPhotos.prototype.Background = "";

        /**
         * CatPhotos Cat.
         * @member {string} Cat
         * @memberof pattern.CatPhotos
         * @instance
         */
        CatPhotos.prototype.Cat = "";

        /**
         * CatPhotos Catroute.
         * @member {string} Catroute
         * @memberof pattern.CatPhotos
         * @instance
         */
        CatPhotos.prototype.Catroute = "";

        /**
         * CatPhotos Order.
         * @member {number} Order
         * @memberof pattern.CatPhotos
         * @instance
         */
        CatPhotos.prototype.Order = 0;

        /**
         * CatPhotos SpecialFunctionType.
         * @member {number} SpecialFunctionType
         * @memberof pattern.CatPhotos
         * @instance
         */
        CatPhotos.prototype.SpecialFunctionType = 0;

        /**
         * CatPhotos SpecialValue.
         * @member {string} SpecialValue
         * @memberof pattern.CatPhotos
         * @instance
         */
        CatPhotos.prototype.SpecialValue = "";

        /**
         * Creates a new CatPhotos instance using the specified properties.
         * @function create
         * @memberof pattern.CatPhotos
         * @static
         * @param {pattern.ICatPhotos=} [properties] Properties to set
         * @returns {pattern.CatPhotos} CatPhotos instance
         */
        CatPhotos.create = function create(properties) {
            return new CatPhotos(properties);
        };

        /**
         * Encodes the specified CatPhotos message. Does not implicitly {@link pattern.CatPhotos.verify|verify} messages.
         * @function encode
         * @memberof pattern.CatPhotos
         * @static
         * @param {pattern.ICatPhotos} message CatPhotos message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatPhotos.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.Type != null && message.hasOwnProperty("Type"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.Type);
            if (message.Background != null && message.hasOwnProperty("Background"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.Background);
            if (message.Cat != null && message.hasOwnProperty("Cat"))
                writer.uint32(/* id 4, wireType 2 =*/34).string(message.Cat);
            if (message.Catroute != null && message.hasOwnProperty("Catroute"))
                writer.uint32(/* id 5, wireType 2 =*/42).string(message.Catroute);
            if (message.Order != null && message.hasOwnProperty("Order"))
                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.Order);
            if (message.SpecialFunctionType != null && message.hasOwnProperty("SpecialFunctionType"))
                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.SpecialFunctionType);
            if (message.SpecialValue != null && message.hasOwnProperty("SpecialValue"))
                writer.uint32(/* id 8, wireType 2 =*/66).string(message.SpecialValue);
            return writer;
        };

        /**
         * Encodes the specified CatPhotos message, length delimited. Does not implicitly {@link pattern.CatPhotos.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.CatPhotos
         * @static
         * @param {pattern.ICatPhotos} message CatPhotos message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatPhotos.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CatPhotos message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.CatPhotos
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.CatPhotos} CatPhotos
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatPhotos.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.CatPhotos();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.Type = reader.string();
                    break;
                case 3:
                    message.Background = reader.string();
                    break;
                case 4:
                    message.Cat = reader.string();
                    break;
                case 5:
                    message.Catroute = reader.string();
                    break;
                case 6:
                    message.Order = reader.int32();
                    break;
                case 7:
                    message.SpecialFunctionType = reader.int32();
                    break;
                case 8:
                    message.SpecialValue = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CatPhotos message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.CatPhotos
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.CatPhotos} CatPhotos
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatPhotos.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CatPhotos message.
         * @function verify
         * @memberof pattern.CatPhotos
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CatPhotos.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.Type != null && message.hasOwnProperty("Type"))
                if (!$util.isString(message.Type))
                    return "Type: string expected";
            if (message.Background != null && message.hasOwnProperty("Background"))
                if (!$util.isString(message.Background))
                    return "Background: string expected";
            if (message.Cat != null && message.hasOwnProperty("Cat"))
                if (!$util.isString(message.Cat))
                    return "Cat: string expected";
            if (message.Catroute != null && message.hasOwnProperty("Catroute"))
                if (!$util.isString(message.Catroute))
                    return "Catroute: string expected";
            if (message.Order != null && message.hasOwnProperty("Order"))
                if (!$util.isInteger(message.Order))
                    return "Order: integer expected";
            if (message.SpecialFunctionType != null && message.hasOwnProperty("SpecialFunctionType"))
                if (!$util.isInteger(message.SpecialFunctionType))
                    return "SpecialFunctionType: integer expected";
            if (message.SpecialValue != null && message.hasOwnProperty("SpecialValue"))
                if (!$util.isString(message.SpecialValue))
                    return "SpecialValue: string expected";
            return null;
        };

        return CatPhotos;
    })();

    pattern.Const = (function() {

        /**
         * Properties of a Const.
         * @memberof pattern
         * @interface IConst
         * @property {string|null} [Id] Const Id
         * @property {string|null} [Value] Const Value
         */

        /**
         * Constructs a new Const.
         * @memberof pattern
         * @classdesc Represents a Const.
         * @implements IConst
         * @constructor
         * @param {pattern.IConst=} [properties] Properties to set
         */
        function Const(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Const Id.
         * @member {string} Id
         * @memberof pattern.Const
         * @instance
         */
        Const.prototype.Id = "";

        /**
         * Const Value.
         * @member {string} Value
         * @memberof pattern.Const
         * @instance
         */
        Const.prototype.Value = "";

        /**
         * Creates a new Const instance using the specified properties.
         * @function create
         * @memberof pattern.Const
         * @static
         * @param {pattern.IConst=} [properties] Properties to set
         * @returns {pattern.Const} Const instance
         */
        Const.create = function create(properties) {
            return new Const(properties);
        };

        /**
         * Encodes the specified Const message. Does not implicitly {@link pattern.Const.verify|verify} messages.
         * @function encode
         * @memberof pattern.Const
         * @static
         * @param {pattern.IConst} message Const message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Const.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.Value != null && message.hasOwnProperty("Value"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.Value);
            return writer;
        };

        /**
         * Encodes the specified Const message, length delimited. Does not implicitly {@link pattern.Const.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.Const
         * @static
         * @param {pattern.IConst} message Const message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Const.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Const message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.Const
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.Const} Const
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Const.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.Const();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.Value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Const message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.Const
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.Const} Const
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Const.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Const message.
         * @function verify
         * @memberof pattern.Const
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Const.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.Value != null && message.hasOwnProperty("Value"))
                if (!$util.isString(message.Value))
                    return "Value: string expected";
            return null;
        };

        return Const;
    })();

    pattern.Foods = (function() {

        /**
         * Properties of a Foods.
         * @memberof pattern
         * @interface IFoods
         * @property {string|null} [Id] Foods Id
         * @property {string|null} [Type] Foods Type
         * @property {string|null} [Desc1] Foods Desc1
         * @property {string|null} [ShopItems] Foods ShopItems
         * @property {number|null} [Limit] Foods Limit
         * @property {number|null} [Cost] Foods Cost
         * @property {number|null} [Income] Foods Income
         * @property {number|null} [CookingTime] Foods CookingTime
         */

        /**
         * Constructs a new Foods.
         * @memberof pattern
         * @classdesc Represents a Foods.
         * @implements IFoods
         * @constructor
         * @param {pattern.IFoods=} [properties] Properties to set
         */
        function Foods(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Foods Id.
         * @member {string} Id
         * @memberof pattern.Foods
         * @instance
         */
        Foods.prototype.Id = "";

        /**
         * Foods Type.
         * @member {string} Type
         * @memberof pattern.Foods
         * @instance
         */
        Foods.prototype.Type = "";

        /**
         * Foods Desc1.
         * @member {string} Desc1
         * @memberof pattern.Foods
         * @instance
         */
        Foods.prototype.Desc1 = "";

        /**
         * Foods ShopItems.
         * @member {string} ShopItems
         * @memberof pattern.Foods
         * @instance
         */
        Foods.prototype.ShopItems = "";

        /**
         * Foods Limit.
         * @member {number} Limit
         * @memberof pattern.Foods
         * @instance
         */
        Foods.prototype.Limit = 0;

        /**
         * Foods Cost.
         * @member {number} Cost
         * @memberof pattern.Foods
         * @instance
         */
        Foods.prototype.Cost = 0;

        /**
         * Foods Income.
         * @member {number} Income
         * @memberof pattern.Foods
         * @instance
         */
        Foods.prototype.Income = 0;

        /**
         * Foods CookingTime.
         * @member {number} CookingTime
         * @memberof pattern.Foods
         * @instance
         */
        Foods.prototype.CookingTime = 0;

        /**
         * Creates a new Foods instance using the specified properties.
         * @function create
         * @memberof pattern.Foods
         * @static
         * @param {pattern.IFoods=} [properties] Properties to set
         * @returns {pattern.Foods} Foods instance
         */
        Foods.create = function create(properties) {
            return new Foods(properties);
        };

        /**
         * Encodes the specified Foods message. Does not implicitly {@link pattern.Foods.verify|verify} messages.
         * @function encode
         * @memberof pattern.Foods
         * @static
         * @param {pattern.IFoods} message Foods message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Foods.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.Type != null && message.hasOwnProperty("Type"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.Type);
            if (message.Desc1 != null && message.hasOwnProperty("Desc1"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.Desc1);
            if (message.ShopItems != null && message.hasOwnProperty("ShopItems"))
                writer.uint32(/* id 4, wireType 2 =*/34).string(message.ShopItems);
            if (message.Limit != null && message.hasOwnProperty("Limit"))
                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.Limit);
            if (message.Cost != null && message.hasOwnProperty("Cost"))
                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.Cost);
            if (message.Income != null && message.hasOwnProperty("Income"))
                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.Income);
            if (message.CookingTime != null && message.hasOwnProperty("CookingTime"))
                writer.uint32(/* id 8, wireType 0 =*/64).int32(message.CookingTime);
            return writer;
        };

        /**
         * Encodes the specified Foods message, length delimited. Does not implicitly {@link pattern.Foods.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.Foods
         * @static
         * @param {pattern.IFoods} message Foods message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Foods.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Foods message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.Foods
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.Foods} Foods
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Foods.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.Foods();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.Type = reader.string();
                    break;
                case 3:
                    message.Desc1 = reader.string();
                    break;
                case 4:
                    message.ShopItems = reader.string();
                    break;
                case 5:
                    message.Limit = reader.int32();
                    break;
                case 6:
                    message.Cost = reader.int32();
                    break;
                case 7:
                    message.Income = reader.int32();
                    break;
                case 8:
                    message.CookingTime = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Foods message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.Foods
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.Foods} Foods
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Foods.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Foods message.
         * @function verify
         * @memberof pattern.Foods
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Foods.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.Type != null && message.hasOwnProperty("Type"))
                if (!$util.isString(message.Type))
                    return "Type: string expected";
            if (message.Desc1 != null && message.hasOwnProperty("Desc1"))
                if (!$util.isString(message.Desc1))
                    return "Desc1: string expected";
            if (message.ShopItems != null && message.hasOwnProperty("ShopItems"))
                if (!$util.isString(message.ShopItems))
                    return "ShopItems: string expected";
            if (message.Limit != null && message.hasOwnProperty("Limit"))
                if (!$util.isInteger(message.Limit))
                    return "Limit: integer expected";
            if (message.Cost != null && message.hasOwnProperty("Cost"))
                if (!$util.isInteger(message.Cost))
                    return "Cost: integer expected";
            if (message.Income != null && message.hasOwnProperty("Income"))
                if (!$util.isInteger(message.Income))
                    return "Income: integer expected";
            if (message.CookingTime != null && message.hasOwnProperty("CookingTime"))
                if (!$util.isInteger(message.CookingTime))
                    return "CookingTime: integer expected";
            return null;
        };

        return Foods;
    })();

    pattern.Milestone = (function() {

        /**
         * Properties of a Milestone.
         * @memberof pattern
         * @interface IMilestone
         * @property {string|null} [Id] Milestone Id
         * @property {string|null} [TopTitle] Milestone TopTitle
         * @property {string|null} [TopImage] Milestone TopImage
         * @property {string|null} [TopImage1] Milestone TopImage1
         * @property {string|null} [TopImage2] Milestone TopImage2
         * @property {string|null} [ContentTitle] Milestone ContentTitle
         * @property {string|null} [Desc1] Milestone Desc1
         * @property {number|null} [Type] Milestone Type
         * @property {string|null} [BottomConfig] Milestone BottomConfig
         * @property {string|null} [Condition] Milestone Condition
         * @property {string|null} [LetterReward] Milestone LetterReward
         * @property {string|null} [LetterTitle] Milestone LetterTitle
         * @property {string|null} [LetterContent] Milestone LetterContent
         * @property {string|null} [LetterSign] Milestone LetterSign
         * @property {number|null} [Order] Milestone Order
         */

        /**
         * Constructs a new Milestone.
         * @memberof pattern
         * @classdesc Represents a Milestone.
         * @implements IMilestone
         * @constructor
         * @param {pattern.IMilestone=} [properties] Properties to set
         */
        function Milestone(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Milestone Id.
         * @member {string} Id
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.Id = "";

        /**
         * Milestone TopTitle.
         * @member {string} TopTitle
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.TopTitle = "";

        /**
         * Milestone TopImage.
         * @member {string} TopImage
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.TopImage = "";

        /**
         * Milestone TopImage1.
         * @member {string} TopImage1
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.TopImage1 = "";

        /**
         * Milestone TopImage2.
         * @member {string} TopImage2
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.TopImage2 = "";

        /**
         * Milestone ContentTitle.
         * @member {string} ContentTitle
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.ContentTitle = "";

        /**
         * Milestone Desc1.
         * @member {string} Desc1
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.Desc1 = "";

        /**
         * Milestone Type.
         * @member {number} Type
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.Type = 0;

        /**
         * Milestone BottomConfig.
         * @member {string} BottomConfig
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.BottomConfig = "";

        /**
         * Milestone Condition.
         * @member {string} Condition
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.Condition = "";

        /**
         * Milestone LetterReward.
         * @member {string} LetterReward
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.LetterReward = "";

        /**
         * Milestone LetterTitle.
         * @member {string} LetterTitle
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.LetterTitle = "";

        /**
         * Milestone LetterContent.
         * @member {string} LetterContent
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.LetterContent = "";

        /**
         * Milestone LetterSign.
         * @member {string} LetterSign
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.LetterSign = "";

        /**
         * Milestone Order.
         * @member {number} Order
         * @memberof pattern.Milestone
         * @instance
         */
        Milestone.prototype.Order = 0;

        /**
         * Creates a new Milestone instance using the specified properties.
         * @function create
         * @memberof pattern.Milestone
         * @static
         * @param {pattern.IMilestone=} [properties] Properties to set
         * @returns {pattern.Milestone} Milestone instance
         */
        Milestone.create = function create(properties) {
            return new Milestone(properties);
        };

        /**
         * Encodes the specified Milestone message. Does not implicitly {@link pattern.Milestone.verify|verify} messages.
         * @function encode
         * @memberof pattern.Milestone
         * @static
         * @param {pattern.IMilestone} message Milestone message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Milestone.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.TopTitle != null && message.hasOwnProperty("TopTitle"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.TopTitle);
            if (message.TopImage != null && message.hasOwnProperty("TopImage"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.TopImage);
            if (message.TopImage1 != null && message.hasOwnProperty("TopImage1"))
                writer.uint32(/* id 4, wireType 2 =*/34).string(message.TopImage1);
            if (message.TopImage2 != null && message.hasOwnProperty("TopImage2"))
                writer.uint32(/* id 5, wireType 2 =*/42).string(message.TopImage2);
            if (message.ContentTitle != null && message.hasOwnProperty("ContentTitle"))
                writer.uint32(/* id 6, wireType 2 =*/50).string(message.ContentTitle);
            if (message.Desc1 != null && message.hasOwnProperty("Desc1"))
                writer.uint32(/* id 7, wireType 2 =*/58).string(message.Desc1);
            if (message.Type != null && message.hasOwnProperty("Type"))
                writer.uint32(/* id 8, wireType 0 =*/64).int32(message.Type);
            if (message.BottomConfig != null && message.hasOwnProperty("BottomConfig"))
                writer.uint32(/* id 9, wireType 2 =*/74).string(message.BottomConfig);
            if (message.Condition != null && message.hasOwnProperty("Condition"))
                writer.uint32(/* id 10, wireType 2 =*/82).string(message.Condition);
            if (message.LetterReward != null && message.hasOwnProperty("LetterReward"))
                writer.uint32(/* id 11, wireType 2 =*/90).string(message.LetterReward);
            if (message.LetterTitle != null && message.hasOwnProperty("LetterTitle"))
                writer.uint32(/* id 12, wireType 2 =*/98).string(message.LetterTitle);
            if (message.LetterContent != null && message.hasOwnProperty("LetterContent"))
                writer.uint32(/* id 13, wireType 2 =*/106).string(message.LetterContent);
            if (message.LetterSign != null && message.hasOwnProperty("LetterSign"))
                writer.uint32(/* id 14, wireType 2 =*/114).string(message.LetterSign);
            if (message.Order != null && message.hasOwnProperty("Order"))
                writer.uint32(/* id 15, wireType 0 =*/120).int32(message.Order);
            return writer;
        };

        /**
         * Encodes the specified Milestone message, length delimited. Does not implicitly {@link pattern.Milestone.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.Milestone
         * @static
         * @param {pattern.IMilestone} message Milestone message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Milestone.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Milestone message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.Milestone
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.Milestone} Milestone
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Milestone.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.Milestone();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.TopTitle = reader.string();
                    break;
                case 3:
                    message.TopImage = reader.string();
                    break;
                case 4:
                    message.TopImage1 = reader.string();
                    break;
                case 5:
                    message.TopImage2 = reader.string();
                    break;
                case 6:
                    message.ContentTitle = reader.string();
                    break;
                case 7:
                    message.Desc1 = reader.string();
                    break;
                case 8:
                    message.Type = reader.int32();
                    break;
                case 9:
                    message.BottomConfig = reader.string();
                    break;
                case 10:
                    message.Condition = reader.string();
                    break;
                case 11:
                    message.LetterReward = reader.string();
                    break;
                case 12:
                    message.LetterTitle = reader.string();
                    break;
                case 13:
                    message.LetterContent = reader.string();
                    break;
                case 14:
                    message.LetterSign = reader.string();
                    break;
                case 15:
                    message.Order = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Milestone message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.Milestone
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.Milestone} Milestone
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Milestone.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Milestone message.
         * @function verify
         * @memberof pattern.Milestone
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Milestone.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.TopTitle != null && message.hasOwnProperty("TopTitle"))
                if (!$util.isString(message.TopTitle))
                    return "TopTitle: string expected";
            if (message.TopImage != null && message.hasOwnProperty("TopImage"))
                if (!$util.isString(message.TopImage))
                    return "TopImage: string expected";
            if (message.TopImage1 != null && message.hasOwnProperty("TopImage1"))
                if (!$util.isString(message.TopImage1))
                    return "TopImage1: string expected";
            if (message.TopImage2 != null && message.hasOwnProperty("TopImage2"))
                if (!$util.isString(message.TopImage2))
                    return "TopImage2: string expected";
            if (message.ContentTitle != null && message.hasOwnProperty("ContentTitle"))
                if (!$util.isString(message.ContentTitle))
                    return "ContentTitle: string expected";
            if (message.Desc1 != null && message.hasOwnProperty("Desc1"))
                if (!$util.isString(message.Desc1))
                    return "Desc1: string expected";
            if (message.Type != null && message.hasOwnProperty("Type"))
                if (!$util.isInteger(message.Type))
                    return "Type: integer expected";
            if (message.BottomConfig != null && message.hasOwnProperty("BottomConfig"))
                if (!$util.isString(message.BottomConfig))
                    return "BottomConfig: string expected";
            if (message.Condition != null && message.hasOwnProperty("Condition"))
                if (!$util.isString(message.Condition))
                    return "Condition: string expected";
            if (message.LetterReward != null && message.hasOwnProperty("LetterReward"))
                if (!$util.isString(message.LetterReward))
                    return "LetterReward: string expected";
            if (message.LetterTitle != null && message.hasOwnProperty("LetterTitle"))
                if (!$util.isString(message.LetterTitle))
                    return "LetterTitle: string expected";
            if (message.LetterContent != null && message.hasOwnProperty("LetterContent"))
                if (!$util.isString(message.LetterContent))
                    return "LetterContent: string expected";
            if (message.LetterSign != null && message.hasOwnProperty("LetterSign"))
                if (!$util.isString(message.LetterSign))
                    return "LetterSign: string expected";
            if (message.Order != null && message.hasOwnProperty("Order"))
                if (!$util.isInteger(message.Order))
                    return "Order: integer expected";
            return null;
        };

        return Milestone;
    })();

    pattern.Mission = (function() {

        /**
         * Properties of a Mission.
         * @memberof pattern
         * @interface IMission
         * @property {string|null} [Id] Mission Id
         * @property {string|null} [EventGroup] Mission EventGroup
         * @property {number|null} [MissionLv] Mission MissionLv
         * @property {string|null} [StarLv] Mission StarLv
         * @property {string|null} [Name] Mission Name
         * @property {string|null} [Desc] Mission Desc
         * @property {string|null} [Icon] Mission Icon
         * @property {string|null} [Reward] Mission Reward
         * @property {number|null} [Weight] Mission Weight
         * @property {string|null} [ValueRange] Mission ValueRange
         */

        /**
         * Constructs a new Mission.
         * @memberof pattern
         * @classdesc Represents a Mission.
         * @implements IMission
         * @constructor
         * @param {pattern.IMission=} [properties] Properties to set
         */
        function Mission(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Mission Id.
         * @member {string} Id
         * @memberof pattern.Mission
         * @instance
         */
        Mission.prototype.Id = "";

        /**
         * Mission EventGroup.
         * @member {string} EventGroup
         * @memberof pattern.Mission
         * @instance
         */
        Mission.prototype.EventGroup = "";

        /**
         * Mission MissionLv.
         * @member {number} MissionLv
         * @memberof pattern.Mission
         * @instance
         */
        Mission.prototype.MissionLv = 0;

        /**
         * Mission StarLv.
         * @member {string} StarLv
         * @memberof pattern.Mission
         * @instance
         */
        Mission.prototype.StarLv = "";

        /**
         * Mission Name.
         * @member {string} Name
         * @memberof pattern.Mission
         * @instance
         */
        Mission.prototype.Name = "";

        /**
         * Mission Desc.
         * @member {string} Desc
         * @memberof pattern.Mission
         * @instance
         */
        Mission.prototype.Desc = "";

        /**
         * Mission Icon.
         * @member {string} Icon
         * @memberof pattern.Mission
         * @instance
         */
        Mission.prototype.Icon = "";

        /**
         * Mission Reward.
         * @member {string} Reward
         * @memberof pattern.Mission
         * @instance
         */
        Mission.prototype.Reward = "";

        /**
         * Mission Weight.
         * @member {number} Weight
         * @memberof pattern.Mission
         * @instance
         */
        Mission.prototype.Weight = 0;

        /**
         * Mission ValueRange.
         * @member {string} ValueRange
         * @memberof pattern.Mission
         * @instance
         */
        Mission.prototype.ValueRange = "";

        /**
         * Creates a new Mission instance using the specified properties.
         * @function create
         * @memberof pattern.Mission
         * @static
         * @param {pattern.IMission=} [properties] Properties to set
         * @returns {pattern.Mission} Mission instance
         */
        Mission.create = function create(properties) {
            return new Mission(properties);
        };

        /**
         * Encodes the specified Mission message. Does not implicitly {@link pattern.Mission.verify|verify} messages.
         * @function encode
         * @memberof pattern.Mission
         * @static
         * @param {pattern.IMission} message Mission message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Mission.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.EventGroup != null && message.hasOwnProperty("EventGroup"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.EventGroup);
            if (message.MissionLv != null && message.hasOwnProperty("MissionLv"))
                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.MissionLv);
            if (message.StarLv != null && message.hasOwnProperty("StarLv"))
                writer.uint32(/* id 4, wireType 2 =*/34).string(message.StarLv);
            if (message.Name != null && message.hasOwnProperty("Name"))
                writer.uint32(/* id 5, wireType 2 =*/42).string(message.Name);
            if (message.Desc != null && message.hasOwnProperty("Desc"))
                writer.uint32(/* id 6, wireType 2 =*/50).string(message.Desc);
            if (message.Icon != null && message.hasOwnProperty("Icon"))
                writer.uint32(/* id 7, wireType 2 =*/58).string(message.Icon);
            if (message.Reward != null && message.hasOwnProperty("Reward"))
                writer.uint32(/* id 8, wireType 2 =*/66).string(message.Reward);
            if (message.Weight != null && message.hasOwnProperty("Weight"))
                writer.uint32(/* id 9, wireType 0 =*/72).int32(message.Weight);
            if (message.ValueRange != null && message.hasOwnProperty("ValueRange"))
                writer.uint32(/* id 10, wireType 2 =*/82).string(message.ValueRange);
            return writer;
        };

        /**
         * Encodes the specified Mission message, length delimited. Does not implicitly {@link pattern.Mission.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.Mission
         * @static
         * @param {pattern.IMission} message Mission message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Mission.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Mission message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.Mission
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.Mission} Mission
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Mission.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.Mission();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.EventGroup = reader.string();
                    break;
                case 3:
                    message.MissionLv = reader.int32();
                    break;
                case 4:
                    message.StarLv = reader.string();
                    break;
                case 5:
                    message.Name = reader.string();
                    break;
                case 6:
                    message.Desc = reader.string();
                    break;
                case 7:
                    message.Icon = reader.string();
                    break;
                case 8:
                    message.Reward = reader.string();
                    break;
                case 9:
                    message.Weight = reader.int32();
                    break;
                case 10:
                    message.ValueRange = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Mission message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.Mission
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.Mission} Mission
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Mission.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Mission message.
         * @function verify
         * @memberof pattern.Mission
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Mission.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.EventGroup != null && message.hasOwnProperty("EventGroup"))
                if (!$util.isString(message.EventGroup))
                    return "EventGroup: string expected";
            if (message.MissionLv != null && message.hasOwnProperty("MissionLv"))
                if (!$util.isInteger(message.MissionLv))
                    return "MissionLv: integer expected";
            if (message.StarLv != null && message.hasOwnProperty("StarLv"))
                if (!$util.isString(message.StarLv))
                    return "StarLv: string expected";
            if (message.Name != null && message.hasOwnProperty("Name"))
                if (!$util.isString(message.Name))
                    return "Name: string expected";
            if (message.Desc != null && message.hasOwnProperty("Desc"))
                if (!$util.isString(message.Desc))
                    return "Desc: string expected";
            if (message.Icon != null && message.hasOwnProperty("Icon"))
                if (!$util.isString(message.Icon))
                    return "Icon: string expected";
            if (message.Reward != null && message.hasOwnProperty("Reward"))
                if (!$util.isString(message.Reward))
                    return "Reward: string expected";
            if (message.Weight != null && message.hasOwnProperty("Weight"))
                if (!$util.isInteger(message.Weight))
                    return "Weight: integer expected";
            if (message.ValueRange != null && message.hasOwnProperty("ValueRange"))
                if (!$util.isString(message.ValueRange))
                    return "ValueRange: string expected";
            return null;
        };

        return Mission;
    })();

    pattern.Purchase = (function() {

        /**
         * Properties of a Purchase.
         * @memberof pattern
         * @interface IPurchase
         * @property {string|null} [Id] Purchase Id
         * @property {string|null} [Type] Purchase Type
         * @property {string|null} [CostType] Purchase CostType
         * @property {number|null} [Price] Purchase Price
         * @property {number|null} [FirstDouble] Purchase FirstDouble
         * @property {string|null} [DirectReward] Purchase DirectReward
         * @property {string|null} [ExtraReward] Purchase ExtraReward
         * @property {string|null} [DailyReawrd] Purchase DailyReawrd
         * @property {string|null} [AndroidPoint] Purchase AndroidPoint
         * @property {string|null} [IOSPoint] Purchase IOSPoint
         * @property {number|null} [Order] Purchase Order
         * @property {string|null} [Picture] Purchase Picture
         */

        /**
         * Constructs a new Purchase.
         * @memberof pattern
         * @classdesc Represents a Purchase.
         * @implements IPurchase
         * @constructor
         * @param {pattern.IPurchase=} [properties] Properties to set
         */
        function Purchase(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Purchase Id.
         * @member {string} Id
         * @memberof pattern.Purchase
         * @instance
         */
        Purchase.prototype.Id = "";

        /**
         * Purchase Type.
         * @member {string} Type
         * @memberof pattern.Purchase
         * @instance
         */
        Purchase.prototype.Type = "";

        /**
         * Purchase CostType.
         * @member {string} CostType
         * @memberof pattern.Purchase
         * @instance
         */
        Purchase.prototype.CostType = "";

        /**
         * Purchase Price.
         * @member {number} Price
         * @memberof pattern.Purchase
         * @instance
         */
        Purchase.prototype.Price = 0;

        /**
         * Purchase FirstDouble.
         * @member {number} FirstDouble
         * @memberof pattern.Purchase
         * @instance
         */
        Purchase.prototype.FirstDouble = 0;

        /**
         * Purchase DirectReward.
         * @member {string} DirectReward
         * @memberof pattern.Purchase
         * @instance
         */
        Purchase.prototype.DirectReward = "";

        /**
         * Purchase ExtraReward.
         * @member {string} ExtraReward
         * @memberof pattern.Purchase
         * @instance
         */
        Purchase.prototype.ExtraReward = "";

        /**
         * Purchase DailyReawrd.
         * @member {string} DailyReawrd
         * @memberof pattern.Purchase
         * @instance
         */
        Purchase.prototype.DailyReawrd = "";

        /**
         * Purchase AndroidPoint.
         * @member {string} AndroidPoint
         * @memberof pattern.Purchase
         * @instance
         */
        Purchase.prototype.AndroidPoint = "";

        /**
         * Purchase IOSPoint.
         * @member {string} IOSPoint
         * @memberof pattern.Purchase
         * @instance
         */
        Purchase.prototype.IOSPoint = "";

        /**
         * Purchase Order.
         * @member {number} Order
         * @memberof pattern.Purchase
         * @instance
         */
        Purchase.prototype.Order = 0;

        /**
         * Purchase Picture.
         * @member {string} Picture
         * @memberof pattern.Purchase
         * @instance
         */
        Purchase.prototype.Picture = "";

        /**
         * Creates a new Purchase instance using the specified properties.
         * @function create
         * @memberof pattern.Purchase
         * @static
         * @param {pattern.IPurchase=} [properties] Properties to set
         * @returns {pattern.Purchase} Purchase instance
         */
        Purchase.create = function create(properties) {
            return new Purchase(properties);
        };

        /**
         * Encodes the specified Purchase message. Does not implicitly {@link pattern.Purchase.verify|verify} messages.
         * @function encode
         * @memberof pattern.Purchase
         * @static
         * @param {pattern.IPurchase} message Purchase message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Purchase.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.Type != null && message.hasOwnProperty("Type"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.Type);
            if (message.CostType != null && message.hasOwnProperty("CostType"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.CostType);
            if (message.Price != null && message.hasOwnProperty("Price"))
                writer.uint32(/* id 4, wireType 1 =*/33).double(message.Price);
            if (message.FirstDouble != null && message.hasOwnProperty("FirstDouble"))
                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.FirstDouble);
            if (message.DirectReward != null && message.hasOwnProperty("DirectReward"))
                writer.uint32(/* id 6, wireType 2 =*/50).string(message.DirectReward);
            if (message.ExtraReward != null && message.hasOwnProperty("ExtraReward"))
                writer.uint32(/* id 7, wireType 2 =*/58).string(message.ExtraReward);
            if (message.DailyReawrd != null && message.hasOwnProperty("DailyReawrd"))
                writer.uint32(/* id 8, wireType 2 =*/66).string(message.DailyReawrd);
            if (message.AndroidPoint != null && message.hasOwnProperty("AndroidPoint"))
                writer.uint32(/* id 9, wireType 2 =*/74).string(message.AndroidPoint);
            if (message.IOSPoint != null && message.hasOwnProperty("IOSPoint"))
                writer.uint32(/* id 10, wireType 2 =*/82).string(message.IOSPoint);
            if (message.Order != null && message.hasOwnProperty("Order"))
                writer.uint32(/* id 11, wireType 0 =*/88).int32(message.Order);
            if (message.Picture != null && message.hasOwnProperty("Picture"))
                writer.uint32(/* id 12, wireType 2 =*/98).string(message.Picture);
            return writer;
        };

        /**
         * Encodes the specified Purchase message, length delimited. Does not implicitly {@link pattern.Purchase.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.Purchase
         * @static
         * @param {pattern.IPurchase} message Purchase message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Purchase.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Purchase message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.Purchase
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.Purchase} Purchase
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Purchase.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.Purchase();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.Type = reader.string();
                    break;
                case 3:
                    message.CostType = reader.string();
                    break;
                case 4:
                    message.Price = reader.double();
                    break;
                case 5:
                    message.FirstDouble = reader.int32();
                    break;
                case 6:
                    message.DirectReward = reader.string();
                    break;
                case 7:
                    message.ExtraReward = reader.string();
                    break;
                case 8:
                    message.DailyReawrd = reader.string();
                    break;
                case 9:
                    message.AndroidPoint = reader.string();
                    break;
                case 10:
                    message.IOSPoint = reader.string();
                    break;
                case 11:
                    message.Order = reader.int32();
                    break;
                case 12:
                    message.Picture = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Purchase message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.Purchase
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.Purchase} Purchase
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Purchase.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Purchase message.
         * @function verify
         * @memberof pattern.Purchase
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Purchase.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.Type != null && message.hasOwnProperty("Type"))
                if (!$util.isString(message.Type))
                    return "Type: string expected";
            if (message.CostType != null && message.hasOwnProperty("CostType"))
                if (!$util.isString(message.CostType))
                    return "CostType: string expected";
            if (message.Price != null && message.hasOwnProperty("Price"))
                if (typeof message.Price !== "number")
                    return "Price: number expected";
            if (message.FirstDouble != null && message.hasOwnProperty("FirstDouble"))
                if (!$util.isInteger(message.FirstDouble))
                    return "FirstDouble: integer expected";
            if (message.DirectReward != null && message.hasOwnProperty("DirectReward"))
                if (!$util.isString(message.DirectReward))
                    return "DirectReward: string expected";
            if (message.ExtraReward != null && message.hasOwnProperty("ExtraReward"))
                if (!$util.isString(message.ExtraReward))
                    return "ExtraReward: string expected";
            if (message.DailyReawrd != null && message.hasOwnProperty("DailyReawrd"))
                if (!$util.isString(message.DailyReawrd))
                    return "DailyReawrd: string expected";
            if (message.AndroidPoint != null && message.hasOwnProperty("AndroidPoint"))
                if (!$util.isString(message.AndroidPoint))
                    return "AndroidPoint: string expected";
            if (message.IOSPoint != null && message.hasOwnProperty("IOSPoint"))
                if (!$util.isString(message.IOSPoint))
                    return "IOSPoint: string expected";
            if (message.Order != null && message.hasOwnProperty("Order"))
                if (!$util.isInteger(message.Order))
                    return "Order: integer expected";
            if (message.Picture != null && message.hasOwnProperty("Picture"))
                if (!$util.isString(message.Picture))
                    return "Picture: string expected";
            return null;
        };

        return Purchase;
    })();

    pattern.Role = (function() {

        /**
         * Properties of a Role.
         * @memberof pattern
         * @interface IRole
         * @property {string|null} [Id] Role Id
         * @property {string|null} [Source] Role Source
         * @property {string|null} [Skin] Role Skin
         * @property {string|null} [DefaultAction] Role DefaultAction
         * @property {string|null} [Icon] Role Icon
         * @property {string|null} [IconShadow] Role IconShadow
         * @property {string|null} [HeadIcon] Role HeadIcon
         * @property {string|null} [EventVisit] Role EventVisit
         * @property {string|null} [EventTravel] Role EventTravel
         * @property {Array.<number>|null} [Intimacy] Role Intimacy
         * @property {number|null} [IntimacyLimit] Role IntimacyLimit
         * @property {string|null} [AdoptLimit] Role AdoptLimit
         * @property {Array.<number>|null} [ValueBase] Role ValueBase
         * @property {number|null} [StarBase] Role StarBase
         * @property {Array.<string>|null} [FavorFoodsList] Role FavorFoodsList
         * @property {string|null} [Gift] Role Gift
         * @property {string|null} [FavorToys] Role FavorToys
         * @property {string|null} [NormalActions] Role NormalActions
         * @property {string|null} [CatSound] Role CatSound
         * @property {number|null} [Rank] Role Rank
         * @property {string|null} [BasicInfor] Role BasicInfor
         * @property {string|null} [ShareReward] Role ShareReward
         * @property {string|null} [DropRate] Role DropRate
         * @property {string|null} [Label] Role Label
         * @property {string|null} [Potential] Role Potential
         * @property {string|null} [Flag] Role Flag
         * @property {string|null} [BaseValue] Role BaseValue
         */

        /**
         * Constructs a new Role.
         * @memberof pattern
         * @classdesc Represents a Role.
         * @implements IRole
         * @constructor
         * @param {pattern.IRole=} [properties] Properties to set
         */
        function Role(properties) {
            this.Intimacy = [];
            this.ValueBase = [];
            this.FavorFoodsList = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Role Id.
         * @member {string} Id
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.Id = "";

        /**
         * Role Source.
         * @member {string} Source
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.Source = "";

        /**
         * Role Skin.
         * @member {string} Skin
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.Skin = "";

        /**
         * Role DefaultAction.
         * @member {string} DefaultAction
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.DefaultAction = "";

        /**
         * Role Icon.
         * @member {string} Icon
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.Icon = "";

        /**
         * Role IconShadow.
         * @member {string} IconShadow
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.IconShadow = "";

        /**
         * Role HeadIcon.
         * @member {string} HeadIcon
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.HeadIcon = "";

        /**
         * Role EventVisit.
         * @member {string} EventVisit
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.EventVisit = "";

        /**
         * Role EventTravel.
         * @member {string} EventTravel
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.EventTravel = "";

        /**
         * Role Intimacy.
         * @member {Array.<number>} Intimacy
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.Intimacy = $util.emptyArray;

        /**
         * Role IntimacyLimit.
         * @member {number} IntimacyLimit
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.IntimacyLimit = 0;

        /**
         * Role AdoptLimit.
         * @member {string} AdoptLimit
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.AdoptLimit = "";

        /**
         * Role ValueBase.
         * @member {Array.<number>} ValueBase
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.ValueBase = $util.emptyArray;

        /**
         * Role StarBase.
         * @member {number} StarBase
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.StarBase = 0;

        /**
         * Role FavorFoodsList.
         * @member {Array.<string>} FavorFoodsList
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.FavorFoodsList = $util.emptyArray;

        /**
         * Role Gift.
         * @member {string} Gift
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.Gift = "";

        /**
         * Role FavorToys.
         * @member {string} FavorToys
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.FavorToys = "";

        /**
         * Role NormalActions.
         * @member {string} NormalActions
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.NormalActions = "";

        /**
         * Role CatSound.
         * @member {string} CatSound
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.CatSound = "";

        /**
         * Role Rank.
         * @member {number} Rank
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.Rank = 0;

        /**
         * Role BasicInfor.
         * @member {string} BasicInfor
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.BasicInfor = "";

        /**
         * Role ShareReward.
         * @member {string} ShareReward
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.ShareReward = "";

        /**
         * Role DropRate.
         * @member {string} DropRate
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.DropRate = "";

        /**
         * Role Label.
         * @member {string} Label
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.Label = "";

        /**
         * Role Potential.
         * @member {string} Potential
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.Potential = "";

        /**
         * Role Flag.
         * @member {string} Flag
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.Flag = "";

        /**
         * Role BaseValue.
         * @member {string} BaseValue
         * @memberof pattern.Role
         * @instance
         */
        Role.prototype.BaseValue = "";

        /**
         * Creates a new Role instance using the specified properties.
         * @function create
         * @memberof pattern.Role
         * @static
         * @param {pattern.IRole=} [properties] Properties to set
         * @returns {pattern.Role} Role instance
         */
        Role.create = function create(properties) {
            return new Role(properties);
        };

        /**
         * Encodes the specified Role message. Does not implicitly {@link pattern.Role.verify|verify} messages.
         * @function encode
         * @memberof pattern.Role
         * @static
         * @param {pattern.IRole} message Role message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Role.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.Source != null && message.hasOwnProperty("Source"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.Source);
            if (message.Skin != null && message.hasOwnProperty("Skin"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.Skin);
            if (message.DefaultAction != null && message.hasOwnProperty("DefaultAction"))
                writer.uint32(/* id 4, wireType 2 =*/34).string(message.DefaultAction);
            if (message.Icon != null && message.hasOwnProperty("Icon"))
                writer.uint32(/* id 5, wireType 2 =*/42).string(message.Icon);
            if (message.IconShadow != null && message.hasOwnProperty("IconShadow"))
                writer.uint32(/* id 6, wireType 2 =*/50).string(message.IconShadow);
            if (message.HeadIcon != null && message.hasOwnProperty("HeadIcon"))
                writer.uint32(/* id 7, wireType 2 =*/58).string(message.HeadIcon);
            if (message.EventVisit != null && message.hasOwnProperty("EventVisit"))
                writer.uint32(/* id 8, wireType 2 =*/66).string(message.EventVisit);
            if (message.EventTravel != null && message.hasOwnProperty("EventTravel"))
                writer.uint32(/* id 9, wireType 2 =*/74).string(message.EventTravel);
            if (message.Intimacy != null && message.Intimacy.length) {
                writer.uint32(/* id 10, wireType 2 =*/82).fork();
                for (var i = 0; i < message.Intimacy.length; ++i)
                    writer.int32(message.Intimacy[i]);
                writer.ldelim();
            }
            if (message.IntimacyLimit != null && message.hasOwnProperty("IntimacyLimit"))
                writer.uint32(/* id 11, wireType 0 =*/88).int32(message.IntimacyLimit);
            if (message.AdoptLimit != null && message.hasOwnProperty("AdoptLimit"))
                writer.uint32(/* id 12, wireType 2 =*/98).string(message.AdoptLimit);
            if (message.ValueBase != null && message.ValueBase.length) {
                writer.uint32(/* id 13, wireType 2 =*/106).fork();
                for (var i = 0; i < message.ValueBase.length; ++i)
                    writer.int32(message.ValueBase[i]);
                writer.ldelim();
            }
            if (message.StarBase != null && message.hasOwnProperty("StarBase"))
                writer.uint32(/* id 14, wireType 0 =*/112).int32(message.StarBase);
            if (message.FavorFoodsList != null && message.FavorFoodsList.length)
                for (var i = 0; i < message.FavorFoodsList.length; ++i)
                    writer.uint32(/* id 15, wireType 2 =*/122).string(message.FavorFoodsList[i]);
            if (message.Gift != null && message.hasOwnProperty("Gift"))
                writer.uint32(/* id 16, wireType 2 =*/130).string(message.Gift);
            if (message.FavorToys != null && message.hasOwnProperty("FavorToys"))
                writer.uint32(/* id 17, wireType 2 =*/138).string(message.FavorToys);
            if (message.NormalActions != null && message.hasOwnProperty("NormalActions"))
                writer.uint32(/* id 18, wireType 2 =*/146).string(message.NormalActions);
            if (message.CatSound != null && message.hasOwnProperty("CatSound"))
                writer.uint32(/* id 19, wireType 2 =*/154).string(message.CatSound);
            if (message.Rank != null && message.hasOwnProperty("Rank"))
                writer.uint32(/* id 20, wireType 0 =*/160).int32(message.Rank);
            if (message.BasicInfor != null && message.hasOwnProperty("BasicInfor"))
                writer.uint32(/* id 21, wireType 2 =*/170).string(message.BasicInfor);
            if (message.ShareReward != null && message.hasOwnProperty("ShareReward"))
                writer.uint32(/* id 22, wireType 2 =*/178).string(message.ShareReward);
            if (message.DropRate != null && message.hasOwnProperty("DropRate"))
                writer.uint32(/* id 23, wireType 2 =*/186).string(message.DropRate);
            if (message.Label != null && message.hasOwnProperty("Label"))
                writer.uint32(/* id 24, wireType 2 =*/194).string(message.Label);
            if (message.Potential != null && message.hasOwnProperty("Potential"))
                writer.uint32(/* id 25, wireType 2 =*/202).string(message.Potential);
            if (message.Flag != null && message.hasOwnProperty("Flag"))
                writer.uint32(/* id 26, wireType 2 =*/210).string(message.Flag);
            if (message.BaseValue != null && message.hasOwnProperty("BaseValue"))
                writer.uint32(/* id 27, wireType 2 =*/218).string(message.BaseValue);
            return writer;
        };

        /**
         * Encodes the specified Role message, length delimited. Does not implicitly {@link pattern.Role.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.Role
         * @static
         * @param {pattern.IRole} message Role message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Role.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Role message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.Role
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.Role} Role
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Role.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.Role();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.Source = reader.string();
                    break;
                case 3:
                    message.Skin = reader.string();
                    break;
                case 4:
                    message.DefaultAction = reader.string();
                    break;
                case 5:
                    message.Icon = reader.string();
                    break;
                case 6:
                    message.IconShadow = reader.string();
                    break;
                case 7:
                    message.HeadIcon = reader.string();
                    break;
                case 8:
                    message.EventVisit = reader.string();
                    break;
                case 9:
                    message.EventTravel = reader.string();
                    break;
                case 10:
                    if (!(message.Intimacy && message.Intimacy.length))
                        message.Intimacy = [];
                    if ((tag & 7) === 2) {
                        var end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2)
                            message.Intimacy.push(reader.int32());
                    } else
                        message.Intimacy.push(reader.int32());
                    break;
                case 11:
                    message.IntimacyLimit = reader.int32();
                    break;
                case 12:
                    message.AdoptLimit = reader.string();
                    break;
                case 13:
                    if (!(message.ValueBase && message.ValueBase.length))
                        message.ValueBase = [];
                    if ((tag & 7) === 2) {
                        var end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2)
                            message.ValueBase.push(reader.int32());
                    } else
                        message.ValueBase.push(reader.int32());
                    break;
                case 14:
                    message.StarBase = reader.int32();
                    break;
                case 15:
                    if (!(message.FavorFoodsList && message.FavorFoodsList.length))
                        message.FavorFoodsList = [];
                    message.FavorFoodsList.push(reader.string());
                    break;
                case 16:
                    message.Gift = reader.string();
                    break;
                case 17:
                    message.FavorToys = reader.string();
                    break;
                case 18:
                    message.NormalActions = reader.string();
                    break;
                case 19:
                    message.CatSound = reader.string();
                    break;
                case 20:
                    message.Rank = reader.int32();
                    break;
                case 21:
                    message.BasicInfor = reader.string();
                    break;
                case 22:
                    message.ShareReward = reader.string();
                    break;
                case 23:
                    message.DropRate = reader.string();
                    break;
                case 24:
                    message.Label = reader.string();
                    break;
                case 25:
                    message.Potential = reader.string();
                    break;
                case 26:
                    message.Flag = reader.string();
                    break;
                case 27:
                    message.BaseValue = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Role message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.Role
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.Role} Role
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Role.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Role message.
         * @function verify
         * @memberof pattern.Role
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Role.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.Source != null && message.hasOwnProperty("Source"))
                if (!$util.isString(message.Source))
                    return "Source: string expected";
            if (message.Skin != null && message.hasOwnProperty("Skin"))
                if (!$util.isString(message.Skin))
                    return "Skin: string expected";
            if (message.DefaultAction != null && message.hasOwnProperty("DefaultAction"))
                if (!$util.isString(message.DefaultAction))
                    return "DefaultAction: string expected";
            if (message.Icon != null && message.hasOwnProperty("Icon"))
                if (!$util.isString(message.Icon))
                    return "Icon: string expected";
            if (message.IconShadow != null && message.hasOwnProperty("IconShadow"))
                if (!$util.isString(message.IconShadow))
                    return "IconShadow: string expected";
            if (message.HeadIcon != null && message.hasOwnProperty("HeadIcon"))
                if (!$util.isString(message.HeadIcon))
                    return "HeadIcon: string expected";
            if (message.EventVisit != null && message.hasOwnProperty("EventVisit"))
                if (!$util.isString(message.EventVisit))
                    return "EventVisit: string expected";
            if (message.EventTravel != null && message.hasOwnProperty("EventTravel"))
                if (!$util.isString(message.EventTravel))
                    return "EventTravel: string expected";
            if (message.Intimacy != null && message.hasOwnProperty("Intimacy")) {
                if (!Array.isArray(message.Intimacy))
                    return "Intimacy: array expected";
                for (var i = 0; i < message.Intimacy.length; ++i)
                    if (!$util.isInteger(message.Intimacy[i]))
                        return "Intimacy: integer[] expected";
            }
            if (message.IntimacyLimit != null && message.hasOwnProperty("IntimacyLimit"))
                if (!$util.isInteger(message.IntimacyLimit))
                    return "IntimacyLimit: integer expected";
            if (message.AdoptLimit != null && message.hasOwnProperty("AdoptLimit"))
                if (!$util.isString(message.AdoptLimit))
                    return "AdoptLimit: string expected";
            if (message.ValueBase != null && message.hasOwnProperty("ValueBase")) {
                if (!Array.isArray(message.ValueBase))
                    return "ValueBase: array expected";
                for (var i = 0; i < message.ValueBase.length; ++i)
                    if (!$util.isInteger(message.ValueBase[i]))
                        return "ValueBase: integer[] expected";
            }
            if (message.StarBase != null && message.hasOwnProperty("StarBase"))
                if (!$util.isInteger(message.StarBase))
                    return "StarBase: integer expected";
            if (message.FavorFoodsList != null && message.hasOwnProperty("FavorFoodsList")) {
                if (!Array.isArray(message.FavorFoodsList))
                    return "FavorFoodsList: array expected";
                for (var i = 0; i < message.FavorFoodsList.length; ++i)
                    if (!$util.isString(message.FavorFoodsList[i]))
                        return "FavorFoodsList: string[] expected";
            }
            if (message.Gift != null && message.hasOwnProperty("Gift"))
                if (!$util.isString(message.Gift))
                    return "Gift: string expected";
            if (message.FavorToys != null && message.hasOwnProperty("FavorToys"))
                if (!$util.isString(message.FavorToys))
                    return "FavorToys: string expected";
            if (message.NormalActions != null && message.hasOwnProperty("NormalActions"))
                if (!$util.isString(message.NormalActions))
                    return "NormalActions: string expected";
            if (message.CatSound != null && message.hasOwnProperty("CatSound"))
                if (!$util.isString(message.CatSound))
                    return "CatSound: string expected";
            if (message.Rank != null && message.hasOwnProperty("Rank"))
                if (!$util.isInteger(message.Rank))
                    return "Rank: integer expected";
            if (message.BasicInfor != null && message.hasOwnProperty("BasicInfor"))
                if (!$util.isString(message.BasicInfor))
                    return "BasicInfor: string expected";
            if (message.ShareReward != null && message.hasOwnProperty("ShareReward"))
                if (!$util.isString(message.ShareReward))
                    return "ShareReward: string expected";
            if (message.DropRate != null && message.hasOwnProperty("DropRate"))
                if (!$util.isString(message.DropRate))
                    return "DropRate: string expected";
            if (message.Label != null && message.hasOwnProperty("Label"))
                if (!$util.isString(message.Label))
                    return "Label: string expected";
            if (message.Potential != null && message.hasOwnProperty("Potential"))
                if (!$util.isString(message.Potential))
                    return "Potential: string expected";
            if (message.Flag != null && message.hasOwnProperty("Flag"))
                if (!$util.isString(message.Flag))
                    return "Flag: string expected";
            if (message.BaseValue != null && message.hasOwnProperty("BaseValue"))
                if (!$util.isString(message.BaseValue))
                    return "BaseValue: string expected";
            return null;
        };

        return Role;
    })();

    pattern.Task = (function() {

        /**
         * Properties of a Task.
         * @memberof pattern
         * @interface ITask
         * @property {string|null} [Id] Task Id
         * @property {string|null} [Name] Task Name
         * @property {string|null} [Desc] Task Desc
         * @property {string|null} [ConditionType] Task ConditionType
         * @property {number|null} [ConditionValue] Task ConditionValue
         * @property {string|null} [RewardType] Task RewardType
         * @property {number|null} [Reward] Task Reward
         * @property {string|null} [InitType] Task InitType
         */

        /**
         * Constructs a new Task.
         * @memberof pattern
         * @classdesc Represents a Task.
         * @implements ITask
         * @constructor
         * @param {pattern.ITask=} [properties] Properties to set
         */
        function Task(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Task Id.
         * @member {string} Id
         * @memberof pattern.Task
         * @instance
         */
        Task.prototype.Id = "";

        /**
         * Task Name.
         * @member {string} Name
         * @memberof pattern.Task
         * @instance
         */
        Task.prototype.Name = "";

        /**
         * Task Desc.
         * @member {string} Desc
         * @memberof pattern.Task
         * @instance
         */
        Task.prototype.Desc = "";

        /**
         * Task ConditionType.
         * @member {string} ConditionType
         * @memberof pattern.Task
         * @instance
         */
        Task.prototype.ConditionType = "";

        /**
         * Task ConditionValue.
         * @member {number} ConditionValue
         * @memberof pattern.Task
         * @instance
         */
        Task.prototype.ConditionValue = 0;

        /**
         * Task RewardType.
         * @member {string} RewardType
         * @memberof pattern.Task
         * @instance
         */
        Task.prototype.RewardType = "";

        /**
         * Task Reward.
         * @member {number} Reward
         * @memberof pattern.Task
         * @instance
         */
        Task.prototype.Reward = 0;

        /**
         * Task InitType.
         * @member {string} InitType
         * @memberof pattern.Task
         * @instance
         */
        Task.prototype.InitType = "";

        /**
         * Creates a new Task instance using the specified properties.
         * @function create
         * @memberof pattern.Task
         * @static
         * @param {pattern.ITask=} [properties] Properties to set
         * @returns {pattern.Task} Task instance
         */
        Task.create = function create(properties) {
            return new Task(properties);
        };

        /**
         * Encodes the specified Task message. Does not implicitly {@link pattern.Task.verify|verify} messages.
         * @function encode
         * @memberof pattern.Task
         * @static
         * @param {pattern.ITask} message Task message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Task.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.Name != null && message.hasOwnProperty("Name"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.Name);
            if (message.Desc != null && message.hasOwnProperty("Desc"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.Desc);
            if (message.ConditionType != null && message.hasOwnProperty("ConditionType"))
                writer.uint32(/* id 4, wireType 2 =*/34).string(message.ConditionType);
            if (message.ConditionValue != null && message.hasOwnProperty("ConditionValue"))
                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.ConditionValue);
            if (message.RewardType != null && message.hasOwnProperty("RewardType"))
                writer.uint32(/* id 6, wireType 2 =*/50).string(message.RewardType);
            if (message.Reward != null && message.hasOwnProperty("Reward"))
                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.Reward);
            if (message.InitType != null && message.hasOwnProperty("InitType"))
                writer.uint32(/* id 8, wireType 2 =*/66).string(message.InitType);
            return writer;
        };

        /**
         * Encodes the specified Task message, length delimited. Does not implicitly {@link pattern.Task.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.Task
         * @static
         * @param {pattern.ITask} message Task message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Task.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Task message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.Task
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.Task} Task
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Task.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.Task();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.Name = reader.string();
                    break;
                case 3:
                    message.Desc = reader.string();
                    break;
                case 4:
                    message.ConditionType = reader.string();
                    break;
                case 5:
                    message.ConditionValue = reader.int32();
                    break;
                case 6:
                    message.RewardType = reader.string();
                    break;
                case 7:
                    message.Reward = reader.int32();
                    break;
                case 8:
                    message.InitType = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Task message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.Task
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.Task} Task
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Task.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Task message.
         * @function verify
         * @memberof pattern.Task
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Task.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.Name != null && message.hasOwnProperty("Name"))
                if (!$util.isString(message.Name))
                    return "Name: string expected";
            if (message.Desc != null && message.hasOwnProperty("Desc"))
                if (!$util.isString(message.Desc))
                    return "Desc: string expected";
            if (message.ConditionType != null && message.hasOwnProperty("ConditionType"))
                if (!$util.isString(message.ConditionType))
                    return "ConditionType: string expected";
            if (message.ConditionValue != null && message.hasOwnProperty("ConditionValue"))
                if (!$util.isInteger(message.ConditionValue))
                    return "ConditionValue: integer expected";
            if (message.RewardType != null && message.hasOwnProperty("RewardType"))
                if (!$util.isString(message.RewardType))
                    return "RewardType: string expected";
            if (message.Reward != null && message.hasOwnProperty("Reward"))
                if (!$util.isInteger(message.Reward))
                    return "Reward: integer expected";
            if (message.InitType != null && message.hasOwnProperty("InitType"))
                if (!$util.isString(message.InitType))
                    return "InitType: string expected";
            return null;
        };

        return Task;
    })();

    pattern.TaskInvite = (function() {

        /**
         * Properties of a TaskInvite.
         * @memberof pattern
         * @interface ITaskInvite
         * @property {string|null} [Id] TaskInvite Id
         * @property {number|null} [Order] TaskInvite Order
         * @property {string|null} [NextId] TaskInvite NextId
         * @property {string|null} [Condition] TaskInvite Condition
         * @property {string|null} [Reward] TaskInvite Reward
         */

        /**
         * Constructs a new TaskInvite.
         * @memberof pattern
         * @classdesc Represents a TaskInvite.
         * @implements ITaskInvite
         * @constructor
         * @param {pattern.ITaskInvite=} [properties] Properties to set
         */
        function TaskInvite(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * TaskInvite Id.
         * @member {string} Id
         * @memberof pattern.TaskInvite
         * @instance
         */
        TaskInvite.prototype.Id = "";

        /**
         * TaskInvite Order.
         * @member {number} Order
         * @memberof pattern.TaskInvite
         * @instance
         */
        TaskInvite.prototype.Order = 0;

        /**
         * TaskInvite NextId.
         * @member {string} NextId
         * @memberof pattern.TaskInvite
         * @instance
         */
        TaskInvite.prototype.NextId = "";

        /**
         * TaskInvite Condition.
         * @member {string} Condition
         * @memberof pattern.TaskInvite
         * @instance
         */
        TaskInvite.prototype.Condition = "";

        /**
         * TaskInvite Reward.
         * @member {string} Reward
         * @memberof pattern.TaskInvite
         * @instance
         */
        TaskInvite.prototype.Reward = "";

        /**
         * Creates a new TaskInvite instance using the specified properties.
         * @function create
         * @memberof pattern.TaskInvite
         * @static
         * @param {pattern.ITaskInvite=} [properties] Properties to set
         * @returns {pattern.TaskInvite} TaskInvite instance
         */
        TaskInvite.create = function create(properties) {
            return new TaskInvite(properties);
        };

        /**
         * Encodes the specified TaskInvite message. Does not implicitly {@link pattern.TaskInvite.verify|verify} messages.
         * @function encode
         * @memberof pattern.TaskInvite
         * @static
         * @param {pattern.ITaskInvite} message TaskInvite message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TaskInvite.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.Order != null && message.hasOwnProperty("Order"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.Order);
            if (message.NextId != null && message.hasOwnProperty("NextId"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.NextId);
            if (message.Condition != null && message.hasOwnProperty("Condition"))
                writer.uint32(/* id 4, wireType 2 =*/34).string(message.Condition);
            if (message.Reward != null && message.hasOwnProperty("Reward"))
                writer.uint32(/* id 5, wireType 2 =*/42).string(message.Reward);
            return writer;
        };

        /**
         * Encodes the specified TaskInvite message, length delimited. Does not implicitly {@link pattern.TaskInvite.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.TaskInvite
         * @static
         * @param {pattern.ITaskInvite} message TaskInvite message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TaskInvite.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a TaskInvite message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.TaskInvite
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.TaskInvite} TaskInvite
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TaskInvite.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.TaskInvite();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.Order = reader.int32();
                    break;
                case 3:
                    message.NextId = reader.string();
                    break;
                case 4:
                    message.Condition = reader.string();
                    break;
                case 5:
                    message.Reward = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a TaskInvite message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.TaskInvite
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.TaskInvite} TaskInvite
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TaskInvite.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a TaskInvite message.
         * @function verify
         * @memberof pattern.TaskInvite
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        TaskInvite.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.Order != null && message.hasOwnProperty("Order"))
                if (!$util.isInteger(message.Order))
                    return "Order: integer expected";
            if (message.NextId != null && message.hasOwnProperty("NextId"))
                if (!$util.isString(message.NextId))
                    return "NextId: string expected";
            if (message.Condition != null && message.hasOwnProperty("Condition"))
                if (!$util.isString(message.Condition))
                    return "Condition: string expected";
            if (message.Reward != null && message.hasOwnProperty("Reward"))
                if (!$util.isString(message.Reward))
                    return "Reward: string expected";
            return null;
        };

        return TaskInvite;
    })();

    pattern.TaskList = (function() {

        /**
         * Properties of a TaskList.
         * @memberof pattern
         * @interface ITaskList
         * @property {string|null} [Id] TaskList Id
         * @property {number|null} [TaskType] TaskList TaskType
         * @property {Array.<string>|null} [List] TaskList List
         * @property {number|null} [Order] TaskList Order
         * @property {Array.<number>|null} [RegistrationDate] TaskList RegistrationDate
         * @property {string|null} [Jump] TaskList Jump
         * @property {string|null} [Picture] TaskList Picture
         */

        /**
         * Constructs a new TaskList.
         * @memberof pattern
         * @classdesc Represents a TaskList.
         * @implements ITaskList
         * @constructor
         * @param {pattern.ITaskList=} [properties] Properties to set
         */
        function TaskList(properties) {
            this.List = [];
            this.RegistrationDate = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * TaskList Id.
         * @member {string} Id
         * @memberof pattern.TaskList
         * @instance
         */
        TaskList.prototype.Id = "";

        /**
         * TaskList TaskType.
         * @member {number} TaskType
         * @memberof pattern.TaskList
         * @instance
         */
        TaskList.prototype.TaskType = 0;

        /**
         * TaskList List.
         * @member {Array.<string>} List
         * @memberof pattern.TaskList
         * @instance
         */
        TaskList.prototype.List = $util.emptyArray;

        /**
         * TaskList Order.
         * @member {number} Order
         * @memberof pattern.TaskList
         * @instance
         */
        TaskList.prototype.Order = 0;

        /**
         * TaskList RegistrationDate.
         * @member {Array.<number>} RegistrationDate
         * @memberof pattern.TaskList
         * @instance
         */
        TaskList.prototype.RegistrationDate = $util.emptyArray;

        /**
         * TaskList Jump.
         * @member {string} Jump
         * @memberof pattern.TaskList
         * @instance
         */
        TaskList.prototype.Jump = "";

        /**
         * TaskList Picture.
         * @member {string} Picture
         * @memberof pattern.TaskList
         * @instance
         */
        TaskList.prototype.Picture = "";

        /**
         * Creates a new TaskList instance using the specified properties.
         * @function create
         * @memberof pattern.TaskList
         * @static
         * @param {pattern.ITaskList=} [properties] Properties to set
         * @returns {pattern.TaskList} TaskList instance
         */
        TaskList.create = function create(properties) {
            return new TaskList(properties);
        };

        /**
         * Encodes the specified TaskList message. Does not implicitly {@link pattern.TaskList.verify|verify} messages.
         * @function encode
         * @memberof pattern.TaskList
         * @static
         * @param {pattern.ITaskList} message TaskList message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TaskList.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.TaskType != null && message.hasOwnProperty("TaskType"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.TaskType);
            if (message.List != null && message.List.length)
                for (var i = 0; i < message.List.length; ++i)
                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.List[i]);
            if (message.Order != null && message.hasOwnProperty("Order"))
                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.Order);
            if (message.RegistrationDate != null && message.RegistrationDate.length) {
                writer.uint32(/* id 5, wireType 2 =*/42).fork();
                for (var i = 0; i < message.RegistrationDate.length; ++i)
                    writer.int32(message.RegistrationDate[i]);
                writer.ldelim();
            }
            if (message.Jump != null && message.hasOwnProperty("Jump"))
                writer.uint32(/* id 6, wireType 2 =*/50).string(message.Jump);
            if (message.Picture != null && message.hasOwnProperty("Picture"))
                writer.uint32(/* id 7, wireType 2 =*/58).string(message.Picture);
            return writer;
        };

        /**
         * Encodes the specified TaskList message, length delimited. Does not implicitly {@link pattern.TaskList.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.TaskList
         * @static
         * @param {pattern.ITaskList} message TaskList message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TaskList.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a TaskList message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.TaskList
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.TaskList} TaskList
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TaskList.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.TaskList();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.TaskType = reader.int32();
                    break;
                case 3:
                    if (!(message.List && message.List.length))
                        message.List = [];
                    message.List.push(reader.string());
                    break;
                case 4:
                    message.Order = reader.int32();
                    break;
                case 5:
                    if (!(message.RegistrationDate && message.RegistrationDate.length))
                        message.RegistrationDate = [];
                    if ((tag & 7) === 2) {
                        var end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2)
                            message.RegistrationDate.push(reader.int32());
                    } else
                        message.RegistrationDate.push(reader.int32());
                    break;
                case 6:
                    message.Jump = reader.string();
                    break;
                case 7:
                    message.Picture = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a TaskList message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.TaskList
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.TaskList} TaskList
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TaskList.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a TaskList message.
         * @function verify
         * @memberof pattern.TaskList
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        TaskList.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.TaskType != null && message.hasOwnProperty("TaskType"))
                if (!$util.isInteger(message.TaskType))
                    return "TaskType: integer expected";
            if (message.List != null && message.hasOwnProperty("List")) {
                if (!Array.isArray(message.List))
                    return "List: array expected";
                for (var i = 0; i < message.List.length; ++i)
                    if (!$util.isString(message.List[i]))
                        return "List: string[] expected";
            }
            if (message.Order != null && message.hasOwnProperty("Order"))
                if (!$util.isInteger(message.Order))
                    return "Order: integer expected";
            if (message.RegistrationDate != null && message.hasOwnProperty("RegistrationDate")) {
                if (!Array.isArray(message.RegistrationDate))
                    return "RegistrationDate: array expected";
                for (var i = 0; i < message.RegistrationDate.length; ++i)
                    if (!$util.isInteger(message.RegistrationDate[i]))
                        return "RegistrationDate: integer[] expected";
            }
            if (message.Jump != null && message.hasOwnProperty("Jump"))
                if (!$util.isString(message.Jump))
                    return "Jump: string expected";
            if (message.Picture != null && message.hasOwnProperty("Picture"))
                if (!$util.isString(message.Picture))
                    return "Picture: string expected";
            return null;
        };

        return TaskList;
    })();

    pattern.TaskMain = (function() {

        /**
         * Properties of a TaskMain.
         * @memberof pattern
         * @interface ITaskMain
         * @property {string|null} [Id] TaskMain Id
         * @property {string|null} [Desc] TaskMain Desc
         * @property {string|null} [ConditionStart] TaskMain ConditionStart
         * @property {number|null} [Order] TaskMain Order
         * @property {string|null} [ConditionType] TaskMain ConditionType
         * @property {number|null} [ConditionValue] TaskMain ConditionValue
         * @property {string|null} [Reward] TaskMain Reward
         * @property {string|null} [Guide] TaskMain Guide
         * @property {Array.<string>|null} [StartDialog] TaskMain StartDialog
         * @property {Array.<string>|null} [EndDialog] TaskMain EndDialog
         * @property {string|null} [Jump] TaskMain Jump
         */

        /**
         * Constructs a new TaskMain.
         * @memberof pattern
         * @classdesc Represents a TaskMain.
         * @implements ITaskMain
         * @constructor
         * @param {pattern.ITaskMain=} [properties] Properties to set
         */
        function TaskMain(properties) {
            this.StartDialog = [];
            this.EndDialog = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * TaskMain Id.
         * @member {string} Id
         * @memberof pattern.TaskMain
         * @instance
         */
        TaskMain.prototype.Id = "";

        /**
         * TaskMain Desc.
         * @member {string} Desc
         * @memberof pattern.TaskMain
         * @instance
         */
        TaskMain.prototype.Desc = "";

        /**
         * TaskMain ConditionStart.
         * @member {string} ConditionStart
         * @memberof pattern.TaskMain
         * @instance
         */
        TaskMain.prototype.ConditionStart = "";

        /**
         * TaskMain Order.
         * @member {number} Order
         * @memberof pattern.TaskMain
         * @instance
         */
        TaskMain.prototype.Order = 0;

        /**
         * TaskMain ConditionType.
         * @member {string} ConditionType
         * @memberof pattern.TaskMain
         * @instance
         */
        TaskMain.prototype.ConditionType = "";

        /**
         * TaskMain ConditionValue.
         * @member {number} ConditionValue
         * @memberof pattern.TaskMain
         * @instance
         */
        TaskMain.prototype.ConditionValue = 0;

        /**
         * TaskMain Reward.
         * @member {string} Reward
         * @memberof pattern.TaskMain
         * @instance
         */
        TaskMain.prototype.Reward = "";

        /**
         * TaskMain Guide.
         * @member {string} Guide
         * @memberof pattern.TaskMain
         * @instance
         */
        TaskMain.prototype.Guide = "";

        /**
         * TaskMain StartDialog.
         * @member {Array.<string>} StartDialog
         * @memberof pattern.TaskMain
         * @instance
         */
        TaskMain.prototype.StartDialog = $util.emptyArray;

        /**
         * TaskMain EndDialog.
         * @member {Array.<string>} EndDialog
         * @memberof pattern.TaskMain
         * @instance
         */
        TaskMain.prototype.EndDialog = $util.emptyArray;

        /**
         * TaskMain Jump.
         * @member {string} Jump
         * @memberof pattern.TaskMain
         * @instance
         */
        TaskMain.prototype.Jump = "";

        /**
         * Creates a new TaskMain instance using the specified properties.
         * @function create
         * @memberof pattern.TaskMain
         * @static
         * @param {pattern.ITaskMain=} [properties] Properties to set
         * @returns {pattern.TaskMain} TaskMain instance
         */
        TaskMain.create = function create(properties) {
            return new TaskMain(properties);
        };

        /**
         * Encodes the specified TaskMain message. Does not implicitly {@link pattern.TaskMain.verify|verify} messages.
         * @function encode
         * @memberof pattern.TaskMain
         * @static
         * @param {pattern.ITaskMain} message TaskMain message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TaskMain.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.Desc != null && message.hasOwnProperty("Desc"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.Desc);
            if (message.ConditionStart != null && message.hasOwnProperty("ConditionStart"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.ConditionStart);
            if (message.Order != null && message.hasOwnProperty("Order"))
                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.Order);
            if (message.ConditionType != null && message.hasOwnProperty("ConditionType"))
                writer.uint32(/* id 5, wireType 2 =*/42).string(message.ConditionType);
            if (message.ConditionValue != null && message.hasOwnProperty("ConditionValue"))
                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.ConditionValue);
            if (message.Reward != null && message.hasOwnProperty("Reward"))
                writer.uint32(/* id 7, wireType 2 =*/58).string(message.Reward);
            if (message.Guide != null && message.hasOwnProperty("Guide"))
                writer.uint32(/* id 8, wireType 2 =*/66).string(message.Guide);
            if (message.StartDialog != null && message.StartDialog.length)
                for (var i = 0; i < message.StartDialog.length; ++i)
                    writer.uint32(/* id 9, wireType 2 =*/74).string(message.StartDialog[i]);
            if (message.EndDialog != null && message.EndDialog.length)
                for (var i = 0; i < message.EndDialog.length; ++i)
                    writer.uint32(/* id 10, wireType 2 =*/82).string(message.EndDialog[i]);
            if (message.Jump != null && message.hasOwnProperty("Jump"))
                writer.uint32(/* id 11, wireType 2 =*/90).string(message.Jump);
            return writer;
        };

        /**
         * Encodes the specified TaskMain message, length delimited. Does not implicitly {@link pattern.TaskMain.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.TaskMain
         * @static
         * @param {pattern.ITaskMain} message TaskMain message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TaskMain.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a TaskMain message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.TaskMain
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.TaskMain} TaskMain
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TaskMain.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.TaskMain();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    message.Desc = reader.string();
                    break;
                case 3:
                    message.ConditionStart = reader.string();
                    break;
                case 4:
                    message.Order = reader.int32();
                    break;
                case 5:
                    message.ConditionType = reader.string();
                    break;
                case 6:
                    message.ConditionValue = reader.int32();
                    break;
                case 7:
                    message.Reward = reader.string();
                    break;
                case 8:
                    message.Guide = reader.string();
                    break;
                case 9:
                    if (!(message.StartDialog && message.StartDialog.length))
                        message.StartDialog = [];
                    message.StartDialog.push(reader.string());
                    break;
                case 10:
                    if (!(message.EndDialog && message.EndDialog.length))
                        message.EndDialog = [];
                    message.EndDialog.push(reader.string());
                    break;
                case 11:
                    message.Jump = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a TaskMain message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.TaskMain
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.TaskMain} TaskMain
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TaskMain.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a TaskMain message.
         * @function verify
         * @memberof pattern.TaskMain
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        TaskMain.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.Desc != null && message.hasOwnProperty("Desc"))
                if (!$util.isString(message.Desc))
                    return "Desc: string expected";
            if (message.ConditionStart != null && message.hasOwnProperty("ConditionStart"))
                if (!$util.isString(message.ConditionStart))
                    return "ConditionStart: string expected";
            if (message.Order != null && message.hasOwnProperty("Order"))
                if (!$util.isInteger(message.Order))
                    return "Order: integer expected";
            if (message.ConditionType != null && message.hasOwnProperty("ConditionType"))
                if (!$util.isString(message.ConditionType))
                    return "ConditionType: string expected";
            if (message.ConditionValue != null && message.hasOwnProperty("ConditionValue"))
                if (!$util.isInteger(message.ConditionValue))
                    return "ConditionValue: integer expected";
            if (message.Reward != null && message.hasOwnProperty("Reward"))
                if (!$util.isString(message.Reward))
                    return "Reward: string expected";
            if (message.Guide != null && message.hasOwnProperty("Guide"))
                if (!$util.isString(message.Guide))
                    return "Guide: string expected";
            if (message.StartDialog != null && message.hasOwnProperty("StartDialog")) {
                if (!Array.isArray(message.StartDialog))
                    return "StartDialog: array expected";
                for (var i = 0; i < message.StartDialog.length; ++i)
                    if (!$util.isString(message.StartDialog[i]))
                        return "StartDialog: string[] expected";
            }
            if (message.EndDialog != null && message.hasOwnProperty("EndDialog")) {
                if (!Array.isArray(message.EndDialog))
                    return "EndDialog: array expected";
                for (var i = 0; i < message.EndDialog.length; ++i)
                    if (!$util.isString(message.EndDialog[i]))
                        return "EndDialog: string[] expected";
            }
            if (message.Jump != null && message.hasOwnProperty("Jump"))
                if (!$util.isString(message.Jump))
                    return "Jump: string expected";
            return null;
        };

        return TaskMain;
    })();

    pattern.Translate = (function() {

        /**
         * Properties of a Translate.
         * @memberof pattern
         * @interface ITranslate
         * @property {string|null} [Id] Translate Id
         * @property {Array.<string>|null} [zh_CH] Translate zh_CH
         */

        /**
         * Constructs a new Translate.
         * @memberof pattern
         * @classdesc Represents a Translate.
         * @implements ITranslate
         * @constructor
         * @param {pattern.ITranslate=} [properties] Properties to set
         */
        function Translate(properties) {
            this.zh_CH = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Translate Id.
         * @member {string} Id
         * @memberof pattern.Translate
         * @instance
         */
        Translate.prototype.Id = "";

        /**
         * Translate zh_CH.
         * @member {Array.<string>} zh_CH
         * @memberof pattern.Translate
         * @instance
         */
        Translate.prototype.zh_CH = $util.emptyArray;

        /**
         * Creates a new Translate instance using the specified properties.
         * @function create
         * @memberof pattern.Translate
         * @static
         * @param {pattern.ITranslate=} [properties] Properties to set
         * @returns {pattern.Translate} Translate instance
         */
        Translate.create = function create(properties) {
            return new Translate(properties);
        };

        /**
         * Encodes the specified Translate message. Does not implicitly {@link pattern.Translate.verify|verify} messages.
         * @function encode
         * @memberof pattern.Translate
         * @static
         * @param {pattern.ITranslate} message Translate message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Translate.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.Id != null && message.hasOwnProperty("Id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.Id);
            if (message.zh_CH != null && message.zh_CH.length)
                for (var i = 0; i < message.zh_CH.length; ++i)
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.zh_CH[i]);
            return writer;
        };

        /**
         * Encodes the specified Translate message, length delimited. Does not implicitly {@link pattern.Translate.verify|verify} messages.
         * @function encodeDelimited
         * @memberof pattern.Translate
         * @static
         * @param {pattern.ITranslate} message Translate message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Translate.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Translate message from the specified reader or buffer.
         * @function decode
         * @memberof pattern.Translate
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {pattern.Translate} Translate
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Translate.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.pattern.Translate();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.Id = reader.string();
                    break;
                case 2:
                    if (!(message.zh_CH && message.zh_CH.length))
                        message.zh_CH = [];
                    message.zh_CH.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Translate message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof pattern.Translate
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {pattern.Translate} Translate
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Translate.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Translate message.
         * @function verify
         * @memberof pattern.Translate
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Translate.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.Id != null && message.hasOwnProperty("Id"))
                if (!$util.isString(message.Id))
                    return "Id: string expected";
            if (message.zh_CH != null && message.hasOwnProperty("zh_CH")) {
                if (!Array.isArray(message.zh_CH))
                    return "zh_CH: array expected";
                for (var i = 0; i < message.zh_CH.length; ++i)
                    if (!$util.isString(message.zh_CH[i]))
                        return "zh_CH: string[] expected";
            }
            return null;
        };

        return Translate;
    })();

    return pattern;
})();