var $protobuf = window.protobuf;
$protobuf.roots.default=window;
// Common aliases
var $Reader = $protobuf.Reader, $Writer = $protobuf.Writer, $util = $protobuf.util;

// Exported root namespace
var $root = $protobuf.roots["default"] || ($protobuf.roots["default"] = {});

$root.Player = (function() {

    /**
     * Namespace Player.
     * @exports Player
     * @namespace
     */
    var Player = {};

    Player.LoginReq = (function() {

        /**
         * Properties of a LoginReq.
         * @memberof Player
         * @interface ILoginReq
         * @property {string|null} [rid] LoginReq rid
         * @property {string|null} [token] LoginReq token
         * @property {string|null} [sdkName] LoginReq sdkName
         * @property {Player.IUserInfo|null} [userInfo] LoginReq userInfo
         * @property {BaseInfo.IPPInfo|null} [ppInfo] LoginReq ppInfo
         */

        /**
         * Constructs a new LoginReq.
         * @memberof Player
         * @classdesc Represents a LoginReq.
         * @implements ILoginReq
         * @constructor
         * @param {Player.ILoginReq=} [properties] Properties to set
         */
        function LoginReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * LoginReq rid.
         * @member {string} rid
         * @memberof Player.LoginReq
         * @instance
         */
        LoginReq.prototype.rid = "";

        /**
         * LoginReq token.
         * @member {string} token
         * @memberof Player.LoginReq
         * @instance
         */
        LoginReq.prototype.token = "";

        /**
         * LoginReq sdkName.
         * @member {string} sdkName
         * @memberof Player.LoginReq
         * @instance
         */
        LoginReq.prototype.sdkName = "";

        /**
         * LoginReq userInfo.
         * @member {Player.IUserInfo|null|undefined} userInfo
         * @memberof Player.LoginReq
         * @instance
         */
        LoginReq.prototype.userInfo = null;

        /**
         * LoginReq ppInfo.
         * @member {BaseInfo.IPPInfo|null|undefined} ppInfo
         * @memberof Player.LoginReq
         * @instance
         */
        LoginReq.prototype.ppInfo = null;

        /**
         * Creates a new LoginReq instance using the specified properties.
         * @function create
         * @memberof Player.LoginReq
         * @static
         * @param {Player.ILoginReq=} [properties] Properties to set
         * @returns {Player.LoginReq} LoginReq instance
         */
        LoginReq.create = function create(properties) {
            return new LoginReq(properties);
        };

        /**
         * Encodes the specified LoginReq message. Does not implicitly {@link Player.LoginReq.verify|verify} messages.
         * @function encode
         * @memberof Player.LoginReq
         * @static
         * @param {Player.ILoginReq} message LoginReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LoginReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.rid != null && message.hasOwnProperty("rid"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.rid);
            if (message.token != null && message.hasOwnProperty("token"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.token);
            if (message.sdkName != null && message.hasOwnProperty("sdkName"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.sdkName);
            if (message.userInfo != null && message.hasOwnProperty("userInfo"))
                $root.Player.UserInfo.encode(message.userInfo, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            if (message.ppInfo != null && message.hasOwnProperty("ppInfo"))
                $root.BaseInfo.PPInfo.encode(message.ppInfo, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified LoginReq message, length delimited. Does not implicitly {@link Player.LoginReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.LoginReq
         * @static
         * @param {Player.ILoginReq} message LoginReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LoginReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a LoginReq message from the specified reader or buffer.
         * @function decode
         * @memberof Player.LoginReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.LoginReq} LoginReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LoginReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.LoginReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.rid = reader.string();
                    break;
                case 2:
                    message.token = reader.string();
                    break;
                case 3:
                    message.sdkName = reader.string();
                    break;
                case 4:
                    message.userInfo = $root.Player.UserInfo.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.ppInfo = $root.BaseInfo.PPInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a LoginReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.LoginReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.LoginReq} LoginReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LoginReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a LoginReq message.
         * @function verify
         * @memberof Player.LoginReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        LoginReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.rid != null && message.hasOwnProperty("rid"))
                if (!$util.isString(message.rid))
                    return "rid: string expected";
            if (message.token != null && message.hasOwnProperty("token"))
                if (!$util.isString(message.token))
                    return "token: string expected";
            if (message.sdkName != null && message.hasOwnProperty("sdkName"))
                if (!$util.isString(message.sdkName))
                    return "sdkName: string expected";
            if (message.userInfo != null && message.hasOwnProperty("userInfo")) {
                var error = $root.Player.UserInfo.verify(message.userInfo);
                if (error)
                    return "userInfo." + error;
            }
            if (message.ppInfo != null && message.hasOwnProperty("ppInfo")) {
                var error = $root.BaseInfo.PPInfo.verify(message.ppInfo);
                if (error)
                    return "ppInfo." + error;
            }
            return null;
        };

        return LoginReq;
    })();

    Player.LoginRes = (function() {

        /**
         * Properties of a LoginRes.
         * @memberof Player
         * @interface ILoginRes
         * @property {BaseInfo.IFullBag|null} [bag] LoginRes bag
         * @property {BaseInfo.IPlayerBuilding|null} [playerBuilding] LoginRes playerBuilding
         * @property {BaseInfo.IPlayerPets|null} [playerPets] LoginRes playerPets
         * @property {BaseInfo.ITasks|null} [tasks] LoginRes tasks
         * @property {BaseInfo.IFoodMenu|null} [menu] LoginRes menu
         * @property {BaseInfo.ILetterBox|null} [letterbox] LoginRes letterbox
         * @property {FishingGame.IFishingGameInfo|null} [fishingGameInfo] LoginRes fishingGameInfo
         * @property {Home.IHomeInfo|null} [homeInfo] LoginRes homeInfo
         * @property {string|null} [customData] LoginRes customData
         * @property {boolean|null} [visitorRewardsExist] LoginRes visitorRewardsExist
         * @property {Object.<string,string>|null} [customKV] LoginRes customKV
         * @property {Object.<string,string>|null} [extraInfo] LoginRes extraInfo
         * @property {Balloon.IBalloonInfo|null} [balloon] LoginRes balloon
         * @property {number|null} [newMailCount] LoginRes newMailCount
         * @property {BaseInfo.IAdRewardsInfo|null} [adRewardsInfo] LoginRes adRewardsInfo
         * @property {LuckyBag.ILuckyBagInfo|null} [luckyBagInfo] LoginRes luckyBagInfo
         * @property {number|Long|null} [timeOffSet] LoginRes timeOffSet
         * @property {BaseInfo.INauticalProjectGroup|null} [nauticalProjectGroup] LoginRes nauticalProjectGroup
         * @property {BaseInfo.IWharfLetterBox|null} [wharfLetterBox] LoginRes wharfLetterBox
         * @property {BaseInfo.IAidedGroupInfo|null} [aidedGroupInfo] LoginRes aidedGroupInfo
         * @property {Array.<string>|null} [finishedMilestone] LoginRes finishedMilestone
         * @property {BaseInfo.ILuckyDraw|null} [luckyDraw] LoginRes luckyDraw
         * @property {boolean|null} [isNew] LoginRes isNew
         * @property {Array.<LuckyDraw.ITicketBuildingInfo>|null} [ticketBuildingInfos] LoginRes ticketBuildingInfos
         * @property {BaseInfo.IPayInfo|null} [payInfo] LoginRes payInfo
         * @property {LuckyDraw.ILotteryBag|null} [lotteryBag] LoginRes lotteryBag
         * @property {BaseInfo.ITakeoutInfo|null} [takeoutInfo] LoginRes takeoutInfo
         */

        /**
         * Constructs a new LoginRes.
         * @memberof Player
         * @classdesc Represents a LoginRes.
         * @implements ILoginRes
         * @constructor
         * @param {Player.ILoginRes=} [properties] Properties to set
         */
        function LoginRes(properties) {
            this.customKV = {};
            this.extraInfo = {};
            this.finishedMilestone = [];
            this.ticketBuildingInfos = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * LoginRes bag.
         * @member {BaseInfo.IFullBag|null|undefined} bag
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.bag = null;

        /**
         * LoginRes playerBuilding.
         * @member {BaseInfo.IPlayerBuilding|null|undefined} playerBuilding
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.playerBuilding = null;

        /**
         * LoginRes playerPets.
         * @member {BaseInfo.IPlayerPets|null|undefined} playerPets
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.playerPets = null;

        /**
         * LoginRes tasks.
         * @member {BaseInfo.ITasks|null|undefined} tasks
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.tasks = null;

        /**
         * LoginRes menu.
         * @member {BaseInfo.IFoodMenu|null|undefined} menu
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.menu = null;

        /**
         * LoginRes letterbox.
         * @member {BaseInfo.ILetterBox|null|undefined} letterbox
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.letterbox = null;

        /**
         * LoginRes fishingGameInfo.
         * @member {FishingGame.IFishingGameInfo|null|undefined} fishingGameInfo
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.fishingGameInfo = null;

        /**
         * LoginRes homeInfo.
         * @member {Home.IHomeInfo|null|undefined} homeInfo
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.homeInfo = null;

        /**
         * LoginRes customData.
         * @member {string} customData
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.customData = "";

        /**
         * LoginRes visitorRewardsExist.
         * @member {boolean} visitorRewardsExist
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.visitorRewardsExist = false;

        /**
         * LoginRes customKV.
         * @member {Object.<string,string>} customKV
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.customKV = $util.emptyObject;

        /**
         * LoginRes extraInfo.
         * @member {Object.<string,string>} extraInfo
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.extraInfo = $util.emptyObject;

        /**
         * LoginRes balloon.
         * @member {Balloon.IBalloonInfo|null|undefined} balloon
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.balloon = null;

        /**
         * LoginRes newMailCount.
         * @member {number} newMailCount
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.newMailCount = 0;

        /**
         * LoginRes adRewardsInfo.
         * @member {BaseInfo.IAdRewardsInfo|null|undefined} adRewardsInfo
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.adRewardsInfo = null;

        /**
         * LoginRes luckyBagInfo.
         * @member {LuckyBag.ILuckyBagInfo|null|undefined} luckyBagInfo
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.luckyBagInfo = null;

        /**
         * LoginRes timeOffSet.
         * @member {number|Long} timeOffSet
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.timeOffSet = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * LoginRes nauticalProjectGroup.
         * @member {BaseInfo.INauticalProjectGroup|null|undefined} nauticalProjectGroup
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.nauticalProjectGroup = null;

        /**
         * LoginRes wharfLetterBox.
         * @member {BaseInfo.IWharfLetterBox|null|undefined} wharfLetterBox
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.wharfLetterBox = null;

        /**
         * LoginRes aidedGroupInfo.
         * @member {BaseInfo.IAidedGroupInfo|null|undefined} aidedGroupInfo
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.aidedGroupInfo = null;

        /**
         * LoginRes finishedMilestone.
         * @member {Array.<string>} finishedMilestone
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.finishedMilestone = $util.emptyArray;

        /**
         * LoginRes luckyDraw.
         * @member {BaseInfo.ILuckyDraw|null|undefined} luckyDraw
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.luckyDraw = null;

        /**
         * LoginRes isNew.
         * @member {boolean} isNew
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.isNew = false;

        /**
         * LoginRes ticketBuildingInfos.
         * @member {Array.<LuckyDraw.ITicketBuildingInfo>} ticketBuildingInfos
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.ticketBuildingInfos = $util.emptyArray;

        /**
         * LoginRes payInfo.
         * @member {BaseInfo.IPayInfo|null|undefined} payInfo
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.payInfo = null;

        /**
         * LoginRes lotteryBag.
         * @member {LuckyDraw.ILotteryBag|null|undefined} lotteryBag
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.lotteryBag = null;

        /**
         * LoginRes takeoutInfo.
         * @member {BaseInfo.ITakeoutInfo|null|undefined} takeoutInfo
         * @memberof Player.LoginRes
         * @instance
         */
        LoginRes.prototype.takeoutInfo = null;

        /**
         * Creates a new LoginRes instance using the specified properties.
         * @function create
         * @memberof Player.LoginRes
         * @static
         * @param {Player.ILoginRes=} [properties] Properties to set
         * @returns {Player.LoginRes} LoginRes instance
         */
        LoginRes.create = function create(properties) {
            return new LoginRes(properties);
        };

        /**
         * Encodes the specified LoginRes message. Does not implicitly {@link Player.LoginRes.verify|verify} messages.
         * @function encode
         * @memberof Player.LoginRes
         * @static
         * @param {Player.ILoginRes} message LoginRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LoginRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.FullBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.playerBuilding != null && message.hasOwnProperty("playerBuilding"))
                $root.BaseInfo.PlayerBuilding.encode(message.playerBuilding, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.playerPets != null && message.hasOwnProperty("playerPets"))
                $root.BaseInfo.PlayerPets.encode(message.playerPets, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.tasks != null && message.hasOwnProperty("tasks"))
                $root.BaseInfo.Tasks.encode(message.tasks, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            if (message.menu != null && message.hasOwnProperty("menu"))
                $root.BaseInfo.FoodMenu.encode(message.menu, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
            if (message.letterbox != null && message.hasOwnProperty("letterbox"))
                $root.BaseInfo.LetterBox.encode(message.letterbox, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
            if (message.customData != null && message.hasOwnProperty("customData"))
                writer.uint32(/* id 7, wireType 2 =*/58).string(message.customData);
            if (message.fishingGameInfo != null && message.hasOwnProperty("fishingGameInfo"))
                $root.FishingGame.FishingGameInfo.encode(message.fishingGameInfo, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
            if (message.homeInfo != null && message.hasOwnProperty("homeInfo"))
                $root.Home.HomeInfo.encode(message.homeInfo, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
            if (message.visitorRewardsExist != null && message.hasOwnProperty("visitorRewardsExist"))
                writer.uint32(/* id 10, wireType 0 =*/80).bool(message.visitorRewardsExist);
            if (message.customKV != null && message.hasOwnProperty("customKV"))
                for (var keys = Object.keys(message.customKV), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 11, wireType 2 =*/90).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.customKV[keys[i]]).ldelim();
            if (message.extraInfo != null && message.hasOwnProperty("extraInfo"))
                for (var keys = Object.keys(message.extraInfo), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 12, wireType 2 =*/98).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.extraInfo[keys[i]]).ldelim();
            if (message.balloon != null && message.hasOwnProperty("balloon"))
                $root.Balloon.BalloonInfo.encode(message.balloon, writer.uint32(/* id 13, wireType 2 =*/106).fork()).ldelim();
            if (message.newMailCount != null && message.hasOwnProperty("newMailCount"))
                writer.uint32(/* id 14, wireType 0 =*/112).int32(message.newMailCount);
            if (message.adRewardsInfo != null && message.hasOwnProperty("adRewardsInfo"))
                $root.BaseInfo.AdRewardsInfo.encode(message.adRewardsInfo, writer.uint32(/* id 15, wireType 2 =*/122).fork()).ldelim();
            if (message.luckyBagInfo != null && message.hasOwnProperty("luckyBagInfo"))
                $root.LuckyBag.LuckyBagInfo.encode(message.luckyBagInfo, writer.uint32(/* id 16, wireType 2 =*/130).fork()).ldelim();
            if (message.timeOffSet != null && message.hasOwnProperty("timeOffSet"))
                writer.uint32(/* id 17, wireType 0 =*/136).int64(message.timeOffSet);
            if (message.nauticalProjectGroup != null && message.hasOwnProperty("nauticalProjectGroup"))
                $root.BaseInfo.NauticalProjectGroup.encode(message.nauticalProjectGroup, writer.uint32(/* id 18, wireType 2 =*/146).fork()).ldelim();
            if (message.wharfLetterBox != null && message.hasOwnProperty("wharfLetterBox"))
                $root.BaseInfo.WharfLetterBox.encode(message.wharfLetterBox, writer.uint32(/* id 19, wireType 2 =*/154).fork()).ldelim();
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo"))
                $root.BaseInfo.AidedGroupInfo.encode(message.aidedGroupInfo, writer.uint32(/* id 20, wireType 2 =*/162).fork()).ldelim();
            if (message.finishedMilestone != null && message.finishedMilestone.length)
                for (var i = 0; i < message.finishedMilestone.length; ++i)
                    writer.uint32(/* id 21, wireType 2 =*/170).string(message.finishedMilestone[i]);
            if (message.luckyDraw != null && message.hasOwnProperty("luckyDraw"))
                $root.BaseInfo.LuckyDraw.encode(message.luckyDraw, writer.uint32(/* id 22, wireType 2 =*/178).fork()).ldelim();
            if (message.ticketBuildingInfos != null && message.ticketBuildingInfos.length)
                for (var i = 0; i < message.ticketBuildingInfos.length; ++i)
                    $root.LuckyDraw.TicketBuildingInfo.encode(message.ticketBuildingInfos[i], writer.uint32(/* id 25, wireType 2 =*/202).fork()).ldelim();
            if (message.payInfo != null && message.hasOwnProperty("payInfo"))
                $root.BaseInfo.PayInfo.encode(message.payInfo, writer.uint32(/* id 26, wireType 2 =*/210).fork()).ldelim();
            if (message.lotteryBag != null && message.hasOwnProperty("lotteryBag"))
                $root.LuckyDraw.LotteryBag.encode(message.lotteryBag, writer.uint32(/* id 27, wireType 2 =*/218).fork()).ldelim();
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo"))
                $root.BaseInfo.TakeoutInfo.encode(message.takeoutInfo, writer.uint32(/* id 28, wireType 2 =*/226).fork()).ldelim();
            if (message.isNew != null && message.hasOwnProperty("isNew"))
                writer.uint32(/* id 901, wireType 0 =*/7208).bool(message.isNew);
            return writer;
        };

        /**
         * Encodes the specified LoginRes message, length delimited. Does not implicitly {@link Player.LoginRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.LoginRes
         * @static
         * @param {Player.ILoginRes} message LoginRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LoginRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a LoginRes message from the specified reader or buffer.
         * @function decode
         * @memberof Player.LoginRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.LoginRes} LoginRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LoginRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.LoginRes(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.FullBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.playerBuilding = $root.BaseInfo.PlayerBuilding.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.playerPets = $root.BaseInfo.PlayerPets.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.tasks = $root.BaseInfo.Tasks.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.menu = $root.BaseInfo.FoodMenu.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.letterbox = $root.BaseInfo.LetterBox.decode(reader, reader.uint32());
                    break;
                case 8:
                    message.fishingGameInfo = $root.FishingGame.FishingGameInfo.decode(reader, reader.uint32());
                    break;
                case 9:
                    message.homeInfo = $root.Home.HomeInfo.decode(reader, reader.uint32());
                    break;
                case 7:
                    message.customData = reader.string();
                    break;
                case 10:
                    message.visitorRewardsExist = reader.bool();
                    break;
                case 11:
                    reader.skip().pos++;
                    if (message.customKV === $util.emptyObject)
                        message.customKV = {};
                    key = reader.string();
                    reader.pos++;
                    message.customKV[key] = reader.string();
                    break;
                case 12:
                    reader.skip().pos++;
                    if (message.extraInfo === $util.emptyObject)
                        message.extraInfo = {};
                    key = reader.string();
                    reader.pos++;
                    message.extraInfo[key] = reader.string();
                    break;
                case 13:
                    message.balloon = $root.Balloon.BalloonInfo.decode(reader, reader.uint32());
                    break;
                case 14:
                    message.newMailCount = reader.int32();
                    break;
                case 15:
                    message.adRewardsInfo = $root.BaseInfo.AdRewardsInfo.decode(reader, reader.uint32());
                    break;
                case 16:
                    message.luckyBagInfo = $root.LuckyBag.LuckyBagInfo.decode(reader, reader.uint32());
                    break;
                case 17:
                    message.timeOffSet = reader.int64();
                    break;
                case 18:
                    message.nauticalProjectGroup = $root.BaseInfo.NauticalProjectGroup.decode(reader, reader.uint32());
                    break;
                case 19:
                    message.wharfLetterBox = $root.BaseInfo.WharfLetterBox.decode(reader, reader.uint32());
                    break;
                case 20:
                    message.aidedGroupInfo = $root.BaseInfo.AidedGroupInfo.decode(reader, reader.uint32());
                    break;
                case 21:
                    if (!(message.finishedMilestone && message.finishedMilestone.length))
                        message.finishedMilestone = [];
                    message.finishedMilestone.push(reader.string());
                    break;
                case 22:
                    message.luckyDraw = $root.BaseInfo.LuckyDraw.decode(reader, reader.uint32());
                    break;
                case 901:
                    message.isNew = reader.bool();
                    break;
                case 25:
                    if (!(message.ticketBuildingInfos && message.ticketBuildingInfos.length))
                        message.ticketBuildingInfos = [];
                    message.ticketBuildingInfos.push($root.LuckyDraw.TicketBuildingInfo.decode(reader, reader.uint32()));
                    break;
                case 26:
                    message.payInfo = $root.BaseInfo.PayInfo.decode(reader, reader.uint32());
                    break;
                case 27:
                    message.lotteryBag = $root.LuckyDraw.LotteryBag.decode(reader, reader.uint32());
                    break;
                case 28:
                    message.takeoutInfo = $root.BaseInfo.TakeoutInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a LoginRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.LoginRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.LoginRes} LoginRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LoginRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a LoginRes message.
         * @function verify
         * @memberof Player.LoginRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        LoginRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.FullBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.playerBuilding != null && message.hasOwnProperty("playerBuilding")) {
                var error = $root.BaseInfo.PlayerBuilding.verify(message.playerBuilding);
                if (error)
                    return "playerBuilding." + error;
            }
            if (message.playerPets != null && message.hasOwnProperty("playerPets")) {
                var error = $root.BaseInfo.PlayerPets.verify(message.playerPets);
                if (error)
                    return "playerPets." + error;
            }
            if (message.tasks != null && message.hasOwnProperty("tasks")) {
                var error = $root.BaseInfo.Tasks.verify(message.tasks);
                if (error)
                    return "tasks." + error;
            }
            if (message.menu != null && message.hasOwnProperty("menu")) {
                var error = $root.BaseInfo.FoodMenu.verify(message.menu);
                if (error)
                    return "menu." + error;
            }
            if (message.letterbox != null && message.hasOwnProperty("letterbox")) {
                var error = $root.BaseInfo.LetterBox.verify(message.letterbox);
                if (error)
                    return "letterbox." + error;
            }
            if (message.fishingGameInfo != null && message.hasOwnProperty("fishingGameInfo")) {
                var error = $root.FishingGame.FishingGameInfo.verify(message.fishingGameInfo);
                if (error)
                    return "fishingGameInfo." + error;
            }
            if (message.homeInfo != null && message.hasOwnProperty("homeInfo")) {
                var error = $root.Home.HomeInfo.verify(message.homeInfo);
                if (error)
                    return "homeInfo." + error;
            }
            if (message.customData != null && message.hasOwnProperty("customData"))
                if (!$util.isString(message.customData))
                    return "customData: string expected";
            if (message.visitorRewardsExist != null && message.hasOwnProperty("visitorRewardsExist"))
                if (typeof message.visitorRewardsExist !== "boolean")
                    return "visitorRewardsExist: boolean expected";
            if (message.customKV != null && message.hasOwnProperty("customKV")) {
                if (!$util.isObject(message.customKV))
                    return "customKV: object expected";
                var key = Object.keys(message.customKV);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.customKV[key[i]]))
                        return "customKV: string{k:string} expected";
            }
            if (message.extraInfo != null && message.hasOwnProperty("extraInfo")) {
                if (!$util.isObject(message.extraInfo))
                    return "extraInfo: object expected";
                var key = Object.keys(message.extraInfo);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.extraInfo[key[i]]))
                        return "extraInfo: string{k:string} expected";
            }
            if (message.balloon != null && message.hasOwnProperty("balloon")) {
                var error = $root.Balloon.BalloonInfo.verify(message.balloon);
                if (error)
                    return "balloon." + error;
            }
            if (message.newMailCount != null && message.hasOwnProperty("newMailCount"))
                if (!$util.isInteger(message.newMailCount))
                    return "newMailCount: integer expected";
            if (message.adRewardsInfo != null && message.hasOwnProperty("adRewardsInfo")) {
                var error = $root.BaseInfo.AdRewardsInfo.verify(message.adRewardsInfo);
                if (error)
                    return "adRewardsInfo." + error;
            }
            if (message.luckyBagInfo != null && message.hasOwnProperty("luckyBagInfo")) {
                var error = $root.LuckyBag.LuckyBagInfo.verify(message.luckyBagInfo);
                if (error)
                    return "luckyBagInfo." + error;
            }
            if (message.timeOffSet != null && message.hasOwnProperty("timeOffSet"))
                if (!$util.isInteger(message.timeOffSet) && !(message.timeOffSet && $util.isInteger(message.timeOffSet.low) && $util.isInteger(message.timeOffSet.high)))
                    return "timeOffSet: integer|Long expected";
            if (message.nauticalProjectGroup != null && message.hasOwnProperty("nauticalProjectGroup")) {
                var error = $root.BaseInfo.NauticalProjectGroup.verify(message.nauticalProjectGroup);
                if (error)
                    return "nauticalProjectGroup." + error;
            }
            if (message.wharfLetterBox != null && message.hasOwnProperty("wharfLetterBox")) {
                var error = $root.BaseInfo.WharfLetterBox.verify(message.wharfLetterBox);
                if (error)
                    return "wharfLetterBox." + error;
            }
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo")) {
                var error = $root.BaseInfo.AidedGroupInfo.verify(message.aidedGroupInfo);
                if (error)
                    return "aidedGroupInfo." + error;
            }
            if (message.finishedMilestone != null && message.hasOwnProperty("finishedMilestone")) {
                if (!Array.isArray(message.finishedMilestone))
                    return "finishedMilestone: array expected";
                for (var i = 0; i < message.finishedMilestone.length; ++i)
                    if (!$util.isString(message.finishedMilestone[i]))
                        return "finishedMilestone: string[] expected";
            }
            if (message.luckyDraw != null && message.hasOwnProperty("luckyDraw")) {
                var error = $root.BaseInfo.LuckyDraw.verify(message.luckyDraw);
                if (error)
                    return "luckyDraw." + error;
            }
            if (message.isNew != null && message.hasOwnProperty("isNew"))
                if (typeof message.isNew !== "boolean")
                    return "isNew: boolean expected";
            if (message.ticketBuildingInfos != null && message.hasOwnProperty("ticketBuildingInfos")) {
                if (!Array.isArray(message.ticketBuildingInfos))
                    return "ticketBuildingInfos: array expected";
                for (var i = 0; i < message.ticketBuildingInfos.length; ++i) {
                    var error = $root.LuckyDraw.TicketBuildingInfo.verify(message.ticketBuildingInfos[i]);
                    if (error)
                        return "ticketBuildingInfos." + error;
                }
            }
            if (message.payInfo != null && message.hasOwnProperty("payInfo")) {
                var error = $root.BaseInfo.PayInfo.verify(message.payInfo);
                if (error)
                    return "payInfo." + error;
            }
            if (message.lotteryBag != null && message.hasOwnProperty("lotteryBag")) {
                var error = $root.LuckyDraw.LotteryBag.verify(message.lotteryBag);
                if (error)
                    return "lotteryBag." + error;
            }
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo")) {
                var error = $root.BaseInfo.TakeoutInfo.verify(message.takeoutInfo);
                if (error)
                    return "takeoutInfo." + error;
            }
            return null;
        };

        return LoginRes;
    })();

    Player.LogoutReq = (function() {

        /**
         * Properties of a LogoutReq.
         * @memberof Player
         * @interface ILogoutReq
         */

        /**
         * Constructs a new LogoutReq.
         * @memberof Player
         * @classdesc Represents a LogoutReq.
         * @implements ILogoutReq
         * @constructor
         * @param {Player.ILogoutReq=} [properties] Properties to set
         */
        function LogoutReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new LogoutReq instance using the specified properties.
         * @function create
         * @memberof Player.LogoutReq
         * @static
         * @param {Player.ILogoutReq=} [properties] Properties to set
         * @returns {Player.LogoutReq} LogoutReq instance
         */
        LogoutReq.create = function create(properties) {
            return new LogoutReq(properties);
        };

        /**
         * Encodes the specified LogoutReq message. Does not implicitly {@link Player.LogoutReq.verify|verify} messages.
         * @function encode
         * @memberof Player.LogoutReq
         * @static
         * @param {Player.ILogoutReq} message LogoutReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LogoutReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified LogoutReq message, length delimited. Does not implicitly {@link Player.LogoutReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.LogoutReq
         * @static
         * @param {Player.ILogoutReq} message LogoutReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LogoutReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a LogoutReq message from the specified reader or buffer.
         * @function decode
         * @memberof Player.LogoutReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.LogoutReq} LogoutReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LogoutReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.LogoutReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a LogoutReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.LogoutReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.LogoutReq} LogoutReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LogoutReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a LogoutReq message.
         * @function verify
         * @memberof Player.LogoutReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        LogoutReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return LogoutReq;
    })();

    Player.LogoutRes = (function() {

        /**
         * Properties of a LogoutRes.
         * @memberof Player
         * @interface ILogoutRes
         */

        /**
         * Constructs a new LogoutRes.
         * @memberof Player
         * @classdesc Represents a LogoutRes.
         * @implements ILogoutRes
         * @constructor
         * @param {Player.ILogoutRes=} [properties] Properties to set
         */
        function LogoutRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new LogoutRes instance using the specified properties.
         * @function create
         * @memberof Player.LogoutRes
         * @static
         * @param {Player.ILogoutRes=} [properties] Properties to set
         * @returns {Player.LogoutRes} LogoutRes instance
         */
        LogoutRes.create = function create(properties) {
            return new LogoutRes(properties);
        };

        /**
         * Encodes the specified LogoutRes message. Does not implicitly {@link Player.LogoutRes.verify|verify} messages.
         * @function encode
         * @memberof Player.LogoutRes
         * @static
         * @param {Player.ILogoutRes} message LogoutRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LogoutRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified LogoutRes message, length delimited. Does not implicitly {@link Player.LogoutRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.LogoutRes
         * @static
         * @param {Player.ILogoutRes} message LogoutRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LogoutRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a LogoutRes message from the specified reader or buffer.
         * @function decode
         * @memberof Player.LogoutRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.LogoutRes} LogoutRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LogoutRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.LogoutRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a LogoutRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.LogoutRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.LogoutRes} LogoutRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LogoutRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a LogoutRes message.
         * @function verify
         * @memberof Player.LogoutRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        LogoutRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return LogoutRes;
    })();

    Player.OnlineCrossDayReq = (function() {

        /**
         * Properties of an OnlineCrossDayReq.
         * @memberof Player
         * @interface IOnlineCrossDayReq
         */

        /**
         * Constructs a new OnlineCrossDayReq.
         * @memberof Player
         * @classdesc Represents an OnlineCrossDayReq.
         * @implements IOnlineCrossDayReq
         * @constructor
         * @param {Player.IOnlineCrossDayReq=} [properties] Properties to set
         */
        function OnlineCrossDayReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new OnlineCrossDayReq instance using the specified properties.
         * @function create
         * @memberof Player.OnlineCrossDayReq
         * @static
         * @param {Player.IOnlineCrossDayReq=} [properties] Properties to set
         * @returns {Player.OnlineCrossDayReq} OnlineCrossDayReq instance
         */
        OnlineCrossDayReq.create = function create(properties) {
            return new OnlineCrossDayReq(properties);
        };

        /**
         * Encodes the specified OnlineCrossDayReq message. Does not implicitly {@link Player.OnlineCrossDayReq.verify|verify} messages.
         * @function encode
         * @memberof Player.OnlineCrossDayReq
         * @static
         * @param {Player.IOnlineCrossDayReq} message OnlineCrossDayReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        OnlineCrossDayReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified OnlineCrossDayReq message, length delimited. Does not implicitly {@link Player.OnlineCrossDayReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.OnlineCrossDayReq
         * @static
         * @param {Player.IOnlineCrossDayReq} message OnlineCrossDayReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        OnlineCrossDayReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an OnlineCrossDayReq message from the specified reader or buffer.
         * @function decode
         * @memberof Player.OnlineCrossDayReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.OnlineCrossDayReq} OnlineCrossDayReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        OnlineCrossDayReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.OnlineCrossDayReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an OnlineCrossDayReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.OnlineCrossDayReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.OnlineCrossDayReq} OnlineCrossDayReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        OnlineCrossDayReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an OnlineCrossDayReq message.
         * @function verify
         * @memberof Player.OnlineCrossDayReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        OnlineCrossDayReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return OnlineCrossDayReq;
    })();

    Player.OnlineCrossDayRes = (function() {

        /**
         * Properties of an OnlineCrossDayRes.
         * @memberof Player
         * @interface IOnlineCrossDayRes
         * @property {BaseInfo.ICurrencyBag|null} [bag] OnlineCrossDayRes bag
         * @property {BaseInfo.ITasks|null} [tasks] OnlineCrossDayRes tasks
         * @property {LuckyBag.ILuckyBagInfo|null} [luckyBagInfo] OnlineCrossDayRes luckyBagInfo
         * @property {BaseInfo.IAidedGroupInfo|null} [aidedGroupInfo] OnlineCrossDayRes aidedGroupInfo
         * @property {BaseInfo.ILuckyDraw|null} [luckyDraw] OnlineCrossDayRes luckyDraw
         */

        /**
         * Constructs a new OnlineCrossDayRes.
         * @memberof Player
         * @classdesc Represents an OnlineCrossDayRes.
         * @implements IOnlineCrossDayRes
         * @constructor
         * @param {Player.IOnlineCrossDayRes=} [properties] Properties to set
         */
        function OnlineCrossDayRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * OnlineCrossDayRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Player.OnlineCrossDayRes
         * @instance
         */
        OnlineCrossDayRes.prototype.bag = null;

        /**
         * OnlineCrossDayRes tasks.
         * @member {BaseInfo.ITasks|null|undefined} tasks
         * @memberof Player.OnlineCrossDayRes
         * @instance
         */
        OnlineCrossDayRes.prototype.tasks = null;

        /**
         * OnlineCrossDayRes luckyBagInfo.
         * @member {LuckyBag.ILuckyBagInfo|null|undefined} luckyBagInfo
         * @memberof Player.OnlineCrossDayRes
         * @instance
         */
        OnlineCrossDayRes.prototype.luckyBagInfo = null;

        /**
         * OnlineCrossDayRes aidedGroupInfo.
         * @member {BaseInfo.IAidedGroupInfo|null|undefined} aidedGroupInfo
         * @memberof Player.OnlineCrossDayRes
         * @instance
         */
        OnlineCrossDayRes.prototype.aidedGroupInfo = null;

        /**
         * OnlineCrossDayRes luckyDraw.
         * @member {BaseInfo.ILuckyDraw|null|undefined} luckyDraw
         * @memberof Player.OnlineCrossDayRes
         * @instance
         */
        OnlineCrossDayRes.prototype.luckyDraw = null;

        /**
         * Creates a new OnlineCrossDayRes instance using the specified properties.
         * @function create
         * @memberof Player.OnlineCrossDayRes
         * @static
         * @param {Player.IOnlineCrossDayRes=} [properties] Properties to set
         * @returns {Player.OnlineCrossDayRes} OnlineCrossDayRes instance
         */
        OnlineCrossDayRes.create = function create(properties) {
            return new OnlineCrossDayRes(properties);
        };

        /**
         * Encodes the specified OnlineCrossDayRes message. Does not implicitly {@link Player.OnlineCrossDayRes.verify|verify} messages.
         * @function encode
         * @memberof Player.OnlineCrossDayRes
         * @static
         * @param {Player.IOnlineCrossDayRes} message OnlineCrossDayRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        OnlineCrossDayRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.tasks != null && message.hasOwnProperty("tasks"))
                $root.BaseInfo.Tasks.encode(message.tasks, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            if (message.luckyBagInfo != null && message.hasOwnProperty("luckyBagInfo"))
                $root.LuckyBag.LuckyBagInfo.encode(message.luckyBagInfo, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo"))
                $root.BaseInfo.AidedGroupInfo.encode(message.aidedGroupInfo, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
            if (message.luckyDraw != null && message.hasOwnProperty("luckyDraw"))
                $root.BaseInfo.LuckyDraw.encode(message.luckyDraw, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified OnlineCrossDayRes message, length delimited. Does not implicitly {@link Player.OnlineCrossDayRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.OnlineCrossDayRes
         * @static
         * @param {Player.IOnlineCrossDayRes} message OnlineCrossDayRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        OnlineCrossDayRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an OnlineCrossDayRes message from the specified reader or buffer.
         * @function decode
         * @memberof Player.OnlineCrossDayRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.OnlineCrossDayRes} OnlineCrossDayRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        OnlineCrossDayRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.OnlineCrossDayRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.tasks = $root.BaseInfo.Tasks.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.luckyBagInfo = $root.LuckyBag.LuckyBagInfo.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.aidedGroupInfo = $root.BaseInfo.AidedGroupInfo.decode(reader, reader.uint32());
                    break;
                case 7:
                    message.luckyDraw = $root.BaseInfo.LuckyDraw.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an OnlineCrossDayRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.OnlineCrossDayRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.OnlineCrossDayRes} OnlineCrossDayRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        OnlineCrossDayRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an OnlineCrossDayRes message.
         * @function verify
         * @memberof Player.OnlineCrossDayRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        OnlineCrossDayRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.tasks != null && message.hasOwnProperty("tasks")) {
                var error = $root.BaseInfo.Tasks.verify(message.tasks);
                if (error)
                    return "tasks." + error;
            }
            if (message.luckyBagInfo != null && message.hasOwnProperty("luckyBagInfo")) {
                var error = $root.LuckyBag.LuckyBagInfo.verify(message.luckyBagInfo);
                if (error)
                    return "luckyBagInfo." + error;
            }
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo")) {
                var error = $root.BaseInfo.AidedGroupInfo.verify(message.aidedGroupInfo);
                if (error)
                    return "aidedGroupInfo." + error;
            }
            if (message.luckyDraw != null && message.hasOwnProperty("luckyDraw")) {
                var error = $root.BaseInfo.LuckyDraw.verify(message.luckyDraw);
                if (error)
                    return "luckyDraw." + error;
            }
            return null;
        };

        return OnlineCrossDayRes;
    })();

    Player.FullBagReq = (function() {

        /**
         * Properties of a FullBagReq.
         * @memberof Player
         * @interface IFullBagReq
         */

        /**
         * Constructs a new FullBagReq.
         * @memberof Player
         * @classdesc Represents a FullBagReq.
         * @implements IFullBagReq
         * @constructor
         * @param {Player.IFullBagReq=} [properties] Properties to set
         */
        function FullBagReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new FullBagReq instance using the specified properties.
         * @function create
         * @memberof Player.FullBagReq
         * @static
         * @param {Player.IFullBagReq=} [properties] Properties to set
         * @returns {Player.FullBagReq} FullBagReq instance
         */
        FullBagReq.create = function create(properties) {
            return new FullBagReq(properties);
        };

        /**
         * Encodes the specified FullBagReq message. Does not implicitly {@link Player.FullBagReq.verify|verify} messages.
         * @function encode
         * @memberof Player.FullBagReq
         * @static
         * @param {Player.IFullBagReq} message FullBagReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FullBagReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified FullBagReq message, length delimited. Does not implicitly {@link Player.FullBagReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.FullBagReq
         * @static
         * @param {Player.IFullBagReq} message FullBagReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FullBagReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FullBagReq message from the specified reader or buffer.
         * @function decode
         * @memberof Player.FullBagReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.FullBagReq} FullBagReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FullBagReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.FullBagReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FullBagReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.FullBagReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.FullBagReq} FullBagReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FullBagReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FullBagReq message.
         * @function verify
         * @memberof Player.FullBagReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FullBagReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return FullBagReq;
    })();

    Player.FullBagRes = (function() {

        /**
         * Properties of a FullBagRes.
         * @memberof Player
         * @interface IFullBagRes
         * @property {BaseInfo.IFullBag|null} [bag] FullBagRes bag
         */

        /**
         * Constructs a new FullBagRes.
         * @memberof Player
         * @classdesc Represents a FullBagRes.
         * @implements IFullBagRes
         * @constructor
         * @param {Player.IFullBagRes=} [properties] Properties to set
         */
        function FullBagRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FullBagRes bag.
         * @member {BaseInfo.IFullBag|null|undefined} bag
         * @memberof Player.FullBagRes
         * @instance
         */
        FullBagRes.prototype.bag = null;

        /**
         * Creates a new FullBagRes instance using the specified properties.
         * @function create
         * @memberof Player.FullBagRes
         * @static
         * @param {Player.IFullBagRes=} [properties] Properties to set
         * @returns {Player.FullBagRes} FullBagRes instance
         */
        FullBagRes.create = function create(properties) {
            return new FullBagRes(properties);
        };

        /**
         * Encodes the specified FullBagRes message. Does not implicitly {@link Player.FullBagRes.verify|verify} messages.
         * @function encode
         * @memberof Player.FullBagRes
         * @static
         * @param {Player.IFullBagRes} message FullBagRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FullBagRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.FullBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FullBagRes message, length delimited. Does not implicitly {@link Player.FullBagRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.FullBagRes
         * @static
         * @param {Player.IFullBagRes} message FullBagRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FullBagRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FullBagRes message from the specified reader or buffer.
         * @function decode
         * @memberof Player.FullBagRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.FullBagRes} FullBagRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FullBagRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.FullBagRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.FullBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FullBagRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.FullBagRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.FullBagRes} FullBagRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FullBagRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FullBagRes message.
         * @function verify
         * @memberof Player.FullBagRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FullBagRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.FullBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return FullBagRes;
    })();

    Player.UserInfo = (function() {

        /**
         * Properties of a UserInfo.
         * @memberof Player
         * @interface IUserInfo
         * @property {string|null} [nickName] UserInfo nickName
         * @property {string|null} [avatarUrl] UserInfo avatarUrl
         */

        /**
         * Constructs a new UserInfo.
         * @memberof Player
         * @classdesc Represents a UserInfo.
         * @implements IUserInfo
         * @constructor
         * @param {Player.IUserInfo=} [properties] Properties to set
         */
        function UserInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * UserInfo nickName.
         * @member {string} nickName
         * @memberof Player.UserInfo
         * @instance
         */
        UserInfo.prototype.nickName = "";

        /**
         * UserInfo avatarUrl.
         * @member {string} avatarUrl
         * @memberof Player.UserInfo
         * @instance
         */
        UserInfo.prototype.avatarUrl = "";

        /**
         * Creates a new UserInfo instance using the specified properties.
         * @function create
         * @memberof Player.UserInfo
         * @static
         * @param {Player.IUserInfo=} [properties] Properties to set
         * @returns {Player.UserInfo} UserInfo instance
         */
        UserInfo.create = function create(properties) {
            return new UserInfo(properties);
        };

        /**
         * Encodes the specified UserInfo message. Does not implicitly {@link Player.UserInfo.verify|verify} messages.
         * @function encode
         * @memberof Player.UserInfo
         * @static
         * @param {Player.IUserInfo} message UserInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        UserInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.nickName != null && message.hasOwnProperty("nickName"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.nickName);
            if (message.avatarUrl != null && message.hasOwnProperty("avatarUrl"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.avatarUrl);
            return writer;
        };

        /**
         * Encodes the specified UserInfo message, length delimited. Does not implicitly {@link Player.UserInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.UserInfo
         * @static
         * @param {Player.IUserInfo} message UserInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        UserInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a UserInfo message from the specified reader or buffer.
         * @function decode
         * @memberof Player.UserInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.UserInfo} UserInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        UserInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.UserInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.nickName = reader.string();
                    break;
                case 2:
                    message.avatarUrl = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a UserInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.UserInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.UserInfo} UserInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        UserInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a UserInfo message.
         * @function verify
         * @memberof Player.UserInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        UserInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.nickName != null && message.hasOwnProperty("nickName"))
                if (!$util.isString(message.nickName))
                    return "nickName: string expected";
            if (message.avatarUrl != null && message.hasOwnProperty("avatarUrl"))
                if (!$util.isString(message.avatarUrl))
                    return "avatarUrl: string expected";
            return null;
        };

        return UserInfo;
    })();

    Player.PutCustomDataReq = (function() {

        /**
         * Properties of a PutCustomDataReq.
         * @memberof Player
         * @interface IPutCustomDataReq
         * @property {Object.<string,string>|null} [customKV] PutCustomDataReq customKV
         */

        /**
         * Constructs a new PutCustomDataReq.
         * @memberof Player
         * @classdesc Represents a PutCustomDataReq.
         * @implements IPutCustomDataReq
         * @constructor
         * @param {Player.IPutCustomDataReq=} [properties] Properties to set
         */
        function PutCustomDataReq(properties) {
            this.customKV = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PutCustomDataReq customKV.
         * @member {Object.<string,string>} customKV
         * @memberof Player.PutCustomDataReq
         * @instance
         */
        PutCustomDataReq.prototype.customKV = $util.emptyObject;

        /**
         * Creates a new PutCustomDataReq instance using the specified properties.
         * @function create
         * @memberof Player.PutCustomDataReq
         * @static
         * @param {Player.IPutCustomDataReq=} [properties] Properties to set
         * @returns {Player.PutCustomDataReq} PutCustomDataReq instance
         */
        PutCustomDataReq.create = function create(properties) {
            return new PutCustomDataReq(properties);
        };

        /**
         * Encodes the specified PutCustomDataReq message. Does not implicitly {@link Player.PutCustomDataReq.verify|verify} messages.
         * @function encode
         * @memberof Player.PutCustomDataReq
         * @static
         * @param {Player.IPutCustomDataReq} message PutCustomDataReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutCustomDataReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.customKV != null && message.hasOwnProperty("customKV"))
                for (var keys = Object.keys(message.customKV), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.customKV[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified PutCustomDataReq message, length delimited. Does not implicitly {@link Player.PutCustomDataReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.PutCustomDataReq
         * @static
         * @param {Player.IPutCustomDataReq} message PutCustomDataReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutCustomDataReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PutCustomDataReq message from the specified reader or buffer.
         * @function decode
         * @memberof Player.PutCustomDataReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.PutCustomDataReq} PutCustomDataReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutCustomDataReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.PutCustomDataReq(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.customKV === $util.emptyObject)
                        message.customKV = {};
                    key = reader.string();
                    reader.pos++;
                    message.customKV[key] = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PutCustomDataReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.PutCustomDataReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.PutCustomDataReq} PutCustomDataReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutCustomDataReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PutCustomDataReq message.
         * @function verify
         * @memberof Player.PutCustomDataReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PutCustomDataReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.customKV != null && message.hasOwnProperty("customKV")) {
                if (!$util.isObject(message.customKV))
                    return "customKV: object expected";
                var key = Object.keys(message.customKV);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.customKV[key[i]]))
                        return "customKV: string{k:string} expected";
            }
            return null;
        };

        return PutCustomDataReq;
    })();

    Player.PutCustomDataRes = (function() {

        /**
         * Properties of a PutCustomDataRes.
         * @memberof Player
         * @interface IPutCustomDataRes
         * @property {Object.<string,string>|null} [customKV] PutCustomDataRes customKV
         */

        /**
         * Constructs a new PutCustomDataRes.
         * @memberof Player
         * @classdesc Represents a PutCustomDataRes.
         * @implements IPutCustomDataRes
         * @constructor
         * @param {Player.IPutCustomDataRes=} [properties] Properties to set
         */
        function PutCustomDataRes(properties) {
            this.customKV = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PutCustomDataRes customKV.
         * @member {Object.<string,string>} customKV
         * @memberof Player.PutCustomDataRes
         * @instance
         */
        PutCustomDataRes.prototype.customKV = $util.emptyObject;

        /**
         * Creates a new PutCustomDataRes instance using the specified properties.
         * @function create
         * @memberof Player.PutCustomDataRes
         * @static
         * @param {Player.IPutCustomDataRes=} [properties] Properties to set
         * @returns {Player.PutCustomDataRes} PutCustomDataRes instance
         */
        PutCustomDataRes.create = function create(properties) {
            return new PutCustomDataRes(properties);
        };

        /**
         * Encodes the specified PutCustomDataRes message. Does not implicitly {@link Player.PutCustomDataRes.verify|verify} messages.
         * @function encode
         * @memberof Player.PutCustomDataRes
         * @static
         * @param {Player.IPutCustomDataRes} message PutCustomDataRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutCustomDataRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.customKV != null && message.hasOwnProperty("customKV"))
                for (var keys = Object.keys(message.customKV), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.customKV[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified PutCustomDataRes message, length delimited. Does not implicitly {@link Player.PutCustomDataRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.PutCustomDataRes
         * @static
         * @param {Player.IPutCustomDataRes} message PutCustomDataRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutCustomDataRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PutCustomDataRes message from the specified reader or buffer.
         * @function decode
         * @memberof Player.PutCustomDataRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.PutCustomDataRes} PutCustomDataRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutCustomDataRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.PutCustomDataRes(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.customKV === $util.emptyObject)
                        message.customKV = {};
                    key = reader.string();
                    reader.pos++;
                    message.customKV[key] = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PutCustomDataRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.PutCustomDataRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.PutCustomDataRes} PutCustomDataRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutCustomDataRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PutCustomDataRes message.
         * @function verify
         * @memberof Player.PutCustomDataRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PutCustomDataRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.customKV != null && message.hasOwnProperty("customKV")) {
                if (!$util.isObject(message.customKV))
                    return "customKV: object expected";
                var key = Object.keys(message.customKV);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.customKV[key[i]]))
                        return "customKV: string{k:string} expected";
            }
            return null;
        };

        return PutCustomDataRes;
    })();

    Player.DelCustomDataReq = (function() {

        /**
         * Properties of a DelCustomDataReq.
         * @memberof Player
         * @interface IDelCustomDataReq
         * @property {Array.<string>|null} [keys] DelCustomDataReq keys
         */

        /**
         * Constructs a new DelCustomDataReq.
         * @memberof Player
         * @classdesc Represents a DelCustomDataReq.
         * @implements IDelCustomDataReq
         * @constructor
         * @param {Player.IDelCustomDataReq=} [properties] Properties to set
         */
        function DelCustomDataReq(properties) {
            this.keys = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * DelCustomDataReq keys.
         * @member {Array.<string>} keys
         * @memberof Player.DelCustomDataReq
         * @instance
         */
        DelCustomDataReq.prototype.keys = $util.emptyArray;

        /**
         * Creates a new DelCustomDataReq instance using the specified properties.
         * @function create
         * @memberof Player.DelCustomDataReq
         * @static
         * @param {Player.IDelCustomDataReq=} [properties] Properties to set
         * @returns {Player.DelCustomDataReq} DelCustomDataReq instance
         */
        DelCustomDataReq.create = function create(properties) {
            return new DelCustomDataReq(properties);
        };

        /**
         * Encodes the specified DelCustomDataReq message. Does not implicitly {@link Player.DelCustomDataReq.verify|verify} messages.
         * @function encode
         * @memberof Player.DelCustomDataReq
         * @static
         * @param {Player.IDelCustomDataReq} message DelCustomDataReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DelCustomDataReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.keys != null && message.keys.length)
                for (var i = 0; i < message.keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.keys[i]);
            return writer;
        };

        /**
         * Encodes the specified DelCustomDataReq message, length delimited. Does not implicitly {@link Player.DelCustomDataReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.DelCustomDataReq
         * @static
         * @param {Player.IDelCustomDataReq} message DelCustomDataReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DelCustomDataReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a DelCustomDataReq message from the specified reader or buffer.
         * @function decode
         * @memberof Player.DelCustomDataReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.DelCustomDataReq} DelCustomDataReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DelCustomDataReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.DelCustomDataReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.keys && message.keys.length))
                        message.keys = [];
                    message.keys.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a DelCustomDataReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.DelCustomDataReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.DelCustomDataReq} DelCustomDataReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DelCustomDataReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a DelCustomDataReq message.
         * @function verify
         * @memberof Player.DelCustomDataReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        DelCustomDataReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.keys != null && message.hasOwnProperty("keys")) {
                if (!Array.isArray(message.keys))
                    return "keys: array expected";
                for (var i = 0; i < message.keys.length; ++i)
                    if (!$util.isString(message.keys[i]))
                        return "keys: string[] expected";
            }
            return null;
        };

        return DelCustomDataReq;
    })();

    Player.DelCustomDataRes = (function() {

        /**
         * Properties of a DelCustomDataRes.
         * @memberof Player
         * @interface IDelCustomDataRes
         * @property {Object.<string,string>|null} [customKV] DelCustomDataRes customKV
         */

        /**
         * Constructs a new DelCustomDataRes.
         * @memberof Player
         * @classdesc Represents a DelCustomDataRes.
         * @implements IDelCustomDataRes
         * @constructor
         * @param {Player.IDelCustomDataRes=} [properties] Properties to set
         */
        function DelCustomDataRes(properties) {
            this.customKV = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * DelCustomDataRes customKV.
         * @member {Object.<string,string>} customKV
         * @memberof Player.DelCustomDataRes
         * @instance
         */
        DelCustomDataRes.prototype.customKV = $util.emptyObject;

        /**
         * Creates a new DelCustomDataRes instance using the specified properties.
         * @function create
         * @memberof Player.DelCustomDataRes
         * @static
         * @param {Player.IDelCustomDataRes=} [properties] Properties to set
         * @returns {Player.DelCustomDataRes} DelCustomDataRes instance
         */
        DelCustomDataRes.create = function create(properties) {
            return new DelCustomDataRes(properties);
        };

        /**
         * Encodes the specified DelCustomDataRes message. Does not implicitly {@link Player.DelCustomDataRes.verify|verify} messages.
         * @function encode
         * @memberof Player.DelCustomDataRes
         * @static
         * @param {Player.IDelCustomDataRes} message DelCustomDataRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DelCustomDataRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.customKV != null && message.hasOwnProperty("customKV"))
                for (var keys = Object.keys(message.customKV), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.customKV[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified DelCustomDataRes message, length delimited. Does not implicitly {@link Player.DelCustomDataRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.DelCustomDataRes
         * @static
         * @param {Player.IDelCustomDataRes} message DelCustomDataRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DelCustomDataRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a DelCustomDataRes message from the specified reader or buffer.
         * @function decode
         * @memberof Player.DelCustomDataRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.DelCustomDataRes} DelCustomDataRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DelCustomDataRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.DelCustomDataRes(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.customKV === $util.emptyObject)
                        message.customKV = {};
                    key = reader.string();
                    reader.pos++;
                    message.customKV[key] = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a DelCustomDataRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.DelCustomDataRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.DelCustomDataRes} DelCustomDataRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DelCustomDataRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a DelCustomDataRes message.
         * @function verify
         * @memberof Player.DelCustomDataRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        DelCustomDataRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.customKV != null && message.hasOwnProperty("customKV")) {
                if (!$util.isObject(message.customKV))
                    return "customKV: object expected";
                var key = Object.keys(message.customKV);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.customKV[key[i]]))
                        return "customKV: string{k:string} expected";
            }
            return null;
        };

        return DelCustomDataRes;
    })();

    Player.GetCustomDataReq = (function() {

        /**
         * Properties of a GetCustomDataReq.
         * @memberof Player
         * @interface IGetCustomDataReq
         */

        /**
         * Constructs a new GetCustomDataReq.
         * @memberof Player
         * @classdesc Represents a GetCustomDataReq.
         * @implements IGetCustomDataReq
         * @constructor
         * @param {Player.IGetCustomDataReq=} [properties] Properties to set
         */
        function GetCustomDataReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetCustomDataReq instance using the specified properties.
         * @function create
         * @memberof Player.GetCustomDataReq
         * @static
         * @param {Player.IGetCustomDataReq=} [properties] Properties to set
         * @returns {Player.GetCustomDataReq} GetCustomDataReq instance
         */
        GetCustomDataReq.create = function create(properties) {
            return new GetCustomDataReq(properties);
        };

        /**
         * Encodes the specified GetCustomDataReq message. Does not implicitly {@link Player.GetCustomDataReq.verify|verify} messages.
         * @function encode
         * @memberof Player.GetCustomDataReq
         * @static
         * @param {Player.IGetCustomDataReq} message GetCustomDataReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetCustomDataReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetCustomDataReq message, length delimited. Does not implicitly {@link Player.GetCustomDataReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.GetCustomDataReq
         * @static
         * @param {Player.IGetCustomDataReq} message GetCustomDataReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetCustomDataReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetCustomDataReq message from the specified reader or buffer.
         * @function decode
         * @memberof Player.GetCustomDataReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.GetCustomDataReq} GetCustomDataReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetCustomDataReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.GetCustomDataReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetCustomDataReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.GetCustomDataReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.GetCustomDataReq} GetCustomDataReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetCustomDataReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetCustomDataReq message.
         * @function verify
         * @memberof Player.GetCustomDataReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetCustomDataReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetCustomDataReq;
    })();

    Player.GetCustomDataRes = (function() {

        /**
         * Properties of a GetCustomDataRes.
         * @memberof Player
         * @interface IGetCustomDataRes
         * @property {Object.<string,string>|null} [customKV] GetCustomDataRes customKV
         */

        /**
         * Constructs a new GetCustomDataRes.
         * @memberof Player
         * @classdesc Represents a GetCustomDataRes.
         * @implements IGetCustomDataRes
         * @constructor
         * @param {Player.IGetCustomDataRes=} [properties] Properties to set
         */
        function GetCustomDataRes(properties) {
            this.customKV = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetCustomDataRes customKV.
         * @member {Object.<string,string>} customKV
         * @memberof Player.GetCustomDataRes
         * @instance
         */
        GetCustomDataRes.prototype.customKV = $util.emptyObject;

        /**
         * Creates a new GetCustomDataRes instance using the specified properties.
         * @function create
         * @memberof Player.GetCustomDataRes
         * @static
         * @param {Player.IGetCustomDataRes=} [properties] Properties to set
         * @returns {Player.GetCustomDataRes} GetCustomDataRes instance
         */
        GetCustomDataRes.create = function create(properties) {
            return new GetCustomDataRes(properties);
        };

        /**
         * Encodes the specified GetCustomDataRes message. Does not implicitly {@link Player.GetCustomDataRes.verify|verify} messages.
         * @function encode
         * @memberof Player.GetCustomDataRes
         * @static
         * @param {Player.IGetCustomDataRes} message GetCustomDataRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetCustomDataRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.customKV != null && message.hasOwnProperty("customKV"))
                for (var keys = Object.keys(message.customKV), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.customKV[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetCustomDataRes message, length delimited. Does not implicitly {@link Player.GetCustomDataRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.GetCustomDataRes
         * @static
         * @param {Player.IGetCustomDataRes} message GetCustomDataRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetCustomDataRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetCustomDataRes message from the specified reader or buffer.
         * @function decode
         * @memberof Player.GetCustomDataRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.GetCustomDataRes} GetCustomDataRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetCustomDataRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.GetCustomDataRes(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.customKV === $util.emptyObject)
                        message.customKV = {};
                    key = reader.string();
                    reader.pos++;
                    message.customKV[key] = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetCustomDataRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.GetCustomDataRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.GetCustomDataRes} GetCustomDataRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetCustomDataRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetCustomDataRes message.
         * @function verify
         * @memberof Player.GetCustomDataRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetCustomDataRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.customKV != null && message.hasOwnProperty("customKV")) {
                if (!$util.isObject(message.customKV))
                    return "customKV: object expected";
                var key = Object.keys(message.customKV);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.customKV[key[i]]))
                        return "customKV: string{k:string} expected";
            }
            return null;
        };

        return GetCustomDataRes;
    })();

    Player.ViewAdReq = (function() {

        /**
         * Properties of a ViewAdReq.
         * @memberof Player
         * @interface IViewAdReq
         * @property {boolean|null} [success] ViewAdReq success
         * @property {string|null} [type] ViewAdReq type
         * @property {number|null} [status] ViewAdReq status
         */

        /**
         * Constructs a new ViewAdReq.
         * @memberof Player
         * @classdesc Represents a ViewAdReq.
         * @implements IViewAdReq
         * @constructor
         * @param {Player.IViewAdReq=} [properties] Properties to set
         */
        function ViewAdReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ViewAdReq success.
         * @member {boolean} success
         * @memberof Player.ViewAdReq
         * @instance
         */
        ViewAdReq.prototype.success = false;

        /**
         * ViewAdReq type.
         * @member {string} type
         * @memberof Player.ViewAdReq
         * @instance
         */
        ViewAdReq.prototype.type = "";

        /**
         * ViewAdReq status.
         * @member {number} status
         * @memberof Player.ViewAdReq
         * @instance
         */
        ViewAdReq.prototype.status = 0;

        /**
         * Creates a new ViewAdReq instance using the specified properties.
         * @function create
         * @memberof Player.ViewAdReq
         * @static
         * @param {Player.IViewAdReq=} [properties] Properties to set
         * @returns {Player.ViewAdReq} ViewAdReq instance
         */
        ViewAdReq.create = function create(properties) {
            return new ViewAdReq(properties);
        };

        /**
         * Encodes the specified ViewAdReq message. Does not implicitly {@link Player.ViewAdReq.verify|verify} messages.
         * @function encode
         * @memberof Player.ViewAdReq
         * @static
         * @param {Player.IViewAdReq} message ViewAdReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ViewAdReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.success != null && message.hasOwnProperty("success"))
                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.success);
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.type);
            if (message.status != null && message.hasOwnProperty("status"))
                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.status);
            return writer;
        };

        /**
         * Encodes the specified ViewAdReq message, length delimited. Does not implicitly {@link Player.ViewAdReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.ViewAdReq
         * @static
         * @param {Player.IViewAdReq} message ViewAdReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ViewAdReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ViewAdReq message from the specified reader or buffer.
         * @function decode
         * @memberof Player.ViewAdReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.ViewAdReq} ViewAdReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ViewAdReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.ViewAdReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.success = reader.bool();
                    break;
                case 3:
                    message.type = reader.string();
                    break;
                case 4:
                    message.status = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ViewAdReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.ViewAdReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.ViewAdReq} ViewAdReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ViewAdReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ViewAdReq message.
         * @function verify
         * @memberof Player.ViewAdReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ViewAdReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.success != null && message.hasOwnProperty("success"))
                if (typeof message.success !== "boolean")
                    return "success: boolean expected";
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isString(message.type))
                    return "type: string expected";
            if (message.status != null && message.hasOwnProperty("status"))
                if (!$util.isInteger(message.status))
                    return "status: integer expected";
            return null;
        };

        return ViewAdReq;
    })();

    Player.ViewAdRes = (function() {

        /**
         * Properties of a ViewAdRes.
         * @memberof Player
         * @interface IViewAdRes
         */

        /**
         * Constructs a new ViewAdRes.
         * @memberof Player
         * @classdesc Represents a ViewAdRes.
         * @implements IViewAdRes
         * @constructor
         * @param {Player.IViewAdRes=} [properties] Properties to set
         */
        function ViewAdRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new ViewAdRes instance using the specified properties.
         * @function create
         * @memberof Player.ViewAdRes
         * @static
         * @param {Player.IViewAdRes=} [properties] Properties to set
         * @returns {Player.ViewAdRes} ViewAdRes instance
         */
        ViewAdRes.create = function create(properties) {
            return new ViewAdRes(properties);
        };

        /**
         * Encodes the specified ViewAdRes message. Does not implicitly {@link Player.ViewAdRes.verify|verify} messages.
         * @function encode
         * @memberof Player.ViewAdRes
         * @static
         * @param {Player.IViewAdRes} message ViewAdRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ViewAdRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified ViewAdRes message, length delimited. Does not implicitly {@link Player.ViewAdRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.ViewAdRes
         * @static
         * @param {Player.IViewAdRes} message ViewAdRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ViewAdRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ViewAdRes message from the specified reader or buffer.
         * @function decode
         * @memberof Player.ViewAdRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.ViewAdRes} ViewAdRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ViewAdRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.ViewAdRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ViewAdRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.ViewAdRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.ViewAdRes} ViewAdRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ViewAdRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ViewAdRes message.
         * @function verify
         * @memberof Player.ViewAdRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ViewAdRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return ViewAdRes;
    })();

    Player.AuthorizeReq = (function() {

        /**
         * Properties of an AuthorizeReq.
         * @memberof Player
         * @interface IAuthorizeReq
         * @property {Player.IUserInfo|null} [userInfo] AuthorizeReq userInfo
         */

        /**
         * Constructs a new AuthorizeReq.
         * @memberof Player
         * @classdesc Represents an AuthorizeReq.
         * @implements IAuthorizeReq
         * @constructor
         * @param {Player.IAuthorizeReq=} [properties] Properties to set
         */
        function AuthorizeReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AuthorizeReq userInfo.
         * @member {Player.IUserInfo|null|undefined} userInfo
         * @memberof Player.AuthorizeReq
         * @instance
         */
        AuthorizeReq.prototype.userInfo = null;

        /**
         * Creates a new AuthorizeReq instance using the specified properties.
         * @function create
         * @memberof Player.AuthorizeReq
         * @static
         * @param {Player.IAuthorizeReq=} [properties] Properties to set
         * @returns {Player.AuthorizeReq} AuthorizeReq instance
         */
        AuthorizeReq.create = function create(properties) {
            return new AuthorizeReq(properties);
        };

        /**
         * Encodes the specified AuthorizeReq message. Does not implicitly {@link Player.AuthorizeReq.verify|verify} messages.
         * @function encode
         * @memberof Player.AuthorizeReq
         * @static
         * @param {Player.IAuthorizeReq} message AuthorizeReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AuthorizeReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.userInfo != null && message.hasOwnProperty("userInfo"))
                $root.Player.UserInfo.encode(message.userInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified AuthorizeReq message, length delimited. Does not implicitly {@link Player.AuthorizeReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.AuthorizeReq
         * @static
         * @param {Player.IAuthorizeReq} message AuthorizeReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AuthorizeReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AuthorizeReq message from the specified reader or buffer.
         * @function decode
         * @memberof Player.AuthorizeReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.AuthorizeReq} AuthorizeReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AuthorizeReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.AuthorizeReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.userInfo = $root.Player.UserInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AuthorizeReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.AuthorizeReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.AuthorizeReq} AuthorizeReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AuthorizeReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AuthorizeReq message.
         * @function verify
         * @memberof Player.AuthorizeReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AuthorizeReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.userInfo != null && message.hasOwnProperty("userInfo")) {
                var error = $root.Player.UserInfo.verify(message.userInfo);
                if (error)
                    return "userInfo." + error;
            }
            return null;
        };

        return AuthorizeReq;
    })();

    Player.AuthorizeRes = (function() {

        /**
         * Properties of an AuthorizeRes.
         * @memberof Player
         * @interface IAuthorizeRes
         */

        /**
         * Constructs a new AuthorizeRes.
         * @memberof Player
         * @classdesc Represents an AuthorizeRes.
         * @implements IAuthorizeRes
         * @constructor
         * @param {Player.IAuthorizeRes=} [properties] Properties to set
         */
        function AuthorizeRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new AuthorizeRes instance using the specified properties.
         * @function create
         * @memberof Player.AuthorizeRes
         * @static
         * @param {Player.IAuthorizeRes=} [properties] Properties to set
         * @returns {Player.AuthorizeRes} AuthorizeRes instance
         */
        AuthorizeRes.create = function create(properties) {
            return new AuthorizeRes(properties);
        };

        /**
         * Encodes the specified AuthorizeRes message. Does not implicitly {@link Player.AuthorizeRes.verify|verify} messages.
         * @function encode
         * @memberof Player.AuthorizeRes
         * @static
         * @param {Player.IAuthorizeRes} message AuthorizeRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AuthorizeRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified AuthorizeRes message, length delimited. Does not implicitly {@link Player.AuthorizeRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.AuthorizeRes
         * @static
         * @param {Player.IAuthorizeRes} message AuthorizeRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AuthorizeRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AuthorizeRes message from the specified reader or buffer.
         * @function decode
         * @memberof Player.AuthorizeRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.AuthorizeRes} AuthorizeRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AuthorizeRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.AuthorizeRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AuthorizeRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.AuthorizeRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.AuthorizeRes} AuthorizeRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AuthorizeRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AuthorizeRes message.
         * @function verify
         * @memberof Player.AuthorizeRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AuthorizeRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return AuthorizeRes;
    })();

    Player.ClientLoadingLogReq = (function() {

        /**
         * Properties of a ClientLoadingLogReq.
         * @memberof Player
         * @interface IClientLoadingLogReq
         * @property {string|null} [customData] ClientLoadingLogReq customData
         */

        /**
         * Constructs a new ClientLoadingLogReq.
         * @memberof Player
         * @classdesc Represents a ClientLoadingLogReq.
         * @implements IClientLoadingLogReq
         * @constructor
         * @param {Player.IClientLoadingLogReq=} [properties] Properties to set
         */
        function ClientLoadingLogReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ClientLoadingLogReq customData.
         * @member {string} customData
         * @memberof Player.ClientLoadingLogReq
         * @instance
         */
        ClientLoadingLogReq.prototype.customData = "";

        /**
         * Creates a new ClientLoadingLogReq instance using the specified properties.
         * @function create
         * @memberof Player.ClientLoadingLogReq
         * @static
         * @param {Player.IClientLoadingLogReq=} [properties] Properties to set
         * @returns {Player.ClientLoadingLogReq} ClientLoadingLogReq instance
         */
        ClientLoadingLogReq.create = function create(properties) {
            return new ClientLoadingLogReq(properties);
        };

        /**
         * Encodes the specified ClientLoadingLogReq message. Does not implicitly {@link Player.ClientLoadingLogReq.verify|verify} messages.
         * @function encode
         * @memberof Player.ClientLoadingLogReq
         * @static
         * @param {Player.IClientLoadingLogReq} message ClientLoadingLogReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ClientLoadingLogReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.customData != null && message.hasOwnProperty("customData"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customData);
            return writer;
        };

        /**
         * Encodes the specified ClientLoadingLogReq message, length delimited. Does not implicitly {@link Player.ClientLoadingLogReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.ClientLoadingLogReq
         * @static
         * @param {Player.IClientLoadingLogReq} message ClientLoadingLogReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ClientLoadingLogReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ClientLoadingLogReq message from the specified reader or buffer.
         * @function decode
         * @memberof Player.ClientLoadingLogReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.ClientLoadingLogReq} ClientLoadingLogReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ClientLoadingLogReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.ClientLoadingLogReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.customData = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ClientLoadingLogReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.ClientLoadingLogReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.ClientLoadingLogReq} ClientLoadingLogReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ClientLoadingLogReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ClientLoadingLogReq message.
         * @function verify
         * @memberof Player.ClientLoadingLogReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ClientLoadingLogReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.customData != null && message.hasOwnProperty("customData"))
                if (!$util.isString(message.customData))
                    return "customData: string expected";
            return null;
        };

        return ClientLoadingLogReq;
    })();

    Player.ClientLoadingLogRes = (function() {

        /**
         * Properties of a ClientLoadingLogRes.
         * @memberof Player
         * @interface IClientLoadingLogRes
         */

        /**
         * Constructs a new ClientLoadingLogRes.
         * @memberof Player
         * @classdesc Represents a ClientLoadingLogRes.
         * @implements IClientLoadingLogRes
         * @constructor
         * @param {Player.IClientLoadingLogRes=} [properties] Properties to set
         */
        function ClientLoadingLogRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new ClientLoadingLogRes instance using the specified properties.
         * @function create
         * @memberof Player.ClientLoadingLogRes
         * @static
         * @param {Player.IClientLoadingLogRes=} [properties] Properties to set
         * @returns {Player.ClientLoadingLogRes} ClientLoadingLogRes instance
         */
        ClientLoadingLogRes.create = function create(properties) {
            return new ClientLoadingLogRes(properties);
        };

        /**
         * Encodes the specified ClientLoadingLogRes message. Does not implicitly {@link Player.ClientLoadingLogRes.verify|verify} messages.
         * @function encode
         * @memberof Player.ClientLoadingLogRes
         * @static
         * @param {Player.IClientLoadingLogRes} message ClientLoadingLogRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ClientLoadingLogRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified ClientLoadingLogRes message, length delimited. Does not implicitly {@link Player.ClientLoadingLogRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.ClientLoadingLogRes
         * @static
         * @param {Player.IClientLoadingLogRes} message ClientLoadingLogRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ClientLoadingLogRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ClientLoadingLogRes message from the specified reader or buffer.
         * @function decode
         * @memberof Player.ClientLoadingLogRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.ClientLoadingLogRes} ClientLoadingLogRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ClientLoadingLogRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.ClientLoadingLogRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ClientLoadingLogRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.ClientLoadingLogRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.ClientLoadingLogRes} ClientLoadingLogRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ClientLoadingLogRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ClientLoadingLogRes message.
         * @function verify
         * @memberof Player.ClientLoadingLogRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ClientLoadingLogRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return ClientLoadingLogRes;
    })();

    Player.ShareReq = (function() {

        /**
         * Properties of a ShareReq.
         * @memberof Player
         * @interface IShareReq
         * @property {string|null} [type] ShareReq type
         * @property {number|null} [status] ShareReq status
         */

        /**
         * Constructs a new ShareReq.
         * @memberof Player
         * @classdesc Represents a ShareReq.
         * @implements IShareReq
         * @constructor
         * @param {Player.IShareReq=} [properties] Properties to set
         */
        function ShareReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ShareReq type.
         * @member {string} type
         * @memberof Player.ShareReq
         * @instance
         */
        ShareReq.prototype.type = "";

        /**
         * ShareReq status.
         * @member {number} status
         * @memberof Player.ShareReq
         * @instance
         */
        ShareReq.prototype.status = 0;

        /**
         * Creates a new ShareReq instance using the specified properties.
         * @function create
         * @memberof Player.ShareReq
         * @static
         * @param {Player.IShareReq=} [properties] Properties to set
         * @returns {Player.ShareReq} ShareReq instance
         */
        ShareReq.create = function create(properties) {
            return new ShareReq(properties);
        };

        /**
         * Encodes the specified ShareReq message. Does not implicitly {@link Player.ShareReq.verify|verify} messages.
         * @function encode
         * @memberof Player.ShareReq
         * @static
         * @param {Player.IShareReq} message ShareReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ShareReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.type);
            if (message.status != null && message.hasOwnProperty("status"))
                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.status);
            return writer;
        };

        /**
         * Encodes the specified ShareReq message, length delimited. Does not implicitly {@link Player.ShareReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.ShareReq
         * @static
         * @param {Player.IShareReq} message ShareReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ShareReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ShareReq message from the specified reader or buffer.
         * @function decode
         * @memberof Player.ShareReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.ShareReq} ShareReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ShareReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.ShareReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 3:
                    message.type = reader.string();
                    break;
                case 4:
                    message.status = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ShareReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.ShareReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.ShareReq} ShareReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ShareReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ShareReq message.
         * @function verify
         * @memberof Player.ShareReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ShareReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isString(message.type))
                    return "type: string expected";
            if (message.status != null && message.hasOwnProperty("status"))
                if (!$util.isInteger(message.status))
                    return "status: integer expected";
            return null;
        };

        return ShareReq;
    })();

    Player.ShareRes = (function() {

        /**
         * Properties of a ShareRes.
         * @memberof Player
         * @interface IShareRes
         */

        /**
         * Constructs a new ShareRes.
         * @memberof Player
         * @classdesc Represents a ShareRes.
         * @implements IShareRes
         * @constructor
         * @param {Player.IShareRes=} [properties] Properties to set
         */
        function ShareRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new ShareRes instance using the specified properties.
         * @function create
         * @memberof Player.ShareRes
         * @static
         * @param {Player.IShareRes=} [properties] Properties to set
         * @returns {Player.ShareRes} ShareRes instance
         */
        ShareRes.create = function create(properties) {
            return new ShareRes(properties);
        };

        /**
         * Encodes the specified ShareRes message. Does not implicitly {@link Player.ShareRes.verify|verify} messages.
         * @function encode
         * @memberof Player.ShareRes
         * @static
         * @param {Player.IShareRes} message ShareRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ShareRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified ShareRes message, length delimited. Does not implicitly {@link Player.ShareRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Player.ShareRes
         * @static
         * @param {Player.IShareRes} message ShareRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ShareRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ShareRes message from the specified reader or buffer.
         * @function decode
         * @memberof Player.ShareRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Player.ShareRes} ShareRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ShareRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Player.ShareRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ShareRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Player.ShareRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Player.ShareRes} ShareRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ShareRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ShareRes message.
         * @function verify
         * @memberof Player.ShareRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ShareRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return ShareRes;
    })();

    return Player;
})();

$root.PlayerPushMsg = (function() {

    /**
     * Namespace PlayerPushMsg.
     * @exports PlayerPushMsg
     * @namespace
     */
    var PlayerPushMsg = {};

    PlayerPushMsg.TestMsg = (function() {

        /**
         * Properties of a TestMsg.
         * @memberof PlayerPushMsg
         * @interface ITestMsg
         * @property {string|null} [text] TestMsg text
         */

        /**
         * Constructs a new TestMsg.
         * @memberof PlayerPushMsg
         * @classdesc Represents a TestMsg.
         * @implements ITestMsg
         * @constructor
         * @param {PlayerPushMsg.ITestMsg=} [properties] Properties to set
         */
        function TestMsg(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * TestMsg text.
         * @member {string} text
         * @memberof PlayerPushMsg.TestMsg
         * @instance
         */
        TestMsg.prototype.text = "";

        /**
         * Creates a new TestMsg instance using the specified properties.
         * @function create
         * @memberof PlayerPushMsg.TestMsg
         * @static
         * @param {PlayerPushMsg.ITestMsg=} [properties] Properties to set
         * @returns {PlayerPushMsg.TestMsg} TestMsg instance
         */
        TestMsg.create = function create(properties) {
            return new TestMsg(properties);
        };

        /**
         * Encodes the specified TestMsg message. Does not implicitly {@link PlayerPushMsg.TestMsg.verify|verify} messages.
         * @function encode
         * @memberof PlayerPushMsg.TestMsg
         * @static
         * @param {PlayerPushMsg.ITestMsg} message TestMsg message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TestMsg.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.text != null && message.hasOwnProperty("text"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.text);
            return writer;
        };

        /**
         * Encodes the specified TestMsg message, length delimited. Does not implicitly {@link PlayerPushMsg.TestMsg.verify|verify} messages.
         * @function encodeDelimited
         * @memberof PlayerPushMsg.TestMsg
         * @static
         * @param {PlayerPushMsg.ITestMsg} message TestMsg message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TestMsg.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a TestMsg message from the specified reader or buffer.
         * @function decode
         * @memberof PlayerPushMsg.TestMsg
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {PlayerPushMsg.TestMsg} TestMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TestMsg.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.PlayerPushMsg.TestMsg();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.text = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a TestMsg message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof PlayerPushMsg.TestMsg
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {PlayerPushMsg.TestMsg} TestMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TestMsg.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a TestMsg message.
         * @function verify
         * @memberof PlayerPushMsg.TestMsg
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        TestMsg.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.text != null && message.hasOwnProperty("text"))
                if (!$util.isString(message.text))
                    return "text: string expected";
            return null;
        };

        return TestMsg;
    })();

    PlayerPushMsg.ReddotMsg = (function() {

        /**
         * Properties of a ReddotMsg.
         * @memberof PlayerPushMsg
         * @interface IReddotMsg
         * @property {number|null} [type] ReddotMsg type
         * @property {string|null} [extraInfo] ReddotMsg extraInfo
         */

        /**
         * Constructs a new ReddotMsg.
         * @memberof PlayerPushMsg
         * @classdesc Represents a ReddotMsg.
         * @implements IReddotMsg
         * @constructor
         * @param {PlayerPushMsg.IReddotMsg=} [properties] Properties to set
         */
        function ReddotMsg(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReddotMsg type.
         * @member {number} type
         * @memberof PlayerPushMsg.ReddotMsg
         * @instance
         */
        ReddotMsg.prototype.type = 0;

        /**
         * ReddotMsg extraInfo.
         * @member {string} extraInfo
         * @memberof PlayerPushMsg.ReddotMsg
         * @instance
         */
        ReddotMsg.prototype.extraInfo = "";

        /**
         * Creates a new ReddotMsg instance using the specified properties.
         * @function create
         * @memberof PlayerPushMsg.ReddotMsg
         * @static
         * @param {PlayerPushMsg.IReddotMsg=} [properties] Properties to set
         * @returns {PlayerPushMsg.ReddotMsg} ReddotMsg instance
         */
        ReddotMsg.create = function create(properties) {
            return new ReddotMsg(properties);
        };

        /**
         * Encodes the specified ReddotMsg message. Does not implicitly {@link PlayerPushMsg.ReddotMsg.verify|verify} messages.
         * @function encode
         * @memberof PlayerPushMsg.ReddotMsg
         * @static
         * @param {PlayerPushMsg.IReddotMsg} message ReddotMsg message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReddotMsg.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
            if (message.extraInfo != null && message.hasOwnProperty("extraInfo"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.extraInfo);
            return writer;
        };

        /**
         * Encodes the specified ReddotMsg message, length delimited. Does not implicitly {@link PlayerPushMsg.ReddotMsg.verify|verify} messages.
         * @function encodeDelimited
         * @memberof PlayerPushMsg.ReddotMsg
         * @static
         * @param {PlayerPushMsg.IReddotMsg} message ReddotMsg message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReddotMsg.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReddotMsg message from the specified reader or buffer.
         * @function decode
         * @memberof PlayerPushMsg.ReddotMsg
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {PlayerPushMsg.ReddotMsg} ReddotMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReddotMsg.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.PlayerPushMsg.ReddotMsg();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.type = reader.int32();
                    break;
                case 2:
                    message.extraInfo = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReddotMsg message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof PlayerPushMsg.ReddotMsg
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {PlayerPushMsg.ReddotMsg} ReddotMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReddotMsg.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReddotMsg message.
         * @function verify
         * @memberof PlayerPushMsg.ReddotMsg
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReddotMsg.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isInteger(message.type))
                    return "type: integer expected";
            if (message.extraInfo != null && message.hasOwnProperty("extraInfo"))
                if (!$util.isString(message.extraInfo))
                    return "extraInfo: string expected";
            return null;
        };

        return ReddotMsg;
    })();

    PlayerPushMsg.OnlineCrossDayMsg = (function() {

        /**
         * Properties of an OnlineCrossDayMsg.
         * @memberof PlayerPushMsg
         * @interface IOnlineCrossDayMsg
         */

        /**
         * Constructs a new OnlineCrossDayMsg.
         * @memberof PlayerPushMsg
         * @classdesc Represents an OnlineCrossDayMsg.
         * @implements IOnlineCrossDayMsg
         * @constructor
         * @param {PlayerPushMsg.IOnlineCrossDayMsg=} [properties] Properties to set
         */
        function OnlineCrossDayMsg(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new OnlineCrossDayMsg instance using the specified properties.
         * @function create
         * @memberof PlayerPushMsg.OnlineCrossDayMsg
         * @static
         * @param {PlayerPushMsg.IOnlineCrossDayMsg=} [properties] Properties to set
         * @returns {PlayerPushMsg.OnlineCrossDayMsg} OnlineCrossDayMsg instance
         */
        OnlineCrossDayMsg.create = function create(properties) {
            return new OnlineCrossDayMsg(properties);
        };

        /**
         * Encodes the specified OnlineCrossDayMsg message. Does not implicitly {@link PlayerPushMsg.OnlineCrossDayMsg.verify|verify} messages.
         * @function encode
         * @memberof PlayerPushMsg.OnlineCrossDayMsg
         * @static
         * @param {PlayerPushMsg.IOnlineCrossDayMsg} message OnlineCrossDayMsg message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        OnlineCrossDayMsg.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified OnlineCrossDayMsg message, length delimited. Does not implicitly {@link PlayerPushMsg.OnlineCrossDayMsg.verify|verify} messages.
         * @function encodeDelimited
         * @memberof PlayerPushMsg.OnlineCrossDayMsg
         * @static
         * @param {PlayerPushMsg.IOnlineCrossDayMsg} message OnlineCrossDayMsg message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        OnlineCrossDayMsg.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an OnlineCrossDayMsg message from the specified reader or buffer.
         * @function decode
         * @memberof PlayerPushMsg.OnlineCrossDayMsg
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {PlayerPushMsg.OnlineCrossDayMsg} OnlineCrossDayMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        OnlineCrossDayMsg.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.PlayerPushMsg.OnlineCrossDayMsg();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an OnlineCrossDayMsg message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof PlayerPushMsg.OnlineCrossDayMsg
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {PlayerPushMsg.OnlineCrossDayMsg} OnlineCrossDayMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        OnlineCrossDayMsg.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an OnlineCrossDayMsg message.
         * @function verify
         * @memberof PlayerPushMsg.OnlineCrossDayMsg
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        OnlineCrossDayMsg.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return OnlineCrossDayMsg;
    })();

    PlayerPushMsg.MailMsg = (function() {

        /**
         * Properties of a MailMsg.
         * @memberof PlayerPushMsg
         * @interface IMailMsg
         */

        /**
         * Constructs a new MailMsg.
         * @memberof PlayerPushMsg
         * @classdesc Represents a MailMsg.
         * @implements IMailMsg
         * @constructor
         * @param {PlayerPushMsg.IMailMsg=} [properties] Properties to set
         */
        function MailMsg(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new MailMsg instance using the specified properties.
         * @function create
         * @memberof PlayerPushMsg.MailMsg
         * @static
         * @param {PlayerPushMsg.IMailMsg=} [properties] Properties to set
         * @returns {PlayerPushMsg.MailMsg} MailMsg instance
         */
        MailMsg.create = function create(properties) {
            return new MailMsg(properties);
        };

        /**
         * Encodes the specified MailMsg message. Does not implicitly {@link PlayerPushMsg.MailMsg.verify|verify} messages.
         * @function encode
         * @memberof PlayerPushMsg.MailMsg
         * @static
         * @param {PlayerPushMsg.IMailMsg} message MailMsg message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        MailMsg.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified MailMsg message, length delimited. Does not implicitly {@link PlayerPushMsg.MailMsg.verify|verify} messages.
         * @function encodeDelimited
         * @memberof PlayerPushMsg.MailMsg
         * @static
         * @param {PlayerPushMsg.IMailMsg} message MailMsg message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        MailMsg.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a MailMsg message from the specified reader or buffer.
         * @function decode
         * @memberof PlayerPushMsg.MailMsg
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {PlayerPushMsg.MailMsg} MailMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        MailMsg.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.PlayerPushMsg.MailMsg();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a MailMsg message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof PlayerPushMsg.MailMsg
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {PlayerPushMsg.MailMsg} MailMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        MailMsg.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a MailMsg message.
         * @function verify
         * @memberof PlayerPushMsg.MailMsg
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        MailMsg.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return MailMsg;
    })();

    PlayerPushMsg.EntrustMsg = (function() {

        /**
         * Properties of an EntrustMsg.
         * @memberof PlayerPushMsg
         * @interface IEntrustMsg
         * @property {BaseInfo.IEntrust|null} [entrust] EntrustMsg entrust
         */

        /**
         * Constructs a new EntrustMsg.
         * @memberof PlayerPushMsg
         * @classdesc Represents an EntrustMsg.
         * @implements IEntrustMsg
         * @constructor
         * @param {PlayerPushMsg.IEntrustMsg=} [properties] Properties to set
         */
        function EntrustMsg(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * EntrustMsg entrust.
         * @member {BaseInfo.IEntrust|null|undefined} entrust
         * @memberof PlayerPushMsg.EntrustMsg
         * @instance
         */
        EntrustMsg.prototype.entrust = null;

        /**
         * Creates a new EntrustMsg instance using the specified properties.
         * @function create
         * @memberof PlayerPushMsg.EntrustMsg
         * @static
         * @param {PlayerPushMsg.IEntrustMsg=} [properties] Properties to set
         * @returns {PlayerPushMsg.EntrustMsg} EntrustMsg instance
         */
        EntrustMsg.create = function create(properties) {
            return new EntrustMsg(properties);
        };

        /**
         * Encodes the specified EntrustMsg message. Does not implicitly {@link PlayerPushMsg.EntrustMsg.verify|verify} messages.
         * @function encode
         * @memberof PlayerPushMsg.EntrustMsg
         * @static
         * @param {PlayerPushMsg.IEntrustMsg} message EntrustMsg message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        EntrustMsg.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.entrust != null && message.hasOwnProperty("entrust"))
                $root.BaseInfo.Entrust.encode(message.entrust, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified EntrustMsg message, length delimited. Does not implicitly {@link PlayerPushMsg.EntrustMsg.verify|verify} messages.
         * @function encodeDelimited
         * @memberof PlayerPushMsg.EntrustMsg
         * @static
         * @param {PlayerPushMsg.IEntrustMsg} message EntrustMsg message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        EntrustMsg.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an EntrustMsg message from the specified reader or buffer.
         * @function decode
         * @memberof PlayerPushMsg.EntrustMsg
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {PlayerPushMsg.EntrustMsg} EntrustMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        EntrustMsg.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.PlayerPushMsg.EntrustMsg();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.entrust = $root.BaseInfo.Entrust.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an EntrustMsg message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof PlayerPushMsg.EntrustMsg
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {PlayerPushMsg.EntrustMsg} EntrustMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        EntrustMsg.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an EntrustMsg message.
         * @function verify
         * @memberof PlayerPushMsg.EntrustMsg
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        EntrustMsg.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.entrust != null && message.hasOwnProperty("entrust")) {
                var error = $root.BaseInfo.Entrust.verify(message.entrust);
                if (error)
                    return "entrust." + error;
            }
            return null;
        };

        return EntrustMsg;
    })();

    PlayerPushMsg.MiniGameMsg = (function() {

        /**
         * Properties of a MiniGameMsg.
         * @memberof PlayerPushMsg
         * @interface IMiniGameMsg
         * @property {BaseInfo.IMiniGame|null} [miniGame] MiniGameMsg miniGame
         */

        /**
         * Constructs a new MiniGameMsg.
         * @memberof PlayerPushMsg
         * @classdesc Represents a MiniGameMsg.
         * @implements IMiniGameMsg
         * @constructor
         * @param {PlayerPushMsg.IMiniGameMsg=} [properties] Properties to set
         */
        function MiniGameMsg(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * MiniGameMsg miniGame.
         * @member {BaseInfo.IMiniGame|null|undefined} miniGame
         * @memberof PlayerPushMsg.MiniGameMsg
         * @instance
         */
        MiniGameMsg.prototype.miniGame = null;

        /**
         * Creates a new MiniGameMsg instance using the specified properties.
         * @function create
         * @memberof PlayerPushMsg.MiniGameMsg
         * @static
         * @param {PlayerPushMsg.IMiniGameMsg=} [properties] Properties to set
         * @returns {PlayerPushMsg.MiniGameMsg} MiniGameMsg instance
         */
        MiniGameMsg.create = function create(properties) {
            return new MiniGameMsg(properties);
        };

        /**
         * Encodes the specified MiniGameMsg message. Does not implicitly {@link PlayerPushMsg.MiniGameMsg.verify|verify} messages.
         * @function encode
         * @memberof PlayerPushMsg.MiniGameMsg
         * @static
         * @param {PlayerPushMsg.IMiniGameMsg} message MiniGameMsg message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        MiniGameMsg.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.miniGame != null && message.hasOwnProperty("miniGame"))
                $root.BaseInfo.MiniGame.encode(message.miniGame, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified MiniGameMsg message, length delimited. Does not implicitly {@link PlayerPushMsg.MiniGameMsg.verify|verify} messages.
         * @function encodeDelimited
         * @memberof PlayerPushMsg.MiniGameMsg
         * @static
         * @param {PlayerPushMsg.IMiniGameMsg} message MiniGameMsg message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        MiniGameMsg.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a MiniGameMsg message from the specified reader or buffer.
         * @function decode
         * @memberof PlayerPushMsg.MiniGameMsg
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {PlayerPushMsg.MiniGameMsg} MiniGameMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        MiniGameMsg.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.PlayerPushMsg.MiniGameMsg();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.miniGame = $root.BaseInfo.MiniGame.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a MiniGameMsg message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof PlayerPushMsg.MiniGameMsg
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {PlayerPushMsg.MiniGameMsg} MiniGameMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        MiniGameMsg.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a MiniGameMsg message.
         * @function verify
         * @memberof PlayerPushMsg.MiniGameMsg
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        MiniGameMsg.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.miniGame != null && message.hasOwnProperty("miniGame")) {
                var error = $root.BaseInfo.MiniGame.verify(message.miniGame);
                if (error)
                    return "miniGame." + error;
            }
            return null;
        };

        return MiniGameMsg;
    })();

    return PlayerPushMsg;
})();

$root.BaseInfo = (function() {

    /**
     * Namespace BaseInfo.
     * @exports BaseInfo
     * @namespace
     */
    var BaseInfo = {};

    BaseInfo.Item = (function() {

        /**
         * Properties of an Item.
         * @memberof BaseInfo
         * @interface IItem
         * @property {string|null} [type] Item type
         * @property {string|null} [id] Item id
         * @property {number|Long|null} [amount] Item amount
         */

        /**
         * Constructs a new Item.
         * @memberof BaseInfo
         * @classdesc Represents an Item.
         * @implements IItem
         * @constructor
         * @param {BaseInfo.IItem=} [properties] Properties to set
         */
        function Item(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Item type.
         * @member {string} type
         * @memberof BaseInfo.Item
         * @instance
         */
        Item.prototype.type = "";

        /**
         * Item id.
         * @member {string} id
         * @memberof BaseInfo.Item
         * @instance
         */
        Item.prototype.id = "";

        /**
         * Item amount.
         * @member {number|Long} amount
         * @memberof BaseInfo.Item
         * @instance
         */
        Item.prototype.amount = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new Item instance using the specified properties.
         * @function create
         * @memberof BaseInfo.Item
         * @static
         * @param {BaseInfo.IItem=} [properties] Properties to set
         * @returns {BaseInfo.Item} Item instance
         */
        Item.create = function create(properties) {
            return new Item(properties);
        };

        /**
         * Encodes the specified Item message. Does not implicitly {@link BaseInfo.Item.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.Item
         * @static
         * @param {BaseInfo.IItem} message Item message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Item.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.type);
            if (message.id != null && message.hasOwnProperty("id"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.id);
            if (message.amount != null && message.hasOwnProperty("amount"))
                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.amount);
            return writer;
        };

        /**
         * Encodes the specified Item message, length delimited. Does not implicitly {@link BaseInfo.Item.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.Item
         * @static
         * @param {BaseInfo.IItem} message Item message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Item.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an Item message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.Item
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.Item} Item
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Item.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.Item();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.type = reader.string();
                    break;
                case 2:
                    message.id = reader.string();
                    break;
                case 3:
                    message.amount = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an Item message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.Item
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.Item} Item
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Item.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an Item message.
         * @function verify
         * @memberof BaseInfo.Item
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Item.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isString(message.type))
                    return "type: string expected";
            if (message.id != null && message.hasOwnProperty("id"))
                if (!$util.isString(message.id))
                    return "id: string expected";
            if (message.amount != null && message.hasOwnProperty("amount"))
                if (!$util.isInteger(message.amount) && !(message.amount && $util.isInteger(message.amount.low) && $util.isInteger(message.amount.high)))
                    return "amount: integer|Long expected";
            return null;
        };

        return Item;
    })();

    BaseInfo.CurrencyBag = (function() {

        /**
         * Properties of a CurrencyBag.
         * @memberof BaseInfo
         * @interface ICurrencyBag
         * @property {Object.<string,BaseInfo.IItem>|null} [currency] CurrencyBag currency
         */

        /**
         * Constructs a new CurrencyBag.
         * @memberof BaseInfo
         * @classdesc Represents a CurrencyBag.
         * @implements ICurrencyBag
         * @constructor
         * @param {BaseInfo.ICurrencyBag=} [properties] Properties to set
         */
        function CurrencyBag(properties) {
            this.currency = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CurrencyBag currency.
         * @member {Object.<string,BaseInfo.IItem>} currency
         * @memberof BaseInfo.CurrencyBag
         * @instance
         */
        CurrencyBag.prototype.currency = $util.emptyObject;

        /**
         * Creates a new CurrencyBag instance using the specified properties.
         * @function create
         * @memberof BaseInfo.CurrencyBag
         * @static
         * @param {BaseInfo.ICurrencyBag=} [properties] Properties to set
         * @returns {BaseInfo.CurrencyBag} CurrencyBag instance
         */
        CurrencyBag.create = function create(properties) {
            return new CurrencyBag(properties);
        };

        /**
         * Encodes the specified CurrencyBag message. Does not implicitly {@link BaseInfo.CurrencyBag.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.CurrencyBag
         * @static
         * @param {BaseInfo.ICurrencyBag} message CurrencyBag message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CurrencyBag.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.currency != null && message.hasOwnProperty("currency"))
                for (var keys = Object.keys(message.currency), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Item.encode(message.currency[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified CurrencyBag message, length delimited. Does not implicitly {@link BaseInfo.CurrencyBag.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.CurrencyBag
         * @static
         * @param {BaseInfo.ICurrencyBag} message CurrencyBag message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CurrencyBag.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CurrencyBag message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.CurrencyBag
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.CurrencyBag} CurrencyBag
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CurrencyBag.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.CurrencyBag(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.currency === $util.emptyObject)
                        message.currency = {};
                    key = reader.string();
                    reader.pos++;
                    message.currency[key] = $root.BaseInfo.Item.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CurrencyBag message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.CurrencyBag
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.CurrencyBag} CurrencyBag
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CurrencyBag.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CurrencyBag message.
         * @function verify
         * @memberof BaseInfo.CurrencyBag
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CurrencyBag.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.currency != null && message.hasOwnProperty("currency")) {
                if (!$util.isObject(message.currency))
                    return "currency: object expected";
                var key = Object.keys(message.currency);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.currency[key[i]]);
                    if (error)
                        return "currency." + error;
                }
            }
            return null;
        };

        return CurrencyBag;
    })();

    BaseInfo.FullBag = (function() {

        /**
         * Properties of a FullBag.
         * @memberof BaseInfo
         * @interface IFullBag
         * @property {Object.<string,BaseInfo.IItem>|null} [currency] FullBag currency
         * @property {Object.<string,BaseInfo.IItem>|null} [nauticalFoods] FullBag nauticalFoods
         * @property {Object.<string,BaseInfo.IItem>|null} [nauticalTools] FullBag nauticalTools
         * @property {Object.<string,number>|null} [foodMenu] FullBag foodMenu
         */

        /**
         * Constructs a new FullBag.
         * @memberof BaseInfo
         * @classdesc Represents a FullBag.
         * @implements IFullBag
         * @constructor
         * @param {BaseInfo.IFullBag=} [properties] Properties to set
         */
        function FullBag(properties) {
            this.currency = {};
            this.nauticalFoods = {};
            this.nauticalTools = {};
            this.foodMenu = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FullBag currency.
         * @member {Object.<string,BaseInfo.IItem>} currency
         * @memberof BaseInfo.FullBag
         * @instance
         */
        FullBag.prototype.currency = $util.emptyObject;

        /**
         * FullBag nauticalFoods.
         * @member {Object.<string,BaseInfo.IItem>} nauticalFoods
         * @memberof BaseInfo.FullBag
         * @instance
         */
        FullBag.prototype.nauticalFoods = $util.emptyObject;

        /**
         * FullBag nauticalTools.
         * @member {Object.<string,BaseInfo.IItem>} nauticalTools
         * @memberof BaseInfo.FullBag
         * @instance
         */
        FullBag.prototype.nauticalTools = $util.emptyObject;

        /**
         * FullBag foodMenu.
         * @member {Object.<string,number>} foodMenu
         * @memberof BaseInfo.FullBag
         * @instance
         */
        FullBag.prototype.foodMenu = $util.emptyObject;

        /**
         * Creates a new FullBag instance using the specified properties.
         * @function create
         * @memberof BaseInfo.FullBag
         * @static
         * @param {BaseInfo.IFullBag=} [properties] Properties to set
         * @returns {BaseInfo.FullBag} FullBag instance
         */
        FullBag.create = function create(properties) {
            return new FullBag(properties);
        };

        /**
         * Encodes the specified FullBag message. Does not implicitly {@link BaseInfo.FullBag.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.FullBag
         * @static
         * @param {BaseInfo.IFullBag} message FullBag message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FullBag.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.currency != null && message.hasOwnProperty("currency"))
                for (var keys = Object.keys(message.currency), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Item.encode(message.currency[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            if (message.nauticalFoods != null && message.hasOwnProperty("nauticalFoods"))
                for (var keys = Object.keys(message.nauticalFoods), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 2, wireType 2 =*/18).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Item.encode(message.nauticalFoods[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            if (message.nauticalTools != null && message.hasOwnProperty("nauticalTools"))
                for (var keys = Object.keys(message.nauticalTools), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 3, wireType 2 =*/26).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Item.encode(message.nauticalTools[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            if (message.foodMenu != null && message.hasOwnProperty("foodMenu"))
                for (var keys = Object.keys(message.foodMenu), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 4, wireType 2 =*/34).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 0 =*/16).int32(message.foodMenu[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FullBag message, length delimited. Does not implicitly {@link BaseInfo.FullBag.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.FullBag
         * @static
         * @param {BaseInfo.IFullBag} message FullBag message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FullBag.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FullBag message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.FullBag
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.FullBag} FullBag
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FullBag.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.FullBag(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.currency === $util.emptyObject)
                        message.currency = {};
                    key = reader.string();
                    reader.pos++;
                    message.currency[key] = $root.BaseInfo.Item.decode(reader, reader.uint32());
                    break;
                case 2:
                    reader.skip().pos++;
                    if (message.nauticalFoods === $util.emptyObject)
                        message.nauticalFoods = {};
                    key = reader.string();
                    reader.pos++;
                    message.nauticalFoods[key] = $root.BaseInfo.Item.decode(reader, reader.uint32());
                    break;
                case 3:
                    reader.skip().pos++;
                    if (message.nauticalTools === $util.emptyObject)
                        message.nauticalTools = {};
                    key = reader.string();
                    reader.pos++;
                    message.nauticalTools[key] = $root.BaseInfo.Item.decode(reader, reader.uint32());
                    break;
                case 4:
                    reader.skip().pos++;
                    if (message.foodMenu === $util.emptyObject)
                        message.foodMenu = {};
                    key = reader.string();
                    reader.pos++;
                    message.foodMenu[key] = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FullBag message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.FullBag
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.FullBag} FullBag
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FullBag.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FullBag message.
         * @function verify
         * @memberof BaseInfo.FullBag
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FullBag.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.currency != null && message.hasOwnProperty("currency")) {
                if (!$util.isObject(message.currency))
                    return "currency: object expected";
                var key = Object.keys(message.currency);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.currency[key[i]]);
                    if (error)
                        return "currency." + error;
                }
            }
            if (message.nauticalFoods != null && message.hasOwnProperty("nauticalFoods")) {
                if (!$util.isObject(message.nauticalFoods))
                    return "nauticalFoods: object expected";
                var key = Object.keys(message.nauticalFoods);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.nauticalFoods[key[i]]);
                    if (error)
                        return "nauticalFoods." + error;
                }
            }
            if (message.nauticalTools != null && message.hasOwnProperty("nauticalTools")) {
                if (!$util.isObject(message.nauticalTools))
                    return "nauticalTools: object expected";
                var key = Object.keys(message.nauticalTools);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.nauticalTools[key[i]]);
                    if (error)
                        return "nauticalTools." + error;
                }
            }
            if (message.foodMenu != null && message.hasOwnProperty("foodMenu")) {
                if (!$util.isObject(message.foodMenu))
                    return "foodMenu: object expected";
                var key = Object.keys(message.foodMenu);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isInteger(message.foodMenu[key[i]]))
                        return "foodMenu: integer{k:string} expected";
            }
            return null;
        };

        return FullBag;
    })();

    BaseInfo.Rewards = (function() {

        /**
         * Properties of a Rewards.
         * @memberof BaseInfo
         * @interface IRewards
         * @property {Array.<BaseInfo.IItem>|null} [rewards] Rewards rewards
         */

        /**
         * Constructs a new Rewards.
         * @memberof BaseInfo
         * @classdesc Represents a Rewards.
         * @implements IRewards
         * @constructor
         * @param {BaseInfo.IRewards=} [properties] Properties to set
         */
        function Rewards(properties) {
            this.rewards = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Rewards rewards.
         * @member {Array.<BaseInfo.IItem>} rewards
         * @memberof BaseInfo.Rewards
         * @instance
         */
        Rewards.prototype.rewards = $util.emptyArray;

        /**
         * Creates a new Rewards instance using the specified properties.
         * @function create
         * @memberof BaseInfo.Rewards
         * @static
         * @param {BaseInfo.IRewards=} [properties] Properties to set
         * @returns {BaseInfo.Rewards} Rewards instance
         */
        Rewards.create = function create(properties) {
            return new Rewards(properties);
        };

        /**
         * Encodes the specified Rewards message. Does not implicitly {@link BaseInfo.Rewards.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.Rewards
         * @static
         * @param {BaseInfo.IRewards} message Rewards message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Rewards.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.rewards != null && message.rewards.length)
                for (var i = 0; i < message.rewards.length; ++i)
                    $root.BaseInfo.Item.encode(message.rewards[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified Rewards message, length delimited. Does not implicitly {@link BaseInfo.Rewards.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.Rewards
         * @static
         * @param {BaseInfo.IRewards} message Rewards message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Rewards.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Rewards message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.Rewards
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.Rewards} Rewards
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Rewards.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.Rewards();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.rewards && message.rewards.length))
                        message.rewards = [];
                    message.rewards.push($root.BaseInfo.Item.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Rewards message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.Rewards
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.Rewards} Rewards
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Rewards.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Rewards message.
         * @function verify
         * @memberof BaseInfo.Rewards
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Rewards.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                if (!Array.isArray(message.rewards))
                    return "rewards: array expected";
                for (var i = 0; i < message.rewards.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.rewards[i]);
                    if (error)
                        return "rewards." + error;
                }
            }
            return null;
        };

        return Rewards;
    })();

    BaseInfo.PetInfo = (function() {

        /**
         * Properties of a PetInfo.
         * @memberof BaseInfo
         * @interface IPetInfo
         * @property {string|null} [id] PetInfo id
         * @property {number|null} [intimacy] PetInfo intimacy
         * @property {number|null} [visitTimes] PetInfo visitTimes
         * @property {boolean|null} [adopted] PetInfo adopted
         * @property {boolean|null} [newCome] PetInfo newCome
         * @property {BaseInfo.IPetHomeStatus|null} [homeStatus] PetInfo homeStatus
         * @property {boolean|null} [inNautical] PetInfo inNautical
         * @property {number|null} [dailyIntimacy] PetInfo dailyIntimacy
         * @property {Object.<string,boolean>|null} [storyUnlock] PetInfo storyUnlock
         * @property {number|null} [catLevel] PetInfo catLevel
         * @property {number|null} [catStarGrade] PetInfo catStarGrade
         * @property {number|null} [favor] PetInfo favor
         */

        /**
         * Constructs a new PetInfo.
         * @memberof BaseInfo
         * @classdesc Represents a PetInfo.
         * @implements IPetInfo
         * @constructor
         * @param {BaseInfo.IPetInfo=} [properties] Properties to set
         */
        function PetInfo(properties) {
            this.storyUnlock = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PetInfo id.
         * @member {string} id
         * @memberof BaseInfo.PetInfo
         * @instance
         */
        PetInfo.prototype.id = "";

        /**
         * PetInfo intimacy.
         * @member {number} intimacy
         * @memberof BaseInfo.PetInfo
         * @instance
         */
        PetInfo.prototype.intimacy = 0;

        /**
         * PetInfo visitTimes.
         * @member {number} visitTimes
         * @memberof BaseInfo.PetInfo
         * @instance
         */
        PetInfo.prototype.visitTimes = 0;

        /**
         * PetInfo adopted.
         * @member {boolean} adopted
         * @memberof BaseInfo.PetInfo
         * @instance
         */
        PetInfo.prototype.adopted = false;

        /**
         * PetInfo newCome.
         * @member {boolean} newCome
         * @memberof BaseInfo.PetInfo
         * @instance
         */
        PetInfo.prototype.newCome = false;

        /**
         * PetInfo homeStatus.
         * @member {BaseInfo.IPetHomeStatus|null|undefined} homeStatus
         * @memberof BaseInfo.PetInfo
         * @instance
         */
        PetInfo.prototype.homeStatus = null;

        /**
         * PetInfo inNautical.
         * @member {boolean} inNautical
         * @memberof BaseInfo.PetInfo
         * @instance
         */
        PetInfo.prototype.inNautical = false;

        /**
         * PetInfo dailyIntimacy.
         * @member {number} dailyIntimacy
         * @memberof BaseInfo.PetInfo
         * @instance
         */
        PetInfo.prototype.dailyIntimacy = 0;

        /**
         * PetInfo storyUnlock.
         * @member {Object.<string,boolean>} storyUnlock
         * @memberof BaseInfo.PetInfo
         * @instance
         */
        PetInfo.prototype.storyUnlock = $util.emptyObject;

        /**
         * PetInfo catLevel.
         * @member {number} catLevel
         * @memberof BaseInfo.PetInfo
         * @instance
         */
        PetInfo.prototype.catLevel = 0;

        /**
         * PetInfo catStarGrade.
         * @member {number} catStarGrade
         * @memberof BaseInfo.PetInfo
         * @instance
         */
        PetInfo.prototype.catStarGrade = 0;

        /**
         * PetInfo favor.
         * @member {number} favor
         * @memberof BaseInfo.PetInfo
         * @instance
         */
        PetInfo.prototype.favor = 0;

        /**
         * Creates a new PetInfo instance using the specified properties.
         * @function create
         * @memberof BaseInfo.PetInfo
         * @static
         * @param {BaseInfo.IPetInfo=} [properties] Properties to set
         * @returns {BaseInfo.PetInfo} PetInfo instance
         */
        PetInfo.create = function create(properties) {
            return new PetInfo(properties);
        };

        /**
         * Encodes the specified PetInfo message. Does not implicitly {@link BaseInfo.PetInfo.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.PetInfo
         * @static
         * @param {BaseInfo.IPetInfo} message PetInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PetInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.id != null && message.hasOwnProperty("id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.id);
            if (message.intimacy != null && message.hasOwnProperty("intimacy"))
                writer.uint32(/* id 2, wireType 1 =*/17).double(message.intimacy);
            if (message.visitTimes != null && message.hasOwnProperty("visitTimes"))
                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.visitTimes);
            if (message.adopted != null && message.hasOwnProperty("adopted"))
                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.adopted);
            if (message.newCome != null && message.hasOwnProperty("newCome"))
                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.newCome);
            if (message.homeStatus != null && message.hasOwnProperty("homeStatus"))
                $root.BaseInfo.PetHomeStatus.encode(message.homeStatus, writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
            if (message.inNautical != null && message.hasOwnProperty("inNautical"))
                writer.uint32(/* id 7, wireType 0 =*/56).bool(message.inNautical);
            if (message.dailyIntimacy != null && message.hasOwnProperty("dailyIntimacy"))
                writer.uint32(/* id 8, wireType 1 =*/65).double(message.dailyIntimacy);
            if (message.storyUnlock != null && message.hasOwnProperty("storyUnlock"))
                for (var keys = Object.keys(message.storyUnlock), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 9, wireType 2 =*/74).fork().uint32(/* id 1, wireType 0 =*/8).int32(keys[i]).uint32(/* id 2, wireType 0 =*/16).bool(message.storyUnlock[keys[i]]).ldelim();
            if (message.catLevel != null && message.hasOwnProperty("catLevel"))
                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.catLevel);
            if (message.catStarGrade != null && message.hasOwnProperty("catStarGrade"))
                writer.uint32(/* id 11, wireType 0 =*/88).int32(message.catStarGrade);
            if (message.favor != null && message.hasOwnProperty("favor"))
                writer.uint32(/* id 12, wireType 0 =*/96).int32(message.favor);
            return writer;
        };

        /**
         * Encodes the specified PetInfo message, length delimited. Does not implicitly {@link BaseInfo.PetInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.PetInfo
         * @static
         * @param {BaseInfo.IPetInfo} message PetInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PetInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PetInfo message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.PetInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.PetInfo} PetInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PetInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.PetInfo(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.intimacy = reader.double();
                    break;
                case 3:
                    message.visitTimes = reader.int32();
                    break;
                case 4:
                    message.adopted = reader.bool();
                    break;
                case 5:
                    message.newCome = reader.bool();
                    break;
                case 6:
                    message.homeStatus = $root.BaseInfo.PetHomeStatus.decode(reader, reader.uint32());
                    break;
                case 7:
                    message.inNautical = reader.bool();
                    break;
                case 8:
                    message.dailyIntimacy = reader.double();
                    break;
                case 9:
                    reader.skip().pos++;
                    if (message.storyUnlock === $util.emptyObject)
                        message.storyUnlock = {};
                    key = reader.int32();
                    reader.pos++;
                    message.storyUnlock[key] = reader.bool();
                    break;
                case 10:
                    message.catLevel = reader.int32();
                    break;
                case 11:
                    message.catStarGrade = reader.int32();
                    break;
                case 12:
                    message.favor = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PetInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.PetInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.PetInfo} PetInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PetInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PetInfo message.
         * @function verify
         * @memberof BaseInfo.PetInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PetInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.id != null && message.hasOwnProperty("id"))
                if (!$util.isString(message.id))
                    return "id: string expected";
            if (message.intimacy != null && message.hasOwnProperty("intimacy"))
                if (typeof message.intimacy !== "number")
                    return "intimacy: number expected";
            if (message.visitTimes != null && message.hasOwnProperty("visitTimes"))
                if (!$util.isInteger(message.visitTimes))
                    return "visitTimes: integer expected";
            if (message.adopted != null && message.hasOwnProperty("adopted"))
                if (typeof message.adopted !== "boolean")
                    return "adopted: boolean expected";
            if (message.newCome != null && message.hasOwnProperty("newCome"))
                if (typeof message.newCome !== "boolean")
                    return "newCome: boolean expected";
            if (message.homeStatus != null && message.hasOwnProperty("homeStatus")) {
                var error = $root.BaseInfo.PetHomeStatus.verify(message.homeStatus);
                if (error)
                    return "homeStatus." + error;
            }
            if (message.inNautical != null && message.hasOwnProperty("inNautical"))
                if (typeof message.inNautical !== "boolean")
                    return "inNautical: boolean expected";
            if (message.dailyIntimacy != null && message.hasOwnProperty("dailyIntimacy"))
                if (typeof message.dailyIntimacy !== "number")
                    return "dailyIntimacy: number expected";
            if (message.storyUnlock != null && message.hasOwnProperty("storyUnlock")) {
                if (!$util.isObject(message.storyUnlock))
                    return "storyUnlock: object expected";
                var key = Object.keys(message.storyUnlock);
                for (var i = 0; i < key.length; ++i) {
                    if (!$util.key32Re.test(key[i]))
                        return "storyUnlock: integer key{k:int32} expected";
                    if (typeof message.storyUnlock[key[i]] !== "boolean")
                        return "storyUnlock: boolean{k:int32} expected";
                }
            }
            if (message.catLevel != null && message.hasOwnProperty("catLevel"))
                if (!$util.isInteger(message.catLevel))
                    return "catLevel: integer expected";
            if (message.catStarGrade != null && message.hasOwnProperty("catStarGrade"))
                if (!$util.isInteger(message.catStarGrade))
                    return "catStarGrade: integer expected";
            if (message.favor != null && message.hasOwnProperty("favor"))
                if (!$util.isInteger(message.favor))
                    return "favor: integer expected";
            return null;
        };

        return PetInfo;
    })();

    BaseInfo.PlayerPets = (function() {

        /**
         * Properties of a PlayerPets.
         * @memberof BaseInfo
         * @interface IPlayerPets
         * @property {Object.<string,BaseInfo.IPetInfo>|null} [cats] PlayerPets cats
         */

        /**
         * Constructs a new PlayerPets.
         * @memberof BaseInfo
         * @classdesc Represents a PlayerPets.
         * @implements IPlayerPets
         * @constructor
         * @param {BaseInfo.IPlayerPets=} [properties] Properties to set
         */
        function PlayerPets(properties) {
            this.cats = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PlayerPets cats.
         * @member {Object.<string,BaseInfo.IPetInfo>} cats
         * @memberof BaseInfo.PlayerPets
         * @instance
         */
        PlayerPets.prototype.cats = $util.emptyObject;

        /**
         * Creates a new PlayerPets instance using the specified properties.
         * @function create
         * @memberof BaseInfo.PlayerPets
         * @static
         * @param {BaseInfo.IPlayerPets=} [properties] Properties to set
         * @returns {BaseInfo.PlayerPets} PlayerPets instance
         */
        PlayerPets.create = function create(properties) {
            return new PlayerPets(properties);
        };

        /**
         * Encodes the specified PlayerPets message. Does not implicitly {@link BaseInfo.PlayerPets.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.PlayerPets
         * @static
         * @param {BaseInfo.IPlayerPets} message PlayerPets message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayerPets.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.cats != null && message.hasOwnProperty("cats"))
                for (var keys = Object.keys(message.cats), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.PetInfo.encode(message.cats[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified PlayerPets message, length delimited. Does not implicitly {@link BaseInfo.PlayerPets.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.PlayerPets
         * @static
         * @param {BaseInfo.IPlayerPets} message PlayerPets message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayerPets.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PlayerPets message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.PlayerPets
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.PlayerPets} PlayerPets
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayerPets.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.PlayerPets(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.cats === $util.emptyObject)
                        message.cats = {};
                    key = reader.string();
                    reader.pos++;
                    message.cats[key] = $root.BaseInfo.PetInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PlayerPets message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.PlayerPets
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.PlayerPets} PlayerPets
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayerPets.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PlayerPets message.
         * @function verify
         * @memberof BaseInfo.PlayerPets
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PlayerPets.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.cats != null && message.hasOwnProperty("cats")) {
                if (!$util.isObject(message.cats))
                    return "cats: object expected";
                var key = Object.keys(message.cats);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.PetInfo.verify(message.cats[key[i]]);
                    if (error)
                        return "cats." + error;
                }
            }
            return null;
        };

        return PlayerPets;
    })();

    BaseInfo.PlayerBuilding = (function() {

        /**
         * Properties of a PlayerBuilding.
         * @memberof BaseInfo
         * @interface IPlayerBuilding
         * @property {Object.<string,BaseInfo.IBuilding>|null} [buildings] PlayerBuilding buildings
         */

        /**
         * Constructs a new PlayerBuilding.
         * @memberof BaseInfo
         * @classdesc Represents a PlayerBuilding.
         * @implements IPlayerBuilding
         * @constructor
         * @param {BaseInfo.IPlayerBuilding=} [properties] Properties to set
         */
        function PlayerBuilding(properties) {
            this.buildings = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PlayerBuilding buildings.
         * @member {Object.<string,BaseInfo.IBuilding>} buildings
         * @memberof BaseInfo.PlayerBuilding
         * @instance
         */
        PlayerBuilding.prototype.buildings = $util.emptyObject;

        /**
         * Creates a new PlayerBuilding instance using the specified properties.
         * @function create
         * @memberof BaseInfo.PlayerBuilding
         * @static
         * @param {BaseInfo.IPlayerBuilding=} [properties] Properties to set
         * @returns {BaseInfo.PlayerBuilding} PlayerBuilding instance
         */
        PlayerBuilding.create = function create(properties) {
            return new PlayerBuilding(properties);
        };

        /**
         * Encodes the specified PlayerBuilding message. Does not implicitly {@link BaseInfo.PlayerBuilding.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.PlayerBuilding
         * @static
         * @param {BaseInfo.IPlayerBuilding} message PlayerBuilding message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayerBuilding.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.buildings != null && message.hasOwnProperty("buildings"))
                for (var keys = Object.keys(message.buildings), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Building.encode(message.buildings[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified PlayerBuilding message, length delimited. Does not implicitly {@link BaseInfo.PlayerBuilding.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.PlayerBuilding
         * @static
         * @param {BaseInfo.IPlayerBuilding} message PlayerBuilding message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayerBuilding.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PlayerBuilding message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.PlayerBuilding
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.PlayerBuilding} PlayerBuilding
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayerBuilding.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.PlayerBuilding(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.buildings === $util.emptyObject)
                        message.buildings = {};
                    key = reader.string();
                    reader.pos++;
                    message.buildings[key] = $root.BaseInfo.Building.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PlayerBuilding message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.PlayerBuilding
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.PlayerBuilding} PlayerBuilding
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayerBuilding.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PlayerBuilding message.
         * @function verify
         * @memberof BaseInfo.PlayerBuilding
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PlayerBuilding.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.buildings != null && message.hasOwnProperty("buildings")) {
                if (!$util.isObject(message.buildings))
                    return "buildings: object expected";
                var key = Object.keys(message.buildings);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Building.verify(message.buildings[key[i]]);
                    if (error)
                        return "buildings." + error;
                }
            }
            return null;
        };

        return PlayerBuilding;
    })();

    BaseInfo.Building = (function() {

        /**
         * Properties of a Building.
         * @memberof BaseInfo
         * @interface IBuilding
         * @property {string|null} [id] Building id
         * @property {string|null} [position] Building position
         */

        /**
         * Constructs a new Building.
         * @memberof BaseInfo
         * @classdesc Represents a Building.
         * @implements IBuilding
         * @constructor
         * @param {BaseInfo.IBuilding=} [properties] Properties to set
         */
        function Building(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Building id.
         * @member {string} id
         * @memberof BaseInfo.Building
         * @instance
         */
        Building.prototype.id = "";

        /**
         * Building position.
         * @member {string} position
         * @memberof BaseInfo.Building
         * @instance
         */
        Building.prototype.position = "";

        /**
         * Creates a new Building instance using the specified properties.
         * @function create
         * @memberof BaseInfo.Building
         * @static
         * @param {BaseInfo.IBuilding=} [properties] Properties to set
         * @returns {BaseInfo.Building} Building instance
         */
        Building.create = function create(properties) {
            return new Building(properties);
        };

        /**
         * Encodes the specified Building message. Does not implicitly {@link BaseInfo.Building.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.Building
         * @static
         * @param {BaseInfo.IBuilding} message Building message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Building.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.id != null && message.hasOwnProperty("id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.id);
            if (message.position != null && message.hasOwnProperty("position"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.position);
            return writer;
        };

        /**
         * Encodes the specified Building message, length delimited. Does not implicitly {@link BaseInfo.Building.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.Building
         * @static
         * @param {BaseInfo.IBuilding} message Building message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Building.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Building message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.Building
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.Building} Building
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Building.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.Building();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.position = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Building message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.Building
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.Building} Building
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Building.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Building message.
         * @function verify
         * @memberof BaseInfo.Building
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Building.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.id != null && message.hasOwnProperty("id"))
                if (!$util.isString(message.id))
                    return "id: string expected";
            if (message.position != null && message.hasOwnProperty("position"))
                if (!$util.isString(message.position))
                    return "position: string expected";
            return null;
        };

        return Building;
    })();

    BaseInfo.LetterBox = (function() {

        /**
         * Properties of a LetterBox.
         * @memberof BaseInfo
         * @interface ILetterBox
         * @property {number|Long|null} [capacity] LetterBox capacity
         * @property {number|Long|null} [fishToReward] LetterBox fishToReward
         * @property {number|Long|null} [lastUpdateMillis] LetterBox lastUpdateMillis
         * @property {number|Long|null} [fullMills] LetterBox fullMills
         */

        /**
         * Constructs a new LetterBox.
         * @memberof BaseInfo
         * @classdesc Represents a LetterBox.
         * @implements ILetterBox
         * @constructor
         * @param {BaseInfo.ILetterBox=} [properties] Properties to set
         */
        function LetterBox(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * LetterBox capacity.
         * @member {number|Long} capacity
         * @memberof BaseInfo.LetterBox
         * @instance
         */
        LetterBox.prototype.capacity = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * LetterBox fishToReward.
         * @member {number|Long} fishToReward
         * @memberof BaseInfo.LetterBox
         * @instance
         */
        LetterBox.prototype.fishToReward = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * LetterBox lastUpdateMillis.
         * @member {number|Long} lastUpdateMillis
         * @memberof BaseInfo.LetterBox
         * @instance
         */
        LetterBox.prototype.lastUpdateMillis = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * LetterBox fullMills.
         * @member {number|Long} fullMills
         * @memberof BaseInfo.LetterBox
         * @instance
         */
        LetterBox.prototype.fullMills = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new LetterBox instance using the specified properties.
         * @function create
         * @memberof BaseInfo.LetterBox
         * @static
         * @param {BaseInfo.ILetterBox=} [properties] Properties to set
         * @returns {BaseInfo.LetterBox} LetterBox instance
         */
        LetterBox.create = function create(properties) {
            return new LetterBox(properties);
        };

        /**
         * Encodes the specified LetterBox message. Does not implicitly {@link BaseInfo.LetterBox.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.LetterBox
         * @static
         * @param {BaseInfo.ILetterBox} message LetterBox message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LetterBox.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.capacity != null && message.hasOwnProperty("capacity"))
                writer.uint32(/* id 1, wireType 0 =*/8).int64(message.capacity);
            if (message.fishToReward != null && message.hasOwnProperty("fishToReward"))
                writer.uint32(/* id 2, wireType 0 =*/16).int64(message.fishToReward);
            if (message.lastUpdateMillis != null && message.hasOwnProperty("lastUpdateMillis"))
                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.lastUpdateMillis);
            if (message.fullMills != null && message.hasOwnProperty("fullMills"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.fullMills);
            return writer;
        };

        /**
         * Encodes the specified LetterBox message, length delimited. Does not implicitly {@link BaseInfo.LetterBox.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.LetterBox
         * @static
         * @param {BaseInfo.ILetterBox} message LetterBox message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LetterBox.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a LetterBox message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.LetterBox
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.LetterBox} LetterBox
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LetterBox.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.LetterBox();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.capacity = reader.int64();
                    break;
                case 2:
                    message.fishToReward = reader.int64();
                    break;
                case 3:
                    message.lastUpdateMillis = reader.int64();
                    break;
                case 4:
                    message.fullMills = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a LetterBox message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.LetterBox
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.LetterBox} LetterBox
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LetterBox.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a LetterBox message.
         * @function verify
         * @memberof BaseInfo.LetterBox
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        LetterBox.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.capacity != null && message.hasOwnProperty("capacity"))
                if (!$util.isInteger(message.capacity) && !(message.capacity && $util.isInteger(message.capacity.low) && $util.isInteger(message.capacity.high)))
                    return "capacity: integer|Long expected";
            if (message.fishToReward != null && message.hasOwnProperty("fishToReward"))
                if (!$util.isInteger(message.fishToReward) && !(message.fishToReward && $util.isInteger(message.fishToReward.low) && $util.isInteger(message.fishToReward.high)))
                    return "fishToReward: integer|Long expected";
            if (message.lastUpdateMillis != null && message.hasOwnProperty("lastUpdateMillis"))
                if (!$util.isInteger(message.lastUpdateMillis) && !(message.lastUpdateMillis && $util.isInteger(message.lastUpdateMillis.low) && $util.isInteger(message.lastUpdateMillis.high)))
                    return "lastUpdateMillis: integer|Long expected";
            if (message.fullMills != null && message.hasOwnProperty("fullMills"))
                if (!$util.isInteger(message.fullMills) && !(message.fullMills && $util.isInteger(message.fullMills.low) && $util.isInteger(message.fullMills.high)))
                    return "fullMills: integer|Long expected";
            return null;
        };

        return LetterBox;
    })();

    BaseInfo.Tasks = (function() {

        /**
         * Properties of a Tasks.
         * @memberof BaseInfo
         * @interface ITasks
         * @property {Object.<string,BaseInfo.ITask>|null} [dailyTasks] Tasks dailyTasks
         * @property {Object.<string,BaseInfo.ITask>|null} [trophyTasks] Tasks trophyTasks
         * @property {Object.<string,BaseInfo.ITask>|null} [mainTasks] Tasks mainTasks
         */

        /**
         * Constructs a new Tasks.
         * @memberof BaseInfo
         * @classdesc Represents a Tasks.
         * @implements ITasks
         * @constructor
         * @param {BaseInfo.ITasks=} [properties] Properties to set
         */
        function Tasks(properties) {
            this.dailyTasks = {};
            this.trophyTasks = {};
            this.mainTasks = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Tasks dailyTasks.
         * @member {Object.<string,BaseInfo.ITask>} dailyTasks
         * @memberof BaseInfo.Tasks
         * @instance
         */
        Tasks.prototype.dailyTasks = $util.emptyObject;

        /**
         * Tasks trophyTasks.
         * @member {Object.<string,BaseInfo.ITask>} trophyTasks
         * @memberof BaseInfo.Tasks
         * @instance
         */
        Tasks.prototype.trophyTasks = $util.emptyObject;

        /**
         * Tasks mainTasks.
         * @member {Object.<string,BaseInfo.ITask>} mainTasks
         * @memberof BaseInfo.Tasks
         * @instance
         */
        Tasks.prototype.mainTasks = $util.emptyObject;

        /**
         * Creates a new Tasks instance using the specified properties.
         * @function create
         * @memberof BaseInfo.Tasks
         * @static
         * @param {BaseInfo.ITasks=} [properties] Properties to set
         * @returns {BaseInfo.Tasks} Tasks instance
         */
        Tasks.create = function create(properties) {
            return new Tasks(properties);
        };

        /**
         * Encodes the specified Tasks message. Does not implicitly {@link BaseInfo.Tasks.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.Tasks
         * @static
         * @param {BaseInfo.ITasks} message Tasks message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Tasks.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.dailyTasks != null && message.hasOwnProperty("dailyTasks"))
                for (var keys = Object.keys(message.dailyTasks), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Task.encode(message.dailyTasks[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            if (message.trophyTasks != null && message.hasOwnProperty("trophyTasks"))
                for (var keys = Object.keys(message.trophyTasks), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 2, wireType 2 =*/18).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Task.encode(message.trophyTasks[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            if (message.mainTasks != null && message.hasOwnProperty("mainTasks"))
                for (var keys = Object.keys(message.mainTasks), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 3, wireType 2 =*/26).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Task.encode(message.mainTasks[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified Tasks message, length delimited. Does not implicitly {@link BaseInfo.Tasks.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.Tasks
         * @static
         * @param {BaseInfo.ITasks} message Tasks message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Tasks.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Tasks message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.Tasks
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.Tasks} Tasks
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Tasks.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.Tasks(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.dailyTasks === $util.emptyObject)
                        message.dailyTasks = {};
                    key = reader.string();
                    reader.pos++;
                    message.dailyTasks[key] = $root.BaseInfo.Task.decode(reader, reader.uint32());
                    break;
                case 2:
                    reader.skip().pos++;
                    if (message.trophyTasks === $util.emptyObject)
                        message.trophyTasks = {};
                    key = reader.string();
                    reader.pos++;
                    message.trophyTasks[key] = $root.BaseInfo.Task.decode(reader, reader.uint32());
                    break;
                case 3:
                    reader.skip().pos++;
                    if (message.mainTasks === $util.emptyObject)
                        message.mainTasks = {};
                    key = reader.string();
                    reader.pos++;
                    message.mainTasks[key] = $root.BaseInfo.Task.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Tasks message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.Tasks
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.Tasks} Tasks
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Tasks.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Tasks message.
         * @function verify
         * @memberof BaseInfo.Tasks
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Tasks.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.dailyTasks != null && message.hasOwnProperty("dailyTasks")) {
                if (!$util.isObject(message.dailyTasks))
                    return "dailyTasks: object expected";
                var key = Object.keys(message.dailyTasks);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Task.verify(message.dailyTasks[key[i]]);
                    if (error)
                        return "dailyTasks." + error;
                }
            }
            if (message.trophyTasks != null && message.hasOwnProperty("trophyTasks")) {
                if (!$util.isObject(message.trophyTasks))
                    return "trophyTasks: object expected";
                var key = Object.keys(message.trophyTasks);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Task.verify(message.trophyTasks[key[i]]);
                    if (error)
                        return "trophyTasks." + error;
                }
            }
            if (message.mainTasks != null && message.hasOwnProperty("mainTasks")) {
                if (!$util.isObject(message.mainTasks))
                    return "mainTasks: object expected";
                var key = Object.keys(message.mainTasks);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Task.verify(message.mainTasks[key[i]]);
                    if (error)
                        return "mainTasks." + error;
                }
            }
            return null;
        };

        return Tasks;
    })();

    BaseInfo.Task = (function() {

        /**
         * Properties of a Task.
         * @memberof BaseInfo
         * @interface ITask
         * @property {string|null} [id] Task id
         * @property {number|Long|null} [current] Task current
         * @property {number|Long|null} [target] Task target
         * @property {string|null} [taskListId] Task taskListId
         */

        /**
         * Constructs a new Task.
         * @memberof BaseInfo
         * @classdesc Represents a Task.
         * @implements ITask
         * @constructor
         * @param {BaseInfo.ITask=} [properties] Properties to set
         */
        function Task(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Task id.
         * @member {string} id
         * @memberof BaseInfo.Task
         * @instance
         */
        Task.prototype.id = "";

        /**
         * Task current.
         * @member {number|Long} current
         * @memberof BaseInfo.Task
         * @instance
         */
        Task.prototype.current = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Task target.
         * @member {number|Long} target
         * @memberof BaseInfo.Task
         * @instance
         */
        Task.prototype.target = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Task taskListId.
         * @member {string} taskListId
         * @memberof BaseInfo.Task
         * @instance
         */
        Task.prototype.taskListId = "";

        /**
         * Creates a new Task instance using the specified properties.
         * @function create
         * @memberof BaseInfo.Task
         * @static
         * @param {BaseInfo.ITask=} [properties] Properties to set
         * @returns {BaseInfo.Task} Task instance
         */
        Task.create = function create(properties) {
            return new Task(properties);
        };

        /**
         * Encodes the specified Task message. Does not implicitly {@link BaseInfo.Task.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.Task
         * @static
         * @param {BaseInfo.ITask} message Task message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Task.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.id != null && message.hasOwnProperty("id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.id);
            if (message.current != null && message.hasOwnProperty("current"))
                writer.uint32(/* id 2, wireType 0 =*/16).int64(message.current);
            if (message.target != null && message.hasOwnProperty("target"))
                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.target);
            if (message.taskListId != null && message.hasOwnProperty("taskListId"))
                writer.uint32(/* id 4, wireType 2 =*/34).string(message.taskListId);
            return writer;
        };

        /**
         * Encodes the specified Task message, length delimited. Does not implicitly {@link BaseInfo.Task.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.Task
         * @static
         * @param {BaseInfo.ITask} message Task message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Task.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Task message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.Task
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.Task} Task
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Task.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.Task();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.current = reader.int64();
                    break;
                case 3:
                    message.target = reader.int64();
                    break;
                case 4:
                    message.taskListId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Task message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.Task
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.Task} Task
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Task.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Task message.
         * @function verify
         * @memberof BaseInfo.Task
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Task.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.id != null && message.hasOwnProperty("id"))
                if (!$util.isString(message.id))
                    return "id: string expected";
            if (message.current != null && message.hasOwnProperty("current"))
                if (!$util.isInteger(message.current) && !(message.current && $util.isInteger(message.current.low) && $util.isInteger(message.current.high)))
                    return "current: integer|Long expected";
            if (message.target != null && message.hasOwnProperty("target"))
                if (!$util.isInteger(message.target) && !(message.target && $util.isInteger(message.target.low) && $util.isInteger(message.target.high)))
                    return "target: integer|Long expected";
            if (message.taskListId != null && message.hasOwnProperty("taskListId"))
                if (!$util.isString(message.taskListId))
                    return "taskListId: string expected";
            return null;
        };

        return Task;
    })();

    BaseInfo.FoodMenu = (function() {

        /**
         * Properties of a FoodMenu.
         * @memberof BaseInfo
         * @interface IFoodMenu
         * @property {Object.<string,number>|null} [menu] FoodMenu menu
         */

        /**
         * Constructs a new FoodMenu.
         * @memberof BaseInfo
         * @classdesc Represents a FoodMenu.
         * @implements IFoodMenu
         * @constructor
         * @param {BaseInfo.IFoodMenu=} [properties] Properties to set
         */
        function FoodMenu(properties) {
            this.menu = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FoodMenu menu.
         * @member {Object.<string,number>} menu
         * @memberof BaseInfo.FoodMenu
         * @instance
         */
        FoodMenu.prototype.menu = $util.emptyObject;

        /**
         * Creates a new FoodMenu instance using the specified properties.
         * @function create
         * @memberof BaseInfo.FoodMenu
         * @static
         * @param {BaseInfo.IFoodMenu=} [properties] Properties to set
         * @returns {BaseInfo.FoodMenu} FoodMenu instance
         */
        FoodMenu.create = function create(properties) {
            return new FoodMenu(properties);
        };

        /**
         * Encodes the specified FoodMenu message. Does not implicitly {@link BaseInfo.FoodMenu.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.FoodMenu
         * @static
         * @param {BaseInfo.IFoodMenu} message FoodMenu message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FoodMenu.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.menu != null && message.hasOwnProperty("menu"))
                for (var keys = Object.keys(message.menu), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 0 =*/16).int32(message.menu[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FoodMenu message, length delimited. Does not implicitly {@link BaseInfo.FoodMenu.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.FoodMenu
         * @static
         * @param {BaseInfo.IFoodMenu} message FoodMenu message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FoodMenu.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FoodMenu message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.FoodMenu
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.FoodMenu} FoodMenu
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FoodMenu.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.FoodMenu(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.menu === $util.emptyObject)
                        message.menu = {};
                    key = reader.string();
                    reader.pos++;
                    message.menu[key] = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FoodMenu message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.FoodMenu
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.FoodMenu} FoodMenu
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FoodMenu.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FoodMenu message.
         * @function verify
         * @memberof BaseInfo.FoodMenu
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FoodMenu.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.menu != null && message.hasOwnProperty("menu")) {
                if (!$util.isObject(message.menu))
                    return "menu: object expected";
                var key = Object.keys(message.menu);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isInteger(message.menu[key[i]]))
                        return "menu: integer{k:string} expected";
            }
            return null;
        };

        return FoodMenu;
    })();

    BaseInfo.StaffSkillGroup = (function() {

        /**
         * Properties of a StaffSkillGroup.
         * @memberof BaseInfo
         * @interface IStaffSkillGroup
         * @property {Object.<string,string>|null} [group] StaffSkillGroup group
         */

        /**
         * Constructs a new StaffSkillGroup.
         * @memberof BaseInfo
         * @classdesc Represents a StaffSkillGroup.
         * @implements IStaffSkillGroup
         * @constructor
         * @param {BaseInfo.IStaffSkillGroup=} [properties] Properties to set
         */
        function StaffSkillGroup(properties) {
            this.group = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * StaffSkillGroup group.
         * @member {Object.<string,string>} group
         * @memberof BaseInfo.StaffSkillGroup
         * @instance
         */
        StaffSkillGroup.prototype.group = $util.emptyObject;

        /**
         * Creates a new StaffSkillGroup instance using the specified properties.
         * @function create
         * @memberof BaseInfo.StaffSkillGroup
         * @static
         * @param {BaseInfo.IStaffSkillGroup=} [properties] Properties to set
         * @returns {BaseInfo.StaffSkillGroup} StaffSkillGroup instance
         */
        StaffSkillGroup.create = function create(properties) {
            return new StaffSkillGroup(properties);
        };

        /**
         * Encodes the specified StaffSkillGroup message. Does not implicitly {@link BaseInfo.StaffSkillGroup.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.StaffSkillGroup
         * @static
         * @param {BaseInfo.IStaffSkillGroup} message StaffSkillGroup message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StaffSkillGroup.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.group != null && message.hasOwnProperty("group"))
                for (var keys = Object.keys(message.group), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.group[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified StaffSkillGroup message, length delimited. Does not implicitly {@link BaseInfo.StaffSkillGroup.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.StaffSkillGroup
         * @static
         * @param {BaseInfo.IStaffSkillGroup} message StaffSkillGroup message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StaffSkillGroup.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a StaffSkillGroup message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.StaffSkillGroup
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.StaffSkillGroup} StaffSkillGroup
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StaffSkillGroup.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.StaffSkillGroup(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.group === $util.emptyObject)
                        message.group = {};
                    key = reader.string();
                    reader.pos++;
                    message.group[key] = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a StaffSkillGroup message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.StaffSkillGroup
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.StaffSkillGroup} StaffSkillGroup
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StaffSkillGroup.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a StaffSkillGroup message.
         * @function verify
         * @memberof BaseInfo.StaffSkillGroup
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        StaffSkillGroup.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.group != null && message.hasOwnProperty("group")) {
                if (!$util.isObject(message.group))
                    return "group: object expected";
                var key = Object.keys(message.group);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.group[key[i]]))
                        return "group: string{k:string} expected";
            }
            return null;
        };

        return StaffSkillGroup;
    })();

    BaseInfo.StaffSkillEndTimeStamp = (function() {

        /**
         * Properties of a StaffSkillEndTimeStamp.
         * @memberof BaseInfo
         * @interface IStaffSkillEndTimeStamp
         * @property {Object.<string,number|Long>|null} [endTimeStamp] StaffSkillEndTimeStamp endTimeStamp
         */

        /**
         * Constructs a new StaffSkillEndTimeStamp.
         * @memberof BaseInfo
         * @classdesc Represents a StaffSkillEndTimeStamp.
         * @implements IStaffSkillEndTimeStamp
         * @constructor
         * @param {BaseInfo.IStaffSkillEndTimeStamp=} [properties] Properties to set
         */
        function StaffSkillEndTimeStamp(properties) {
            this.endTimeStamp = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * StaffSkillEndTimeStamp endTimeStamp.
         * @member {Object.<string,number|Long>} endTimeStamp
         * @memberof BaseInfo.StaffSkillEndTimeStamp
         * @instance
         */
        StaffSkillEndTimeStamp.prototype.endTimeStamp = $util.emptyObject;

        /**
         * Creates a new StaffSkillEndTimeStamp instance using the specified properties.
         * @function create
         * @memberof BaseInfo.StaffSkillEndTimeStamp
         * @static
         * @param {BaseInfo.IStaffSkillEndTimeStamp=} [properties] Properties to set
         * @returns {BaseInfo.StaffSkillEndTimeStamp} StaffSkillEndTimeStamp instance
         */
        StaffSkillEndTimeStamp.create = function create(properties) {
            return new StaffSkillEndTimeStamp(properties);
        };

        /**
         * Encodes the specified StaffSkillEndTimeStamp message. Does not implicitly {@link BaseInfo.StaffSkillEndTimeStamp.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.StaffSkillEndTimeStamp
         * @static
         * @param {BaseInfo.IStaffSkillEndTimeStamp} message StaffSkillEndTimeStamp message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StaffSkillEndTimeStamp.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp"))
                for (var keys = Object.keys(message.endTimeStamp), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 0 =*/16).int64(message.endTimeStamp[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified StaffSkillEndTimeStamp message, length delimited. Does not implicitly {@link BaseInfo.StaffSkillEndTimeStamp.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.StaffSkillEndTimeStamp
         * @static
         * @param {BaseInfo.IStaffSkillEndTimeStamp} message StaffSkillEndTimeStamp message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StaffSkillEndTimeStamp.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a StaffSkillEndTimeStamp message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.StaffSkillEndTimeStamp
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.StaffSkillEndTimeStamp} StaffSkillEndTimeStamp
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StaffSkillEndTimeStamp.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.StaffSkillEndTimeStamp(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.endTimeStamp === $util.emptyObject)
                        message.endTimeStamp = {};
                    key = reader.string();
                    reader.pos++;
                    message.endTimeStamp[key] = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a StaffSkillEndTimeStamp message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.StaffSkillEndTimeStamp
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.StaffSkillEndTimeStamp} StaffSkillEndTimeStamp
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StaffSkillEndTimeStamp.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a StaffSkillEndTimeStamp message.
         * @function verify
         * @memberof BaseInfo.StaffSkillEndTimeStamp
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        StaffSkillEndTimeStamp.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp")) {
                if (!$util.isObject(message.endTimeStamp))
                    return "endTimeStamp: object expected";
                var key = Object.keys(message.endTimeStamp);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isInteger(message.endTimeStamp[key[i]]) && !(message.endTimeStamp[key[i]] && $util.isInteger(message.endTimeStamp[key[i]].low) && $util.isInteger(message.endTimeStamp[key[i]].high)))
                        return "endTimeStamp: integer|Long{k:string} expected";
            }
            return null;
        };

        return StaffSkillEndTimeStamp;
    })();

    BaseInfo.StaffGroup = (function() {

        /**
         * Properties of a StaffGroup.
         * @memberof BaseInfo
         * @interface IStaffGroup
         * @property {Object.<string,string>|null} [group] StaffGroup group
         */

        /**
         * Constructs a new StaffGroup.
         * @memberof BaseInfo
         * @classdesc Represents a StaffGroup.
         * @implements IStaffGroup
         * @constructor
         * @param {BaseInfo.IStaffGroup=} [properties] Properties to set
         */
        function StaffGroup(properties) {
            this.group = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * StaffGroup group.
         * @member {Object.<string,string>} group
         * @memberof BaseInfo.StaffGroup
         * @instance
         */
        StaffGroup.prototype.group = $util.emptyObject;

        /**
         * Creates a new StaffGroup instance using the specified properties.
         * @function create
         * @memberof BaseInfo.StaffGroup
         * @static
         * @param {BaseInfo.IStaffGroup=} [properties] Properties to set
         * @returns {BaseInfo.StaffGroup} StaffGroup instance
         */
        StaffGroup.create = function create(properties) {
            return new StaffGroup(properties);
        };

        /**
         * Encodes the specified StaffGroup message. Does not implicitly {@link BaseInfo.StaffGroup.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.StaffGroup
         * @static
         * @param {BaseInfo.IStaffGroup} message StaffGroup message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StaffGroup.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.group != null && message.hasOwnProperty("group"))
                for (var keys = Object.keys(message.group), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.group[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified StaffGroup message, length delimited. Does not implicitly {@link BaseInfo.StaffGroup.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.StaffGroup
         * @static
         * @param {BaseInfo.IStaffGroup} message StaffGroup message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StaffGroup.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a StaffGroup message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.StaffGroup
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.StaffGroup} StaffGroup
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StaffGroup.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.StaffGroup(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.group === $util.emptyObject)
                        message.group = {};
                    key = reader.string();
                    reader.pos++;
                    message.group[key] = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a StaffGroup message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.StaffGroup
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.StaffGroup} StaffGroup
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StaffGroup.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a StaffGroup message.
         * @function verify
         * @memberof BaseInfo.StaffGroup
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        StaffGroup.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.group != null && message.hasOwnProperty("group")) {
                if (!$util.isObject(message.group))
                    return "group: object expected";
                var key = Object.keys(message.group);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.group[key[i]]))
                        return "group: string{k:string} expected";
            }
            return null;
        };

        return StaffGroup;
    })();

    BaseInfo.StaffSkillAmount = (function() {

        /**
         * Properties of a StaffSkillAmount.
         * @memberof BaseInfo
         * @interface IStaffSkillAmount
         * @property {Object.<string,number>|null} [skillAmount] StaffSkillAmount skillAmount
         */

        /**
         * Constructs a new StaffSkillAmount.
         * @memberof BaseInfo
         * @classdesc Represents a StaffSkillAmount.
         * @implements IStaffSkillAmount
         * @constructor
         * @param {BaseInfo.IStaffSkillAmount=} [properties] Properties to set
         */
        function StaffSkillAmount(properties) {
            this.skillAmount = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * StaffSkillAmount skillAmount.
         * @member {Object.<string,number>} skillAmount
         * @memberof BaseInfo.StaffSkillAmount
         * @instance
         */
        StaffSkillAmount.prototype.skillAmount = $util.emptyObject;

        /**
         * Creates a new StaffSkillAmount instance using the specified properties.
         * @function create
         * @memberof BaseInfo.StaffSkillAmount
         * @static
         * @param {BaseInfo.IStaffSkillAmount=} [properties] Properties to set
         * @returns {BaseInfo.StaffSkillAmount} StaffSkillAmount instance
         */
        StaffSkillAmount.create = function create(properties) {
            return new StaffSkillAmount(properties);
        };

        /**
         * Encodes the specified StaffSkillAmount message. Does not implicitly {@link BaseInfo.StaffSkillAmount.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.StaffSkillAmount
         * @static
         * @param {BaseInfo.IStaffSkillAmount} message StaffSkillAmount message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StaffSkillAmount.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.skillAmount != null && message.hasOwnProperty("skillAmount"))
                for (var keys = Object.keys(message.skillAmount), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 0 =*/16).int32(message.skillAmount[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified StaffSkillAmount message, length delimited. Does not implicitly {@link BaseInfo.StaffSkillAmount.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.StaffSkillAmount
         * @static
         * @param {BaseInfo.IStaffSkillAmount} message StaffSkillAmount message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StaffSkillAmount.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a StaffSkillAmount message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.StaffSkillAmount
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.StaffSkillAmount} StaffSkillAmount
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StaffSkillAmount.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.StaffSkillAmount(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.skillAmount === $util.emptyObject)
                        message.skillAmount = {};
                    key = reader.string();
                    reader.pos++;
                    message.skillAmount[key] = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a StaffSkillAmount message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.StaffSkillAmount
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.StaffSkillAmount} StaffSkillAmount
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StaffSkillAmount.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a StaffSkillAmount message.
         * @function verify
         * @memberof BaseInfo.StaffSkillAmount
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        StaffSkillAmount.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.skillAmount != null && message.hasOwnProperty("skillAmount")) {
                if (!$util.isObject(message.skillAmount))
                    return "skillAmount: object expected";
                var key = Object.keys(message.skillAmount);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isInteger(message.skillAmount[key[i]]))
                        return "skillAmount: integer{k:string} expected";
            }
            return null;
        };

        return StaffSkillAmount;
    })();

    BaseInfo.SignInfo = (function() {

        /**
         * Properties of a SignInfo.
         * @memberof BaseInfo
         * @interface ISignInfo
         * @property {number|Long|null} [lastSignTime] SignInfo lastSignTime
         * @property {number|null} [signTimes] SignInfo signTimes
         */

        /**
         * Constructs a new SignInfo.
         * @memberof BaseInfo
         * @classdesc Represents a SignInfo.
         * @implements ISignInfo
         * @constructor
         * @param {BaseInfo.ISignInfo=} [properties] Properties to set
         */
        function SignInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * SignInfo lastSignTime.
         * @member {number|Long} lastSignTime
         * @memberof BaseInfo.SignInfo
         * @instance
         */
        SignInfo.prototype.lastSignTime = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * SignInfo signTimes.
         * @member {number} signTimes
         * @memberof BaseInfo.SignInfo
         * @instance
         */
        SignInfo.prototype.signTimes = 0;

        /**
         * Creates a new SignInfo instance using the specified properties.
         * @function create
         * @memberof BaseInfo.SignInfo
         * @static
         * @param {BaseInfo.ISignInfo=} [properties] Properties to set
         * @returns {BaseInfo.SignInfo} SignInfo instance
         */
        SignInfo.create = function create(properties) {
            return new SignInfo(properties);
        };

        /**
         * Encodes the specified SignInfo message. Does not implicitly {@link BaseInfo.SignInfo.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.SignInfo
         * @static
         * @param {BaseInfo.ISignInfo} message SignInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SignInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.lastSignTime != null && message.hasOwnProperty("lastSignTime"))
                writer.uint32(/* id 1, wireType 0 =*/8).int64(message.lastSignTime);
            if (message.signTimes != null && message.hasOwnProperty("signTimes"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.signTimes);
            return writer;
        };

        /**
         * Encodes the specified SignInfo message, length delimited. Does not implicitly {@link BaseInfo.SignInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.SignInfo
         * @static
         * @param {BaseInfo.ISignInfo} message SignInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SignInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a SignInfo message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.SignInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.SignInfo} SignInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SignInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.SignInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.lastSignTime = reader.int64();
                    break;
                case 2:
                    message.signTimes = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a SignInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.SignInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.SignInfo} SignInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SignInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a SignInfo message.
         * @function verify
         * @memberof BaseInfo.SignInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        SignInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.lastSignTime != null && message.hasOwnProperty("lastSignTime"))
                if (!$util.isInteger(message.lastSignTime) && !(message.lastSignTime && $util.isInteger(message.lastSignTime.low) && $util.isInteger(message.lastSignTime.high)))
                    return "lastSignTime: integer|Long expected";
            if (message.signTimes != null && message.hasOwnProperty("signTimes"))
                if (!$util.isInteger(message.signTimes))
                    return "signTimes: integer expected";
            return null;
        };

        return SignInfo;
    })();

    /**
     * FetchType enum.
     * @name BaseInfo.FetchType
     * @enum {string}
     * @property {number} DIRECT=0 DIRECT value
     * @property {number} AD=1 AD value
     * @property {number} DIAMOND=2 DIAMOND value
     */
    BaseInfo.FetchType = (function() {
        var valuesById = {}, values = Object.create(valuesById);
        values[valuesById[0] = "DIRECT"] = 0;
        values[valuesById[1] = "AD"] = 1;
        values[valuesById[2] = "DIAMOND"] = 2;
        return values;
    })();

    BaseInfo.PetHomeStatus = (function() {

        /**
         * Properties of a PetHomeStatus.
         * @memberof BaseInfo
         * @interface IPetHomeStatus
         * @property {boolean|null} [inHome] PetHomeStatus inHome
         * @property {number|Long|null} [homeTime] PetHomeStatus homeTime
         */

        /**
         * Constructs a new PetHomeStatus.
         * @memberof BaseInfo
         * @classdesc Represents a PetHomeStatus.
         * @implements IPetHomeStatus
         * @constructor
         * @param {BaseInfo.IPetHomeStatus=} [properties] Properties to set
         */
        function PetHomeStatus(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PetHomeStatus inHome.
         * @member {boolean} inHome
         * @memberof BaseInfo.PetHomeStatus
         * @instance
         */
        PetHomeStatus.prototype.inHome = false;

        /**
         * PetHomeStatus homeTime.
         * @member {number|Long} homeTime
         * @memberof BaseInfo.PetHomeStatus
         * @instance
         */
        PetHomeStatus.prototype.homeTime = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new PetHomeStatus instance using the specified properties.
         * @function create
         * @memberof BaseInfo.PetHomeStatus
         * @static
         * @param {BaseInfo.IPetHomeStatus=} [properties] Properties to set
         * @returns {BaseInfo.PetHomeStatus} PetHomeStatus instance
         */
        PetHomeStatus.create = function create(properties) {
            return new PetHomeStatus(properties);
        };

        /**
         * Encodes the specified PetHomeStatus message. Does not implicitly {@link BaseInfo.PetHomeStatus.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.PetHomeStatus
         * @static
         * @param {BaseInfo.IPetHomeStatus} message PetHomeStatus message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PetHomeStatus.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.inHome != null && message.hasOwnProperty("inHome"))
                writer.uint32(/* id 1, wireType 0 =*/8).bool(message.inHome);
            if (message.homeTime != null && message.hasOwnProperty("homeTime"))
                writer.uint32(/* id 2, wireType 0 =*/16).int64(message.homeTime);
            return writer;
        };

        /**
         * Encodes the specified PetHomeStatus message, length delimited. Does not implicitly {@link BaseInfo.PetHomeStatus.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.PetHomeStatus
         * @static
         * @param {BaseInfo.IPetHomeStatus} message PetHomeStatus message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PetHomeStatus.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PetHomeStatus message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.PetHomeStatus
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.PetHomeStatus} PetHomeStatus
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PetHomeStatus.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.PetHomeStatus();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.inHome = reader.bool();
                    break;
                case 2:
                    message.homeTime = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PetHomeStatus message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.PetHomeStatus
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.PetHomeStatus} PetHomeStatus
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PetHomeStatus.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PetHomeStatus message.
         * @function verify
         * @memberof BaseInfo.PetHomeStatus
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PetHomeStatus.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.inHome != null && message.hasOwnProperty("inHome"))
                if (typeof message.inHome !== "boolean")
                    return "inHome: boolean expected";
            if (message.homeTime != null && message.hasOwnProperty("homeTime"))
                if (!$util.isInteger(message.homeTime) && !(message.homeTime && $util.isInteger(message.homeTime.low) && $util.isInteger(message.homeTime.high)))
                    return "homeTime: integer|Long expected";
            return null;
        };

        return PetHomeStatus;
    })();

    BaseInfo.Entrusts = (function() {

        /**
         * Properties of an Entrusts.
         * @memberof BaseInfo
         * @interface IEntrusts
         * @property {Object.<string,BaseInfo.IEntrust>|null} [entrustMap] Entrusts entrustMap
         */

        /**
         * Constructs a new Entrusts.
         * @memberof BaseInfo
         * @classdesc Represents an Entrusts.
         * @implements IEntrusts
         * @constructor
         * @param {BaseInfo.IEntrusts=} [properties] Properties to set
         */
        function Entrusts(properties) {
            this.entrustMap = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Entrusts entrustMap.
         * @member {Object.<string,BaseInfo.IEntrust>} entrustMap
         * @memberof BaseInfo.Entrusts
         * @instance
         */
        Entrusts.prototype.entrustMap = $util.emptyObject;

        /**
         * Creates a new Entrusts instance using the specified properties.
         * @function create
         * @memberof BaseInfo.Entrusts
         * @static
         * @param {BaseInfo.IEntrusts=} [properties] Properties to set
         * @returns {BaseInfo.Entrusts} Entrusts instance
         */
        Entrusts.create = function create(properties) {
            return new Entrusts(properties);
        };

        /**
         * Encodes the specified Entrusts message. Does not implicitly {@link BaseInfo.Entrusts.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.Entrusts
         * @static
         * @param {BaseInfo.IEntrusts} message Entrusts message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Entrusts.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.entrustMap != null && message.hasOwnProperty("entrustMap"))
                for (var keys = Object.keys(message.entrustMap), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Entrust.encode(message.entrustMap[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified Entrusts message, length delimited. Does not implicitly {@link BaseInfo.Entrusts.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.Entrusts
         * @static
         * @param {BaseInfo.IEntrusts} message Entrusts message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Entrusts.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an Entrusts message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.Entrusts
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.Entrusts} Entrusts
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Entrusts.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.Entrusts(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.entrustMap === $util.emptyObject)
                        message.entrustMap = {};
                    key = reader.string();
                    reader.pos++;
                    message.entrustMap[key] = $root.BaseInfo.Entrust.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an Entrusts message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.Entrusts
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.Entrusts} Entrusts
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Entrusts.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an Entrusts message.
         * @function verify
         * @memberof BaseInfo.Entrusts
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Entrusts.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.entrustMap != null && message.hasOwnProperty("entrustMap")) {
                if (!$util.isObject(message.entrustMap))
                    return "entrustMap: object expected";
                var key = Object.keys(message.entrustMap);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Entrust.verify(message.entrustMap[key[i]]);
                    if (error)
                        return "entrustMap." + error;
                }
            }
            return null;
        };

        return Entrusts;
    })();

    BaseInfo.Entrust = (function() {

        /**
         * Properties of an Entrust.
         * @memberof BaseInfo
         * @interface IEntrust
         * @property {string|null} [id] Entrust id
         * @property {Array.<BaseInfo.IEntrustCompoundCondition>|null} [conditions] Entrust conditions
         * @property {number|null} [status] Entrust status
         * @property {string|null} [listId] Entrust listId
         */

        /**
         * Constructs a new Entrust.
         * @memberof BaseInfo
         * @classdesc Represents an Entrust.
         * @implements IEntrust
         * @constructor
         * @param {BaseInfo.IEntrust=} [properties] Properties to set
         */
        function Entrust(properties) {
            this.conditions = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Entrust id.
         * @member {string} id
         * @memberof BaseInfo.Entrust
         * @instance
         */
        Entrust.prototype.id = "";

        /**
         * Entrust conditions.
         * @member {Array.<BaseInfo.IEntrustCompoundCondition>} conditions
         * @memberof BaseInfo.Entrust
         * @instance
         */
        Entrust.prototype.conditions = $util.emptyArray;

        /**
         * Entrust status.
         * @member {number} status
         * @memberof BaseInfo.Entrust
         * @instance
         */
        Entrust.prototype.status = 0;

        /**
         * Entrust listId.
         * @member {string} listId
         * @memberof BaseInfo.Entrust
         * @instance
         */
        Entrust.prototype.listId = "";

        /**
         * Creates a new Entrust instance using the specified properties.
         * @function create
         * @memberof BaseInfo.Entrust
         * @static
         * @param {BaseInfo.IEntrust=} [properties] Properties to set
         * @returns {BaseInfo.Entrust} Entrust instance
         */
        Entrust.create = function create(properties) {
            return new Entrust(properties);
        };

        /**
         * Encodes the specified Entrust message. Does not implicitly {@link BaseInfo.Entrust.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.Entrust
         * @static
         * @param {BaseInfo.IEntrust} message Entrust message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Entrust.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.id != null && message.hasOwnProperty("id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.id);
            if (message.conditions != null && message.conditions.length)
                for (var i = 0; i < message.conditions.length; ++i)
                    $root.BaseInfo.EntrustCompoundCondition.encode(message.conditions[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.status != null && message.hasOwnProperty("status"))
                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.status);
            if (message.listId != null && message.hasOwnProperty("listId"))
                writer.uint32(/* id 4, wireType 2 =*/34).string(message.listId);
            return writer;
        };

        /**
         * Encodes the specified Entrust message, length delimited. Does not implicitly {@link BaseInfo.Entrust.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.Entrust
         * @static
         * @param {BaseInfo.IEntrust} message Entrust message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Entrust.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an Entrust message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.Entrust
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.Entrust} Entrust
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Entrust.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.Entrust();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    if (!(message.conditions && message.conditions.length))
                        message.conditions = [];
                    message.conditions.push($root.BaseInfo.EntrustCompoundCondition.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.status = reader.int32();
                    break;
                case 4:
                    message.listId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an Entrust message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.Entrust
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.Entrust} Entrust
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Entrust.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an Entrust message.
         * @function verify
         * @memberof BaseInfo.Entrust
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Entrust.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.id != null && message.hasOwnProperty("id"))
                if (!$util.isString(message.id))
                    return "id: string expected";
            if (message.conditions != null && message.hasOwnProperty("conditions")) {
                if (!Array.isArray(message.conditions))
                    return "conditions: array expected";
                for (var i = 0; i < message.conditions.length; ++i) {
                    var error = $root.BaseInfo.EntrustCompoundCondition.verify(message.conditions[i]);
                    if (error)
                        return "conditions." + error;
                }
            }
            if (message.status != null && message.hasOwnProperty("status"))
                if (!$util.isInteger(message.status))
                    return "status: integer expected";
            if (message.listId != null && message.hasOwnProperty("listId"))
                if (!$util.isString(message.listId))
                    return "listId: string expected";
            return null;
        };

        return Entrust;
    })();

    BaseInfo.EntrustCompoundCondition = (function() {

        /**
         * Properties of an EntrustCompoundCondition.
         * @memberof BaseInfo
         * @interface IEntrustCompoundCondition
         * @property {Object.<string,BaseInfo.IEntrustValue>|null} [values] EntrustCompoundCondition values
         */

        /**
         * Constructs a new EntrustCompoundCondition.
         * @memberof BaseInfo
         * @classdesc Represents an EntrustCompoundCondition.
         * @implements IEntrustCompoundCondition
         * @constructor
         * @param {BaseInfo.IEntrustCompoundCondition=} [properties] Properties to set
         */
        function EntrustCompoundCondition(properties) {
            this.values = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * EntrustCompoundCondition values.
         * @member {Object.<string,BaseInfo.IEntrustValue>} values
         * @memberof BaseInfo.EntrustCompoundCondition
         * @instance
         */
        EntrustCompoundCondition.prototype.values = $util.emptyObject;

        /**
         * Creates a new EntrustCompoundCondition instance using the specified properties.
         * @function create
         * @memberof BaseInfo.EntrustCompoundCondition
         * @static
         * @param {BaseInfo.IEntrustCompoundCondition=} [properties] Properties to set
         * @returns {BaseInfo.EntrustCompoundCondition} EntrustCompoundCondition instance
         */
        EntrustCompoundCondition.create = function create(properties) {
            return new EntrustCompoundCondition(properties);
        };

        /**
         * Encodes the specified EntrustCompoundCondition message. Does not implicitly {@link BaseInfo.EntrustCompoundCondition.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.EntrustCompoundCondition
         * @static
         * @param {BaseInfo.IEntrustCompoundCondition} message EntrustCompoundCondition message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        EntrustCompoundCondition.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.values != null && message.hasOwnProperty("values"))
                for (var keys = Object.keys(message.values), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.EntrustValue.encode(message.values[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified EntrustCompoundCondition message, length delimited. Does not implicitly {@link BaseInfo.EntrustCompoundCondition.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.EntrustCompoundCondition
         * @static
         * @param {BaseInfo.IEntrustCompoundCondition} message EntrustCompoundCondition message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        EntrustCompoundCondition.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an EntrustCompoundCondition message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.EntrustCompoundCondition
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.EntrustCompoundCondition} EntrustCompoundCondition
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        EntrustCompoundCondition.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.EntrustCompoundCondition(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.values === $util.emptyObject)
                        message.values = {};
                    key = reader.string();
                    reader.pos++;
                    message.values[key] = $root.BaseInfo.EntrustValue.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an EntrustCompoundCondition message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.EntrustCompoundCondition
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.EntrustCompoundCondition} EntrustCompoundCondition
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        EntrustCompoundCondition.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an EntrustCompoundCondition message.
         * @function verify
         * @memberof BaseInfo.EntrustCompoundCondition
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        EntrustCompoundCondition.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.values != null && message.hasOwnProperty("values")) {
                if (!$util.isObject(message.values))
                    return "values: object expected";
                var key = Object.keys(message.values);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.EntrustValue.verify(message.values[key[i]]);
                    if (error)
                        return "values." + error;
                }
            }
            return null;
        };

        return EntrustCompoundCondition;
    })();

    BaseInfo.EntrustValue = (function() {

        /**
         * Properties of an EntrustValue.
         * @memberof BaseInfo
         * @interface IEntrustValue
         * @property {number|Long|null} [current] EntrustValue current
         * @property {number|Long|null} [target] EntrustValue target
         * @property {string|null} [eventType] EntrustValue eventType
         */

        /**
         * Constructs a new EntrustValue.
         * @memberof BaseInfo
         * @classdesc Represents an EntrustValue.
         * @implements IEntrustValue
         * @constructor
         * @param {BaseInfo.IEntrustValue=} [properties] Properties to set
         */
        function EntrustValue(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * EntrustValue current.
         * @member {number|Long} current
         * @memberof BaseInfo.EntrustValue
         * @instance
         */
        EntrustValue.prototype.current = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * EntrustValue target.
         * @member {number|Long} target
         * @memberof BaseInfo.EntrustValue
         * @instance
         */
        EntrustValue.prototype.target = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * EntrustValue eventType.
         * @member {string} eventType
         * @memberof BaseInfo.EntrustValue
         * @instance
         */
        EntrustValue.prototype.eventType = "";

        /**
         * Creates a new EntrustValue instance using the specified properties.
         * @function create
         * @memberof BaseInfo.EntrustValue
         * @static
         * @param {BaseInfo.IEntrustValue=} [properties] Properties to set
         * @returns {BaseInfo.EntrustValue} EntrustValue instance
         */
        EntrustValue.create = function create(properties) {
            return new EntrustValue(properties);
        };

        /**
         * Encodes the specified EntrustValue message. Does not implicitly {@link BaseInfo.EntrustValue.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.EntrustValue
         * @static
         * @param {BaseInfo.IEntrustValue} message EntrustValue message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        EntrustValue.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.current != null && message.hasOwnProperty("current"))
                writer.uint32(/* id 1, wireType 0 =*/8).int64(message.current);
            if (message.target != null && message.hasOwnProperty("target"))
                writer.uint32(/* id 2, wireType 0 =*/16).int64(message.target);
            if (message.eventType != null && message.hasOwnProperty("eventType"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.eventType);
            return writer;
        };

        /**
         * Encodes the specified EntrustValue message, length delimited. Does not implicitly {@link BaseInfo.EntrustValue.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.EntrustValue
         * @static
         * @param {BaseInfo.IEntrustValue} message EntrustValue message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        EntrustValue.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an EntrustValue message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.EntrustValue
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.EntrustValue} EntrustValue
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        EntrustValue.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.EntrustValue();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.current = reader.int64();
                    break;
                case 2:
                    message.target = reader.int64();
                    break;
                case 3:
                    message.eventType = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an EntrustValue message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.EntrustValue
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.EntrustValue} EntrustValue
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        EntrustValue.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an EntrustValue message.
         * @function verify
         * @memberof BaseInfo.EntrustValue
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        EntrustValue.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.current != null && message.hasOwnProperty("current"))
                if (!$util.isInteger(message.current) && !(message.current && $util.isInteger(message.current.low) && $util.isInteger(message.current.high)))
                    return "current: integer|Long expected";
            if (message.target != null && message.hasOwnProperty("target"))
                if (!$util.isInteger(message.target) && !(message.target && $util.isInteger(message.target.low) && $util.isInteger(message.target.high)))
                    return "target: integer|Long expected";
            if (message.eventType != null && message.hasOwnProperty("eventType"))
                if (!$util.isString(message.eventType))
                    return "eventType: string expected";
            return null;
        };

        return EntrustValue;
    })();

    BaseInfo.MiniGame = (function() {

        /**
         * Properties of a MiniGame.
         * @memberof BaseInfo
         * @interface IMiniGame
         * @property {string|null} [gameId] MiniGame gameId
         * @property {string|null} [listId] MiniGame listId
         * @property {Object.<string,number|Long>|null} [restEventTimes] MiniGame restEventTimes
         */

        /**
         * Constructs a new MiniGame.
         * @memberof BaseInfo
         * @classdesc Represents a MiniGame.
         * @implements IMiniGame
         * @constructor
         * @param {BaseInfo.IMiniGame=} [properties] Properties to set
         */
        function MiniGame(properties) {
            this.restEventTimes = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * MiniGame gameId.
         * @member {string} gameId
         * @memberof BaseInfo.MiniGame
         * @instance
         */
        MiniGame.prototype.gameId = "";

        /**
         * MiniGame listId.
         * @member {string} listId
         * @memberof BaseInfo.MiniGame
         * @instance
         */
        MiniGame.prototype.listId = "";

        /**
         * MiniGame restEventTimes.
         * @member {Object.<string,number|Long>} restEventTimes
         * @memberof BaseInfo.MiniGame
         * @instance
         */
        MiniGame.prototype.restEventTimes = $util.emptyObject;

        /**
         * Creates a new MiniGame instance using the specified properties.
         * @function create
         * @memberof BaseInfo.MiniGame
         * @static
         * @param {BaseInfo.IMiniGame=} [properties] Properties to set
         * @returns {BaseInfo.MiniGame} MiniGame instance
         */
        MiniGame.create = function create(properties) {
            return new MiniGame(properties);
        };

        /**
         * Encodes the specified MiniGame message. Does not implicitly {@link BaseInfo.MiniGame.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.MiniGame
         * @static
         * @param {BaseInfo.IMiniGame} message MiniGame message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        MiniGame.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.gameId != null && message.hasOwnProperty("gameId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.gameId);
            if (message.listId != null && message.hasOwnProperty("listId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.listId);
            if (message.restEventTimes != null && message.hasOwnProperty("restEventTimes"))
                for (var keys = Object.keys(message.restEventTimes), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 3, wireType 2 =*/26).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 0 =*/16).int64(message.restEventTimes[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified MiniGame message, length delimited. Does not implicitly {@link BaseInfo.MiniGame.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.MiniGame
         * @static
         * @param {BaseInfo.IMiniGame} message MiniGame message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        MiniGame.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a MiniGame message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.MiniGame
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.MiniGame} MiniGame
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        MiniGame.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.MiniGame(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.gameId = reader.string();
                    break;
                case 2:
                    message.listId = reader.string();
                    break;
                case 3:
                    reader.skip().pos++;
                    if (message.restEventTimes === $util.emptyObject)
                        message.restEventTimes = {};
                    key = reader.string();
                    reader.pos++;
                    message.restEventTimes[key] = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a MiniGame message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.MiniGame
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.MiniGame} MiniGame
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        MiniGame.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a MiniGame message.
         * @function verify
         * @memberof BaseInfo.MiniGame
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        MiniGame.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.gameId != null && message.hasOwnProperty("gameId"))
                if (!$util.isString(message.gameId))
                    return "gameId: string expected";
            if (message.listId != null && message.hasOwnProperty("listId"))
                if (!$util.isString(message.listId))
                    return "listId: string expected";
            if (message.restEventTimes != null && message.hasOwnProperty("restEventTimes")) {
                if (!$util.isObject(message.restEventTimes))
                    return "restEventTimes: object expected";
                var key = Object.keys(message.restEventTimes);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isInteger(message.restEventTimes[key[i]]) && !(message.restEventTimes[key[i]] && $util.isInteger(message.restEventTimes[key[i]].low) && $util.isInteger(message.restEventTimes[key[i]].high)))
                        return "restEventTimes: integer|Long{k:string} expected";
            }
            return null;
        };

        return MiniGame;
    })();

    BaseInfo.AdRewardsInfo = (function() {

        /**
         * Properties of an AdRewardsInfo.
         * @memberof BaseInfo
         * @interface IAdRewardsInfo
         * @property {number|null} [makeUpTimes] AdRewardsInfo makeUpTimes
         * @property {number|null} [taskRewardTimes] AdRewardsInfo taskRewardTimes
         */

        /**
         * Constructs a new AdRewardsInfo.
         * @memberof BaseInfo
         * @classdesc Represents an AdRewardsInfo.
         * @implements IAdRewardsInfo
         * @constructor
         * @param {BaseInfo.IAdRewardsInfo=} [properties] Properties to set
         */
        function AdRewardsInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AdRewardsInfo makeUpTimes.
         * @member {number} makeUpTimes
         * @memberof BaseInfo.AdRewardsInfo
         * @instance
         */
        AdRewardsInfo.prototype.makeUpTimes = 0;

        /**
         * AdRewardsInfo taskRewardTimes.
         * @member {number} taskRewardTimes
         * @memberof BaseInfo.AdRewardsInfo
         * @instance
         */
        AdRewardsInfo.prototype.taskRewardTimes = 0;

        /**
         * Creates a new AdRewardsInfo instance using the specified properties.
         * @function create
         * @memberof BaseInfo.AdRewardsInfo
         * @static
         * @param {BaseInfo.IAdRewardsInfo=} [properties] Properties to set
         * @returns {BaseInfo.AdRewardsInfo} AdRewardsInfo instance
         */
        AdRewardsInfo.create = function create(properties) {
            return new AdRewardsInfo(properties);
        };

        /**
         * Encodes the specified AdRewardsInfo message. Does not implicitly {@link BaseInfo.AdRewardsInfo.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.AdRewardsInfo
         * @static
         * @param {BaseInfo.IAdRewardsInfo} message AdRewardsInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdRewardsInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.makeUpTimes != null && message.hasOwnProperty("makeUpTimes"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.makeUpTimes);
            if (message.taskRewardTimes != null && message.hasOwnProperty("taskRewardTimes"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.taskRewardTimes);
            return writer;
        };

        /**
         * Encodes the specified AdRewardsInfo message, length delimited. Does not implicitly {@link BaseInfo.AdRewardsInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.AdRewardsInfo
         * @static
         * @param {BaseInfo.IAdRewardsInfo} message AdRewardsInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdRewardsInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AdRewardsInfo message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.AdRewardsInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.AdRewardsInfo} AdRewardsInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdRewardsInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.AdRewardsInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.makeUpTimes = reader.int32();
                    break;
                case 2:
                    message.taskRewardTimes = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AdRewardsInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.AdRewardsInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.AdRewardsInfo} AdRewardsInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdRewardsInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AdRewardsInfo message.
         * @function verify
         * @memberof BaseInfo.AdRewardsInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AdRewardsInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.makeUpTimes != null && message.hasOwnProperty("makeUpTimes"))
                if (!$util.isInteger(message.makeUpTimes))
                    return "makeUpTimes: integer expected";
            if (message.taskRewardTimes != null && message.hasOwnProperty("taskRewardTimes"))
                if (!$util.isInteger(message.taskRewardTimes))
                    return "taskRewardTimes: integer expected";
            return null;
        };

        return AdRewardsInfo;
    })();

    BaseInfo.NauticalProjectGroup = (function() {

        /**
         * Properties of a NauticalProjectGroup.
         * @memberof BaseInfo
         * @interface INauticalProjectGroup
         * @property {Object.<string,string>|null} [group] NauticalProjectGroup group
         */

        /**
         * Constructs a new NauticalProjectGroup.
         * @memberof BaseInfo
         * @classdesc Represents a NauticalProjectGroup.
         * @implements INauticalProjectGroup
         * @constructor
         * @param {BaseInfo.INauticalProjectGroup=} [properties] Properties to set
         */
        function NauticalProjectGroup(properties) {
            this.group = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * NauticalProjectGroup group.
         * @member {Object.<string,string>} group
         * @memberof BaseInfo.NauticalProjectGroup
         * @instance
         */
        NauticalProjectGroup.prototype.group = $util.emptyObject;

        /**
         * Creates a new NauticalProjectGroup instance using the specified properties.
         * @function create
         * @memberof BaseInfo.NauticalProjectGroup
         * @static
         * @param {BaseInfo.INauticalProjectGroup=} [properties] Properties to set
         * @returns {BaseInfo.NauticalProjectGroup} NauticalProjectGroup instance
         */
        NauticalProjectGroup.create = function create(properties) {
            return new NauticalProjectGroup(properties);
        };

        /**
         * Encodes the specified NauticalProjectGroup message. Does not implicitly {@link BaseInfo.NauticalProjectGroup.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.NauticalProjectGroup
         * @static
         * @param {BaseInfo.INauticalProjectGroup} message NauticalProjectGroup message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        NauticalProjectGroup.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.group != null && message.hasOwnProperty("group"))
                for (var keys = Object.keys(message.group), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.group[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified NauticalProjectGroup message, length delimited. Does not implicitly {@link BaseInfo.NauticalProjectGroup.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.NauticalProjectGroup
         * @static
         * @param {BaseInfo.INauticalProjectGroup} message NauticalProjectGroup message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        NauticalProjectGroup.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a NauticalProjectGroup message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.NauticalProjectGroup
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.NauticalProjectGroup} NauticalProjectGroup
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        NauticalProjectGroup.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.NauticalProjectGroup(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.group === $util.emptyObject)
                        message.group = {};
                    key = reader.string();
                    reader.pos++;
                    message.group[key] = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a NauticalProjectGroup message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.NauticalProjectGroup
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.NauticalProjectGroup} NauticalProjectGroup
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        NauticalProjectGroup.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a NauticalProjectGroup message.
         * @function verify
         * @memberof BaseInfo.NauticalProjectGroup
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        NauticalProjectGroup.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.group != null && message.hasOwnProperty("group")) {
                if (!$util.isObject(message.group))
                    return "group: object expected";
                var key = Object.keys(message.group);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.group[key[i]]))
                        return "group: string{k:string} expected";
            }
            return null;
        };

        return NauticalProjectGroup;
    })();

    BaseInfo.WharfLetterBox = (function() {

        /**
         * Properties of a WharfLetterBox.
         * @memberof BaseInfo
         * @interface IWharfLetterBox
         * @property {number|Long|null} [fishToReward] WharfLetterBox fishToReward
         * @property {number|Long|null} [capacity] WharfLetterBox capacity
         * @property {number|Long|null} [shareFishToReward] WharfLetterBox shareFishToReward
         * @property {number|Long|null} [shellToReward] WharfLetterBox shellToReward
         * @property {number|Long|null} [shareShellToReward] WharfLetterBox shareShellToReward
         */

        /**
         * Constructs a new WharfLetterBox.
         * @memberof BaseInfo
         * @classdesc Represents a WharfLetterBox.
         * @implements IWharfLetterBox
         * @constructor
         * @param {BaseInfo.IWharfLetterBox=} [properties] Properties to set
         */
        function WharfLetterBox(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * WharfLetterBox fishToReward.
         * @member {number|Long} fishToReward
         * @memberof BaseInfo.WharfLetterBox
         * @instance
         */
        WharfLetterBox.prototype.fishToReward = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * WharfLetterBox capacity.
         * @member {number|Long} capacity
         * @memberof BaseInfo.WharfLetterBox
         * @instance
         */
        WharfLetterBox.prototype.capacity = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * WharfLetterBox shareFishToReward.
         * @member {number|Long} shareFishToReward
         * @memberof BaseInfo.WharfLetterBox
         * @instance
         */
        WharfLetterBox.prototype.shareFishToReward = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * WharfLetterBox shellToReward.
         * @member {number|Long} shellToReward
         * @memberof BaseInfo.WharfLetterBox
         * @instance
         */
        WharfLetterBox.prototype.shellToReward = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * WharfLetterBox shareShellToReward.
         * @member {number|Long} shareShellToReward
         * @memberof BaseInfo.WharfLetterBox
         * @instance
         */
        WharfLetterBox.prototype.shareShellToReward = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new WharfLetterBox instance using the specified properties.
         * @function create
         * @memberof BaseInfo.WharfLetterBox
         * @static
         * @param {BaseInfo.IWharfLetterBox=} [properties] Properties to set
         * @returns {BaseInfo.WharfLetterBox} WharfLetterBox instance
         */
        WharfLetterBox.create = function create(properties) {
            return new WharfLetterBox(properties);
        };

        /**
         * Encodes the specified WharfLetterBox message. Does not implicitly {@link BaseInfo.WharfLetterBox.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.WharfLetterBox
         * @static
         * @param {BaseInfo.IWharfLetterBox} message WharfLetterBox message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        WharfLetterBox.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.fishToReward != null && message.hasOwnProperty("fishToReward"))
                writer.uint32(/* id 1, wireType 0 =*/8).int64(message.fishToReward);
            if (message.capacity != null && message.hasOwnProperty("capacity"))
                writer.uint32(/* id 2, wireType 0 =*/16).int64(message.capacity);
            if (message.shareFishToReward != null && message.hasOwnProperty("shareFishToReward"))
                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.shareFishToReward);
            if (message.shellToReward != null && message.hasOwnProperty("shellToReward"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.shellToReward);
            if (message.shareShellToReward != null && message.hasOwnProperty("shareShellToReward"))
                writer.uint32(/* id 5, wireType 0 =*/40).int64(message.shareShellToReward);
            return writer;
        };

        /**
         * Encodes the specified WharfLetterBox message, length delimited. Does not implicitly {@link BaseInfo.WharfLetterBox.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.WharfLetterBox
         * @static
         * @param {BaseInfo.IWharfLetterBox} message WharfLetterBox message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        WharfLetterBox.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a WharfLetterBox message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.WharfLetterBox
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.WharfLetterBox} WharfLetterBox
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        WharfLetterBox.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.WharfLetterBox();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.fishToReward = reader.int64();
                    break;
                case 2:
                    message.capacity = reader.int64();
                    break;
                case 3:
                    message.shareFishToReward = reader.int64();
                    break;
                case 4:
                    message.shellToReward = reader.int64();
                    break;
                case 5:
                    message.shareShellToReward = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a WharfLetterBox message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.WharfLetterBox
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.WharfLetterBox} WharfLetterBox
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        WharfLetterBox.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a WharfLetterBox message.
         * @function verify
         * @memberof BaseInfo.WharfLetterBox
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        WharfLetterBox.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.fishToReward != null && message.hasOwnProperty("fishToReward"))
                if (!$util.isInteger(message.fishToReward) && !(message.fishToReward && $util.isInteger(message.fishToReward.low) && $util.isInteger(message.fishToReward.high)))
                    return "fishToReward: integer|Long expected";
            if (message.capacity != null && message.hasOwnProperty("capacity"))
                if (!$util.isInteger(message.capacity) && !(message.capacity && $util.isInteger(message.capacity.low) && $util.isInteger(message.capacity.high)))
                    return "capacity: integer|Long expected";
            if (message.shareFishToReward != null && message.hasOwnProperty("shareFishToReward"))
                if (!$util.isInteger(message.shareFishToReward) && !(message.shareFishToReward && $util.isInteger(message.shareFishToReward.low) && $util.isInteger(message.shareFishToReward.high)))
                    return "shareFishToReward: integer|Long expected";
            if (message.shellToReward != null && message.hasOwnProperty("shellToReward"))
                if (!$util.isInteger(message.shellToReward) && !(message.shellToReward && $util.isInteger(message.shellToReward.low) && $util.isInteger(message.shellToReward.high)))
                    return "shellToReward: integer|Long expected";
            if (message.shareShellToReward != null && message.hasOwnProperty("shareShellToReward"))
                if (!$util.isInteger(message.shareShellToReward) && !(message.shareShellToReward && $util.isInteger(message.shareShellToReward.low) && $util.isInteger(message.shareShellToReward.high)))
                    return "shareShellToReward: integer|Long expected";
            return null;
        };

        return WharfLetterBox;
    })();

    BaseInfo.AidedGroupInfo = (function() {

        /**
         * Properties of an AidedGroupInfo.
         * @memberof BaseInfo
         * @interface IAidedGroupInfo
         * @property {Object.<string,BaseInfo.IAidedInfo>|null} [aidedInfoGroup] AidedGroupInfo aidedInfoGroup
         * @property {number|null} [aidedFinishNum] AidedGroupInfo aidedFinishNum
         * @property {BaseInfo.IAidInfo|null} [aidInfo] AidedGroupInfo aidInfo
         * @property {BaseInfo.ISlogan|null} [slogan] AidedGroupInfo slogan
         */

        /**
         * Constructs a new AidedGroupInfo.
         * @memberof BaseInfo
         * @classdesc Represents an AidedGroupInfo.
         * @implements IAidedGroupInfo
         * @constructor
         * @param {BaseInfo.IAidedGroupInfo=} [properties] Properties to set
         */
        function AidedGroupInfo(properties) {
            this.aidedInfoGroup = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AidedGroupInfo aidedInfoGroup.
         * @member {Object.<string,BaseInfo.IAidedInfo>} aidedInfoGroup
         * @memberof BaseInfo.AidedGroupInfo
         * @instance
         */
        AidedGroupInfo.prototype.aidedInfoGroup = $util.emptyObject;

        /**
         * AidedGroupInfo aidedFinishNum.
         * @member {number} aidedFinishNum
         * @memberof BaseInfo.AidedGroupInfo
         * @instance
         */
        AidedGroupInfo.prototype.aidedFinishNum = 0;

        /**
         * AidedGroupInfo aidInfo.
         * @member {BaseInfo.IAidInfo|null|undefined} aidInfo
         * @memberof BaseInfo.AidedGroupInfo
         * @instance
         */
        AidedGroupInfo.prototype.aidInfo = null;

        /**
         * AidedGroupInfo slogan.
         * @member {BaseInfo.ISlogan|null|undefined} slogan
         * @memberof BaseInfo.AidedGroupInfo
         * @instance
         */
        AidedGroupInfo.prototype.slogan = null;

        /**
         * Creates a new AidedGroupInfo instance using the specified properties.
         * @function create
         * @memberof BaseInfo.AidedGroupInfo
         * @static
         * @param {BaseInfo.IAidedGroupInfo=} [properties] Properties to set
         * @returns {BaseInfo.AidedGroupInfo} AidedGroupInfo instance
         */
        AidedGroupInfo.create = function create(properties) {
            return new AidedGroupInfo(properties);
        };

        /**
         * Encodes the specified AidedGroupInfo message. Does not implicitly {@link BaseInfo.AidedGroupInfo.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.AidedGroupInfo
         * @static
         * @param {BaseInfo.IAidedGroupInfo} message AidedGroupInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AidedGroupInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.aidedInfoGroup != null && message.hasOwnProperty("aidedInfoGroup"))
                for (var keys = Object.keys(message.aidedInfoGroup), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.AidedInfo.encode(message.aidedInfoGroup[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            if (message.aidedFinishNum != null && message.hasOwnProperty("aidedFinishNum"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.aidedFinishNum);
            if (message.aidInfo != null && message.hasOwnProperty("aidInfo"))
                $root.BaseInfo.AidInfo.encode(message.aidInfo, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.slogan != null && message.hasOwnProperty("slogan"))
                $root.BaseInfo.Slogan.encode(message.slogan, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified AidedGroupInfo message, length delimited. Does not implicitly {@link BaseInfo.AidedGroupInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.AidedGroupInfo
         * @static
         * @param {BaseInfo.IAidedGroupInfo} message AidedGroupInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AidedGroupInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AidedGroupInfo message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.AidedGroupInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.AidedGroupInfo} AidedGroupInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AidedGroupInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.AidedGroupInfo(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.aidedInfoGroup === $util.emptyObject)
                        message.aidedInfoGroup = {};
                    key = reader.string();
                    reader.pos++;
                    message.aidedInfoGroup[key] = $root.BaseInfo.AidedInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.aidedFinishNum = reader.int32();
                    break;
                case 3:
                    message.aidInfo = $root.BaseInfo.AidInfo.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.slogan = $root.BaseInfo.Slogan.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AidedGroupInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.AidedGroupInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.AidedGroupInfo} AidedGroupInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AidedGroupInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AidedGroupInfo message.
         * @function verify
         * @memberof BaseInfo.AidedGroupInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AidedGroupInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.aidedInfoGroup != null && message.hasOwnProperty("aidedInfoGroup")) {
                if (!$util.isObject(message.aidedInfoGroup))
                    return "aidedInfoGroup: object expected";
                var key = Object.keys(message.aidedInfoGroup);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.AidedInfo.verify(message.aidedInfoGroup[key[i]]);
                    if (error)
                        return "aidedInfoGroup." + error;
                }
            }
            if (message.aidedFinishNum != null && message.hasOwnProperty("aidedFinishNum"))
                if (!$util.isInteger(message.aidedFinishNum))
                    return "aidedFinishNum: integer expected";
            if (message.aidInfo != null && message.hasOwnProperty("aidInfo")) {
                var error = $root.BaseInfo.AidInfo.verify(message.aidInfo);
                if (error)
                    return "aidInfo." + error;
            }
            if (message.slogan != null && message.hasOwnProperty("slogan")) {
                var error = $root.BaseInfo.Slogan.verify(message.slogan);
                if (error)
                    return "slogan." + error;
            }
            return null;
        };

        return AidedGroupInfo;
    })();

    BaseInfo.AidedInfo = (function() {

        /**
         * Properties of an AidedInfo.
         * @memberof BaseInfo
         * @interface IAidedInfo
         * @property {string|null} [rid] AidedInfo rid
         * @property {string|null} [openId] AidedInfo openId
         * @property {number|Long|null} [endTimeStamp] AidedInfo endTimeStamp
         */

        /**
         * Constructs a new AidedInfo.
         * @memberof BaseInfo
         * @classdesc Represents an AidedInfo.
         * @implements IAidedInfo
         * @constructor
         * @param {BaseInfo.IAidedInfo=} [properties] Properties to set
         */
        function AidedInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AidedInfo rid.
         * @member {string} rid
         * @memberof BaseInfo.AidedInfo
         * @instance
         */
        AidedInfo.prototype.rid = "";

        /**
         * AidedInfo openId.
         * @member {string} openId
         * @memberof BaseInfo.AidedInfo
         * @instance
         */
        AidedInfo.prototype.openId = "";

        /**
         * AidedInfo endTimeStamp.
         * @member {number|Long} endTimeStamp
         * @memberof BaseInfo.AidedInfo
         * @instance
         */
        AidedInfo.prototype.endTimeStamp = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new AidedInfo instance using the specified properties.
         * @function create
         * @memberof BaseInfo.AidedInfo
         * @static
         * @param {BaseInfo.IAidedInfo=} [properties] Properties to set
         * @returns {BaseInfo.AidedInfo} AidedInfo instance
         */
        AidedInfo.create = function create(properties) {
            return new AidedInfo(properties);
        };

        /**
         * Encodes the specified AidedInfo message. Does not implicitly {@link BaseInfo.AidedInfo.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.AidedInfo
         * @static
         * @param {BaseInfo.IAidedInfo} message AidedInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AidedInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.rid != null && message.hasOwnProperty("rid"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.rid);
            if (message.openId != null && message.hasOwnProperty("openId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.openId);
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.endTimeStamp);
            return writer;
        };

        /**
         * Encodes the specified AidedInfo message, length delimited. Does not implicitly {@link BaseInfo.AidedInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.AidedInfo
         * @static
         * @param {BaseInfo.IAidedInfo} message AidedInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AidedInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AidedInfo message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.AidedInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.AidedInfo} AidedInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AidedInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.AidedInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.rid = reader.string();
                    break;
                case 2:
                    message.openId = reader.string();
                    break;
                case 4:
                    message.endTimeStamp = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AidedInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.AidedInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.AidedInfo} AidedInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AidedInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AidedInfo message.
         * @function verify
         * @memberof BaseInfo.AidedInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AidedInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.rid != null && message.hasOwnProperty("rid"))
                if (!$util.isString(message.rid))
                    return "rid: string expected";
            if (message.openId != null && message.hasOwnProperty("openId"))
                if (!$util.isString(message.openId))
                    return "openId: string expected";
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp"))
                if (!$util.isInteger(message.endTimeStamp) && !(message.endTimeStamp && $util.isInteger(message.endTimeStamp.low) && $util.isInteger(message.endTimeStamp.high)))
                    return "endTimeStamp: integer|Long expected";
            return null;
        };

        return AidedInfo;
    })();

    BaseInfo.AidInfo = (function() {

        /**
         * Properties of an AidInfo.
         * @memberof BaseInfo
         * @interface IAidInfo
         * @property {string|null} [rid] AidInfo rid
         * @property {string|null} [openId] AidInfo openId
         * @property {number|Long|null} [endTimeStamp] AidInfo endTimeStamp
         * @property {boolean|null} [hasReceive] AidInfo hasReceive
         * @property {number|null} [aidTimes] AidInfo aidTimes
         */

        /**
         * Constructs a new AidInfo.
         * @memberof BaseInfo
         * @classdesc Represents an AidInfo.
         * @implements IAidInfo
         * @constructor
         * @param {BaseInfo.IAidInfo=} [properties] Properties to set
         */
        function AidInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AidInfo rid.
         * @member {string} rid
         * @memberof BaseInfo.AidInfo
         * @instance
         */
        AidInfo.prototype.rid = "";

        /**
         * AidInfo openId.
         * @member {string} openId
         * @memberof BaseInfo.AidInfo
         * @instance
         */
        AidInfo.prototype.openId = "";

        /**
         * AidInfo endTimeStamp.
         * @member {number|Long} endTimeStamp
         * @memberof BaseInfo.AidInfo
         * @instance
         */
        AidInfo.prototype.endTimeStamp = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * AidInfo hasReceive.
         * @member {boolean} hasReceive
         * @memberof BaseInfo.AidInfo
         * @instance
         */
        AidInfo.prototype.hasReceive = false;

        /**
         * AidInfo aidTimes.
         * @member {number} aidTimes
         * @memberof BaseInfo.AidInfo
         * @instance
         */
        AidInfo.prototype.aidTimes = 0;

        /**
         * Creates a new AidInfo instance using the specified properties.
         * @function create
         * @memberof BaseInfo.AidInfo
         * @static
         * @param {BaseInfo.IAidInfo=} [properties] Properties to set
         * @returns {BaseInfo.AidInfo} AidInfo instance
         */
        AidInfo.create = function create(properties) {
            return new AidInfo(properties);
        };

        /**
         * Encodes the specified AidInfo message. Does not implicitly {@link BaseInfo.AidInfo.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.AidInfo
         * @static
         * @param {BaseInfo.IAidInfo} message AidInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AidInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.rid != null && message.hasOwnProperty("rid"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.rid);
            if (message.openId != null && message.hasOwnProperty("openId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.openId);
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.endTimeStamp);
            if (message.hasReceive != null && message.hasOwnProperty("hasReceive"))
                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.hasReceive);
            if (message.aidTimes != null && message.hasOwnProperty("aidTimes"))
                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.aidTimes);
            return writer;
        };

        /**
         * Encodes the specified AidInfo message, length delimited. Does not implicitly {@link BaseInfo.AidInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.AidInfo
         * @static
         * @param {BaseInfo.IAidInfo} message AidInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AidInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AidInfo message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.AidInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.AidInfo} AidInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AidInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.AidInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.rid = reader.string();
                    break;
                case 2:
                    message.openId = reader.string();
                    break;
                case 4:
                    message.endTimeStamp = reader.int64();
                    break;
                case 5:
                    message.hasReceive = reader.bool();
                    break;
                case 6:
                    message.aidTimes = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AidInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.AidInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.AidInfo} AidInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AidInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AidInfo message.
         * @function verify
         * @memberof BaseInfo.AidInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AidInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.rid != null && message.hasOwnProperty("rid"))
                if (!$util.isString(message.rid))
                    return "rid: string expected";
            if (message.openId != null && message.hasOwnProperty("openId"))
                if (!$util.isString(message.openId))
                    return "openId: string expected";
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp"))
                if (!$util.isInteger(message.endTimeStamp) && !(message.endTimeStamp && $util.isInteger(message.endTimeStamp.low) && $util.isInteger(message.endTimeStamp.high)))
                    return "endTimeStamp: integer|Long expected";
            if (message.hasReceive != null && message.hasOwnProperty("hasReceive"))
                if (typeof message.hasReceive !== "boolean")
                    return "hasReceive: boolean expected";
            if (message.aidTimes != null && message.hasOwnProperty("aidTimes"))
                if (!$util.isInteger(message.aidTimes))
                    return "aidTimes: integer expected";
            return null;
        };

        return AidInfo;
    })();

    BaseInfo.Slogan = (function() {

        /**
         * Properties of a Slogan.
         * @memberof BaseInfo
         * @interface ISlogan
         * @property {number|null} [type] Slogan type
         * @property {string|null} [rid] Slogan rid
         * @property {string|null} [openId] Slogan openId
         * @property {number|Long|null} [shell] Slogan shell
         */

        /**
         * Constructs a new Slogan.
         * @memberof BaseInfo
         * @classdesc Represents a Slogan.
         * @implements ISlogan
         * @constructor
         * @param {BaseInfo.ISlogan=} [properties] Properties to set
         */
        function Slogan(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Slogan type.
         * @member {number} type
         * @memberof BaseInfo.Slogan
         * @instance
         */
        Slogan.prototype.type = 0;

        /**
         * Slogan rid.
         * @member {string} rid
         * @memberof BaseInfo.Slogan
         * @instance
         */
        Slogan.prototype.rid = "";

        /**
         * Slogan openId.
         * @member {string} openId
         * @memberof BaseInfo.Slogan
         * @instance
         */
        Slogan.prototype.openId = "";

        /**
         * Slogan shell.
         * @member {number|Long} shell
         * @memberof BaseInfo.Slogan
         * @instance
         */
        Slogan.prototype.shell = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new Slogan instance using the specified properties.
         * @function create
         * @memberof BaseInfo.Slogan
         * @static
         * @param {BaseInfo.ISlogan=} [properties] Properties to set
         * @returns {BaseInfo.Slogan} Slogan instance
         */
        Slogan.create = function create(properties) {
            return new Slogan(properties);
        };

        /**
         * Encodes the specified Slogan message. Does not implicitly {@link BaseInfo.Slogan.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.Slogan
         * @static
         * @param {BaseInfo.ISlogan} message Slogan message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Slogan.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
            if (message.rid != null && message.hasOwnProperty("rid"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.rid);
            if (message.openId != null && message.hasOwnProperty("openId"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.openId);
            if (message.shell != null && message.hasOwnProperty("shell"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.shell);
            return writer;
        };

        /**
         * Encodes the specified Slogan message, length delimited. Does not implicitly {@link BaseInfo.Slogan.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.Slogan
         * @static
         * @param {BaseInfo.ISlogan} message Slogan message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Slogan.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Slogan message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.Slogan
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.Slogan} Slogan
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Slogan.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.Slogan();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.type = reader.int32();
                    break;
                case 2:
                    message.rid = reader.string();
                    break;
                case 3:
                    message.openId = reader.string();
                    break;
                case 4:
                    message.shell = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Slogan message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.Slogan
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.Slogan} Slogan
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Slogan.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Slogan message.
         * @function verify
         * @memberof BaseInfo.Slogan
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Slogan.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isInteger(message.type))
                    return "type: integer expected";
            if (message.rid != null && message.hasOwnProperty("rid"))
                if (!$util.isString(message.rid))
                    return "rid: string expected";
            if (message.openId != null && message.hasOwnProperty("openId"))
                if (!$util.isString(message.openId))
                    return "openId: string expected";
            if (message.shell != null && message.hasOwnProperty("shell"))
                if (!$util.isInteger(message.shell) && !(message.shell && $util.isInteger(message.shell.low) && $util.isInteger(message.shell.high)))
                    return "shell: integer|Long expected";
            return null;
        };

        return Slogan;
    })();

    BaseInfo.LuckyDraw = (function() {

        /**
         * Properties of a LuckyDraw.
         * @memberof BaseInfo
         * @interface ILuckyDraw
         * @property {boolean|null} [freeDraw] LuckyDraw freeDraw
         * @property {number|null} [adDrawTimes] LuckyDraw adDrawTimes
         * @property {number|Long|null} [diamondAmount] LuckyDraw diamondAmount
         */

        /**
         * Constructs a new LuckyDraw.
         * @memberof BaseInfo
         * @classdesc Represents a LuckyDraw.
         * @implements ILuckyDraw
         * @constructor
         * @param {BaseInfo.ILuckyDraw=} [properties] Properties to set
         */
        function LuckyDraw(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * LuckyDraw freeDraw.
         * @member {boolean} freeDraw
         * @memberof BaseInfo.LuckyDraw
         * @instance
         */
        LuckyDraw.prototype.freeDraw = false;

        /**
         * LuckyDraw adDrawTimes.
         * @member {number} adDrawTimes
         * @memberof BaseInfo.LuckyDraw
         * @instance
         */
        LuckyDraw.prototype.adDrawTimes = 0;

        /**
         * LuckyDraw diamondAmount.
         * @member {number|Long} diamondAmount
         * @memberof BaseInfo.LuckyDraw
         * @instance
         */
        LuckyDraw.prototype.diamondAmount = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new LuckyDraw instance using the specified properties.
         * @function create
         * @memberof BaseInfo.LuckyDraw
         * @static
         * @param {BaseInfo.ILuckyDraw=} [properties] Properties to set
         * @returns {BaseInfo.LuckyDraw} LuckyDraw instance
         */
        LuckyDraw.create = function create(properties) {
            return new LuckyDraw(properties);
        };

        /**
         * Encodes the specified LuckyDraw message. Does not implicitly {@link BaseInfo.LuckyDraw.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.LuckyDraw
         * @static
         * @param {BaseInfo.ILuckyDraw} message LuckyDraw message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LuckyDraw.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.freeDraw != null && message.hasOwnProperty("freeDraw"))
                writer.uint32(/* id 1, wireType 0 =*/8).bool(message.freeDraw);
            if (message.adDrawTimes != null && message.hasOwnProperty("adDrawTimes"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.adDrawTimes);
            if (message.diamondAmount != null && message.hasOwnProperty("diamondAmount"))
                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.diamondAmount);
            return writer;
        };

        /**
         * Encodes the specified LuckyDraw message, length delimited. Does not implicitly {@link BaseInfo.LuckyDraw.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.LuckyDraw
         * @static
         * @param {BaseInfo.ILuckyDraw} message LuckyDraw message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LuckyDraw.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a LuckyDraw message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.LuckyDraw
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.LuckyDraw} LuckyDraw
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LuckyDraw.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.LuckyDraw();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.freeDraw = reader.bool();
                    break;
                case 2:
                    message.adDrawTimes = reader.int32();
                    break;
                case 3:
                    message.diamondAmount = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a LuckyDraw message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.LuckyDraw
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.LuckyDraw} LuckyDraw
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LuckyDraw.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a LuckyDraw message.
         * @function verify
         * @memberof BaseInfo.LuckyDraw
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        LuckyDraw.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.freeDraw != null && message.hasOwnProperty("freeDraw"))
                if (typeof message.freeDraw !== "boolean")
                    return "freeDraw: boolean expected";
            if (message.adDrawTimes != null && message.hasOwnProperty("adDrawTimes"))
                if (!$util.isInteger(message.adDrawTimes))
                    return "adDrawTimes: integer expected";
            if (message.diamondAmount != null && message.hasOwnProperty("diamondAmount"))
                if (!$util.isInteger(message.diamondAmount) && !(message.diamondAmount && $util.isInteger(message.diamondAmount.low) && $util.isInteger(message.diamondAmount.high)))
                    return "diamondAmount: integer|Long expected";
            return null;
        };

        return LuckyDraw;
    })();

    BaseInfo.LevelToy = (function() {

        /**
         * Properties of a LevelToy.
         * @memberof BaseInfo
         * @interface ILevelToy
         * @property {string|null} [toyId] LevelToy toyId
         * @property {number|null} [level] LevelToy level
         * @property {number|null} [exp] LevelToy exp
         */

        /**
         * Constructs a new LevelToy.
         * @memberof BaseInfo
         * @classdesc Represents a LevelToy.
         * @implements ILevelToy
         * @constructor
         * @param {BaseInfo.ILevelToy=} [properties] Properties to set
         */
        function LevelToy(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * LevelToy toyId.
         * @member {string} toyId
         * @memberof BaseInfo.LevelToy
         * @instance
         */
        LevelToy.prototype.toyId = "";

        /**
         * LevelToy level.
         * @member {number} level
         * @memberof BaseInfo.LevelToy
         * @instance
         */
        LevelToy.prototype.level = 0;

        /**
         * LevelToy exp.
         * @member {number} exp
         * @memberof BaseInfo.LevelToy
         * @instance
         */
        LevelToy.prototype.exp = 0;

        /**
         * Creates a new LevelToy instance using the specified properties.
         * @function create
         * @memberof BaseInfo.LevelToy
         * @static
         * @param {BaseInfo.ILevelToy=} [properties] Properties to set
         * @returns {BaseInfo.LevelToy} LevelToy instance
         */
        LevelToy.create = function create(properties) {
            return new LevelToy(properties);
        };

        /**
         * Encodes the specified LevelToy message. Does not implicitly {@link BaseInfo.LevelToy.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.LevelToy
         * @static
         * @param {BaseInfo.ILevelToy} message LevelToy message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LevelToy.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.toyId != null && message.hasOwnProperty("toyId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.toyId);
            if (message.level != null && message.hasOwnProperty("level"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.level);
            if (message.exp != null && message.hasOwnProperty("exp"))
                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.exp);
            return writer;
        };

        /**
         * Encodes the specified LevelToy message, length delimited. Does not implicitly {@link BaseInfo.LevelToy.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.LevelToy
         * @static
         * @param {BaseInfo.ILevelToy} message LevelToy message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LevelToy.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a LevelToy message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.LevelToy
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.LevelToy} LevelToy
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LevelToy.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.LevelToy();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.toyId = reader.string();
                    break;
                case 2:
                    message.level = reader.int32();
                    break;
                case 3:
                    message.exp = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a LevelToy message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.LevelToy
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.LevelToy} LevelToy
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LevelToy.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a LevelToy message.
         * @function verify
         * @memberof BaseInfo.LevelToy
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        LevelToy.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.toyId != null && message.hasOwnProperty("toyId"))
                if (!$util.isString(message.toyId))
                    return "toyId: string expected";
            if (message.level != null && message.hasOwnProperty("level"))
                if (!$util.isInteger(message.level))
                    return "level: integer expected";
            if (message.exp != null && message.hasOwnProperty("exp"))
                if (!$util.isInteger(message.exp))
                    return "exp: integer expected";
            return null;
        };

        return LevelToy;
    })();

    BaseInfo.PayInfo = (function() {

        /**
         * Properties of a PayInfo.
         * @memberof BaseInfo
         * @interface IPayInfo
         * @property {Array.<string>|null} [firstPay] PayInfo firstPay
         * @property {BaseInfo.IPayCardInfo|null} [payCardInfo] PayInfo payCardInfo
         * @property {number|Long|null} [freeDiamondReceiveMills] PayInfo freeDiamondReceiveMills
         */

        /**
         * Constructs a new PayInfo.
         * @memberof BaseInfo
         * @classdesc Represents a PayInfo.
         * @implements IPayInfo
         * @constructor
         * @param {BaseInfo.IPayInfo=} [properties] Properties to set
         */
        function PayInfo(properties) {
            this.firstPay = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PayInfo firstPay.
         * @member {Array.<string>} firstPay
         * @memberof BaseInfo.PayInfo
         * @instance
         */
        PayInfo.prototype.firstPay = $util.emptyArray;

        /**
         * PayInfo payCardInfo.
         * @member {BaseInfo.IPayCardInfo|null|undefined} payCardInfo
         * @memberof BaseInfo.PayInfo
         * @instance
         */
        PayInfo.prototype.payCardInfo = null;

        /**
         * PayInfo freeDiamondReceiveMills.
         * @member {number|Long} freeDiamondReceiveMills
         * @memberof BaseInfo.PayInfo
         * @instance
         */
        PayInfo.prototype.freeDiamondReceiveMills = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new PayInfo instance using the specified properties.
         * @function create
         * @memberof BaseInfo.PayInfo
         * @static
         * @param {BaseInfo.IPayInfo=} [properties] Properties to set
         * @returns {BaseInfo.PayInfo} PayInfo instance
         */
        PayInfo.create = function create(properties) {
            return new PayInfo(properties);
        };

        /**
         * Encodes the specified PayInfo message. Does not implicitly {@link BaseInfo.PayInfo.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.PayInfo
         * @static
         * @param {BaseInfo.IPayInfo} message PayInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PayInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.firstPay != null && message.firstPay.length)
                for (var i = 0; i < message.firstPay.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.firstPay[i]);
            if (message.payCardInfo != null && message.hasOwnProperty("payCardInfo"))
                $root.BaseInfo.PayCardInfo.encode(message.payCardInfo, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.freeDiamondReceiveMills != null && message.hasOwnProperty("freeDiamondReceiveMills"))
                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.freeDiamondReceiveMills);
            return writer;
        };

        /**
         * Encodes the specified PayInfo message, length delimited. Does not implicitly {@link BaseInfo.PayInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.PayInfo
         * @static
         * @param {BaseInfo.IPayInfo} message PayInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PayInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PayInfo message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.PayInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.PayInfo} PayInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PayInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.PayInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.firstPay && message.firstPay.length))
                        message.firstPay = [];
                    message.firstPay.push(reader.string());
                    break;
                case 2:
                    message.payCardInfo = $root.BaseInfo.PayCardInfo.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.freeDiamondReceiveMills = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PayInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.PayInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.PayInfo} PayInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PayInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PayInfo message.
         * @function verify
         * @memberof BaseInfo.PayInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PayInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.firstPay != null && message.hasOwnProperty("firstPay")) {
                if (!Array.isArray(message.firstPay))
                    return "firstPay: array expected";
                for (var i = 0; i < message.firstPay.length; ++i)
                    if (!$util.isString(message.firstPay[i]))
                        return "firstPay: string[] expected";
            }
            if (message.payCardInfo != null && message.hasOwnProperty("payCardInfo")) {
                var error = $root.BaseInfo.PayCardInfo.verify(message.payCardInfo);
                if (error)
                    return "payCardInfo." + error;
            }
            if (message.freeDiamondReceiveMills != null && message.hasOwnProperty("freeDiamondReceiveMills"))
                if (!$util.isInteger(message.freeDiamondReceiveMills) && !(message.freeDiamondReceiveMills && $util.isInteger(message.freeDiamondReceiveMills.low) && $util.isInteger(message.freeDiamondReceiveMills.high)))
                    return "freeDiamondReceiveMills: integer|Long expected";
            return null;
        };

        return PayInfo;
    })();

    BaseInfo.PayCardInfo = (function() {

        /**
         * Properties of a PayCardInfo.
         * @memberof BaseInfo
         * @interface IPayCardInfo
         * @property {number|Long|null} [weekCardEndMills] PayCardInfo weekCardEndMills
         * @property {number|Long|null} [weekCardReceiveMills] PayCardInfo weekCardReceiveMills
         * @property {number|Long|null} [monthCardEndMills] PayCardInfo monthCardEndMills
         * @property {number|Long|null} [monthCardReceiveMills] PayCardInfo monthCardReceiveMills
         */

        /**
         * Constructs a new PayCardInfo.
         * @memberof BaseInfo
         * @classdesc Represents a PayCardInfo.
         * @implements IPayCardInfo
         * @constructor
         * @param {BaseInfo.IPayCardInfo=} [properties] Properties to set
         */
        function PayCardInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PayCardInfo weekCardEndMills.
         * @member {number|Long} weekCardEndMills
         * @memberof BaseInfo.PayCardInfo
         * @instance
         */
        PayCardInfo.prototype.weekCardEndMills = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * PayCardInfo weekCardReceiveMills.
         * @member {number|Long} weekCardReceiveMills
         * @memberof BaseInfo.PayCardInfo
         * @instance
         */
        PayCardInfo.prototype.weekCardReceiveMills = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * PayCardInfo monthCardEndMills.
         * @member {number|Long} monthCardEndMills
         * @memberof BaseInfo.PayCardInfo
         * @instance
         */
        PayCardInfo.prototype.monthCardEndMills = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * PayCardInfo monthCardReceiveMills.
         * @member {number|Long} monthCardReceiveMills
         * @memberof BaseInfo.PayCardInfo
         * @instance
         */
        PayCardInfo.prototype.monthCardReceiveMills = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new PayCardInfo instance using the specified properties.
         * @function create
         * @memberof BaseInfo.PayCardInfo
         * @static
         * @param {BaseInfo.IPayCardInfo=} [properties] Properties to set
         * @returns {BaseInfo.PayCardInfo} PayCardInfo instance
         */
        PayCardInfo.create = function create(properties) {
            return new PayCardInfo(properties);
        };

        /**
         * Encodes the specified PayCardInfo message. Does not implicitly {@link BaseInfo.PayCardInfo.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.PayCardInfo
         * @static
         * @param {BaseInfo.IPayCardInfo} message PayCardInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PayCardInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.weekCardEndMills != null && message.hasOwnProperty("weekCardEndMills"))
                writer.uint32(/* id 1, wireType 0 =*/8).int64(message.weekCardEndMills);
            if (message.weekCardReceiveMills != null && message.hasOwnProperty("weekCardReceiveMills"))
                writer.uint32(/* id 2, wireType 0 =*/16).int64(message.weekCardReceiveMills);
            if (message.monthCardEndMills != null && message.hasOwnProperty("monthCardEndMills"))
                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.monthCardEndMills);
            if (message.monthCardReceiveMills != null && message.hasOwnProperty("monthCardReceiveMills"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.monthCardReceiveMills);
            return writer;
        };

        /**
         * Encodes the specified PayCardInfo message, length delimited. Does not implicitly {@link BaseInfo.PayCardInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.PayCardInfo
         * @static
         * @param {BaseInfo.IPayCardInfo} message PayCardInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PayCardInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PayCardInfo message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.PayCardInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.PayCardInfo} PayCardInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PayCardInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.PayCardInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.weekCardEndMills = reader.int64();
                    break;
                case 2:
                    message.weekCardReceiveMills = reader.int64();
                    break;
                case 3:
                    message.monthCardEndMills = reader.int64();
                    break;
                case 4:
                    message.monthCardReceiveMills = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PayCardInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.PayCardInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.PayCardInfo} PayCardInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PayCardInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PayCardInfo message.
         * @function verify
         * @memberof BaseInfo.PayCardInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PayCardInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.weekCardEndMills != null && message.hasOwnProperty("weekCardEndMills"))
                if (!$util.isInteger(message.weekCardEndMills) && !(message.weekCardEndMills && $util.isInteger(message.weekCardEndMills.low) && $util.isInteger(message.weekCardEndMills.high)))
                    return "weekCardEndMills: integer|Long expected";
            if (message.weekCardReceiveMills != null && message.hasOwnProperty("weekCardReceiveMills"))
                if (!$util.isInteger(message.weekCardReceiveMills) && !(message.weekCardReceiveMills && $util.isInteger(message.weekCardReceiveMills.low) && $util.isInteger(message.weekCardReceiveMills.high)))
                    return "weekCardReceiveMills: integer|Long expected";
            if (message.monthCardEndMills != null && message.hasOwnProperty("monthCardEndMills"))
                if (!$util.isInteger(message.monthCardEndMills) && !(message.monthCardEndMills && $util.isInteger(message.monthCardEndMills.low) && $util.isInteger(message.monthCardEndMills.high)))
                    return "monthCardEndMills: integer|Long expected";
            if (message.monthCardReceiveMills != null && message.hasOwnProperty("monthCardReceiveMills"))
                if (!$util.isInteger(message.monthCardReceiveMills) && !(message.monthCardReceiveMills && $util.isInteger(message.monthCardReceiveMills.low) && $util.isInteger(message.monthCardReceiveMills.high)))
                    return "monthCardReceiveMills: integer|Long expected";
            return null;
        };

        return PayCardInfo;
    })();

    /**
     * PayCardType enum.
     * @name BaseInfo.PayCardType
     * @enum {string}
     * @property {number} WEEK=0 WEEK value
     * @property {number} MONTH=1 MONTH value
     */
    BaseInfo.PayCardType = (function() {
        var valuesById = {}, values = Object.create(valuesById);
        values[valuesById[0] = "WEEK"] = 0;
        values[valuesById[1] = "MONTH"] = 1;
        return values;
    })();

    BaseInfo.PPInfo = (function() {

        /**
         * Properties of a PPInfo.
         * @memberof BaseInfo
         * @interface IPPInfo
         * @property {string|null} [gameId] PPInfo gameId
         * @property {string|null} [channelId] PPInfo channelId
         * @property {string|null} [subGameId] PPInfo subGameId
         * @property {string|null} [platformId] PPInfo platformId
         * @property {string|null} [buildVersion] PPInfo buildVersion
         * @property {string|null} [devId] PPInfo devId
         * @property {string|null} [deviceType] PPInfo deviceType
         * @property {string|null} [os] PPInfo os
         * @property {string|null} [source] PPInfo source
         * @property {string|null} [apiKey] PPInfo apiKey
         */

        /**
         * Constructs a new PPInfo.
         * @memberof BaseInfo
         * @classdesc Represents a PPInfo.
         * @implements IPPInfo
         * @constructor
         * @param {BaseInfo.IPPInfo=} [properties] Properties to set
         */
        function PPInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PPInfo gameId.
         * @member {string} gameId
         * @memberof BaseInfo.PPInfo
         * @instance
         */
        PPInfo.prototype.gameId = "";

        /**
         * PPInfo channelId.
         * @member {string} channelId
         * @memberof BaseInfo.PPInfo
         * @instance
         */
        PPInfo.prototype.channelId = "";

        /**
         * PPInfo subGameId.
         * @member {string} subGameId
         * @memberof BaseInfo.PPInfo
         * @instance
         */
        PPInfo.prototype.subGameId = "";

        /**
         * PPInfo platformId.
         * @member {string} platformId
         * @memberof BaseInfo.PPInfo
         * @instance
         */
        PPInfo.prototype.platformId = "";

        /**
         * PPInfo buildVersion.
         * @member {string} buildVersion
         * @memberof BaseInfo.PPInfo
         * @instance
         */
        PPInfo.prototype.buildVersion = "";

        /**
         * PPInfo devId.
         * @member {string} devId
         * @memberof BaseInfo.PPInfo
         * @instance
         */
        PPInfo.prototype.devId = "";

        /**
         * PPInfo deviceType.
         * @member {string} deviceType
         * @memberof BaseInfo.PPInfo
         * @instance
         */
        PPInfo.prototype.deviceType = "";

        /**
         * PPInfo os.
         * @member {string} os
         * @memberof BaseInfo.PPInfo
         * @instance
         */
        PPInfo.prototype.os = "";

        /**
         * PPInfo source.
         * @member {string} source
         * @memberof BaseInfo.PPInfo
         * @instance
         */
        PPInfo.prototype.source = "";

        /**
         * PPInfo apiKey.
         * @member {string} apiKey
         * @memberof BaseInfo.PPInfo
         * @instance
         */
        PPInfo.prototype.apiKey = "";

        /**
         * Creates a new PPInfo instance using the specified properties.
         * @function create
         * @memberof BaseInfo.PPInfo
         * @static
         * @param {BaseInfo.IPPInfo=} [properties] Properties to set
         * @returns {BaseInfo.PPInfo} PPInfo instance
         */
        PPInfo.create = function create(properties) {
            return new PPInfo(properties);
        };

        /**
         * Encodes the specified PPInfo message. Does not implicitly {@link BaseInfo.PPInfo.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.PPInfo
         * @static
         * @param {BaseInfo.IPPInfo} message PPInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PPInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.gameId != null && message.hasOwnProperty("gameId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.gameId);
            if (message.channelId != null && message.hasOwnProperty("channelId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.channelId);
            if (message.subGameId != null && message.hasOwnProperty("subGameId"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.subGameId);
            if (message.platformId != null && message.hasOwnProperty("platformId"))
                writer.uint32(/* id 4, wireType 2 =*/34).string(message.platformId);
            if (message.buildVersion != null && message.hasOwnProperty("buildVersion"))
                writer.uint32(/* id 5, wireType 2 =*/42).string(message.buildVersion);
            if (message.devId != null && message.hasOwnProperty("devId"))
                writer.uint32(/* id 6, wireType 2 =*/50).string(message.devId);
            if (message.deviceType != null && message.hasOwnProperty("deviceType"))
                writer.uint32(/* id 7, wireType 2 =*/58).string(message.deviceType);
            if (message.os != null && message.hasOwnProperty("os"))
                writer.uint32(/* id 8, wireType 2 =*/66).string(message.os);
            if (message.source != null && message.hasOwnProperty("source"))
                writer.uint32(/* id 9, wireType 2 =*/74).string(message.source);
            if (message.apiKey != null && message.hasOwnProperty("apiKey"))
                writer.uint32(/* id 10, wireType 2 =*/82).string(message.apiKey);
            return writer;
        };

        /**
         * Encodes the specified PPInfo message, length delimited. Does not implicitly {@link BaseInfo.PPInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.PPInfo
         * @static
         * @param {BaseInfo.IPPInfo} message PPInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PPInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PPInfo message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.PPInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.PPInfo} PPInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PPInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.PPInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.gameId = reader.string();
                    break;
                case 2:
                    message.channelId = reader.string();
                    break;
                case 3:
                    message.subGameId = reader.string();
                    break;
                case 4:
                    message.platformId = reader.string();
                    break;
                case 5:
                    message.buildVersion = reader.string();
                    break;
                case 6:
                    message.devId = reader.string();
                    break;
                case 7:
                    message.deviceType = reader.string();
                    break;
                case 8:
                    message.os = reader.string();
                    break;
                case 9:
                    message.source = reader.string();
                    break;
                case 10:
                    message.apiKey = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PPInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.PPInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.PPInfo} PPInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PPInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PPInfo message.
         * @function verify
         * @memberof BaseInfo.PPInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PPInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.gameId != null && message.hasOwnProperty("gameId"))
                if (!$util.isString(message.gameId))
                    return "gameId: string expected";
            if (message.channelId != null && message.hasOwnProperty("channelId"))
                if (!$util.isString(message.channelId))
                    return "channelId: string expected";
            if (message.subGameId != null && message.hasOwnProperty("subGameId"))
                if (!$util.isString(message.subGameId))
                    return "subGameId: string expected";
            if (message.platformId != null && message.hasOwnProperty("platformId"))
                if (!$util.isString(message.platformId))
                    return "platformId: string expected";
            if (message.buildVersion != null && message.hasOwnProperty("buildVersion"))
                if (!$util.isString(message.buildVersion))
                    return "buildVersion: string expected";
            if (message.devId != null && message.hasOwnProperty("devId"))
                if (!$util.isString(message.devId))
                    return "devId: string expected";
            if (message.deviceType != null && message.hasOwnProperty("deviceType"))
                if (!$util.isString(message.deviceType))
                    return "deviceType: string expected";
            if (message.os != null && message.hasOwnProperty("os"))
                if (!$util.isString(message.os))
                    return "os: string expected";
            if (message.source != null && message.hasOwnProperty("source"))
                if (!$util.isString(message.source))
                    return "source: string expected";
            if (message.apiKey != null && message.hasOwnProperty("apiKey"))
                if (!$util.isString(message.apiKey))
                    return "apiKey: string expected";
            return null;
        };

        return PPInfo;
    })();

    BaseInfo.Delivery = (function() {

        /**
         * Properties of a Delivery.
         * @memberof BaseInfo
         * @interface IDelivery
         * @property {number|Long|null} [rewardAmount] Delivery rewardAmount
         * @property {number|Long|null} [endTs] Delivery endTs
         * @property {boolean|null} [receive] Delivery receive
         * @property {Array.<string>|null} [pets] Delivery pets
         * @property {string|null} [tag] Delivery tag
         */

        /**
         * Constructs a new Delivery.
         * @memberof BaseInfo
         * @classdesc Represents a Delivery.
         * @implements IDelivery
         * @constructor
         * @param {BaseInfo.IDelivery=} [properties] Properties to set
         */
        function Delivery(properties) {
            this.pets = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Delivery rewardAmount.
         * @member {number|Long} rewardAmount
         * @memberof BaseInfo.Delivery
         * @instance
         */
        Delivery.prototype.rewardAmount = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Delivery endTs.
         * @member {number|Long} endTs
         * @memberof BaseInfo.Delivery
         * @instance
         */
        Delivery.prototype.endTs = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Delivery receive.
         * @member {boolean} receive
         * @memberof BaseInfo.Delivery
         * @instance
         */
        Delivery.prototype.receive = false;

        /**
         * Delivery pets.
         * @member {Array.<string>} pets
         * @memberof BaseInfo.Delivery
         * @instance
         */
        Delivery.prototype.pets = $util.emptyArray;

        /**
         * Delivery tag.
         * @member {string} tag
         * @memberof BaseInfo.Delivery
         * @instance
         */
        Delivery.prototype.tag = "";

        /**
         * Creates a new Delivery instance using the specified properties.
         * @function create
         * @memberof BaseInfo.Delivery
         * @static
         * @param {BaseInfo.IDelivery=} [properties] Properties to set
         * @returns {BaseInfo.Delivery} Delivery instance
         */
        Delivery.create = function create(properties) {
            return new Delivery(properties);
        };

        /**
         * Encodes the specified Delivery message. Does not implicitly {@link BaseInfo.Delivery.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.Delivery
         * @static
         * @param {BaseInfo.IDelivery} message Delivery message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Delivery.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.rewardAmount != null && message.hasOwnProperty("rewardAmount"))
                writer.uint32(/* id 1, wireType 0 =*/8).int64(message.rewardAmount);
            if (message.endTs != null && message.hasOwnProperty("endTs"))
                writer.uint32(/* id 2, wireType 0 =*/16).int64(message.endTs);
            if (message.receive != null && message.hasOwnProperty("receive"))
                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.receive);
            if (message.pets != null && message.pets.length)
                for (var i = 0; i < message.pets.length; ++i)
                    writer.uint32(/* id 4, wireType 2 =*/34).string(message.pets[i]);
            if (message.tag != null && message.hasOwnProperty("tag"))
                writer.uint32(/* id 5, wireType 2 =*/42).string(message.tag);
            return writer;
        };

        /**
         * Encodes the specified Delivery message, length delimited. Does not implicitly {@link BaseInfo.Delivery.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.Delivery
         * @static
         * @param {BaseInfo.IDelivery} message Delivery message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Delivery.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Delivery message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.Delivery
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.Delivery} Delivery
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Delivery.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.Delivery();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.rewardAmount = reader.int64();
                    break;
                case 2:
                    message.endTs = reader.int64();
                    break;
                case 3:
                    message.receive = reader.bool();
                    break;
                case 4:
                    if (!(message.pets && message.pets.length))
                        message.pets = [];
                    message.pets.push(reader.string());
                    break;
                case 5:
                    message.tag = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Delivery message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.Delivery
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.Delivery} Delivery
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Delivery.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Delivery message.
         * @function verify
         * @memberof BaseInfo.Delivery
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Delivery.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.rewardAmount != null && message.hasOwnProperty("rewardAmount"))
                if (!$util.isInteger(message.rewardAmount) && !(message.rewardAmount && $util.isInteger(message.rewardAmount.low) && $util.isInteger(message.rewardAmount.high)))
                    return "rewardAmount: integer|Long expected";
            if (message.endTs != null && message.hasOwnProperty("endTs"))
                if (!$util.isInteger(message.endTs) && !(message.endTs && $util.isInteger(message.endTs.low) && $util.isInteger(message.endTs.high)))
                    return "endTs: integer|Long expected";
            if (message.receive != null && message.hasOwnProperty("receive"))
                if (typeof message.receive !== "boolean")
                    return "receive: boolean expected";
            if (message.pets != null && message.hasOwnProperty("pets")) {
                if (!Array.isArray(message.pets))
                    return "pets: array expected";
                for (var i = 0; i < message.pets.length; ++i)
                    if (!$util.isString(message.pets[i]))
                        return "pets: string[] expected";
            }
            if (message.tag != null && message.hasOwnProperty("tag"))
                if (!$util.isString(message.tag))
                    return "tag: string expected";
            return null;
        };

        return Delivery;
    })();

    BaseInfo.TakeoutOrder = (function() {

        /**
         * Properties of a TakeoutOrder.
         * @memberof BaseInfo
         * @interface ITakeoutOrder
         * @property {number|null} [order] TakeoutOrder order
         * @property {number|null} [progress] TakeoutOrder progress
         * @property {number|null} [speed] TakeoutOrder speed
         * @property {number|Long|null} [lastUpdateTs] TakeoutOrder lastUpdateTs
         * @property {Array.<string>|null} [pets] TakeoutOrder pets
         * @property {number|null} [boughtTimes] TakeoutOrder boughtTimes
         */

        /**
         * Constructs a new TakeoutOrder.
         * @memberof BaseInfo
         * @classdesc Represents a TakeoutOrder.
         * @implements ITakeoutOrder
         * @constructor
         * @param {BaseInfo.ITakeoutOrder=} [properties] Properties to set
         */
        function TakeoutOrder(properties) {
            this.pets = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * TakeoutOrder order.
         * @member {number} order
         * @memberof BaseInfo.TakeoutOrder
         * @instance
         */
        TakeoutOrder.prototype.order = 0;

        /**
         * TakeoutOrder progress.
         * @member {number} progress
         * @memberof BaseInfo.TakeoutOrder
         * @instance
         */
        TakeoutOrder.prototype.progress = 0;

        /**
         * TakeoutOrder speed.
         * @member {number} speed
         * @memberof BaseInfo.TakeoutOrder
         * @instance
         */
        TakeoutOrder.prototype.speed = 0;

        /**
         * TakeoutOrder lastUpdateTs.
         * @member {number|Long} lastUpdateTs
         * @memberof BaseInfo.TakeoutOrder
         * @instance
         */
        TakeoutOrder.prototype.lastUpdateTs = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * TakeoutOrder pets.
         * @member {Array.<string>} pets
         * @memberof BaseInfo.TakeoutOrder
         * @instance
         */
        TakeoutOrder.prototype.pets = $util.emptyArray;

        /**
         * TakeoutOrder boughtTimes.
         * @member {number} boughtTimes
         * @memberof BaseInfo.TakeoutOrder
         * @instance
         */
        TakeoutOrder.prototype.boughtTimes = 0;

        /**
         * Creates a new TakeoutOrder instance using the specified properties.
         * @function create
         * @memberof BaseInfo.TakeoutOrder
         * @static
         * @param {BaseInfo.ITakeoutOrder=} [properties] Properties to set
         * @returns {BaseInfo.TakeoutOrder} TakeoutOrder instance
         */
        TakeoutOrder.create = function create(properties) {
            return new TakeoutOrder(properties);
        };

        /**
         * Encodes the specified TakeoutOrder message. Does not implicitly {@link BaseInfo.TakeoutOrder.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.TakeoutOrder
         * @static
         * @param {BaseInfo.ITakeoutOrder} message TakeoutOrder message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TakeoutOrder.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.order != null && message.hasOwnProperty("order"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.order);
            if (message.progress != null && message.hasOwnProperty("progress"))
                writer.uint32(/* id 2, wireType 1 =*/17).double(message.progress);
            if (message.speed != null && message.hasOwnProperty("speed"))
                writer.uint32(/* id 3, wireType 1 =*/25).double(message.speed);
            if (message.lastUpdateTs != null && message.hasOwnProperty("lastUpdateTs"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.lastUpdateTs);
            if (message.pets != null && message.pets.length)
                for (var i = 0; i < message.pets.length; ++i)
                    writer.uint32(/* id 5, wireType 2 =*/42).string(message.pets[i]);
            if (message.boughtTimes != null && message.hasOwnProperty("boughtTimes"))
                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.boughtTimes);
            return writer;
        };

        /**
         * Encodes the specified TakeoutOrder message, length delimited. Does not implicitly {@link BaseInfo.TakeoutOrder.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.TakeoutOrder
         * @static
         * @param {BaseInfo.ITakeoutOrder} message TakeoutOrder message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TakeoutOrder.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a TakeoutOrder message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.TakeoutOrder
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.TakeoutOrder} TakeoutOrder
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TakeoutOrder.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.TakeoutOrder();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.order = reader.int32();
                    break;
                case 2:
                    message.progress = reader.double();
                    break;
                case 3:
                    message.speed = reader.double();
                    break;
                case 4:
                    message.lastUpdateTs = reader.int64();
                    break;
                case 5:
                    if (!(message.pets && message.pets.length))
                        message.pets = [];
                    message.pets.push(reader.string());
                    break;
                case 6:
                    message.boughtTimes = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a TakeoutOrder message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.TakeoutOrder
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.TakeoutOrder} TakeoutOrder
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TakeoutOrder.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a TakeoutOrder message.
         * @function verify
         * @memberof BaseInfo.TakeoutOrder
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        TakeoutOrder.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.order != null && message.hasOwnProperty("order"))
                if (!$util.isInteger(message.order))
                    return "order: integer expected";
            if (message.progress != null && message.hasOwnProperty("progress"))
                if (typeof message.progress !== "number")
                    return "progress: number expected";
            if (message.speed != null && message.hasOwnProperty("speed"))
                if (typeof message.speed !== "number")
                    return "speed: number expected";
            if (message.lastUpdateTs != null && message.hasOwnProperty("lastUpdateTs"))
                if (!$util.isInteger(message.lastUpdateTs) && !(message.lastUpdateTs && $util.isInteger(message.lastUpdateTs.low) && $util.isInteger(message.lastUpdateTs.high)))
                    return "lastUpdateTs: integer|Long expected";
            if (message.pets != null && message.hasOwnProperty("pets")) {
                if (!Array.isArray(message.pets))
                    return "pets: array expected";
                for (var i = 0; i < message.pets.length; ++i)
                    if (!$util.isString(message.pets[i]))
                        return "pets: string[] expected";
            }
            if (message.boughtTimes != null && message.hasOwnProperty("boughtTimes"))
                if (!$util.isInteger(message.boughtTimes))
                    return "boughtTimes: integer expected";
            return null;
        };

        return TakeoutOrder;
    })();

    BaseInfo.TakeoutInfo = (function() {

        /**
         * Properties of a TakeoutInfo.
         * @memberof BaseInfo
         * @interface ITakeoutInfo
         * @property {number|null} [level] TakeoutInfo level
         * @property {BaseInfo.IDelivery|null} [delivery] TakeoutInfo delivery
         * @property {BaseInfo.ITakeoutOrder|null} [takeoutOrder] TakeoutInfo takeoutOrder
         */

        /**
         * Constructs a new TakeoutInfo.
         * @memberof BaseInfo
         * @classdesc Represents a TakeoutInfo.
         * @implements ITakeoutInfo
         * @constructor
         * @param {BaseInfo.ITakeoutInfo=} [properties] Properties to set
         */
        function TakeoutInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * TakeoutInfo level.
         * @member {number} level
         * @memberof BaseInfo.TakeoutInfo
         * @instance
         */
        TakeoutInfo.prototype.level = 0;

        /**
         * TakeoutInfo delivery.
         * @member {BaseInfo.IDelivery|null|undefined} delivery
         * @memberof BaseInfo.TakeoutInfo
         * @instance
         */
        TakeoutInfo.prototype.delivery = null;

        /**
         * TakeoutInfo takeoutOrder.
         * @member {BaseInfo.ITakeoutOrder|null|undefined} takeoutOrder
         * @memberof BaseInfo.TakeoutInfo
         * @instance
         */
        TakeoutInfo.prototype.takeoutOrder = null;

        /**
         * Creates a new TakeoutInfo instance using the specified properties.
         * @function create
         * @memberof BaseInfo.TakeoutInfo
         * @static
         * @param {BaseInfo.ITakeoutInfo=} [properties] Properties to set
         * @returns {BaseInfo.TakeoutInfo} TakeoutInfo instance
         */
        TakeoutInfo.create = function create(properties) {
            return new TakeoutInfo(properties);
        };

        /**
         * Encodes the specified TakeoutInfo message. Does not implicitly {@link BaseInfo.TakeoutInfo.verify|verify} messages.
         * @function encode
         * @memberof BaseInfo.TakeoutInfo
         * @static
         * @param {BaseInfo.ITakeoutInfo} message TakeoutInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TakeoutInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.level != null && message.hasOwnProperty("level"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.level);
            if (message.delivery != null && message.hasOwnProperty("delivery"))
                $root.BaseInfo.Delivery.encode(message.delivery, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.takeoutOrder != null && message.hasOwnProperty("takeoutOrder"))
                $root.BaseInfo.TakeoutOrder.encode(message.takeoutOrder, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified TakeoutInfo message, length delimited. Does not implicitly {@link BaseInfo.TakeoutInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof BaseInfo.TakeoutInfo
         * @static
         * @param {BaseInfo.ITakeoutInfo} message TakeoutInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TakeoutInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a TakeoutInfo message from the specified reader or buffer.
         * @function decode
         * @memberof BaseInfo.TakeoutInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {BaseInfo.TakeoutInfo} TakeoutInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TakeoutInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.BaseInfo.TakeoutInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.level = reader.int32();
                    break;
                case 2:
                    message.delivery = $root.BaseInfo.Delivery.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.takeoutOrder = $root.BaseInfo.TakeoutOrder.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a TakeoutInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof BaseInfo.TakeoutInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {BaseInfo.TakeoutInfo} TakeoutInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TakeoutInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a TakeoutInfo message.
         * @function verify
         * @memberof BaseInfo.TakeoutInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        TakeoutInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.level != null && message.hasOwnProperty("level"))
                if (!$util.isInteger(message.level))
                    return "level: integer expected";
            if (message.delivery != null && message.hasOwnProperty("delivery")) {
                var error = $root.BaseInfo.Delivery.verify(message.delivery);
                if (error)
                    return "delivery." + error;
            }
            if (message.takeoutOrder != null && message.hasOwnProperty("takeoutOrder")) {
                var error = $root.BaseInfo.TakeoutOrder.verify(message.takeoutOrder);
                if (error)
                    return "takeoutOrder." + error;
            }
            return null;
        };

        return TakeoutInfo;
    })();

    return BaseInfo;
})();

$root.Building = (function() {

    /**
     * Namespace Building.
     * @exports Building
     * @namespace
     */
    var Building = {};

    Building.GetAllBuildingReq = (function() {

        /**
         * Properties of a GetAllBuildingReq.
         * @memberof Building
         * @interface IGetAllBuildingReq
         */

        /**
         * Constructs a new GetAllBuildingReq.
         * @memberof Building
         * @classdesc Represents a GetAllBuildingReq.
         * @implements IGetAllBuildingReq
         * @constructor
         * @param {Building.IGetAllBuildingReq=} [properties] Properties to set
         */
        function GetAllBuildingReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetAllBuildingReq instance using the specified properties.
         * @function create
         * @memberof Building.GetAllBuildingReq
         * @static
         * @param {Building.IGetAllBuildingReq=} [properties] Properties to set
         * @returns {Building.GetAllBuildingReq} GetAllBuildingReq instance
         */
        GetAllBuildingReq.create = function create(properties) {
            return new GetAllBuildingReq(properties);
        };

        /**
         * Encodes the specified GetAllBuildingReq message. Does not implicitly {@link Building.GetAllBuildingReq.verify|verify} messages.
         * @function encode
         * @memberof Building.GetAllBuildingReq
         * @static
         * @param {Building.IGetAllBuildingReq} message GetAllBuildingReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetAllBuildingReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetAllBuildingReq message, length delimited. Does not implicitly {@link Building.GetAllBuildingReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Building.GetAllBuildingReq
         * @static
         * @param {Building.IGetAllBuildingReq} message GetAllBuildingReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetAllBuildingReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetAllBuildingReq message from the specified reader or buffer.
         * @function decode
         * @memberof Building.GetAllBuildingReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Building.GetAllBuildingReq} GetAllBuildingReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetAllBuildingReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Building.GetAllBuildingReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetAllBuildingReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Building.GetAllBuildingReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Building.GetAllBuildingReq} GetAllBuildingReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetAllBuildingReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetAllBuildingReq message.
         * @function verify
         * @memberof Building.GetAllBuildingReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetAllBuildingReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetAllBuildingReq;
    })();

    Building.GetAllBuildingRes = (function() {

        /**
         * Properties of a GetAllBuildingRes.
         * @memberof Building
         * @interface IGetAllBuildingRes
         * @property {BaseInfo.IPlayerBuilding|null} [playerBuilding] GetAllBuildingRes playerBuilding
         * @property {BaseInfo.ICurrencyBag|null} [bag] GetAllBuildingRes bag
         */

        /**
         * Constructs a new GetAllBuildingRes.
         * @memberof Building
         * @classdesc Represents a GetAllBuildingRes.
         * @implements IGetAllBuildingRes
         * @constructor
         * @param {Building.IGetAllBuildingRes=} [properties] Properties to set
         */
        function GetAllBuildingRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetAllBuildingRes playerBuilding.
         * @member {BaseInfo.IPlayerBuilding|null|undefined} playerBuilding
         * @memberof Building.GetAllBuildingRes
         * @instance
         */
        GetAllBuildingRes.prototype.playerBuilding = null;

        /**
         * GetAllBuildingRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Building.GetAllBuildingRes
         * @instance
         */
        GetAllBuildingRes.prototype.bag = null;

        /**
         * Creates a new GetAllBuildingRes instance using the specified properties.
         * @function create
         * @memberof Building.GetAllBuildingRes
         * @static
         * @param {Building.IGetAllBuildingRes=} [properties] Properties to set
         * @returns {Building.GetAllBuildingRes} GetAllBuildingRes instance
         */
        GetAllBuildingRes.create = function create(properties) {
            return new GetAllBuildingRes(properties);
        };

        /**
         * Encodes the specified GetAllBuildingRes message. Does not implicitly {@link Building.GetAllBuildingRes.verify|verify} messages.
         * @function encode
         * @memberof Building.GetAllBuildingRes
         * @static
         * @param {Building.IGetAllBuildingRes} message GetAllBuildingRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetAllBuildingRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.playerBuilding != null && message.hasOwnProperty("playerBuilding"))
                $root.BaseInfo.PlayerBuilding.encode(message.playerBuilding, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetAllBuildingRes message, length delimited. Does not implicitly {@link Building.GetAllBuildingRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Building.GetAllBuildingRes
         * @static
         * @param {Building.IGetAllBuildingRes} message GetAllBuildingRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetAllBuildingRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetAllBuildingRes message from the specified reader or buffer.
         * @function decode
         * @memberof Building.GetAllBuildingRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Building.GetAllBuildingRes} GetAllBuildingRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetAllBuildingRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Building.GetAllBuildingRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.playerBuilding = $root.BaseInfo.PlayerBuilding.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetAllBuildingRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Building.GetAllBuildingRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Building.GetAllBuildingRes} GetAllBuildingRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetAllBuildingRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetAllBuildingRes message.
         * @function verify
         * @memberof Building.GetAllBuildingRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetAllBuildingRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.playerBuilding != null && message.hasOwnProperty("playerBuilding")) {
                var error = $root.BaseInfo.PlayerBuilding.verify(message.playerBuilding);
                if (error)
                    return "playerBuilding." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return GetAllBuildingRes;
    })();

    Building.PutBuildingReq = (function() {

        /**
         * Properties of a PutBuildingReq.
         * @memberof Building
         * @interface IPutBuildingReq
         * @property {string|null} [buildingId] PutBuildingReq buildingId
         * @property {string|null} [pos] PutBuildingReq pos
         */

        /**
         * Constructs a new PutBuildingReq.
         * @memberof Building
         * @classdesc Represents a PutBuildingReq.
         * @implements IPutBuildingReq
         * @constructor
         * @param {Building.IPutBuildingReq=} [properties] Properties to set
         */
        function PutBuildingReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PutBuildingReq buildingId.
         * @member {string} buildingId
         * @memberof Building.PutBuildingReq
         * @instance
         */
        PutBuildingReq.prototype.buildingId = "";

        /**
         * PutBuildingReq pos.
         * @member {string} pos
         * @memberof Building.PutBuildingReq
         * @instance
         */
        PutBuildingReq.prototype.pos = "";

        /**
         * Creates a new PutBuildingReq instance using the specified properties.
         * @function create
         * @memberof Building.PutBuildingReq
         * @static
         * @param {Building.IPutBuildingReq=} [properties] Properties to set
         * @returns {Building.PutBuildingReq} PutBuildingReq instance
         */
        PutBuildingReq.create = function create(properties) {
            return new PutBuildingReq(properties);
        };

        /**
         * Encodes the specified PutBuildingReq message. Does not implicitly {@link Building.PutBuildingReq.verify|verify} messages.
         * @function encode
         * @memberof Building.PutBuildingReq
         * @static
         * @param {Building.IPutBuildingReq} message PutBuildingReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutBuildingReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.buildingId != null && message.hasOwnProperty("buildingId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.buildingId);
            if (message.pos != null && message.hasOwnProperty("pos"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pos);
            return writer;
        };

        /**
         * Encodes the specified PutBuildingReq message, length delimited. Does not implicitly {@link Building.PutBuildingReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Building.PutBuildingReq
         * @static
         * @param {Building.IPutBuildingReq} message PutBuildingReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutBuildingReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PutBuildingReq message from the specified reader or buffer.
         * @function decode
         * @memberof Building.PutBuildingReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Building.PutBuildingReq} PutBuildingReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutBuildingReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Building.PutBuildingReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.buildingId = reader.string();
                    break;
                case 3:
                    message.pos = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PutBuildingReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Building.PutBuildingReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Building.PutBuildingReq} PutBuildingReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutBuildingReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PutBuildingReq message.
         * @function verify
         * @memberof Building.PutBuildingReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PutBuildingReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.buildingId != null && message.hasOwnProperty("buildingId"))
                if (!$util.isString(message.buildingId))
                    return "buildingId: string expected";
            if (message.pos != null && message.hasOwnProperty("pos"))
                if (!$util.isString(message.pos))
                    return "pos: string expected";
            return null;
        };

        return PutBuildingReq;
    })();

    Building.PutBuildingRes = (function() {

        /**
         * Properties of a PutBuildingRes.
         * @memberof Building
         * @interface IPutBuildingRes
         * @property {BaseInfo.ICurrencyBag|null} [bag] PutBuildingRes bag
         * @property {BaseInfo.ILetterBox|null} [letterbox] PutBuildingRes letterbox
         * @property {boolean|null} [ifCanBargain] PutBuildingRes ifCanBargain
         */

        /**
         * Constructs a new PutBuildingRes.
         * @memberof Building
         * @classdesc Represents a PutBuildingRes.
         * @implements IPutBuildingRes
         * @constructor
         * @param {Building.IPutBuildingRes=} [properties] Properties to set
         */
        function PutBuildingRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PutBuildingRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Building.PutBuildingRes
         * @instance
         */
        PutBuildingRes.prototype.bag = null;

        /**
         * PutBuildingRes letterbox.
         * @member {BaseInfo.ILetterBox|null|undefined} letterbox
         * @memberof Building.PutBuildingRes
         * @instance
         */
        PutBuildingRes.prototype.letterbox = null;

        /**
         * PutBuildingRes ifCanBargain.
         * @member {boolean} ifCanBargain
         * @memberof Building.PutBuildingRes
         * @instance
         */
        PutBuildingRes.prototype.ifCanBargain = false;

        /**
         * Creates a new PutBuildingRes instance using the specified properties.
         * @function create
         * @memberof Building.PutBuildingRes
         * @static
         * @param {Building.IPutBuildingRes=} [properties] Properties to set
         * @returns {Building.PutBuildingRes} PutBuildingRes instance
         */
        PutBuildingRes.create = function create(properties) {
            return new PutBuildingRes(properties);
        };

        /**
         * Encodes the specified PutBuildingRes message. Does not implicitly {@link Building.PutBuildingRes.verify|verify} messages.
         * @function encode
         * @memberof Building.PutBuildingRes
         * @static
         * @param {Building.IPutBuildingRes} message PutBuildingRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutBuildingRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.letterbox != null && message.hasOwnProperty("letterbox"))
                $root.BaseInfo.LetterBox.encode(message.letterbox, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.ifCanBargain != null && message.hasOwnProperty("ifCanBargain"))
                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.ifCanBargain);
            return writer;
        };

        /**
         * Encodes the specified PutBuildingRes message, length delimited. Does not implicitly {@link Building.PutBuildingRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Building.PutBuildingRes
         * @static
         * @param {Building.IPutBuildingRes} message PutBuildingRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutBuildingRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PutBuildingRes message from the specified reader or buffer.
         * @function decode
         * @memberof Building.PutBuildingRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Building.PutBuildingRes} PutBuildingRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutBuildingRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Building.PutBuildingRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.letterbox = $root.BaseInfo.LetterBox.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.ifCanBargain = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PutBuildingRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Building.PutBuildingRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Building.PutBuildingRes} PutBuildingRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutBuildingRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PutBuildingRes message.
         * @function verify
         * @memberof Building.PutBuildingRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PutBuildingRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.letterbox != null && message.hasOwnProperty("letterbox")) {
                var error = $root.BaseInfo.LetterBox.verify(message.letterbox);
                if (error)
                    return "letterbox." + error;
            }
            if (message.ifCanBargain != null && message.hasOwnProperty("ifCanBargain"))
                if (typeof message.ifCanBargain !== "boolean")
                    return "ifCanBargain: boolean expected";
            return null;
        };

        return PutBuildingRes;
    })();

    Building.RemoveBuildingReq = (function() {

        /**
         * Properties of a RemoveBuildingReq.
         * @memberof Building
         * @interface IRemoveBuildingReq
         * @property {string|null} [buildingId] RemoveBuildingReq buildingId
         */

        /**
         * Constructs a new RemoveBuildingReq.
         * @memberof Building
         * @classdesc Represents a RemoveBuildingReq.
         * @implements IRemoveBuildingReq
         * @constructor
         * @param {Building.IRemoveBuildingReq=} [properties] Properties to set
         */
        function RemoveBuildingReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * RemoveBuildingReq buildingId.
         * @member {string} buildingId
         * @memberof Building.RemoveBuildingReq
         * @instance
         */
        RemoveBuildingReq.prototype.buildingId = "";

        /**
         * Creates a new RemoveBuildingReq instance using the specified properties.
         * @function create
         * @memberof Building.RemoveBuildingReq
         * @static
         * @param {Building.IRemoveBuildingReq=} [properties] Properties to set
         * @returns {Building.RemoveBuildingReq} RemoveBuildingReq instance
         */
        RemoveBuildingReq.create = function create(properties) {
            return new RemoveBuildingReq(properties);
        };

        /**
         * Encodes the specified RemoveBuildingReq message. Does not implicitly {@link Building.RemoveBuildingReq.verify|verify} messages.
         * @function encode
         * @memberof Building.RemoveBuildingReq
         * @static
         * @param {Building.IRemoveBuildingReq} message RemoveBuildingReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        RemoveBuildingReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.buildingId != null && message.hasOwnProperty("buildingId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.buildingId);
            return writer;
        };

        /**
         * Encodes the specified RemoveBuildingReq message, length delimited. Does not implicitly {@link Building.RemoveBuildingReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Building.RemoveBuildingReq
         * @static
         * @param {Building.IRemoveBuildingReq} message RemoveBuildingReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        RemoveBuildingReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a RemoveBuildingReq message from the specified reader or buffer.
         * @function decode
         * @memberof Building.RemoveBuildingReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Building.RemoveBuildingReq} RemoveBuildingReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        RemoveBuildingReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Building.RemoveBuildingReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.buildingId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a RemoveBuildingReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Building.RemoveBuildingReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Building.RemoveBuildingReq} RemoveBuildingReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        RemoveBuildingReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a RemoveBuildingReq message.
         * @function verify
         * @memberof Building.RemoveBuildingReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        RemoveBuildingReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.buildingId != null && message.hasOwnProperty("buildingId"))
                if (!$util.isString(message.buildingId))
                    return "buildingId: string expected";
            return null;
        };

        return RemoveBuildingReq;
    })();

    Building.RemoveBuildingRes = (function() {

        /**
         * Properties of a RemoveBuildingRes.
         * @memberof Building
         * @interface IRemoveBuildingRes
         * @property {BaseInfo.ICurrencyBag|null} [bag] RemoveBuildingRes bag
         */

        /**
         * Constructs a new RemoveBuildingRes.
         * @memberof Building
         * @classdesc Represents a RemoveBuildingRes.
         * @implements IRemoveBuildingRes
         * @constructor
         * @param {Building.IRemoveBuildingRes=} [properties] Properties to set
         */
        function RemoveBuildingRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * RemoveBuildingRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Building.RemoveBuildingRes
         * @instance
         */
        RemoveBuildingRes.prototype.bag = null;

        /**
         * Creates a new RemoveBuildingRes instance using the specified properties.
         * @function create
         * @memberof Building.RemoveBuildingRes
         * @static
         * @param {Building.IRemoveBuildingRes=} [properties] Properties to set
         * @returns {Building.RemoveBuildingRes} RemoveBuildingRes instance
         */
        RemoveBuildingRes.create = function create(properties) {
            return new RemoveBuildingRes(properties);
        };

        /**
         * Encodes the specified RemoveBuildingRes message. Does not implicitly {@link Building.RemoveBuildingRes.verify|verify} messages.
         * @function encode
         * @memberof Building.RemoveBuildingRes
         * @static
         * @param {Building.IRemoveBuildingRes} message RemoveBuildingRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        RemoveBuildingRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified RemoveBuildingRes message, length delimited. Does not implicitly {@link Building.RemoveBuildingRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Building.RemoveBuildingRes
         * @static
         * @param {Building.IRemoveBuildingRes} message RemoveBuildingRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        RemoveBuildingRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a RemoveBuildingRes message from the specified reader or buffer.
         * @function decode
         * @memberof Building.RemoveBuildingRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Building.RemoveBuildingRes} RemoveBuildingRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        RemoveBuildingRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Building.RemoveBuildingRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a RemoveBuildingRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Building.RemoveBuildingRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Building.RemoveBuildingRes} RemoveBuildingRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        RemoveBuildingRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a RemoveBuildingRes message.
         * @function verify
         * @memberof Building.RemoveBuildingRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        RemoveBuildingRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return RemoveBuildingRes;
    })();

    Building.PutBuildingWithAdReq = (function() {

        /**
         * Properties of a PutBuildingWithAdReq.
         * @memberof Building
         * @interface IPutBuildingWithAdReq
         * @property {string|null} [buildingId] PutBuildingWithAdReq buildingId
         * @property {string|null} [pos] PutBuildingWithAdReq pos
         * @property {BaseInfo.FetchType|null} [fetchType] PutBuildingWithAdReq fetchType
         */

        /**
         * Constructs a new PutBuildingWithAdReq.
         * @memberof Building
         * @classdesc Represents a PutBuildingWithAdReq.
         * @implements IPutBuildingWithAdReq
         * @constructor
         * @param {Building.IPutBuildingWithAdReq=} [properties] Properties to set
         */
        function PutBuildingWithAdReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PutBuildingWithAdReq buildingId.
         * @member {string} buildingId
         * @memberof Building.PutBuildingWithAdReq
         * @instance
         */
        PutBuildingWithAdReq.prototype.buildingId = "";

        /**
         * PutBuildingWithAdReq pos.
         * @member {string} pos
         * @memberof Building.PutBuildingWithAdReq
         * @instance
         */
        PutBuildingWithAdReq.prototype.pos = "";

        /**
         * PutBuildingWithAdReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof Building.PutBuildingWithAdReq
         * @instance
         */
        PutBuildingWithAdReq.prototype.fetchType = 0;

        /**
         * Creates a new PutBuildingWithAdReq instance using the specified properties.
         * @function create
         * @memberof Building.PutBuildingWithAdReq
         * @static
         * @param {Building.IPutBuildingWithAdReq=} [properties] Properties to set
         * @returns {Building.PutBuildingWithAdReq} PutBuildingWithAdReq instance
         */
        PutBuildingWithAdReq.create = function create(properties) {
            return new PutBuildingWithAdReq(properties);
        };

        /**
         * Encodes the specified PutBuildingWithAdReq message. Does not implicitly {@link Building.PutBuildingWithAdReq.verify|verify} messages.
         * @function encode
         * @memberof Building.PutBuildingWithAdReq
         * @static
         * @param {Building.IPutBuildingWithAdReq} message PutBuildingWithAdReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutBuildingWithAdReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.buildingId != null && message.hasOwnProperty("buildingId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.buildingId);
            if (message.pos != null && message.hasOwnProperty("pos"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.pos);
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified PutBuildingWithAdReq message, length delimited. Does not implicitly {@link Building.PutBuildingWithAdReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Building.PutBuildingWithAdReq
         * @static
         * @param {Building.IPutBuildingWithAdReq} message PutBuildingWithAdReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutBuildingWithAdReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PutBuildingWithAdReq message from the specified reader or buffer.
         * @function decode
         * @memberof Building.PutBuildingWithAdReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Building.PutBuildingWithAdReq} PutBuildingWithAdReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutBuildingWithAdReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Building.PutBuildingWithAdReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.buildingId = reader.string();
                    break;
                case 3:
                    message.pos = reader.string();
                    break;
                case 4:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PutBuildingWithAdReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Building.PutBuildingWithAdReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Building.PutBuildingWithAdReq} PutBuildingWithAdReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutBuildingWithAdReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PutBuildingWithAdReq message.
         * @function verify
         * @memberof Building.PutBuildingWithAdReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PutBuildingWithAdReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.buildingId != null && message.hasOwnProperty("buildingId"))
                if (!$util.isString(message.buildingId))
                    return "buildingId: string expected";
            if (message.pos != null && message.hasOwnProperty("pos"))
                if (!$util.isString(message.pos))
                    return "pos: string expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return PutBuildingWithAdReq;
    })();

    Building.PutBuildingWithAdRes = (function() {

        /**
         * Properties of a PutBuildingWithAdRes.
         * @memberof Building
         * @interface IPutBuildingWithAdRes
         * @property {BaseInfo.ICurrencyBag|null} [bag] PutBuildingWithAdRes bag
         * @property {BaseInfo.ILetterBox|null} [letterbox] PutBuildingWithAdRes letterbox
         * @property {boolean|null} [ifCanBargain] PutBuildingWithAdRes ifCanBargain
         * @property {BaseInfo.IAdRewardsInfo|null} [adRewardsInfo] PutBuildingWithAdRes adRewardsInfo
         */

        /**
         * Constructs a new PutBuildingWithAdRes.
         * @memberof Building
         * @classdesc Represents a PutBuildingWithAdRes.
         * @implements IPutBuildingWithAdRes
         * @constructor
         * @param {Building.IPutBuildingWithAdRes=} [properties] Properties to set
         */
        function PutBuildingWithAdRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PutBuildingWithAdRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Building.PutBuildingWithAdRes
         * @instance
         */
        PutBuildingWithAdRes.prototype.bag = null;

        /**
         * PutBuildingWithAdRes letterbox.
         * @member {BaseInfo.ILetterBox|null|undefined} letterbox
         * @memberof Building.PutBuildingWithAdRes
         * @instance
         */
        PutBuildingWithAdRes.prototype.letterbox = null;

        /**
         * PutBuildingWithAdRes ifCanBargain.
         * @member {boolean} ifCanBargain
         * @memberof Building.PutBuildingWithAdRes
         * @instance
         */
        PutBuildingWithAdRes.prototype.ifCanBargain = false;

        /**
         * PutBuildingWithAdRes adRewardsInfo.
         * @member {BaseInfo.IAdRewardsInfo|null|undefined} adRewardsInfo
         * @memberof Building.PutBuildingWithAdRes
         * @instance
         */
        PutBuildingWithAdRes.prototype.adRewardsInfo = null;

        /**
         * Creates a new PutBuildingWithAdRes instance using the specified properties.
         * @function create
         * @memberof Building.PutBuildingWithAdRes
         * @static
         * @param {Building.IPutBuildingWithAdRes=} [properties] Properties to set
         * @returns {Building.PutBuildingWithAdRes} PutBuildingWithAdRes instance
         */
        PutBuildingWithAdRes.create = function create(properties) {
            return new PutBuildingWithAdRes(properties);
        };

        /**
         * Encodes the specified PutBuildingWithAdRes message. Does not implicitly {@link Building.PutBuildingWithAdRes.verify|verify} messages.
         * @function encode
         * @memberof Building.PutBuildingWithAdRes
         * @static
         * @param {Building.IPutBuildingWithAdRes} message PutBuildingWithAdRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutBuildingWithAdRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.letterbox != null && message.hasOwnProperty("letterbox"))
                $root.BaseInfo.LetterBox.encode(message.letterbox, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.ifCanBargain != null && message.hasOwnProperty("ifCanBargain"))
                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.ifCanBargain);
            if (message.adRewardsInfo != null && message.hasOwnProperty("adRewardsInfo"))
                $root.BaseInfo.AdRewardsInfo.encode(message.adRewardsInfo, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified PutBuildingWithAdRes message, length delimited. Does not implicitly {@link Building.PutBuildingWithAdRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Building.PutBuildingWithAdRes
         * @static
         * @param {Building.IPutBuildingWithAdRes} message PutBuildingWithAdRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutBuildingWithAdRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PutBuildingWithAdRes message from the specified reader or buffer.
         * @function decode
         * @memberof Building.PutBuildingWithAdRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Building.PutBuildingWithAdRes} PutBuildingWithAdRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutBuildingWithAdRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Building.PutBuildingWithAdRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.letterbox = $root.BaseInfo.LetterBox.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.ifCanBargain = reader.bool();
                    break;
                case 4:
                    message.adRewardsInfo = $root.BaseInfo.AdRewardsInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PutBuildingWithAdRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Building.PutBuildingWithAdRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Building.PutBuildingWithAdRes} PutBuildingWithAdRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutBuildingWithAdRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PutBuildingWithAdRes message.
         * @function verify
         * @memberof Building.PutBuildingWithAdRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PutBuildingWithAdRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.letterbox != null && message.hasOwnProperty("letterbox")) {
                var error = $root.BaseInfo.LetterBox.verify(message.letterbox);
                if (error)
                    return "letterbox." + error;
            }
            if (message.ifCanBargain != null && message.hasOwnProperty("ifCanBargain"))
                if (typeof message.ifCanBargain !== "boolean")
                    return "ifCanBargain: boolean expected";
            if (message.adRewardsInfo != null && message.hasOwnProperty("adRewardsInfo")) {
                var error = $root.BaseInfo.AdRewardsInfo.verify(message.adRewardsInfo);
                if (error)
                    return "adRewardsInfo." + error;
            }
            return null;
        };

        return PutBuildingWithAdRes;
    })();

    Building.BargainReq = (function() {

        /**
         * Properties of a BargainReq.
         * @memberof Building
         * @interface IBargainReq
         * @property {BaseInfo.FetchType|null} [fetchType] BargainReq fetchType
         * @property {number|Long|null} [fishAmount] BargainReq fishAmount
         * @property {string|null} [buildingId] BargainReq buildingId
         */

        /**
         * Constructs a new BargainReq.
         * @memberof Building
         * @classdesc Represents a BargainReq.
         * @implements IBargainReq
         * @constructor
         * @param {Building.IBargainReq=} [properties] Properties to set
         */
        function BargainReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * BargainReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof Building.BargainReq
         * @instance
         */
        BargainReq.prototype.fetchType = 0;

        /**
         * BargainReq fishAmount.
         * @member {number|Long} fishAmount
         * @memberof Building.BargainReq
         * @instance
         */
        BargainReq.prototype.fishAmount = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * BargainReq buildingId.
         * @member {string} buildingId
         * @memberof Building.BargainReq
         * @instance
         */
        BargainReq.prototype.buildingId = "";

        /**
         * Creates a new BargainReq instance using the specified properties.
         * @function create
         * @memberof Building.BargainReq
         * @static
         * @param {Building.IBargainReq=} [properties] Properties to set
         * @returns {Building.BargainReq} BargainReq instance
         */
        BargainReq.create = function create(properties) {
            return new BargainReq(properties);
        };

        /**
         * Encodes the specified BargainReq message. Does not implicitly {@link Building.BargainReq.verify|verify} messages.
         * @function encode
         * @memberof Building.BargainReq
         * @static
         * @param {Building.IBargainReq} message BargainReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        BargainReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.fetchType);
            if (message.fishAmount != null && message.hasOwnProperty("fishAmount"))
                writer.uint32(/* id 2, wireType 0 =*/16).int64(message.fishAmount);
            if (message.buildingId != null && message.hasOwnProperty("buildingId"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.buildingId);
            return writer;
        };

        /**
         * Encodes the specified BargainReq message, length delimited. Does not implicitly {@link Building.BargainReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Building.BargainReq
         * @static
         * @param {Building.IBargainReq} message BargainReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        BargainReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a BargainReq message from the specified reader or buffer.
         * @function decode
         * @memberof Building.BargainReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Building.BargainReq} BargainReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        BargainReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Building.BargainReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.fetchType = reader.int32();
                    break;
                case 2:
                    message.fishAmount = reader.int64();
                    break;
                case 3:
                    message.buildingId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a BargainReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Building.BargainReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Building.BargainReq} BargainReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        BargainReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a BargainReq message.
         * @function verify
         * @memberof Building.BargainReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        BargainReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            if (message.fishAmount != null && message.hasOwnProperty("fishAmount"))
                if (!$util.isInteger(message.fishAmount) && !(message.fishAmount && $util.isInteger(message.fishAmount.low) && $util.isInteger(message.fishAmount.high)))
                    return "fishAmount: integer|Long expected";
            if (message.buildingId != null && message.hasOwnProperty("buildingId"))
                if (!$util.isString(message.buildingId))
                    return "buildingId: string expected";
            return null;
        };

        return BargainReq;
    })();

    Building.BargainRes = (function() {

        /**
         * Properties of a BargainRes.
         * @memberof Building
         * @interface IBargainRes
         * @property {BaseInfo.ICurrencyBag|null} [bag] BargainRes bag
         * @property {number|null} [bargainTimes] BargainRes bargainTimes
         * @property {boolean|null} [freeBargain] BargainRes freeBargain
         */

        /**
         * Constructs a new BargainRes.
         * @memberof Building
         * @classdesc Represents a BargainRes.
         * @implements IBargainRes
         * @constructor
         * @param {Building.IBargainRes=} [properties] Properties to set
         */
        function BargainRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * BargainRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Building.BargainRes
         * @instance
         */
        BargainRes.prototype.bag = null;

        /**
         * BargainRes bargainTimes.
         * @member {number} bargainTimes
         * @memberof Building.BargainRes
         * @instance
         */
        BargainRes.prototype.bargainTimes = 0;

        /**
         * BargainRes freeBargain.
         * @member {boolean} freeBargain
         * @memberof Building.BargainRes
         * @instance
         */
        BargainRes.prototype.freeBargain = false;

        /**
         * Creates a new BargainRes instance using the specified properties.
         * @function create
         * @memberof Building.BargainRes
         * @static
         * @param {Building.IBargainRes=} [properties] Properties to set
         * @returns {Building.BargainRes} BargainRes instance
         */
        BargainRes.create = function create(properties) {
            return new BargainRes(properties);
        };

        /**
         * Encodes the specified BargainRes message. Does not implicitly {@link Building.BargainRes.verify|verify} messages.
         * @function encode
         * @memberof Building.BargainRes
         * @static
         * @param {Building.IBargainRes} message BargainRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        BargainRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bargainTimes != null && message.hasOwnProperty("bargainTimes"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.bargainTimes);
            if (message.freeBargain != null && message.hasOwnProperty("freeBargain"))
                writer.uint32(/* id 3, wireType 0 =*/24).bool(message.freeBargain);
            return writer;
        };

        /**
         * Encodes the specified BargainRes message, length delimited. Does not implicitly {@link Building.BargainRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Building.BargainRes
         * @static
         * @param {Building.IBargainRes} message BargainRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        BargainRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a BargainRes message from the specified reader or buffer.
         * @function decode
         * @memberof Building.BargainRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Building.BargainRes} BargainRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        BargainRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Building.BargainRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bargainTimes = reader.int32();
                    break;
                case 3:
                    message.freeBargain = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a BargainRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Building.BargainRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Building.BargainRes} BargainRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        BargainRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a BargainRes message.
         * @function verify
         * @memberof Building.BargainRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        BargainRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.bargainTimes != null && message.hasOwnProperty("bargainTimes"))
                if (!$util.isInteger(message.bargainTimes))
                    return "bargainTimes: integer expected";
            if (message.freeBargain != null && message.hasOwnProperty("freeBargain"))
                if (typeof message.freeBargain !== "boolean")
                    return "freeBargain: boolean expected";
            return null;
        };

        return BargainRes;
    })();

    return Building;
})();

$root.Scene = (function() {

    /**
     * Namespace Scene.
     * @exports Scene
     * @namespace
     */
    var Scene = {};

    Scene.UpdateSceneInfoReq = (function() {

        /**
         * Properties of an UpdateSceneInfoReq.
         * @memberof Scene
         * @interface IUpdateSceneInfoReq
         * @property {string|null} [customData] UpdateSceneInfoReq customData
         * @property {BaseInfo.IRewards|null} [rewards] UpdateSceneInfoReq rewards
         * @property {Object.<string,Scene.IPetReward>|null} [petRewards] UpdateSceneInfoReq petRewards
         * @property {Array.<Scene.IVisitorReward>|null} [visitorRewards] UpdateSceneInfoReq visitorRewards
         * @property {Array.<Event.IEvent>|null} [events] UpdateSceneInfoReq events
         */

        /**
         * Constructs a new UpdateSceneInfoReq.
         * @memberof Scene
         * @classdesc Represents an UpdateSceneInfoReq.
         * @implements IUpdateSceneInfoReq
         * @constructor
         * @param {Scene.IUpdateSceneInfoReq=} [properties] Properties to set
         */
        function UpdateSceneInfoReq(properties) {
            this.petRewards = {};
            this.visitorRewards = [];
            this.events = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * UpdateSceneInfoReq customData.
         * @member {string} customData
         * @memberof Scene.UpdateSceneInfoReq
         * @instance
         */
        UpdateSceneInfoReq.prototype.customData = "";

        /**
         * UpdateSceneInfoReq rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Scene.UpdateSceneInfoReq
         * @instance
         */
        UpdateSceneInfoReq.prototype.rewards = null;

        /**
         * UpdateSceneInfoReq petRewards.
         * @member {Object.<string,Scene.IPetReward>} petRewards
         * @memberof Scene.UpdateSceneInfoReq
         * @instance
         */
        UpdateSceneInfoReq.prototype.petRewards = $util.emptyObject;

        /**
         * UpdateSceneInfoReq visitorRewards.
         * @member {Array.<Scene.IVisitorReward>} visitorRewards
         * @memberof Scene.UpdateSceneInfoReq
         * @instance
         */
        UpdateSceneInfoReq.prototype.visitorRewards = $util.emptyArray;

        /**
         * UpdateSceneInfoReq events.
         * @member {Array.<Event.IEvent>} events
         * @memberof Scene.UpdateSceneInfoReq
         * @instance
         */
        UpdateSceneInfoReq.prototype.events = $util.emptyArray;

        /**
         * Creates a new UpdateSceneInfoReq instance using the specified properties.
         * @function create
         * @memberof Scene.UpdateSceneInfoReq
         * @static
         * @param {Scene.IUpdateSceneInfoReq=} [properties] Properties to set
         * @returns {Scene.UpdateSceneInfoReq} UpdateSceneInfoReq instance
         */
        UpdateSceneInfoReq.create = function create(properties) {
            return new UpdateSceneInfoReq(properties);
        };

        /**
         * Encodes the specified UpdateSceneInfoReq message. Does not implicitly {@link Scene.UpdateSceneInfoReq.verify|verify} messages.
         * @function encode
         * @memberof Scene.UpdateSceneInfoReq
         * @static
         * @param {Scene.IUpdateSceneInfoReq} message UpdateSceneInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        UpdateSceneInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.customData != null && message.hasOwnProperty("customData"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.customData);
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.petRewards != null && message.hasOwnProperty("petRewards"))
                for (var keys = Object.keys(message.petRewards), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 3, wireType 2 =*/26).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.Scene.PetReward.encode(message.petRewards[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            if (message.visitorRewards != null && message.visitorRewards.length)
                for (var i = 0; i < message.visitorRewards.length; ++i)
                    $root.Scene.VisitorReward.encode(message.visitorRewards[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            if (message.events != null && message.events.length)
                for (var i = 0; i < message.events.length; ++i)
                    $root.Event.Event.encode(message.events[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified UpdateSceneInfoReq message, length delimited. Does not implicitly {@link Scene.UpdateSceneInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.UpdateSceneInfoReq
         * @static
         * @param {Scene.IUpdateSceneInfoReq} message UpdateSceneInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        UpdateSceneInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an UpdateSceneInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.UpdateSceneInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.UpdateSceneInfoReq} UpdateSceneInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        UpdateSceneInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.UpdateSceneInfoReq(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.customData = reader.string();
                    break;
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 3:
                    reader.skip().pos++;
                    if (message.petRewards === $util.emptyObject)
                        message.petRewards = {};
                    key = reader.string();
                    reader.pos++;
                    message.petRewards[key] = $root.Scene.PetReward.decode(reader, reader.uint32());
                    break;
                case 4:
                    if (!(message.visitorRewards && message.visitorRewards.length))
                        message.visitorRewards = [];
                    message.visitorRewards.push($root.Scene.VisitorReward.decode(reader, reader.uint32()));
                    break;
                case 5:
                    if (!(message.events && message.events.length))
                        message.events = [];
                    message.events.push($root.Event.Event.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an UpdateSceneInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.UpdateSceneInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.UpdateSceneInfoReq} UpdateSceneInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        UpdateSceneInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an UpdateSceneInfoReq message.
         * @function verify
         * @memberof Scene.UpdateSceneInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        UpdateSceneInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.customData != null && message.hasOwnProperty("customData"))
                if (!$util.isString(message.customData))
                    return "customData: string expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.petRewards != null && message.hasOwnProperty("petRewards")) {
                if (!$util.isObject(message.petRewards))
                    return "petRewards: object expected";
                var key = Object.keys(message.petRewards);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.Scene.PetReward.verify(message.petRewards[key[i]]);
                    if (error)
                        return "petRewards." + error;
                }
            }
            if (message.visitorRewards != null && message.hasOwnProperty("visitorRewards")) {
                if (!Array.isArray(message.visitorRewards))
                    return "visitorRewards: array expected";
                for (var i = 0; i < message.visitorRewards.length; ++i) {
                    var error = $root.Scene.VisitorReward.verify(message.visitorRewards[i]);
                    if (error)
                        return "visitorRewards." + error;
                }
            }
            if (message.events != null && message.hasOwnProperty("events")) {
                if (!Array.isArray(message.events))
                    return "events: array expected";
                for (var i = 0; i < message.events.length; ++i) {
                    var error = $root.Event.Event.verify(message.events[i]);
                    if (error)
                        return "events." + error;
                }
            }
            return null;
        };

        return UpdateSceneInfoReq;
    })();

    Scene.UpdateSceneInfoRes = (function() {

        /**
         * Properties of an UpdateSceneInfoRes.
         * @memberof Scene
         * @interface IUpdateSceneInfoRes
         * @property {BaseInfo.ICurrencyBag|null} [bag] UpdateSceneInfoRes bag
         * @property {BaseInfo.ILetterBox|null} [letterbox] UpdateSceneInfoRes letterbox
         * @property {BaseInfo.IWharfLetterBox|null} [wharfLetterBox] UpdateSceneInfoRes wharfLetterBox
         * @property {BaseInfo.IAidedGroupInfo|null} [aidedGroupInfo] UpdateSceneInfoRes aidedGroupInfo
         */

        /**
         * Constructs a new UpdateSceneInfoRes.
         * @memberof Scene
         * @classdesc Represents an UpdateSceneInfoRes.
         * @implements IUpdateSceneInfoRes
         * @constructor
         * @param {Scene.IUpdateSceneInfoRes=} [properties] Properties to set
         */
        function UpdateSceneInfoRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * UpdateSceneInfoRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Scene.UpdateSceneInfoRes
         * @instance
         */
        UpdateSceneInfoRes.prototype.bag = null;

        /**
         * UpdateSceneInfoRes letterbox.
         * @member {BaseInfo.ILetterBox|null|undefined} letterbox
         * @memberof Scene.UpdateSceneInfoRes
         * @instance
         */
        UpdateSceneInfoRes.prototype.letterbox = null;

        /**
         * UpdateSceneInfoRes wharfLetterBox.
         * @member {BaseInfo.IWharfLetterBox|null|undefined} wharfLetterBox
         * @memberof Scene.UpdateSceneInfoRes
         * @instance
         */
        UpdateSceneInfoRes.prototype.wharfLetterBox = null;

        /**
         * UpdateSceneInfoRes aidedGroupInfo.
         * @member {BaseInfo.IAidedGroupInfo|null|undefined} aidedGroupInfo
         * @memberof Scene.UpdateSceneInfoRes
         * @instance
         */
        UpdateSceneInfoRes.prototype.aidedGroupInfo = null;

        /**
         * Creates a new UpdateSceneInfoRes instance using the specified properties.
         * @function create
         * @memberof Scene.UpdateSceneInfoRes
         * @static
         * @param {Scene.IUpdateSceneInfoRes=} [properties] Properties to set
         * @returns {Scene.UpdateSceneInfoRes} UpdateSceneInfoRes instance
         */
        UpdateSceneInfoRes.create = function create(properties) {
            return new UpdateSceneInfoRes(properties);
        };

        /**
         * Encodes the specified UpdateSceneInfoRes message. Does not implicitly {@link Scene.UpdateSceneInfoRes.verify|verify} messages.
         * @function encode
         * @memberof Scene.UpdateSceneInfoRes
         * @static
         * @param {Scene.IUpdateSceneInfoRes} message UpdateSceneInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        UpdateSceneInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.letterbox != null && message.hasOwnProperty("letterbox"))
                $root.BaseInfo.LetterBox.encode(message.letterbox, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.wharfLetterBox != null && message.hasOwnProperty("wharfLetterBox"))
                $root.BaseInfo.WharfLetterBox.encode(message.wharfLetterBox, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo"))
                $root.BaseInfo.AidedGroupInfo.encode(message.aidedGroupInfo, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified UpdateSceneInfoRes message, length delimited. Does not implicitly {@link Scene.UpdateSceneInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.UpdateSceneInfoRes
         * @static
         * @param {Scene.IUpdateSceneInfoRes} message UpdateSceneInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        UpdateSceneInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an UpdateSceneInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.UpdateSceneInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.UpdateSceneInfoRes} UpdateSceneInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        UpdateSceneInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.UpdateSceneInfoRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.letterbox = $root.BaseInfo.LetterBox.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.wharfLetterBox = $root.BaseInfo.WharfLetterBox.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.aidedGroupInfo = $root.BaseInfo.AidedGroupInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an UpdateSceneInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.UpdateSceneInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.UpdateSceneInfoRes} UpdateSceneInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        UpdateSceneInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an UpdateSceneInfoRes message.
         * @function verify
         * @memberof Scene.UpdateSceneInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        UpdateSceneInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.letterbox != null && message.hasOwnProperty("letterbox")) {
                var error = $root.BaseInfo.LetterBox.verify(message.letterbox);
                if (error)
                    return "letterbox." + error;
            }
            if (message.wharfLetterBox != null && message.hasOwnProperty("wharfLetterBox")) {
                var error = $root.BaseInfo.WharfLetterBox.verify(message.wharfLetterBox);
                if (error)
                    return "wharfLetterBox." + error;
            }
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo")) {
                var error = $root.BaseInfo.AidedGroupInfo.verify(message.aidedGroupInfo);
                if (error)
                    return "aidedGroupInfo." + error;
            }
            return null;
        };

        return UpdateSceneInfoRes;
    })();

    Scene.FetchLetterBoxReq = (function() {

        /**
         * Properties of a FetchLetterBoxReq.
         * @memberof Scene
         * @interface IFetchLetterBoxReq
         * @property {boolean|null} [ad] FetchLetterBoxReq ad
         */

        /**
         * Constructs a new FetchLetterBoxReq.
         * @memberof Scene
         * @classdesc Represents a FetchLetterBoxReq.
         * @implements IFetchLetterBoxReq
         * @constructor
         * @param {Scene.IFetchLetterBoxReq=} [properties] Properties to set
         */
        function FetchLetterBoxReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchLetterBoxReq ad.
         * @member {boolean} ad
         * @memberof Scene.FetchLetterBoxReq
         * @instance
         */
        FetchLetterBoxReq.prototype.ad = false;

        /**
         * Creates a new FetchLetterBoxReq instance using the specified properties.
         * @function create
         * @memberof Scene.FetchLetterBoxReq
         * @static
         * @param {Scene.IFetchLetterBoxReq=} [properties] Properties to set
         * @returns {Scene.FetchLetterBoxReq} FetchLetterBoxReq instance
         */
        FetchLetterBoxReq.create = function create(properties) {
            return new FetchLetterBoxReq(properties);
        };

        /**
         * Encodes the specified FetchLetterBoxReq message. Does not implicitly {@link Scene.FetchLetterBoxReq.verify|verify} messages.
         * @function encode
         * @memberof Scene.FetchLetterBoxReq
         * @static
         * @param {Scene.IFetchLetterBoxReq} message FetchLetterBoxReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchLetterBoxReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.ad != null && message.hasOwnProperty("ad"))
                writer.uint32(/* id 1, wireType 0 =*/8).bool(message.ad);
            return writer;
        };

        /**
         * Encodes the specified FetchLetterBoxReq message, length delimited. Does not implicitly {@link Scene.FetchLetterBoxReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.FetchLetterBoxReq
         * @static
         * @param {Scene.IFetchLetterBoxReq} message FetchLetterBoxReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchLetterBoxReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchLetterBoxReq message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.FetchLetterBoxReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.FetchLetterBoxReq} FetchLetterBoxReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchLetterBoxReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.FetchLetterBoxReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.ad = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchLetterBoxReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.FetchLetterBoxReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.FetchLetterBoxReq} FetchLetterBoxReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchLetterBoxReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchLetterBoxReq message.
         * @function verify
         * @memberof Scene.FetchLetterBoxReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchLetterBoxReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.ad != null && message.hasOwnProperty("ad"))
                if (typeof message.ad !== "boolean")
                    return "ad: boolean expected";
            return null;
        };

        return FetchLetterBoxReq;
    })();

    Scene.FetchLetterBoxRes = (function() {

        /**
         * Properties of a FetchLetterBoxRes.
         * @memberof Scene
         * @interface IFetchLetterBoxRes
         * @property {BaseInfo.ICurrencyBag|null} [bag] FetchLetterBoxRes bag
         * @property {BaseInfo.ILetterBox|null} [letterbox] FetchLetterBoxRes letterbox
         */

        /**
         * Constructs a new FetchLetterBoxRes.
         * @memberof Scene
         * @classdesc Represents a FetchLetterBoxRes.
         * @implements IFetchLetterBoxRes
         * @constructor
         * @param {Scene.IFetchLetterBoxRes=} [properties] Properties to set
         */
        function FetchLetterBoxRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchLetterBoxRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Scene.FetchLetterBoxRes
         * @instance
         */
        FetchLetterBoxRes.prototype.bag = null;

        /**
         * FetchLetterBoxRes letterbox.
         * @member {BaseInfo.ILetterBox|null|undefined} letterbox
         * @memberof Scene.FetchLetterBoxRes
         * @instance
         */
        FetchLetterBoxRes.prototype.letterbox = null;

        /**
         * Creates a new FetchLetterBoxRes instance using the specified properties.
         * @function create
         * @memberof Scene.FetchLetterBoxRes
         * @static
         * @param {Scene.IFetchLetterBoxRes=} [properties] Properties to set
         * @returns {Scene.FetchLetterBoxRes} FetchLetterBoxRes instance
         */
        FetchLetterBoxRes.create = function create(properties) {
            return new FetchLetterBoxRes(properties);
        };

        /**
         * Encodes the specified FetchLetterBoxRes message. Does not implicitly {@link Scene.FetchLetterBoxRes.verify|verify} messages.
         * @function encode
         * @memberof Scene.FetchLetterBoxRes
         * @static
         * @param {Scene.IFetchLetterBoxRes} message FetchLetterBoxRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchLetterBoxRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.letterbox != null && message.hasOwnProperty("letterbox"))
                $root.BaseInfo.LetterBox.encode(message.letterbox, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FetchLetterBoxRes message, length delimited. Does not implicitly {@link Scene.FetchLetterBoxRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.FetchLetterBoxRes
         * @static
         * @param {Scene.IFetchLetterBoxRes} message FetchLetterBoxRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchLetterBoxRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchLetterBoxRes message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.FetchLetterBoxRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.FetchLetterBoxRes} FetchLetterBoxRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchLetterBoxRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.FetchLetterBoxRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.letterbox = $root.BaseInfo.LetterBox.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchLetterBoxRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.FetchLetterBoxRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.FetchLetterBoxRes} FetchLetterBoxRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchLetterBoxRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchLetterBoxRes message.
         * @function verify
         * @memberof Scene.FetchLetterBoxRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchLetterBoxRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.letterbox != null && message.hasOwnProperty("letterbox")) {
                var error = $root.BaseInfo.LetterBox.verify(message.letterbox);
                if (error)
                    return "letterbox." + error;
            }
            return null;
        };

        return FetchLetterBoxRes;
    })();

    Scene.GetLetterBoxInfoReq = (function() {

        /**
         * Properties of a GetLetterBoxInfoReq.
         * @memberof Scene
         * @interface IGetLetterBoxInfoReq
         */

        /**
         * Constructs a new GetLetterBoxInfoReq.
         * @memberof Scene
         * @classdesc Represents a GetLetterBoxInfoReq.
         * @implements IGetLetterBoxInfoReq
         * @constructor
         * @param {Scene.IGetLetterBoxInfoReq=} [properties] Properties to set
         */
        function GetLetterBoxInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetLetterBoxInfoReq instance using the specified properties.
         * @function create
         * @memberof Scene.GetLetterBoxInfoReq
         * @static
         * @param {Scene.IGetLetterBoxInfoReq=} [properties] Properties to set
         * @returns {Scene.GetLetterBoxInfoReq} GetLetterBoxInfoReq instance
         */
        GetLetterBoxInfoReq.create = function create(properties) {
            return new GetLetterBoxInfoReq(properties);
        };

        /**
         * Encodes the specified GetLetterBoxInfoReq message. Does not implicitly {@link Scene.GetLetterBoxInfoReq.verify|verify} messages.
         * @function encode
         * @memberof Scene.GetLetterBoxInfoReq
         * @static
         * @param {Scene.IGetLetterBoxInfoReq} message GetLetterBoxInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetLetterBoxInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetLetterBoxInfoReq message, length delimited. Does not implicitly {@link Scene.GetLetterBoxInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.GetLetterBoxInfoReq
         * @static
         * @param {Scene.IGetLetterBoxInfoReq} message GetLetterBoxInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetLetterBoxInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetLetterBoxInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.GetLetterBoxInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.GetLetterBoxInfoReq} GetLetterBoxInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetLetterBoxInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.GetLetterBoxInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetLetterBoxInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.GetLetterBoxInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.GetLetterBoxInfoReq} GetLetterBoxInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetLetterBoxInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetLetterBoxInfoReq message.
         * @function verify
         * @memberof Scene.GetLetterBoxInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetLetterBoxInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetLetterBoxInfoReq;
    })();

    Scene.GetLetterBoxInfoRes = (function() {

        /**
         * Properties of a GetLetterBoxInfoRes.
         * @memberof Scene
         * @interface IGetLetterBoxInfoRes
         * @property {BaseInfo.ILetterBox|null} [letterbox] GetLetterBoxInfoRes letterbox
         */

        /**
         * Constructs a new GetLetterBoxInfoRes.
         * @memberof Scene
         * @classdesc Represents a GetLetterBoxInfoRes.
         * @implements IGetLetterBoxInfoRes
         * @constructor
         * @param {Scene.IGetLetterBoxInfoRes=} [properties] Properties to set
         */
        function GetLetterBoxInfoRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetLetterBoxInfoRes letterbox.
         * @member {BaseInfo.ILetterBox|null|undefined} letterbox
         * @memberof Scene.GetLetterBoxInfoRes
         * @instance
         */
        GetLetterBoxInfoRes.prototype.letterbox = null;

        /**
         * Creates a new GetLetterBoxInfoRes instance using the specified properties.
         * @function create
         * @memberof Scene.GetLetterBoxInfoRes
         * @static
         * @param {Scene.IGetLetterBoxInfoRes=} [properties] Properties to set
         * @returns {Scene.GetLetterBoxInfoRes} GetLetterBoxInfoRes instance
         */
        GetLetterBoxInfoRes.create = function create(properties) {
            return new GetLetterBoxInfoRes(properties);
        };

        /**
         * Encodes the specified GetLetterBoxInfoRes message. Does not implicitly {@link Scene.GetLetterBoxInfoRes.verify|verify} messages.
         * @function encode
         * @memberof Scene.GetLetterBoxInfoRes
         * @static
         * @param {Scene.IGetLetterBoxInfoRes} message GetLetterBoxInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetLetterBoxInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.letterbox != null && message.hasOwnProperty("letterbox"))
                $root.BaseInfo.LetterBox.encode(message.letterbox, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetLetterBoxInfoRes message, length delimited. Does not implicitly {@link Scene.GetLetterBoxInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.GetLetterBoxInfoRes
         * @static
         * @param {Scene.IGetLetterBoxInfoRes} message GetLetterBoxInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetLetterBoxInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetLetterBoxInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.GetLetterBoxInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.GetLetterBoxInfoRes} GetLetterBoxInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetLetterBoxInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.GetLetterBoxInfoRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.letterbox = $root.BaseInfo.LetterBox.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetLetterBoxInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.GetLetterBoxInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.GetLetterBoxInfoRes} GetLetterBoxInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetLetterBoxInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetLetterBoxInfoRes message.
         * @function verify
         * @memberof Scene.GetLetterBoxInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetLetterBoxInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.letterbox != null && message.hasOwnProperty("letterbox")) {
                var error = $root.BaseInfo.LetterBox.verify(message.letterbox);
                if (error)
                    return "letterbox." + error;
            }
            return null;
        };

        return GetLetterBoxInfoRes;
    })();

    Scene.FindVisitorGiftReq = (function() {

        /**
         * Properties of a FindVisitorGiftReq.
         * @memberof Scene
         * @interface IFindVisitorGiftReq
         */

        /**
         * Constructs a new FindVisitorGiftReq.
         * @memberof Scene
         * @classdesc Represents a FindVisitorGiftReq.
         * @implements IFindVisitorGiftReq
         * @constructor
         * @param {Scene.IFindVisitorGiftReq=} [properties] Properties to set
         */
        function FindVisitorGiftReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new FindVisitorGiftReq instance using the specified properties.
         * @function create
         * @memberof Scene.FindVisitorGiftReq
         * @static
         * @param {Scene.IFindVisitorGiftReq=} [properties] Properties to set
         * @returns {Scene.FindVisitorGiftReq} FindVisitorGiftReq instance
         */
        FindVisitorGiftReq.create = function create(properties) {
            return new FindVisitorGiftReq(properties);
        };

        /**
         * Encodes the specified FindVisitorGiftReq message. Does not implicitly {@link Scene.FindVisitorGiftReq.verify|verify} messages.
         * @function encode
         * @memberof Scene.FindVisitorGiftReq
         * @static
         * @param {Scene.IFindVisitorGiftReq} message FindVisitorGiftReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FindVisitorGiftReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified FindVisitorGiftReq message, length delimited. Does not implicitly {@link Scene.FindVisitorGiftReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.FindVisitorGiftReq
         * @static
         * @param {Scene.IFindVisitorGiftReq} message FindVisitorGiftReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FindVisitorGiftReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FindVisitorGiftReq message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.FindVisitorGiftReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.FindVisitorGiftReq} FindVisitorGiftReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FindVisitorGiftReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.FindVisitorGiftReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FindVisitorGiftReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.FindVisitorGiftReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.FindVisitorGiftReq} FindVisitorGiftReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FindVisitorGiftReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FindVisitorGiftReq message.
         * @function verify
         * @memberof Scene.FindVisitorGiftReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FindVisitorGiftReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return FindVisitorGiftReq;
    })();

    Scene.FindVisitorGiftRes = (function() {

        /**
         * Properties of a FindVisitorGiftRes.
         * @memberof Scene
         * @interface IFindVisitorGiftRes
         * @property {Array.<Scene.IVisitorReward>|null} [visitorRewards] FindVisitorGiftRes visitorRewards
         */

        /**
         * Constructs a new FindVisitorGiftRes.
         * @memberof Scene
         * @classdesc Represents a FindVisitorGiftRes.
         * @implements IFindVisitorGiftRes
         * @constructor
         * @param {Scene.IFindVisitorGiftRes=} [properties] Properties to set
         */
        function FindVisitorGiftRes(properties) {
            this.visitorRewards = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FindVisitorGiftRes visitorRewards.
         * @member {Array.<Scene.IVisitorReward>} visitorRewards
         * @memberof Scene.FindVisitorGiftRes
         * @instance
         */
        FindVisitorGiftRes.prototype.visitorRewards = $util.emptyArray;

        /**
         * Creates a new FindVisitorGiftRes instance using the specified properties.
         * @function create
         * @memberof Scene.FindVisitorGiftRes
         * @static
         * @param {Scene.IFindVisitorGiftRes=} [properties] Properties to set
         * @returns {Scene.FindVisitorGiftRes} FindVisitorGiftRes instance
         */
        FindVisitorGiftRes.create = function create(properties) {
            return new FindVisitorGiftRes(properties);
        };

        /**
         * Encodes the specified FindVisitorGiftRes message. Does not implicitly {@link Scene.FindVisitorGiftRes.verify|verify} messages.
         * @function encode
         * @memberof Scene.FindVisitorGiftRes
         * @static
         * @param {Scene.IFindVisitorGiftRes} message FindVisitorGiftRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FindVisitorGiftRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.visitorRewards != null && message.visitorRewards.length)
                for (var i = 0; i < message.visitorRewards.length; ++i)
                    $root.Scene.VisitorReward.encode(message.visitorRewards[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FindVisitorGiftRes message, length delimited. Does not implicitly {@link Scene.FindVisitorGiftRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.FindVisitorGiftRes
         * @static
         * @param {Scene.IFindVisitorGiftRes} message FindVisitorGiftRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FindVisitorGiftRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FindVisitorGiftRes message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.FindVisitorGiftRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.FindVisitorGiftRes} FindVisitorGiftRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FindVisitorGiftRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.FindVisitorGiftRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    if (!(message.visitorRewards && message.visitorRewards.length))
                        message.visitorRewards = [];
                    message.visitorRewards.push($root.Scene.VisitorReward.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FindVisitorGiftRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.FindVisitorGiftRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.FindVisitorGiftRes} FindVisitorGiftRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FindVisitorGiftRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FindVisitorGiftRes message.
         * @function verify
         * @memberof Scene.FindVisitorGiftRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FindVisitorGiftRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.visitorRewards != null && message.hasOwnProperty("visitorRewards")) {
                if (!Array.isArray(message.visitorRewards))
                    return "visitorRewards: array expected";
                for (var i = 0; i < message.visitorRewards.length; ++i) {
                    var error = $root.Scene.VisitorReward.verify(message.visitorRewards[i]);
                    if (error)
                        return "visitorRewards." + error;
                }
            }
            return null;
        };

        return FindVisitorGiftRes;
    })();

    Scene.GetVisitorGiftAllReq = (function() {

        /**
         * Properties of a GetVisitorGiftAllReq.
         * @memberof Scene
         * @interface IGetVisitorGiftAllReq
         * @property {BaseInfo.FetchType|null} [type] GetVisitorGiftAllReq type
         */

        /**
         * Constructs a new GetVisitorGiftAllReq.
         * @memberof Scene
         * @classdesc Represents a GetVisitorGiftAllReq.
         * @implements IGetVisitorGiftAllReq
         * @constructor
         * @param {Scene.IGetVisitorGiftAllReq=} [properties] Properties to set
         */
        function GetVisitorGiftAllReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetVisitorGiftAllReq type.
         * @member {BaseInfo.FetchType} type
         * @memberof Scene.GetVisitorGiftAllReq
         * @instance
         */
        GetVisitorGiftAllReq.prototype.type = 0;

        /**
         * Creates a new GetVisitorGiftAllReq instance using the specified properties.
         * @function create
         * @memberof Scene.GetVisitorGiftAllReq
         * @static
         * @param {Scene.IGetVisitorGiftAllReq=} [properties] Properties to set
         * @returns {Scene.GetVisitorGiftAllReq} GetVisitorGiftAllReq instance
         */
        GetVisitorGiftAllReq.create = function create(properties) {
            return new GetVisitorGiftAllReq(properties);
        };

        /**
         * Encodes the specified GetVisitorGiftAllReq message. Does not implicitly {@link Scene.GetVisitorGiftAllReq.verify|verify} messages.
         * @function encode
         * @memberof Scene.GetVisitorGiftAllReq
         * @static
         * @param {Scene.IGetVisitorGiftAllReq} message GetVisitorGiftAllReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetVisitorGiftAllReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
            return writer;
        };

        /**
         * Encodes the specified GetVisitorGiftAllReq message, length delimited. Does not implicitly {@link Scene.GetVisitorGiftAllReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.GetVisitorGiftAllReq
         * @static
         * @param {Scene.IGetVisitorGiftAllReq} message GetVisitorGiftAllReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetVisitorGiftAllReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetVisitorGiftAllReq message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.GetVisitorGiftAllReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.GetVisitorGiftAllReq} GetVisitorGiftAllReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetVisitorGiftAllReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.GetVisitorGiftAllReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.type = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetVisitorGiftAllReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.GetVisitorGiftAllReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.GetVisitorGiftAllReq} GetVisitorGiftAllReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetVisitorGiftAllReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetVisitorGiftAllReq message.
         * @function verify
         * @memberof Scene.GetVisitorGiftAllReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetVisitorGiftAllReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.type != null && message.hasOwnProperty("type"))
                switch (message.type) {
                default:
                    return "type: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return GetVisitorGiftAllReq;
    })();

    Scene.GetVisitorGiftAllRes = (function() {

        /**
         * Properties of a GetVisitorGiftAllRes.
         * @memberof Scene
         * @interface IGetVisitorGiftAllRes
         * @property {BaseInfo.IRewards|null} [rewards] GetVisitorGiftAllRes rewards
         * @property {BaseInfo.ICurrencyBag|null} [bag] GetVisitorGiftAllRes bag
         */

        /**
         * Constructs a new GetVisitorGiftAllRes.
         * @memberof Scene
         * @classdesc Represents a GetVisitorGiftAllRes.
         * @implements IGetVisitorGiftAllRes
         * @constructor
         * @param {Scene.IGetVisitorGiftAllRes=} [properties] Properties to set
         */
        function GetVisitorGiftAllRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetVisitorGiftAllRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Scene.GetVisitorGiftAllRes
         * @instance
         */
        GetVisitorGiftAllRes.prototype.rewards = null;

        /**
         * GetVisitorGiftAllRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Scene.GetVisitorGiftAllRes
         * @instance
         */
        GetVisitorGiftAllRes.prototype.bag = null;

        /**
         * Creates a new GetVisitorGiftAllRes instance using the specified properties.
         * @function create
         * @memberof Scene.GetVisitorGiftAllRes
         * @static
         * @param {Scene.IGetVisitorGiftAllRes=} [properties] Properties to set
         * @returns {Scene.GetVisitorGiftAllRes} GetVisitorGiftAllRes instance
         */
        GetVisitorGiftAllRes.create = function create(properties) {
            return new GetVisitorGiftAllRes(properties);
        };

        /**
         * Encodes the specified GetVisitorGiftAllRes message. Does not implicitly {@link Scene.GetVisitorGiftAllRes.verify|verify} messages.
         * @function encode
         * @memberof Scene.GetVisitorGiftAllRes
         * @static
         * @param {Scene.IGetVisitorGiftAllRes} message GetVisitorGiftAllRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetVisitorGiftAllRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetVisitorGiftAllRes message, length delimited. Does not implicitly {@link Scene.GetVisitorGiftAllRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.GetVisitorGiftAllRes
         * @static
         * @param {Scene.IGetVisitorGiftAllRes} message GetVisitorGiftAllRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetVisitorGiftAllRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetVisitorGiftAllRes message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.GetVisitorGiftAllRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.GetVisitorGiftAllRes} GetVisitorGiftAllRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetVisitorGiftAllRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.GetVisitorGiftAllRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetVisitorGiftAllRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.GetVisitorGiftAllRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.GetVisitorGiftAllRes} GetVisitorGiftAllRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetVisitorGiftAllRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetVisitorGiftAllRes message.
         * @function verify
         * @memberof Scene.GetVisitorGiftAllRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetVisitorGiftAllRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return GetVisitorGiftAllRes;
    })();

    Scene.GetVisitorGiftSingleReq = (function() {

        /**
         * Properties of a GetVisitorGiftSingleReq.
         * @memberof Scene
         * @interface IGetVisitorGiftSingleReq
         * @property {string|null} [id] GetVisitorGiftSingleReq id
         */

        /**
         * Constructs a new GetVisitorGiftSingleReq.
         * @memberof Scene
         * @classdesc Represents a GetVisitorGiftSingleReq.
         * @implements IGetVisitorGiftSingleReq
         * @constructor
         * @param {Scene.IGetVisitorGiftSingleReq=} [properties] Properties to set
         */
        function GetVisitorGiftSingleReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetVisitorGiftSingleReq id.
         * @member {string} id
         * @memberof Scene.GetVisitorGiftSingleReq
         * @instance
         */
        GetVisitorGiftSingleReq.prototype.id = "";

        /**
         * Creates a new GetVisitorGiftSingleReq instance using the specified properties.
         * @function create
         * @memberof Scene.GetVisitorGiftSingleReq
         * @static
         * @param {Scene.IGetVisitorGiftSingleReq=} [properties] Properties to set
         * @returns {Scene.GetVisitorGiftSingleReq} GetVisitorGiftSingleReq instance
         */
        GetVisitorGiftSingleReq.create = function create(properties) {
            return new GetVisitorGiftSingleReq(properties);
        };

        /**
         * Encodes the specified GetVisitorGiftSingleReq message. Does not implicitly {@link Scene.GetVisitorGiftSingleReq.verify|verify} messages.
         * @function encode
         * @memberof Scene.GetVisitorGiftSingleReq
         * @static
         * @param {Scene.IGetVisitorGiftSingleReq} message GetVisitorGiftSingleReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetVisitorGiftSingleReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.id != null && message.hasOwnProperty("id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.id);
            return writer;
        };

        /**
         * Encodes the specified GetVisitorGiftSingleReq message, length delimited. Does not implicitly {@link Scene.GetVisitorGiftSingleReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.GetVisitorGiftSingleReq
         * @static
         * @param {Scene.IGetVisitorGiftSingleReq} message GetVisitorGiftSingleReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetVisitorGiftSingleReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetVisitorGiftSingleReq message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.GetVisitorGiftSingleReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.GetVisitorGiftSingleReq} GetVisitorGiftSingleReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetVisitorGiftSingleReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.GetVisitorGiftSingleReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetVisitorGiftSingleReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.GetVisitorGiftSingleReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.GetVisitorGiftSingleReq} GetVisitorGiftSingleReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetVisitorGiftSingleReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetVisitorGiftSingleReq message.
         * @function verify
         * @memberof Scene.GetVisitorGiftSingleReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetVisitorGiftSingleReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.id != null && message.hasOwnProperty("id"))
                if (!$util.isString(message.id))
                    return "id: string expected";
            return null;
        };

        return GetVisitorGiftSingleReq;
    })();

    Scene.GetVisitorGiftSingleRes = (function() {

        /**
         * Properties of a GetVisitorGiftSingleRes.
         * @memberof Scene
         * @interface IGetVisitorGiftSingleRes
         * @property {BaseInfo.IRewards|null} [rewards] GetVisitorGiftSingleRes rewards
         * @property {BaseInfo.ICurrencyBag|null} [bag] GetVisitorGiftSingleRes bag
         * @property {Array.<Scene.IVisitorReward>|null} [visitorRewards] GetVisitorGiftSingleRes visitorRewards
         */

        /**
         * Constructs a new GetVisitorGiftSingleRes.
         * @memberof Scene
         * @classdesc Represents a GetVisitorGiftSingleRes.
         * @implements IGetVisitorGiftSingleRes
         * @constructor
         * @param {Scene.IGetVisitorGiftSingleRes=} [properties] Properties to set
         */
        function GetVisitorGiftSingleRes(properties) {
            this.visitorRewards = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetVisitorGiftSingleRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Scene.GetVisitorGiftSingleRes
         * @instance
         */
        GetVisitorGiftSingleRes.prototype.rewards = null;

        /**
         * GetVisitorGiftSingleRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Scene.GetVisitorGiftSingleRes
         * @instance
         */
        GetVisitorGiftSingleRes.prototype.bag = null;

        /**
         * GetVisitorGiftSingleRes visitorRewards.
         * @member {Array.<Scene.IVisitorReward>} visitorRewards
         * @memberof Scene.GetVisitorGiftSingleRes
         * @instance
         */
        GetVisitorGiftSingleRes.prototype.visitorRewards = $util.emptyArray;

        /**
         * Creates a new GetVisitorGiftSingleRes instance using the specified properties.
         * @function create
         * @memberof Scene.GetVisitorGiftSingleRes
         * @static
         * @param {Scene.IGetVisitorGiftSingleRes=} [properties] Properties to set
         * @returns {Scene.GetVisitorGiftSingleRes} GetVisitorGiftSingleRes instance
         */
        GetVisitorGiftSingleRes.create = function create(properties) {
            return new GetVisitorGiftSingleRes(properties);
        };

        /**
         * Encodes the specified GetVisitorGiftSingleRes message. Does not implicitly {@link Scene.GetVisitorGiftSingleRes.verify|verify} messages.
         * @function encode
         * @memberof Scene.GetVisitorGiftSingleRes
         * @static
         * @param {Scene.IGetVisitorGiftSingleRes} message GetVisitorGiftSingleRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetVisitorGiftSingleRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.visitorRewards != null && message.visitorRewards.length)
                for (var i = 0; i < message.visitorRewards.length; ++i)
                    $root.Scene.VisitorReward.encode(message.visitorRewards[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetVisitorGiftSingleRes message, length delimited. Does not implicitly {@link Scene.GetVisitorGiftSingleRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.GetVisitorGiftSingleRes
         * @static
         * @param {Scene.IGetVisitorGiftSingleRes} message GetVisitorGiftSingleRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetVisitorGiftSingleRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetVisitorGiftSingleRes message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.GetVisitorGiftSingleRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.GetVisitorGiftSingleRes} GetVisitorGiftSingleRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetVisitorGiftSingleRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.GetVisitorGiftSingleRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    if (!(message.visitorRewards && message.visitorRewards.length))
                        message.visitorRewards = [];
                    message.visitorRewards.push($root.Scene.VisitorReward.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetVisitorGiftSingleRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.GetVisitorGiftSingleRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.GetVisitorGiftSingleRes} GetVisitorGiftSingleRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetVisitorGiftSingleRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetVisitorGiftSingleRes message.
         * @function verify
         * @memberof Scene.GetVisitorGiftSingleRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetVisitorGiftSingleRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.visitorRewards != null && message.hasOwnProperty("visitorRewards")) {
                if (!Array.isArray(message.visitorRewards))
                    return "visitorRewards: array expected";
                for (var i = 0; i < message.visitorRewards.length; ++i) {
                    var error = $root.Scene.VisitorReward.verify(message.visitorRewards[i]);
                    if (error)
                        return "visitorRewards." + error;
                }
            }
            return null;
        };

        return GetVisitorGiftSingleRes;
    })();

    Scene.CatFoodSubscribeReq = (function() {

        /**
         * Properties of a CatFoodSubscribeReq.
         * @memberof Scene
         * @interface ICatFoodSubscribeReq
         * @property {number|Long|null} [endTime] CatFoodSubscribeReq endTime
         */

        /**
         * Constructs a new CatFoodSubscribeReq.
         * @memberof Scene
         * @classdesc Represents a CatFoodSubscribeReq.
         * @implements ICatFoodSubscribeReq
         * @constructor
         * @param {Scene.ICatFoodSubscribeReq=} [properties] Properties to set
         */
        function CatFoodSubscribeReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CatFoodSubscribeReq endTime.
         * @member {number|Long} endTime
         * @memberof Scene.CatFoodSubscribeReq
         * @instance
         */
        CatFoodSubscribeReq.prototype.endTime = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new CatFoodSubscribeReq instance using the specified properties.
         * @function create
         * @memberof Scene.CatFoodSubscribeReq
         * @static
         * @param {Scene.ICatFoodSubscribeReq=} [properties] Properties to set
         * @returns {Scene.CatFoodSubscribeReq} CatFoodSubscribeReq instance
         */
        CatFoodSubscribeReq.create = function create(properties) {
            return new CatFoodSubscribeReq(properties);
        };

        /**
         * Encodes the specified CatFoodSubscribeReq message. Does not implicitly {@link Scene.CatFoodSubscribeReq.verify|verify} messages.
         * @function encode
         * @memberof Scene.CatFoodSubscribeReq
         * @static
         * @param {Scene.ICatFoodSubscribeReq} message CatFoodSubscribeReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatFoodSubscribeReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.endTime != null && message.hasOwnProperty("endTime"))
                writer.uint32(/* id 1, wireType 0 =*/8).int64(message.endTime);
            return writer;
        };

        /**
         * Encodes the specified CatFoodSubscribeReq message, length delimited. Does not implicitly {@link Scene.CatFoodSubscribeReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.CatFoodSubscribeReq
         * @static
         * @param {Scene.ICatFoodSubscribeReq} message CatFoodSubscribeReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatFoodSubscribeReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CatFoodSubscribeReq message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.CatFoodSubscribeReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.CatFoodSubscribeReq} CatFoodSubscribeReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatFoodSubscribeReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.CatFoodSubscribeReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.endTime = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CatFoodSubscribeReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.CatFoodSubscribeReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.CatFoodSubscribeReq} CatFoodSubscribeReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatFoodSubscribeReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CatFoodSubscribeReq message.
         * @function verify
         * @memberof Scene.CatFoodSubscribeReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CatFoodSubscribeReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.endTime != null && message.hasOwnProperty("endTime"))
                if (!$util.isInteger(message.endTime) && !(message.endTime && $util.isInteger(message.endTime.low) && $util.isInteger(message.endTime.high)))
                    return "endTime: integer|Long expected";
            return null;
        };

        return CatFoodSubscribeReq;
    })();

    Scene.CatFoodSubscribeRes = (function() {

        /**
         * Properties of a CatFoodSubscribeRes.
         * @memberof Scene
         * @interface ICatFoodSubscribeRes
         */

        /**
         * Constructs a new CatFoodSubscribeRes.
         * @memberof Scene
         * @classdesc Represents a CatFoodSubscribeRes.
         * @implements ICatFoodSubscribeRes
         * @constructor
         * @param {Scene.ICatFoodSubscribeRes=} [properties] Properties to set
         */
        function CatFoodSubscribeRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new CatFoodSubscribeRes instance using the specified properties.
         * @function create
         * @memberof Scene.CatFoodSubscribeRes
         * @static
         * @param {Scene.ICatFoodSubscribeRes=} [properties] Properties to set
         * @returns {Scene.CatFoodSubscribeRes} CatFoodSubscribeRes instance
         */
        CatFoodSubscribeRes.create = function create(properties) {
            return new CatFoodSubscribeRes(properties);
        };

        /**
         * Encodes the specified CatFoodSubscribeRes message. Does not implicitly {@link Scene.CatFoodSubscribeRes.verify|verify} messages.
         * @function encode
         * @memberof Scene.CatFoodSubscribeRes
         * @static
         * @param {Scene.ICatFoodSubscribeRes} message CatFoodSubscribeRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatFoodSubscribeRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified CatFoodSubscribeRes message, length delimited. Does not implicitly {@link Scene.CatFoodSubscribeRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.CatFoodSubscribeRes
         * @static
         * @param {Scene.ICatFoodSubscribeRes} message CatFoodSubscribeRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatFoodSubscribeRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CatFoodSubscribeRes message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.CatFoodSubscribeRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.CatFoodSubscribeRes} CatFoodSubscribeRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatFoodSubscribeRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.CatFoodSubscribeRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CatFoodSubscribeRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.CatFoodSubscribeRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.CatFoodSubscribeRes} CatFoodSubscribeRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatFoodSubscribeRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CatFoodSubscribeRes message.
         * @function verify
         * @memberof Scene.CatFoodSubscribeRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CatFoodSubscribeRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return CatFoodSubscribeRes;
    })();

    Scene.PetReward = (function() {

        /**
         * Properties of a PetReward.
         * @memberof Scene
         * @interface IPetReward
         * @property {number|null} [intimacyIncr] PetReward intimacyIncr
         * @property {number|null} [visitTimesIncr] PetReward visitTimesIncr
         */

        /**
         * Constructs a new PetReward.
         * @memberof Scene
         * @classdesc Represents a PetReward.
         * @implements IPetReward
         * @constructor
         * @param {Scene.IPetReward=} [properties] Properties to set
         */
        function PetReward(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PetReward intimacyIncr.
         * @member {number} intimacyIncr
         * @memberof Scene.PetReward
         * @instance
         */
        PetReward.prototype.intimacyIncr = 0;

        /**
         * PetReward visitTimesIncr.
         * @member {number} visitTimesIncr
         * @memberof Scene.PetReward
         * @instance
         */
        PetReward.prototype.visitTimesIncr = 0;

        /**
         * Creates a new PetReward instance using the specified properties.
         * @function create
         * @memberof Scene.PetReward
         * @static
         * @param {Scene.IPetReward=} [properties] Properties to set
         * @returns {Scene.PetReward} PetReward instance
         */
        PetReward.create = function create(properties) {
            return new PetReward(properties);
        };

        /**
         * Encodes the specified PetReward message. Does not implicitly {@link Scene.PetReward.verify|verify} messages.
         * @function encode
         * @memberof Scene.PetReward
         * @static
         * @param {Scene.IPetReward} message PetReward message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PetReward.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.intimacyIncr != null && message.hasOwnProperty("intimacyIncr"))
                writer.uint32(/* id 2, wireType 1 =*/17).double(message.intimacyIncr);
            if (message.visitTimesIncr != null && message.hasOwnProperty("visitTimesIncr"))
                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.visitTimesIncr);
            return writer;
        };

        /**
         * Encodes the specified PetReward message, length delimited. Does not implicitly {@link Scene.PetReward.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.PetReward
         * @static
         * @param {Scene.IPetReward} message PetReward message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PetReward.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PetReward message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.PetReward
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.PetReward} PetReward
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PetReward.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.PetReward();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.intimacyIncr = reader.double();
                    break;
                case 3:
                    message.visitTimesIncr = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PetReward message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.PetReward
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.PetReward} PetReward
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PetReward.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PetReward message.
         * @function verify
         * @memberof Scene.PetReward
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PetReward.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.intimacyIncr != null && message.hasOwnProperty("intimacyIncr"))
                if (typeof message.intimacyIncr !== "number")
                    return "intimacyIncr: number expected";
            if (message.visitTimesIncr != null && message.hasOwnProperty("visitTimesIncr"))
                if (!$util.isInteger(message.visitTimesIncr))
                    return "visitTimesIncr: integer expected";
            return null;
        };

        return PetReward;
    })();

    Scene.VisitorReward = (function() {

        /**
         * Properties of a VisitorReward.
         * @memberof Scene
         * @interface IVisitorReward
         * @property {string|null} [id] VisitorReward id
         * @property {string|null} [name] VisitorReward name
         * @property {string|null} [buildingId] VisitorReward buildingId
         * @property {BaseInfo.IRewards|null} [rewards] VisitorReward rewards
         * @property {string|null} [roleId] VisitorReward roleId
         */

        /**
         * Constructs a new VisitorReward.
         * @memberof Scene
         * @classdesc Represents a VisitorReward.
         * @implements IVisitorReward
         * @constructor
         * @param {Scene.IVisitorReward=} [properties] Properties to set
         */
        function VisitorReward(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * VisitorReward id.
         * @member {string} id
         * @memberof Scene.VisitorReward
         * @instance
         */
        VisitorReward.prototype.id = "";

        /**
         * VisitorReward name.
         * @member {string} name
         * @memberof Scene.VisitorReward
         * @instance
         */
        VisitorReward.prototype.name = "";

        /**
         * VisitorReward buildingId.
         * @member {string} buildingId
         * @memberof Scene.VisitorReward
         * @instance
         */
        VisitorReward.prototype.buildingId = "";

        /**
         * VisitorReward rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Scene.VisitorReward
         * @instance
         */
        VisitorReward.prototype.rewards = null;

        /**
         * VisitorReward roleId.
         * @member {string} roleId
         * @memberof Scene.VisitorReward
         * @instance
         */
        VisitorReward.prototype.roleId = "";

        /**
         * Creates a new VisitorReward instance using the specified properties.
         * @function create
         * @memberof Scene.VisitorReward
         * @static
         * @param {Scene.IVisitorReward=} [properties] Properties to set
         * @returns {Scene.VisitorReward} VisitorReward instance
         */
        VisitorReward.create = function create(properties) {
            return new VisitorReward(properties);
        };

        /**
         * Encodes the specified VisitorReward message. Does not implicitly {@link Scene.VisitorReward.verify|verify} messages.
         * @function encode
         * @memberof Scene.VisitorReward
         * @static
         * @param {Scene.IVisitorReward} message VisitorReward message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        VisitorReward.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.id != null && message.hasOwnProperty("id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.id);
            if (message.name != null && message.hasOwnProperty("name"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.name);
            if (message.buildingId != null && message.hasOwnProperty("buildingId"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.buildingId);
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            if (message.roleId != null && message.hasOwnProperty("roleId"))
                writer.uint32(/* id 6, wireType 2 =*/50).string(message.roleId);
            return writer;
        };

        /**
         * Encodes the specified VisitorReward message, length delimited. Does not implicitly {@link Scene.VisitorReward.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Scene.VisitorReward
         * @static
         * @param {Scene.IVisitorReward} message VisitorReward message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        VisitorReward.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a VisitorReward message from the specified reader or buffer.
         * @function decode
         * @memberof Scene.VisitorReward
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Scene.VisitorReward} VisitorReward
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        VisitorReward.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Scene.VisitorReward();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.name = reader.string();
                    break;
                case 3:
                    message.buildingId = reader.string();
                    break;
                case 4:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.roleId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a VisitorReward message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Scene.VisitorReward
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Scene.VisitorReward} VisitorReward
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        VisitorReward.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a VisitorReward message.
         * @function verify
         * @memberof Scene.VisitorReward
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        VisitorReward.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.id != null && message.hasOwnProperty("id"))
                if (!$util.isString(message.id))
                    return "id: string expected";
            if (message.name != null && message.hasOwnProperty("name"))
                if (!$util.isString(message.name))
                    return "name: string expected";
            if (message.buildingId != null && message.hasOwnProperty("buildingId"))
                if (!$util.isString(message.buildingId))
                    return "buildingId: string expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.roleId != null && message.hasOwnProperty("roleId"))
                if (!$util.isString(message.roleId))
                    return "roleId: string expected";
            return null;
        };

        return VisitorReward;
    })();

    return Scene;
})();

$root.Task = (function() {

    /**
     * Namespace Task.
     * @exports Task
     * @namespace
     */
    var Task = {};

    Task.GetAllTasksReq = (function() {

        /**
         * Properties of a GetAllTasksReq.
         * @memberof Task
         * @interface IGetAllTasksReq
         */

        /**
         * Constructs a new GetAllTasksReq.
         * @memberof Task
         * @classdesc Represents a GetAllTasksReq.
         * @implements IGetAllTasksReq
         * @constructor
         * @param {Task.IGetAllTasksReq=} [properties] Properties to set
         */
        function GetAllTasksReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetAllTasksReq instance using the specified properties.
         * @function create
         * @memberof Task.GetAllTasksReq
         * @static
         * @param {Task.IGetAllTasksReq=} [properties] Properties to set
         * @returns {Task.GetAllTasksReq} GetAllTasksReq instance
         */
        GetAllTasksReq.create = function create(properties) {
            return new GetAllTasksReq(properties);
        };

        /**
         * Encodes the specified GetAllTasksReq message. Does not implicitly {@link Task.GetAllTasksReq.verify|verify} messages.
         * @function encode
         * @memberof Task.GetAllTasksReq
         * @static
         * @param {Task.IGetAllTasksReq} message GetAllTasksReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetAllTasksReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetAllTasksReq message, length delimited. Does not implicitly {@link Task.GetAllTasksReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Task.GetAllTasksReq
         * @static
         * @param {Task.IGetAllTasksReq} message GetAllTasksReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetAllTasksReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetAllTasksReq message from the specified reader or buffer.
         * @function decode
         * @memberof Task.GetAllTasksReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Task.GetAllTasksReq} GetAllTasksReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetAllTasksReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Task.GetAllTasksReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetAllTasksReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Task.GetAllTasksReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Task.GetAllTasksReq} GetAllTasksReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetAllTasksReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetAllTasksReq message.
         * @function verify
         * @memberof Task.GetAllTasksReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetAllTasksReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetAllTasksReq;
    })();

    Task.GetAllTasksRes = (function() {

        /**
         * Properties of a GetAllTasksRes.
         * @memberof Task
         * @interface IGetAllTasksRes
         * @property {BaseInfo.ITasks|null} [tasks] GetAllTasksRes tasks
         * @property {number|null} [registerDays] GetAllTasksRes registerDays
         */

        /**
         * Constructs a new GetAllTasksRes.
         * @memberof Task
         * @classdesc Represents a GetAllTasksRes.
         * @implements IGetAllTasksRes
         * @constructor
         * @param {Task.IGetAllTasksRes=} [properties] Properties to set
         */
        function GetAllTasksRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetAllTasksRes tasks.
         * @member {BaseInfo.ITasks|null|undefined} tasks
         * @memberof Task.GetAllTasksRes
         * @instance
         */
        GetAllTasksRes.prototype.tasks = null;

        /**
         * GetAllTasksRes registerDays.
         * @member {number} registerDays
         * @memberof Task.GetAllTasksRes
         * @instance
         */
        GetAllTasksRes.prototype.registerDays = 0;

        /**
         * Creates a new GetAllTasksRes instance using the specified properties.
         * @function create
         * @memberof Task.GetAllTasksRes
         * @static
         * @param {Task.IGetAllTasksRes=} [properties] Properties to set
         * @returns {Task.GetAllTasksRes} GetAllTasksRes instance
         */
        GetAllTasksRes.create = function create(properties) {
            return new GetAllTasksRes(properties);
        };

        /**
         * Encodes the specified GetAllTasksRes message. Does not implicitly {@link Task.GetAllTasksRes.verify|verify} messages.
         * @function encode
         * @memberof Task.GetAllTasksRes
         * @static
         * @param {Task.IGetAllTasksRes} message GetAllTasksRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetAllTasksRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.tasks != null && message.hasOwnProperty("tasks"))
                $root.BaseInfo.Tasks.encode(message.tasks, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.registerDays != null && message.hasOwnProperty("registerDays"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.registerDays);
            return writer;
        };

        /**
         * Encodes the specified GetAllTasksRes message, length delimited. Does not implicitly {@link Task.GetAllTasksRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Task.GetAllTasksRes
         * @static
         * @param {Task.IGetAllTasksRes} message GetAllTasksRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetAllTasksRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetAllTasksRes message from the specified reader or buffer.
         * @function decode
         * @memberof Task.GetAllTasksRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Task.GetAllTasksRes} GetAllTasksRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetAllTasksRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Task.GetAllTasksRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.tasks = $root.BaseInfo.Tasks.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.registerDays = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetAllTasksRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Task.GetAllTasksRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Task.GetAllTasksRes} GetAllTasksRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetAllTasksRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetAllTasksRes message.
         * @function verify
         * @memberof Task.GetAllTasksRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetAllTasksRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.tasks != null && message.hasOwnProperty("tasks")) {
                var error = $root.BaseInfo.Tasks.verify(message.tasks);
                if (error)
                    return "tasks." + error;
            }
            if (message.registerDays != null && message.hasOwnProperty("registerDays"))
                if (!$util.isInteger(message.registerDays))
                    return "registerDays: integer expected";
            return null;
        };

        return GetAllTasksRes;
    })();

    Task.getDailyTaskRewardReq = (function() {

        /**
         * Properties of a getDailyTaskRewardReq.
         * @memberof Task
         * @interface IgetDailyTaskRewardReq
         * @property {string|null} [taskId] getDailyTaskRewardReq taskId
         */

        /**
         * Constructs a new getDailyTaskRewardReq.
         * @memberof Task
         * @classdesc Represents a getDailyTaskRewardReq.
         * @implements IgetDailyTaskRewardReq
         * @constructor
         * @param {Task.IgetDailyTaskRewardReq=} [properties] Properties to set
         */
        function getDailyTaskRewardReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * getDailyTaskRewardReq taskId.
         * @member {string} taskId
         * @memberof Task.getDailyTaskRewardReq
         * @instance
         */
        getDailyTaskRewardReq.prototype.taskId = "";

        /**
         * Creates a new getDailyTaskRewardReq instance using the specified properties.
         * @function create
         * @memberof Task.getDailyTaskRewardReq
         * @static
         * @param {Task.IgetDailyTaskRewardReq=} [properties] Properties to set
         * @returns {Task.getDailyTaskRewardReq} getDailyTaskRewardReq instance
         */
        getDailyTaskRewardReq.create = function create(properties) {
            return new getDailyTaskRewardReq(properties);
        };

        /**
         * Encodes the specified getDailyTaskRewardReq message. Does not implicitly {@link Task.getDailyTaskRewardReq.verify|verify} messages.
         * @function encode
         * @memberof Task.getDailyTaskRewardReq
         * @static
         * @param {Task.IgetDailyTaskRewardReq} message getDailyTaskRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getDailyTaskRewardReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.taskId != null && message.hasOwnProperty("taskId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.taskId);
            return writer;
        };

        /**
         * Encodes the specified getDailyTaskRewardReq message, length delimited. Does not implicitly {@link Task.getDailyTaskRewardReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Task.getDailyTaskRewardReq
         * @static
         * @param {Task.IgetDailyTaskRewardReq} message getDailyTaskRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getDailyTaskRewardReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a getDailyTaskRewardReq message from the specified reader or buffer.
         * @function decode
         * @memberof Task.getDailyTaskRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Task.getDailyTaskRewardReq} getDailyTaskRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getDailyTaskRewardReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Task.getDailyTaskRewardReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.taskId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a getDailyTaskRewardReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Task.getDailyTaskRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Task.getDailyTaskRewardReq} getDailyTaskRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getDailyTaskRewardReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a getDailyTaskRewardReq message.
         * @function verify
         * @memberof Task.getDailyTaskRewardReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        getDailyTaskRewardReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.taskId != null && message.hasOwnProperty("taskId"))
                if (!$util.isString(message.taskId))
                    return "taskId: string expected";
            return null;
        };

        return getDailyTaskRewardReq;
    })();

    Task.getDailyTaskRewardRes = (function() {

        /**
         * Properties of a getDailyTaskRewardRes.
         * @memberof Task
         * @interface IgetDailyTaskRewardRes
         * @property {BaseInfo.ITasks|null} [tasks] getDailyTaskRewardRes tasks
         * @property {BaseInfo.ICurrencyBag|null} [bag] getDailyTaskRewardRes bag
         * @property {BaseInfo.IRewards|null} [rewards] getDailyTaskRewardRes rewards
         */

        /**
         * Constructs a new getDailyTaskRewardRes.
         * @memberof Task
         * @classdesc Represents a getDailyTaskRewardRes.
         * @implements IgetDailyTaskRewardRes
         * @constructor
         * @param {Task.IgetDailyTaskRewardRes=} [properties] Properties to set
         */
        function getDailyTaskRewardRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * getDailyTaskRewardRes tasks.
         * @member {BaseInfo.ITasks|null|undefined} tasks
         * @memberof Task.getDailyTaskRewardRes
         * @instance
         */
        getDailyTaskRewardRes.prototype.tasks = null;

        /**
         * getDailyTaskRewardRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Task.getDailyTaskRewardRes
         * @instance
         */
        getDailyTaskRewardRes.prototype.bag = null;

        /**
         * getDailyTaskRewardRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Task.getDailyTaskRewardRes
         * @instance
         */
        getDailyTaskRewardRes.prototype.rewards = null;

        /**
         * Creates a new getDailyTaskRewardRes instance using the specified properties.
         * @function create
         * @memberof Task.getDailyTaskRewardRes
         * @static
         * @param {Task.IgetDailyTaskRewardRes=} [properties] Properties to set
         * @returns {Task.getDailyTaskRewardRes} getDailyTaskRewardRes instance
         */
        getDailyTaskRewardRes.create = function create(properties) {
            return new getDailyTaskRewardRes(properties);
        };

        /**
         * Encodes the specified getDailyTaskRewardRes message. Does not implicitly {@link Task.getDailyTaskRewardRes.verify|verify} messages.
         * @function encode
         * @memberof Task.getDailyTaskRewardRes
         * @static
         * @param {Task.IgetDailyTaskRewardRes} message getDailyTaskRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getDailyTaskRewardRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.tasks != null && message.hasOwnProperty("tasks"))
                $root.BaseInfo.Tasks.encode(message.tasks, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified getDailyTaskRewardRes message, length delimited. Does not implicitly {@link Task.getDailyTaskRewardRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Task.getDailyTaskRewardRes
         * @static
         * @param {Task.IgetDailyTaskRewardRes} message getDailyTaskRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getDailyTaskRewardRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a getDailyTaskRewardRes message from the specified reader or buffer.
         * @function decode
         * @memberof Task.getDailyTaskRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Task.getDailyTaskRewardRes} getDailyTaskRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getDailyTaskRewardRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Task.getDailyTaskRewardRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.tasks = $root.BaseInfo.Tasks.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a getDailyTaskRewardRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Task.getDailyTaskRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Task.getDailyTaskRewardRes} getDailyTaskRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getDailyTaskRewardRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a getDailyTaskRewardRes message.
         * @function verify
         * @memberof Task.getDailyTaskRewardRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        getDailyTaskRewardRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.tasks != null && message.hasOwnProperty("tasks")) {
                var error = $root.BaseInfo.Tasks.verify(message.tasks);
                if (error)
                    return "tasks." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            return null;
        };

        return getDailyTaskRewardRes;
    })();

    Task.getTrophyTaskRewardReq = (function() {

        /**
         * Properties of a getTrophyTaskRewardReq.
         * @memberof Task
         * @interface IgetTrophyTaskRewardReq
         * @property {string|null} [taskId] getTrophyTaskRewardReq taskId
         */

        /**
         * Constructs a new getTrophyTaskRewardReq.
         * @memberof Task
         * @classdesc Represents a getTrophyTaskRewardReq.
         * @implements IgetTrophyTaskRewardReq
         * @constructor
         * @param {Task.IgetTrophyTaskRewardReq=} [properties] Properties to set
         */
        function getTrophyTaskRewardReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * getTrophyTaskRewardReq taskId.
         * @member {string} taskId
         * @memberof Task.getTrophyTaskRewardReq
         * @instance
         */
        getTrophyTaskRewardReq.prototype.taskId = "";

        /**
         * Creates a new getTrophyTaskRewardReq instance using the specified properties.
         * @function create
         * @memberof Task.getTrophyTaskRewardReq
         * @static
         * @param {Task.IgetTrophyTaskRewardReq=} [properties] Properties to set
         * @returns {Task.getTrophyTaskRewardReq} getTrophyTaskRewardReq instance
         */
        getTrophyTaskRewardReq.create = function create(properties) {
            return new getTrophyTaskRewardReq(properties);
        };

        /**
         * Encodes the specified getTrophyTaskRewardReq message. Does not implicitly {@link Task.getTrophyTaskRewardReq.verify|verify} messages.
         * @function encode
         * @memberof Task.getTrophyTaskRewardReq
         * @static
         * @param {Task.IgetTrophyTaskRewardReq} message getTrophyTaskRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getTrophyTaskRewardReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.taskId != null && message.hasOwnProperty("taskId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.taskId);
            return writer;
        };

        /**
         * Encodes the specified getTrophyTaskRewardReq message, length delimited. Does not implicitly {@link Task.getTrophyTaskRewardReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Task.getTrophyTaskRewardReq
         * @static
         * @param {Task.IgetTrophyTaskRewardReq} message getTrophyTaskRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getTrophyTaskRewardReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a getTrophyTaskRewardReq message from the specified reader or buffer.
         * @function decode
         * @memberof Task.getTrophyTaskRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Task.getTrophyTaskRewardReq} getTrophyTaskRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getTrophyTaskRewardReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Task.getTrophyTaskRewardReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.taskId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a getTrophyTaskRewardReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Task.getTrophyTaskRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Task.getTrophyTaskRewardReq} getTrophyTaskRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getTrophyTaskRewardReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a getTrophyTaskRewardReq message.
         * @function verify
         * @memberof Task.getTrophyTaskRewardReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        getTrophyTaskRewardReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.taskId != null && message.hasOwnProperty("taskId"))
                if (!$util.isString(message.taskId))
                    return "taskId: string expected";
            return null;
        };

        return getTrophyTaskRewardReq;
    })();

    Task.getTrophyTaskRewardRes = (function() {

        /**
         * Properties of a getTrophyTaskRewardRes.
         * @memberof Task
         * @interface IgetTrophyTaskRewardRes
         * @property {BaseInfo.ITasks|null} [tasks] getTrophyTaskRewardRes tasks
         * @property {BaseInfo.ICurrencyBag|null} [bag] getTrophyTaskRewardRes bag
         * @property {BaseInfo.IRewards|null} [rewards] getTrophyTaskRewardRes rewards
         */

        /**
         * Constructs a new getTrophyTaskRewardRes.
         * @memberof Task
         * @classdesc Represents a getTrophyTaskRewardRes.
         * @implements IgetTrophyTaskRewardRes
         * @constructor
         * @param {Task.IgetTrophyTaskRewardRes=} [properties] Properties to set
         */
        function getTrophyTaskRewardRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * getTrophyTaskRewardRes tasks.
         * @member {BaseInfo.ITasks|null|undefined} tasks
         * @memberof Task.getTrophyTaskRewardRes
         * @instance
         */
        getTrophyTaskRewardRes.prototype.tasks = null;

        /**
         * getTrophyTaskRewardRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Task.getTrophyTaskRewardRes
         * @instance
         */
        getTrophyTaskRewardRes.prototype.bag = null;

        /**
         * getTrophyTaskRewardRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Task.getTrophyTaskRewardRes
         * @instance
         */
        getTrophyTaskRewardRes.prototype.rewards = null;

        /**
         * Creates a new getTrophyTaskRewardRes instance using the specified properties.
         * @function create
         * @memberof Task.getTrophyTaskRewardRes
         * @static
         * @param {Task.IgetTrophyTaskRewardRes=} [properties] Properties to set
         * @returns {Task.getTrophyTaskRewardRes} getTrophyTaskRewardRes instance
         */
        getTrophyTaskRewardRes.create = function create(properties) {
            return new getTrophyTaskRewardRes(properties);
        };

        /**
         * Encodes the specified getTrophyTaskRewardRes message. Does not implicitly {@link Task.getTrophyTaskRewardRes.verify|verify} messages.
         * @function encode
         * @memberof Task.getTrophyTaskRewardRes
         * @static
         * @param {Task.IgetTrophyTaskRewardRes} message getTrophyTaskRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getTrophyTaskRewardRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.tasks != null && message.hasOwnProperty("tasks"))
                $root.BaseInfo.Tasks.encode(message.tasks, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified getTrophyTaskRewardRes message, length delimited. Does not implicitly {@link Task.getTrophyTaskRewardRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Task.getTrophyTaskRewardRes
         * @static
         * @param {Task.IgetTrophyTaskRewardRes} message getTrophyTaskRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getTrophyTaskRewardRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a getTrophyTaskRewardRes message from the specified reader or buffer.
         * @function decode
         * @memberof Task.getTrophyTaskRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Task.getTrophyTaskRewardRes} getTrophyTaskRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getTrophyTaskRewardRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Task.getTrophyTaskRewardRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.tasks = $root.BaseInfo.Tasks.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a getTrophyTaskRewardRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Task.getTrophyTaskRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Task.getTrophyTaskRewardRes} getTrophyTaskRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getTrophyTaskRewardRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a getTrophyTaskRewardRes message.
         * @function verify
         * @memberof Task.getTrophyTaskRewardRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        getTrophyTaskRewardRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.tasks != null && message.hasOwnProperty("tasks")) {
                var error = $root.BaseInfo.Tasks.verify(message.tasks);
                if (error)
                    return "tasks." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            return null;
        };

        return getTrophyTaskRewardRes;
    })();

    Task.getDailyTaskRewardWithAdReq = (function() {

        /**
         * Properties of a getDailyTaskRewardWithAdReq.
         * @memberof Task
         * @interface IgetDailyTaskRewardWithAdReq
         * @property {string|null} [taskId] getDailyTaskRewardWithAdReq taskId
         * @property {BaseInfo.FetchType|null} [fetchType] getDailyTaskRewardWithAdReq fetchType
         */

        /**
         * Constructs a new getDailyTaskRewardWithAdReq.
         * @memberof Task
         * @classdesc Represents a getDailyTaskRewardWithAdReq.
         * @implements IgetDailyTaskRewardWithAdReq
         * @constructor
         * @param {Task.IgetDailyTaskRewardWithAdReq=} [properties] Properties to set
         */
        function getDailyTaskRewardWithAdReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * getDailyTaskRewardWithAdReq taskId.
         * @member {string} taskId
         * @memberof Task.getDailyTaskRewardWithAdReq
         * @instance
         */
        getDailyTaskRewardWithAdReq.prototype.taskId = "";

        /**
         * getDailyTaskRewardWithAdReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof Task.getDailyTaskRewardWithAdReq
         * @instance
         */
        getDailyTaskRewardWithAdReq.prototype.fetchType = 0;

        /**
         * Creates a new getDailyTaskRewardWithAdReq instance using the specified properties.
         * @function create
         * @memberof Task.getDailyTaskRewardWithAdReq
         * @static
         * @param {Task.IgetDailyTaskRewardWithAdReq=} [properties] Properties to set
         * @returns {Task.getDailyTaskRewardWithAdReq} getDailyTaskRewardWithAdReq instance
         */
        getDailyTaskRewardWithAdReq.create = function create(properties) {
            return new getDailyTaskRewardWithAdReq(properties);
        };

        /**
         * Encodes the specified getDailyTaskRewardWithAdReq message. Does not implicitly {@link Task.getDailyTaskRewardWithAdReq.verify|verify} messages.
         * @function encode
         * @memberof Task.getDailyTaskRewardWithAdReq
         * @static
         * @param {Task.IgetDailyTaskRewardWithAdReq} message getDailyTaskRewardWithAdReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getDailyTaskRewardWithAdReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.taskId != null && message.hasOwnProperty("taskId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.taskId);
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified getDailyTaskRewardWithAdReq message, length delimited. Does not implicitly {@link Task.getDailyTaskRewardWithAdReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Task.getDailyTaskRewardWithAdReq
         * @static
         * @param {Task.IgetDailyTaskRewardWithAdReq} message getDailyTaskRewardWithAdReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getDailyTaskRewardWithAdReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a getDailyTaskRewardWithAdReq message from the specified reader or buffer.
         * @function decode
         * @memberof Task.getDailyTaskRewardWithAdReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Task.getDailyTaskRewardWithAdReq} getDailyTaskRewardWithAdReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getDailyTaskRewardWithAdReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Task.getDailyTaskRewardWithAdReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.taskId = reader.string();
                    break;
                case 3:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a getDailyTaskRewardWithAdReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Task.getDailyTaskRewardWithAdReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Task.getDailyTaskRewardWithAdReq} getDailyTaskRewardWithAdReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getDailyTaskRewardWithAdReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a getDailyTaskRewardWithAdReq message.
         * @function verify
         * @memberof Task.getDailyTaskRewardWithAdReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        getDailyTaskRewardWithAdReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.taskId != null && message.hasOwnProperty("taskId"))
                if (!$util.isString(message.taskId))
                    return "taskId: string expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return getDailyTaskRewardWithAdReq;
    })();

    Task.getDailyTaskRewardWithAdRes = (function() {

        /**
         * Properties of a getDailyTaskRewardWithAdRes.
         * @memberof Task
         * @interface IgetDailyTaskRewardWithAdRes
         * @property {BaseInfo.ITasks|null} [tasks] getDailyTaskRewardWithAdRes tasks
         * @property {BaseInfo.ICurrencyBag|null} [bag] getDailyTaskRewardWithAdRes bag
         * @property {BaseInfo.IRewards|null} [rewards] getDailyTaskRewardWithAdRes rewards
         * @property {BaseInfo.IAdRewardsInfo|null} [adRewardsInfo] getDailyTaskRewardWithAdRes adRewardsInfo
         */

        /**
         * Constructs a new getDailyTaskRewardWithAdRes.
         * @memberof Task
         * @classdesc Represents a getDailyTaskRewardWithAdRes.
         * @implements IgetDailyTaskRewardWithAdRes
         * @constructor
         * @param {Task.IgetDailyTaskRewardWithAdRes=} [properties] Properties to set
         */
        function getDailyTaskRewardWithAdRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * getDailyTaskRewardWithAdRes tasks.
         * @member {BaseInfo.ITasks|null|undefined} tasks
         * @memberof Task.getDailyTaskRewardWithAdRes
         * @instance
         */
        getDailyTaskRewardWithAdRes.prototype.tasks = null;

        /**
         * getDailyTaskRewardWithAdRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Task.getDailyTaskRewardWithAdRes
         * @instance
         */
        getDailyTaskRewardWithAdRes.prototype.bag = null;

        /**
         * getDailyTaskRewardWithAdRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Task.getDailyTaskRewardWithAdRes
         * @instance
         */
        getDailyTaskRewardWithAdRes.prototype.rewards = null;

        /**
         * getDailyTaskRewardWithAdRes adRewardsInfo.
         * @member {BaseInfo.IAdRewardsInfo|null|undefined} adRewardsInfo
         * @memberof Task.getDailyTaskRewardWithAdRes
         * @instance
         */
        getDailyTaskRewardWithAdRes.prototype.adRewardsInfo = null;

        /**
         * Creates a new getDailyTaskRewardWithAdRes instance using the specified properties.
         * @function create
         * @memberof Task.getDailyTaskRewardWithAdRes
         * @static
         * @param {Task.IgetDailyTaskRewardWithAdRes=} [properties] Properties to set
         * @returns {Task.getDailyTaskRewardWithAdRes} getDailyTaskRewardWithAdRes instance
         */
        getDailyTaskRewardWithAdRes.create = function create(properties) {
            return new getDailyTaskRewardWithAdRes(properties);
        };

        /**
         * Encodes the specified getDailyTaskRewardWithAdRes message. Does not implicitly {@link Task.getDailyTaskRewardWithAdRes.verify|verify} messages.
         * @function encode
         * @memberof Task.getDailyTaskRewardWithAdRes
         * @static
         * @param {Task.IgetDailyTaskRewardWithAdRes} message getDailyTaskRewardWithAdRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getDailyTaskRewardWithAdRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.tasks != null && message.hasOwnProperty("tasks"))
                $root.BaseInfo.Tasks.encode(message.tasks, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.adRewardsInfo != null && message.hasOwnProperty("adRewardsInfo"))
                $root.BaseInfo.AdRewardsInfo.encode(message.adRewardsInfo, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified getDailyTaskRewardWithAdRes message, length delimited. Does not implicitly {@link Task.getDailyTaskRewardWithAdRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Task.getDailyTaskRewardWithAdRes
         * @static
         * @param {Task.IgetDailyTaskRewardWithAdRes} message getDailyTaskRewardWithAdRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getDailyTaskRewardWithAdRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a getDailyTaskRewardWithAdRes message from the specified reader or buffer.
         * @function decode
         * @memberof Task.getDailyTaskRewardWithAdRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Task.getDailyTaskRewardWithAdRes} getDailyTaskRewardWithAdRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getDailyTaskRewardWithAdRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Task.getDailyTaskRewardWithAdRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.tasks = $root.BaseInfo.Tasks.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.adRewardsInfo = $root.BaseInfo.AdRewardsInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a getDailyTaskRewardWithAdRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Task.getDailyTaskRewardWithAdRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Task.getDailyTaskRewardWithAdRes} getDailyTaskRewardWithAdRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getDailyTaskRewardWithAdRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a getDailyTaskRewardWithAdRes message.
         * @function verify
         * @memberof Task.getDailyTaskRewardWithAdRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        getDailyTaskRewardWithAdRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.tasks != null && message.hasOwnProperty("tasks")) {
                var error = $root.BaseInfo.Tasks.verify(message.tasks);
                if (error)
                    return "tasks." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.adRewardsInfo != null && message.hasOwnProperty("adRewardsInfo")) {
                var error = $root.BaseInfo.AdRewardsInfo.verify(message.adRewardsInfo);
                if (error)
                    return "adRewardsInfo." + error;
            }
            return null;
        };

        return getDailyTaskRewardWithAdRes;
    })();

    Task.getTrophyTaskRewardWithAdReq = (function() {

        /**
         * Properties of a getTrophyTaskRewardWithAdReq.
         * @memberof Task
         * @interface IgetTrophyTaskRewardWithAdReq
         * @property {string|null} [taskId] getTrophyTaskRewardWithAdReq taskId
         * @property {BaseInfo.FetchType|null} [fetchType] getTrophyTaskRewardWithAdReq fetchType
         */

        /**
         * Constructs a new getTrophyTaskRewardWithAdReq.
         * @memberof Task
         * @classdesc Represents a getTrophyTaskRewardWithAdReq.
         * @implements IgetTrophyTaskRewardWithAdReq
         * @constructor
         * @param {Task.IgetTrophyTaskRewardWithAdReq=} [properties] Properties to set
         */
        function getTrophyTaskRewardWithAdReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * getTrophyTaskRewardWithAdReq taskId.
         * @member {string} taskId
         * @memberof Task.getTrophyTaskRewardWithAdReq
         * @instance
         */
        getTrophyTaskRewardWithAdReq.prototype.taskId = "";

        /**
         * getTrophyTaskRewardWithAdReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof Task.getTrophyTaskRewardWithAdReq
         * @instance
         */
        getTrophyTaskRewardWithAdReq.prototype.fetchType = 0;

        /**
         * Creates a new getTrophyTaskRewardWithAdReq instance using the specified properties.
         * @function create
         * @memberof Task.getTrophyTaskRewardWithAdReq
         * @static
         * @param {Task.IgetTrophyTaskRewardWithAdReq=} [properties] Properties to set
         * @returns {Task.getTrophyTaskRewardWithAdReq} getTrophyTaskRewardWithAdReq instance
         */
        getTrophyTaskRewardWithAdReq.create = function create(properties) {
            return new getTrophyTaskRewardWithAdReq(properties);
        };

        /**
         * Encodes the specified getTrophyTaskRewardWithAdReq message. Does not implicitly {@link Task.getTrophyTaskRewardWithAdReq.verify|verify} messages.
         * @function encode
         * @memberof Task.getTrophyTaskRewardWithAdReq
         * @static
         * @param {Task.IgetTrophyTaskRewardWithAdReq} message getTrophyTaskRewardWithAdReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getTrophyTaskRewardWithAdReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.taskId != null && message.hasOwnProperty("taskId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.taskId);
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified getTrophyTaskRewardWithAdReq message, length delimited. Does not implicitly {@link Task.getTrophyTaskRewardWithAdReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Task.getTrophyTaskRewardWithAdReq
         * @static
         * @param {Task.IgetTrophyTaskRewardWithAdReq} message getTrophyTaskRewardWithAdReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getTrophyTaskRewardWithAdReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a getTrophyTaskRewardWithAdReq message from the specified reader or buffer.
         * @function decode
         * @memberof Task.getTrophyTaskRewardWithAdReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Task.getTrophyTaskRewardWithAdReq} getTrophyTaskRewardWithAdReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getTrophyTaskRewardWithAdReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Task.getTrophyTaskRewardWithAdReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.taskId = reader.string();
                    break;
                case 3:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a getTrophyTaskRewardWithAdReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Task.getTrophyTaskRewardWithAdReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Task.getTrophyTaskRewardWithAdReq} getTrophyTaskRewardWithAdReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getTrophyTaskRewardWithAdReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a getTrophyTaskRewardWithAdReq message.
         * @function verify
         * @memberof Task.getTrophyTaskRewardWithAdReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        getTrophyTaskRewardWithAdReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.taskId != null && message.hasOwnProperty("taskId"))
                if (!$util.isString(message.taskId))
                    return "taskId: string expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return getTrophyTaskRewardWithAdReq;
    })();

    Task.getTrophyTaskRewardWithAdRes = (function() {

        /**
         * Properties of a getTrophyTaskRewardWithAdRes.
         * @memberof Task
         * @interface IgetTrophyTaskRewardWithAdRes
         * @property {BaseInfo.ITasks|null} [tasks] getTrophyTaskRewardWithAdRes tasks
         * @property {BaseInfo.ICurrencyBag|null} [bag] getTrophyTaskRewardWithAdRes bag
         * @property {BaseInfo.IRewards|null} [rewards] getTrophyTaskRewardWithAdRes rewards
         * @property {BaseInfo.IAdRewardsInfo|null} [adRewardsInfo] getTrophyTaskRewardWithAdRes adRewardsInfo
         */

        /**
         * Constructs a new getTrophyTaskRewardWithAdRes.
         * @memberof Task
         * @classdesc Represents a getTrophyTaskRewardWithAdRes.
         * @implements IgetTrophyTaskRewardWithAdRes
         * @constructor
         * @param {Task.IgetTrophyTaskRewardWithAdRes=} [properties] Properties to set
         */
        function getTrophyTaskRewardWithAdRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * getTrophyTaskRewardWithAdRes tasks.
         * @member {BaseInfo.ITasks|null|undefined} tasks
         * @memberof Task.getTrophyTaskRewardWithAdRes
         * @instance
         */
        getTrophyTaskRewardWithAdRes.prototype.tasks = null;

        /**
         * getTrophyTaskRewardWithAdRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Task.getTrophyTaskRewardWithAdRes
         * @instance
         */
        getTrophyTaskRewardWithAdRes.prototype.bag = null;

        /**
         * getTrophyTaskRewardWithAdRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Task.getTrophyTaskRewardWithAdRes
         * @instance
         */
        getTrophyTaskRewardWithAdRes.prototype.rewards = null;

        /**
         * getTrophyTaskRewardWithAdRes adRewardsInfo.
         * @member {BaseInfo.IAdRewardsInfo|null|undefined} adRewardsInfo
         * @memberof Task.getTrophyTaskRewardWithAdRes
         * @instance
         */
        getTrophyTaskRewardWithAdRes.prototype.adRewardsInfo = null;

        /**
         * Creates a new getTrophyTaskRewardWithAdRes instance using the specified properties.
         * @function create
         * @memberof Task.getTrophyTaskRewardWithAdRes
         * @static
         * @param {Task.IgetTrophyTaskRewardWithAdRes=} [properties] Properties to set
         * @returns {Task.getTrophyTaskRewardWithAdRes} getTrophyTaskRewardWithAdRes instance
         */
        getTrophyTaskRewardWithAdRes.create = function create(properties) {
            return new getTrophyTaskRewardWithAdRes(properties);
        };

        /**
         * Encodes the specified getTrophyTaskRewardWithAdRes message. Does not implicitly {@link Task.getTrophyTaskRewardWithAdRes.verify|verify} messages.
         * @function encode
         * @memberof Task.getTrophyTaskRewardWithAdRes
         * @static
         * @param {Task.IgetTrophyTaskRewardWithAdRes} message getTrophyTaskRewardWithAdRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getTrophyTaskRewardWithAdRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.tasks != null && message.hasOwnProperty("tasks"))
                $root.BaseInfo.Tasks.encode(message.tasks, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.adRewardsInfo != null && message.hasOwnProperty("adRewardsInfo"))
                $root.BaseInfo.AdRewardsInfo.encode(message.adRewardsInfo, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified getTrophyTaskRewardWithAdRes message, length delimited. Does not implicitly {@link Task.getTrophyTaskRewardWithAdRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Task.getTrophyTaskRewardWithAdRes
         * @static
         * @param {Task.IgetTrophyTaskRewardWithAdRes} message getTrophyTaskRewardWithAdRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getTrophyTaskRewardWithAdRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a getTrophyTaskRewardWithAdRes message from the specified reader or buffer.
         * @function decode
         * @memberof Task.getTrophyTaskRewardWithAdRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Task.getTrophyTaskRewardWithAdRes} getTrophyTaskRewardWithAdRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getTrophyTaskRewardWithAdRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Task.getTrophyTaskRewardWithAdRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.tasks = $root.BaseInfo.Tasks.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.adRewardsInfo = $root.BaseInfo.AdRewardsInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a getTrophyTaskRewardWithAdRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Task.getTrophyTaskRewardWithAdRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Task.getTrophyTaskRewardWithAdRes} getTrophyTaskRewardWithAdRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getTrophyTaskRewardWithAdRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a getTrophyTaskRewardWithAdRes message.
         * @function verify
         * @memberof Task.getTrophyTaskRewardWithAdRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        getTrophyTaskRewardWithAdRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.tasks != null && message.hasOwnProperty("tasks")) {
                var error = $root.BaseInfo.Tasks.verify(message.tasks);
                if (error)
                    return "tasks." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.adRewardsInfo != null && message.hasOwnProperty("adRewardsInfo")) {
                var error = $root.BaseInfo.AdRewardsInfo.verify(message.adRewardsInfo);
                if (error)
                    return "adRewardsInfo." + error;
            }
            return null;
        };

        return getTrophyTaskRewardWithAdRes;
    })();

    Task.getMainTaskRewardReq = (function() {

        /**
         * Properties of a getMainTaskRewardReq.
         * @memberof Task
         * @interface IgetMainTaskRewardReq
         * @property {string|null} [taskId] getMainTaskRewardReq taskId
         */

        /**
         * Constructs a new getMainTaskRewardReq.
         * @memberof Task
         * @classdesc Represents a getMainTaskRewardReq.
         * @implements IgetMainTaskRewardReq
         * @constructor
         * @param {Task.IgetMainTaskRewardReq=} [properties] Properties to set
         */
        function getMainTaskRewardReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * getMainTaskRewardReq taskId.
         * @member {string} taskId
         * @memberof Task.getMainTaskRewardReq
         * @instance
         */
        getMainTaskRewardReq.prototype.taskId = "";

        /**
         * Creates a new getMainTaskRewardReq instance using the specified properties.
         * @function create
         * @memberof Task.getMainTaskRewardReq
         * @static
         * @param {Task.IgetMainTaskRewardReq=} [properties] Properties to set
         * @returns {Task.getMainTaskRewardReq} getMainTaskRewardReq instance
         */
        getMainTaskRewardReq.create = function create(properties) {
            return new getMainTaskRewardReq(properties);
        };

        /**
         * Encodes the specified getMainTaskRewardReq message. Does not implicitly {@link Task.getMainTaskRewardReq.verify|verify} messages.
         * @function encode
         * @memberof Task.getMainTaskRewardReq
         * @static
         * @param {Task.IgetMainTaskRewardReq} message getMainTaskRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getMainTaskRewardReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.taskId != null && message.hasOwnProperty("taskId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.taskId);
            return writer;
        };

        /**
         * Encodes the specified getMainTaskRewardReq message, length delimited. Does not implicitly {@link Task.getMainTaskRewardReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Task.getMainTaskRewardReq
         * @static
         * @param {Task.IgetMainTaskRewardReq} message getMainTaskRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getMainTaskRewardReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a getMainTaskRewardReq message from the specified reader or buffer.
         * @function decode
         * @memberof Task.getMainTaskRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Task.getMainTaskRewardReq} getMainTaskRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getMainTaskRewardReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Task.getMainTaskRewardReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.taskId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a getMainTaskRewardReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Task.getMainTaskRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Task.getMainTaskRewardReq} getMainTaskRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getMainTaskRewardReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a getMainTaskRewardReq message.
         * @function verify
         * @memberof Task.getMainTaskRewardReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        getMainTaskRewardReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.taskId != null && message.hasOwnProperty("taskId"))
                if (!$util.isString(message.taskId))
                    return "taskId: string expected";
            return null;
        };

        return getMainTaskRewardReq;
    })();

    Task.getMainTaskRewardRes = (function() {

        /**
         * Properties of a getMainTaskRewardRes.
         * @memberof Task
         * @interface IgetMainTaskRewardRes
         * @property {BaseInfo.ITasks|null} [tasks] getMainTaskRewardRes tasks
         * @property {BaseInfo.ICurrencyBag|null} [bag] getMainTaskRewardRes bag
         * @property {BaseInfo.IRewards|null} [rewards] getMainTaskRewardRes rewards
         */

        /**
         * Constructs a new getMainTaskRewardRes.
         * @memberof Task
         * @classdesc Represents a getMainTaskRewardRes.
         * @implements IgetMainTaskRewardRes
         * @constructor
         * @param {Task.IgetMainTaskRewardRes=} [properties] Properties to set
         */
        function getMainTaskRewardRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * getMainTaskRewardRes tasks.
         * @member {BaseInfo.ITasks|null|undefined} tasks
         * @memberof Task.getMainTaskRewardRes
         * @instance
         */
        getMainTaskRewardRes.prototype.tasks = null;

        /**
         * getMainTaskRewardRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Task.getMainTaskRewardRes
         * @instance
         */
        getMainTaskRewardRes.prototype.bag = null;

        /**
         * getMainTaskRewardRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Task.getMainTaskRewardRes
         * @instance
         */
        getMainTaskRewardRes.prototype.rewards = null;

        /**
         * Creates a new getMainTaskRewardRes instance using the specified properties.
         * @function create
         * @memberof Task.getMainTaskRewardRes
         * @static
         * @param {Task.IgetMainTaskRewardRes=} [properties] Properties to set
         * @returns {Task.getMainTaskRewardRes} getMainTaskRewardRes instance
         */
        getMainTaskRewardRes.create = function create(properties) {
            return new getMainTaskRewardRes(properties);
        };

        /**
         * Encodes the specified getMainTaskRewardRes message. Does not implicitly {@link Task.getMainTaskRewardRes.verify|verify} messages.
         * @function encode
         * @memberof Task.getMainTaskRewardRes
         * @static
         * @param {Task.IgetMainTaskRewardRes} message getMainTaskRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getMainTaskRewardRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.tasks != null && message.hasOwnProperty("tasks"))
                $root.BaseInfo.Tasks.encode(message.tasks, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified getMainTaskRewardRes message, length delimited. Does not implicitly {@link Task.getMainTaskRewardRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Task.getMainTaskRewardRes
         * @static
         * @param {Task.IgetMainTaskRewardRes} message getMainTaskRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        getMainTaskRewardRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a getMainTaskRewardRes message from the specified reader or buffer.
         * @function decode
         * @memberof Task.getMainTaskRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Task.getMainTaskRewardRes} getMainTaskRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getMainTaskRewardRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Task.getMainTaskRewardRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.tasks = $root.BaseInfo.Tasks.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a getMainTaskRewardRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Task.getMainTaskRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Task.getMainTaskRewardRes} getMainTaskRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        getMainTaskRewardRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a getMainTaskRewardRes message.
         * @function verify
         * @memberof Task.getMainTaskRewardRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        getMainTaskRewardRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.tasks != null && message.hasOwnProperty("tasks")) {
                var error = $root.BaseInfo.Tasks.verify(message.tasks);
                if (error)
                    return "tasks." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            return null;
        };

        return getMainTaskRewardRes;
    })();

    return Task;
})();

$root.Food = (function() {

    /**
     * Namespace Food.
     * @exports Food
     * @namespace
     */
    var Food = {};

    Food.GetPlayerFoodMenuReq = (function() {

        /**
         * Properties of a GetPlayerFoodMenuReq.
         * @memberof Food
         * @interface IGetPlayerFoodMenuReq
         */

        /**
         * Constructs a new GetPlayerFoodMenuReq.
         * @memberof Food
         * @classdesc Represents a GetPlayerFoodMenuReq.
         * @implements IGetPlayerFoodMenuReq
         * @constructor
         * @param {Food.IGetPlayerFoodMenuReq=} [properties] Properties to set
         */
        function GetPlayerFoodMenuReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetPlayerFoodMenuReq instance using the specified properties.
         * @function create
         * @memberof Food.GetPlayerFoodMenuReq
         * @static
         * @param {Food.IGetPlayerFoodMenuReq=} [properties] Properties to set
         * @returns {Food.GetPlayerFoodMenuReq} GetPlayerFoodMenuReq instance
         */
        GetPlayerFoodMenuReq.create = function create(properties) {
            return new GetPlayerFoodMenuReq(properties);
        };

        /**
         * Encodes the specified GetPlayerFoodMenuReq message. Does not implicitly {@link Food.GetPlayerFoodMenuReq.verify|verify} messages.
         * @function encode
         * @memberof Food.GetPlayerFoodMenuReq
         * @static
         * @param {Food.IGetPlayerFoodMenuReq} message GetPlayerFoodMenuReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetPlayerFoodMenuReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetPlayerFoodMenuReq message, length delimited. Does not implicitly {@link Food.GetPlayerFoodMenuReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Food.GetPlayerFoodMenuReq
         * @static
         * @param {Food.IGetPlayerFoodMenuReq} message GetPlayerFoodMenuReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetPlayerFoodMenuReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetPlayerFoodMenuReq message from the specified reader or buffer.
         * @function decode
         * @memberof Food.GetPlayerFoodMenuReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Food.GetPlayerFoodMenuReq} GetPlayerFoodMenuReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetPlayerFoodMenuReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Food.GetPlayerFoodMenuReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetPlayerFoodMenuReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Food.GetPlayerFoodMenuReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Food.GetPlayerFoodMenuReq} GetPlayerFoodMenuReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetPlayerFoodMenuReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetPlayerFoodMenuReq message.
         * @function verify
         * @memberof Food.GetPlayerFoodMenuReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetPlayerFoodMenuReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetPlayerFoodMenuReq;
    })();

    Food.GetPlayerFoodMenuRes = (function() {

        /**
         * Properties of a GetPlayerFoodMenuRes.
         * @memberof Food
         * @interface IGetPlayerFoodMenuRes
         * @property {BaseInfo.IFoodMenu|null} [menu] GetPlayerFoodMenuRes menu
         */

        /**
         * Constructs a new GetPlayerFoodMenuRes.
         * @memberof Food
         * @classdesc Represents a GetPlayerFoodMenuRes.
         * @implements IGetPlayerFoodMenuRes
         * @constructor
         * @param {Food.IGetPlayerFoodMenuRes=} [properties] Properties to set
         */
        function GetPlayerFoodMenuRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetPlayerFoodMenuRes menu.
         * @member {BaseInfo.IFoodMenu|null|undefined} menu
         * @memberof Food.GetPlayerFoodMenuRes
         * @instance
         */
        GetPlayerFoodMenuRes.prototype.menu = null;

        /**
         * Creates a new GetPlayerFoodMenuRes instance using the specified properties.
         * @function create
         * @memberof Food.GetPlayerFoodMenuRes
         * @static
         * @param {Food.IGetPlayerFoodMenuRes=} [properties] Properties to set
         * @returns {Food.GetPlayerFoodMenuRes} GetPlayerFoodMenuRes instance
         */
        GetPlayerFoodMenuRes.create = function create(properties) {
            return new GetPlayerFoodMenuRes(properties);
        };

        /**
         * Encodes the specified GetPlayerFoodMenuRes message. Does not implicitly {@link Food.GetPlayerFoodMenuRes.verify|verify} messages.
         * @function encode
         * @memberof Food.GetPlayerFoodMenuRes
         * @static
         * @param {Food.IGetPlayerFoodMenuRes} message GetPlayerFoodMenuRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetPlayerFoodMenuRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.menu != null && message.hasOwnProperty("menu"))
                $root.BaseInfo.FoodMenu.encode(message.menu, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetPlayerFoodMenuRes message, length delimited. Does not implicitly {@link Food.GetPlayerFoodMenuRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Food.GetPlayerFoodMenuRes
         * @static
         * @param {Food.IGetPlayerFoodMenuRes} message GetPlayerFoodMenuRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetPlayerFoodMenuRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetPlayerFoodMenuRes message from the specified reader or buffer.
         * @function decode
         * @memberof Food.GetPlayerFoodMenuRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Food.GetPlayerFoodMenuRes} GetPlayerFoodMenuRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetPlayerFoodMenuRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Food.GetPlayerFoodMenuRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.menu = $root.BaseInfo.FoodMenu.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetPlayerFoodMenuRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Food.GetPlayerFoodMenuRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Food.GetPlayerFoodMenuRes} GetPlayerFoodMenuRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetPlayerFoodMenuRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetPlayerFoodMenuRes message.
         * @function verify
         * @memberof Food.GetPlayerFoodMenuRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetPlayerFoodMenuRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.menu != null && message.hasOwnProperty("menu")) {
                var error = $root.BaseInfo.FoodMenu.verify(message.menu);
                if (error)
                    return "menu." + error;
            }
            return null;
        };

        return GetPlayerFoodMenuRes;
    })();

    Food.FoodLevelUpReq = (function() {

        /**
         * Properties of a FoodLevelUpReq.
         * @memberof Food
         * @interface IFoodLevelUpReq
         * @property {string|null} [foodListId] FoodLevelUpReq foodListId
         */

        /**
         * Constructs a new FoodLevelUpReq.
         * @memberof Food
         * @classdesc Represents a FoodLevelUpReq.
         * @implements IFoodLevelUpReq
         * @constructor
         * @param {Food.IFoodLevelUpReq=} [properties] Properties to set
         */
        function FoodLevelUpReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FoodLevelUpReq foodListId.
         * @member {string} foodListId
         * @memberof Food.FoodLevelUpReq
         * @instance
         */
        FoodLevelUpReq.prototype.foodListId = "";

        /**
         * Creates a new FoodLevelUpReq instance using the specified properties.
         * @function create
         * @memberof Food.FoodLevelUpReq
         * @static
         * @param {Food.IFoodLevelUpReq=} [properties] Properties to set
         * @returns {Food.FoodLevelUpReq} FoodLevelUpReq instance
         */
        FoodLevelUpReq.create = function create(properties) {
            return new FoodLevelUpReq(properties);
        };

        /**
         * Encodes the specified FoodLevelUpReq message. Does not implicitly {@link Food.FoodLevelUpReq.verify|verify} messages.
         * @function encode
         * @memberof Food.FoodLevelUpReq
         * @static
         * @param {Food.IFoodLevelUpReq} message FoodLevelUpReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FoodLevelUpReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.foodListId != null && message.hasOwnProperty("foodListId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.foodListId);
            return writer;
        };

        /**
         * Encodes the specified FoodLevelUpReq message, length delimited. Does not implicitly {@link Food.FoodLevelUpReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Food.FoodLevelUpReq
         * @static
         * @param {Food.IFoodLevelUpReq} message FoodLevelUpReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FoodLevelUpReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FoodLevelUpReq message from the specified reader or buffer.
         * @function decode
         * @memberof Food.FoodLevelUpReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Food.FoodLevelUpReq} FoodLevelUpReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FoodLevelUpReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Food.FoodLevelUpReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.foodListId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FoodLevelUpReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Food.FoodLevelUpReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Food.FoodLevelUpReq} FoodLevelUpReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FoodLevelUpReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FoodLevelUpReq message.
         * @function verify
         * @memberof Food.FoodLevelUpReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FoodLevelUpReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.foodListId != null && message.hasOwnProperty("foodListId"))
                if (!$util.isString(message.foodListId))
                    return "foodListId: string expected";
            return null;
        };

        return FoodLevelUpReq;
    })();

    Food.FoodLevelUpRes = (function() {

        /**
         * Properties of a FoodLevelUpRes.
         * @memberof Food
         * @interface IFoodLevelUpRes
         * @property {BaseInfo.IFoodMenu|null} [menu] FoodLevelUpRes menu
         * @property {BaseInfo.IFullBag|null} [bag] FoodLevelUpRes bag
         */

        /**
         * Constructs a new FoodLevelUpRes.
         * @memberof Food
         * @classdesc Represents a FoodLevelUpRes.
         * @implements IFoodLevelUpRes
         * @constructor
         * @param {Food.IFoodLevelUpRes=} [properties] Properties to set
         */
        function FoodLevelUpRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FoodLevelUpRes menu.
         * @member {BaseInfo.IFoodMenu|null|undefined} menu
         * @memberof Food.FoodLevelUpRes
         * @instance
         */
        FoodLevelUpRes.prototype.menu = null;

        /**
         * FoodLevelUpRes bag.
         * @member {BaseInfo.IFullBag|null|undefined} bag
         * @memberof Food.FoodLevelUpRes
         * @instance
         */
        FoodLevelUpRes.prototype.bag = null;

        /**
         * Creates a new FoodLevelUpRes instance using the specified properties.
         * @function create
         * @memberof Food.FoodLevelUpRes
         * @static
         * @param {Food.IFoodLevelUpRes=} [properties] Properties to set
         * @returns {Food.FoodLevelUpRes} FoodLevelUpRes instance
         */
        FoodLevelUpRes.create = function create(properties) {
            return new FoodLevelUpRes(properties);
        };

        /**
         * Encodes the specified FoodLevelUpRes message. Does not implicitly {@link Food.FoodLevelUpRes.verify|verify} messages.
         * @function encode
         * @memberof Food.FoodLevelUpRes
         * @static
         * @param {Food.IFoodLevelUpRes} message FoodLevelUpRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FoodLevelUpRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.menu != null && message.hasOwnProperty("menu"))
                $root.BaseInfo.FoodMenu.encode(message.menu, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.FullBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FoodLevelUpRes message, length delimited. Does not implicitly {@link Food.FoodLevelUpRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Food.FoodLevelUpRes
         * @static
         * @param {Food.IFoodLevelUpRes} message FoodLevelUpRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FoodLevelUpRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FoodLevelUpRes message from the specified reader or buffer.
         * @function decode
         * @memberof Food.FoodLevelUpRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Food.FoodLevelUpRes} FoodLevelUpRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FoodLevelUpRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Food.FoodLevelUpRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.menu = $root.BaseInfo.FoodMenu.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.FullBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FoodLevelUpRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Food.FoodLevelUpRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Food.FoodLevelUpRes} FoodLevelUpRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FoodLevelUpRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FoodLevelUpRes message.
         * @function verify
         * @memberof Food.FoodLevelUpRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FoodLevelUpRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.menu != null && message.hasOwnProperty("menu")) {
                var error = $root.BaseInfo.FoodMenu.verify(message.menu);
                if (error)
                    return "menu." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.FullBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return FoodLevelUpRes;
    })();

    Food.FoodLevelUpWithAdReq = (function() {

        /**
         * Properties of a FoodLevelUpWithAdReq.
         * @memberof Food
         * @interface IFoodLevelUpWithAdReq
         * @property {string|null} [foodListId] FoodLevelUpWithAdReq foodListId
         * @property {BaseInfo.FetchType|null} [fetchType] FoodLevelUpWithAdReq fetchType
         */

        /**
         * Constructs a new FoodLevelUpWithAdReq.
         * @memberof Food
         * @classdesc Represents a FoodLevelUpWithAdReq.
         * @implements IFoodLevelUpWithAdReq
         * @constructor
         * @param {Food.IFoodLevelUpWithAdReq=} [properties] Properties to set
         */
        function FoodLevelUpWithAdReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FoodLevelUpWithAdReq foodListId.
         * @member {string} foodListId
         * @memberof Food.FoodLevelUpWithAdReq
         * @instance
         */
        FoodLevelUpWithAdReq.prototype.foodListId = "";

        /**
         * FoodLevelUpWithAdReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof Food.FoodLevelUpWithAdReq
         * @instance
         */
        FoodLevelUpWithAdReq.prototype.fetchType = 0;

        /**
         * Creates a new FoodLevelUpWithAdReq instance using the specified properties.
         * @function create
         * @memberof Food.FoodLevelUpWithAdReq
         * @static
         * @param {Food.IFoodLevelUpWithAdReq=} [properties] Properties to set
         * @returns {Food.FoodLevelUpWithAdReq} FoodLevelUpWithAdReq instance
         */
        FoodLevelUpWithAdReq.create = function create(properties) {
            return new FoodLevelUpWithAdReq(properties);
        };

        /**
         * Encodes the specified FoodLevelUpWithAdReq message. Does not implicitly {@link Food.FoodLevelUpWithAdReq.verify|verify} messages.
         * @function encode
         * @memberof Food.FoodLevelUpWithAdReq
         * @static
         * @param {Food.IFoodLevelUpWithAdReq} message FoodLevelUpWithAdReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FoodLevelUpWithAdReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.foodListId != null && message.hasOwnProperty("foodListId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.foodListId);
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified FoodLevelUpWithAdReq message, length delimited. Does not implicitly {@link Food.FoodLevelUpWithAdReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Food.FoodLevelUpWithAdReq
         * @static
         * @param {Food.IFoodLevelUpWithAdReq} message FoodLevelUpWithAdReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FoodLevelUpWithAdReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FoodLevelUpWithAdReq message from the specified reader or buffer.
         * @function decode
         * @memberof Food.FoodLevelUpWithAdReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Food.FoodLevelUpWithAdReq} FoodLevelUpWithAdReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FoodLevelUpWithAdReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Food.FoodLevelUpWithAdReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.foodListId = reader.string();
                    break;
                case 2:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FoodLevelUpWithAdReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Food.FoodLevelUpWithAdReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Food.FoodLevelUpWithAdReq} FoodLevelUpWithAdReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FoodLevelUpWithAdReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FoodLevelUpWithAdReq message.
         * @function verify
         * @memberof Food.FoodLevelUpWithAdReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FoodLevelUpWithAdReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.foodListId != null && message.hasOwnProperty("foodListId"))
                if (!$util.isString(message.foodListId))
                    return "foodListId: string expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return FoodLevelUpWithAdReq;
    })();

    Food.FoodLevelUpWithAdRes = (function() {

        /**
         * Properties of a FoodLevelUpWithAdRes.
         * @memberof Food
         * @interface IFoodLevelUpWithAdRes
         * @property {BaseInfo.IFoodMenu|null} [menu] FoodLevelUpWithAdRes menu
         * @property {BaseInfo.IFullBag|null} [bag] FoodLevelUpWithAdRes bag
         * @property {BaseInfo.IAdRewardsInfo|null} [adRewardsInfo] FoodLevelUpWithAdRes adRewardsInfo
         */

        /**
         * Constructs a new FoodLevelUpWithAdRes.
         * @memberof Food
         * @classdesc Represents a FoodLevelUpWithAdRes.
         * @implements IFoodLevelUpWithAdRes
         * @constructor
         * @param {Food.IFoodLevelUpWithAdRes=} [properties] Properties to set
         */
        function FoodLevelUpWithAdRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FoodLevelUpWithAdRes menu.
         * @member {BaseInfo.IFoodMenu|null|undefined} menu
         * @memberof Food.FoodLevelUpWithAdRes
         * @instance
         */
        FoodLevelUpWithAdRes.prototype.menu = null;

        /**
         * FoodLevelUpWithAdRes bag.
         * @member {BaseInfo.IFullBag|null|undefined} bag
         * @memberof Food.FoodLevelUpWithAdRes
         * @instance
         */
        FoodLevelUpWithAdRes.prototype.bag = null;

        /**
         * FoodLevelUpWithAdRes adRewardsInfo.
         * @member {BaseInfo.IAdRewardsInfo|null|undefined} adRewardsInfo
         * @memberof Food.FoodLevelUpWithAdRes
         * @instance
         */
        FoodLevelUpWithAdRes.prototype.adRewardsInfo = null;

        /**
         * Creates a new FoodLevelUpWithAdRes instance using the specified properties.
         * @function create
         * @memberof Food.FoodLevelUpWithAdRes
         * @static
         * @param {Food.IFoodLevelUpWithAdRes=} [properties] Properties to set
         * @returns {Food.FoodLevelUpWithAdRes} FoodLevelUpWithAdRes instance
         */
        FoodLevelUpWithAdRes.create = function create(properties) {
            return new FoodLevelUpWithAdRes(properties);
        };

        /**
         * Encodes the specified FoodLevelUpWithAdRes message. Does not implicitly {@link Food.FoodLevelUpWithAdRes.verify|verify} messages.
         * @function encode
         * @memberof Food.FoodLevelUpWithAdRes
         * @static
         * @param {Food.IFoodLevelUpWithAdRes} message FoodLevelUpWithAdRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FoodLevelUpWithAdRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.menu != null && message.hasOwnProperty("menu"))
                $root.BaseInfo.FoodMenu.encode(message.menu, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.FullBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.adRewardsInfo != null && message.hasOwnProperty("adRewardsInfo"))
                $root.BaseInfo.AdRewardsInfo.encode(message.adRewardsInfo, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FoodLevelUpWithAdRes message, length delimited. Does not implicitly {@link Food.FoodLevelUpWithAdRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Food.FoodLevelUpWithAdRes
         * @static
         * @param {Food.IFoodLevelUpWithAdRes} message FoodLevelUpWithAdRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FoodLevelUpWithAdRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FoodLevelUpWithAdRes message from the specified reader or buffer.
         * @function decode
         * @memberof Food.FoodLevelUpWithAdRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Food.FoodLevelUpWithAdRes} FoodLevelUpWithAdRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FoodLevelUpWithAdRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Food.FoodLevelUpWithAdRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.menu = $root.BaseInfo.FoodMenu.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.FullBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.adRewardsInfo = $root.BaseInfo.AdRewardsInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FoodLevelUpWithAdRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Food.FoodLevelUpWithAdRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Food.FoodLevelUpWithAdRes} FoodLevelUpWithAdRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FoodLevelUpWithAdRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FoodLevelUpWithAdRes message.
         * @function verify
         * @memberof Food.FoodLevelUpWithAdRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FoodLevelUpWithAdRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.menu != null && message.hasOwnProperty("menu")) {
                var error = $root.BaseInfo.FoodMenu.verify(message.menu);
                if (error)
                    return "menu." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.FullBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.adRewardsInfo != null && message.hasOwnProperty("adRewardsInfo")) {
                var error = $root.BaseInfo.AdRewardsInfo.verify(message.adRewardsInfo);
                if (error)
                    return "adRewardsInfo." + error;
            }
            return null;
        };

        return FoodLevelUpWithAdRes;
    })();

    return Food;
})();

$root.Pet = (function() {

    /**
     * Namespace Pet.
     * @exports Pet
     * @namespace
     */
    var Pet = {};

    Pet.GetPlayerPetsInfoReq = (function() {

        /**
         * Properties of a GetPlayerPetsInfoReq.
         * @memberof Pet
         * @interface IGetPlayerPetsInfoReq
         */

        /**
         * Constructs a new GetPlayerPetsInfoReq.
         * @memberof Pet
         * @classdesc Represents a GetPlayerPetsInfoReq.
         * @implements IGetPlayerPetsInfoReq
         * @constructor
         * @param {Pet.IGetPlayerPetsInfoReq=} [properties] Properties to set
         */
        function GetPlayerPetsInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetPlayerPetsInfoReq instance using the specified properties.
         * @function create
         * @memberof Pet.GetPlayerPetsInfoReq
         * @static
         * @param {Pet.IGetPlayerPetsInfoReq=} [properties] Properties to set
         * @returns {Pet.GetPlayerPetsInfoReq} GetPlayerPetsInfoReq instance
         */
        GetPlayerPetsInfoReq.create = function create(properties) {
            return new GetPlayerPetsInfoReq(properties);
        };

        /**
         * Encodes the specified GetPlayerPetsInfoReq message. Does not implicitly {@link Pet.GetPlayerPetsInfoReq.verify|verify} messages.
         * @function encode
         * @memberof Pet.GetPlayerPetsInfoReq
         * @static
         * @param {Pet.IGetPlayerPetsInfoReq} message GetPlayerPetsInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetPlayerPetsInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetPlayerPetsInfoReq message, length delimited. Does not implicitly {@link Pet.GetPlayerPetsInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pet.GetPlayerPetsInfoReq
         * @static
         * @param {Pet.IGetPlayerPetsInfoReq} message GetPlayerPetsInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetPlayerPetsInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetPlayerPetsInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof Pet.GetPlayerPetsInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pet.GetPlayerPetsInfoReq} GetPlayerPetsInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetPlayerPetsInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pet.GetPlayerPetsInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetPlayerPetsInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pet.GetPlayerPetsInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pet.GetPlayerPetsInfoReq} GetPlayerPetsInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetPlayerPetsInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetPlayerPetsInfoReq message.
         * @function verify
         * @memberof Pet.GetPlayerPetsInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetPlayerPetsInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetPlayerPetsInfoReq;
    })();

    Pet.GetPlayerPetsInfoRes = (function() {

        /**
         * Properties of a GetPlayerPetsInfoRes.
         * @memberof Pet
         * @interface IGetPlayerPetsInfoRes
         * @property {BaseInfo.IPlayerPets|null} [playerPets] GetPlayerPetsInfoRes playerPets
         */

        /**
         * Constructs a new GetPlayerPetsInfoRes.
         * @memberof Pet
         * @classdesc Represents a GetPlayerPetsInfoRes.
         * @implements IGetPlayerPetsInfoRes
         * @constructor
         * @param {Pet.IGetPlayerPetsInfoRes=} [properties] Properties to set
         */
        function GetPlayerPetsInfoRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetPlayerPetsInfoRes playerPets.
         * @member {BaseInfo.IPlayerPets|null|undefined} playerPets
         * @memberof Pet.GetPlayerPetsInfoRes
         * @instance
         */
        GetPlayerPetsInfoRes.prototype.playerPets = null;

        /**
         * Creates a new GetPlayerPetsInfoRes instance using the specified properties.
         * @function create
         * @memberof Pet.GetPlayerPetsInfoRes
         * @static
         * @param {Pet.IGetPlayerPetsInfoRes=} [properties] Properties to set
         * @returns {Pet.GetPlayerPetsInfoRes} GetPlayerPetsInfoRes instance
         */
        GetPlayerPetsInfoRes.create = function create(properties) {
            return new GetPlayerPetsInfoRes(properties);
        };

        /**
         * Encodes the specified GetPlayerPetsInfoRes message. Does not implicitly {@link Pet.GetPlayerPetsInfoRes.verify|verify} messages.
         * @function encode
         * @memberof Pet.GetPlayerPetsInfoRes
         * @static
         * @param {Pet.IGetPlayerPetsInfoRes} message GetPlayerPetsInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetPlayerPetsInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.playerPets != null && message.hasOwnProperty("playerPets"))
                $root.BaseInfo.PlayerPets.encode(message.playerPets, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetPlayerPetsInfoRes message, length delimited. Does not implicitly {@link Pet.GetPlayerPetsInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pet.GetPlayerPetsInfoRes
         * @static
         * @param {Pet.IGetPlayerPetsInfoRes} message GetPlayerPetsInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetPlayerPetsInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetPlayerPetsInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof Pet.GetPlayerPetsInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pet.GetPlayerPetsInfoRes} GetPlayerPetsInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetPlayerPetsInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pet.GetPlayerPetsInfoRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.playerPets = $root.BaseInfo.PlayerPets.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetPlayerPetsInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pet.GetPlayerPetsInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pet.GetPlayerPetsInfoRes} GetPlayerPetsInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetPlayerPetsInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetPlayerPetsInfoRes message.
         * @function verify
         * @memberof Pet.GetPlayerPetsInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetPlayerPetsInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.playerPets != null && message.hasOwnProperty("playerPets")) {
                var error = $root.BaseInfo.PlayerPets.verify(message.playerPets);
                if (error)
                    return "playerPets." + error;
            }
            return null;
        };

        return GetPlayerPetsInfoRes;
    })();

    Pet.AdoptPetReq = (function() {

        /**
         * Properties of an AdoptPetReq.
         * @memberof Pet
         * @interface IAdoptPetReq
         * @property {string|null} [roleId] AdoptPetReq roleId
         * @property {BaseInfo.FetchType|null} [type] AdoptPetReq type
         */

        /**
         * Constructs a new AdoptPetReq.
         * @memberof Pet
         * @classdesc Represents an AdoptPetReq.
         * @implements IAdoptPetReq
         * @constructor
         * @param {Pet.IAdoptPetReq=} [properties] Properties to set
         */
        function AdoptPetReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AdoptPetReq roleId.
         * @member {string} roleId
         * @memberof Pet.AdoptPetReq
         * @instance
         */
        AdoptPetReq.prototype.roleId = "";

        /**
         * AdoptPetReq type.
         * @member {BaseInfo.FetchType} type
         * @memberof Pet.AdoptPetReq
         * @instance
         */
        AdoptPetReq.prototype.type = 0;

        /**
         * Creates a new AdoptPetReq instance using the specified properties.
         * @function create
         * @memberof Pet.AdoptPetReq
         * @static
         * @param {Pet.IAdoptPetReq=} [properties] Properties to set
         * @returns {Pet.AdoptPetReq} AdoptPetReq instance
         */
        AdoptPetReq.create = function create(properties) {
            return new AdoptPetReq(properties);
        };

        /**
         * Encodes the specified AdoptPetReq message. Does not implicitly {@link Pet.AdoptPetReq.verify|verify} messages.
         * @function encode
         * @memberof Pet.AdoptPetReq
         * @static
         * @param {Pet.IAdoptPetReq} message AdoptPetReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdoptPetReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.roleId != null && message.hasOwnProperty("roleId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.roleId);
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.type);
            return writer;
        };

        /**
         * Encodes the specified AdoptPetReq message, length delimited. Does not implicitly {@link Pet.AdoptPetReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pet.AdoptPetReq
         * @static
         * @param {Pet.IAdoptPetReq} message AdoptPetReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdoptPetReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AdoptPetReq message from the specified reader or buffer.
         * @function decode
         * @memberof Pet.AdoptPetReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pet.AdoptPetReq} AdoptPetReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdoptPetReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pet.AdoptPetReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.roleId = reader.string();
                    break;
                case 2:
                    message.type = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AdoptPetReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pet.AdoptPetReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pet.AdoptPetReq} AdoptPetReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdoptPetReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AdoptPetReq message.
         * @function verify
         * @memberof Pet.AdoptPetReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AdoptPetReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.roleId != null && message.hasOwnProperty("roleId"))
                if (!$util.isString(message.roleId))
                    return "roleId: string expected";
            if (message.type != null && message.hasOwnProperty("type"))
                switch (message.type) {
                default:
                    return "type: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return AdoptPetReq;
    })();

    Pet.AdoptPetRes = (function() {

        /**
         * Properties of an AdoptPetRes.
         * @memberof Pet
         * @interface IAdoptPetRes
         * @property {BaseInfo.ICurrencyBag|null} [currencyBag] AdoptPetRes currencyBag
         */

        /**
         * Constructs a new AdoptPetRes.
         * @memberof Pet
         * @classdesc Represents an AdoptPetRes.
         * @implements IAdoptPetRes
         * @constructor
         * @param {Pet.IAdoptPetRes=} [properties] Properties to set
         */
        function AdoptPetRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AdoptPetRes currencyBag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} currencyBag
         * @memberof Pet.AdoptPetRes
         * @instance
         */
        AdoptPetRes.prototype.currencyBag = null;

        /**
         * Creates a new AdoptPetRes instance using the specified properties.
         * @function create
         * @memberof Pet.AdoptPetRes
         * @static
         * @param {Pet.IAdoptPetRes=} [properties] Properties to set
         * @returns {Pet.AdoptPetRes} AdoptPetRes instance
         */
        AdoptPetRes.create = function create(properties) {
            return new AdoptPetRes(properties);
        };

        /**
         * Encodes the specified AdoptPetRes message. Does not implicitly {@link Pet.AdoptPetRes.verify|verify} messages.
         * @function encode
         * @memberof Pet.AdoptPetRes
         * @static
         * @param {Pet.IAdoptPetRes} message AdoptPetRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdoptPetRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag"))
                $root.BaseInfo.CurrencyBag.encode(message.currencyBag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified AdoptPetRes message, length delimited. Does not implicitly {@link Pet.AdoptPetRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pet.AdoptPetRes
         * @static
         * @param {Pet.IAdoptPetRes} message AdoptPetRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdoptPetRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AdoptPetRes message from the specified reader or buffer.
         * @function decode
         * @memberof Pet.AdoptPetRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pet.AdoptPetRes} AdoptPetRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdoptPetRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pet.AdoptPetRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.currencyBag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AdoptPetRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pet.AdoptPetRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pet.AdoptPetRes} AdoptPetRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdoptPetRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AdoptPetRes message.
         * @function verify
         * @memberof Pet.AdoptPetRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AdoptPetRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.currencyBag);
                if (error)
                    return "currencyBag." + error;
            }
            return null;
        };

        return AdoptPetRes;
    })();

    Pet.StoryUnlockReq = (function() {

        /**
         * Properties of a StoryUnlockReq.
         * @memberof Pet
         * @interface IStoryUnlockReq
         * @property {string|null} [roleId] StoryUnlockReq roleId
         * @property {number|null} [unlockIndex] StoryUnlockReq unlockIndex
         */

        /**
         * Constructs a new StoryUnlockReq.
         * @memberof Pet
         * @classdesc Represents a StoryUnlockReq.
         * @implements IStoryUnlockReq
         * @constructor
         * @param {Pet.IStoryUnlockReq=} [properties] Properties to set
         */
        function StoryUnlockReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * StoryUnlockReq roleId.
         * @member {string} roleId
         * @memberof Pet.StoryUnlockReq
         * @instance
         */
        StoryUnlockReq.prototype.roleId = "";

        /**
         * StoryUnlockReq unlockIndex.
         * @member {number} unlockIndex
         * @memberof Pet.StoryUnlockReq
         * @instance
         */
        StoryUnlockReq.prototype.unlockIndex = 0;

        /**
         * Creates a new StoryUnlockReq instance using the specified properties.
         * @function create
         * @memberof Pet.StoryUnlockReq
         * @static
         * @param {Pet.IStoryUnlockReq=} [properties] Properties to set
         * @returns {Pet.StoryUnlockReq} StoryUnlockReq instance
         */
        StoryUnlockReq.create = function create(properties) {
            return new StoryUnlockReq(properties);
        };

        /**
         * Encodes the specified StoryUnlockReq message. Does not implicitly {@link Pet.StoryUnlockReq.verify|verify} messages.
         * @function encode
         * @memberof Pet.StoryUnlockReq
         * @static
         * @param {Pet.IStoryUnlockReq} message StoryUnlockReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StoryUnlockReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.roleId != null && message.hasOwnProperty("roleId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.roleId);
            if (message.unlockIndex != null && message.hasOwnProperty("unlockIndex"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.unlockIndex);
            return writer;
        };

        /**
         * Encodes the specified StoryUnlockReq message, length delimited. Does not implicitly {@link Pet.StoryUnlockReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pet.StoryUnlockReq
         * @static
         * @param {Pet.IStoryUnlockReq} message StoryUnlockReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StoryUnlockReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a StoryUnlockReq message from the specified reader or buffer.
         * @function decode
         * @memberof Pet.StoryUnlockReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pet.StoryUnlockReq} StoryUnlockReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StoryUnlockReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pet.StoryUnlockReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.roleId = reader.string();
                    break;
                case 2:
                    message.unlockIndex = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a StoryUnlockReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pet.StoryUnlockReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pet.StoryUnlockReq} StoryUnlockReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StoryUnlockReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a StoryUnlockReq message.
         * @function verify
         * @memberof Pet.StoryUnlockReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        StoryUnlockReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.roleId != null && message.hasOwnProperty("roleId"))
                if (!$util.isString(message.roleId))
                    return "roleId: string expected";
            if (message.unlockIndex != null && message.hasOwnProperty("unlockIndex"))
                if (!$util.isInteger(message.unlockIndex))
                    return "unlockIndex: integer expected";
            return null;
        };

        return StoryUnlockReq;
    })();

    Pet.StoryUnlockRes = (function() {

        /**
         * Properties of a StoryUnlockRes.
         * @memberof Pet
         * @interface IStoryUnlockRes
         * @property {BaseInfo.IPetInfo|null} [petInfo] StoryUnlockRes petInfo
         * @property {BaseInfo.IRewards|null} [rewards] StoryUnlockRes rewards
         * @property {BaseInfo.ICurrencyBag|null} [currencyBag] StoryUnlockRes currencyBag
         */

        /**
         * Constructs a new StoryUnlockRes.
         * @memberof Pet
         * @classdesc Represents a StoryUnlockRes.
         * @implements IStoryUnlockRes
         * @constructor
         * @param {Pet.IStoryUnlockRes=} [properties] Properties to set
         */
        function StoryUnlockRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * StoryUnlockRes petInfo.
         * @member {BaseInfo.IPetInfo|null|undefined} petInfo
         * @memberof Pet.StoryUnlockRes
         * @instance
         */
        StoryUnlockRes.prototype.petInfo = null;

        /**
         * StoryUnlockRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Pet.StoryUnlockRes
         * @instance
         */
        StoryUnlockRes.prototype.rewards = null;

        /**
         * StoryUnlockRes currencyBag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} currencyBag
         * @memberof Pet.StoryUnlockRes
         * @instance
         */
        StoryUnlockRes.prototype.currencyBag = null;

        /**
         * Creates a new StoryUnlockRes instance using the specified properties.
         * @function create
         * @memberof Pet.StoryUnlockRes
         * @static
         * @param {Pet.IStoryUnlockRes=} [properties] Properties to set
         * @returns {Pet.StoryUnlockRes} StoryUnlockRes instance
         */
        StoryUnlockRes.create = function create(properties) {
            return new StoryUnlockRes(properties);
        };

        /**
         * Encodes the specified StoryUnlockRes message. Does not implicitly {@link Pet.StoryUnlockRes.verify|verify} messages.
         * @function encode
         * @memberof Pet.StoryUnlockRes
         * @static
         * @param {Pet.IStoryUnlockRes} message StoryUnlockRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StoryUnlockRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.petInfo != null && message.hasOwnProperty("petInfo"))
                $root.BaseInfo.PetInfo.encode(message.petInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag"))
                $root.BaseInfo.CurrencyBag.encode(message.currencyBag, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified StoryUnlockRes message, length delimited. Does not implicitly {@link Pet.StoryUnlockRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pet.StoryUnlockRes
         * @static
         * @param {Pet.IStoryUnlockRes} message StoryUnlockRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StoryUnlockRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a StoryUnlockRes message from the specified reader or buffer.
         * @function decode
         * @memberof Pet.StoryUnlockRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pet.StoryUnlockRes} StoryUnlockRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StoryUnlockRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pet.StoryUnlockRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.petInfo = $root.BaseInfo.PetInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.currencyBag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a StoryUnlockRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pet.StoryUnlockRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pet.StoryUnlockRes} StoryUnlockRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StoryUnlockRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a StoryUnlockRes message.
         * @function verify
         * @memberof Pet.StoryUnlockRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        StoryUnlockRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.petInfo != null && message.hasOwnProperty("petInfo")) {
                var error = $root.BaseInfo.PetInfo.verify(message.petInfo);
                if (error)
                    return "petInfo." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.currencyBag);
                if (error)
                    return "currencyBag." + error;
            }
            return null;
        };

        return StoryUnlockRes;
    })();

    Pet.ShareGetRewardReq = (function() {

        /**
         * Properties of a ShareGetRewardReq.
         * @memberof Pet
         * @interface IShareGetRewardReq
         * @property {string|null} [json] ShareGetRewardReq json
         */

        /**
         * Constructs a new ShareGetRewardReq.
         * @memberof Pet
         * @classdesc Represents a ShareGetRewardReq.
         * @implements IShareGetRewardReq
         * @constructor
         * @param {Pet.IShareGetRewardReq=} [properties] Properties to set
         */
        function ShareGetRewardReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ShareGetRewardReq json.
         * @member {string} json
         * @memberof Pet.ShareGetRewardReq
         * @instance
         */
        ShareGetRewardReq.prototype.json = "";

        /**
         * Creates a new ShareGetRewardReq instance using the specified properties.
         * @function create
         * @memberof Pet.ShareGetRewardReq
         * @static
         * @param {Pet.IShareGetRewardReq=} [properties] Properties to set
         * @returns {Pet.ShareGetRewardReq} ShareGetRewardReq instance
         */
        ShareGetRewardReq.create = function create(properties) {
            return new ShareGetRewardReq(properties);
        };

        /**
         * Encodes the specified ShareGetRewardReq message. Does not implicitly {@link Pet.ShareGetRewardReq.verify|verify} messages.
         * @function encode
         * @memberof Pet.ShareGetRewardReq
         * @static
         * @param {Pet.IShareGetRewardReq} message ShareGetRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ShareGetRewardReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.json != null && message.hasOwnProperty("json"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.json);
            return writer;
        };

        /**
         * Encodes the specified ShareGetRewardReq message, length delimited. Does not implicitly {@link Pet.ShareGetRewardReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pet.ShareGetRewardReq
         * @static
         * @param {Pet.IShareGetRewardReq} message ShareGetRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ShareGetRewardReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ShareGetRewardReq message from the specified reader or buffer.
         * @function decode
         * @memberof Pet.ShareGetRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pet.ShareGetRewardReq} ShareGetRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ShareGetRewardReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pet.ShareGetRewardReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.json = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ShareGetRewardReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pet.ShareGetRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pet.ShareGetRewardReq} ShareGetRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ShareGetRewardReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ShareGetRewardReq message.
         * @function verify
         * @memberof Pet.ShareGetRewardReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ShareGetRewardReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.json != null && message.hasOwnProperty("json"))
                if (!$util.isString(message.json))
                    return "json: string expected";
            return null;
        };

        return ShareGetRewardReq;
    })();

    Pet.ShareGetRewardRes = (function() {

        /**
         * Properties of a ShareGetRewardRes.
         * @memberof Pet
         * @interface IShareGetRewardRes
         * @property {BaseInfo.ICurrencyBag|null} [currencyBag] ShareGetRewardRes currencyBag
         * @property {BaseInfo.IRewards|null} [rewards] ShareGetRewardRes rewards
         */

        /**
         * Constructs a new ShareGetRewardRes.
         * @memberof Pet
         * @classdesc Represents a ShareGetRewardRes.
         * @implements IShareGetRewardRes
         * @constructor
         * @param {Pet.IShareGetRewardRes=} [properties] Properties to set
         */
        function ShareGetRewardRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ShareGetRewardRes currencyBag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} currencyBag
         * @memberof Pet.ShareGetRewardRes
         * @instance
         */
        ShareGetRewardRes.prototype.currencyBag = null;

        /**
         * ShareGetRewardRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Pet.ShareGetRewardRes
         * @instance
         */
        ShareGetRewardRes.prototype.rewards = null;

        /**
         * Creates a new ShareGetRewardRes instance using the specified properties.
         * @function create
         * @memberof Pet.ShareGetRewardRes
         * @static
         * @param {Pet.IShareGetRewardRes=} [properties] Properties to set
         * @returns {Pet.ShareGetRewardRes} ShareGetRewardRes instance
         */
        ShareGetRewardRes.create = function create(properties) {
            return new ShareGetRewardRes(properties);
        };

        /**
         * Encodes the specified ShareGetRewardRes message. Does not implicitly {@link Pet.ShareGetRewardRes.verify|verify} messages.
         * @function encode
         * @memberof Pet.ShareGetRewardRes
         * @static
         * @param {Pet.IShareGetRewardRes} message ShareGetRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ShareGetRewardRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag"))
                $root.BaseInfo.CurrencyBag.encode(message.currencyBag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified ShareGetRewardRes message, length delimited. Does not implicitly {@link Pet.ShareGetRewardRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pet.ShareGetRewardRes
         * @static
         * @param {Pet.IShareGetRewardRes} message ShareGetRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ShareGetRewardRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ShareGetRewardRes message from the specified reader or buffer.
         * @function decode
         * @memberof Pet.ShareGetRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pet.ShareGetRewardRes} ShareGetRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ShareGetRewardRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pet.ShareGetRewardRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.currencyBag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ShareGetRewardRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pet.ShareGetRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pet.ShareGetRewardRes} ShareGetRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ShareGetRewardRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ShareGetRewardRes message.
         * @function verify
         * @memberof Pet.ShareGetRewardRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ShareGetRewardRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.currencyBag);
                if (error)
                    return "currencyBag." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            return null;
        };

        return ShareGetRewardRes;
    })();

    Pet.CatLevelUpReq = (function() {

        /**
         * Properties of a CatLevelUpReq.
         * @memberof Pet
         * @interface ICatLevelUpReq
         * @property {string|null} [roleId] CatLevelUpReq roleId
         */

        /**
         * Constructs a new CatLevelUpReq.
         * @memberof Pet
         * @classdesc Represents a CatLevelUpReq.
         * @implements ICatLevelUpReq
         * @constructor
         * @param {Pet.ICatLevelUpReq=} [properties] Properties to set
         */
        function CatLevelUpReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CatLevelUpReq roleId.
         * @member {string} roleId
         * @memberof Pet.CatLevelUpReq
         * @instance
         */
        CatLevelUpReq.prototype.roleId = "";

        /**
         * Creates a new CatLevelUpReq instance using the specified properties.
         * @function create
         * @memberof Pet.CatLevelUpReq
         * @static
         * @param {Pet.ICatLevelUpReq=} [properties] Properties to set
         * @returns {Pet.CatLevelUpReq} CatLevelUpReq instance
         */
        CatLevelUpReq.create = function create(properties) {
            return new CatLevelUpReq(properties);
        };

        /**
         * Encodes the specified CatLevelUpReq message. Does not implicitly {@link Pet.CatLevelUpReq.verify|verify} messages.
         * @function encode
         * @memberof Pet.CatLevelUpReq
         * @static
         * @param {Pet.ICatLevelUpReq} message CatLevelUpReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatLevelUpReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.roleId != null && message.hasOwnProperty("roleId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.roleId);
            return writer;
        };

        /**
         * Encodes the specified CatLevelUpReq message, length delimited. Does not implicitly {@link Pet.CatLevelUpReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pet.CatLevelUpReq
         * @static
         * @param {Pet.ICatLevelUpReq} message CatLevelUpReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatLevelUpReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CatLevelUpReq message from the specified reader or buffer.
         * @function decode
         * @memberof Pet.CatLevelUpReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pet.CatLevelUpReq} CatLevelUpReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatLevelUpReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pet.CatLevelUpReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.roleId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CatLevelUpReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pet.CatLevelUpReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pet.CatLevelUpReq} CatLevelUpReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatLevelUpReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CatLevelUpReq message.
         * @function verify
         * @memberof Pet.CatLevelUpReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CatLevelUpReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.roleId != null && message.hasOwnProperty("roleId"))
                if (!$util.isString(message.roleId))
                    return "roleId: string expected";
            return null;
        };

        return CatLevelUpReq;
    })();

    Pet.CatLevelUpRes = (function() {

        /**
         * Properties of a CatLevelUpRes.
         * @memberof Pet
         * @interface ICatLevelUpRes
         * @property {BaseInfo.IPlayerPets|null} [playerPets] CatLevelUpRes playerPets
         * @property {BaseInfo.ICurrencyBag|null} [bag] CatLevelUpRes bag
         */

        /**
         * Constructs a new CatLevelUpRes.
         * @memberof Pet
         * @classdesc Represents a CatLevelUpRes.
         * @implements ICatLevelUpRes
         * @constructor
         * @param {Pet.ICatLevelUpRes=} [properties] Properties to set
         */
        function CatLevelUpRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CatLevelUpRes playerPets.
         * @member {BaseInfo.IPlayerPets|null|undefined} playerPets
         * @memberof Pet.CatLevelUpRes
         * @instance
         */
        CatLevelUpRes.prototype.playerPets = null;

        /**
         * CatLevelUpRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Pet.CatLevelUpRes
         * @instance
         */
        CatLevelUpRes.prototype.bag = null;

        /**
         * Creates a new CatLevelUpRes instance using the specified properties.
         * @function create
         * @memberof Pet.CatLevelUpRes
         * @static
         * @param {Pet.ICatLevelUpRes=} [properties] Properties to set
         * @returns {Pet.CatLevelUpRes} CatLevelUpRes instance
         */
        CatLevelUpRes.create = function create(properties) {
            return new CatLevelUpRes(properties);
        };

        /**
         * Encodes the specified CatLevelUpRes message. Does not implicitly {@link Pet.CatLevelUpRes.verify|verify} messages.
         * @function encode
         * @memberof Pet.CatLevelUpRes
         * @static
         * @param {Pet.ICatLevelUpRes} message CatLevelUpRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatLevelUpRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.playerPets != null && message.hasOwnProperty("playerPets"))
                $root.BaseInfo.PlayerPets.encode(message.playerPets, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified CatLevelUpRes message, length delimited. Does not implicitly {@link Pet.CatLevelUpRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pet.CatLevelUpRes
         * @static
         * @param {Pet.ICatLevelUpRes} message CatLevelUpRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatLevelUpRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CatLevelUpRes message from the specified reader or buffer.
         * @function decode
         * @memberof Pet.CatLevelUpRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pet.CatLevelUpRes} CatLevelUpRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatLevelUpRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pet.CatLevelUpRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.playerPets = $root.BaseInfo.PlayerPets.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CatLevelUpRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pet.CatLevelUpRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pet.CatLevelUpRes} CatLevelUpRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatLevelUpRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CatLevelUpRes message.
         * @function verify
         * @memberof Pet.CatLevelUpRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CatLevelUpRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.playerPets != null && message.hasOwnProperty("playerPets")) {
                var error = $root.BaseInfo.PlayerPets.verify(message.playerPets);
                if (error)
                    return "playerPets." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return CatLevelUpRes;
    })();

    Pet.CatStarUpGradeReq = (function() {

        /**
         * Properties of a CatStarUpGradeReq.
         * @memberof Pet
         * @interface ICatStarUpGradeReq
         * @property {string|null} [roleId] CatStarUpGradeReq roleId
         */

        /**
         * Constructs a new CatStarUpGradeReq.
         * @memberof Pet
         * @classdesc Represents a CatStarUpGradeReq.
         * @implements ICatStarUpGradeReq
         * @constructor
         * @param {Pet.ICatStarUpGradeReq=} [properties] Properties to set
         */
        function CatStarUpGradeReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CatStarUpGradeReq roleId.
         * @member {string} roleId
         * @memberof Pet.CatStarUpGradeReq
         * @instance
         */
        CatStarUpGradeReq.prototype.roleId = "";

        /**
         * Creates a new CatStarUpGradeReq instance using the specified properties.
         * @function create
         * @memberof Pet.CatStarUpGradeReq
         * @static
         * @param {Pet.ICatStarUpGradeReq=} [properties] Properties to set
         * @returns {Pet.CatStarUpGradeReq} CatStarUpGradeReq instance
         */
        CatStarUpGradeReq.create = function create(properties) {
            return new CatStarUpGradeReq(properties);
        };

        /**
         * Encodes the specified CatStarUpGradeReq message. Does not implicitly {@link Pet.CatStarUpGradeReq.verify|verify} messages.
         * @function encode
         * @memberof Pet.CatStarUpGradeReq
         * @static
         * @param {Pet.ICatStarUpGradeReq} message CatStarUpGradeReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatStarUpGradeReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.roleId != null && message.hasOwnProperty("roleId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.roleId);
            return writer;
        };

        /**
         * Encodes the specified CatStarUpGradeReq message, length delimited. Does not implicitly {@link Pet.CatStarUpGradeReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pet.CatStarUpGradeReq
         * @static
         * @param {Pet.ICatStarUpGradeReq} message CatStarUpGradeReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatStarUpGradeReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CatStarUpGradeReq message from the specified reader or buffer.
         * @function decode
         * @memberof Pet.CatStarUpGradeReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pet.CatStarUpGradeReq} CatStarUpGradeReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatStarUpGradeReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pet.CatStarUpGradeReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.roleId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CatStarUpGradeReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pet.CatStarUpGradeReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pet.CatStarUpGradeReq} CatStarUpGradeReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatStarUpGradeReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CatStarUpGradeReq message.
         * @function verify
         * @memberof Pet.CatStarUpGradeReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CatStarUpGradeReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.roleId != null && message.hasOwnProperty("roleId"))
                if (!$util.isString(message.roleId))
                    return "roleId: string expected";
            return null;
        };

        return CatStarUpGradeReq;
    })();

    Pet.CatStarUpGradeRes = (function() {

        /**
         * Properties of a CatStarUpGradeRes.
         * @memberof Pet
         * @interface ICatStarUpGradeRes
         * @property {BaseInfo.IPlayerPets|null} [playerPets] CatStarUpGradeRes playerPets
         * @property {BaseInfo.ICurrencyBag|null} [bag] CatStarUpGradeRes bag
         */

        /**
         * Constructs a new CatStarUpGradeRes.
         * @memberof Pet
         * @classdesc Represents a CatStarUpGradeRes.
         * @implements ICatStarUpGradeRes
         * @constructor
         * @param {Pet.ICatStarUpGradeRes=} [properties] Properties to set
         */
        function CatStarUpGradeRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CatStarUpGradeRes playerPets.
         * @member {BaseInfo.IPlayerPets|null|undefined} playerPets
         * @memberof Pet.CatStarUpGradeRes
         * @instance
         */
        CatStarUpGradeRes.prototype.playerPets = null;

        /**
         * CatStarUpGradeRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Pet.CatStarUpGradeRes
         * @instance
         */
        CatStarUpGradeRes.prototype.bag = null;

        /**
         * Creates a new CatStarUpGradeRes instance using the specified properties.
         * @function create
         * @memberof Pet.CatStarUpGradeRes
         * @static
         * @param {Pet.ICatStarUpGradeRes=} [properties] Properties to set
         * @returns {Pet.CatStarUpGradeRes} CatStarUpGradeRes instance
         */
        CatStarUpGradeRes.create = function create(properties) {
            return new CatStarUpGradeRes(properties);
        };

        /**
         * Encodes the specified CatStarUpGradeRes message. Does not implicitly {@link Pet.CatStarUpGradeRes.verify|verify} messages.
         * @function encode
         * @memberof Pet.CatStarUpGradeRes
         * @static
         * @param {Pet.ICatStarUpGradeRes} message CatStarUpGradeRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatStarUpGradeRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.playerPets != null && message.hasOwnProperty("playerPets"))
                $root.BaseInfo.PlayerPets.encode(message.playerPets, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified CatStarUpGradeRes message, length delimited. Does not implicitly {@link Pet.CatStarUpGradeRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pet.CatStarUpGradeRes
         * @static
         * @param {Pet.ICatStarUpGradeRes} message CatStarUpGradeRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatStarUpGradeRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CatStarUpGradeRes message from the specified reader or buffer.
         * @function decode
         * @memberof Pet.CatStarUpGradeRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pet.CatStarUpGradeRes} CatStarUpGradeRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatStarUpGradeRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pet.CatStarUpGradeRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.playerPets = $root.BaseInfo.PlayerPets.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CatStarUpGradeRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pet.CatStarUpGradeRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pet.CatStarUpGradeRes} CatStarUpGradeRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatStarUpGradeRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CatStarUpGradeRes message.
         * @function verify
         * @memberof Pet.CatStarUpGradeRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CatStarUpGradeRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.playerPets != null && message.hasOwnProperty("playerPets")) {
                var error = $root.BaseInfo.PlayerPets.verify(message.playerPets);
                if (error)
                    return "playerPets." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return CatStarUpGradeRes;
    })();

    return Pet;
})();

$root.Nautical = (function() {

    /**
     * Namespace Nautical.
     * @exports Nautical
     * @namespace
     */
    var Nautical = {};

    Nautical.GetNauticalInfoReq = (function() {

        /**
         * Properties of a GetNauticalInfoReq.
         * @memberof Nautical
         * @interface IGetNauticalInfoReq
         */

        /**
         * Constructs a new GetNauticalInfoReq.
         * @memberof Nautical
         * @classdesc Represents a GetNauticalInfoReq.
         * @implements IGetNauticalInfoReq
         * @constructor
         * @param {Nautical.IGetNauticalInfoReq=} [properties] Properties to set
         */
        function GetNauticalInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetNauticalInfoReq instance using the specified properties.
         * @function create
         * @memberof Nautical.GetNauticalInfoReq
         * @static
         * @param {Nautical.IGetNauticalInfoReq=} [properties] Properties to set
         * @returns {Nautical.GetNauticalInfoReq} GetNauticalInfoReq instance
         */
        GetNauticalInfoReq.create = function create(properties) {
            return new GetNauticalInfoReq(properties);
        };

        /**
         * Encodes the specified GetNauticalInfoReq message. Does not implicitly {@link Nautical.GetNauticalInfoReq.verify|verify} messages.
         * @function encode
         * @memberof Nautical.GetNauticalInfoReq
         * @static
         * @param {Nautical.IGetNauticalInfoReq} message GetNauticalInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetNauticalInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetNauticalInfoReq message, length delimited. Does not implicitly {@link Nautical.GetNauticalInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.GetNauticalInfoReq
         * @static
         * @param {Nautical.IGetNauticalInfoReq} message GetNauticalInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetNauticalInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetNauticalInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.GetNauticalInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.GetNauticalInfoReq} GetNauticalInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetNauticalInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.GetNauticalInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetNauticalInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.GetNauticalInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.GetNauticalInfoReq} GetNauticalInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetNauticalInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetNauticalInfoReq message.
         * @function verify
         * @memberof Nautical.GetNauticalInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetNauticalInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetNauticalInfoReq;
    })();

    Nautical.GetNauticalInfoRes = (function() {

        /**
         * Properties of a GetNauticalInfoRes.
         * @memberof Nautical
         * @interface IGetNauticalInfoRes
         * @property {Nautical.INauticalInfo|null} [nauticalInfo] GetNauticalInfoRes nauticalInfo
         * @property {Array.<string>|null} [petIds] GetNauticalInfoRes petIds
         * @property {Object.<string,BaseInfo.IItem>|null} [nauticalFoods] GetNauticalInfoRes nauticalFoods
         * @property {Object.<string,BaseInfo.IItem>|null} [nauticalTools] GetNauticalInfoRes nauticalTools
         */

        /**
         * Constructs a new GetNauticalInfoRes.
         * @memberof Nautical
         * @classdesc Represents a GetNauticalInfoRes.
         * @implements IGetNauticalInfoRes
         * @constructor
         * @param {Nautical.IGetNauticalInfoRes=} [properties] Properties to set
         */
        function GetNauticalInfoRes(properties) {
            this.petIds = [];
            this.nauticalFoods = {};
            this.nauticalTools = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetNauticalInfoRes nauticalInfo.
         * @member {Nautical.INauticalInfo|null|undefined} nauticalInfo
         * @memberof Nautical.GetNauticalInfoRes
         * @instance
         */
        GetNauticalInfoRes.prototype.nauticalInfo = null;

        /**
         * GetNauticalInfoRes petIds.
         * @member {Array.<string>} petIds
         * @memberof Nautical.GetNauticalInfoRes
         * @instance
         */
        GetNauticalInfoRes.prototype.petIds = $util.emptyArray;

        /**
         * GetNauticalInfoRes nauticalFoods.
         * @member {Object.<string,BaseInfo.IItem>} nauticalFoods
         * @memberof Nautical.GetNauticalInfoRes
         * @instance
         */
        GetNauticalInfoRes.prototype.nauticalFoods = $util.emptyObject;

        /**
         * GetNauticalInfoRes nauticalTools.
         * @member {Object.<string,BaseInfo.IItem>} nauticalTools
         * @memberof Nautical.GetNauticalInfoRes
         * @instance
         */
        GetNauticalInfoRes.prototype.nauticalTools = $util.emptyObject;

        /**
         * Creates a new GetNauticalInfoRes instance using the specified properties.
         * @function create
         * @memberof Nautical.GetNauticalInfoRes
         * @static
         * @param {Nautical.IGetNauticalInfoRes=} [properties] Properties to set
         * @returns {Nautical.GetNauticalInfoRes} GetNauticalInfoRes instance
         */
        GetNauticalInfoRes.create = function create(properties) {
            return new GetNauticalInfoRes(properties);
        };

        /**
         * Encodes the specified GetNauticalInfoRes message. Does not implicitly {@link Nautical.GetNauticalInfoRes.verify|verify} messages.
         * @function encode
         * @memberof Nautical.GetNauticalInfoRes
         * @static
         * @param {Nautical.IGetNauticalInfoRes} message GetNauticalInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetNauticalInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo"))
                $root.Nautical.NauticalInfo.encode(message.nauticalInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.petIds != null && message.petIds.length)
                for (var i = 0; i < message.petIds.length; ++i)
                    writer.uint32(/* id 8, wireType 2 =*/66).string(message.petIds[i]);
            if (message.nauticalFoods != null && message.hasOwnProperty("nauticalFoods"))
                for (var keys = Object.keys(message.nauticalFoods), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 9, wireType 2 =*/74).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Item.encode(message.nauticalFoods[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            if (message.nauticalTools != null && message.hasOwnProperty("nauticalTools"))
                for (var keys = Object.keys(message.nauticalTools), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 10, wireType 2 =*/82).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Item.encode(message.nauticalTools[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified GetNauticalInfoRes message, length delimited. Does not implicitly {@link Nautical.GetNauticalInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.GetNauticalInfoRes
         * @static
         * @param {Nautical.IGetNauticalInfoRes} message GetNauticalInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetNauticalInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetNauticalInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.GetNauticalInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.GetNauticalInfoRes} GetNauticalInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetNauticalInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.GetNauticalInfoRes(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.nauticalInfo = $root.Nautical.NauticalInfo.decode(reader, reader.uint32());
                    break;
                case 8:
                    if (!(message.petIds && message.petIds.length))
                        message.petIds = [];
                    message.petIds.push(reader.string());
                    break;
                case 9:
                    reader.skip().pos++;
                    if (message.nauticalFoods === $util.emptyObject)
                        message.nauticalFoods = {};
                    key = reader.string();
                    reader.pos++;
                    message.nauticalFoods[key] = $root.BaseInfo.Item.decode(reader, reader.uint32());
                    break;
                case 10:
                    reader.skip().pos++;
                    if (message.nauticalTools === $util.emptyObject)
                        message.nauticalTools = {};
                    key = reader.string();
                    reader.pos++;
                    message.nauticalTools[key] = $root.BaseInfo.Item.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetNauticalInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.GetNauticalInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.GetNauticalInfoRes} GetNauticalInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetNauticalInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetNauticalInfoRes message.
         * @function verify
         * @memberof Nautical.GetNauticalInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetNauticalInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo")) {
                var error = $root.Nautical.NauticalInfo.verify(message.nauticalInfo);
                if (error)
                    return "nauticalInfo." + error;
            }
            if (message.petIds != null && message.hasOwnProperty("petIds")) {
                if (!Array.isArray(message.petIds))
                    return "petIds: array expected";
                for (var i = 0; i < message.petIds.length; ++i)
                    if (!$util.isString(message.petIds[i]))
                        return "petIds: string[] expected";
            }
            if (message.nauticalFoods != null && message.hasOwnProperty("nauticalFoods")) {
                if (!$util.isObject(message.nauticalFoods))
                    return "nauticalFoods: object expected";
                var key = Object.keys(message.nauticalFoods);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.nauticalFoods[key[i]]);
                    if (error)
                        return "nauticalFoods." + error;
                }
            }
            if (message.nauticalTools != null && message.hasOwnProperty("nauticalTools")) {
                if (!$util.isObject(message.nauticalTools))
                    return "nauticalTools: object expected";
                var key = Object.keys(message.nauticalTools);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.nauticalTools[key[i]]);
                    if (error)
                        return "nauticalTools." + error;
                }
            }
            return null;
        };

        return GetNauticalInfoRes;
    })();

    Nautical.MergeNauticalFoodReq = (function() {

        /**
         * Properties of a MergeNauticalFoodReq.
         * @memberof Nautical
         * @interface IMergeNauticalFoodReq
         * @property {string|null} [id] MergeNauticalFoodReq id
         * @property {number|null} [amount] MergeNauticalFoodReq amount
         */

        /**
         * Constructs a new MergeNauticalFoodReq.
         * @memberof Nautical
         * @classdesc Represents a MergeNauticalFoodReq.
         * @implements IMergeNauticalFoodReq
         * @constructor
         * @param {Nautical.IMergeNauticalFoodReq=} [properties] Properties to set
         */
        function MergeNauticalFoodReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * MergeNauticalFoodReq id.
         * @member {string} id
         * @memberof Nautical.MergeNauticalFoodReq
         * @instance
         */
        MergeNauticalFoodReq.prototype.id = "";

        /**
         * MergeNauticalFoodReq amount.
         * @member {number} amount
         * @memberof Nautical.MergeNauticalFoodReq
         * @instance
         */
        MergeNauticalFoodReq.prototype.amount = 0;

        /**
         * Creates a new MergeNauticalFoodReq instance using the specified properties.
         * @function create
         * @memberof Nautical.MergeNauticalFoodReq
         * @static
         * @param {Nautical.IMergeNauticalFoodReq=} [properties] Properties to set
         * @returns {Nautical.MergeNauticalFoodReq} MergeNauticalFoodReq instance
         */
        MergeNauticalFoodReq.create = function create(properties) {
            return new MergeNauticalFoodReq(properties);
        };

        /**
         * Encodes the specified MergeNauticalFoodReq message. Does not implicitly {@link Nautical.MergeNauticalFoodReq.verify|verify} messages.
         * @function encode
         * @memberof Nautical.MergeNauticalFoodReq
         * @static
         * @param {Nautical.IMergeNauticalFoodReq} message MergeNauticalFoodReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        MergeNauticalFoodReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.id != null && message.hasOwnProperty("id"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.id);
            if (message.amount != null && message.hasOwnProperty("amount"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.amount);
            return writer;
        };

        /**
         * Encodes the specified MergeNauticalFoodReq message, length delimited. Does not implicitly {@link Nautical.MergeNauticalFoodReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.MergeNauticalFoodReq
         * @static
         * @param {Nautical.IMergeNauticalFoodReq} message MergeNauticalFoodReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        MergeNauticalFoodReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a MergeNauticalFoodReq message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.MergeNauticalFoodReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.MergeNauticalFoodReq} MergeNauticalFoodReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        MergeNauticalFoodReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.MergeNauticalFoodReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.amount = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a MergeNauticalFoodReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.MergeNauticalFoodReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.MergeNauticalFoodReq} MergeNauticalFoodReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        MergeNauticalFoodReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a MergeNauticalFoodReq message.
         * @function verify
         * @memberof Nautical.MergeNauticalFoodReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        MergeNauticalFoodReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.id != null && message.hasOwnProperty("id"))
                if (!$util.isString(message.id))
                    return "id: string expected";
            if (message.amount != null && message.hasOwnProperty("amount"))
                if (!$util.isInteger(message.amount))
                    return "amount: integer expected";
            return null;
        };

        return MergeNauticalFoodReq;
    })();

    Nautical.MergeNauticalFoodRes = (function() {

        /**
         * Properties of a MergeNauticalFoodRes.
         * @memberof Nautical
         * @interface IMergeNauticalFoodRes
         * @property {BaseInfo.IFullBag|null} [bag] MergeNauticalFoodRes bag
         */

        /**
         * Constructs a new MergeNauticalFoodRes.
         * @memberof Nautical
         * @classdesc Represents a MergeNauticalFoodRes.
         * @implements IMergeNauticalFoodRes
         * @constructor
         * @param {Nautical.IMergeNauticalFoodRes=} [properties] Properties to set
         */
        function MergeNauticalFoodRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * MergeNauticalFoodRes bag.
         * @member {BaseInfo.IFullBag|null|undefined} bag
         * @memberof Nautical.MergeNauticalFoodRes
         * @instance
         */
        MergeNauticalFoodRes.prototype.bag = null;

        /**
         * Creates a new MergeNauticalFoodRes instance using the specified properties.
         * @function create
         * @memberof Nautical.MergeNauticalFoodRes
         * @static
         * @param {Nautical.IMergeNauticalFoodRes=} [properties] Properties to set
         * @returns {Nautical.MergeNauticalFoodRes} MergeNauticalFoodRes instance
         */
        MergeNauticalFoodRes.create = function create(properties) {
            return new MergeNauticalFoodRes(properties);
        };

        /**
         * Encodes the specified MergeNauticalFoodRes message. Does not implicitly {@link Nautical.MergeNauticalFoodRes.verify|verify} messages.
         * @function encode
         * @memberof Nautical.MergeNauticalFoodRes
         * @static
         * @param {Nautical.IMergeNauticalFoodRes} message MergeNauticalFoodRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        MergeNauticalFoodRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.FullBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified MergeNauticalFoodRes message, length delimited. Does not implicitly {@link Nautical.MergeNauticalFoodRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.MergeNauticalFoodRes
         * @static
         * @param {Nautical.IMergeNauticalFoodRes} message MergeNauticalFoodRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        MergeNauticalFoodRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a MergeNauticalFoodRes message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.MergeNauticalFoodRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.MergeNauticalFoodRes} MergeNauticalFoodRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        MergeNauticalFoodRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.MergeNauticalFoodRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.FullBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a MergeNauticalFoodRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.MergeNauticalFoodRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.MergeNauticalFoodRes} MergeNauticalFoodRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        MergeNauticalFoodRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a MergeNauticalFoodRes message.
         * @function verify
         * @memberof Nautical.MergeNauticalFoodRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        MergeNauticalFoodRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.FullBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return MergeNauticalFoodRes;
    })();

    Nautical.StartNauticalTripReq = (function() {

        /**
         * Properties of a StartNauticalTripReq.
         * @memberof Nautical
         * @interface IStartNauticalTripReq
         * @property {Array.<string>|null} [catIds] StartNauticalTripReq catIds
         * @property {Object.<string,number|Long>|null} [foodInTrip] StartNauticalTripReq foodInTrip
         * @property {Array.<string>|null} [toolInTrip] StartNauticalTripReq toolInTrip
         */

        /**
         * Constructs a new StartNauticalTripReq.
         * @memberof Nautical
         * @classdesc Represents a StartNauticalTripReq.
         * @implements IStartNauticalTripReq
         * @constructor
         * @param {Nautical.IStartNauticalTripReq=} [properties] Properties to set
         */
        function StartNauticalTripReq(properties) {
            this.catIds = [];
            this.foodInTrip = {};
            this.toolInTrip = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * StartNauticalTripReq catIds.
         * @member {Array.<string>} catIds
         * @memberof Nautical.StartNauticalTripReq
         * @instance
         */
        StartNauticalTripReq.prototype.catIds = $util.emptyArray;

        /**
         * StartNauticalTripReq foodInTrip.
         * @member {Object.<string,number|Long>} foodInTrip
         * @memberof Nautical.StartNauticalTripReq
         * @instance
         */
        StartNauticalTripReq.prototype.foodInTrip = $util.emptyObject;

        /**
         * StartNauticalTripReq toolInTrip.
         * @member {Array.<string>} toolInTrip
         * @memberof Nautical.StartNauticalTripReq
         * @instance
         */
        StartNauticalTripReq.prototype.toolInTrip = $util.emptyArray;

        /**
         * Creates a new StartNauticalTripReq instance using the specified properties.
         * @function create
         * @memberof Nautical.StartNauticalTripReq
         * @static
         * @param {Nautical.IStartNauticalTripReq=} [properties] Properties to set
         * @returns {Nautical.StartNauticalTripReq} StartNauticalTripReq instance
         */
        StartNauticalTripReq.create = function create(properties) {
            return new StartNauticalTripReq(properties);
        };

        /**
         * Encodes the specified StartNauticalTripReq message. Does not implicitly {@link Nautical.StartNauticalTripReq.verify|verify} messages.
         * @function encode
         * @memberof Nautical.StartNauticalTripReq
         * @static
         * @param {Nautical.IStartNauticalTripReq} message StartNauticalTripReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StartNauticalTripReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.catIds != null && message.catIds.length)
                for (var i = 0; i < message.catIds.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.catIds[i]);
            if (message.foodInTrip != null && message.hasOwnProperty("foodInTrip"))
                for (var keys = Object.keys(message.foodInTrip), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 2, wireType 2 =*/18).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 0 =*/16).int64(message.foodInTrip[keys[i]]).ldelim();
            if (message.toolInTrip != null && message.toolInTrip.length)
                for (var i = 0; i < message.toolInTrip.length; ++i)
                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.toolInTrip[i]);
            return writer;
        };

        /**
         * Encodes the specified StartNauticalTripReq message, length delimited. Does not implicitly {@link Nautical.StartNauticalTripReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.StartNauticalTripReq
         * @static
         * @param {Nautical.IStartNauticalTripReq} message StartNauticalTripReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StartNauticalTripReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a StartNauticalTripReq message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.StartNauticalTripReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.StartNauticalTripReq} StartNauticalTripReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StartNauticalTripReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.StartNauticalTripReq(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.catIds && message.catIds.length))
                        message.catIds = [];
                    message.catIds.push(reader.string());
                    break;
                case 2:
                    reader.skip().pos++;
                    if (message.foodInTrip === $util.emptyObject)
                        message.foodInTrip = {};
                    key = reader.string();
                    reader.pos++;
                    message.foodInTrip[key] = reader.int64();
                    break;
                case 3:
                    if (!(message.toolInTrip && message.toolInTrip.length))
                        message.toolInTrip = [];
                    message.toolInTrip.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a StartNauticalTripReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.StartNauticalTripReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.StartNauticalTripReq} StartNauticalTripReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StartNauticalTripReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a StartNauticalTripReq message.
         * @function verify
         * @memberof Nautical.StartNauticalTripReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        StartNauticalTripReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.catIds != null && message.hasOwnProperty("catIds")) {
                if (!Array.isArray(message.catIds))
                    return "catIds: array expected";
                for (var i = 0; i < message.catIds.length; ++i)
                    if (!$util.isString(message.catIds[i]))
                        return "catIds: string[] expected";
            }
            if (message.foodInTrip != null && message.hasOwnProperty("foodInTrip")) {
                if (!$util.isObject(message.foodInTrip))
                    return "foodInTrip: object expected";
                var key = Object.keys(message.foodInTrip);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isInteger(message.foodInTrip[key[i]]) && !(message.foodInTrip[key[i]] && $util.isInteger(message.foodInTrip[key[i]].low) && $util.isInteger(message.foodInTrip[key[i]].high)))
                        return "foodInTrip: integer|Long{k:string} expected";
            }
            if (message.toolInTrip != null && message.hasOwnProperty("toolInTrip")) {
                if (!Array.isArray(message.toolInTrip))
                    return "toolInTrip: array expected";
                for (var i = 0; i < message.toolInTrip.length; ++i)
                    if (!$util.isString(message.toolInTrip[i]))
                        return "toolInTrip: string[] expected";
            }
            return null;
        };

        return StartNauticalTripReq;
    })();

    Nautical.StartNauticalTripRes = (function() {

        /**
         * Properties of a StartNauticalTripRes.
         * @memberof Nautical
         * @interface IStartNauticalTripRes
         * @property {Nautical.INauticalInfo|null} [nauticalInfo] StartNauticalTripRes nauticalInfo
         */

        /**
         * Constructs a new StartNauticalTripRes.
         * @memberof Nautical
         * @classdesc Represents a StartNauticalTripRes.
         * @implements IStartNauticalTripRes
         * @constructor
         * @param {Nautical.IStartNauticalTripRes=} [properties] Properties to set
         */
        function StartNauticalTripRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * StartNauticalTripRes nauticalInfo.
         * @member {Nautical.INauticalInfo|null|undefined} nauticalInfo
         * @memberof Nautical.StartNauticalTripRes
         * @instance
         */
        StartNauticalTripRes.prototype.nauticalInfo = null;

        /**
         * Creates a new StartNauticalTripRes instance using the specified properties.
         * @function create
         * @memberof Nautical.StartNauticalTripRes
         * @static
         * @param {Nautical.IStartNauticalTripRes=} [properties] Properties to set
         * @returns {Nautical.StartNauticalTripRes} StartNauticalTripRes instance
         */
        StartNauticalTripRes.create = function create(properties) {
            return new StartNauticalTripRes(properties);
        };

        /**
         * Encodes the specified StartNauticalTripRes message. Does not implicitly {@link Nautical.StartNauticalTripRes.verify|verify} messages.
         * @function encode
         * @memberof Nautical.StartNauticalTripRes
         * @static
         * @param {Nautical.IStartNauticalTripRes} message StartNauticalTripRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StartNauticalTripRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo"))
                $root.Nautical.NauticalInfo.encode(message.nauticalInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified StartNauticalTripRes message, length delimited. Does not implicitly {@link Nautical.StartNauticalTripRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.StartNauticalTripRes
         * @static
         * @param {Nautical.IStartNauticalTripRes} message StartNauticalTripRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StartNauticalTripRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a StartNauticalTripRes message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.StartNauticalTripRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.StartNauticalTripRes} StartNauticalTripRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StartNauticalTripRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.StartNauticalTripRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.nauticalInfo = $root.Nautical.NauticalInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a StartNauticalTripRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.StartNauticalTripRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.StartNauticalTripRes} StartNauticalTripRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StartNauticalTripRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a StartNauticalTripRes message.
         * @function verify
         * @memberof Nautical.StartNauticalTripRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        StartNauticalTripRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo")) {
                var error = $root.Nautical.NauticalInfo.verify(message.nauticalInfo);
                if (error)
                    return "nauticalInfo." + error;
            }
            return null;
        };

        return StartNauticalTripRes;
    })();

    Nautical.FinishNauticalTripReq = (function() {

        /**
         * Properties of a FinishNauticalTripReq.
         * @memberof Nautical
         * @interface IFinishNauticalTripReq
         * @property {BaseInfo.FetchType|null} [fetchType] FinishNauticalTripReq fetchType
         */

        /**
         * Constructs a new FinishNauticalTripReq.
         * @memberof Nautical
         * @classdesc Represents a FinishNauticalTripReq.
         * @implements IFinishNauticalTripReq
         * @constructor
         * @param {Nautical.IFinishNauticalTripReq=} [properties] Properties to set
         */
        function FinishNauticalTripReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FinishNauticalTripReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof Nautical.FinishNauticalTripReq
         * @instance
         */
        FinishNauticalTripReq.prototype.fetchType = 0;

        /**
         * Creates a new FinishNauticalTripReq instance using the specified properties.
         * @function create
         * @memberof Nautical.FinishNauticalTripReq
         * @static
         * @param {Nautical.IFinishNauticalTripReq=} [properties] Properties to set
         * @returns {Nautical.FinishNauticalTripReq} FinishNauticalTripReq instance
         */
        FinishNauticalTripReq.create = function create(properties) {
            return new FinishNauticalTripReq(properties);
        };

        /**
         * Encodes the specified FinishNauticalTripReq message. Does not implicitly {@link Nautical.FinishNauticalTripReq.verify|verify} messages.
         * @function encode
         * @memberof Nautical.FinishNauticalTripReq
         * @static
         * @param {Nautical.IFinishNauticalTripReq} message FinishNauticalTripReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishNauticalTripReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified FinishNauticalTripReq message, length delimited. Does not implicitly {@link Nautical.FinishNauticalTripReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.FinishNauticalTripReq
         * @static
         * @param {Nautical.IFinishNauticalTripReq} message FinishNauticalTripReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishNauticalTripReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FinishNauticalTripReq message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.FinishNauticalTripReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.FinishNauticalTripReq} FinishNauticalTripReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishNauticalTripReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.FinishNauticalTripReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FinishNauticalTripReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.FinishNauticalTripReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.FinishNauticalTripReq} FinishNauticalTripReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishNauticalTripReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FinishNauticalTripReq message.
         * @function verify
         * @memberof Nautical.FinishNauticalTripReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FinishNauticalTripReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return FinishNauticalTripReq;
    })();

    Nautical.FinishNauticalTripRes = (function() {

        /**
         * Properties of a FinishNauticalTripRes.
         * @memberof Nautical
         * @interface IFinishNauticalTripRes
         * @property {BaseInfo.IFullBag|null} [bag] FinishNauticalTripRes bag
         * @property {BaseInfo.IRewards|null} [rewards] FinishNauticalTripRes rewards
         * @property {Array.<BaseInfo.IPetInfo>|null} [petInfos] FinishNauticalTripRes petInfos
         * @property {Array.<Nautical.INauticalPhotoReward>|null} [photoRewards] FinishNauticalTripRes photoRewards
         */

        /**
         * Constructs a new FinishNauticalTripRes.
         * @memberof Nautical
         * @classdesc Represents a FinishNauticalTripRes.
         * @implements IFinishNauticalTripRes
         * @constructor
         * @param {Nautical.IFinishNauticalTripRes=} [properties] Properties to set
         */
        function FinishNauticalTripRes(properties) {
            this.petInfos = [];
            this.photoRewards = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FinishNauticalTripRes bag.
         * @member {BaseInfo.IFullBag|null|undefined} bag
         * @memberof Nautical.FinishNauticalTripRes
         * @instance
         */
        FinishNauticalTripRes.prototype.bag = null;

        /**
         * FinishNauticalTripRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Nautical.FinishNauticalTripRes
         * @instance
         */
        FinishNauticalTripRes.prototype.rewards = null;

        /**
         * FinishNauticalTripRes petInfos.
         * @member {Array.<BaseInfo.IPetInfo>} petInfos
         * @memberof Nautical.FinishNauticalTripRes
         * @instance
         */
        FinishNauticalTripRes.prototype.petInfos = $util.emptyArray;

        /**
         * FinishNauticalTripRes photoRewards.
         * @member {Array.<Nautical.INauticalPhotoReward>} photoRewards
         * @memberof Nautical.FinishNauticalTripRes
         * @instance
         */
        FinishNauticalTripRes.prototype.photoRewards = $util.emptyArray;

        /**
         * Creates a new FinishNauticalTripRes instance using the specified properties.
         * @function create
         * @memberof Nautical.FinishNauticalTripRes
         * @static
         * @param {Nautical.IFinishNauticalTripRes=} [properties] Properties to set
         * @returns {Nautical.FinishNauticalTripRes} FinishNauticalTripRes instance
         */
        FinishNauticalTripRes.create = function create(properties) {
            return new FinishNauticalTripRes(properties);
        };

        /**
         * Encodes the specified FinishNauticalTripRes message. Does not implicitly {@link Nautical.FinishNauticalTripRes.verify|verify} messages.
         * @function encode
         * @memberof Nautical.FinishNauticalTripRes
         * @static
         * @param {Nautical.IFinishNauticalTripRes} message FinishNauticalTripRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishNauticalTripRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.FullBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.petInfos != null && message.petInfos.length)
                for (var i = 0; i < message.petInfos.length; ++i)
                    $root.BaseInfo.PetInfo.encode(message.petInfos[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            if (message.photoRewards != null && message.photoRewards.length)
                for (var i = 0; i < message.photoRewards.length; ++i)
                    $root.Nautical.NauticalPhotoReward.encode(message.photoRewards[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FinishNauticalTripRes message, length delimited. Does not implicitly {@link Nautical.FinishNauticalTripRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.FinishNauticalTripRes
         * @static
         * @param {Nautical.IFinishNauticalTripRes} message FinishNauticalTripRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishNauticalTripRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FinishNauticalTripRes message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.FinishNauticalTripRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.FinishNauticalTripRes} FinishNauticalTripRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishNauticalTripRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.FinishNauticalTripRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.bag = $root.BaseInfo.FullBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 4:
                    if (!(message.petInfos && message.petInfos.length))
                        message.petInfos = [];
                    message.petInfos.push($root.BaseInfo.PetInfo.decode(reader, reader.uint32()));
                    break;
                case 5:
                    if (!(message.photoRewards && message.photoRewards.length))
                        message.photoRewards = [];
                    message.photoRewards.push($root.Nautical.NauticalPhotoReward.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FinishNauticalTripRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.FinishNauticalTripRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.FinishNauticalTripRes} FinishNauticalTripRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishNauticalTripRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FinishNauticalTripRes message.
         * @function verify
         * @memberof Nautical.FinishNauticalTripRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FinishNauticalTripRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.FullBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.petInfos != null && message.hasOwnProperty("petInfos")) {
                if (!Array.isArray(message.petInfos))
                    return "petInfos: array expected";
                for (var i = 0; i < message.petInfos.length; ++i) {
                    var error = $root.BaseInfo.PetInfo.verify(message.petInfos[i]);
                    if (error)
                        return "petInfos." + error;
                }
            }
            if (message.photoRewards != null && message.hasOwnProperty("photoRewards")) {
                if (!Array.isArray(message.photoRewards))
                    return "photoRewards: array expected";
                for (var i = 0; i < message.photoRewards.length; ++i) {
                    var error = $root.Nautical.NauticalPhotoReward.verify(message.photoRewards[i]);
                    if (error)
                        return "photoRewards." + error;
                }
            }
            return null;
        };

        return FinishNauticalTripRes;
    })();

    Nautical.PreviewNauticalTripReq = (function() {

        /**
         * Properties of a PreviewNauticalTripReq.
         * @memberof Nautical
         * @interface IPreviewNauticalTripReq
         */

        /**
         * Constructs a new PreviewNauticalTripReq.
         * @memberof Nautical
         * @classdesc Represents a PreviewNauticalTripReq.
         * @implements IPreviewNauticalTripReq
         * @constructor
         * @param {Nautical.IPreviewNauticalTripReq=} [properties] Properties to set
         */
        function PreviewNauticalTripReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new PreviewNauticalTripReq instance using the specified properties.
         * @function create
         * @memberof Nautical.PreviewNauticalTripReq
         * @static
         * @param {Nautical.IPreviewNauticalTripReq=} [properties] Properties to set
         * @returns {Nautical.PreviewNauticalTripReq} PreviewNauticalTripReq instance
         */
        PreviewNauticalTripReq.create = function create(properties) {
            return new PreviewNauticalTripReq(properties);
        };

        /**
         * Encodes the specified PreviewNauticalTripReq message. Does not implicitly {@link Nautical.PreviewNauticalTripReq.verify|verify} messages.
         * @function encode
         * @memberof Nautical.PreviewNauticalTripReq
         * @static
         * @param {Nautical.IPreviewNauticalTripReq} message PreviewNauticalTripReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PreviewNauticalTripReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified PreviewNauticalTripReq message, length delimited. Does not implicitly {@link Nautical.PreviewNauticalTripReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.PreviewNauticalTripReq
         * @static
         * @param {Nautical.IPreviewNauticalTripReq} message PreviewNauticalTripReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PreviewNauticalTripReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PreviewNauticalTripReq message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.PreviewNauticalTripReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.PreviewNauticalTripReq} PreviewNauticalTripReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PreviewNauticalTripReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.PreviewNauticalTripReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PreviewNauticalTripReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.PreviewNauticalTripReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.PreviewNauticalTripReq} PreviewNauticalTripReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PreviewNauticalTripReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PreviewNauticalTripReq message.
         * @function verify
         * @memberof Nautical.PreviewNauticalTripReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PreviewNauticalTripReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return PreviewNauticalTripReq;
    })();

    Nautical.PreviewNauticalTripRes = (function() {

        /**
         * Properties of a PreviewNauticalTripRes.
         * @memberof Nautical
         * @interface IPreviewNauticalTripRes
         * @property {BaseInfo.IRewards|null} [rewards] PreviewNauticalTripRes rewards
         * @property {number|null} [intimacyIncr] PreviewNauticalTripRes intimacyIncr
         * @property {Array.<Nautical.INauticalPhotoReward>|null} [photoRewards] PreviewNauticalTripRes photoRewards
         */

        /**
         * Constructs a new PreviewNauticalTripRes.
         * @memberof Nautical
         * @classdesc Represents a PreviewNauticalTripRes.
         * @implements IPreviewNauticalTripRes
         * @constructor
         * @param {Nautical.IPreviewNauticalTripRes=} [properties] Properties to set
         */
        function PreviewNauticalTripRes(properties) {
            this.photoRewards = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PreviewNauticalTripRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Nautical.PreviewNauticalTripRes
         * @instance
         */
        PreviewNauticalTripRes.prototype.rewards = null;

        /**
         * PreviewNauticalTripRes intimacyIncr.
         * @member {number} intimacyIncr
         * @memberof Nautical.PreviewNauticalTripRes
         * @instance
         */
        PreviewNauticalTripRes.prototype.intimacyIncr = 0;

        /**
         * PreviewNauticalTripRes photoRewards.
         * @member {Array.<Nautical.INauticalPhotoReward>} photoRewards
         * @memberof Nautical.PreviewNauticalTripRes
         * @instance
         */
        PreviewNauticalTripRes.prototype.photoRewards = $util.emptyArray;

        /**
         * Creates a new PreviewNauticalTripRes instance using the specified properties.
         * @function create
         * @memberof Nautical.PreviewNauticalTripRes
         * @static
         * @param {Nautical.IPreviewNauticalTripRes=} [properties] Properties to set
         * @returns {Nautical.PreviewNauticalTripRes} PreviewNauticalTripRes instance
         */
        PreviewNauticalTripRes.create = function create(properties) {
            return new PreviewNauticalTripRes(properties);
        };

        /**
         * Encodes the specified PreviewNauticalTripRes message. Does not implicitly {@link Nautical.PreviewNauticalTripRes.verify|verify} messages.
         * @function encode
         * @memberof Nautical.PreviewNauticalTripRes
         * @static
         * @param {Nautical.IPreviewNauticalTripRes} message PreviewNauticalTripRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PreviewNauticalTripRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.intimacyIncr != null && message.hasOwnProperty("intimacyIncr"))
                writer.uint32(/* id 3, wireType 1 =*/25).double(message.intimacyIncr);
            if (message.photoRewards != null && message.photoRewards.length)
                for (var i = 0; i < message.photoRewards.length; ++i)
                    $root.Nautical.NauticalPhotoReward.encode(message.photoRewards[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified PreviewNauticalTripRes message, length delimited. Does not implicitly {@link Nautical.PreviewNauticalTripRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.PreviewNauticalTripRes
         * @static
         * @param {Nautical.IPreviewNauticalTripRes} message PreviewNauticalTripRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PreviewNauticalTripRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PreviewNauticalTripRes message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.PreviewNauticalTripRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.PreviewNauticalTripRes} PreviewNauticalTripRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PreviewNauticalTripRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.PreviewNauticalTripRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.intimacyIncr = reader.double();
                    break;
                case 4:
                    if (!(message.photoRewards && message.photoRewards.length))
                        message.photoRewards = [];
                    message.photoRewards.push($root.Nautical.NauticalPhotoReward.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PreviewNauticalTripRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.PreviewNauticalTripRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.PreviewNauticalTripRes} PreviewNauticalTripRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PreviewNauticalTripRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PreviewNauticalTripRes message.
         * @function verify
         * @memberof Nautical.PreviewNauticalTripRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PreviewNauticalTripRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.intimacyIncr != null && message.hasOwnProperty("intimacyIncr"))
                if (typeof message.intimacyIncr !== "number")
                    return "intimacyIncr: number expected";
            if (message.photoRewards != null && message.hasOwnProperty("photoRewards")) {
                if (!Array.isArray(message.photoRewards))
                    return "photoRewards: array expected";
                for (var i = 0; i < message.photoRewards.length; ++i) {
                    var error = $root.Nautical.NauticalPhotoReward.verify(message.photoRewards[i]);
                    if (error)
                        return "photoRewards." + error;
                }
            }
            return null;
        };

        return PreviewNauticalTripRes;
    })();

    Nautical.AdReduceNauticalTimeReq = (function() {

        /**
         * Properties of an AdReduceNauticalTimeReq.
         * @memberof Nautical
         * @interface IAdReduceNauticalTimeReq
         */

        /**
         * Constructs a new AdReduceNauticalTimeReq.
         * @memberof Nautical
         * @classdesc Represents an AdReduceNauticalTimeReq.
         * @implements IAdReduceNauticalTimeReq
         * @constructor
         * @param {Nautical.IAdReduceNauticalTimeReq=} [properties] Properties to set
         */
        function AdReduceNauticalTimeReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new AdReduceNauticalTimeReq instance using the specified properties.
         * @function create
         * @memberof Nautical.AdReduceNauticalTimeReq
         * @static
         * @param {Nautical.IAdReduceNauticalTimeReq=} [properties] Properties to set
         * @returns {Nautical.AdReduceNauticalTimeReq} AdReduceNauticalTimeReq instance
         */
        AdReduceNauticalTimeReq.create = function create(properties) {
            return new AdReduceNauticalTimeReq(properties);
        };

        /**
         * Encodes the specified AdReduceNauticalTimeReq message. Does not implicitly {@link Nautical.AdReduceNauticalTimeReq.verify|verify} messages.
         * @function encode
         * @memberof Nautical.AdReduceNauticalTimeReq
         * @static
         * @param {Nautical.IAdReduceNauticalTimeReq} message AdReduceNauticalTimeReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdReduceNauticalTimeReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified AdReduceNauticalTimeReq message, length delimited. Does not implicitly {@link Nautical.AdReduceNauticalTimeReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.AdReduceNauticalTimeReq
         * @static
         * @param {Nautical.IAdReduceNauticalTimeReq} message AdReduceNauticalTimeReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdReduceNauticalTimeReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AdReduceNauticalTimeReq message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.AdReduceNauticalTimeReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.AdReduceNauticalTimeReq} AdReduceNauticalTimeReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdReduceNauticalTimeReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.AdReduceNauticalTimeReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AdReduceNauticalTimeReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.AdReduceNauticalTimeReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.AdReduceNauticalTimeReq} AdReduceNauticalTimeReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdReduceNauticalTimeReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AdReduceNauticalTimeReq message.
         * @function verify
         * @memberof Nautical.AdReduceNauticalTimeReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AdReduceNauticalTimeReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return AdReduceNauticalTimeReq;
    })();

    Nautical.AdReduceNauticalTimeRes = (function() {

        /**
         * Properties of an AdReduceNauticalTimeRes.
         * @memberof Nautical
         * @interface IAdReduceNauticalTimeRes
         * @property {Nautical.INauticalInfo|null} [nauticalInfo] AdReduceNauticalTimeRes nauticalInfo
         * @property {boolean|null} [isDirectFinish] AdReduceNauticalTimeRes isDirectFinish
         */

        /**
         * Constructs a new AdReduceNauticalTimeRes.
         * @memberof Nautical
         * @classdesc Represents an AdReduceNauticalTimeRes.
         * @implements IAdReduceNauticalTimeRes
         * @constructor
         * @param {Nautical.IAdReduceNauticalTimeRes=} [properties] Properties to set
         */
        function AdReduceNauticalTimeRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AdReduceNauticalTimeRes nauticalInfo.
         * @member {Nautical.INauticalInfo|null|undefined} nauticalInfo
         * @memberof Nautical.AdReduceNauticalTimeRes
         * @instance
         */
        AdReduceNauticalTimeRes.prototype.nauticalInfo = null;

        /**
         * AdReduceNauticalTimeRes isDirectFinish.
         * @member {boolean} isDirectFinish
         * @memberof Nautical.AdReduceNauticalTimeRes
         * @instance
         */
        AdReduceNauticalTimeRes.prototype.isDirectFinish = false;

        /**
         * Creates a new AdReduceNauticalTimeRes instance using the specified properties.
         * @function create
         * @memberof Nautical.AdReduceNauticalTimeRes
         * @static
         * @param {Nautical.IAdReduceNauticalTimeRes=} [properties] Properties to set
         * @returns {Nautical.AdReduceNauticalTimeRes} AdReduceNauticalTimeRes instance
         */
        AdReduceNauticalTimeRes.create = function create(properties) {
            return new AdReduceNauticalTimeRes(properties);
        };

        /**
         * Encodes the specified AdReduceNauticalTimeRes message. Does not implicitly {@link Nautical.AdReduceNauticalTimeRes.verify|verify} messages.
         * @function encode
         * @memberof Nautical.AdReduceNauticalTimeRes
         * @static
         * @param {Nautical.IAdReduceNauticalTimeRes} message AdReduceNauticalTimeRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdReduceNauticalTimeRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo"))
                $root.Nautical.NauticalInfo.encode(message.nauticalInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.isDirectFinish != null && message.hasOwnProperty("isDirectFinish"))
                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.isDirectFinish);
            return writer;
        };

        /**
         * Encodes the specified AdReduceNauticalTimeRes message, length delimited. Does not implicitly {@link Nautical.AdReduceNauticalTimeRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.AdReduceNauticalTimeRes
         * @static
         * @param {Nautical.IAdReduceNauticalTimeRes} message AdReduceNauticalTimeRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdReduceNauticalTimeRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AdReduceNauticalTimeRes message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.AdReduceNauticalTimeRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.AdReduceNauticalTimeRes} AdReduceNauticalTimeRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdReduceNauticalTimeRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.AdReduceNauticalTimeRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.nauticalInfo = $root.Nautical.NauticalInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.isDirectFinish = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AdReduceNauticalTimeRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.AdReduceNauticalTimeRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.AdReduceNauticalTimeRes} AdReduceNauticalTimeRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdReduceNauticalTimeRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AdReduceNauticalTimeRes message.
         * @function verify
         * @memberof Nautical.AdReduceNauticalTimeRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AdReduceNauticalTimeRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo")) {
                var error = $root.Nautical.NauticalInfo.verify(message.nauticalInfo);
                if (error)
                    return "nauticalInfo." + error;
            }
            if (message.isDirectFinish != null && message.hasOwnProperty("isDirectFinish"))
                if (typeof message.isDirectFinish !== "boolean")
                    return "isDirectFinish: boolean expected";
            return null;
        };

        return AdReduceNauticalTimeRes;
    })();

    Nautical.GetNauticalInfo0912Req = (function() {

        /**
         * Properties of a GetNauticalInfo0912Req.
         * @memberof Nautical
         * @interface IGetNauticalInfo0912Req
         */

        /**
         * Constructs a new GetNauticalInfo0912Req.
         * @memberof Nautical
         * @classdesc Represents a GetNauticalInfo0912Req.
         * @implements IGetNauticalInfo0912Req
         * @constructor
         * @param {Nautical.IGetNauticalInfo0912Req=} [properties] Properties to set
         */
        function GetNauticalInfo0912Req(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetNauticalInfo0912Req instance using the specified properties.
         * @function create
         * @memberof Nautical.GetNauticalInfo0912Req
         * @static
         * @param {Nautical.IGetNauticalInfo0912Req=} [properties] Properties to set
         * @returns {Nautical.GetNauticalInfo0912Req} GetNauticalInfo0912Req instance
         */
        GetNauticalInfo0912Req.create = function create(properties) {
            return new GetNauticalInfo0912Req(properties);
        };

        /**
         * Encodes the specified GetNauticalInfo0912Req message. Does not implicitly {@link Nautical.GetNauticalInfo0912Req.verify|verify} messages.
         * @function encode
         * @memberof Nautical.GetNauticalInfo0912Req
         * @static
         * @param {Nautical.IGetNauticalInfo0912Req} message GetNauticalInfo0912Req message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetNauticalInfo0912Req.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetNauticalInfo0912Req message, length delimited. Does not implicitly {@link Nautical.GetNauticalInfo0912Req.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.GetNauticalInfo0912Req
         * @static
         * @param {Nautical.IGetNauticalInfo0912Req} message GetNauticalInfo0912Req message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetNauticalInfo0912Req.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetNauticalInfo0912Req message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.GetNauticalInfo0912Req
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.GetNauticalInfo0912Req} GetNauticalInfo0912Req
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetNauticalInfo0912Req.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.GetNauticalInfo0912Req();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetNauticalInfo0912Req message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.GetNauticalInfo0912Req
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.GetNauticalInfo0912Req} GetNauticalInfo0912Req
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetNauticalInfo0912Req.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetNauticalInfo0912Req message.
         * @function verify
         * @memberof Nautical.GetNauticalInfo0912Req
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetNauticalInfo0912Req.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetNauticalInfo0912Req;
    })();

    Nautical.GetNauticalInfo0912Res = (function() {

        /**
         * Properties of a GetNauticalInfo0912Res.
         * @memberof Nautical
         * @interface IGetNauticalInfo0912Res
         * @property {Array.<Nautical.INauticalInfo>|null} [nauticalInfo] GetNauticalInfo0912Res nauticalInfo
         * @property {Array.<string>|null} [petIds] GetNauticalInfo0912Res petIds
         * @property {Object.<string,BaseInfo.IItem>|null} [nauticalFoods] GetNauticalInfo0912Res nauticalFoods
         * @property {Object.<string,BaseInfo.IItem>|null} [nauticalTools] GetNauticalInfo0912Res nauticalTools
         * @property {number|null} [nauticalTicketNum] GetNauticalInfo0912Res nauticalTicketNum
         */

        /**
         * Constructs a new GetNauticalInfo0912Res.
         * @memberof Nautical
         * @classdesc Represents a GetNauticalInfo0912Res.
         * @implements IGetNauticalInfo0912Res
         * @constructor
         * @param {Nautical.IGetNauticalInfo0912Res=} [properties] Properties to set
         */
        function GetNauticalInfo0912Res(properties) {
            this.nauticalInfo = [];
            this.petIds = [];
            this.nauticalFoods = {};
            this.nauticalTools = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetNauticalInfo0912Res nauticalInfo.
         * @member {Array.<Nautical.INauticalInfo>} nauticalInfo
         * @memberof Nautical.GetNauticalInfo0912Res
         * @instance
         */
        GetNauticalInfo0912Res.prototype.nauticalInfo = $util.emptyArray;

        /**
         * GetNauticalInfo0912Res petIds.
         * @member {Array.<string>} petIds
         * @memberof Nautical.GetNauticalInfo0912Res
         * @instance
         */
        GetNauticalInfo0912Res.prototype.petIds = $util.emptyArray;

        /**
         * GetNauticalInfo0912Res nauticalFoods.
         * @member {Object.<string,BaseInfo.IItem>} nauticalFoods
         * @memberof Nautical.GetNauticalInfo0912Res
         * @instance
         */
        GetNauticalInfo0912Res.prototype.nauticalFoods = $util.emptyObject;

        /**
         * GetNauticalInfo0912Res nauticalTools.
         * @member {Object.<string,BaseInfo.IItem>} nauticalTools
         * @memberof Nautical.GetNauticalInfo0912Res
         * @instance
         */
        GetNauticalInfo0912Res.prototype.nauticalTools = $util.emptyObject;

        /**
         * GetNauticalInfo0912Res nauticalTicketNum.
         * @member {number} nauticalTicketNum
         * @memberof Nautical.GetNauticalInfo0912Res
         * @instance
         */
        GetNauticalInfo0912Res.prototype.nauticalTicketNum = 0;

        /**
         * Creates a new GetNauticalInfo0912Res instance using the specified properties.
         * @function create
         * @memberof Nautical.GetNauticalInfo0912Res
         * @static
         * @param {Nautical.IGetNauticalInfo0912Res=} [properties] Properties to set
         * @returns {Nautical.GetNauticalInfo0912Res} GetNauticalInfo0912Res instance
         */
        GetNauticalInfo0912Res.create = function create(properties) {
            return new GetNauticalInfo0912Res(properties);
        };

        /**
         * Encodes the specified GetNauticalInfo0912Res message. Does not implicitly {@link Nautical.GetNauticalInfo0912Res.verify|verify} messages.
         * @function encode
         * @memberof Nautical.GetNauticalInfo0912Res
         * @static
         * @param {Nautical.IGetNauticalInfo0912Res} message GetNauticalInfo0912Res message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetNauticalInfo0912Res.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.nauticalInfo != null && message.nauticalInfo.length)
                for (var i = 0; i < message.nauticalInfo.length; ++i)
                    $root.Nautical.NauticalInfo.encode(message.nauticalInfo[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.petIds != null && message.petIds.length)
                for (var i = 0; i < message.petIds.length; ++i)
                    writer.uint32(/* id 8, wireType 2 =*/66).string(message.petIds[i]);
            if (message.nauticalFoods != null && message.hasOwnProperty("nauticalFoods"))
                for (var keys = Object.keys(message.nauticalFoods), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 9, wireType 2 =*/74).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Item.encode(message.nauticalFoods[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            if (message.nauticalTools != null && message.hasOwnProperty("nauticalTools"))
                for (var keys = Object.keys(message.nauticalTools), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 10, wireType 2 =*/82).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Item.encode(message.nauticalTools[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            if (message.nauticalTicketNum != null && message.hasOwnProperty("nauticalTicketNum"))
                writer.uint32(/* id 11, wireType 0 =*/88).int32(message.nauticalTicketNum);
            return writer;
        };

        /**
         * Encodes the specified GetNauticalInfo0912Res message, length delimited. Does not implicitly {@link Nautical.GetNauticalInfo0912Res.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.GetNauticalInfo0912Res
         * @static
         * @param {Nautical.IGetNauticalInfo0912Res} message GetNauticalInfo0912Res message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetNauticalInfo0912Res.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetNauticalInfo0912Res message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.GetNauticalInfo0912Res
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.GetNauticalInfo0912Res} GetNauticalInfo0912Res
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetNauticalInfo0912Res.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.GetNauticalInfo0912Res(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.nauticalInfo && message.nauticalInfo.length))
                        message.nauticalInfo = [];
                    message.nauticalInfo.push($root.Nautical.NauticalInfo.decode(reader, reader.uint32()));
                    break;
                case 8:
                    if (!(message.petIds && message.petIds.length))
                        message.petIds = [];
                    message.petIds.push(reader.string());
                    break;
                case 9:
                    reader.skip().pos++;
                    if (message.nauticalFoods === $util.emptyObject)
                        message.nauticalFoods = {};
                    key = reader.string();
                    reader.pos++;
                    message.nauticalFoods[key] = $root.BaseInfo.Item.decode(reader, reader.uint32());
                    break;
                case 10:
                    reader.skip().pos++;
                    if (message.nauticalTools === $util.emptyObject)
                        message.nauticalTools = {};
                    key = reader.string();
                    reader.pos++;
                    message.nauticalTools[key] = $root.BaseInfo.Item.decode(reader, reader.uint32());
                    break;
                case 11:
                    message.nauticalTicketNum = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetNauticalInfo0912Res message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.GetNauticalInfo0912Res
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.GetNauticalInfo0912Res} GetNauticalInfo0912Res
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetNauticalInfo0912Res.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetNauticalInfo0912Res message.
         * @function verify
         * @memberof Nautical.GetNauticalInfo0912Res
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetNauticalInfo0912Res.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo")) {
                if (!Array.isArray(message.nauticalInfo))
                    return "nauticalInfo: array expected";
                for (var i = 0; i < message.nauticalInfo.length; ++i) {
                    var error = $root.Nautical.NauticalInfo.verify(message.nauticalInfo[i]);
                    if (error)
                        return "nauticalInfo." + error;
                }
            }
            if (message.petIds != null && message.hasOwnProperty("petIds")) {
                if (!Array.isArray(message.petIds))
                    return "petIds: array expected";
                for (var i = 0; i < message.petIds.length; ++i)
                    if (!$util.isString(message.petIds[i]))
                        return "petIds: string[] expected";
            }
            if (message.nauticalFoods != null && message.hasOwnProperty("nauticalFoods")) {
                if (!$util.isObject(message.nauticalFoods))
                    return "nauticalFoods: object expected";
                var key = Object.keys(message.nauticalFoods);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.nauticalFoods[key[i]]);
                    if (error)
                        return "nauticalFoods." + error;
                }
            }
            if (message.nauticalTools != null && message.hasOwnProperty("nauticalTools")) {
                if (!$util.isObject(message.nauticalTools))
                    return "nauticalTools: object expected";
                var key = Object.keys(message.nauticalTools);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.nauticalTools[key[i]]);
                    if (error)
                        return "nauticalTools." + error;
                }
            }
            if (message.nauticalTicketNum != null && message.hasOwnProperty("nauticalTicketNum"))
                if (!$util.isInteger(message.nauticalTicketNum))
                    return "nauticalTicketNum: integer expected";
            return null;
        };

        return GetNauticalInfo0912Res;
    })();

    Nautical.StartNauticalTrip0912Req = (function() {

        /**
         * Properties of a StartNauticalTrip0912Req.
         * @memberof Nautical
         * @interface IStartNauticalTrip0912Req
         * @property {Array.<string>|null} [catIds] StartNauticalTrip0912Req catIds
         * @property {Object.<string,number|Long>|null} [foodInTrip] StartNauticalTrip0912Req foodInTrip
         * @property {Array.<string>|null} [toolInTrip] StartNauticalTrip0912Req toolInTrip
         * @property {number|null} [tripIndex] StartNauticalTrip0912Req tripIndex
         */

        /**
         * Constructs a new StartNauticalTrip0912Req.
         * @memberof Nautical
         * @classdesc Represents a StartNauticalTrip0912Req.
         * @implements IStartNauticalTrip0912Req
         * @constructor
         * @param {Nautical.IStartNauticalTrip0912Req=} [properties] Properties to set
         */
        function StartNauticalTrip0912Req(properties) {
            this.catIds = [];
            this.foodInTrip = {};
            this.toolInTrip = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * StartNauticalTrip0912Req catIds.
         * @member {Array.<string>} catIds
         * @memberof Nautical.StartNauticalTrip0912Req
         * @instance
         */
        StartNauticalTrip0912Req.prototype.catIds = $util.emptyArray;

        /**
         * StartNauticalTrip0912Req foodInTrip.
         * @member {Object.<string,number|Long>} foodInTrip
         * @memberof Nautical.StartNauticalTrip0912Req
         * @instance
         */
        StartNauticalTrip0912Req.prototype.foodInTrip = $util.emptyObject;

        /**
         * StartNauticalTrip0912Req toolInTrip.
         * @member {Array.<string>} toolInTrip
         * @memberof Nautical.StartNauticalTrip0912Req
         * @instance
         */
        StartNauticalTrip0912Req.prototype.toolInTrip = $util.emptyArray;

        /**
         * StartNauticalTrip0912Req tripIndex.
         * @member {number} tripIndex
         * @memberof Nautical.StartNauticalTrip0912Req
         * @instance
         */
        StartNauticalTrip0912Req.prototype.tripIndex = 0;

        /**
         * Creates a new StartNauticalTrip0912Req instance using the specified properties.
         * @function create
         * @memberof Nautical.StartNauticalTrip0912Req
         * @static
         * @param {Nautical.IStartNauticalTrip0912Req=} [properties] Properties to set
         * @returns {Nautical.StartNauticalTrip0912Req} StartNauticalTrip0912Req instance
         */
        StartNauticalTrip0912Req.create = function create(properties) {
            return new StartNauticalTrip0912Req(properties);
        };

        /**
         * Encodes the specified StartNauticalTrip0912Req message. Does not implicitly {@link Nautical.StartNauticalTrip0912Req.verify|verify} messages.
         * @function encode
         * @memberof Nautical.StartNauticalTrip0912Req
         * @static
         * @param {Nautical.IStartNauticalTrip0912Req} message StartNauticalTrip0912Req message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StartNauticalTrip0912Req.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.catIds != null && message.catIds.length)
                for (var i = 0; i < message.catIds.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.catIds[i]);
            if (message.foodInTrip != null && message.hasOwnProperty("foodInTrip"))
                for (var keys = Object.keys(message.foodInTrip), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 2, wireType 2 =*/18).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 0 =*/16).int64(message.foodInTrip[keys[i]]).ldelim();
            if (message.toolInTrip != null && message.toolInTrip.length)
                for (var i = 0; i < message.toolInTrip.length; ++i)
                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.toolInTrip[i]);
            if (message.tripIndex != null && message.hasOwnProperty("tripIndex"))
                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.tripIndex);
            return writer;
        };

        /**
         * Encodes the specified StartNauticalTrip0912Req message, length delimited. Does not implicitly {@link Nautical.StartNauticalTrip0912Req.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.StartNauticalTrip0912Req
         * @static
         * @param {Nautical.IStartNauticalTrip0912Req} message StartNauticalTrip0912Req message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StartNauticalTrip0912Req.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a StartNauticalTrip0912Req message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.StartNauticalTrip0912Req
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.StartNauticalTrip0912Req} StartNauticalTrip0912Req
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StartNauticalTrip0912Req.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.StartNauticalTrip0912Req(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.catIds && message.catIds.length))
                        message.catIds = [];
                    message.catIds.push(reader.string());
                    break;
                case 2:
                    reader.skip().pos++;
                    if (message.foodInTrip === $util.emptyObject)
                        message.foodInTrip = {};
                    key = reader.string();
                    reader.pos++;
                    message.foodInTrip[key] = reader.int64();
                    break;
                case 3:
                    if (!(message.toolInTrip && message.toolInTrip.length))
                        message.toolInTrip = [];
                    message.toolInTrip.push(reader.string());
                    break;
                case 4:
                    message.tripIndex = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a StartNauticalTrip0912Req message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.StartNauticalTrip0912Req
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.StartNauticalTrip0912Req} StartNauticalTrip0912Req
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StartNauticalTrip0912Req.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a StartNauticalTrip0912Req message.
         * @function verify
         * @memberof Nautical.StartNauticalTrip0912Req
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        StartNauticalTrip0912Req.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.catIds != null && message.hasOwnProperty("catIds")) {
                if (!Array.isArray(message.catIds))
                    return "catIds: array expected";
                for (var i = 0; i < message.catIds.length; ++i)
                    if (!$util.isString(message.catIds[i]))
                        return "catIds: string[] expected";
            }
            if (message.foodInTrip != null && message.hasOwnProperty("foodInTrip")) {
                if (!$util.isObject(message.foodInTrip))
                    return "foodInTrip: object expected";
                var key = Object.keys(message.foodInTrip);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isInteger(message.foodInTrip[key[i]]) && !(message.foodInTrip[key[i]] && $util.isInteger(message.foodInTrip[key[i]].low) && $util.isInteger(message.foodInTrip[key[i]].high)))
                        return "foodInTrip: integer|Long{k:string} expected";
            }
            if (message.toolInTrip != null && message.hasOwnProperty("toolInTrip")) {
                if (!Array.isArray(message.toolInTrip))
                    return "toolInTrip: array expected";
                for (var i = 0; i < message.toolInTrip.length; ++i)
                    if (!$util.isString(message.toolInTrip[i]))
                        return "toolInTrip: string[] expected";
            }
            if (message.tripIndex != null && message.hasOwnProperty("tripIndex"))
                if (!$util.isInteger(message.tripIndex))
                    return "tripIndex: integer expected";
            return null;
        };

        return StartNauticalTrip0912Req;
    })();

    Nautical.StartNauticalTrip0912Res = (function() {

        /**
         * Properties of a StartNauticalTrip0912Res.
         * @memberof Nautical
         * @interface IStartNauticalTrip0912Res
         * @property {Nautical.INauticalInfo|null} [nauticalInfo] StartNauticalTrip0912Res nauticalInfo
         * @property {Array.<string>|null} [petIds] StartNauticalTrip0912Res petIds
         * @property {Object.<string,BaseInfo.IItem>|null} [nauticalFoods] StartNauticalTrip0912Res nauticalFoods
         * @property {Object.<string,BaseInfo.IItem>|null} [nauticalTools] StartNauticalTrip0912Res nauticalTools
         */

        /**
         * Constructs a new StartNauticalTrip0912Res.
         * @memberof Nautical
         * @classdesc Represents a StartNauticalTrip0912Res.
         * @implements IStartNauticalTrip0912Res
         * @constructor
         * @param {Nautical.IStartNauticalTrip0912Res=} [properties] Properties to set
         */
        function StartNauticalTrip0912Res(properties) {
            this.petIds = [];
            this.nauticalFoods = {};
            this.nauticalTools = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * StartNauticalTrip0912Res nauticalInfo.
         * @member {Nautical.INauticalInfo|null|undefined} nauticalInfo
         * @memberof Nautical.StartNauticalTrip0912Res
         * @instance
         */
        StartNauticalTrip0912Res.prototype.nauticalInfo = null;

        /**
         * StartNauticalTrip0912Res petIds.
         * @member {Array.<string>} petIds
         * @memberof Nautical.StartNauticalTrip0912Res
         * @instance
         */
        StartNauticalTrip0912Res.prototype.petIds = $util.emptyArray;

        /**
         * StartNauticalTrip0912Res nauticalFoods.
         * @member {Object.<string,BaseInfo.IItem>} nauticalFoods
         * @memberof Nautical.StartNauticalTrip0912Res
         * @instance
         */
        StartNauticalTrip0912Res.prototype.nauticalFoods = $util.emptyObject;

        /**
         * StartNauticalTrip0912Res nauticalTools.
         * @member {Object.<string,BaseInfo.IItem>} nauticalTools
         * @memberof Nautical.StartNauticalTrip0912Res
         * @instance
         */
        StartNauticalTrip0912Res.prototype.nauticalTools = $util.emptyObject;

        /**
         * Creates a new StartNauticalTrip0912Res instance using the specified properties.
         * @function create
         * @memberof Nautical.StartNauticalTrip0912Res
         * @static
         * @param {Nautical.IStartNauticalTrip0912Res=} [properties] Properties to set
         * @returns {Nautical.StartNauticalTrip0912Res} StartNauticalTrip0912Res instance
         */
        StartNauticalTrip0912Res.create = function create(properties) {
            return new StartNauticalTrip0912Res(properties);
        };

        /**
         * Encodes the specified StartNauticalTrip0912Res message. Does not implicitly {@link Nautical.StartNauticalTrip0912Res.verify|verify} messages.
         * @function encode
         * @memberof Nautical.StartNauticalTrip0912Res
         * @static
         * @param {Nautical.IStartNauticalTrip0912Res} message StartNauticalTrip0912Res message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StartNauticalTrip0912Res.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo"))
                $root.Nautical.NauticalInfo.encode(message.nauticalInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.petIds != null && message.petIds.length)
                for (var i = 0; i < message.petIds.length; ++i)
                    writer.uint32(/* id 8, wireType 2 =*/66).string(message.petIds[i]);
            if (message.nauticalFoods != null && message.hasOwnProperty("nauticalFoods"))
                for (var keys = Object.keys(message.nauticalFoods), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 9, wireType 2 =*/74).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Item.encode(message.nauticalFoods[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            if (message.nauticalTools != null && message.hasOwnProperty("nauticalTools"))
                for (var keys = Object.keys(message.nauticalTools), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 10, wireType 2 =*/82).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Item.encode(message.nauticalTools[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified StartNauticalTrip0912Res message, length delimited. Does not implicitly {@link Nautical.StartNauticalTrip0912Res.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.StartNauticalTrip0912Res
         * @static
         * @param {Nautical.IStartNauticalTrip0912Res} message StartNauticalTrip0912Res message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StartNauticalTrip0912Res.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a StartNauticalTrip0912Res message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.StartNauticalTrip0912Res
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.StartNauticalTrip0912Res} StartNauticalTrip0912Res
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StartNauticalTrip0912Res.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.StartNauticalTrip0912Res(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.nauticalInfo = $root.Nautical.NauticalInfo.decode(reader, reader.uint32());
                    break;
                case 8:
                    if (!(message.petIds && message.petIds.length))
                        message.petIds = [];
                    message.petIds.push(reader.string());
                    break;
                case 9:
                    reader.skip().pos++;
                    if (message.nauticalFoods === $util.emptyObject)
                        message.nauticalFoods = {};
                    key = reader.string();
                    reader.pos++;
                    message.nauticalFoods[key] = $root.BaseInfo.Item.decode(reader, reader.uint32());
                    break;
                case 10:
                    reader.skip().pos++;
                    if (message.nauticalTools === $util.emptyObject)
                        message.nauticalTools = {};
                    key = reader.string();
                    reader.pos++;
                    message.nauticalTools[key] = $root.BaseInfo.Item.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a StartNauticalTrip0912Res message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.StartNauticalTrip0912Res
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.StartNauticalTrip0912Res} StartNauticalTrip0912Res
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StartNauticalTrip0912Res.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a StartNauticalTrip0912Res message.
         * @function verify
         * @memberof Nautical.StartNauticalTrip0912Res
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        StartNauticalTrip0912Res.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo")) {
                var error = $root.Nautical.NauticalInfo.verify(message.nauticalInfo);
                if (error)
                    return "nauticalInfo." + error;
            }
            if (message.petIds != null && message.hasOwnProperty("petIds")) {
                if (!Array.isArray(message.petIds))
                    return "petIds: array expected";
                for (var i = 0; i < message.petIds.length; ++i)
                    if (!$util.isString(message.petIds[i]))
                        return "petIds: string[] expected";
            }
            if (message.nauticalFoods != null && message.hasOwnProperty("nauticalFoods")) {
                if (!$util.isObject(message.nauticalFoods))
                    return "nauticalFoods: object expected";
                var key = Object.keys(message.nauticalFoods);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.nauticalFoods[key[i]]);
                    if (error)
                        return "nauticalFoods." + error;
                }
            }
            if (message.nauticalTools != null && message.hasOwnProperty("nauticalTools")) {
                if (!$util.isObject(message.nauticalTools))
                    return "nauticalTools: object expected";
                var key = Object.keys(message.nauticalTools);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.nauticalTools[key[i]]);
                    if (error)
                        return "nauticalTools." + error;
                }
            }
            return null;
        };

        return StartNauticalTrip0912Res;
    })();

    Nautical.FinishNauticalTrip0912Req = (function() {

        /**
         * Properties of a FinishNauticalTrip0912Req.
         * @memberof Nautical
         * @interface IFinishNauticalTrip0912Req
         * @property {BaseInfo.FetchType|null} [fetchType] FinishNauticalTrip0912Req fetchType
         * @property {number|null} [tripIndex] FinishNauticalTrip0912Req tripIndex
         */

        /**
         * Constructs a new FinishNauticalTrip0912Req.
         * @memberof Nautical
         * @classdesc Represents a FinishNauticalTrip0912Req.
         * @implements IFinishNauticalTrip0912Req
         * @constructor
         * @param {Nautical.IFinishNauticalTrip0912Req=} [properties] Properties to set
         */
        function FinishNauticalTrip0912Req(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FinishNauticalTrip0912Req fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof Nautical.FinishNauticalTrip0912Req
         * @instance
         */
        FinishNauticalTrip0912Req.prototype.fetchType = 0;

        /**
         * FinishNauticalTrip0912Req tripIndex.
         * @member {number} tripIndex
         * @memberof Nautical.FinishNauticalTrip0912Req
         * @instance
         */
        FinishNauticalTrip0912Req.prototype.tripIndex = 0;

        /**
         * Creates a new FinishNauticalTrip0912Req instance using the specified properties.
         * @function create
         * @memberof Nautical.FinishNauticalTrip0912Req
         * @static
         * @param {Nautical.IFinishNauticalTrip0912Req=} [properties] Properties to set
         * @returns {Nautical.FinishNauticalTrip0912Req} FinishNauticalTrip0912Req instance
         */
        FinishNauticalTrip0912Req.create = function create(properties) {
            return new FinishNauticalTrip0912Req(properties);
        };

        /**
         * Encodes the specified FinishNauticalTrip0912Req message. Does not implicitly {@link Nautical.FinishNauticalTrip0912Req.verify|verify} messages.
         * @function encode
         * @memberof Nautical.FinishNauticalTrip0912Req
         * @static
         * @param {Nautical.IFinishNauticalTrip0912Req} message FinishNauticalTrip0912Req message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishNauticalTrip0912Req.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.fetchType);
            if (message.tripIndex != null && message.hasOwnProperty("tripIndex"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.tripIndex);
            return writer;
        };

        /**
         * Encodes the specified FinishNauticalTrip0912Req message, length delimited. Does not implicitly {@link Nautical.FinishNauticalTrip0912Req.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.FinishNauticalTrip0912Req
         * @static
         * @param {Nautical.IFinishNauticalTrip0912Req} message FinishNauticalTrip0912Req message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishNauticalTrip0912Req.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FinishNauticalTrip0912Req message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.FinishNauticalTrip0912Req
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.FinishNauticalTrip0912Req} FinishNauticalTrip0912Req
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishNauticalTrip0912Req.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.FinishNauticalTrip0912Req();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.fetchType = reader.int32();
                    break;
                case 2:
                    message.tripIndex = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FinishNauticalTrip0912Req message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.FinishNauticalTrip0912Req
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.FinishNauticalTrip0912Req} FinishNauticalTrip0912Req
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishNauticalTrip0912Req.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FinishNauticalTrip0912Req message.
         * @function verify
         * @memberof Nautical.FinishNauticalTrip0912Req
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FinishNauticalTrip0912Req.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            if (message.tripIndex != null && message.hasOwnProperty("tripIndex"))
                if (!$util.isInteger(message.tripIndex))
                    return "tripIndex: integer expected";
            return null;
        };

        return FinishNauticalTrip0912Req;
    })();

    Nautical.FinishNauticalTrip0912Res = (function() {

        /**
         * Properties of a FinishNauticalTrip0912Res.
         * @memberof Nautical
         * @interface IFinishNauticalTrip0912Res
         * @property {BaseInfo.IFullBag|null} [bag] FinishNauticalTrip0912Res bag
         * @property {BaseInfo.IRewards|null} [rewards] FinishNauticalTrip0912Res rewards
         * @property {Array.<BaseInfo.IPetInfo>|null} [petInfos] FinishNauticalTrip0912Res petInfos
         * @property {Array.<Nautical.INauticalPhotoReward>|null} [photoRewards] FinishNauticalTrip0912Res photoRewards
         * @property {Array.<string>|null} [petIds] FinishNauticalTrip0912Res petIds
         * @property {Object.<string,BaseInfo.IItem>|null} [nauticalFoods] FinishNauticalTrip0912Res nauticalFoods
         * @property {Object.<string,BaseInfo.IItem>|null} [nauticalTools] FinishNauticalTrip0912Res nauticalTools
         */

        /**
         * Constructs a new FinishNauticalTrip0912Res.
         * @memberof Nautical
         * @classdesc Represents a FinishNauticalTrip0912Res.
         * @implements IFinishNauticalTrip0912Res
         * @constructor
         * @param {Nautical.IFinishNauticalTrip0912Res=} [properties] Properties to set
         */
        function FinishNauticalTrip0912Res(properties) {
            this.petInfos = [];
            this.photoRewards = [];
            this.petIds = [];
            this.nauticalFoods = {};
            this.nauticalTools = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FinishNauticalTrip0912Res bag.
         * @member {BaseInfo.IFullBag|null|undefined} bag
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @instance
         */
        FinishNauticalTrip0912Res.prototype.bag = null;

        /**
         * FinishNauticalTrip0912Res rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @instance
         */
        FinishNauticalTrip0912Res.prototype.rewards = null;

        /**
         * FinishNauticalTrip0912Res petInfos.
         * @member {Array.<BaseInfo.IPetInfo>} petInfos
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @instance
         */
        FinishNauticalTrip0912Res.prototype.petInfos = $util.emptyArray;

        /**
         * FinishNauticalTrip0912Res photoRewards.
         * @member {Array.<Nautical.INauticalPhotoReward>} photoRewards
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @instance
         */
        FinishNauticalTrip0912Res.prototype.photoRewards = $util.emptyArray;

        /**
         * FinishNauticalTrip0912Res petIds.
         * @member {Array.<string>} petIds
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @instance
         */
        FinishNauticalTrip0912Res.prototype.petIds = $util.emptyArray;

        /**
         * FinishNauticalTrip0912Res nauticalFoods.
         * @member {Object.<string,BaseInfo.IItem>} nauticalFoods
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @instance
         */
        FinishNauticalTrip0912Res.prototype.nauticalFoods = $util.emptyObject;

        /**
         * FinishNauticalTrip0912Res nauticalTools.
         * @member {Object.<string,BaseInfo.IItem>} nauticalTools
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @instance
         */
        FinishNauticalTrip0912Res.prototype.nauticalTools = $util.emptyObject;

        /**
         * Creates a new FinishNauticalTrip0912Res instance using the specified properties.
         * @function create
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @static
         * @param {Nautical.IFinishNauticalTrip0912Res=} [properties] Properties to set
         * @returns {Nautical.FinishNauticalTrip0912Res} FinishNauticalTrip0912Res instance
         */
        FinishNauticalTrip0912Res.create = function create(properties) {
            return new FinishNauticalTrip0912Res(properties);
        };

        /**
         * Encodes the specified FinishNauticalTrip0912Res message. Does not implicitly {@link Nautical.FinishNauticalTrip0912Res.verify|verify} messages.
         * @function encode
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @static
         * @param {Nautical.IFinishNauticalTrip0912Res} message FinishNauticalTrip0912Res message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishNauticalTrip0912Res.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.FullBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.petInfos != null && message.petInfos.length)
                for (var i = 0; i < message.petInfos.length; ++i)
                    $root.BaseInfo.PetInfo.encode(message.petInfos[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            if (message.photoRewards != null && message.photoRewards.length)
                for (var i = 0; i < message.photoRewards.length; ++i)
                    $root.Nautical.NauticalPhotoReward.encode(message.photoRewards[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
            if (message.petIds != null && message.petIds.length)
                for (var i = 0; i < message.petIds.length; ++i)
                    writer.uint32(/* id 8, wireType 2 =*/66).string(message.petIds[i]);
            if (message.nauticalFoods != null && message.hasOwnProperty("nauticalFoods"))
                for (var keys = Object.keys(message.nauticalFoods), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 9, wireType 2 =*/74).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Item.encode(message.nauticalFoods[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            if (message.nauticalTools != null && message.hasOwnProperty("nauticalTools"))
                for (var keys = Object.keys(message.nauticalTools), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 10, wireType 2 =*/82).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.Item.encode(message.nauticalTools[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified FinishNauticalTrip0912Res message, length delimited. Does not implicitly {@link Nautical.FinishNauticalTrip0912Res.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @static
         * @param {Nautical.IFinishNauticalTrip0912Res} message FinishNauticalTrip0912Res message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishNauticalTrip0912Res.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FinishNauticalTrip0912Res message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.FinishNauticalTrip0912Res} FinishNauticalTrip0912Res
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishNauticalTrip0912Res.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.FinishNauticalTrip0912Res(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.bag = $root.BaseInfo.FullBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 4:
                    if (!(message.petInfos && message.petInfos.length))
                        message.petInfos = [];
                    message.petInfos.push($root.BaseInfo.PetInfo.decode(reader, reader.uint32()));
                    break;
                case 5:
                    if (!(message.photoRewards && message.photoRewards.length))
                        message.photoRewards = [];
                    message.photoRewards.push($root.Nautical.NauticalPhotoReward.decode(reader, reader.uint32()));
                    break;
                case 8:
                    if (!(message.petIds && message.petIds.length))
                        message.petIds = [];
                    message.petIds.push(reader.string());
                    break;
                case 9:
                    reader.skip().pos++;
                    if (message.nauticalFoods === $util.emptyObject)
                        message.nauticalFoods = {};
                    key = reader.string();
                    reader.pos++;
                    message.nauticalFoods[key] = $root.BaseInfo.Item.decode(reader, reader.uint32());
                    break;
                case 10:
                    reader.skip().pos++;
                    if (message.nauticalTools === $util.emptyObject)
                        message.nauticalTools = {};
                    key = reader.string();
                    reader.pos++;
                    message.nauticalTools[key] = $root.BaseInfo.Item.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FinishNauticalTrip0912Res message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.FinishNauticalTrip0912Res} FinishNauticalTrip0912Res
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishNauticalTrip0912Res.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FinishNauticalTrip0912Res message.
         * @function verify
         * @memberof Nautical.FinishNauticalTrip0912Res
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FinishNauticalTrip0912Res.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.FullBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.petInfos != null && message.hasOwnProperty("petInfos")) {
                if (!Array.isArray(message.petInfos))
                    return "petInfos: array expected";
                for (var i = 0; i < message.petInfos.length; ++i) {
                    var error = $root.BaseInfo.PetInfo.verify(message.petInfos[i]);
                    if (error)
                        return "petInfos." + error;
                }
            }
            if (message.photoRewards != null && message.hasOwnProperty("photoRewards")) {
                if (!Array.isArray(message.photoRewards))
                    return "photoRewards: array expected";
                for (var i = 0; i < message.photoRewards.length; ++i) {
                    var error = $root.Nautical.NauticalPhotoReward.verify(message.photoRewards[i]);
                    if (error)
                        return "photoRewards." + error;
                }
            }
            if (message.petIds != null && message.hasOwnProperty("petIds")) {
                if (!Array.isArray(message.petIds))
                    return "petIds: array expected";
                for (var i = 0; i < message.petIds.length; ++i)
                    if (!$util.isString(message.petIds[i]))
                        return "petIds: string[] expected";
            }
            if (message.nauticalFoods != null && message.hasOwnProperty("nauticalFoods")) {
                if (!$util.isObject(message.nauticalFoods))
                    return "nauticalFoods: object expected";
                var key = Object.keys(message.nauticalFoods);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.nauticalFoods[key[i]]);
                    if (error)
                        return "nauticalFoods." + error;
                }
            }
            if (message.nauticalTools != null && message.hasOwnProperty("nauticalTools")) {
                if (!$util.isObject(message.nauticalTools))
                    return "nauticalTools: object expected";
                var key = Object.keys(message.nauticalTools);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.Item.verify(message.nauticalTools[key[i]]);
                    if (error)
                        return "nauticalTools." + error;
                }
            }
            return null;
        };

        return FinishNauticalTrip0912Res;
    })();

    Nautical.PreviewNauticalTrip0912Req = (function() {

        /**
         * Properties of a PreviewNauticalTrip0912Req.
         * @memberof Nautical
         * @interface IPreviewNauticalTrip0912Req
         * @property {number|null} [tripIndex] PreviewNauticalTrip0912Req tripIndex
         */

        /**
         * Constructs a new PreviewNauticalTrip0912Req.
         * @memberof Nautical
         * @classdesc Represents a PreviewNauticalTrip0912Req.
         * @implements IPreviewNauticalTrip0912Req
         * @constructor
         * @param {Nautical.IPreviewNauticalTrip0912Req=} [properties] Properties to set
         */
        function PreviewNauticalTrip0912Req(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PreviewNauticalTrip0912Req tripIndex.
         * @member {number} tripIndex
         * @memberof Nautical.PreviewNauticalTrip0912Req
         * @instance
         */
        PreviewNauticalTrip0912Req.prototype.tripIndex = 0;

        /**
         * Creates a new PreviewNauticalTrip0912Req instance using the specified properties.
         * @function create
         * @memberof Nautical.PreviewNauticalTrip0912Req
         * @static
         * @param {Nautical.IPreviewNauticalTrip0912Req=} [properties] Properties to set
         * @returns {Nautical.PreviewNauticalTrip0912Req} PreviewNauticalTrip0912Req instance
         */
        PreviewNauticalTrip0912Req.create = function create(properties) {
            return new PreviewNauticalTrip0912Req(properties);
        };

        /**
         * Encodes the specified PreviewNauticalTrip0912Req message. Does not implicitly {@link Nautical.PreviewNauticalTrip0912Req.verify|verify} messages.
         * @function encode
         * @memberof Nautical.PreviewNauticalTrip0912Req
         * @static
         * @param {Nautical.IPreviewNauticalTrip0912Req} message PreviewNauticalTrip0912Req message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PreviewNauticalTrip0912Req.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.tripIndex != null && message.hasOwnProperty("tripIndex"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.tripIndex);
            return writer;
        };

        /**
         * Encodes the specified PreviewNauticalTrip0912Req message, length delimited. Does not implicitly {@link Nautical.PreviewNauticalTrip0912Req.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.PreviewNauticalTrip0912Req
         * @static
         * @param {Nautical.IPreviewNauticalTrip0912Req} message PreviewNauticalTrip0912Req message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PreviewNauticalTrip0912Req.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PreviewNauticalTrip0912Req message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.PreviewNauticalTrip0912Req
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.PreviewNauticalTrip0912Req} PreviewNauticalTrip0912Req
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PreviewNauticalTrip0912Req.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.PreviewNauticalTrip0912Req();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.tripIndex = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PreviewNauticalTrip0912Req message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.PreviewNauticalTrip0912Req
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.PreviewNauticalTrip0912Req} PreviewNauticalTrip0912Req
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PreviewNauticalTrip0912Req.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PreviewNauticalTrip0912Req message.
         * @function verify
         * @memberof Nautical.PreviewNauticalTrip0912Req
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PreviewNauticalTrip0912Req.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.tripIndex != null && message.hasOwnProperty("tripIndex"))
                if (!$util.isInteger(message.tripIndex))
                    return "tripIndex: integer expected";
            return null;
        };

        return PreviewNauticalTrip0912Req;
    })();

    Nautical.PreviewNauticalTrip0912Res = (function() {

        /**
         * Properties of a PreviewNauticalTrip0912Res.
         * @memberof Nautical
         * @interface IPreviewNauticalTrip0912Res
         * @property {BaseInfo.IRewards|null} [rewards] PreviewNauticalTrip0912Res rewards
         * @property {number|null} [intimacyIncr] PreviewNauticalTrip0912Res intimacyIncr
         * @property {Array.<Nautical.INauticalPhotoReward>|null} [photoRewards] PreviewNauticalTrip0912Res photoRewards
         */

        /**
         * Constructs a new PreviewNauticalTrip0912Res.
         * @memberof Nautical
         * @classdesc Represents a PreviewNauticalTrip0912Res.
         * @implements IPreviewNauticalTrip0912Res
         * @constructor
         * @param {Nautical.IPreviewNauticalTrip0912Res=} [properties] Properties to set
         */
        function PreviewNauticalTrip0912Res(properties) {
            this.photoRewards = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PreviewNauticalTrip0912Res rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Nautical.PreviewNauticalTrip0912Res
         * @instance
         */
        PreviewNauticalTrip0912Res.prototype.rewards = null;

        /**
         * PreviewNauticalTrip0912Res intimacyIncr.
         * @member {number} intimacyIncr
         * @memberof Nautical.PreviewNauticalTrip0912Res
         * @instance
         */
        PreviewNauticalTrip0912Res.prototype.intimacyIncr = 0;

        /**
         * PreviewNauticalTrip0912Res photoRewards.
         * @member {Array.<Nautical.INauticalPhotoReward>} photoRewards
         * @memberof Nautical.PreviewNauticalTrip0912Res
         * @instance
         */
        PreviewNauticalTrip0912Res.prototype.photoRewards = $util.emptyArray;

        /**
         * Creates a new PreviewNauticalTrip0912Res instance using the specified properties.
         * @function create
         * @memberof Nautical.PreviewNauticalTrip0912Res
         * @static
         * @param {Nautical.IPreviewNauticalTrip0912Res=} [properties] Properties to set
         * @returns {Nautical.PreviewNauticalTrip0912Res} PreviewNauticalTrip0912Res instance
         */
        PreviewNauticalTrip0912Res.create = function create(properties) {
            return new PreviewNauticalTrip0912Res(properties);
        };

        /**
         * Encodes the specified PreviewNauticalTrip0912Res message. Does not implicitly {@link Nautical.PreviewNauticalTrip0912Res.verify|verify} messages.
         * @function encode
         * @memberof Nautical.PreviewNauticalTrip0912Res
         * @static
         * @param {Nautical.IPreviewNauticalTrip0912Res} message PreviewNauticalTrip0912Res message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PreviewNauticalTrip0912Res.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.intimacyIncr != null && message.hasOwnProperty("intimacyIncr"))
                writer.uint32(/* id 3, wireType 1 =*/25).double(message.intimacyIncr);
            if (message.photoRewards != null && message.photoRewards.length)
                for (var i = 0; i < message.photoRewards.length; ++i)
                    $root.Nautical.NauticalPhotoReward.encode(message.photoRewards[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified PreviewNauticalTrip0912Res message, length delimited. Does not implicitly {@link Nautical.PreviewNauticalTrip0912Res.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.PreviewNauticalTrip0912Res
         * @static
         * @param {Nautical.IPreviewNauticalTrip0912Res} message PreviewNauticalTrip0912Res message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PreviewNauticalTrip0912Res.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PreviewNauticalTrip0912Res message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.PreviewNauticalTrip0912Res
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.PreviewNauticalTrip0912Res} PreviewNauticalTrip0912Res
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PreviewNauticalTrip0912Res.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.PreviewNauticalTrip0912Res();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.intimacyIncr = reader.double();
                    break;
                case 4:
                    if (!(message.photoRewards && message.photoRewards.length))
                        message.photoRewards = [];
                    message.photoRewards.push($root.Nautical.NauticalPhotoReward.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PreviewNauticalTrip0912Res message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.PreviewNauticalTrip0912Res
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.PreviewNauticalTrip0912Res} PreviewNauticalTrip0912Res
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PreviewNauticalTrip0912Res.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PreviewNauticalTrip0912Res message.
         * @function verify
         * @memberof Nautical.PreviewNauticalTrip0912Res
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PreviewNauticalTrip0912Res.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.intimacyIncr != null && message.hasOwnProperty("intimacyIncr"))
                if (typeof message.intimacyIncr !== "number")
                    return "intimacyIncr: number expected";
            if (message.photoRewards != null && message.hasOwnProperty("photoRewards")) {
                if (!Array.isArray(message.photoRewards))
                    return "photoRewards: array expected";
                for (var i = 0; i < message.photoRewards.length; ++i) {
                    var error = $root.Nautical.NauticalPhotoReward.verify(message.photoRewards[i]);
                    if (error)
                        return "photoRewards." + error;
                }
            }
            return null;
        };

        return PreviewNauticalTrip0912Res;
    })();

    Nautical.AdReduceNauticalTime0912Req = (function() {

        /**
         * Properties of an AdReduceNauticalTime0912Req.
         * @memberof Nautical
         * @interface IAdReduceNauticalTime0912Req
         * @property {number|null} [tripIndex] AdReduceNauticalTime0912Req tripIndex
         * @property {number|null} [type] AdReduceNauticalTime0912Req type
         */

        /**
         * Constructs a new AdReduceNauticalTime0912Req.
         * @memberof Nautical
         * @classdesc Represents an AdReduceNauticalTime0912Req.
         * @implements IAdReduceNauticalTime0912Req
         * @constructor
         * @param {Nautical.IAdReduceNauticalTime0912Req=} [properties] Properties to set
         */
        function AdReduceNauticalTime0912Req(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AdReduceNauticalTime0912Req tripIndex.
         * @member {number} tripIndex
         * @memberof Nautical.AdReduceNauticalTime0912Req
         * @instance
         */
        AdReduceNauticalTime0912Req.prototype.tripIndex = 0;

        /**
         * AdReduceNauticalTime0912Req type.
         * @member {number} type
         * @memberof Nautical.AdReduceNauticalTime0912Req
         * @instance
         */
        AdReduceNauticalTime0912Req.prototype.type = 0;

        /**
         * Creates a new AdReduceNauticalTime0912Req instance using the specified properties.
         * @function create
         * @memberof Nautical.AdReduceNauticalTime0912Req
         * @static
         * @param {Nautical.IAdReduceNauticalTime0912Req=} [properties] Properties to set
         * @returns {Nautical.AdReduceNauticalTime0912Req} AdReduceNauticalTime0912Req instance
         */
        AdReduceNauticalTime0912Req.create = function create(properties) {
            return new AdReduceNauticalTime0912Req(properties);
        };

        /**
         * Encodes the specified AdReduceNauticalTime0912Req message. Does not implicitly {@link Nautical.AdReduceNauticalTime0912Req.verify|verify} messages.
         * @function encode
         * @memberof Nautical.AdReduceNauticalTime0912Req
         * @static
         * @param {Nautical.IAdReduceNauticalTime0912Req} message AdReduceNauticalTime0912Req message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdReduceNauticalTime0912Req.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.tripIndex != null && message.hasOwnProperty("tripIndex"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.tripIndex);
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.type);
            return writer;
        };

        /**
         * Encodes the specified AdReduceNauticalTime0912Req message, length delimited. Does not implicitly {@link Nautical.AdReduceNauticalTime0912Req.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.AdReduceNauticalTime0912Req
         * @static
         * @param {Nautical.IAdReduceNauticalTime0912Req} message AdReduceNauticalTime0912Req message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdReduceNauticalTime0912Req.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AdReduceNauticalTime0912Req message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.AdReduceNauticalTime0912Req
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.AdReduceNauticalTime0912Req} AdReduceNauticalTime0912Req
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdReduceNauticalTime0912Req.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.AdReduceNauticalTime0912Req();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.tripIndex = reader.int32();
                    break;
                case 2:
                    message.type = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AdReduceNauticalTime0912Req message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.AdReduceNauticalTime0912Req
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.AdReduceNauticalTime0912Req} AdReduceNauticalTime0912Req
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdReduceNauticalTime0912Req.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AdReduceNauticalTime0912Req message.
         * @function verify
         * @memberof Nautical.AdReduceNauticalTime0912Req
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AdReduceNauticalTime0912Req.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.tripIndex != null && message.hasOwnProperty("tripIndex"))
                if (!$util.isInteger(message.tripIndex))
                    return "tripIndex: integer expected";
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isInteger(message.type))
                    return "type: integer expected";
            return null;
        };

        return AdReduceNauticalTime0912Req;
    })();

    Nautical.AdReduceNauticalTime0912Res = (function() {

        /**
         * Properties of an AdReduceNauticalTime0912Res.
         * @memberof Nautical
         * @interface IAdReduceNauticalTime0912Res
         * @property {Nautical.INauticalInfo|null} [nauticalInfo] AdReduceNauticalTime0912Res nauticalInfo
         * @property {boolean|null} [isDirectFinish] AdReduceNauticalTime0912Res isDirectFinish
         * @property {number|null} [nauticalTicketNum] AdReduceNauticalTime0912Res nauticalTicketNum
         */

        /**
         * Constructs a new AdReduceNauticalTime0912Res.
         * @memberof Nautical
         * @classdesc Represents an AdReduceNauticalTime0912Res.
         * @implements IAdReduceNauticalTime0912Res
         * @constructor
         * @param {Nautical.IAdReduceNauticalTime0912Res=} [properties] Properties to set
         */
        function AdReduceNauticalTime0912Res(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AdReduceNauticalTime0912Res nauticalInfo.
         * @member {Nautical.INauticalInfo|null|undefined} nauticalInfo
         * @memberof Nautical.AdReduceNauticalTime0912Res
         * @instance
         */
        AdReduceNauticalTime0912Res.prototype.nauticalInfo = null;

        /**
         * AdReduceNauticalTime0912Res isDirectFinish.
         * @member {boolean} isDirectFinish
         * @memberof Nautical.AdReduceNauticalTime0912Res
         * @instance
         */
        AdReduceNauticalTime0912Res.prototype.isDirectFinish = false;

        /**
         * AdReduceNauticalTime0912Res nauticalTicketNum.
         * @member {number} nauticalTicketNum
         * @memberof Nautical.AdReduceNauticalTime0912Res
         * @instance
         */
        AdReduceNauticalTime0912Res.prototype.nauticalTicketNum = 0;

        /**
         * Creates a new AdReduceNauticalTime0912Res instance using the specified properties.
         * @function create
         * @memberof Nautical.AdReduceNauticalTime0912Res
         * @static
         * @param {Nautical.IAdReduceNauticalTime0912Res=} [properties] Properties to set
         * @returns {Nautical.AdReduceNauticalTime0912Res} AdReduceNauticalTime0912Res instance
         */
        AdReduceNauticalTime0912Res.create = function create(properties) {
            return new AdReduceNauticalTime0912Res(properties);
        };

        /**
         * Encodes the specified AdReduceNauticalTime0912Res message. Does not implicitly {@link Nautical.AdReduceNauticalTime0912Res.verify|verify} messages.
         * @function encode
         * @memberof Nautical.AdReduceNauticalTime0912Res
         * @static
         * @param {Nautical.IAdReduceNauticalTime0912Res} message AdReduceNauticalTime0912Res message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdReduceNauticalTime0912Res.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo"))
                $root.Nautical.NauticalInfo.encode(message.nauticalInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.isDirectFinish != null && message.hasOwnProperty("isDirectFinish"))
                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.isDirectFinish);
            if (message.nauticalTicketNum != null && message.hasOwnProperty("nauticalTicketNum"))
                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.nauticalTicketNum);
            return writer;
        };

        /**
         * Encodes the specified AdReduceNauticalTime0912Res message, length delimited. Does not implicitly {@link Nautical.AdReduceNauticalTime0912Res.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.AdReduceNauticalTime0912Res
         * @static
         * @param {Nautical.IAdReduceNauticalTime0912Res} message AdReduceNauticalTime0912Res message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdReduceNauticalTime0912Res.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AdReduceNauticalTime0912Res message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.AdReduceNauticalTime0912Res
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.AdReduceNauticalTime0912Res} AdReduceNauticalTime0912Res
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdReduceNauticalTime0912Res.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.AdReduceNauticalTime0912Res();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.nauticalInfo = $root.Nautical.NauticalInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.isDirectFinish = reader.bool();
                    break;
                case 3:
                    message.nauticalTicketNum = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AdReduceNauticalTime0912Res message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.AdReduceNauticalTime0912Res
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.AdReduceNauticalTime0912Res} AdReduceNauticalTime0912Res
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdReduceNauticalTime0912Res.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AdReduceNauticalTime0912Res message.
         * @function verify
         * @memberof Nautical.AdReduceNauticalTime0912Res
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AdReduceNauticalTime0912Res.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo")) {
                var error = $root.Nautical.NauticalInfo.verify(message.nauticalInfo);
                if (error)
                    return "nauticalInfo." + error;
            }
            if (message.isDirectFinish != null && message.hasOwnProperty("isDirectFinish"))
                if (typeof message.isDirectFinish !== "boolean")
                    return "isDirectFinish: boolean expected";
            if (message.nauticalTicketNum != null && message.hasOwnProperty("nauticalTicketNum"))
                if (!$util.isInteger(message.nauticalTicketNum))
                    return "nauticalTicketNum: integer expected";
            return null;
        };

        return AdReduceNauticalTime0912Res;
    })();

    Nautical.unlockNauticalReq = (function() {

        /**
         * Properties of an unlockNauticalReq.
         * @memberof Nautical
         * @interface IunlockNauticalReq
         * @property {number|null} [tripIndex] unlockNauticalReq tripIndex
         */

        /**
         * Constructs a new unlockNauticalReq.
         * @memberof Nautical
         * @classdesc Represents an unlockNauticalReq.
         * @implements IunlockNauticalReq
         * @constructor
         * @param {Nautical.IunlockNauticalReq=} [properties] Properties to set
         */
        function unlockNauticalReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * unlockNauticalReq tripIndex.
         * @member {number} tripIndex
         * @memberof Nautical.unlockNauticalReq
         * @instance
         */
        unlockNauticalReq.prototype.tripIndex = 0;

        /**
         * Creates a new unlockNauticalReq instance using the specified properties.
         * @function create
         * @memberof Nautical.unlockNauticalReq
         * @static
         * @param {Nautical.IunlockNauticalReq=} [properties] Properties to set
         * @returns {Nautical.unlockNauticalReq} unlockNauticalReq instance
         */
        unlockNauticalReq.create = function create(properties) {
            return new unlockNauticalReq(properties);
        };

        /**
         * Encodes the specified unlockNauticalReq message. Does not implicitly {@link Nautical.unlockNauticalReq.verify|verify} messages.
         * @function encode
         * @memberof Nautical.unlockNauticalReq
         * @static
         * @param {Nautical.IunlockNauticalReq} message unlockNauticalReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        unlockNauticalReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.tripIndex != null && message.hasOwnProperty("tripIndex"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.tripIndex);
            return writer;
        };

        /**
         * Encodes the specified unlockNauticalReq message, length delimited. Does not implicitly {@link Nautical.unlockNauticalReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.unlockNauticalReq
         * @static
         * @param {Nautical.IunlockNauticalReq} message unlockNauticalReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        unlockNauticalReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an unlockNauticalReq message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.unlockNauticalReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.unlockNauticalReq} unlockNauticalReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        unlockNauticalReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.unlockNauticalReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.tripIndex = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an unlockNauticalReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.unlockNauticalReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.unlockNauticalReq} unlockNauticalReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        unlockNauticalReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an unlockNauticalReq message.
         * @function verify
         * @memberof Nautical.unlockNauticalReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        unlockNauticalReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.tripIndex != null && message.hasOwnProperty("tripIndex"))
                if (!$util.isInteger(message.tripIndex))
                    return "tripIndex: integer expected";
            return null;
        };

        return unlockNauticalReq;
    })();

    Nautical.unlockNauticalRes = (function() {

        /**
         * Properties of an unlockNauticalRes.
         * @memberof Nautical
         * @interface IunlockNauticalRes
         * @property {Nautical.INauticalInfo|null} [nauticalInfo] unlockNauticalRes nauticalInfo
         */

        /**
         * Constructs a new unlockNauticalRes.
         * @memberof Nautical
         * @classdesc Represents an unlockNauticalRes.
         * @implements IunlockNauticalRes
         * @constructor
         * @param {Nautical.IunlockNauticalRes=} [properties] Properties to set
         */
        function unlockNauticalRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * unlockNauticalRes nauticalInfo.
         * @member {Nautical.INauticalInfo|null|undefined} nauticalInfo
         * @memberof Nautical.unlockNauticalRes
         * @instance
         */
        unlockNauticalRes.prototype.nauticalInfo = null;

        /**
         * Creates a new unlockNauticalRes instance using the specified properties.
         * @function create
         * @memberof Nautical.unlockNauticalRes
         * @static
         * @param {Nautical.IunlockNauticalRes=} [properties] Properties to set
         * @returns {Nautical.unlockNauticalRes} unlockNauticalRes instance
         */
        unlockNauticalRes.create = function create(properties) {
            return new unlockNauticalRes(properties);
        };

        /**
         * Encodes the specified unlockNauticalRes message. Does not implicitly {@link Nautical.unlockNauticalRes.verify|verify} messages.
         * @function encode
         * @memberof Nautical.unlockNauticalRes
         * @static
         * @param {Nautical.IunlockNauticalRes} message unlockNauticalRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        unlockNauticalRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo"))
                $root.Nautical.NauticalInfo.encode(message.nauticalInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified unlockNauticalRes message, length delimited. Does not implicitly {@link Nautical.unlockNauticalRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.unlockNauticalRes
         * @static
         * @param {Nautical.IunlockNauticalRes} message unlockNauticalRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        unlockNauticalRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an unlockNauticalRes message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.unlockNauticalRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.unlockNauticalRes} unlockNauticalRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        unlockNauticalRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.unlockNauticalRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.nauticalInfo = $root.Nautical.NauticalInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an unlockNauticalRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.unlockNauticalRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.unlockNauticalRes} unlockNauticalRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        unlockNauticalRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an unlockNauticalRes message.
         * @function verify
         * @memberof Nautical.unlockNauticalRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        unlockNauticalRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.nauticalInfo != null && message.hasOwnProperty("nauticalInfo")) {
                var error = $root.Nautical.NauticalInfo.verify(message.nauticalInfo);
                if (error)
                    return "nauticalInfo." + error;
            }
            return null;
        };

        return unlockNauticalRes;
    })();

    Nautical.NauticalInfo = (function() {

        /**
         * Properties of a NauticalInfo.
         * @memberof Nautical
         * @interface INauticalInfo
         * @property {boolean|null} [inTrip] NauticalInfo inTrip
         * @property {number|Long|null} [tripStartSec] NauticalInfo tripStartSec
         * @property {number|Long|null} [tripEndSec] NauticalInfo tripEndSec
         * @property {Array.<string>|null} [team] NauticalInfo team
         * @property {Object.<string,number|Long>|null} [foodInTrip] NauticalInfo foodInTrip
         * @property {Array.<string>|null} [toolInTrip] NauticalInfo toolInTrip
         * @property {number|null} [adReduceTimes] NauticalInfo adReduceTimes
         * @property {number|Long|null} [originEndSec] NauticalInfo originEndSec
         * @property {number|null} [adLock] NauticalInfo adLock
         */

        /**
         * Constructs a new NauticalInfo.
         * @memberof Nautical
         * @classdesc Represents a NauticalInfo.
         * @implements INauticalInfo
         * @constructor
         * @param {Nautical.INauticalInfo=} [properties] Properties to set
         */
        function NauticalInfo(properties) {
            this.team = [];
            this.foodInTrip = {};
            this.toolInTrip = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * NauticalInfo inTrip.
         * @member {boolean} inTrip
         * @memberof Nautical.NauticalInfo
         * @instance
         */
        NauticalInfo.prototype.inTrip = false;

        /**
         * NauticalInfo tripStartSec.
         * @member {number|Long} tripStartSec
         * @memberof Nautical.NauticalInfo
         * @instance
         */
        NauticalInfo.prototype.tripStartSec = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * NauticalInfo tripEndSec.
         * @member {number|Long} tripEndSec
         * @memberof Nautical.NauticalInfo
         * @instance
         */
        NauticalInfo.prototype.tripEndSec = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * NauticalInfo team.
         * @member {Array.<string>} team
         * @memberof Nautical.NauticalInfo
         * @instance
         */
        NauticalInfo.prototype.team = $util.emptyArray;

        /**
         * NauticalInfo foodInTrip.
         * @member {Object.<string,number|Long>} foodInTrip
         * @memberof Nautical.NauticalInfo
         * @instance
         */
        NauticalInfo.prototype.foodInTrip = $util.emptyObject;

        /**
         * NauticalInfo toolInTrip.
         * @member {Array.<string>} toolInTrip
         * @memberof Nautical.NauticalInfo
         * @instance
         */
        NauticalInfo.prototype.toolInTrip = $util.emptyArray;

        /**
         * NauticalInfo adReduceTimes.
         * @member {number} adReduceTimes
         * @memberof Nautical.NauticalInfo
         * @instance
         */
        NauticalInfo.prototype.adReduceTimes = 0;

        /**
         * NauticalInfo originEndSec.
         * @member {number|Long} originEndSec
         * @memberof Nautical.NauticalInfo
         * @instance
         */
        NauticalInfo.prototype.originEndSec = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * NauticalInfo adLock.
         * @member {number} adLock
         * @memberof Nautical.NauticalInfo
         * @instance
         */
        NauticalInfo.prototype.adLock = 0;

        /**
         * Creates a new NauticalInfo instance using the specified properties.
         * @function create
         * @memberof Nautical.NauticalInfo
         * @static
         * @param {Nautical.INauticalInfo=} [properties] Properties to set
         * @returns {Nautical.NauticalInfo} NauticalInfo instance
         */
        NauticalInfo.create = function create(properties) {
            return new NauticalInfo(properties);
        };

        /**
         * Encodes the specified NauticalInfo message. Does not implicitly {@link Nautical.NauticalInfo.verify|verify} messages.
         * @function encode
         * @memberof Nautical.NauticalInfo
         * @static
         * @param {Nautical.INauticalInfo} message NauticalInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        NauticalInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.inTrip != null && message.hasOwnProperty("inTrip"))
                writer.uint32(/* id 1, wireType 0 =*/8).bool(message.inTrip);
            if (message.tripStartSec != null && message.hasOwnProperty("tripStartSec"))
                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.tripStartSec);
            if (message.tripEndSec != null && message.hasOwnProperty("tripEndSec"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.tripEndSec);
            if (message.team != null && message.team.length)
                for (var i = 0; i < message.team.length; ++i)
                    writer.uint32(/* id 5, wireType 2 =*/42).string(message.team[i]);
            if (message.foodInTrip != null && message.hasOwnProperty("foodInTrip"))
                for (var keys = Object.keys(message.foodInTrip), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 6, wireType 2 =*/50).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 0 =*/16).int64(message.foodInTrip[keys[i]]).ldelim();
            if (message.toolInTrip != null && message.toolInTrip.length)
                for (var i = 0; i < message.toolInTrip.length; ++i)
                    writer.uint32(/* id 7, wireType 2 =*/58).string(message.toolInTrip[i]);
            if (message.adReduceTimes != null && message.hasOwnProperty("adReduceTimes"))
                writer.uint32(/* id 8, wireType 0 =*/64).int32(message.adReduceTimes);
            if (message.originEndSec != null && message.hasOwnProperty("originEndSec"))
                writer.uint32(/* id 9, wireType 0 =*/72).int64(message.originEndSec);
            if (message.adLock != null && message.hasOwnProperty("adLock"))
                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.adLock);
            return writer;
        };

        /**
         * Encodes the specified NauticalInfo message, length delimited. Does not implicitly {@link Nautical.NauticalInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.NauticalInfo
         * @static
         * @param {Nautical.INauticalInfo} message NauticalInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        NauticalInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a NauticalInfo message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.NauticalInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.NauticalInfo} NauticalInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        NauticalInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.NauticalInfo(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.inTrip = reader.bool();
                    break;
                case 3:
                    message.tripStartSec = reader.int64();
                    break;
                case 4:
                    message.tripEndSec = reader.int64();
                    break;
                case 5:
                    if (!(message.team && message.team.length))
                        message.team = [];
                    message.team.push(reader.string());
                    break;
                case 6:
                    reader.skip().pos++;
                    if (message.foodInTrip === $util.emptyObject)
                        message.foodInTrip = {};
                    key = reader.string();
                    reader.pos++;
                    message.foodInTrip[key] = reader.int64();
                    break;
                case 7:
                    if (!(message.toolInTrip && message.toolInTrip.length))
                        message.toolInTrip = [];
                    message.toolInTrip.push(reader.string());
                    break;
                case 8:
                    message.adReduceTimes = reader.int32();
                    break;
                case 9:
                    message.originEndSec = reader.int64();
                    break;
                case 10:
                    message.adLock = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a NauticalInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.NauticalInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.NauticalInfo} NauticalInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        NauticalInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a NauticalInfo message.
         * @function verify
         * @memberof Nautical.NauticalInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        NauticalInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.inTrip != null && message.hasOwnProperty("inTrip"))
                if (typeof message.inTrip !== "boolean")
                    return "inTrip: boolean expected";
            if (message.tripStartSec != null && message.hasOwnProperty("tripStartSec"))
                if (!$util.isInteger(message.tripStartSec) && !(message.tripStartSec && $util.isInteger(message.tripStartSec.low) && $util.isInteger(message.tripStartSec.high)))
                    return "tripStartSec: integer|Long expected";
            if (message.tripEndSec != null && message.hasOwnProperty("tripEndSec"))
                if (!$util.isInteger(message.tripEndSec) && !(message.tripEndSec && $util.isInteger(message.tripEndSec.low) && $util.isInteger(message.tripEndSec.high)))
                    return "tripEndSec: integer|Long expected";
            if (message.team != null && message.hasOwnProperty("team")) {
                if (!Array.isArray(message.team))
                    return "team: array expected";
                for (var i = 0; i < message.team.length; ++i)
                    if (!$util.isString(message.team[i]))
                        return "team: string[] expected";
            }
            if (message.foodInTrip != null && message.hasOwnProperty("foodInTrip")) {
                if (!$util.isObject(message.foodInTrip))
                    return "foodInTrip: object expected";
                var key = Object.keys(message.foodInTrip);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isInteger(message.foodInTrip[key[i]]) && !(message.foodInTrip[key[i]] && $util.isInteger(message.foodInTrip[key[i]].low) && $util.isInteger(message.foodInTrip[key[i]].high)))
                        return "foodInTrip: integer|Long{k:string} expected";
            }
            if (message.toolInTrip != null && message.hasOwnProperty("toolInTrip")) {
                if (!Array.isArray(message.toolInTrip))
                    return "toolInTrip: array expected";
                for (var i = 0; i < message.toolInTrip.length; ++i)
                    if (!$util.isString(message.toolInTrip[i]))
                        return "toolInTrip: string[] expected";
            }
            if (message.adReduceTimes != null && message.hasOwnProperty("adReduceTimes"))
                if (!$util.isInteger(message.adReduceTimes))
                    return "adReduceTimes: integer expected";
            if (message.originEndSec != null && message.hasOwnProperty("originEndSec"))
                if (!$util.isInteger(message.originEndSec) && !(message.originEndSec && $util.isInteger(message.originEndSec.low) && $util.isInteger(message.originEndSec.high)))
                    return "originEndSec: integer|Long expected";
            if (message.adLock != null && message.hasOwnProperty("adLock"))
                if (!$util.isInteger(message.adLock))
                    return "adLock: integer expected";
            return null;
        };

        return NauticalInfo;
    })();

    Nautical.NauticalPhotoReward = (function() {

        /**
         * Properties of a NauticalPhotoReward.
         * @memberof Nautical
         * @interface INauticalPhotoReward
         * @property {boolean|null} [ifNew] NauticalPhotoReward ifNew
         * @property {string|null} [photoId] NauticalPhotoReward photoId
         */

        /**
         * Constructs a new NauticalPhotoReward.
         * @memberof Nautical
         * @classdesc Represents a NauticalPhotoReward.
         * @implements INauticalPhotoReward
         * @constructor
         * @param {Nautical.INauticalPhotoReward=} [properties] Properties to set
         */
        function NauticalPhotoReward(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * NauticalPhotoReward ifNew.
         * @member {boolean} ifNew
         * @memberof Nautical.NauticalPhotoReward
         * @instance
         */
        NauticalPhotoReward.prototype.ifNew = false;

        /**
         * NauticalPhotoReward photoId.
         * @member {string} photoId
         * @memberof Nautical.NauticalPhotoReward
         * @instance
         */
        NauticalPhotoReward.prototype.photoId = "";

        /**
         * Creates a new NauticalPhotoReward instance using the specified properties.
         * @function create
         * @memberof Nautical.NauticalPhotoReward
         * @static
         * @param {Nautical.INauticalPhotoReward=} [properties] Properties to set
         * @returns {Nautical.NauticalPhotoReward} NauticalPhotoReward instance
         */
        NauticalPhotoReward.create = function create(properties) {
            return new NauticalPhotoReward(properties);
        };

        /**
         * Encodes the specified NauticalPhotoReward message. Does not implicitly {@link Nautical.NauticalPhotoReward.verify|verify} messages.
         * @function encode
         * @memberof Nautical.NauticalPhotoReward
         * @static
         * @param {Nautical.INauticalPhotoReward} message NauticalPhotoReward message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        NauticalPhotoReward.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.ifNew != null && message.hasOwnProperty("ifNew"))
                writer.uint32(/* id 1, wireType 0 =*/8).bool(message.ifNew);
            if (message.photoId != null && message.hasOwnProperty("photoId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.photoId);
            return writer;
        };

        /**
         * Encodes the specified NauticalPhotoReward message, length delimited. Does not implicitly {@link Nautical.NauticalPhotoReward.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Nautical.NauticalPhotoReward
         * @static
         * @param {Nautical.INauticalPhotoReward} message NauticalPhotoReward message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        NauticalPhotoReward.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a NauticalPhotoReward message from the specified reader or buffer.
         * @function decode
         * @memberof Nautical.NauticalPhotoReward
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Nautical.NauticalPhotoReward} NauticalPhotoReward
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        NauticalPhotoReward.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Nautical.NauticalPhotoReward();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.ifNew = reader.bool();
                    break;
                case 2:
                    message.photoId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a NauticalPhotoReward message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Nautical.NauticalPhotoReward
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Nautical.NauticalPhotoReward} NauticalPhotoReward
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        NauticalPhotoReward.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a NauticalPhotoReward message.
         * @function verify
         * @memberof Nautical.NauticalPhotoReward
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        NauticalPhotoReward.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.ifNew != null && message.hasOwnProperty("ifNew"))
                if (typeof message.ifNew !== "boolean")
                    return "ifNew: boolean expected";
            if (message.photoId != null && message.hasOwnProperty("photoId"))
                if (!$util.isString(message.photoId))
                    return "photoId: string expected";
            return null;
        };

        return NauticalPhotoReward;
    })();

    return Nautical;
})();

$root.FishingGame = (function() {

    /**
     * Namespace FishingGame.
     * @exports FishingGame
     * @namespace
     */
    var FishingGame = {};

    FishingGame.GetFishGameInfoReq = (function() {

        /**
         * Properties of a GetFishGameInfoReq.
         * @memberof FishingGame
         * @interface IGetFishGameInfoReq
         */

        /**
         * Constructs a new GetFishGameInfoReq.
         * @memberof FishingGame
         * @classdesc Represents a GetFishGameInfoReq.
         * @implements IGetFishGameInfoReq
         * @constructor
         * @param {FishingGame.IGetFishGameInfoReq=} [properties] Properties to set
         */
        function GetFishGameInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetFishGameInfoReq instance using the specified properties.
         * @function create
         * @memberof FishingGame.GetFishGameInfoReq
         * @static
         * @param {FishingGame.IGetFishGameInfoReq=} [properties] Properties to set
         * @returns {FishingGame.GetFishGameInfoReq} GetFishGameInfoReq instance
         */
        GetFishGameInfoReq.create = function create(properties) {
            return new GetFishGameInfoReq(properties);
        };

        /**
         * Encodes the specified GetFishGameInfoReq message. Does not implicitly {@link FishingGame.GetFishGameInfoReq.verify|verify} messages.
         * @function encode
         * @memberof FishingGame.GetFishGameInfoReq
         * @static
         * @param {FishingGame.IGetFishGameInfoReq} message GetFishGameInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetFishGameInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetFishGameInfoReq message, length delimited. Does not implicitly {@link FishingGame.GetFishGameInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof FishingGame.GetFishGameInfoReq
         * @static
         * @param {FishingGame.IGetFishGameInfoReq} message GetFishGameInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetFishGameInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetFishGameInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof FishingGame.GetFishGameInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {FishingGame.GetFishGameInfoReq} GetFishGameInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetFishGameInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.FishingGame.GetFishGameInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetFishGameInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof FishingGame.GetFishGameInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {FishingGame.GetFishGameInfoReq} GetFishGameInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetFishGameInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetFishGameInfoReq message.
         * @function verify
         * @memberof FishingGame.GetFishGameInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetFishGameInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetFishGameInfoReq;
    })();

    FishingGame.GetFishGameInfoRes = (function() {

        /**
         * Properties of a GetFishGameInfoRes.
         * @memberof FishingGame
         * @interface IGetFishGameInfoRes
         * @property {FishingGame.IFishingGameInfo|null} [gameInfo] GetFishGameInfoRes gameInfo
         * @property {BaseInfo.ICurrencyBag|null} [bag] GetFishGameInfoRes bag
         */

        /**
         * Constructs a new GetFishGameInfoRes.
         * @memberof FishingGame
         * @classdesc Represents a GetFishGameInfoRes.
         * @implements IGetFishGameInfoRes
         * @constructor
         * @param {FishingGame.IGetFishGameInfoRes=} [properties] Properties to set
         */
        function GetFishGameInfoRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetFishGameInfoRes gameInfo.
         * @member {FishingGame.IFishingGameInfo|null|undefined} gameInfo
         * @memberof FishingGame.GetFishGameInfoRes
         * @instance
         */
        GetFishGameInfoRes.prototype.gameInfo = null;

        /**
         * GetFishGameInfoRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof FishingGame.GetFishGameInfoRes
         * @instance
         */
        GetFishGameInfoRes.prototype.bag = null;

        /**
         * Creates a new GetFishGameInfoRes instance using the specified properties.
         * @function create
         * @memberof FishingGame.GetFishGameInfoRes
         * @static
         * @param {FishingGame.IGetFishGameInfoRes=} [properties] Properties to set
         * @returns {FishingGame.GetFishGameInfoRes} GetFishGameInfoRes instance
         */
        GetFishGameInfoRes.create = function create(properties) {
            return new GetFishGameInfoRes(properties);
        };

        /**
         * Encodes the specified GetFishGameInfoRes message. Does not implicitly {@link FishingGame.GetFishGameInfoRes.verify|verify} messages.
         * @function encode
         * @memberof FishingGame.GetFishGameInfoRes
         * @static
         * @param {FishingGame.IGetFishGameInfoRes} message GetFishGameInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetFishGameInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.gameInfo != null && message.hasOwnProperty("gameInfo"))
                $root.FishingGame.FishingGameInfo.encode(message.gameInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetFishGameInfoRes message, length delimited. Does not implicitly {@link FishingGame.GetFishGameInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof FishingGame.GetFishGameInfoRes
         * @static
         * @param {FishingGame.IGetFishGameInfoRes} message GetFishGameInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetFishGameInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetFishGameInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof FishingGame.GetFishGameInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {FishingGame.GetFishGameInfoRes} GetFishGameInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetFishGameInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.FishingGame.GetFishGameInfoRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.gameInfo = $root.FishingGame.FishingGameInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetFishGameInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof FishingGame.GetFishGameInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {FishingGame.GetFishGameInfoRes} GetFishGameInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetFishGameInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetFishGameInfoRes message.
         * @function verify
         * @memberof FishingGame.GetFishGameInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetFishGameInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.gameInfo != null && message.hasOwnProperty("gameInfo")) {
                var error = $root.FishingGame.FishingGameInfo.verify(message.gameInfo);
                if (error)
                    return "gameInfo." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return GetFishGameInfoRes;
    })();

    FishingGame.PlayFishGameReq = (function() {

        /**
         * Properties of a PlayFishGameReq.
         * @memberof FishingGame
         * @interface IPlayFishGameReq
         * @property {string|null} [fishingFishId] PlayFishGameReq fishingFishId
         * @property {string|null} [fishingBaitId] PlayFishGameReq fishingBaitId
         * @property {BaseInfo.IRewards|null} [rewards] PlayFishGameReq rewards
         * @property {number|null} [fishingFishSize] PlayFishGameReq fishingFishSize
         * @property {number|null} [type] PlayFishGameReq type
         * @property {BaseInfo.FetchType|null} [fetchType] PlayFishGameReq fetchType
         */

        /**
         * Constructs a new PlayFishGameReq.
         * @memberof FishingGame
         * @classdesc Represents a PlayFishGameReq.
         * @implements IPlayFishGameReq
         * @constructor
         * @param {FishingGame.IPlayFishGameReq=} [properties] Properties to set
         */
        function PlayFishGameReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PlayFishGameReq fishingFishId.
         * @member {string} fishingFishId
         * @memberof FishingGame.PlayFishGameReq
         * @instance
         */
        PlayFishGameReq.prototype.fishingFishId = "";

        /**
         * PlayFishGameReq fishingBaitId.
         * @member {string} fishingBaitId
         * @memberof FishingGame.PlayFishGameReq
         * @instance
         */
        PlayFishGameReq.prototype.fishingBaitId = "";

        /**
         * PlayFishGameReq rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof FishingGame.PlayFishGameReq
         * @instance
         */
        PlayFishGameReq.prototype.rewards = null;

        /**
         * PlayFishGameReq fishingFishSize.
         * @member {number} fishingFishSize
         * @memberof FishingGame.PlayFishGameReq
         * @instance
         */
        PlayFishGameReq.prototype.fishingFishSize = 0;

        /**
         * PlayFishGameReq type.
         * @member {number} type
         * @memberof FishingGame.PlayFishGameReq
         * @instance
         */
        PlayFishGameReq.prototype.type = 0;

        /**
         * PlayFishGameReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof FishingGame.PlayFishGameReq
         * @instance
         */
        PlayFishGameReq.prototype.fetchType = 0;

        /**
         * Creates a new PlayFishGameReq instance using the specified properties.
         * @function create
         * @memberof FishingGame.PlayFishGameReq
         * @static
         * @param {FishingGame.IPlayFishGameReq=} [properties] Properties to set
         * @returns {FishingGame.PlayFishGameReq} PlayFishGameReq instance
         */
        PlayFishGameReq.create = function create(properties) {
            return new PlayFishGameReq(properties);
        };

        /**
         * Encodes the specified PlayFishGameReq message. Does not implicitly {@link FishingGame.PlayFishGameReq.verify|verify} messages.
         * @function encode
         * @memberof FishingGame.PlayFishGameReq
         * @static
         * @param {FishingGame.IPlayFishGameReq} message PlayFishGameReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayFishGameReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.fishingFishId != null && message.hasOwnProperty("fishingFishId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.fishingFishId);
            if (message.fishingBaitId != null && message.hasOwnProperty("fishingBaitId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.fishingBaitId);
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.fishingFishSize != null && message.hasOwnProperty("fishingFishSize"))
                writer.uint32(/* id 4, wireType 1 =*/33).double(message.fishingFishSize);
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.type);
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified PlayFishGameReq message, length delimited. Does not implicitly {@link FishingGame.PlayFishGameReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof FishingGame.PlayFishGameReq
         * @static
         * @param {FishingGame.IPlayFishGameReq} message PlayFishGameReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayFishGameReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PlayFishGameReq message from the specified reader or buffer.
         * @function decode
         * @memberof FishingGame.PlayFishGameReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {FishingGame.PlayFishGameReq} PlayFishGameReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayFishGameReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.FishingGame.PlayFishGameReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.fishingFishId = reader.string();
                    break;
                case 2:
                    message.fishingBaitId = reader.string();
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.fishingFishSize = reader.double();
                    break;
                case 5:
                    message.type = reader.int32();
                    break;
                case 6:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PlayFishGameReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof FishingGame.PlayFishGameReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {FishingGame.PlayFishGameReq} PlayFishGameReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayFishGameReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PlayFishGameReq message.
         * @function verify
         * @memberof FishingGame.PlayFishGameReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PlayFishGameReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.fishingFishId != null && message.hasOwnProperty("fishingFishId"))
                if (!$util.isString(message.fishingFishId))
                    return "fishingFishId: string expected";
            if (message.fishingBaitId != null && message.hasOwnProperty("fishingBaitId"))
                if (!$util.isString(message.fishingBaitId))
                    return "fishingBaitId: string expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.fishingFishSize != null && message.hasOwnProperty("fishingFishSize"))
                if (typeof message.fishingFishSize !== "number")
                    return "fishingFishSize: number expected";
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isInteger(message.type))
                    return "type: integer expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return PlayFishGameReq;
    })();

    FishingGame.PlayFishGameRes = (function() {

        /**
         * Properties of a PlayFishGameRes.
         * @memberof FishingGame
         * @interface IPlayFishGameRes
         * @property {BaseInfo.ICurrencyBag|null} [bag] PlayFishGameRes bag
         * @property {FishingGame.IFishingGameInfo|null} [gameInfo] PlayFishGameRes gameInfo
         * @property {BaseInfo.IRewards|null} [actualRewards] PlayFishGameRes actualRewards
         */

        /**
         * Constructs a new PlayFishGameRes.
         * @memberof FishingGame
         * @classdesc Represents a PlayFishGameRes.
         * @implements IPlayFishGameRes
         * @constructor
         * @param {FishingGame.IPlayFishGameRes=} [properties] Properties to set
         */
        function PlayFishGameRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PlayFishGameRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof FishingGame.PlayFishGameRes
         * @instance
         */
        PlayFishGameRes.prototype.bag = null;

        /**
         * PlayFishGameRes gameInfo.
         * @member {FishingGame.IFishingGameInfo|null|undefined} gameInfo
         * @memberof FishingGame.PlayFishGameRes
         * @instance
         */
        PlayFishGameRes.prototype.gameInfo = null;

        /**
         * PlayFishGameRes actualRewards.
         * @member {BaseInfo.IRewards|null|undefined} actualRewards
         * @memberof FishingGame.PlayFishGameRes
         * @instance
         */
        PlayFishGameRes.prototype.actualRewards = null;

        /**
         * Creates a new PlayFishGameRes instance using the specified properties.
         * @function create
         * @memberof FishingGame.PlayFishGameRes
         * @static
         * @param {FishingGame.IPlayFishGameRes=} [properties] Properties to set
         * @returns {FishingGame.PlayFishGameRes} PlayFishGameRes instance
         */
        PlayFishGameRes.create = function create(properties) {
            return new PlayFishGameRes(properties);
        };

        /**
         * Encodes the specified PlayFishGameRes message. Does not implicitly {@link FishingGame.PlayFishGameRes.verify|verify} messages.
         * @function encode
         * @memberof FishingGame.PlayFishGameRes
         * @static
         * @param {FishingGame.IPlayFishGameRes} message PlayFishGameRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayFishGameRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.gameInfo != null && message.hasOwnProperty("gameInfo"))
                $root.FishingGame.FishingGameInfo.encode(message.gameInfo, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.actualRewards != null && message.hasOwnProperty("actualRewards"))
                $root.BaseInfo.Rewards.encode(message.actualRewards, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified PlayFishGameRes message, length delimited. Does not implicitly {@link FishingGame.PlayFishGameRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof FishingGame.PlayFishGameRes
         * @static
         * @param {FishingGame.IPlayFishGameRes} message PlayFishGameRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayFishGameRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PlayFishGameRes message from the specified reader or buffer.
         * @function decode
         * @memberof FishingGame.PlayFishGameRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {FishingGame.PlayFishGameRes} PlayFishGameRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayFishGameRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.FishingGame.PlayFishGameRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.gameInfo = $root.FishingGame.FishingGameInfo.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.actualRewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PlayFishGameRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof FishingGame.PlayFishGameRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {FishingGame.PlayFishGameRes} PlayFishGameRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayFishGameRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PlayFishGameRes message.
         * @function verify
         * @memberof FishingGame.PlayFishGameRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PlayFishGameRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.gameInfo != null && message.hasOwnProperty("gameInfo")) {
                var error = $root.FishingGame.FishingGameInfo.verify(message.gameInfo);
                if (error)
                    return "gameInfo." + error;
            }
            if (message.actualRewards != null && message.hasOwnProperty("actualRewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.actualRewards);
                if (error)
                    return "actualRewards." + error;
            }
            return null;
        };

        return PlayFishGameRes;
    })();

    FishingGame.GetFishingFishInfoReq = (function() {

        /**
         * Properties of a GetFishingFishInfoReq.
         * @memberof FishingGame
         * @interface IGetFishingFishInfoReq
         */

        /**
         * Constructs a new GetFishingFishInfoReq.
         * @memberof FishingGame
         * @classdesc Represents a GetFishingFishInfoReq.
         * @implements IGetFishingFishInfoReq
         * @constructor
         * @param {FishingGame.IGetFishingFishInfoReq=} [properties] Properties to set
         */
        function GetFishingFishInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetFishingFishInfoReq instance using the specified properties.
         * @function create
         * @memberof FishingGame.GetFishingFishInfoReq
         * @static
         * @param {FishingGame.IGetFishingFishInfoReq=} [properties] Properties to set
         * @returns {FishingGame.GetFishingFishInfoReq} GetFishingFishInfoReq instance
         */
        GetFishingFishInfoReq.create = function create(properties) {
            return new GetFishingFishInfoReq(properties);
        };

        /**
         * Encodes the specified GetFishingFishInfoReq message. Does not implicitly {@link FishingGame.GetFishingFishInfoReq.verify|verify} messages.
         * @function encode
         * @memberof FishingGame.GetFishingFishInfoReq
         * @static
         * @param {FishingGame.IGetFishingFishInfoReq} message GetFishingFishInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetFishingFishInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetFishingFishInfoReq message, length delimited. Does not implicitly {@link FishingGame.GetFishingFishInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof FishingGame.GetFishingFishInfoReq
         * @static
         * @param {FishingGame.IGetFishingFishInfoReq} message GetFishingFishInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetFishingFishInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetFishingFishInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof FishingGame.GetFishingFishInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {FishingGame.GetFishingFishInfoReq} GetFishingFishInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetFishingFishInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.FishingGame.GetFishingFishInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetFishingFishInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof FishingGame.GetFishingFishInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {FishingGame.GetFishingFishInfoReq} GetFishingFishInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetFishingFishInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetFishingFishInfoReq message.
         * @function verify
         * @memberof FishingGame.GetFishingFishInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetFishingFishInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetFishingFishInfoReq;
    })();

    FishingGame.GetFishingFishInfoRes = (function() {

        /**
         * Properties of a GetFishingFishInfoRes.
         * @memberof FishingGame
         * @interface IGetFishingFishInfoRes
         * @property {Object.<string,FishingGame.IFishingFishInfo>|null} [fishInfos] GetFishingFishInfoRes fishInfos
         */

        /**
         * Constructs a new GetFishingFishInfoRes.
         * @memberof FishingGame
         * @classdesc Represents a GetFishingFishInfoRes.
         * @implements IGetFishingFishInfoRes
         * @constructor
         * @param {FishingGame.IGetFishingFishInfoRes=} [properties] Properties to set
         */
        function GetFishingFishInfoRes(properties) {
            this.fishInfos = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetFishingFishInfoRes fishInfos.
         * @member {Object.<string,FishingGame.IFishingFishInfo>} fishInfos
         * @memberof FishingGame.GetFishingFishInfoRes
         * @instance
         */
        GetFishingFishInfoRes.prototype.fishInfos = $util.emptyObject;

        /**
         * Creates a new GetFishingFishInfoRes instance using the specified properties.
         * @function create
         * @memberof FishingGame.GetFishingFishInfoRes
         * @static
         * @param {FishingGame.IGetFishingFishInfoRes=} [properties] Properties to set
         * @returns {FishingGame.GetFishingFishInfoRes} GetFishingFishInfoRes instance
         */
        GetFishingFishInfoRes.create = function create(properties) {
            return new GetFishingFishInfoRes(properties);
        };

        /**
         * Encodes the specified GetFishingFishInfoRes message. Does not implicitly {@link FishingGame.GetFishingFishInfoRes.verify|verify} messages.
         * @function encode
         * @memberof FishingGame.GetFishingFishInfoRes
         * @static
         * @param {FishingGame.IGetFishingFishInfoRes} message GetFishingFishInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetFishingFishInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.fishInfos != null && message.hasOwnProperty("fishInfos"))
                for (var keys = Object.keys(message.fishInfos), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.FishingGame.FishingFishInfo.encode(message.fishInfos[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified GetFishingFishInfoRes message, length delimited. Does not implicitly {@link FishingGame.GetFishingFishInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof FishingGame.GetFishingFishInfoRes
         * @static
         * @param {FishingGame.IGetFishingFishInfoRes} message GetFishingFishInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetFishingFishInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetFishingFishInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof FishingGame.GetFishingFishInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {FishingGame.GetFishingFishInfoRes} GetFishingFishInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetFishingFishInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.FishingGame.GetFishingFishInfoRes(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.fishInfos === $util.emptyObject)
                        message.fishInfos = {};
                    key = reader.string();
                    reader.pos++;
                    message.fishInfos[key] = $root.FishingGame.FishingFishInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetFishingFishInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof FishingGame.GetFishingFishInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {FishingGame.GetFishingFishInfoRes} GetFishingFishInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetFishingFishInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetFishingFishInfoRes message.
         * @function verify
         * @memberof FishingGame.GetFishingFishInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetFishingFishInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.fishInfos != null && message.hasOwnProperty("fishInfos")) {
                if (!$util.isObject(message.fishInfos))
                    return "fishInfos: object expected";
                var key = Object.keys(message.fishInfos);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.FishingGame.FishingFishInfo.verify(message.fishInfos[key[i]]);
                    if (error)
                        return "fishInfos." + error;
                }
            }
            return null;
        };

        return GetFishingFishInfoRes;
    })();

    FishingGame.PlayFishGameRelease0611Req = (function() {

        /**
         * Properties of a PlayFishGameRelease0611Req.
         * @memberof FishingGame
         * @interface IPlayFishGameRelease0611Req
         * @property {string|null} [fishingFishId] PlayFishGameRelease0611Req fishingFishId
         * @property {string|null} [fishingBaitId] PlayFishGameRelease0611Req fishingBaitId
         * @property {BaseInfo.IRewards|null} [rewards] PlayFishGameRelease0611Req rewards
         * @property {number|null} [fishingFishSize] PlayFishGameRelease0611Req fishingFishSize
         * @property {BaseInfo.FetchType|null} [fetchType] PlayFishGameRelease0611Req fetchType
         */

        /**
         * Constructs a new PlayFishGameRelease0611Req.
         * @memberof FishingGame
         * @classdesc Represents a PlayFishGameRelease0611Req.
         * @implements IPlayFishGameRelease0611Req
         * @constructor
         * @param {FishingGame.IPlayFishGameRelease0611Req=} [properties] Properties to set
         */
        function PlayFishGameRelease0611Req(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PlayFishGameRelease0611Req fishingFishId.
         * @member {string} fishingFishId
         * @memberof FishingGame.PlayFishGameRelease0611Req
         * @instance
         */
        PlayFishGameRelease0611Req.prototype.fishingFishId = "";

        /**
         * PlayFishGameRelease0611Req fishingBaitId.
         * @member {string} fishingBaitId
         * @memberof FishingGame.PlayFishGameRelease0611Req
         * @instance
         */
        PlayFishGameRelease0611Req.prototype.fishingBaitId = "";

        /**
         * PlayFishGameRelease0611Req rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof FishingGame.PlayFishGameRelease0611Req
         * @instance
         */
        PlayFishGameRelease0611Req.prototype.rewards = null;

        /**
         * PlayFishGameRelease0611Req fishingFishSize.
         * @member {number} fishingFishSize
         * @memberof FishingGame.PlayFishGameRelease0611Req
         * @instance
         */
        PlayFishGameRelease0611Req.prototype.fishingFishSize = 0;

        /**
         * PlayFishGameRelease0611Req fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof FishingGame.PlayFishGameRelease0611Req
         * @instance
         */
        PlayFishGameRelease0611Req.prototype.fetchType = 0;

        /**
         * Creates a new PlayFishGameRelease0611Req instance using the specified properties.
         * @function create
         * @memberof FishingGame.PlayFishGameRelease0611Req
         * @static
         * @param {FishingGame.IPlayFishGameRelease0611Req=} [properties] Properties to set
         * @returns {FishingGame.PlayFishGameRelease0611Req} PlayFishGameRelease0611Req instance
         */
        PlayFishGameRelease0611Req.create = function create(properties) {
            return new PlayFishGameRelease0611Req(properties);
        };

        /**
         * Encodes the specified PlayFishGameRelease0611Req message. Does not implicitly {@link FishingGame.PlayFishGameRelease0611Req.verify|verify} messages.
         * @function encode
         * @memberof FishingGame.PlayFishGameRelease0611Req
         * @static
         * @param {FishingGame.IPlayFishGameRelease0611Req} message PlayFishGameRelease0611Req message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayFishGameRelease0611Req.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.fishingFishId != null && message.hasOwnProperty("fishingFishId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.fishingFishId);
            if (message.fishingBaitId != null && message.hasOwnProperty("fishingBaitId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.fishingBaitId);
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.fishingFishSize != null && message.hasOwnProperty("fishingFishSize"))
                writer.uint32(/* id 4, wireType 1 =*/33).double(message.fishingFishSize);
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified PlayFishGameRelease0611Req message, length delimited. Does not implicitly {@link FishingGame.PlayFishGameRelease0611Req.verify|verify} messages.
         * @function encodeDelimited
         * @memberof FishingGame.PlayFishGameRelease0611Req
         * @static
         * @param {FishingGame.IPlayFishGameRelease0611Req} message PlayFishGameRelease0611Req message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayFishGameRelease0611Req.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PlayFishGameRelease0611Req message from the specified reader or buffer.
         * @function decode
         * @memberof FishingGame.PlayFishGameRelease0611Req
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {FishingGame.PlayFishGameRelease0611Req} PlayFishGameRelease0611Req
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayFishGameRelease0611Req.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.FishingGame.PlayFishGameRelease0611Req();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.fishingFishId = reader.string();
                    break;
                case 2:
                    message.fishingBaitId = reader.string();
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.fishingFishSize = reader.double();
                    break;
                case 5:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PlayFishGameRelease0611Req message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof FishingGame.PlayFishGameRelease0611Req
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {FishingGame.PlayFishGameRelease0611Req} PlayFishGameRelease0611Req
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayFishGameRelease0611Req.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PlayFishGameRelease0611Req message.
         * @function verify
         * @memberof FishingGame.PlayFishGameRelease0611Req
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PlayFishGameRelease0611Req.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.fishingFishId != null && message.hasOwnProperty("fishingFishId"))
                if (!$util.isString(message.fishingFishId))
                    return "fishingFishId: string expected";
            if (message.fishingBaitId != null && message.hasOwnProperty("fishingBaitId"))
                if (!$util.isString(message.fishingBaitId))
                    return "fishingBaitId: string expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.fishingFishSize != null && message.hasOwnProperty("fishingFishSize"))
                if (typeof message.fishingFishSize !== "number")
                    return "fishingFishSize: number expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return PlayFishGameRelease0611Req;
    })();

    FishingGame.PlayFishGameRelease0611Res = (function() {

        /**
         * Properties of a PlayFishGameRelease0611Res.
         * @memberof FishingGame
         * @interface IPlayFishGameRelease0611Res
         * @property {BaseInfo.ICurrencyBag|null} [bag] PlayFishGameRelease0611Res bag
         * @property {FishingGame.IFishingGameInfo|null} [gameInfo] PlayFishGameRelease0611Res gameInfo
         * @property {BaseInfo.IRewards|null} [actualRewards] PlayFishGameRelease0611Res actualRewards
         */

        /**
         * Constructs a new PlayFishGameRelease0611Res.
         * @memberof FishingGame
         * @classdesc Represents a PlayFishGameRelease0611Res.
         * @implements IPlayFishGameRelease0611Res
         * @constructor
         * @param {FishingGame.IPlayFishGameRelease0611Res=} [properties] Properties to set
         */
        function PlayFishGameRelease0611Res(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PlayFishGameRelease0611Res bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof FishingGame.PlayFishGameRelease0611Res
         * @instance
         */
        PlayFishGameRelease0611Res.prototype.bag = null;

        /**
         * PlayFishGameRelease0611Res gameInfo.
         * @member {FishingGame.IFishingGameInfo|null|undefined} gameInfo
         * @memberof FishingGame.PlayFishGameRelease0611Res
         * @instance
         */
        PlayFishGameRelease0611Res.prototype.gameInfo = null;

        /**
         * PlayFishGameRelease0611Res actualRewards.
         * @member {BaseInfo.IRewards|null|undefined} actualRewards
         * @memberof FishingGame.PlayFishGameRelease0611Res
         * @instance
         */
        PlayFishGameRelease0611Res.prototype.actualRewards = null;

        /**
         * Creates a new PlayFishGameRelease0611Res instance using the specified properties.
         * @function create
         * @memberof FishingGame.PlayFishGameRelease0611Res
         * @static
         * @param {FishingGame.IPlayFishGameRelease0611Res=} [properties] Properties to set
         * @returns {FishingGame.PlayFishGameRelease0611Res} PlayFishGameRelease0611Res instance
         */
        PlayFishGameRelease0611Res.create = function create(properties) {
            return new PlayFishGameRelease0611Res(properties);
        };

        /**
         * Encodes the specified PlayFishGameRelease0611Res message. Does not implicitly {@link FishingGame.PlayFishGameRelease0611Res.verify|verify} messages.
         * @function encode
         * @memberof FishingGame.PlayFishGameRelease0611Res
         * @static
         * @param {FishingGame.IPlayFishGameRelease0611Res} message PlayFishGameRelease0611Res message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayFishGameRelease0611Res.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.gameInfo != null && message.hasOwnProperty("gameInfo"))
                $root.FishingGame.FishingGameInfo.encode(message.gameInfo, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.actualRewards != null && message.hasOwnProperty("actualRewards"))
                $root.BaseInfo.Rewards.encode(message.actualRewards, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified PlayFishGameRelease0611Res message, length delimited. Does not implicitly {@link FishingGame.PlayFishGameRelease0611Res.verify|verify} messages.
         * @function encodeDelimited
         * @memberof FishingGame.PlayFishGameRelease0611Res
         * @static
         * @param {FishingGame.IPlayFishGameRelease0611Res} message PlayFishGameRelease0611Res message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayFishGameRelease0611Res.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PlayFishGameRelease0611Res message from the specified reader or buffer.
         * @function decode
         * @memberof FishingGame.PlayFishGameRelease0611Res
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {FishingGame.PlayFishGameRelease0611Res} PlayFishGameRelease0611Res
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayFishGameRelease0611Res.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.FishingGame.PlayFishGameRelease0611Res();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.gameInfo = $root.FishingGame.FishingGameInfo.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.actualRewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PlayFishGameRelease0611Res message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof FishingGame.PlayFishGameRelease0611Res
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {FishingGame.PlayFishGameRelease0611Res} PlayFishGameRelease0611Res
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayFishGameRelease0611Res.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PlayFishGameRelease0611Res message.
         * @function verify
         * @memberof FishingGame.PlayFishGameRelease0611Res
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PlayFishGameRelease0611Res.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.gameInfo != null && message.hasOwnProperty("gameInfo")) {
                var error = $root.FishingGame.FishingGameInfo.verify(message.gameInfo);
                if (error)
                    return "gameInfo." + error;
            }
            if (message.actualRewards != null && message.hasOwnProperty("actualRewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.actualRewards);
                if (error)
                    return "actualRewards." + error;
            }
            return null;
        };

        return PlayFishGameRelease0611Res;
    })();

    FishingGame.AdFreeFishingReq = (function() {

        /**
         * Properties of an AdFreeFishingReq.
         * @memberof FishingGame
         * @interface IAdFreeFishingReq
         */

        /**
         * Constructs a new AdFreeFishingReq.
         * @memberof FishingGame
         * @classdesc Represents an AdFreeFishingReq.
         * @implements IAdFreeFishingReq
         * @constructor
         * @param {FishingGame.IAdFreeFishingReq=} [properties] Properties to set
         */
        function AdFreeFishingReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new AdFreeFishingReq instance using the specified properties.
         * @function create
         * @memberof FishingGame.AdFreeFishingReq
         * @static
         * @param {FishingGame.IAdFreeFishingReq=} [properties] Properties to set
         * @returns {FishingGame.AdFreeFishingReq} AdFreeFishingReq instance
         */
        AdFreeFishingReq.create = function create(properties) {
            return new AdFreeFishingReq(properties);
        };

        /**
         * Encodes the specified AdFreeFishingReq message. Does not implicitly {@link FishingGame.AdFreeFishingReq.verify|verify} messages.
         * @function encode
         * @memberof FishingGame.AdFreeFishingReq
         * @static
         * @param {FishingGame.IAdFreeFishingReq} message AdFreeFishingReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdFreeFishingReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified AdFreeFishingReq message, length delimited. Does not implicitly {@link FishingGame.AdFreeFishingReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof FishingGame.AdFreeFishingReq
         * @static
         * @param {FishingGame.IAdFreeFishingReq} message AdFreeFishingReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdFreeFishingReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AdFreeFishingReq message from the specified reader or buffer.
         * @function decode
         * @memberof FishingGame.AdFreeFishingReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {FishingGame.AdFreeFishingReq} AdFreeFishingReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdFreeFishingReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.FishingGame.AdFreeFishingReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AdFreeFishingReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof FishingGame.AdFreeFishingReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {FishingGame.AdFreeFishingReq} AdFreeFishingReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdFreeFishingReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AdFreeFishingReq message.
         * @function verify
         * @memberof FishingGame.AdFreeFishingReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AdFreeFishingReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return AdFreeFishingReq;
    })();

    FishingGame.AdFreeFishingRes = (function() {

        /**
         * Properties of an AdFreeFishingRes.
         * @memberof FishingGame
         * @interface IAdFreeFishingRes
         * @property {FishingGame.IFishingGameInfo|null} [gameInfo] AdFreeFishingRes gameInfo
         */

        /**
         * Constructs a new AdFreeFishingRes.
         * @memberof FishingGame
         * @classdesc Represents an AdFreeFishingRes.
         * @implements IAdFreeFishingRes
         * @constructor
         * @param {FishingGame.IAdFreeFishingRes=} [properties] Properties to set
         */
        function AdFreeFishingRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AdFreeFishingRes gameInfo.
         * @member {FishingGame.IFishingGameInfo|null|undefined} gameInfo
         * @memberof FishingGame.AdFreeFishingRes
         * @instance
         */
        AdFreeFishingRes.prototype.gameInfo = null;

        /**
         * Creates a new AdFreeFishingRes instance using the specified properties.
         * @function create
         * @memberof FishingGame.AdFreeFishingRes
         * @static
         * @param {FishingGame.IAdFreeFishingRes=} [properties] Properties to set
         * @returns {FishingGame.AdFreeFishingRes} AdFreeFishingRes instance
         */
        AdFreeFishingRes.create = function create(properties) {
            return new AdFreeFishingRes(properties);
        };

        /**
         * Encodes the specified AdFreeFishingRes message. Does not implicitly {@link FishingGame.AdFreeFishingRes.verify|verify} messages.
         * @function encode
         * @memberof FishingGame.AdFreeFishingRes
         * @static
         * @param {FishingGame.IAdFreeFishingRes} message AdFreeFishingRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdFreeFishingRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.gameInfo != null && message.hasOwnProperty("gameInfo"))
                $root.FishingGame.FishingGameInfo.encode(message.gameInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified AdFreeFishingRes message, length delimited. Does not implicitly {@link FishingGame.AdFreeFishingRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof FishingGame.AdFreeFishingRes
         * @static
         * @param {FishingGame.IAdFreeFishingRes} message AdFreeFishingRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AdFreeFishingRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AdFreeFishingRes message from the specified reader or buffer.
         * @function decode
         * @memberof FishingGame.AdFreeFishingRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {FishingGame.AdFreeFishingRes} AdFreeFishingRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdFreeFishingRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.FishingGame.AdFreeFishingRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.gameInfo = $root.FishingGame.FishingGameInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AdFreeFishingRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof FishingGame.AdFreeFishingRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {FishingGame.AdFreeFishingRes} AdFreeFishingRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AdFreeFishingRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AdFreeFishingRes message.
         * @function verify
         * @memberof FishingGame.AdFreeFishingRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AdFreeFishingRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.gameInfo != null && message.hasOwnProperty("gameInfo")) {
                var error = $root.FishingGame.FishingGameInfo.verify(message.gameInfo);
                if (error)
                    return "gameInfo." + error;
            }
            return null;
        };

        return AdFreeFishingRes;
    })();

    FishingGame.FishingGameInfo = (function() {

        /**
         * Properties of a FishingGameInfo.
         * @memberof FishingGame
         * @interface IFishingGameInfo
         * @property {number|null} [remainTimes] FishingGameInfo remainTimes
         * @property {number|null} [maxTimes] FishingGameInfo maxTimes
         * @property {number|Long|null} [nextUpdateTs] FishingGameInfo nextUpdateTs
         * @property {number|Long|null} [fullMills] FishingGameInfo fullMills
         * @property {string|null} [lastBaitsId] FishingGameInfo lastBaitsId
         * @property {Array.<string>|null} [unlockBatis] FishingGameInfo unlockBatis
         * @property {number|null} [dailyFreeTimes] FishingGameInfo dailyFreeTimes
         * @property {number|null} [fishingTicketNum] FishingGameInfo fishingTicketNum
         */

        /**
         * Constructs a new FishingGameInfo.
         * @memberof FishingGame
         * @classdesc Represents a FishingGameInfo.
         * @implements IFishingGameInfo
         * @constructor
         * @param {FishingGame.IFishingGameInfo=} [properties] Properties to set
         */
        function FishingGameInfo(properties) {
            this.unlockBatis = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FishingGameInfo remainTimes.
         * @member {number} remainTimes
         * @memberof FishingGame.FishingGameInfo
         * @instance
         */
        FishingGameInfo.prototype.remainTimes = 0;

        /**
         * FishingGameInfo maxTimes.
         * @member {number} maxTimes
         * @memberof FishingGame.FishingGameInfo
         * @instance
         */
        FishingGameInfo.prototype.maxTimes = 0;

        /**
         * FishingGameInfo nextUpdateTs.
         * @member {number|Long} nextUpdateTs
         * @memberof FishingGame.FishingGameInfo
         * @instance
         */
        FishingGameInfo.prototype.nextUpdateTs = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * FishingGameInfo fullMills.
         * @member {number|Long} fullMills
         * @memberof FishingGame.FishingGameInfo
         * @instance
         */
        FishingGameInfo.prototype.fullMills = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * FishingGameInfo lastBaitsId.
         * @member {string} lastBaitsId
         * @memberof FishingGame.FishingGameInfo
         * @instance
         */
        FishingGameInfo.prototype.lastBaitsId = "";

        /**
         * FishingGameInfo unlockBatis.
         * @member {Array.<string>} unlockBatis
         * @memberof FishingGame.FishingGameInfo
         * @instance
         */
        FishingGameInfo.prototype.unlockBatis = $util.emptyArray;

        /**
         * FishingGameInfo dailyFreeTimes.
         * @member {number} dailyFreeTimes
         * @memberof FishingGame.FishingGameInfo
         * @instance
         */
        FishingGameInfo.prototype.dailyFreeTimes = 0;

        /**
         * FishingGameInfo fishingTicketNum.
         * @member {number} fishingTicketNum
         * @memberof FishingGame.FishingGameInfo
         * @instance
         */
        FishingGameInfo.prototype.fishingTicketNum = 0;

        /**
         * Creates a new FishingGameInfo instance using the specified properties.
         * @function create
         * @memberof FishingGame.FishingGameInfo
         * @static
         * @param {FishingGame.IFishingGameInfo=} [properties] Properties to set
         * @returns {FishingGame.FishingGameInfo} FishingGameInfo instance
         */
        FishingGameInfo.create = function create(properties) {
            return new FishingGameInfo(properties);
        };

        /**
         * Encodes the specified FishingGameInfo message. Does not implicitly {@link FishingGame.FishingGameInfo.verify|verify} messages.
         * @function encode
         * @memberof FishingGame.FishingGameInfo
         * @static
         * @param {FishingGame.IFishingGameInfo} message FishingGameInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FishingGameInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.remainTimes != null && message.hasOwnProperty("remainTimes"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.remainTimes);
            if (message.maxTimes != null && message.hasOwnProperty("maxTimes"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.maxTimes);
            if (message.nextUpdateTs != null && message.hasOwnProperty("nextUpdateTs"))
                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.nextUpdateTs);
            if (message.lastBaitsId != null && message.hasOwnProperty("lastBaitsId"))
                writer.uint32(/* id 4, wireType 2 =*/34).string(message.lastBaitsId);
            if (message.unlockBatis != null && message.unlockBatis.length)
                for (var i = 0; i < message.unlockBatis.length; ++i)
                    writer.uint32(/* id 5, wireType 2 =*/42).string(message.unlockBatis[i]);
            if (message.dailyFreeTimes != null && message.hasOwnProperty("dailyFreeTimes"))
                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.dailyFreeTimes);
            if (message.fishingTicketNum != null && message.hasOwnProperty("fishingTicketNum"))
                writer.uint32(/* id 7, wireType 0 =*/56).int32(message.fishingTicketNum);
            if (message.fullMills != null && message.hasOwnProperty("fullMills"))
                writer.uint32(/* id 8, wireType 0 =*/64).int64(message.fullMills);
            return writer;
        };

        /**
         * Encodes the specified FishingGameInfo message, length delimited. Does not implicitly {@link FishingGame.FishingGameInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof FishingGame.FishingGameInfo
         * @static
         * @param {FishingGame.IFishingGameInfo} message FishingGameInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FishingGameInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FishingGameInfo message from the specified reader or buffer.
         * @function decode
         * @memberof FishingGame.FishingGameInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {FishingGame.FishingGameInfo} FishingGameInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FishingGameInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.FishingGame.FishingGameInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.remainTimes = reader.int32();
                    break;
                case 2:
                    message.maxTimes = reader.int32();
                    break;
                case 3:
                    message.nextUpdateTs = reader.int64();
                    break;
                case 8:
                    message.fullMills = reader.int64();
                    break;
                case 4:
                    message.lastBaitsId = reader.string();
                    break;
                case 5:
                    if (!(message.unlockBatis && message.unlockBatis.length))
                        message.unlockBatis = [];
                    message.unlockBatis.push(reader.string());
                    break;
                case 6:
                    message.dailyFreeTimes = reader.int32();
                    break;
                case 7:
                    message.fishingTicketNum = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FishingGameInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof FishingGame.FishingGameInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {FishingGame.FishingGameInfo} FishingGameInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FishingGameInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FishingGameInfo message.
         * @function verify
         * @memberof FishingGame.FishingGameInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FishingGameInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.remainTimes != null && message.hasOwnProperty("remainTimes"))
                if (!$util.isInteger(message.remainTimes))
                    return "remainTimes: integer expected";
            if (message.maxTimes != null && message.hasOwnProperty("maxTimes"))
                if (!$util.isInteger(message.maxTimes))
                    return "maxTimes: integer expected";
            if (message.nextUpdateTs != null && message.hasOwnProperty("nextUpdateTs"))
                if (!$util.isInteger(message.nextUpdateTs) && !(message.nextUpdateTs && $util.isInteger(message.nextUpdateTs.low) && $util.isInteger(message.nextUpdateTs.high)))
                    return "nextUpdateTs: integer|Long expected";
            if (message.fullMills != null && message.hasOwnProperty("fullMills"))
                if (!$util.isInteger(message.fullMills) && !(message.fullMills && $util.isInteger(message.fullMills.low) && $util.isInteger(message.fullMills.high)))
                    return "fullMills: integer|Long expected";
            if (message.lastBaitsId != null && message.hasOwnProperty("lastBaitsId"))
                if (!$util.isString(message.lastBaitsId))
                    return "lastBaitsId: string expected";
            if (message.unlockBatis != null && message.hasOwnProperty("unlockBatis")) {
                if (!Array.isArray(message.unlockBatis))
                    return "unlockBatis: array expected";
                for (var i = 0; i < message.unlockBatis.length; ++i)
                    if (!$util.isString(message.unlockBatis[i]))
                        return "unlockBatis: string[] expected";
            }
            if (message.dailyFreeTimes != null && message.hasOwnProperty("dailyFreeTimes"))
                if (!$util.isInteger(message.dailyFreeTimes))
                    return "dailyFreeTimes: integer expected";
            if (message.fishingTicketNum != null && message.hasOwnProperty("fishingTicketNum"))
                if (!$util.isInteger(message.fishingTicketNum))
                    return "fishingTicketNum: integer expected";
            return null;
        };

        return FishingGameInfo;
    })();

    FishingGame.FishingFishInfo = (function() {

        /**
         * Properties of a FishingFishInfo.
         * @memberof FishingGame
         * @interface IFishingFishInfo
         * @property {string|null} [fishId] FishingFishInfo fishId
         * @property {number|null} [acquireTimes] FishingFishInfo acquireTimes
         * @property {number|null} [maxSize] FishingFishInfo maxSize
         * @property {boolean|null} [newCome] FishingFishInfo newCome
         */

        /**
         * Constructs a new FishingFishInfo.
         * @memberof FishingGame
         * @classdesc Represents a FishingFishInfo.
         * @implements IFishingFishInfo
         * @constructor
         * @param {FishingGame.IFishingFishInfo=} [properties] Properties to set
         */
        function FishingFishInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FishingFishInfo fishId.
         * @member {string} fishId
         * @memberof FishingGame.FishingFishInfo
         * @instance
         */
        FishingFishInfo.prototype.fishId = "";

        /**
         * FishingFishInfo acquireTimes.
         * @member {number} acquireTimes
         * @memberof FishingGame.FishingFishInfo
         * @instance
         */
        FishingFishInfo.prototype.acquireTimes = 0;

        /**
         * FishingFishInfo maxSize.
         * @member {number} maxSize
         * @memberof FishingGame.FishingFishInfo
         * @instance
         */
        FishingFishInfo.prototype.maxSize = 0;

        /**
         * FishingFishInfo newCome.
         * @member {boolean} newCome
         * @memberof FishingGame.FishingFishInfo
         * @instance
         */
        FishingFishInfo.prototype.newCome = false;

        /**
         * Creates a new FishingFishInfo instance using the specified properties.
         * @function create
         * @memberof FishingGame.FishingFishInfo
         * @static
         * @param {FishingGame.IFishingFishInfo=} [properties] Properties to set
         * @returns {FishingGame.FishingFishInfo} FishingFishInfo instance
         */
        FishingFishInfo.create = function create(properties) {
            return new FishingFishInfo(properties);
        };

        /**
         * Encodes the specified FishingFishInfo message. Does not implicitly {@link FishingGame.FishingFishInfo.verify|verify} messages.
         * @function encode
         * @memberof FishingGame.FishingFishInfo
         * @static
         * @param {FishingGame.IFishingFishInfo} message FishingFishInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FishingFishInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.fishId != null && message.hasOwnProperty("fishId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.fishId);
            if (message.acquireTimes != null && message.hasOwnProperty("acquireTimes"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.acquireTimes);
            if (message.maxSize != null && message.hasOwnProperty("maxSize"))
                writer.uint32(/* id 3, wireType 1 =*/25).double(message.maxSize);
            if (message.newCome != null && message.hasOwnProperty("newCome"))
                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.newCome);
            return writer;
        };

        /**
         * Encodes the specified FishingFishInfo message, length delimited. Does not implicitly {@link FishingGame.FishingFishInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof FishingGame.FishingFishInfo
         * @static
         * @param {FishingGame.IFishingFishInfo} message FishingFishInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FishingFishInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FishingFishInfo message from the specified reader or buffer.
         * @function decode
         * @memberof FishingGame.FishingFishInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {FishingGame.FishingFishInfo} FishingFishInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FishingFishInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.FishingGame.FishingFishInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.fishId = reader.string();
                    break;
                case 2:
                    message.acquireTimes = reader.int32();
                    break;
                case 3:
                    message.maxSize = reader.double();
                    break;
                case 5:
                    message.newCome = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FishingFishInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof FishingGame.FishingFishInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {FishingGame.FishingFishInfo} FishingFishInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FishingFishInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FishingFishInfo message.
         * @function verify
         * @memberof FishingGame.FishingFishInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FishingFishInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.fishId != null && message.hasOwnProperty("fishId"))
                if (!$util.isString(message.fishId))
                    return "fishId: string expected";
            if (message.acquireTimes != null && message.hasOwnProperty("acquireTimes"))
                if (!$util.isInteger(message.acquireTimes))
                    return "acquireTimes: integer expected";
            if (message.maxSize != null && message.hasOwnProperty("maxSize"))
                if (typeof message.maxSize !== "number")
                    return "maxSize: number expected";
            if (message.newCome != null && message.hasOwnProperty("newCome"))
                if (typeof message.newCome !== "boolean")
                    return "newCome: boolean expected";
            return null;
        };

        return FishingFishInfo;
    })();

    return FishingGame;
})();

$root.Home = (function() {

    /**
     * Namespace Home.
     * @exports Home
     * @namespace
     */
    var Home = {};

    Home.SetPetStatusReq = (function() {

        /**
         * Properties of a SetPetStatusReq.
         * @memberof Home
         * @interface ISetPetStatusReq
         * @property {Array.<Home.IPetStatusParam>|null} [params] SetPetStatusReq params
         */

        /**
         * Constructs a new SetPetStatusReq.
         * @memberof Home
         * @classdesc Represents a SetPetStatusReq.
         * @implements ISetPetStatusReq
         * @constructor
         * @param {Home.ISetPetStatusReq=} [properties] Properties to set
         */
        function SetPetStatusReq(properties) {
            this.params = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * SetPetStatusReq params.
         * @member {Array.<Home.IPetStatusParam>} params
         * @memberof Home.SetPetStatusReq
         * @instance
         */
        SetPetStatusReq.prototype.params = $util.emptyArray;

        /**
         * Creates a new SetPetStatusReq instance using the specified properties.
         * @function create
         * @memberof Home.SetPetStatusReq
         * @static
         * @param {Home.ISetPetStatusReq=} [properties] Properties to set
         * @returns {Home.SetPetStatusReq} SetPetStatusReq instance
         */
        SetPetStatusReq.create = function create(properties) {
            return new SetPetStatusReq(properties);
        };

        /**
         * Encodes the specified SetPetStatusReq message. Does not implicitly {@link Home.SetPetStatusReq.verify|verify} messages.
         * @function encode
         * @memberof Home.SetPetStatusReq
         * @static
         * @param {Home.ISetPetStatusReq} message SetPetStatusReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SetPetStatusReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.params != null && message.params.length)
                for (var i = 0; i < message.params.length; ++i)
                    $root.Home.PetStatusParam.encode(message.params[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified SetPetStatusReq message, length delimited. Does not implicitly {@link Home.SetPetStatusReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.SetPetStatusReq
         * @static
         * @param {Home.ISetPetStatusReq} message SetPetStatusReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SetPetStatusReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a SetPetStatusReq message from the specified reader or buffer.
         * @function decode
         * @memberof Home.SetPetStatusReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.SetPetStatusReq} SetPetStatusReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SetPetStatusReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.SetPetStatusReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.params && message.params.length))
                        message.params = [];
                    message.params.push($root.Home.PetStatusParam.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a SetPetStatusReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.SetPetStatusReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.SetPetStatusReq} SetPetStatusReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SetPetStatusReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a SetPetStatusReq message.
         * @function verify
         * @memberof Home.SetPetStatusReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        SetPetStatusReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.params != null && message.hasOwnProperty("params")) {
                if (!Array.isArray(message.params))
                    return "params: array expected";
                for (var i = 0; i < message.params.length; ++i) {
                    var error = $root.Home.PetStatusParam.verify(message.params[i]);
                    if (error)
                        return "params." + error;
                }
            }
            return null;
        };

        return SetPetStatusReq;
    })();

    Home.PetStatusParam = (function() {

        /**
         * Properties of a PetStatusParam.
         * @memberof Home
         * @interface IPetStatusParam
         * @property {string|null} [petId] PetStatusParam petId
         * @property {boolean|null} [inHome] PetStatusParam inHome
         */

        /**
         * Constructs a new PetStatusParam.
         * @memberof Home
         * @classdesc Represents a PetStatusParam.
         * @implements IPetStatusParam
         * @constructor
         * @param {Home.IPetStatusParam=} [properties] Properties to set
         */
        function PetStatusParam(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PetStatusParam petId.
         * @member {string} petId
         * @memberof Home.PetStatusParam
         * @instance
         */
        PetStatusParam.prototype.petId = "";

        /**
         * PetStatusParam inHome.
         * @member {boolean} inHome
         * @memberof Home.PetStatusParam
         * @instance
         */
        PetStatusParam.prototype.inHome = false;

        /**
         * Creates a new PetStatusParam instance using the specified properties.
         * @function create
         * @memberof Home.PetStatusParam
         * @static
         * @param {Home.IPetStatusParam=} [properties] Properties to set
         * @returns {Home.PetStatusParam} PetStatusParam instance
         */
        PetStatusParam.create = function create(properties) {
            return new PetStatusParam(properties);
        };

        /**
         * Encodes the specified PetStatusParam message. Does not implicitly {@link Home.PetStatusParam.verify|verify} messages.
         * @function encode
         * @memberof Home.PetStatusParam
         * @static
         * @param {Home.IPetStatusParam} message PetStatusParam message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PetStatusParam.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.petId != null && message.hasOwnProperty("petId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.petId);
            if (message.inHome != null && message.hasOwnProperty("inHome"))
                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.inHome);
            return writer;
        };

        /**
         * Encodes the specified PetStatusParam message, length delimited. Does not implicitly {@link Home.PetStatusParam.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.PetStatusParam
         * @static
         * @param {Home.IPetStatusParam} message PetStatusParam message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PetStatusParam.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PetStatusParam message from the specified reader or buffer.
         * @function decode
         * @memberof Home.PetStatusParam
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.PetStatusParam} PetStatusParam
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PetStatusParam.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.PetStatusParam();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.petId = reader.string();
                    break;
                case 2:
                    message.inHome = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PetStatusParam message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.PetStatusParam
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.PetStatusParam} PetStatusParam
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PetStatusParam.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PetStatusParam message.
         * @function verify
         * @memberof Home.PetStatusParam
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PetStatusParam.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.petId != null && message.hasOwnProperty("petId"))
                if (!$util.isString(message.petId))
                    return "petId: string expected";
            if (message.inHome != null && message.hasOwnProperty("inHome"))
                if (typeof message.inHome !== "boolean")
                    return "inHome: boolean expected";
            return null;
        };

        return PetStatusParam;
    })();

    Home.SetPetStatusRes = (function() {

        /**
         * Properties of a SetPetStatusRes.
         * @memberof Home
         * @interface ISetPetStatusRes
         * @property {Array.<BaseInfo.IPetInfo>|null} [petInfos] SetPetStatusRes petInfos
         */

        /**
         * Constructs a new SetPetStatusRes.
         * @memberof Home
         * @classdesc Represents a SetPetStatusRes.
         * @implements ISetPetStatusRes
         * @constructor
         * @param {Home.ISetPetStatusRes=} [properties] Properties to set
         */
        function SetPetStatusRes(properties) {
            this.petInfos = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * SetPetStatusRes petInfos.
         * @member {Array.<BaseInfo.IPetInfo>} petInfos
         * @memberof Home.SetPetStatusRes
         * @instance
         */
        SetPetStatusRes.prototype.petInfos = $util.emptyArray;

        /**
         * Creates a new SetPetStatusRes instance using the specified properties.
         * @function create
         * @memberof Home.SetPetStatusRes
         * @static
         * @param {Home.ISetPetStatusRes=} [properties] Properties to set
         * @returns {Home.SetPetStatusRes} SetPetStatusRes instance
         */
        SetPetStatusRes.create = function create(properties) {
            return new SetPetStatusRes(properties);
        };

        /**
         * Encodes the specified SetPetStatusRes message. Does not implicitly {@link Home.SetPetStatusRes.verify|verify} messages.
         * @function encode
         * @memberof Home.SetPetStatusRes
         * @static
         * @param {Home.ISetPetStatusRes} message SetPetStatusRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SetPetStatusRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.petInfos != null && message.petInfos.length)
                for (var i = 0; i < message.petInfos.length; ++i)
                    $root.BaseInfo.PetInfo.encode(message.petInfos[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified SetPetStatusRes message, length delimited. Does not implicitly {@link Home.SetPetStatusRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.SetPetStatusRes
         * @static
         * @param {Home.ISetPetStatusRes} message SetPetStatusRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SetPetStatusRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a SetPetStatusRes message from the specified reader or buffer.
         * @function decode
         * @memberof Home.SetPetStatusRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.SetPetStatusRes} SetPetStatusRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SetPetStatusRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.SetPetStatusRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.petInfos && message.petInfos.length))
                        message.petInfos = [];
                    message.petInfos.push($root.BaseInfo.PetInfo.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a SetPetStatusRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.SetPetStatusRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.SetPetStatusRes} SetPetStatusRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SetPetStatusRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a SetPetStatusRes message.
         * @function verify
         * @memberof Home.SetPetStatusRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        SetPetStatusRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.petInfos != null && message.hasOwnProperty("petInfos")) {
                if (!Array.isArray(message.petInfos))
                    return "petInfos: array expected";
                for (var i = 0; i < message.petInfos.length; ++i) {
                    var error = $root.BaseInfo.PetInfo.verify(message.petInfos[i]);
                    if (error)
                        return "petInfos." + error;
                }
            }
            return null;
        };

        return SetPetStatusRes;
    })();

    Home.CuteInteractReq = (function() {

        /**
         * Properties of a CuteInteractReq.
         * @memberof Home
         * @interface ICuteInteractReq
         * @property {string|null} [petId] CuteInteractReq petId
         * @property {string|null} [toyId] CuteInteractReq toyId
         */

        /**
         * Constructs a new CuteInteractReq.
         * @memberof Home
         * @classdesc Represents a CuteInteractReq.
         * @implements ICuteInteractReq
         * @constructor
         * @param {Home.ICuteInteractReq=} [properties] Properties to set
         */
        function CuteInteractReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CuteInteractReq petId.
         * @member {string} petId
         * @memberof Home.CuteInteractReq
         * @instance
         */
        CuteInteractReq.prototype.petId = "";

        /**
         * CuteInteractReq toyId.
         * @member {string} toyId
         * @memberof Home.CuteInteractReq
         * @instance
         */
        CuteInteractReq.prototype.toyId = "";

        /**
         * Creates a new CuteInteractReq instance using the specified properties.
         * @function create
         * @memberof Home.CuteInteractReq
         * @static
         * @param {Home.ICuteInteractReq=} [properties] Properties to set
         * @returns {Home.CuteInteractReq} CuteInteractReq instance
         */
        CuteInteractReq.create = function create(properties) {
            return new CuteInteractReq(properties);
        };

        /**
         * Encodes the specified CuteInteractReq message. Does not implicitly {@link Home.CuteInteractReq.verify|verify} messages.
         * @function encode
         * @memberof Home.CuteInteractReq
         * @static
         * @param {Home.ICuteInteractReq} message CuteInteractReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CuteInteractReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.petId != null && message.hasOwnProperty("petId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.petId);
            if (message.toyId != null && message.hasOwnProperty("toyId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.toyId);
            return writer;
        };

        /**
         * Encodes the specified CuteInteractReq message, length delimited. Does not implicitly {@link Home.CuteInteractReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.CuteInteractReq
         * @static
         * @param {Home.ICuteInteractReq} message CuteInteractReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CuteInteractReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CuteInteractReq message from the specified reader or buffer.
         * @function decode
         * @memberof Home.CuteInteractReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.CuteInteractReq} CuteInteractReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CuteInteractReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.CuteInteractReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.petId = reader.string();
                    break;
                case 2:
                    message.toyId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CuteInteractReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.CuteInteractReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.CuteInteractReq} CuteInteractReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CuteInteractReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CuteInteractReq message.
         * @function verify
         * @memberof Home.CuteInteractReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CuteInteractReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.petId != null && message.hasOwnProperty("petId"))
                if (!$util.isString(message.petId))
                    return "petId: string expected";
            if (message.toyId != null && message.hasOwnProperty("toyId"))
                if (!$util.isString(message.toyId))
                    return "toyId: string expected";
            return null;
        };

        return CuteInteractReq;
    })();

    Home.CuteInteractRes = (function() {

        /**
         * Properties of a CuteInteractRes.
         * @memberof Home
         * @interface ICuteInteractRes
         * @property {number|null} [increase] CuteInteractRes increase
         * @property {BaseInfo.IRewards|null} [rewards] CuteInteractRes rewards
         * @property {BaseInfo.IPetInfo|null} [petInfo] CuteInteractRes petInfo
         * @property {number|Long|null} [amount] CuteInteractRes amount
         */

        /**
         * Constructs a new CuteInteractRes.
         * @memberof Home
         * @classdesc Represents a CuteInteractRes.
         * @implements ICuteInteractRes
         * @constructor
         * @param {Home.ICuteInteractRes=} [properties] Properties to set
         */
        function CuteInteractRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CuteInteractRes increase.
         * @member {number} increase
         * @memberof Home.CuteInteractRes
         * @instance
         */
        CuteInteractRes.prototype.increase = 0;

        /**
         * CuteInteractRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Home.CuteInteractRes
         * @instance
         */
        CuteInteractRes.prototype.rewards = null;

        /**
         * CuteInteractRes petInfo.
         * @member {BaseInfo.IPetInfo|null|undefined} petInfo
         * @memberof Home.CuteInteractRes
         * @instance
         */
        CuteInteractRes.prototype.petInfo = null;

        /**
         * CuteInteractRes amount.
         * @member {number|Long} amount
         * @memberof Home.CuteInteractRes
         * @instance
         */
        CuteInteractRes.prototype.amount = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new CuteInteractRes instance using the specified properties.
         * @function create
         * @memberof Home.CuteInteractRes
         * @static
         * @param {Home.ICuteInteractRes=} [properties] Properties to set
         * @returns {Home.CuteInteractRes} CuteInteractRes instance
         */
        CuteInteractRes.create = function create(properties) {
            return new CuteInteractRes(properties);
        };

        /**
         * Encodes the specified CuteInteractRes message. Does not implicitly {@link Home.CuteInteractRes.verify|verify} messages.
         * @function encode
         * @memberof Home.CuteInteractRes
         * @static
         * @param {Home.ICuteInteractRes} message CuteInteractRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CuteInteractRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.increase != null && message.hasOwnProperty("increase"))
                writer.uint32(/* id 1, wireType 1 =*/9).double(message.increase);
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.petInfo != null && message.hasOwnProperty("petInfo"))
                $root.BaseInfo.PetInfo.encode(message.petInfo, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.amount != null && message.hasOwnProperty("amount"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.amount);
            return writer;
        };

        /**
         * Encodes the specified CuteInteractRes message, length delimited. Does not implicitly {@link Home.CuteInteractRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.CuteInteractRes
         * @static
         * @param {Home.ICuteInteractRes} message CuteInteractRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CuteInteractRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CuteInteractRes message from the specified reader or buffer.
         * @function decode
         * @memberof Home.CuteInteractRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.CuteInteractRes} CuteInteractRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CuteInteractRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.CuteInteractRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.increase = reader.double();
                    break;
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.petInfo = $root.BaseInfo.PetInfo.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.amount = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CuteInteractRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.CuteInteractRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.CuteInteractRes} CuteInteractRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CuteInteractRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CuteInteractRes message.
         * @function verify
         * @memberof Home.CuteInteractRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CuteInteractRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.increase != null && message.hasOwnProperty("increase"))
                if (typeof message.increase !== "number")
                    return "increase: number expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.petInfo != null && message.hasOwnProperty("petInfo")) {
                var error = $root.BaseInfo.PetInfo.verify(message.petInfo);
                if (error)
                    return "petInfo." + error;
            }
            if (message.amount != null && message.hasOwnProperty("amount"))
                if (!$util.isInteger(message.amount) && !(message.amount && $util.isInteger(message.amount.low) && $util.isInteger(message.amount.high)))
                    return "amount: integer|Long expected";
            return null;
        };

        return CuteInteractRes;
    })();

    Home.CommonInteractReq = (function() {

        /**
         * Properties of a CommonInteractReq.
         * @memberof Home
         * @interface ICommonInteractReq
         * @property {string|null} [petId] CommonInteractReq petId
         */

        /**
         * Constructs a new CommonInteractReq.
         * @memberof Home
         * @classdesc Represents a CommonInteractReq.
         * @implements ICommonInteractReq
         * @constructor
         * @param {Home.ICommonInteractReq=} [properties] Properties to set
         */
        function CommonInteractReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CommonInteractReq petId.
         * @member {string} petId
         * @memberof Home.CommonInteractReq
         * @instance
         */
        CommonInteractReq.prototype.petId = "";

        /**
         * Creates a new CommonInteractReq instance using the specified properties.
         * @function create
         * @memberof Home.CommonInteractReq
         * @static
         * @param {Home.ICommonInteractReq=} [properties] Properties to set
         * @returns {Home.CommonInteractReq} CommonInteractReq instance
         */
        CommonInteractReq.create = function create(properties) {
            return new CommonInteractReq(properties);
        };

        /**
         * Encodes the specified CommonInteractReq message. Does not implicitly {@link Home.CommonInteractReq.verify|verify} messages.
         * @function encode
         * @memberof Home.CommonInteractReq
         * @static
         * @param {Home.ICommonInteractReq} message CommonInteractReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CommonInteractReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.petId != null && message.hasOwnProperty("petId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.petId);
            return writer;
        };

        /**
         * Encodes the specified CommonInteractReq message, length delimited. Does not implicitly {@link Home.CommonInteractReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.CommonInteractReq
         * @static
         * @param {Home.ICommonInteractReq} message CommonInteractReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CommonInteractReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CommonInteractReq message from the specified reader or buffer.
         * @function decode
         * @memberof Home.CommonInteractReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.CommonInteractReq} CommonInteractReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CommonInteractReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.CommonInteractReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.petId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CommonInteractReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.CommonInteractReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.CommonInteractReq} CommonInteractReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CommonInteractReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CommonInteractReq message.
         * @function verify
         * @memberof Home.CommonInteractReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CommonInteractReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.petId != null && message.hasOwnProperty("petId"))
                if (!$util.isString(message.petId))
                    return "petId: string expected";
            return null;
        };

        return CommonInteractReq;
    })();

    Home.CommonInteractRes = (function() {

        /**
         * Properties of a CommonInteractRes.
         * @memberof Home
         * @interface ICommonInteractRes
         * @property {number|null} [increase] CommonInteractRes increase
         * @property {BaseInfo.IRewards|null} [rewards] CommonInteractRes rewards
         * @property {BaseInfo.IPetInfo|null} [petInfo] CommonInteractRes petInfo
         * @property {number|Long|null} [amount] CommonInteractRes amount
         */

        /**
         * Constructs a new CommonInteractRes.
         * @memberof Home
         * @classdesc Represents a CommonInteractRes.
         * @implements ICommonInteractRes
         * @constructor
         * @param {Home.ICommonInteractRes=} [properties] Properties to set
         */
        function CommonInteractRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CommonInteractRes increase.
         * @member {number} increase
         * @memberof Home.CommonInteractRes
         * @instance
         */
        CommonInteractRes.prototype.increase = 0;

        /**
         * CommonInteractRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Home.CommonInteractRes
         * @instance
         */
        CommonInteractRes.prototype.rewards = null;

        /**
         * CommonInteractRes petInfo.
         * @member {BaseInfo.IPetInfo|null|undefined} petInfo
         * @memberof Home.CommonInteractRes
         * @instance
         */
        CommonInteractRes.prototype.petInfo = null;

        /**
         * CommonInteractRes amount.
         * @member {number|Long} amount
         * @memberof Home.CommonInteractRes
         * @instance
         */
        CommonInteractRes.prototype.amount = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new CommonInteractRes instance using the specified properties.
         * @function create
         * @memberof Home.CommonInteractRes
         * @static
         * @param {Home.ICommonInteractRes=} [properties] Properties to set
         * @returns {Home.CommonInteractRes} CommonInteractRes instance
         */
        CommonInteractRes.create = function create(properties) {
            return new CommonInteractRes(properties);
        };

        /**
         * Encodes the specified CommonInteractRes message. Does not implicitly {@link Home.CommonInteractRes.verify|verify} messages.
         * @function encode
         * @memberof Home.CommonInteractRes
         * @static
         * @param {Home.ICommonInteractRes} message CommonInteractRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CommonInteractRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.increase != null && message.hasOwnProperty("increase"))
                writer.uint32(/* id 1, wireType 1 =*/9).double(message.increase);
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.petInfo != null && message.hasOwnProperty("petInfo"))
                $root.BaseInfo.PetInfo.encode(message.petInfo, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.amount != null && message.hasOwnProperty("amount"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.amount);
            return writer;
        };

        /**
         * Encodes the specified CommonInteractRes message, length delimited. Does not implicitly {@link Home.CommonInteractRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.CommonInteractRes
         * @static
         * @param {Home.ICommonInteractRes} message CommonInteractRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CommonInteractRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CommonInteractRes message from the specified reader or buffer.
         * @function decode
         * @memberof Home.CommonInteractRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.CommonInteractRes} CommonInteractRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CommonInteractRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.CommonInteractRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.increase = reader.double();
                    break;
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.petInfo = $root.BaseInfo.PetInfo.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.amount = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CommonInteractRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.CommonInteractRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.CommonInteractRes} CommonInteractRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CommonInteractRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CommonInteractRes message.
         * @function verify
         * @memberof Home.CommonInteractRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CommonInteractRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.increase != null && message.hasOwnProperty("increase"))
                if (typeof message.increase !== "number")
                    return "increase: number expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.petInfo != null && message.hasOwnProperty("petInfo")) {
                var error = $root.BaseInfo.PetInfo.verify(message.petInfo);
                if (error)
                    return "petInfo." + error;
            }
            if (message.amount != null && message.hasOwnProperty("amount"))
                if (!$util.isInteger(message.amount) && !(message.amount && $util.isInteger(message.amount.low) && $util.isInteger(message.amount.high)))
                    return "amount: integer|Long expected";
            return null;
        };

        return CommonInteractRes;
    })();

    Home.FetchPhotoWallReq = (function() {

        /**
         * Properties of a FetchPhotoWallReq.
         * @memberof Home
         * @interface IFetchPhotoWallReq
         */

        /**
         * Constructs a new FetchPhotoWallReq.
         * @memberof Home
         * @classdesc Represents a FetchPhotoWallReq.
         * @implements IFetchPhotoWallReq
         * @constructor
         * @param {Home.IFetchPhotoWallReq=} [properties] Properties to set
         */
        function FetchPhotoWallReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new FetchPhotoWallReq instance using the specified properties.
         * @function create
         * @memberof Home.FetchPhotoWallReq
         * @static
         * @param {Home.IFetchPhotoWallReq=} [properties] Properties to set
         * @returns {Home.FetchPhotoWallReq} FetchPhotoWallReq instance
         */
        FetchPhotoWallReq.create = function create(properties) {
            return new FetchPhotoWallReq(properties);
        };

        /**
         * Encodes the specified FetchPhotoWallReq message. Does not implicitly {@link Home.FetchPhotoWallReq.verify|verify} messages.
         * @function encode
         * @memberof Home.FetchPhotoWallReq
         * @static
         * @param {Home.IFetchPhotoWallReq} message FetchPhotoWallReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchPhotoWallReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified FetchPhotoWallReq message, length delimited. Does not implicitly {@link Home.FetchPhotoWallReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.FetchPhotoWallReq
         * @static
         * @param {Home.IFetchPhotoWallReq} message FetchPhotoWallReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchPhotoWallReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchPhotoWallReq message from the specified reader or buffer.
         * @function decode
         * @memberof Home.FetchPhotoWallReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.FetchPhotoWallReq} FetchPhotoWallReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchPhotoWallReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.FetchPhotoWallReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchPhotoWallReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.FetchPhotoWallReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.FetchPhotoWallReq} FetchPhotoWallReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchPhotoWallReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchPhotoWallReq message.
         * @function verify
         * @memberof Home.FetchPhotoWallReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchPhotoWallReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return FetchPhotoWallReq;
    })();

    Home.FetchPhotoWallRes = (function() {

        /**
         * Properties of a FetchPhotoWallRes.
         * @memberof Home
         * @interface IFetchPhotoWallRes
         * @property {Home.IPhotoWall|null} [photoWall] FetchPhotoWallRes photoWall
         */

        /**
         * Constructs a new FetchPhotoWallRes.
         * @memberof Home
         * @classdesc Represents a FetchPhotoWallRes.
         * @implements IFetchPhotoWallRes
         * @constructor
         * @param {Home.IFetchPhotoWallRes=} [properties] Properties to set
         */
        function FetchPhotoWallRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchPhotoWallRes photoWall.
         * @member {Home.IPhotoWall|null|undefined} photoWall
         * @memberof Home.FetchPhotoWallRes
         * @instance
         */
        FetchPhotoWallRes.prototype.photoWall = null;

        /**
         * Creates a new FetchPhotoWallRes instance using the specified properties.
         * @function create
         * @memberof Home.FetchPhotoWallRes
         * @static
         * @param {Home.IFetchPhotoWallRes=} [properties] Properties to set
         * @returns {Home.FetchPhotoWallRes} FetchPhotoWallRes instance
         */
        FetchPhotoWallRes.create = function create(properties) {
            return new FetchPhotoWallRes(properties);
        };

        /**
         * Encodes the specified FetchPhotoWallRes message. Does not implicitly {@link Home.FetchPhotoWallRes.verify|verify} messages.
         * @function encode
         * @memberof Home.FetchPhotoWallRes
         * @static
         * @param {Home.IFetchPhotoWallRes} message FetchPhotoWallRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchPhotoWallRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.photoWall != null && message.hasOwnProperty("photoWall"))
                $root.Home.PhotoWall.encode(message.photoWall, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FetchPhotoWallRes message, length delimited. Does not implicitly {@link Home.FetchPhotoWallRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.FetchPhotoWallRes
         * @static
         * @param {Home.IFetchPhotoWallRes} message FetchPhotoWallRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchPhotoWallRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchPhotoWallRes message from the specified reader or buffer.
         * @function decode
         * @memberof Home.FetchPhotoWallRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.FetchPhotoWallRes} FetchPhotoWallRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchPhotoWallRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.FetchPhotoWallRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.photoWall = $root.Home.PhotoWall.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchPhotoWallRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.FetchPhotoWallRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.FetchPhotoWallRes} FetchPhotoWallRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchPhotoWallRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchPhotoWallRes message.
         * @function verify
         * @memberof Home.FetchPhotoWallRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchPhotoWallRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.photoWall != null && message.hasOwnProperty("photoWall")) {
                var error = $root.Home.PhotoWall.verify(message.photoWall);
                if (error)
                    return "photoWall." + error;
            }
            return null;
        };

        return FetchPhotoWallRes;
    })();

    Home.FetchHomeInfoReq = (function() {

        /**
         * Properties of a FetchHomeInfoReq.
         * @memberof Home
         * @interface IFetchHomeInfoReq
         */

        /**
         * Constructs a new FetchHomeInfoReq.
         * @memberof Home
         * @classdesc Represents a FetchHomeInfoReq.
         * @implements IFetchHomeInfoReq
         * @constructor
         * @param {Home.IFetchHomeInfoReq=} [properties] Properties to set
         */
        function FetchHomeInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new FetchHomeInfoReq instance using the specified properties.
         * @function create
         * @memberof Home.FetchHomeInfoReq
         * @static
         * @param {Home.IFetchHomeInfoReq=} [properties] Properties to set
         * @returns {Home.FetchHomeInfoReq} FetchHomeInfoReq instance
         */
        FetchHomeInfoReq.create = function create(properties) {
            return new FetchHomeInfoReq(properties);
        };

        /**
         * Encodes the specified FetchHomeInfoReq message. Does not implicitly {@link Home.FetchHomeInfoReq.verify|verify} messages.
         * @function encode
         * @memberof Home.FetchHomeInfoReq
         * @static
         * @param {Home.IFetchHomeInfoReq} message FetchHomeInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchHomeInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified FetchHomeInfoReq message, length delimited. Does not implicitly {@link Home.FetchHomeInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.FetchHomeInfoReq
         * @static
         * @param {Home.IFetchHomeInfoReq} message FetchHomeInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchHomeInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchHomeInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof Home.FetchHomeInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.FetchHomeInfoReq} FetchHomeInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchHomeInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.FetchHomeInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchHomeInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.FetchHomeInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.FetchHomeInfoReq} FetchHomeInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchHomeInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchHomeInfoReq message.
         * @function verify
         * @memberof Home.FetchHomeInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchHomeInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return FetchHomeInfoReq;
    })();

    Home.FetchHomeInfoRes = (function() {

        /**
         * Properties of a FetchHomeInfoRes.
         * @memberof Home
         * @interface IFetchHomeInfoRes
         * @property {Home.IHomeInfo|null} [homeInfo] FetchHomeInfoRes homeInfo
         */

        /**
         * Constructs a new FetchHomeInfoRes.
         * @memberof Home
         * @classdesc Represents a FetchHomeInfoRes.
         * @implements IFetchHomeInfoRes
         * @constructor
         * @param {Home.IFetchHomeInfoRes=} [properties] Properties to set
         */
        function FetchHomeInfoRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchHomeInfoRes homeInfo.
         * @member {Home.IHomeInfo|null|undefined} homeInfo
         * @memberof Home.FetchHomeInfoRes
         * @instance
         */
        FetchHomeInfoRes.prototype.homeInfo = null;

        /**
         * Creates a new FetchHomeInfoRes instance using the specified properties.
         * @function create
         * @memberof Home.FetchHomeInfoRes
         * @static
         * @param {Home.IFetchHomeInfoRes=} [properties] Properties to set
         * @returns {Home.FetchHomeInfoRes} FetchHomeInfoRes instance
         */
        FetchHomeInfoRes.create = function create(properties) {
            return new FetchHomeInfoRes(properties);
        };

        /**
         * Encodes the specified FetchHomeInfoRes message. Does not implicitly {@link Home.FetchHomeInfoRes.verify|verify} messages.
         * @function encode
         * @memberof Home.FetchHomeInfoRes
         * @static
         * @param {Home.IFetchHomeInfoRes} message FetchHomeInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchHomeInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.homeInfo != null && message.hasOwnProperty("homeInfo"))
                $root.Home.HomeInfo.encode(message.homeInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FetchHomeInfoRes message, length delimited. Does not implicitly {@link Home.FetchHomeInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.FetchHomeInfoRes
         * @static
         * @param {Home.IFetchHomeInfoRes} message FetchHomeInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchHomeInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchHomeInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof Home.FetchHomeInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.FetchHomeInfoRes} FetchHomeInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchHomeInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.FetchHomeInfoRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.homeInfo = $root.Home.HomeInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchHomeInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.FetchHomeInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.FetchHomeInfoRes} FetchHomeInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchHomeInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchHomeInfoRes message.
         * @function verify
         * @memberof Home.FetchHomeInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchHomeInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.homeInfo != null && message.hasOwnProperty("homeInfo")) {
                var error = $root.Home.HomeInfo.verify(message.homeInfo);
                if (error)
                    return "homeInfo." + error;
            }
            return null;
        };

        return FetchHomeInfoRes;
    })();

    Home.HealthyInteractReq = (function() {

        /**
         * Properties of a HealthyInteractReq.
         * @memberof Home
         * @interface IHealthyInteractReq
         * @property {string|null} [petId] HealthyInteractReq petId
         * @property {number|null} [type] HealthyInteractReq type
         */

        /**
         * Constructs a new HealthyInteractReq.
         * @memberof Home
         * @classdesc Represents a HealthyInteractReq.
         * @implements IHealthyInteractReq
         * @constructor
         * @param {Home.IHealthyInteractReq=} [properties] Properties to set
         */
        function HealthyInteractReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * HealthyInteractReq petId.
         * @member {string} petId
         * @memberof Home.HealthyInteractReq
         * @instance
         */
        HealthyInteractReq.prototype.petId = "";

        /**
         * HealthyInteractReq type.
         * @member {number} type
         * @memberof Home.HealthyInteractReq
         * @instance
         */
        HealthyInteractReq.prototype.type = 0;

        /**
         * Creates a new HealthyInteractReq instance using the specified properties.
         * @function create
         * @memberof Home.HealthyInteractReq
         * @static
         * @param {Home.IHealthyInteractReq=} [properties] Properties to set
         * @returns {Home.HealthyInteractReq} HealthyInteractReq instance
         */
        HealthyInteractReq.create = function create(properties) {
            return new HealthyInteractReq(properties);
        };

        /**
         * Encodes the specified HealthyInteractReq message. Does not implicitly {@link Home.HealthyInteractReq.verify|verify} messages.
         * @function encode
         * @memberof Home.HealthyInteractReq
         * @static
         * @param {Home.IHealthyInteractReq} message HealthyInteractReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        HealthyInteractReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.petId != null && message.hasOwnProperty("petId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.petId);
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.type);
            return writer;
        };

        /**
         * Encodes the specified HealthyInteractReq message, length delimited. Does not implicitly {@link Home.HealthyInteractReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.HealthyInteractReq
         * @static
         * @param {Home.IHealthyInteractReq} message HealthyInteractReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        HealthyInteractReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a HealthyInteractReq message from the specified reader or buffer.
         * @function decode
         * @memberof Home.HealthyInteractReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.HealthyInteractReq} HealthyInteractReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        HealthyInteractReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.HealthyInteractReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.petId = reader.string();
                    break;
                case 2:
                    message.type = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a HealthyInteractReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.HealthyInteractReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.HealthyInteractReq} HealthyInteractReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        HealthyInteractReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a HealthyInteractReq message.
         * @function verify
         * @memberof Home.HealthyInteractReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        HealthyInteractReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.petId != null && message.hasOwnProperty("petId"))
                if (!$util.isString(message.petId))
                    return "petId: string expected";
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isInteger(message.type))
                    return "type: integer expected";
            return null;
        };

        return HealthyInteractReq;
    })();

    Home.HealthyInteractRes = (function() {

        /**
         * Properties of a HealthyInteractRes.
         * @memberof Home
         * @interface IHealthyInteractRes
         * @property {number|null} [increase] HealthyInteractRes increase
         * @property {BaseInfo.IRewards|null} [rewards] HealthyInteractRes rewards
         * @property {BaseInfo.IPetInfo|null} [petInfo] HealthyInteractRes petInfo
         * @property {number|Long|null} [amount] HealthyInteractRes amount
         */

        /**
         * Constructs a new HealthyInteractRes.
         * @memberof Home
         * @classdesc Represents a HealthyInteractRes.
         * @implements IHealthyInteractRes
         * @constructor
         * @param {Home.IHealthyInteractRes=} [properties] Properties to set
         */
        function HealthyInteractRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * HealthyInteractRes increase.
         * @member {number} increase
         * @memberof Home.HealthyInteractRes
         * @instance
         */
        HealthyInteractRes.prototype.increase = 0;

        /**
         * HealthyInteractRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Home.HealthyInteractRes
         * @instance
         */
        HealthyInteractRes.prototype.rewards = null;

        /**
         * HealthyInteractRes petInfo.
         * @member {BaseInfo.IPetInfo|null|undefined} petInfo
         * @memberof Home.HealthyInteractRes
         * @instance
         */
        HealthyInteractRes.prototype.petInfo = null;

        /**
         * HealthyInteractRes amount.
         * @member {number|Long} amount
         * @memberof Home.HealthyInteractRes
         * @instance
         */
        HealthyInteractRes.prototype.amount = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new HealthyInteractRes instance using the specified properties.
         * @function create
         * @memberof Home.HealthyInteractRes
         * @static
         * @param {Home.IHealthyInteractRes=} [properties] Properties to set
         * @returns {Home.HealthyInteractRes} HealthyInteractRes instance
         */
        HealthyInteractRes.create = function create(properties) {
            return new HealthyInteractRes(properties);
        };

        /**
         * Encodes the specified HealthyInteractRes message. Does not implicitly {@link Home.HealthyInteractRes.verify|verify} messages.
         * @function encode
         * @memberof Home.HealthyInteractRes
         * @static
         * @param {Home.IHealthyInteractRes} message HealthyInteractRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        HealthyInteractRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.increase != null && message.hasOwnProperty("increase"))
                writer.uint32(/* id 1, wireType 1 =*/9).double(message.increase);
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.petInfo != null && message.hasOwnProperty("petInfo"))
                $root.BaseInfo.PetInfo.encode(message.petInfo, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.amount != null && message.hasOwnProperty("amount"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.amount);
            return writer;
        };

        /**
         * Encodes the specified HealthyInteractRes message, length delimited. Does not implicitly {@link Home.HealthyInteractRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.HealthyInteractRes
         * @static
         * @param {Home.IHealthyInteractRes} message HealthyInteractRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        HealthyInteractRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a HealthyInteractRes message from the specified reader or buffer.
         * @function decode
         * @memberof Home.HealthyInteractRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.HealthyInteractRes} HealthyInteractRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        HealthyInteractRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.HealthyInteractRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.increase = reader.double();
                    break;
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.petInfo = $root.BaseInfo.PetInfo.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.amount = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a HealthyInteractRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.HealthyInteractRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.HealthyInteractRes} HealthyInteractRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        HealthyInteractRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a HealthyInteractRes message.
         * @function verify
         * @memberof Home.HealthyInteractRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        HealthyInteractRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.increase != null && message.hasOwnProperty("increase"))
                if (typeof message.increase !== "number")
                    return "increase: number expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.petInfo != null && message.hasOwnProperty("petInfo")) {
                var error = $root.BaseInfo.PetInfo.verify(message.petInfo);
                if (error)
                    return "petInfo." + error;
            }
            if (message.amount != null && message.hasOwnProperty("amount"))
                if (!$util.isInteger(message.amount) && !(message.amount && $util.isInteger(message.amount.low) && $util.isInteger(message.amount.high)))
                    return "amount: integer|Long expected";
            return null;
        };

        return HealthyInteractRes;
    })();

    Home.HomeInfo = (function() {

        /**
         * Properties of a HomeInfo.
         * @memberof Home
         * @interface IHomeInfo
         * @property {Home.IPhotoWall|null} [photoWall] HomeInfo photoWall
         * @property {Array.<string>|null} [petsInHome] HomeInfo petsInHome
         * @property {Array.<string>|null} [unlockPetToys] HomeInfo unlockPetToys
         * @property {Object.<string,BaseInfo.ILevelToy>|null} [levelToyMap] HomeInfo levelToyMap
         */

        /**
         * Constructs a new HomeInfo.
         * @memberof Home
         * @classdesc Represents a HomeInfo.
         * @implements IHomeInfo
         * @constructor
         * @param {Home.IHomeInfo=} [properties] Properties to set
         */
        function HomeInfo(properties) {
            this.petsInHome = [];
            this.unlockPetToys = [];
            this.levelToyMap = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * HomeInfo photoWall.
         * @member {Home.IPhotoWall|null|undefined} photoWall
         * @memberof Home.HomeInfo
         * @instance
         */
        HomeInfo.prototype.photoWall = null;

        /**
         * HomeInfo petsInHome.
         * @member {Array.<string>} petsInHome
         * @memberof Home.HomeInfo
         * @instance
         */
        HomeInfo.prototype.petsInHome = $util.emptyArray;

        /**
         * HomeInfo unlockPetToys.
         * @member {Array.<string>} unlockPetToys
         * @memberof Home.HomeInfo
         * @instance
         */
        HomeInfo.prototype.unlockPetToys = $util.emptyArray;

        /**
         * HomeInfo levelToyMap.
         * @member {Object.<string,BaseInfo.ILevelToy>} levelToyMap
         * @memberof Home.HomeInfo
         * @instance
         */
        HomeInfo.prototype.levelToyMap = $util.emptyObject;

        /**
         * Creates a new HomeInfo instance using the specified properties.
         * @function create
         * @memberof Home.HomeInfo
         * @static
         * @param {Home.IHomeInfo=} [properties] Properties to set
         * @returns {Home.HomeInfo} HomeInfo instance
         */
        HomeInfo.create = function create(properties) {
            return new HomeInfo(properties);
        };

        /**
         * Encodes the specified HomeInfo message. Does not implicitly {@link Home.HomeInfo.verify|verify} messages.
         * @function encode
         * @memberof Home.HomeInfo
         * @static
         * @param {Home.IHomeInfo} message HomeInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        HomeInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.photoWall != null && message.hasOwnProperty("photoWall"))
                $root.Home.PhotoWall.encode(message.photoWall, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.petsInHome != null && message.petsInHome.length)
                for (var i = 0; i < message.petsInHome.length; ++i)
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.petsInHome[i]);
            if (message.unlockPetToys != null && message.unlockPetToys.length)
                for (var i = 0; i < message.unlockPetToys.length; ++i)
                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.unlockPetToys[i]);
            if (message.levelToyMap != null && message.hasOwnProperty("levelToyMap"))
                for (var keys = Object.keys(message.levelToyMap), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 4, wireType 2 =*/34).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.LevelToy.encode(message.levelToyMap[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified HomeInfo message, length delimited. Does not implicitly {@link Home.HomeInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.HomeInfo
         * @static
         * @param {Home.IHomeInfo} message HomeInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        HomeInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a HomeInfo message from the specified reader or buffer.
         * @function decode
         * @memberof Home.HomeInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.HomeInfo} HomeInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        HomeInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.HomeInfo(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.photoWall = $root.Home.PhotoWall.decode(reader, reader.uint32());
                    break;
                case 2:
                    if (!(message.petsInHome && message.petsInHome.length))
                        message.petsInHome = [];
                    message.petsInHome.push(reader.string());
                    break;
                case 3:
                    if (!(message.unlockPetToys && message.unlockPetToys.length))
                        message.unlockPetToys = [];
                    message.unlockPetToys.push(reader.string());
                    break;
                case 4:
                    reader.skip().pos++;
                    if (message.levelToyMap === $util.emptyObject)
                        message.levelToyMap = {};
                    key = reader.string();
                    reader.pos++;
                    message.levelToyMap[key] = $root.BaseInfo.LevelToy.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a HomeInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.HomeInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.HomeInfo} HomeInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        HomeInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a HomeInfo message.
         * @function verify
         * @memberof Home.HomeInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        HomeInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.photoWall != null && message.hasOwnProperty("photoWall")) {
                var error = $root.Home.PhotoWall.verify(message.photoWall);
                if (error)
                    return "photoWall." + error;
            }
            if (message.petsInHome != null && message.hasOwnProperty("petsInHome")) {
                if (!Array.isArray(message.petsInHome))
                    return "petsInHome: array expected";
                for (var i = 0; i < message.petsInHome.length; ++i)
                    if (!$util.isString(message.petsInHome[i]))
                        return "petsInHome: string[] expected";
            }
            if (message.unlockPetToys != null && message.hasOwnProperty("unlockPetToys")) {
                if (!Array.isArray(message.unlockPetToys))
                    return "unlockPetToys: array expected";
                for (var i = 0; i < message.unlockPetToys.length; ++i)
                    if (!$util.isString(message.unlockPetToys[i]))
                        return "unlockPetToys: string[] expected";
            }
            if (message.levelToyMap != null && message.hasOwnProperty("levelToyMap")) {
                if (!$util.isObject(message.levelToyMap))
                    return "levelToyMap: object expected";
                var key = Object.keys(message.levelToyMap);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.LevelToy.verify(message.levelToyMap[key[i]]);
                    if (error)
                        return "levelToyMap." + error;
                }
            }
            return null;
        };

        return HomeInfo;
    })();

    Home.PhotoWall = (function() {

        /**
         * Properties of a PhotoWall.
         * @memberof Home
         * @interface IPhotoWall
         * @property {Array.<string>|null} [systemPhotos] PhotoWall systemPhotos
         */

        /**
         * Constructs a new PhotoWall.
         * @memberof Home
         * @classdesc Represents a PhotoWall.
         * @implements IPhotoWall
         * @constructor
         * @param {Home.IPhotoWall=} [properties] Properties to set
         */
        function PhotoWall(properties) {
            this.systemPhotos = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PhotoWall systemPhotos.
         * @member {Array.<string>} systemPhotos
         * @memberof Home.PhotoWall
         * @instance
         */
        PhotoWall.prototype.systemPhotos = $util.emptyArray;

        /**
         * Creates a new PhotoWall instance using the specified properties.
         * @function create
         * @memberof Home.PhotoWall
         * @static
         * @param {Home.IPhotoWall=} [properties] Properties to set
         * @returns {Home.PhotoWall} PhotoWall instance
         */
        PhotoWall.create = function create(properties) {
            return new PhotoWall(properties);
        };

        /**
         * Encodes the specified PhotoWall message. Does not implicitly {@link Home.PhotoWall.verify|verify} messages.
         * @function encode
         * @memberof Home.PhotoWall
         * @static
         * @param {Home.IPhotoWall} message PhotoWall message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PhotoWall.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.systemPhotos != null && message.systemPhotos.length)
                for (var i = 0; i < message.systemPhotos.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.systemPhotos[i]);
            return writer;
        };

        /**
         * Encodes the specified PhotoWall message, length delimited. Does not implicitly {@link Home.PhotoWall.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Home.PhotoWall
         * @static
         * @param {Home.IPhotoWall} message PhotoWall message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PhotoWall.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PhotoWall message from the specified reader or buffer.
         * @function decode
         * @memberof Home.PhotoWall
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Home.PhotoWall} PhotoWall
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PhotoWall.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Home.PhotoWall();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.systemPhotos && message.systemPhotos.length))
                        message.systemPhotos = [];
                    message.systemPhotos.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PhotoWall message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Home.PhotoWall
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Home.PhotoWall} PhotoWall
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PhotoWall.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PhotoWall message.
         * @function verify
         * @memberof Home.PhotoWall
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PhotoWall.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.systemPhotos != null && message.hasOwnProperty("systemPhotos")) {
                if (!Array.isArray(message.systemPhotos))
                    return "systemPhotos: array expected";
                for (var i = 0; i < message.systemPhotos.length; ++i)
                    if (!$util.isString(message.systemPhotos[i]))
                        return "systemPhotos: string[] expected";
            }
            return null;
        };

        return PhotoWall;
    })();

    return Home;
})();

$root.Mail = (function() {

    /**
     * Namespace Mail.
     * @exports Mail
     * @namespace
     */
    var Mail = {};

    Mail.FetchAllMailsReq = (function() {

        /**
         * Properties of a FetchAllMailsReq.
         * @memberof Mail
         * @interface IFetchAllMailsReq
         */

        /**
         * Constructs a new FetchAllMailsReq.
         * @memberof Mail
         * @classdesc Represents a FetchAllMailsReq.
         * @implements IFetchAllMailsReq
         * @constructor
         * @param {Mail.IFetchAllMailsReq=} [properties] Properties to set
         */
        function FetchAllMailsReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new FetchAllMailsReq instance using the specified properties.
         * @function create
         * @memberof Mail.FetchAllMailsReq
         * @static
         * @param {Mail.IFetchAllMailsReq=} [properties] Properties to set
         * @returns {Mail.FetchAllMailsReq} FetchAllMailsReq instance
         */
        FetchAllMailsReq.create = function create(properties) {
            return new FetchAllMailsReq(properties);
        };

        /**
         * Encodes the specified FetchAllMailsReq message. Does not implicitly {@link Mail.FetchAllMailsReq.verify|verify} messages.
         * @function encode
         * @memberof Mail.FetchAllMailsReq
         * @static
         * @param {Mail.IFetchAllMailsReq} message FetchAllMailsReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchAllMailsReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified FetchAllMailsReq message, length delimited. Does not implicitly {@link Mail.FetchAllMailsReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Mail.FetchAllMailsReq
         * @static
         * @param {Mail.IFetchAllMailsReq} message FetchAllMailsReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchAllMailsReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchAllMailsReq message from the specified reader or buffer.
         * @function decode
         * @memberof Mail.FetchAllMailsReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Mail.FetchAllMailsReq} FetchAllMailsReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchAllMailsReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Mail.FetchAllMailsReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchAllMailsReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Mail.FetchAllMailsReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Mail.FetchAllMailsReq} FetchAllMailsReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchAllMailsReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchAllMailsReq message.
         * @function verify
         * @memberof Mail.FetchAllMailsReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchAllMailsReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return FetchAllMailsReq;
    })();

    Mail.FetchAllMailsRes = (function() {

        /**
         * Properties of a FetchAllMailsRes.
         * @memberof Mail
         * @interface IFetchAllMailsRes
         * @property {Array.<Mail.IMail>|null} [mails] FetchAllMailsRes mails
         */

        /**
         * Constructs a new FetchAllMailsRes.
         * @memberof Mail
         * @classdesc Represents a FetchAllMailsRes.
         * @implements IFetchAllMailsRes
         * @constructor
         * @param {Mail.IFetchAllMailsRes=} [properties] Properties to set
         */
        function FetchAllMailsRes(properties) {
            this.mails = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchAllMailsRes mails.
         * @member {Array.<Mail.IMail>} mails
         * @memberof Mail.FetchAllMailsRes
         * @instance
         */
        FetchAllMailsRes.prototype.mails = $util.emptyArray;

        /**
         * Creates a new FetchAllMailsRes instance using the specified properties.
         * @function create
         * @memberof Mail.FetchAllMailsRes
         * @static
         * @param {Mail.IFetchAllMailsRes=} [properties] Properties to set
         * @returns {Mail.FetchAllMailsRes} FetchAllMailsRes instance
         */
        FetchAllMailsRes.create = function create(properties) {
            return new FetchAllMailsRes(properties);
        };

        /**
         * Encodes the specified FetchAllMailsRes message. Does not implicitly {@link Mail.FetchAllMailsRes.verify|verify} messages.
         * @function encode
         * @memberof Mail.FetchAllMailsRes
         * @static
         * @param {Mail.IFetchAllMailsRes} message FetchAllMailsRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchAllMailsRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.mails != null && message.mails.length)
                for (var i = 0; i < message.mails.length; ++i)
                    $root.Mail.Mail.encode(message.mails[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FetchAllMailsRes message, length delimited. Does not implicitly {@link Mail.FetchAllMailsRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Mail.FetchAllMailsRes
         * @static
         * @param {Mail.IFetchAllMailsRes} message FetchAllMailsRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchAllMailsRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchAllMailsRes message from the specified reader or buffer.
         * @function decode
         * @memberof Mail.FetchAllMailsRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Mail.FetchAllMailsRes} FetchAllMailsRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchAllMailsRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Mail.FetchAllMailsRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.mails && message.mails.length))
                        message.mails = [];
                    message.mails.push($root.Mail.Mail.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchAllMailsRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Mail.FetchAllMailsRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Mail.FetchAllMailsRes} FetchAllMailsRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchAllMailsRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchAllMailsRes message.
         * @function verify
         * @memberof Mail.FetchAllMailsRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchAllMailsRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.mails != null && message.hasOwnProperty("mails")) {
                if (!Array.isArray(message.mails))
                    return "mails: array expected";
                for (var i = 0; i < message.mails.length; ++i) {
                    var error = $root.Mail.Mail.verify(message.mails[i]);
                    if (error)
                        return "mails." + error;
                }
            }
            return null;
        };

        return FetchAllMailsRes;
    })();

    Mail.ReadMailReq = (function() {

        /**
         * Properties of a ReadMailReq.
         * @memberof Mail
         * @interface IReadMailReq
         * @property {string|null} [mailId] ReadMailReq mailId
         */

        /**
         * Constructs a new ReadMailReq.
         * @memberof Mail
         * @classdesc Represents a ReadMailReq.
         * @implements IReadMailReq
         * @constructor
         * @param {Mail.IReadMailReq=} [properties] Properties to set
         */
        function ReadMailReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReadMailReq mailId.
         * @member {string} mailId
         * @memberof Mail.ReadMailReq
         * @instance
         */
        ReadMailReq.prototype.mailId = "";

        /**
         * Creates a new ReadMailReq instance using the specified properties.
         * @function create
         * @memberof Mail.ReadMailReq
         * @static
         * @param {Mail.IReadMailReq=} [properties] Properties to set
         * @returns {Mail.ReadMailReq} ReadMailReq instance
         */
        ReadMailReq.create = function create(properties) {
            return new ReadMailReq(properties);
        };

        /**
         * Encodes the specified ReadMailReq message. Does not implicitly {@link Mail.ReadMailReq.verify|verify} messages.
         * @function encode
         * @memberof Mail.ReadMailReq
         * @static
         * @param {Mail.IReadMailReq} message ReadMailReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReadMailReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.mailId != null && message.hasOwnProperty("mailId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.mailId);
            return writer;
        };

        /**
         * Encodes the specified ReadMailReq message, length delimited. Does not implicitly {@link Mail.ReadMailReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Mail.ReadMailReq
         * @static
         * @param {Mail.IReadMailReq} message ReadMailReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReadMailReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReadMailReq message from the specified reader or buffer.
         * @function decode
         * @memberof Mail.ReadMailReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Mail.ReadMailReq} ReadMailReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReadMailReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Mail.ReadMailReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.mailId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReadMailReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Mail.ReadMailReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Mail.ReadMailReq} ReadMailReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReadMailReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReadMailReq message.
         * @function verify
         * @memberof Mail.ReadMailReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReadMailReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.mailId != null && message.hasOwnProperty("mailId"))
                if (!$util.isString(message.mailId))
                    return "mailId: string expected";
            return null;
        };

        return ReadMailReq;
    })();

    Mail.ReadMailRes = (function() {

        /**
         * Properties of a ReadMailRes.
         * @memberof Mail
         * @interface IReadMailRes
         * @property {Mail.IMail|null} [mail] ReadMailRes mail
         */

        /**
         * Constructs a new ReadMailRes.
         * @memberof Mail
         * @classdesc Represents a ReadMailRes.
         * @implements IReadMailRes
         * @constructor
         * @param {Mail.IReadMailRes=} [properties] Properties to set
         */
        function ReadMailRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReadMailRes mail.
         * @member {Mail.IMail|null|undefined} mail
         * @memberof Mail.ReadMailRes
         * @instance
         */
        ReadMailRes.prototype.mail = null;

        /**
         * Creates a new ReadMailRes instance using the specified properties.
         * @function create
         * @memberof Mail.ReadMailRes
         * @static
         * @param {Mail.IReadMailRes=} [properties] Properties to set
         * @returns {Mail.ReadMailRes} ReadMailRes instance
         */
        ReadMailRes.create = function create(properties) {
            return new ReadMailRes(properties);
        };

        /**
         * Encodes the specified ReadMailRes message. Does not implicitly {@link Mail.ReadMailRes.verify|verify} messages.
         * @function encode
         * @memberof Mail.ReadMailRes
         * @static
         * @param {Mail.IReadMailRes} message ReadMailRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReadMailRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.mail != null && message.hasOwnProperty("mail"))
                $root.Mail.Mail.encode(message.mail, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified ReadMailRes message, length delimited. Does not implicitly {@link Mail.ReadMailRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Mail.ReadMailRes
         * @static
         * @param {Mail.IReadMailRes} message ReadMailRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReadMailRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReadMailRes message from the specified reader or buffer.
         * @function decode
         * @memberof Mail.ReadMailRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Mail.ReadMailRes} ReadMailRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReadMailRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Mail.ReadMailRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.mail = $root.Mail.Mail.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReadMailRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Mail.ReadMailRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Mail.ReadMailRes} ReadMailRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReadMailRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReadMailRes message.
         * @function verify
         * @memberof Mail.ReadMailRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReadMailRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.mail != null && message.hasOwnProperty("mail")) {
                var error = $root.Mail.Mail.verify(message.mail);
                if (error)
                    return "mail." + error;
            }
            return null;
        };

        return ReadMailRes;
    })();

    Mail.DeleteMailReq = (function() {

        /**
         * Properties of a DeleteMailReq.
         * @memberof Mail
         * @interface IDeleteMailReq
         * @property {string|null} [mailId] DeleteMailReq mailId
         */

        /**
         * Constructs a new DeleteMailReq.
         * @memberof Mail
         * @classdesc Represents a DeleteMailReq.
         * @implements IDeleteMailReq
         * @constructor
         * @param {Mail.IDeleteMailReq=} [properties] Properties to set
         */
        function DeleteMailReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * DeleteMailReq mailId.
         * @member {string} mailId
         * @memberof Mail.DeleteMailReq
         * @instance
         */
        DeleteMailReq.prototype.mailId = "";

        /**
         * Creates a new DeleteMailReq instance using the specified properties.
         * @function create
         * @memberof Mail.DeleteMailReq
         * @static
         * @param {Mail.IDeleteMailReq=} [properties] Properties to set
         * @returns {Mail.DeleteMailReq} DeleteMailReq instance
         */
        DeleteMailReq.create = function create(properties) {
            return new DeleteMailReq(properties);
        };

        /**
         * Encodes the specified DeleteMailReq message. Does not implicitly {@link Mail.DeleteMailReq.verify|verify} messages.
         * @function encode
         * @memberof Mail.DeleteMailReq
         * @static
         * @param {Mail.IDeleteMailReq} message DeleteMailReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DeleteMailReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.mailId != null && message.hasOwnProperty("mailId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.mailId);
            return writer;
        };

        /**
         * Encodes the specified DeleteMailReq message, length delimited. Does not implicitly {@link Mail.DeleteMailReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Mail.DeleteMailReq
         * @static
         * @param {Mail.IDeleteMailReq} message DeleteMailReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DeleteMailReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a DeleteMailReq message from the specified reader or buffer.
         * @function decode
         * @memberof Mail.DeleteMailReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Mail.DeleteMailReq} DeleteMailReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DeleteMailReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Mail.DeleteMailReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.mailId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a DeleteMailReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Mail.DeleteMailReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Mail.DeleteMailReq} DeleteMailReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DeleteMailReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a DeleteMailReq message.
         * @function verify
         * @memberof Mail.DeleteMailReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        DeleteMailReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.mailId != null && message.hasOwnProperty("mailId"))
                if (!$util.isString(message.mailId))
                    return "mailId: string expected";
            return null;
        };

        return DeleteMailReq;
    })();

    Mail.DeleteMailRes = (function() {

        /**
         * Properties of a DeleteMailRes.
         * @memberof Mail
         * @interface IDeleteMailRes
         */

        /**
         * Constructs a new DeleteMailRes.
         * @memberof Mail
         * @classdesc Represents a DeleteMailRes.
         * @implements IDeleteMailRes
         * @constructor
         * @param {Mail.IDeleteMailRes=} [properties] Properties to set
         */
        function DeleteMailRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new DeleteMailRes instance using the specified properties.
         * @function create
         * @memberof Mail.DeleteMailRes
         * @static
         * @param {Mail.IDeleteMailRes=} [properties] Properties to set
         * @returns {Mail.DeleteMailRes} DeleteMailRes instance
         */
        DeleteMailRes.create = function create(properties) {
            return new DeleteMailRes(properties);
        };

        /**
         * Encodes the specified DeleteMailRes message. Does not implicitly {@link Mail.DeleteMailRes.verify|verify} messages.
         * @function encode
         * @memberof Mail.DeleteMailRes
         * @static
         * @param {Mail.IDeleteMailRes} message DeleteMailRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DeleteMailRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified DeleteMailRes message, length delimited. Does not implicitly {@link Mail.DeleteMailRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Mail.DeleteMailRes
         * @static
         * @param {Mail.IDeleteMailRes} message DeleteMailRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DeleteMailRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a DeleteMailRes message from the specified reader or buffer.
         * @function decode
         * @memberof Mail.DeleteMailRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Mail.DeleteMailRes} DeleteMailRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DeleteMailRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Mail.DeleteMailRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a DeleteMailRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Mail.DeleteMailRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Mail.DeleteMailRes} DeleteMailRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DeleteMailRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a DeleteMailRes message.
         * @function verify
         * @memberof Mail.DeleteMailRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        DeleteMailRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return DeleteMailRes;
    })();

    Mail.DeleteReadMailsReq = (function() {

        /**
         * Properties of a DeleteReadMailsReq.
         * @memberof Mail
         * @interface IDeleteReadMailsReq
         */

        /**
         * Constructs a new DeleteReadMailsReq.
         * @memberof Mail
         * @classdesc Represents a DeleteReadMailsReq.
         * @implements IDeleteReadMailsReq
         * @constructor
         * @param {Mail.IDeleteReadMailsReq=} [properties] Properties to set
         */
        function DeleteReadMailsReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new DeleteReadMailsReq instance using the specified properties.
         * @function create
         * @memberof Mail.DeleteReadMailsReq
         * @static
         * @param {Mail.IDeleteReadMailsReq=} [properties] Properties to set
         * @returns {Mail.DeleteReadMailsReq} DeleteReadMailsReq instance
         */
        DeleteReadMailsReq.create = function create(properties) {
            return new DeleteReadMailsReq(properties);
        };

        /**
         * Encodes the specified DeleteReadMailsReq message. Does not implicitly {@link Mail.DeleteReadMailsReq.verify|verify} messages.
         * @function encode
         * @memberof Mail.DeleteReadMailsReq
         * @static
         * @param {Mail.IDeleteReadMailsReq} message DeleteReadMailsReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DeleteReadMailsReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified DeleteReadMailsReq message, length delimited. Does not implicitly {@link Mail.DeleteReadMailsReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Mail.DeleteReadMailsReq
         * @static
         * @param {Mail.IDeleteReadMailsReq} message DeleteReadMailsReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DeleteReadMailsReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a DeleteReadMailsReq message from the specified reader or buffer.
         * @function decode
         * @memberof Mail.DeleteReadMailsReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Mail.DeleteReadMailsReq} DeleteReadMailsReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DeleteReadMailsReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Mail.DeleteReadMailsReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a DeleteReadMailsReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Mail.DeleteReadMailsReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Mail.DeleteReadMailsReq} DeleteReadMailsReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DeleteReadMailsReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a DeleteReadMailsReq message.
         * @function verify
         * @memberof Mail.DeleteReadMailsReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        DeleteReadMailsReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return DeleteReadMailsReq;
    })();

    Mail.DeleteReadMailsRes = (function() {

        /**
         * Properties of a DeleteReadMailsRes.
         * @memberof Mail
         * @interface IDeleteReadMailsRes
         * @property {Array.<Mail.IMail>|null} [mails] DeleteReadMailsRes mails
         */

        /**
         * Constructs a new DeleteReadMailsRes.
         * @memberof Mail
         * @classdesc Represents a DeleteReadMailsRes.
         * @implements IDeleteReadMailsRes
         * @constructor
         * @param {Mail.IDeleteReadMailsRes=} [properties] Properties to set
         */
        function DeleteReadMailsRes(properties) {
            this.mails = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * DeleteReadMailsRes mails.
         * @member {Array.<Mail.IMail>} mails
         * @memberof Mail.DeleteReadMailsRes
         * @instance
         */
        DeleteReadMailsRes.prototype.mails = $util.emptyArray;

        /**
         * Creates a new DeleteReadMailsRes instance using the specified properties.
         * @function create
         * @memberof Mail.DeleteReadMailsRes
         * @static
         * @param {Mail.IDeleteReadMailsRes=} [properties] Properties to set
         * @returns {Mail.DeleteReadMailsRes} DeleteReadMailsRes instance
         */
        DeleteReadMailsRes.create = function create(properties) {
            return new DeleteReadMailsRes(properties);
        };

        /**
         * Encodes the specified DeleteReadMailsRes message. Does not implicitly {@link Mail.DeleteReadMailsRes.verify|verify} messages.
         * @function encode
         * @memberof Mail.DeleteReadMailsRes
         * @static
         * @param {Mail.IDeleteReadMailsRes} message DeleteReadMailsRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DeleteReadMailsRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.mails != null && message.mails.length)
                for (var i = 0; i < message.mails.length; ++i)
                    $root.Mail.Mail.encode(message.mails[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified DeleteReadMailsRes message, length delimited. Does not implicitly {@link Mail.DeleteReadMailsRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Mail.DeleteReadMailsRes
         * @static
         * @param {Mail.IDeleteReadMailsRes} message DeleteReadMailsRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DeleteReadMailsRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a DeleteReadMailsRes message from the specified reader or buffer.
         * @function decode
         * @memberof Mail.DeleteReadMailsRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Mail.DeleteReadMailsRes} DeleteReadMailsRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DeleteReadMailsRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Mail.DeleteReadMailsRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.mails && message.mails.length))
                        message.mails = [];
                    message.mails.push($root.Mail.Mail.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a DeleteReadMailsRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Mail.DeleteReadMailsRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Mail.DeleteReadMailsRes} DeleteReadMailsRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DeleteReadMailsRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a DeleteReadMailsRes message.
         * @function verify
         * @memberof Mail.DeleteReadMailsRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        DeleteReadMailsRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.mails != null && message.hasOwnProperty("mails")) {
                if (!Array.isArray(message.mails))
                    return "mails: array expected";
                for (var i = 0; i < message.mails.length; ++i) {
                    var error = $root.Mail.Mail.verify(message.mails[i]);
                    if (error)
                        return "mails." + error;
                }
            }
            return null;
        };

        return DeleteReadMailsRes;
    })();

    Mail.ReceiveMailRewardsReq = (function() {

        /**
         * Properties of a ReceiveMailRewardsReq.
         * @memberof Mail
         * @interface IReceiveMailRewardsReq
         * @property {string|null} [mailId] ReceiveMailRewardsReq mailId
         */

        /**
         * Constructs a new ReceiveMailRewardsReq.
         * @memberof Mail
         * @classdesc Represents a ReceiveMailRewardsReq.
         * @implements IReceiveMailRewardsReq
         * @constructor
         * @param {Mail.IReceiveMailRewardsReq=} [properties] Properties to set
         */
        function ReceiveMailRewardsReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReceiveMailRewardsReq mailId.
         * @member {string} mailId
         * @memberof Mail.ReceiveMailRewardsReq
         * @instance
         */
        ReceiveMailRewardsReq.prototype.mailId = "";

        /**
         * Creates a new ReceiveMailRewardsReq instance using the specified properties.
         * @function create
         * @memberof Mail.ReceiveMailRewardsReq
         * @static
         * @param {Mail.IReceiveMailRewardsReq=} [properties] Properties to set
         * @returns {Mail.ReceiveMailRewardsReq} ReceiveMailRewardsReq instance
         */
        ReceiveMailRewardsReq.create = function create(properties) {
            return new ReceiveMailRewardsReq(properties);
        };

        /**
         * Encodes the specified ReceiveMailRewardsReq message. Does not implicitly {@link Mail.ReceiveMailRewardsReq.verify|verify} messages.
         * @function encode
         * @memberof Mail.ReceiveMailRewardsReq
         * @static
         * @param {Mail.IReceiveMailRewardsReq} message ReceiveMailRewardsReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveMailRewardsReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.mailId != null && message.hasOwnProperty("mailId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.mailId);
            return writer;
        };

        /**
         * Encodes the specified ReceiveMailRewardsReq message, length delimited. Does not implicitly {@link Mail.ReceiveMailRewardsReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Mail.ReceiveMailRewardsReq
         * @static
         * @param {Mail.IReceiveMailRewardsReq} message ReceiveMailRewardsReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveMailRewardsReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveMailRewardsReq message from the specified reader or buffer.
         * @function decode
         * @memberof Mail.ReceiveMailRewardsReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Mail.ReceiveMailRewardsReq} ReceiveMailRewardsReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveMailRewardsReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Mail.ReceiveMailRewardsReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.mailId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveMailRewardsReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Mail.ReceiveMailRewardsReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Mail.ReceiveMailRewardsReq} ReceiveMailRewardsReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveMailRewardsReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveMailRewardsReq message.
         * @function verify
         * @memberof Mail.ReceiveMailRewardsReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveMailRewardsReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.mailId != null && message.hasOwnProperty("mailId"))
                if (!$util.isString(message.mailId))
                    return "mailId: string expected";
            return null;
        };

        return ReceiveMailRewardsReq;
    })();

    Mail.ReceiveMailRewardsRes = (function() {

        /**
         * Properties of a ReceiveMailRewardsRes.
         * @memberof Mail
         * @interface IReceiveMailRewardsRes
         * @property {Array.<Mail.IMail>|null} [mails] ReceiveMailRewardsRes mails
         * @property {BaseInfo.IRewards|null} [rewards] ReceiveMailRewardsRes rewards
         */

        /**
         * Constructs a new ReceiveMailRewardsRes.
         * @memberof Mail
         * @classdesc Represents a ReceiveMailRewardsRes.
         * @implements IReceiveMailRewardsRes
         * @constructor
         * @param {Mail.IReceiveMailRewardsRes=} [properties] Properties to set
         */
        function ReceiveMailRewardsRes(properties) {
            this.mails = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReceiveMailRewardsRes mails.
         * @member {Array.<Mail.IMail>} mails
         * @memberof Mail.ReceiveMailRewardsRes
         * @instance
         */
        ReceiveMailRewardsRes.prototype.mails = $util.emptyArray;

        /**
         * ReceiveMailRewardsRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Mail.ReceiveMailRewardsRes
         * @instance
         */
        ReceiveMailRewardsRes.prototype.rewards = null;

        /**
         * Creates a new ReceiveMailRewardsRes instance using the specified properties.
         * @function create
         * @memberof Mail.ReceiveMailRewardsRes
         * @static
         * @param {Mail.IReceiveMailRewardsRes=} [properties] Properties to set
         * @returns {Mail.ReceiveMailRewardsRes} ReceiveMailRewardsRes instance
         */
        ReceiveMailRewardsRes.create = function create(properties) {
            return new ReceiveMailRewardsRes(properties);
        };

        /**
         * Encodes the specified ReceiveMailRewardsRes message. Does not implicitly {@link Mail.ReceiveMailRewardsRes.verify|verify} messages.
         * @function encode
         * @memberof Mail.ReceiveMailRewardsRes
         * @static
         * @param {Mail.IReceiveMailRewardsRes} message ReceiveMailRewardsRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveMailRewardsRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.mails != null && message.mails.length)
                for (var i = 0; i < message.mails.length; ++i)
                    $root.Mail.Mail.encode(message.mails[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified ReceiveMailRewardsRes message, length delimited. Does not implicitly {@link Mail.ReceiveMailRewardsRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Mail.ReceiveMailRewardsRes
         * @static
         * @param {Mail.IReceiveMailRewardsRes} message ReceiveMailRewardsRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveMailRewardsRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveMailRewardsRes message from the specified reader or buffer.
         * @function decode
         * @memberof Mail.ReceiveMailRewardsRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Mail.ReceiveMailRewardsRes} ReceiveMailRewardsRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveMailRewardsRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Mail.ReceiveMailRewardsRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.mails && message.mails.length))
                        message.mails = [];
                    message.mails.push($root.Mail.Mail.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveMailRewardsRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Mail.ReceiveMailRewardsRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Mail.ReceiveMailRewardsRes} ReceiveMailRewardsRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveMailRewardsRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveMailRewardsRes message.
         * @function verify
         * @memberof Mail.ReceiveMailRewardsRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveMailRewardsRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.mails != null && message.hasOwnProperty("mails")) {
                if (!Array.isArray(message.mails))
                    return "mails: array expected";
                for (var i = 0; i < message.mails.length; ++i) {
                    var error = $root.Mail.Mail.verify(message.mails[i]);
                    if (error)
                        return "mails." + error;
                }
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            return null;
        };

        return ReceiveMailRewardsRes;
    })();

    Mail.Mail = (function() {

        /**
         * Properties of a Mail.
         * @memberof Mail
         * @interface IMail
         * @property {string|null} [title] Mail title
         * @property {string|null} [content] Mail content
         * @property {number|Long|null} [sendTime] Mail sendTime
         * @property {number|Long|null} [expireTime] Mail expireTime
         * @property {boolean|null} [read] Mail read
         * @property {boolean|null} [receive] Mail receive
         * @property {BaseInfo.IRewards|null} [mailItems] Mail mailItems
         * @property {string|null} [id] Mail id
         * @property {Object.<string,string>|null} [customData] Mail customData
         * @property {string|null} [systemId] Mail systemId
         */

        /**
         * Constructs a new Mail.
         * @memberof Mail
         * @classdesc Represents a Mail.
         * @implements IMail
         * @constructor
         * @param {Mail.IMail=} [properties] Properties to set
         */
        function Mail(properties) {
            this.customData = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Mail title.
         * @member {string} title
         * @memberof Mail.Mail
         * @instance
         */
        Mail.prototype.title = "";

        /**
         * Mail content.
         * @member {string} content
         * @memberof Mail.Mail
         * @instance
         */
        Mail.prototype.content = "";

        /**
         * Mail sendTime.
         * @member {number|Long} sendTime
         * @memberof Mail.Mail
         * @instance
         */
        Mail.prototype.sendTime = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Mail expireTime.
         * @member {number|Long} expireTime
         * @memberof Mail.Mail
         * @instance
         */
        Mail.prototype.expireTime = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Mail read.
         * @member {boolean} read
         * @memberof Mail.Mail
         * @instance
         */
        Mail.prototype.read = false;

        /**
         * Mail receive.
         * @member {boolean} receive
         * @memberof Mail.Mail
         * @instance
         */
        Mail.prototype.receive = false;

        /**
         * Mail mailItems.
         * @member {BaseInfo.IRewards|null|undefined} mailItems
         * @memberof Mail.Mail
         * @instance
         */
        Mail.prototype.mailItems = null;

        /**
         * Mail id.
         * @member {string} id
         * @memberof Mail.Mail
         * @instance
         */
        Mail.prototype.id = "";

        /**
         * Mail customData.
         * @member {Object.<string,string>} customData
         * @memberof Mail.Mail
         * @instance
         */
        Mail.prototype.customData = $util.emptyObject;

        /**
         * Mail systemId.
         * @member {string} systemId
         * @memberof Mail.Mail
         * @instance
         */
        Mail.prototype.systemId = "";

        /**
         * Creates a new Mail instance using the specified properties.
         * @function create
         * @memberof Mail.Mail
         * @static
         * @param {Mail.IMail=} [properties] Properties to set
         * @returns {Mail.Mail} Mail instance
         */
        Mail.create = function create(properties) {
            return new Mail(properties);
        };

        /**
         * Encodes the specified Mail message. Does not implicitly {@link Mail.Mail.verify|verify} messages.
         * @function encode
         * @memberof Mail.Mail
         * @static
         * @param {Mail.IMail} message Mail message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Mail.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.title != null && message.hasOwnProperty("title"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.title);
            if (message.content != null && message.hasOwnProperty("content"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.content);
            if (message.sendTime != null && message.hasOwnProperty("sendTime"))
                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.sendTime);
            if (message.expireTime != null && message.hasOwnProperty("expireTime"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.expireTime);
            if (message.read != null && message.hasOwnProperty("read"))
                writer.uint32(/* id 5, wireType 0 =*/40).bool(message.read);
            if (message.receive != null && message.hasOwnProperty("receive"))
                writer.uint32(/* id 6, wireType 0 =*/48).bool(message.receive);
            if (message.mailItems != null && message.hasOwnProperty("mailItems"))
                $root.BaseInfo.Rewards.encode(message.mailItems, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
            if (message.id != null && message.hasOwnProperty("id"))
                writer.uint32(/* id 8, wireType 2 =*/66).string(message.id);
            if (message.customData != null && message.hasOwnProperty("customData"))
                for (var keys = Object.keys(message.customData), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 9, wireType 2 =*/74).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.customData[keys[i]]).ldelim();
            if (message.systemId != null && message.hasOwnProperty("systemId"))
                writer.uint32(/* id 10, wireType 2 =*/82).string(message.systemId);
            return writer;
        };

        /**
         * Encodes the specified Mail message, length delimited. Does not implicitly {@link Mail.Mail.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Mail.Mail
         * @static
         * @param {Mail.IMail} message Mail message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Mail.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Mail message from the specified reader or buffer.
         * @function decode
         * @memberof Mail.Mail
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Mail.Mail} Mail
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Mail.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Mail.Mail(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.title = reader.string();
                    break;
                case 2:
                    message.content = reader.string();
                    break;
                case 3:
                    message.sendTime = reader.int64();
                    break;
                case 4:
                    message.expireTime = reader.int64();
                    break;
                case 5:
                    message.read = reader.bool();
                    break;
                case 6:
                    message.receive = reader.bool();
                    break;
                case 7:
                    message.mailItems = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 8:
                    message.id = reader.string();
                    break;
                case 9:
                    reader.skip().pos++;
                    if (message.customData === $util.emptyObject)
                        message.customData = {};
                    key = reader.string();
                    reader.pos++;
                    message.customData[key] = reader.string();
                    break;
                case 10:
                    message.systemId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Mail message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Mail.Mail
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Mail.Mail} Mail
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Mail.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Mail message.
         * @function verify
         * @memberof Mail.Mail
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Mail.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.title != null && message.hasOwnProperty("title"))
                if (!$util.isString(message.title))
                    return "title: string expected";
            if (message.content != null && message.hasOwnProperty("content"))
                if (!$util.isString(message.content))
                    return "content: string expected";
            if (message.sendTime != null && message.hasOwnProperty("sendTime"))
                if (!$util.isInteger(message.sendTime) && !(message.sendTime && $util.isInteger(message.sendTime.low) && $util.isInteger(message.sendTime.high)))
                    return "sendTime: integer|Long expected";
            if (message.expireTime != null && message.hasOwnProperty("expireTime"))
                if (!$util.isInteger(message.expireTime) && !(message.expireTime && $util.isInteger(message.expireTime.low) && $util.isInteger(message.expireTime.high)))
                    return "expireTime: integer|Long expected";
            if (message.read != null && message.hasOwnProperty("read"))
                if (typeof message.read !== "boolean")
                    return "read: boolean expected";
            if (message.receive != null && message.hasOwnProperty("receive"))
                if (typeof message.receive !== "boolean")
                    return "receive: boolean expected";
            if (message.mailItems != null && message.hasOwnProperty("mailItems")) {
                var error = $root.BaseInfo.Rewards.verify(message.mailItems);
                if (error)
                    return "mailItems." + error;
            }
            if (message.id != null && message.hasOwnProperty("id"))
                if (!$util.isString(message.id))
                    return "id: string expected";
            if (message.customData != null && message.hasOwnProperty("customData")) {
                if (!$util.isObject(message.customData))
                    return "customData: object expected";
                var key = Object.keys(message.customData);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.customData[key[i]]))
                        return "customData: string{k:string} expected";
            }
            if (message.systemId != null && message.hasOwnProperty("systemId"))
                if (!$util.isString(message.systemId))
                    return "systemId: string expected";
            return null;
        };

        return Mail;
    })();

    return Mail;
})();

$root.Entrust = (function() {

    /**
     * Namespace Entrust.
     * @exports Entrust
     * @namespace
     */
    var Entrust = {};

    Entrust.GetEntrustReq = (function() {

        /**
         * Properties of a GetEntrustReq.
         * @memberof Entrust
         * @interface IGetEntrustReq
         */

        /**
         * Constructs a new GetEntrustReq.
         * @memberof Entrust
         * @classdesc Represents a GetEntrustReq.
         * @implements IGetEntrustReq
         * @constructor
         * @param {Entrust.IGetEntrustReq=} [properties] Properties to set
         */
        function GetEntrustReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetEntrustReq instance using the specified properties.
         * @function create
         * @memberof Entrust.GetEntrustReq
         * @static
         * @param {Entrust.IGetEntrustReq=} [properties] Properties to set
         * @returns {Entrust.GetEntrustReq} GetEntrustReq instance
         */
        GetEntrustReq.create = function create(properties) {
            return new GetEntrustReq(properties);
        };

        /**
         * Encodes the specified GetEntrustReq message. Does not implicitly {@link Entrust.GetEntrustReq.verify|verify} messages.
         * @function encode
         * @memberof Entrust.GetEntrustReq
         * @static
         * @param {Entrust.IGetEntrustReq} message GetEntrustReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetEntrustReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetEntrustReq message, length delimited. Does not implicitly {@link Entrust.GetEntrustReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Entrust.GetEntrustReq
         * @static
         * @param {Entrust.IGetEntrustReq} message GetEntrustReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetEntrustReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetEntrustReq message from the specified reader or buffer.
         * @function decode
         * @memberof Entrust.GetEntrustReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Entrust.GetEntrustReq} GetEntrustReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetEntrustReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Entrust.GetEntrustReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetEntrustReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Entrust.GetEntrustReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Entrust.GetEntrustReq} GetEntrustReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetEntrustReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetEntrustReq message.
         * @function verify
         * @memberof Entrust.GetEntrustReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetEntrustReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetEntrustReq;
    })();

    Entrust.GetEntrustRes = (function() {

        /**
         * Properties of a GetEntrustRes.
         * @memberof Entrust
         * @interface IGetEntrustRes
         * @property {BaseInfo.IEntrusts|null} [entrusts] GetEntrustRes entrusts
         * @property {number|null} [registerDays] GetEntrustRes registerDays
         */

        /**
         * Constructs a new GetEntrustRes.
         * @memberof Entrust
         * @classdesc Represents a GetEntrustRes.
         * @implements IGetEntrustRes
         * @constructor
         * @param {Entrust.IGetEntrustRes=} [properties] Properties to set
         */
        function GetEntrustRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetEntrustRes entrusts.
         * @member {BaseInfo.IEntrusts|null|undefined} entrusts
         * @memberof Entrust.GetEntrustRes
         * @instance
         */
        GetEntrustRes.prototype.entrusts = null;

        /**
         * GetEntrustRes registerDays.
         * @member {number} registerDays
         * @memberof Entrust.GetEntrustRes
         * @instance
         */
        GetEntrustRes.prototype.registerDays = 0;

        /**
         * Creates a new GetEntrustRes instance using the specified properties.
         * @function create
         * @memberof Entrust.GetEntrustRes
         * @static
         * @param {Entrust.IGetEntrustRes=} [properties] Properties to set
         * @returns {Entrust.GetEntrustRes} GetEntrustRes instance
         */
        GetEntrustRes.create = function create(properties) {
            return new GetEntrustRes(properties);
        };

        /**
         * Encodes the specified GetEntrustRes message. Does not implicitly {@link Entrust.GetEntrustRes.verify|verify} messages.
         * @function encode
         * @memberof Entrust.GetEntrustRes
         * @static
         * @param {Entrust.IGetEntrustRes} message GetEntrustRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetEntrustRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.entrusts != null && message.hasOwnProperty("entrusts"))
                $root.BaseInfo.Entrusts.encode(message.entrusts, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.registerDays != null && message.hasOwnProperty("registerDays"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.registerDays);
            return writer;
        };

        /**
         * Encodes the specified GetEntrustRes message, length delimited. Does not implicitly {@link Entrust.GetEntrustRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Entrust.GetEntrustRes
         * @static
         * @param {Entrust.IGetEntrustRes} message GetEntrustRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetEntrustRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetEntrustRes message from the specified reader or buffer.
         * @function decode
         * @memberof Entrust.GetEntrustRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Entrust.GetEntrustRes} GetEntrustRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetEntrustRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Entrust.GetEntrustRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.entrusts = $root.BaseInfo.Entrusts.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.registerDays = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetEntrustRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Entrust.GetEntrustRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Entrust.GetEntrustRes} GetEntrustRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetEntrustRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetEntrustRes message.
         * @function verify
         * @memberof Entrust.GetEntrustRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetEntrustRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.entrusts != null && message.hasOwnProperty("entrusts")) {
                var error = $root.BaseInfo.Entrusts.verify(message.entrusts);
                if (error)
                    return "entrusts." + error;
            }
            if (message.registerDays != null && message.hasOwnProperty("registerDays"))
                if (!$util.isInteger(message.registerDays))
                    return "registerDays: integer expected";
            return null;
        };

        return GetEntrustRes;
    })();

    Entrust.AcceptEntrustReq = (function() {

        /**
         * Properties of an AcceptEntrustReq.
         * @memberof Entrust
         * @interface IAcceptEntrustReq
         * @property {string|null} [listId] AcceptEntrustReq listId
         */

        /**
         * Constructs a new AcceptEntrustReq.
         * @memberof Entrust
         * @classdesc Represents an AcceptEntrustReq.
         * @implements IAcceptEntrustReq
         * @constructor
         * @param {Entrust.IAcceptEntrustReq=} [properties] Properties to set
         */
        function AcceptEntrustReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AcceptEntrustReq listId.
         * @member {string} listId
         * @memberof Entrust.AcceptEntrustReq
         * @instance
         */
        AcceptEntrustReq.prototype.listId = "";

        /**
         * Creates a new AcceptEntrustReq instance using the specified properties.
         * @function create
         * @memberof Entrust.AcceptEntrustReq
         * @static
         * @param {Entrust.IAcceptEntrustReq=} [properties] Properties to set
         * @returns {Entrust.AcceptEntrustReq} AcceptEntrustReq instance
         */
        AcceptEntrustReq.create = function create(properties) {
            return new AcceptEntrustReq(properties);
        };

        /**
         * Encodes the specified AcceptEntrustReq message. Does not implicitly {@link Entrust.AcceptEntrustReq.verify|verify} messages.
         * @function encode
         * @memberof Entrust.AcceptEntrustReq
         * @static
         * @param {Entrust.IAcceptEntrustReq} message AcceptEntrustReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AcceptEntrustReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.listId != null && message.hasOwnProperty("listId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.listId);
            return writer;
        };

        /**
         * Encodes the specified AcceptEntrustReq message, length delimited. Does not implicitly {@link Entrust.AcceptEntrustReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Entrust.AcceptEntrustReq
         * @static
         * @param {Entrust.IAcceptEntrustReq} message AcceptEntrustReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AcceptEntrustReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AcceptEntrustReq message from the specified reader or buffer.
         * @function decode
         * @memberof Entrust.AcceptEntrustReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Entrust.AcceptEntrustReq} AcceptEntrustReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AcceptEntrustReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Entrust.AcceptEntrustReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.listId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AcceptEntrustReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Entrust.AcceptEntrustReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Entrust.AcceptEntrustReq} AcceptEntrustReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AcceptEntrustReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AcceptEntrustReq message.
         * @function verify
         * @memberof Entrust.AcceptEntrustReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AcceptEntrustReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.listId != null && message.hasOwnProperty("listId"))
                if (!$util.isString(message.listId))
                    return "listId: string expected";
            return null;
        };

        return AcceptEntrustReq;
    })();

    Entrust.AcceptEntrustRes = (function() {

        /**
         * Properties of an AcceptEntrustRes.
         * @memberof Entrust
         * @interface IAcceptEntrustRes
         * @property {BaseInfo.IEntrust|null} [entrust] AcceptEntrustRes entrust
         */

        /**
         * Constructs a new AcceptEntrustRes.
         * @memberof Entrust
         * @classdesc Represents an AcceptEntrustRes.
         * @implements IAcceptEntrustRes
         * @constructor
         * @param {Entrust.IAcceptEntrustRes=} [properties] Properties to set
         */
        function AcceptEntrustRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AcceptEntrustRes entrust.
         * @member {BaseInfo.IEntrust|null|undefined} entrust
         * @memberof Entrust.AcceptEntrustRes
         * @instance
         */
        AcceptEntrustRes.prototype.entrust = null;

        /**
         * Creates a new AcceptEntrustRes instance using the specified properties.
         * @function create
         * @memberof Entrust.AcceptEntrustRes
         * @static
         * @param {Entrust.IAcceptEntrustRes=} [properties] Properties to set
         * @returns {Entrust.AcceptEntrustRes} AcceptEntrustRes instance
         */
        AcceptEntrustRes.create = function create(properties) {
            return new AcceptEntrustRes(properties);
        };

        /**
         * Encodes the specified AcceptEntrustRes message. Does not implicitly {@link Entrust.AcceptEntrustRes.verify|verify} messages.
         * @function encode
         * @memberof Entrust.AcceptEntrustRes
         * @static
         * @param {Entrust.IAcceptEntrustRes} message AcceptEntrustRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AcceptEntrustRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.entrust != null && message.hasOwnProperty("entrust"))
                $root.BaseInfo.Entrust.encode(message.entrust, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified AcceptEntrustRes message, length delimited. Does not implicitly {@link Entrust.AcceptEntrustRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Entrust.AcceptEntrustRes
         * @static
         * @param {Entrust.IAcceptEntrustRes} message AcceptEntrustRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AcceptEntrustRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AcceptEntrustRes message from the specified reader or buffer.
         * @function decode
         * @memberof Entrust.AcceptEntrustRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Entrust.AcceptEntrustRes} AcceptEntrustRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AcceptEntrustRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Entrust.AcceptEntrustRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.entrust = $root.BaseInfo.Entrust.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AcceptEntrustRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Entrust.AcceptEntrustRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Entrust.AcceptEntrustRes} AcceptEntrustRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AcceptEntrustRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AcceptEntrustRes message.
         * @function verify
         * @memberof Entrust.AcceptEntrustRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AcceptEntrustRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.entrust != null && message.hasOwnProperty("entrust")) {
                var error = $root.BaseInfo.Entrust.verify(message.entrust);
                if (error)
                    return "entrust." + error;
            }
            return null;
        };

        return AcceptEntrustRes;
    })();

    Entrust.ReceiveRewardsReq = (function() {

        /**
         * Properties of a ReceiveRewardsReq.
         * @memberof Entrust
         * @interface IReceiveRewardsReq
         * @property {string|null} [listId] ReceiveRewardsReq listId
         */

        /**
         * Constructs a new ReceiveRewardsReq.
         * @memberof Entrust
         * @classdesc Represents a ReceiveRewardsReq.
         * @implements IReceiveRewardsReq
         * @constructor
         * @param {Entrust.IReceiveRewardsReq=} [properties] Properties to set
         */
        function ReceiveRewardsReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReceiveRewardsReq listId.
         * @member {string} listId
         * @memberof Entrust.ReceiveRewardsReq
         * @instance
         */
        ReceiveRewardsReq.prototype.listId = "";

        /**
         * Creates a new ReceiveRewardsReq instance using the specified properties.
         * @function create
         * @memberof Entrust.ReceiveRewardsReq
         * @static
         * @param {Entrust.IReceiveRewardsReq=} [properties] Properties to set
         * @returns {Entrust.ReceiveRewardsReq} ReceiveRewardsReq instance
         */
        ReceiveRewardsReq.create = function create(properties) {
            return new ReceiveRewardsReq(properties);
        };

        /**
         * Encodes the specified ReceiveRewardsReq message. Does not implicitly {@link Entrust.ReceiveRewardsReq.verify|verify} messages.
         * @function encode
         * @memberof Entrust.ReceiveRewardsReq
         * @static
         * @param {Entrust.IReceiveRewardsReq} message ReceiveRewardsReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveRewardsReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.listId != null && message.hasOwnProperty("listId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.listId);
            return writer;
        };

        /**
         * Encodes the specified ReceiveRewardsReq message, length delimited. Does not implicitly {@link Entrust.ReceiveRewardsReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Entrust.ReceiveRewardsReq
         * @static
         * @param {Entrust.IReceiveRewardsReq} message ReceiveRewardsReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveRewardsReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveRewardsReq message from the specified reader or buffer.
         * @function decode
         * @memberof Entrust.ReceiveRewardsReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Entrust.ReceiveRewardsReq} ReceiveRewardsReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveRewardsReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Entrust.ReceiveRewardsReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.listId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveRewardsReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Entrust.ReceiveRewardsReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Entrust.ReceiveRewardsReq} ReceiveRewardsReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveRewardsReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveRewardsReq message.
         * @function verify
         * @memberof Entrust.ReceiveRewardsReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveRewardsReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.listId != null && message.hasOwnProperty("listId"))
                if (!$util.isString(message.listId))
                    return "listId: string expected";
            return null;
        };

        return ReceiveRewardsReq;
    })();

    Entrust.ReceiveRewardsRes = (function() {

        /**
         * Properties of a ReceiveRewardsRes.
         * @memberof Entrust
         * @interface IReceiveRewardsRes
         * @property {BaseInfo.ICurrencyBag|null} [bag] ReceiveRewardsRes bag
         * @property {BaseInfo.IRewards|null} [rewards] ReceiveRewardsRes rewards
         * @property {BaseInfo.IEntrusts|null} [entrusts] ReceiveRewardsRes entrusts
         */

        /**
         * Constructs a new ReceiveRewardsRes.
         * @memberof Entrust
         * @classdesc Represents a ReceiveRewardsRes.
         * @implements IReceiveRewardsRes
         * @constructor
         * @param {Entrust.IReceiveRewardsRes=} [properties] Properties to set
         */
        function ReceiveRewardsRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReceiveRewardsRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Entrust.ReceiveRewardsRes
         * @instance
         */
        ReceiveRewardsRes.prototype.bag = null;

        /**
         * ReceiveRewardsRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Entrust.ReceiveRewardsRes
         * @instance
         */
        ReceiveRewardsRes.prototype.rewards = null;

        /**
         * ReceiveRewardsRes entrusts.
         * @member {BaseInfo.IEntrusts|null|undefined} entrusts
         * @memberof Entrust.ReceiveRewardsRes
         * @instance
         */
        ReceiveRewardsRes.prototype.entrusts = null;

        /**
         * Creates a new ReceiveRewardsRes instance using the specified properties.
         * @function create
         * @memberof Entrust.ReceiveRewardsRes
         * @static
         * @param {Entrust.IReceiveRewardsRes=} [properties] Properties to set
         * @returns {Entrust.ReceiveRewardsRes} ReceiveRewardsRes instance
         */
        ReceiveRewardsRes.create = function create(properties) {
            return new ReceiveRewardsRes(properties);
        };

        /**
         * Encodes the specified ReceiveRewardsRes message. Does not implicitly {@link Entrust.ReceiveRewardsRes.verify|verify} messages.
         * @function encode
         * @memberof Entrust.ReceiveRewardsRes
         * @static
         * @param {Entrust.IReceiveRewardsRes} message ReceiveRewardsRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveRewardsRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.entrusts != null && message.hasOwnProperty("entrusts"))
                $root.BaseInfo.Entrusts.encode(message.entrusts, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified ReceiveRewardsRes message, length delimited. Does not implicitly {@link Entrust.ReceiveRewardsRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Entrust.ReceiveRewardsRes
         * @static
         * @param {Entrust.IReceiveRewardsRes} message ReceiveRewardsRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveRewardsRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveRewardsRes message from the specified reader or buffer.
         * @function decode
         * @memberof Entrust.ReceiveRewardsRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Entrust.ReceiveRewardsRes} ReceiveRewardsRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveRewardsRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Entrust.ReceiveRewardsRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.entrusts = $root.BaseInfo.Entrusts.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveRewardsRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Entrust.ReceiveRewardsRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Entrust.ReceiveRewardsRes} ReceiveRewardsRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveRewardsRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveRewardsRes message.
         * @function verify
         * @memberof Entrust.ReceiveRewardsRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveRewardsRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.entrusts != null && message.hasOwnProperty("entrusts")) {
                var error = $root.BaseInfo.Entrusts.verify(message.entrusts);
                if (error)
                    return "entrusts." + error;
            }
            return null;
        };

        return ReceiveRewardsRes;
    })();

    return Entrust;
})();

$root.Suggest = (function() {

    /**
     * Namespace Suggest.
     * @exports Suggest
     * @namespace
     */
    var Suggest = {};

    Suggest.SendSuggestReq = (function() {

        /**
         * Properties of a SendSuggestReq.
         * @memberof Suggest
         * @interface ISendSuggestReq
         * @property {string|null} [content] SendSuggestReq content
         */

        /**
         * Constructs a new SendSuggestReq.
         * @memberof Suggest
         * @classdesc Represents a SendSuggestReq.
         * @implements ISendSuggestReq
         * @constructor
         * @param {Suggest.ISendSuggestReq=} [properties] Properties to set
         */
        function SendSuggestReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * SendSuggestReq content.
         * @member {string} content
         * @memberof Suggest.SendSuggestReq
         * @instance
         */
        SendSuggestReq.prototype.content = "";

        /**
         * Creates a new SendSuggestReq instance using the specified properties.
         * @function create
         * @memberof Suggest.SendSuggestReq
         * @static
         * @param {Suggest.ISendSuggestReq=} [properties] Properties to set
         * @returns {Suggest.SendSuggestReq} SendSuggestReq instance
         */
        SendSuggestReq.create = function create(properties) {
            return new SendSuggestReq(properties);
        };

        /**
         * Encodes the specified SendSuggestReq message. Does not implicitly {@link Suggest.SendSuggestReq.verify|verify} messages.
         * @function encode
         * @memberof Suggest.SendSuggestReq
         * @static
         * @param {Suggest.ISendSuggestReq} message SendSuggestReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SendSuggestReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.content != null && message.hasOwnProperty("content"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.content);
            return writer;
        };

        /**
         * Encodes the specified SendSuggestReq message, length delimited. Does not implicitly {@link Suggest.SendSuggestReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Suggest.SendSuggestReq
         * @static
         * @param {Suggest.ISendSuggestReq} message SendSuggestReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SendSuggestReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a SendSuggestReq message from the specified reader or buffer.
         * @function decode
         * @memberof Suggest.SendSuggestReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Suggest.SendSuggestReq} SendSuggestReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SendSuggestReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Suggest.SendSuggestReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.content = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a SendSuggestReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Suggest.SendSuggestReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Suggest.SendSuggestReq} SendSuggestReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SendSuggestReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a SendSuggestReq message.
         * @function verify
         * @memberof Suggest.SendSuggestReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        SendSuggestReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.content != null && message.hasOwnProperty("content"))
                if (!$util.isString(message.content))
                    return "content: string expected";
            return null;
        };

        return SendSuggestReq;
    })();

    Suggest.SendSuggestRes = (function() {

        /**
         * Properties of a SendSuggestRes.
         * @memberof Suggest
         * @interface ISendSuggestRes
         */

        /**
         * Constructs a new SendSuggestRes.
         * @memberof Suggest
         * @classdesc Represents a SendSuggestRes.
         * @implements ISendSuggestRes
         * @constructor
         * @param {Suggest.ISendSuggestRes=} [properties] Properties to set
         */
        function SendSuggestRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new SendSuggestRes instance using the specified properties.
         * @function create
         * @memberof Suggest.SendSuggestRes
         * @static
         * @param {Suggest.ISendSuggestRes=} [properties] Properties to set
         * @returns {Suggest.SendSuggestRes} SendSuggestRes instance
         */
        SendSuggestRes.create = function create(properties) {
            return new SendSuggestRes(properties);
        };

        /**
         * Encodes the specified SendSuggestRes message. Does not implicitly {@link Suggest.SendSuggestRes.verify|verify} messages.
         * @function encode
         * @memberof Suggest.SendSuggestRes
         * @static
         * @param {Suggest.ISendSuggestRes} message SendSuggestRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SendSuggestRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified SendSuggestRes message, length delimited. Does not implicitly {@link Suggest.SendSuggestRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Suggest.SendSuggestRes
         * @static
         * @param {Suggest.ISendSuggestRes} message SendSuggestRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SendSuggestRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a SendSuggestRes message from the specified reader or buffer.
         * @function decode
         * @memberof Suggest.SendSuggestRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Suggest.SendSuggestRes} SendSuggestRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SendSuggestRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Suggest.SendSuggestRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a SendSuggestRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Suggest.SendSuggestRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Suggest.SendSuggestRes} SendSuggestRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SendSuggestRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a SendSuggestRes message.
         * @function verify
         * @memberof Suggest.SendSuggestRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        SendSuggestRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return SendSuggestRes;
    })();

    return Suggest;
})();

$root.MiniGames = (function() {

    /**
     * Namespace MiniGames.
     * @exports MiniGames
     * @namespace
     */
    var MiniGames = {};

    MiniGames.GetMiniGameReq = (function() {

        /**
         * Properties of a GetMiniGameReq.
         * @memberof MiniGames
         * @interface IGetMiniGameReq
         */

        /**
         * Constructs a new GetMiniGameReq.
         * @memberof MiniGames
         * @classdesc Represents a GetMiniGameReq.
         * @implements IGetMiniGameReq
         * @constructor
         * @param {MiniGames.IGetMiniGameReq=} [properties] Properties to set
         */
        function GetMiniGameReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetMiniGameReq instance using the specified properties.
         * @function create
         * @memberof MiniGames.GetMiniGameReq
         * @static
         * @param {MiniGames.IGetMiniGameReq=} [properties] Properties to set
         * @returns {MiniGames.GetMiniGameReq} GetMiniGameReq instance
         */
        GetMiniGameReq.create = function create(properties) {
            return new GetMiniGameReq(properties);
        };

        /**
         * Encodes the specified GetMiniGameReq message. Does not implicitly {@link MiniGames.GetMiniGameReq.verify|verify} messages.
         * @function encode
         * @memberof MiniGames.GetMiniGameReq
         * @static
         * @param {MiniGames.IGetMiniGameReq} message GetMiniGameReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetMiniGameReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetMiniGameReq message, length delimited. Does not implicitly {@link MiniGames.GetMiniGameReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof MiniGames.GetMiniGameReq
         * @static
         * @param {MiniGames.IGetMiniGameReq} message GetMiniGameReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetMiniGameReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetMiniGameReq message from the specified reader or buffer.
         * @function decode
         * @memberof MiniGames.GetMiniGameReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {MiniGames.GetMiniGameReq} GetMiniGameReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetMiniGameReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.MiniGames.GetMiniGameReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetMiniGameReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof MiniGames.GetMiniGameReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {MiniGames.GetMiniGameReq} GetMiniGameReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetMiniGameReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetMiniGameReq message.
         * @function verify
         * @memberof MiniGames.GetMiniGameReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetMiniGameReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetMiniGameReq;
    })();

    MiniGames.GetMiniGameRes = (function() {

        /**
         * Properties of a GetMiniGameRes.
         * @memberof MiniGames
         * @interface IGetMiniGameRes
         * @property {boolean|null} [gameActive] GetMiniGameRes gameActive
         * @property {BaseInfo.IMiniGame|null} [game] GetMiniGameRes game
         */

        /**
         * Constructs a new GetMiniGameRes.
         * @memberof MiniGames
         * @classdesc Represents a GetMiniGameRes.
         * @implements IGetMiniGameRes
         * @constructor
         * @param {MiniGames.IGetMiniGameRes=} [properties] Properties to set
         */
        function GetMiniGameRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetMiniGameRes gameActive.
         * @member {boolean} gameActive
         * @memberof MiniGames.GetMiniGameRes
         * @instance
         */
        GetMiniGameRes.prototype.gameActive = false;

        /**
         * GetMiniGameRes game.
         * @member {BaseInfo.IMiniGame|null|undefined} game
         * @memberof MiniGames.GetMiniGameRes
         * @instance
         */
        GetMiniGameRes.prototype.game = null;

        /**
         * Creates a new GetMiniGameRes instance using the specified properties.
         * @function create
         * @memberof MiniGames.GetMiniGameRes
         * @static
         * @param {MiniGames.IGetMiniGameRes=} [properties] Properties to set
         * @returns {MiniGames.GetMiniGameRes} GetMiniGameRes instance
         */
        GetMiniGameRes.create = function create(properties) {
            return new GetMiniGameRes(properties);
        };

        /**
         * Encodes the specified GetMiniGameRes message. Does not implicitly {@link MiniGames.GetMiniGameRes.verify|verify} messages.
         * @function encode
         * @memberof MiniGames.GetMiniGameRes
         * @static
         * @param {MiniGames.IGetMiniGameRes} message GetMiniGameRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetMiniGameRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.gameActive != null && message.hasOwnProperty("gameActive"))
                writer.uint32(/* id 1, wireType 0 =*/8).bool(message.gameActive);
            if (message.game != null && message.hasOwnProperty("game"))
                $root.BaseInfo.MiniGame.encode(message.game, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetMiniGameRes message, length delimited. Does not implicitly {@link MiniGames.GetMiniGameRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof MiniGames.GetMiniGameRes
         * @static
         * @param {MiniGames.IGetMiniGameRes} message GetMiniGameRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetMiniGameRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetMiniGameRes message from the specified reader or buffer.
         * @function decode
         * @memberof MiniGames.GetMiniGameRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {MiniGames.GetMiniGameRes} GetMiniGameRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetMiniGameRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.MiniGames.GetMiniGameRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.gameActive = reader.bool();
                    break;
                case 2:
                    message.game = $root.BaseInfo.MiniGame.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetMiniGameRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof MiniGames.GetMiniGameRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {MiniGames.GetMiniGameRes} GetMiniGameRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetMiniGameRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetMiniGameRes message.
         * @function verify
         * @memberof MiniGames.GetMiniGameRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetMiniGameRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.gameActive != null && message.hasOwnProperty("gameActive"))
                if (typeof message.gameActive !== "boolean")
                    return "gameActive: boolean expected";
            if (message.game != null && message.hasOwnProperty("game")) {
                var error = $root.BaseInfo.MiniGame.verify(message.game);
                if (error)
                    return "game." + error;
            }
            return null;
        };

        return GetMiniGameRes;
    })();

    MiniGames.FinishMiniGameReq = (function() {

        /**
         * Properties of a FinishMiniGameReq.
         * @memberof MiniGames
         * @interface IFinishMiniGameReq
         * @property {string|null} [listId] FinishMiniGameReq listId
         * @property {MiniGames.IGameResult|null} [result] FinishMiniGameReq result
         * @property {BaseInfo.FetchType|null} [fetchType] FinishMiniGameReq fetchType
         */

        /**
         * Constructs a new FinishMiniGameReq.
         * @memberof MiniGames
         * @classdesc Represents a FinishMiniGameReq.
         * @implements IFinishMiniGameReq
         * @constructor
         * @param {MiniGames.IFinishMiniGameReq=} [properties] Properties to set
         */
        function FinishMiniGameReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FinishMiniGameReq listId.
         * @member {string} listId
         * @memberof MiniGames.FinishMiniGameReq
         * @instance
         */
        FinishMiniGameReq.prototype.listId = "";

        /**
         * FinishMiniGameReq result.
         * @member {MiniGames.IGameResult|null|undefined} result
         * @memberof MiniGames.FinishMiniGameReq
         * @instance
         */
        FinishMiniGameReq.prototype.result = null;

        /**
         * FinishMiniGameReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof MiniGames.FinishMiniGameReq
         * @instance
         */
        FinishMiniGameReq.prototype.fetchType = 0;

        /**
         * Creates a new FinishMiniGameReq instance using the specified properties.
         * @function create
         * @memberof MiniGames.FinishMiniGameReq
         * @static
         * @param {MiniGames.IFinishMiniGameReq=} [properties] Properties to set
         * @returns {MiniGames.FinishMiniGameReq} FinishMiniGameReq instance
         */
        FinishMiniGameReq.create = function create(properties) {
            return new FinishMiniGameReq(properties);
        };

        /**
         * Encodes the specified FinishMiniGameReq message. Does not implicitly {@link MiniGames.FinishMiniGameReq.verify|verify} messages.
         * @function encode
         * @memberof MiniGames.FinishMiniGameReq
         * @static
         * @param {MiniGames.IFinishMiniGameReq} message FinishMiniGameReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishMiniGameReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.listId != null && message.hasOwnProperty("listId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.listId);
            if (message.result != null && message.hasOwnProperty("result"))
                $root.MiniGames.GameResult.encode(message.result, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified FinishMiniGameReq message, length delimited. Does not implicitly {@link MiniGames.FinishMiniGameReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof MiniGames.FinishMiniGameReq
         * @static
         * @param {MiniGames.IFinishMiniGameReq} message FinishMiniGameReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishMiniGameReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FinishMiniGameReq message from the specified reader or buffer.
         * @function decode
         * @memberof MiniGames.FinishMiniGameReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {MiniGames.FinishMiniGameReq} FinishMiniGameReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishMiniGameReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.MiniGames.FinishMiniGameReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.listId = reader.string();
                    break;
                case 2:
                    message.result = $root.MiniGames.GameResult.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FinishMiniGameReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof MiniGames.FinishMiniGameReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {MiniGames.FinishMiniGameReq} FinishMiniGameReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishMiniGameReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FinishMiniGameReq message.
         * @function verify
         * @memberof MiniGames.FinishMiniGameReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FinishMiniGameReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.listId != null && message.hasOwnProperty("listId"))
                if (!$util.isString(message.listId))
                    return "listId: string expected";
            if (message.result != null && message.hasOwnProperty("result")) {
                var error = $root.MiniGames.GameResult.verify(message.result);
                if (error)
                    return "result." + error;
            }
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return FinishMiniGameReq;
    })();

    MiniGames.FinishMiniGameRes = (function() {

        /**
         * Properties of a FinishMiniGameRes.
         * @memberof MiniGames
         * @interface IFinishMiniGameRes
         * @property {BaseInfo.IRewards|null} [rewards] FinishMiniGameRes rewards
         * @property {BaseInfo.IMiniGame|null} [game] FinishMiniGameRes game
         */

        /**
         * Constructs a new FinishMiniGameRes.
         * @memberof MiniGames
         * @classdesc Represents a FinishMiniGameRes.
         * @implements IFinishMiniGameRes
         * @constructor
         * @param {MiniGames.IFinishMiniGameRes=} [properties] Properties to set
         */
        function FinishMiniGameRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FinishMiniGameRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof MiniGames.FinishMiniGameRes
         * @instance
         */
        FinishMiniGameRes.prototype.rewards = null;

        /**
         * FinishMiniGameRes game.
         * @member {BaseInfo.IMiniGame|null|undefined} game
         * @memberof MiniGames.FinishMiniGameRes
         * @instance
         */
        FinishMiniGameRes.prototype.game = null;

        /**
         * Creates a new FinishMiniGameRes instance using the specified properties.
         * @function create
         * @memberof MiniGames.FinishMiniGameRes
         * @static
         * @param {MiniGames.IFinishMiniGameRes=} [properties] Properties to set
         * @returns {MiniGames.FinishMiniGameRes} FinishMiniGameRes instance
         */
        FinishMiniGameRes.create = function create(properties) {
            return new FinishMiniGameRes(properties);
        };

        /**
         * Encodes the specified FinishMiniGameRes message. Does not implicitly {@link MiniGames.FinishMiniGameRes.verify|verify} messages.
         * @function encode
         * @memberof MiniGames.FinishMiniGameRes
         * @static
         * @param {MiniGames.IFinishMiniGameRes} message FinishMiniGameRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishMiniGameRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.game != null && message.hasOwnProperty("game"))
                $root.BaseInfo.MiniGame.encode(message.game, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FinishMiniGameRes message, length delimited. Does not implicitly {@link MiniGames.FinishMiniGameRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof MiniGames.FinishMiniGameRes
         * @static
         * @param {MiniGames.IFinishMiniGameRes} message FinishMiniGameRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishMiniGameRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FinishMiniGameRes message from the specified reader or buffer.
         * @function decode
         * @memberof MiniGames.FinishMiniGameRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {MiniGames.FinishMiniGameRes} FinishMiniGameRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishMiniGameRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.MiniGames.FinishMiniGameRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.game = $root.BaseInfo.MiniGame.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FinishMiniGameRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof MiniGames.FinishMiniGameRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {MiniGames.FinishMiniGameRes} FinishMiniGameRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishMiniGameRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FinishMiniGameRes message.
         * @function verify
         * @memberof MiniGames.FinishMiniGameRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FinishMiniGameRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.game != null && message.hasOwnProperty("game")) {
                var error = $root.BaseInfo.MiniGame.verify(message.game);
                if (error)
                    return "game." + error;
            }
            return null;
        };

        return FinishMiniGameRes;
    })();

    MiniGames.ClientTriggerMiniGameReq = (function() {

        /**
         * Properties of a ClientTriggerMiniGameReq.
         * @memberof MiniGames
         * @interface IClientTriggerMiniGameReq
         */

        /**
         * Constructs a new ClientTriggerMiniGameReq.
         * @memberof MiniGames
         * @classdesc Represents a ClientTriggerMiniGameReq.
         * @implements IClientTriggerMiniGameReq
         * @constructor
         * @param {MiniGames.IClientTriggerMiniGameReq=} [properties] Properties to set
         */
        function ClientTriggerMiniGameReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new ClientTriggerMiniGameReq instance using the specified properties.
         * @function create
         * @memberof MiniGames.ClientTriggerMiniGameReq
         * @static
         * @param {MiniGames.IClientTriggerMiniGameReq=} [properties] Properties to set
         * @returns {MiniGames.ClientTriggerMiniGameReq} ClientTriggerMiniGameReq instance
         */
        ClientTriggerMiniGameReq.create = function create(properties) {
            return new ClientTriggerMiniGameReq(properties);
        };

        /**
         * Encodes the specified ClientTriggerMiniGameReq message. Does not implicitly {@link MiniGames.ClientTriggerMiniGameReq.verify|verify} messages.
         * @function encode
         * @memberof MiniGames.ClientTriggerMiniGameReq
         * @static
         * @param {MiniGames.IClientTriggerMiniGameReq} message ClientTriggerMiniGameReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ClientTriggerMiniGameReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified ClientTriggerMiniGameReq message, length delimited. Does not implicitly {@link MiniGames.ClientTriggerMiniGameReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof MiniGames.ClientTriggerMiniGameReq
         * @static
         * @param {MiniGames.IClientTriggerMiniGameReq} message ClientTriggerMiniGameReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ClientTriggerMiniGameReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ClientTriggerMiniGameReq message from the specified reader or buffer.
         * @function decode
         * @memberof MiniGames.ClientTriggerMiniGameReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {MiniGames.ClientTriggerMiniGameReq} ClientTriggerMiniGameReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ClientTriggerMiniGameReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.MiniGames.ClientTriggerMiniGameReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ClientTriggerMiniGameReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof MiniGames.ClientTriggerMiniGameReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {MiniGames.ClientTriggerMiniGameReq} ClientTriggerMiniGameReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ClientTriggerMiniGameReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ClientTriggerMiniGameReq message.
         * @function verify
         * @memberof MiniGames.ClientTriggerMiniGameReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ClientTriggerMiniGameReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return ClientTriggerMiniGameReq;
    })();

    MiniGames.ClientTriggerMiniGameRes = (function() {

        /**
         * Properties of a ClientTriggerMiniGameRes.
         * @memberof MiniGames
         * @interface IClientTriggerMiniGameRes
         * @property {boolean|null} [success] ClientTriggerMiniGameRes success
         */

        /**
         * Constructs a new ClientTriggerMiniGameRes.
         * @memberof MiniGames
         * @classdesc Represents a ClientTriggerMiniGameRes.
         * @implements IClientTriggerMiniGameRes
         * @constructor
         * @param {MiniGames.IClientTriggerMiniGameRes=} [properties] Properties to set
         */
        function ClientTriggerMiniGameRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ClientTriggerMiniGameRes success.
         * @member {boolean} success
         * @memberof MiniGames.ClientTriggerMiniGameRes
         * @instance
         */
        ClientTriggerMiniGameRes.prototype.success = false;

        /**
         * Creates a new ClientTriggerMiniGameRes instance using the specified properties.
         * @function create
         * @memberof MiniGames.ClientTriggerMiniGameRes
         * @static
         * @param {MiniGames.IClientTriggerMiniGameRes=} [properties] Properties to set
         * @returns {MiniGames.ClientTriggerMiniGameRes} ClientTriggerMiniGameRes instance
         */
        ClientTriggerMiniGameRes.create = function create(properties) {
            return new ClientTriggerMiniGameRes(properties);
        };

        /**
         * Encodes the specified ClientTriggerMiniGameRes message. Does not implicitly {@link MiniGames.ClientTriggerMiniGameRes.verify|verify} messages.
         * @function encode
         * @memberof MiniGames.ClientTriggerMiniGameRes
         * @static
         * @param {MiniGames.IClientTriggerMiniGameRes} message ClientTriggerMiniGameRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ClientTriggerMiniGameRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.success != null && message.hasOwnProperty("success"))
                writer.uint32(/* id 1, wireType 0 =*/8).bool(message.success);
            return writer;
        };

        /**
         * Encodes the specified ClientTriggerMiniGameRes message, length delimited. Does not implicitly {@link MiniGames.ClientTriggerMiniGameRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof MiniGames.ClientTriggerMiniGameRes
         * @static
         * @param {MiniGames.IClientTriggerMiniGameRes} message ClientTriggerMiniGameRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ClientTriggerMiniGameRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ClientTriggerMiniGameRes message from the specified reader or buffer.
         * @function decode
         * @memberof MiniGames.ClientTriggerMiniGameRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {MiniGames.ClientTriggerMiniGameRes} ClientTriggerMiniGameRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ClientTriggerMiniGameRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.MiniGames.ClientTriggerMiniGameRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.success = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ClientTriggerMiniGameRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof MiniGames.ClientTriggerMiniGameRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {MiniGames.ClientTriggerMiniGameRes} ClientTriggerMiniGameRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ClientTriggerMiniGameRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ClientTriggerMiniGameRes message.
         * @function verify
         * @memberof MiniGames.ClientTriggerMiniGameRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ClientTriggerMiniGameRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.success != null && message.hasOwnProperty("success"))
                if (typeof message.success !== "boolean")
                    return "success: boolean expected";
            return null;
        };

        return ClientTriggerMiniGameRes;
    })();

    MiniGames.GiveUpMiniGameReq = (function() {

        /**
         * Properties of a GiveUpMiniGameReq.
         * @memberof MiniGames
         * @interface IGiveUpMiniGameReq
         */

        /**
         * Constructs a new GiveUpMiniGameReq.
         * @memberof MiniGames
         * @classdesc Represents a GiveUpMiniGameReq.
         * @implements IGiveUpMiniGameReq
         * @constructor
         * @param {MiniGames.IGiveUpMiniGameReq=} [properties] Properties to set
         */
        function GiveUpMiniGameReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GiveUpMiniGameReq instance using the specified properties.
         * @function create
         * @memberof MiniGames.GiveUpMiniGameReq
         * @static
         * @param {MiniGames.IGiveUpMiniGameReq=} [properties] Properties to set
         * @returns {MiniGames.GiveUpMiniGameReq} GiveUpMiniGameReq instance
         */
        GiveUpMiniGameReq.create = function create(properties) {
            return new GiveUpMiniGameReq(properties);
        };

        /**
         * Encodes the specified GiveUpMiniGameReq message. Does not implicitly {@link MiniGames.GiveUpMiniGameReq.verify|verify} messages.
         * @function encode
         * @memberof MiniGames.GiveUpMiniGameReq
         * @static
         * @param {MiniGames.IGiveUpMiniGameReq} message GiveUpMiniGameReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GiveUpMiniGameReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GiveUpMiniGameReq message, length delimited. Does not implicitly {@link MiniGames.GiveUpMiniGameReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof MiniGames.GiveUpMiniGameReq
         * @static
         * @param {MiniGames.IGiveUpMiniGameReq} message GiveUpMiniGameReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GiveUpMiniGameReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GiveUpMiniGameReq message from the specified reader or buffer.
         * @function decode
         * @memberof MiniGames.GiveUpMiniGameReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {MiniGames.GiveUpMiniGameReq} GiveUpMiniGameReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GiveUpMiniGameReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.MiniGames.GiveUpMiniGameReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GiveUpMiniGameReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof MiniGames.GiveUpMiniGameReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {MiniGames.GiveUpMiniGameReq} GiveUpMiniGameReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GiveUpMiniGameReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GiveUpMiniGameReq message.
         * @function verify
         * @memberof MiniGames.GiveUpMiniGameReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GiveUpMiniGameReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GiveUpMiniGameReq;
    })();

    MiniGames.GiveUpMiniGameRes = (function() {

        /**
         * Properties of a GiveUpMiniGameRes.
         * @memberof MiniGames
         * @interface IGiveUpMiniGameRes
         * @property {BaseInfo.IMiniGame|null} [game] GiveUpMiniGameRes game
         */

        /**
         * Constructs a new GiveUpMiniGameRes.
         * @memberof MiniGames
         * @classdesc Represents a GiveUpMiniGameRes.
         * @implements IGiveUpMiniGameRes
         * @constructor
         * @param {MiniGames.IGiveUpMiniGameRes=} [properties] Properties to set
         */
        function GiveUpMiniGameRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GiveUpMiniGameRes game.
         * @member {BaseInfo.IMiniGame|null|undefined} game
         * @memberof MiniGames.GiveUpMiniGameRes
         * @instance
         */
        GiveUpMiniGameRes.prototype.game = null;

        /**
         * Creates a new GiveUpMiniGameRes instance using the specified properties.
         * @function create
         * @memberof MiniGames.GiveUpMiniGameRes
         * @static
         * @param {MiniGames.IGiveUpMiniGameRes=} [properties] Properties to set
         * @returns {MiniGames.GiveUpMiniGameRes} GiveUpMiniGameRes instance
         */
        GiveUpMiniGameRes.create = function create(properties) {
            return new GiveUpMiniGameRes(properties);
        };

        /**
         * Encodes the specified GiveUpMiniGameRes message. Does not implicitly {@link MiniGames.GiveUpMiniGameRes.verify|verify} messages.
         * @function encode
         * @memberof MiniGames.GiveUpMiniGameRes
         * @static
         * @param {MiniGames.IGiveUpMiniGameRes} message GiveUpMiniGameRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GiveUpMiniGameRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.game != null && message.hasOwnProperty("game"))
                $root.BaseInfo.MiniGame.encode(message.game, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GiveUpMiniGameRes message, length delimited. Does not implicitly {@link MiniGames.GiveUpMiniGameRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof MiniGames.GiveUpMiniGameRes
         * @static
         * @param {MiniGames.IGiveUpMiniGameRes} message GiveUpMiniGameRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GiveUpMiniGameRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GiveUpMiniGameRes message from the specified reader or buffer.
         * @function decode
         * @memberof MiniGames.GiveUpMiniGameRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {MiniGames.GiveUpMiniGameRes} GiveUpMiniGameRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GiveUpMiniGameRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.MiniGames.GiveUpMiniGameRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.game = $root.BaseInfo.MiniGame.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GiveUpMiniGameRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof MiniGames.GiveUpMiniGameRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {MiniGames.GiveUpMiniGameRes} GiveUpMiniGameRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GiveUpMiniGameRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GiveUpMiniGameRes message.
         * @function verify
         * @memberof MiniGames.GiveUpMiniGameRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GiveUpMiniGameRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.game != null && message.hasOwnProperty("game")) {
                var error = $root.BaseInfo.MiniGame.verify(message.game);
                if (error)
                    return "game." + error;
            }
            return null;
        };

        return GiveUpMiniGameRes;
    })();

    MiniGames.GameResult = (function() {

        /**
         * Properties of a GameResult.
         * @memberof MiniGames
         * @interface IGameResult
         * @property {number|null} [resultStatus] GameResult resultStatus
         * @property {number|null} [score] GameResult score
         */

        /**
         * Constructs a new GameResult.
         * @memberof MiniGames
         * @classdesc Represents a GameResult.
         * @implements IGameResult
         * @constructor
         * @param {MiniGames.IGameResult=} [properties] Properties to set
         */
        function GameResult(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GameResult resultStatus.
         * @member {number} resultStatus
         * @memberof MiniGames.GameResult
         * @instance
         */
        GameResult.prototype.resultStatus = 0;

        /**
         * GameResult score.
         * @member {number} score
         * @memberof MiniGames.GameResult
         * @instance
         */
        GameResult.prototype.score = 0;

        /**
         * Creates a new GameResult instance using the specified properties.
         * @function create
         * @memberof MiniGames.GameResult
         * @static
         * @param {MiniGames.IGameResult=} [properties] Properties to set
         * @returns {MiniGames.GameResult} GameResult instance
         */
        GameResult.create = function create(properties) {
            return new GameResult(properties);
        };

        /**
         * Encodes the specified GameResult message. Does not implicitly {@link MiniGames.GameResult.verify|verify} messages.
         * @function encode
         * @memberof MiniGames.GameResult
         * @static
         * @param {MiniGames.IGameResult} message GameResult message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GameResult.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.resultStatus != null && message.hasOwnProperty("resultStatus"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.resultStatus);
            if (message.score != null && message.hasOwnProperty("score"))
                writer.uint32(/* id 2, wireType 1 =*/17).double(message.score);
            return writer;
        };

        /**
         * Encodes the specified GameResult message, length delimited. Does not implicitly {@link MiniGames.GameResult.verify|verify} messages.
         * @function encodeDelimited
         * @memberof MiniGames.GameResult
         * @static
         * @param {MiniGames.IGameResult} message GameResult message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GameResult.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GameResult message from the specified reader or buffer.
         * @function decode
         * @memberof MiniGames.GameResult
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {MiniGames.GameResult} GameResult
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GameResult.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.MiniGames.GameResult();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.resultStatus = reader.int32();
                    break;
                case 2:
                    message.score = reader.double();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GameResult message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof MiniGames.GameResult
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {MiniGames.GameResult} GameResult
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GameResult.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GameResult message.
         * @function verify
         * @memberof MiniGames.GameResult
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GameResult.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.resultStatus != null && message.hasOwnProperty("resultStatus"))
                if (!$util.isInteger(message.resultStatus))
                    return "resultStatus: integer expected";
            if (message.score != null && message.hasOwnProperty("score"))
                if (typeof message.score !== "number")
                    return "score: number expected";
            return null;
        };

        return GameResult;
    })();

    return MiniGames;
})();

$root.Balloon = (function() {

    /**
     * Namespace Balloon.
     * @exports Balloon
     * @namespace
     */
    var Balloon = {};

    Balloon.BalloonInfo = (function() {

        /**
         * Properties of a BalloonInfo.
         * @memberof Balloon
         * @interface IBalloonInfo
         * @property {number|null} [dailyCount] BalloonInfo dailyCount
         */

        /**
         * Constructs a new BalloonInfo.
         * @memberof Balloon
         * @classdesc Represents a BalloonInfo.
         * @implements IBalloonInfo
         * @constructor
         * @param {Balloon.IBalloonInfo=} [properties] Properties to set
         */
        function BalloonInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * BalloonInfo dailyCount.
         * @member {number} dailyCount
         * @memberof Balloon.BalloonInfo
         * @instance
         */
        BalloonInfo.prototype.dailyCount = 0;

        /**
         * Creates a new BalloonInfo instance using the specified properties.
         * @function create
         * @memberof Balloon.BalloonInfo
         * @static
         * @param {Balloon.IBalloonInfo=} [properties] Properties to set
         * @returns {Balloon.BalloonInfo} BalloonInfo instance
         */
        BalloonInfo.create = function create(properties) {
            return new BalloonInfo(properties);
        };

        /**
         * Encodes the specified BalloonInfo message. Does not implicitly {@link Balloon.BalloonInfo.verify|verify} messages.
         * @function encode
         * @memberof Balloon.BalloonInfo
         * @static
         * @param {Balloon.IBalloonInfo} message BalloonInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        BalloonInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.dailyCount != null && message.hasOwnProperty("dailyCount"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.dailyCount);
            return writer;
        };

        /**
         * Encodes the specified BalloonInfo message, length delimited. Does not implicitly {@link Balloon.BalloonInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Balloon.BalloonInfo
         * @static
         * @param {Balloon.IBalloonInfo} message BalloonInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        BalloonInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a BalloonInfo message from the specified reader or buffer.
         * @function decode
         * @memberof Balloon.BalloonInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Balloon.BalloonInfo} BalloonInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        BalloonInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Balloon.BalloonInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.dailyCount = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a BalloonInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Balloon.BalloonInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Balloon.BalloonInfo} BalloonInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        BalloonInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a BalloonInfo message.
         * @function verify
         * @memberof Balloon.BalloonInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        BalloonInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.dailyCount != null && message.hasOwnProperty("dailyCount"))
                if (!$util.isInteger(message.dailyCount))
                    return "dailyCount: integer expected";
            return null;
        };

        return BalloonInfo;
    })();

    Balloon.TouchBalloonReq = (function() {

        /**
         * Properties of a TouchBalloonReq.
         * @memberof Balloon
         * @interface ITouchBalloonReq
         * @property {BaseInfo.FetchType|null} [fetchType] TouchBalloonReq fetchType
         */

        /**
         * Constructs a new TouchBalloonReq.
         * @memberof Balloon
         * @classdesc Represents a TouchBalloonReq.
         * @implements ITouchBalloonReq
         * @constructor
         * @param {Balloon.ITouchBalloonReq=} [properties] Properties to set
         */
        function TouchBalloonReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * TouchBalloonReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof Balloon.TouchBalloonReq
         * @instance
         */
        TouchBalloonReq.prototype.fetchType = 0;

        /**
         * Creates a new TouchBalloonReq instance using the specified properties.
         * @function create
         * @memberof Balloon.TouchBalloonReq
         * @static
         * @param {Balloon.ITouchBalloonReq=} [properties] Properties to set
         * @returns {Balloon.TouchBalloonReq} TouchBalloonReq instance
         */
        TouchBalloonReq.create = function create(properties) {
            return new TouchBalloonReq(properties);
        };

        /**
         * Encodes the specified TouchBalloonReq message. Does not implicitly {@link Balloon.TouchBalloonReq.verify|verify} messages.
         * @function encode
         * @memberof Balloon.TouchBalloonReq
         * @static
         * @param {Balloon.ITouchBalloonReq} message TouchBalloonReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TouchBalloonReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified TouchBalloonReq message, length delimited. Does not implicitly {@link Balloon.TouchBalloonReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Balloon.TouchBalloonReq
         * @static
         * @param {Balloon.ITouchBalloonReq} message TouchBalloonReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TouchBalloonReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a TouchBalloonReq message from the specified reader or buffer.
         * @function decode
         * @memberof Balloon.TouchBalloonReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Balloon.TouchBalloonReq} TouchBalloonReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TouchBalloonReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Balloon.TouchBalloonReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a TouchBalloonReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Balloon.TouchBalloonReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Balloon.TouchBalloonReq} TouchBalloonReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TouchBalloonReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a TouchBalloonReq message.
         * @function verify
         * @memberof Balloon.TouchBalloonReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        TouchBalloonReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return TouchBalloonReq;
    })();

    Balloon.TouchBalloonRes = (function() {

        /**
         * Properties of a TouchBalloonRes.
         * @memberof Balloon
         * @interface ITouchBalloonRes
         * @property {Balloon.IBalloonInfo|null} [balloon] TouchBalloonRes balloon
         * @property {BaseInfo.IRewards|null} [rewards] TouchBalloonRes rewards
         */

        /**
         * Constructs a new TouchBalloonRes.
         * @memberof Balloon
         * @classdesc Represents a TouchBalloonRes.
         * @implements ITouchBalloonRes
         * @constructor
         * @param {Balloon.ITouchBalloonRes=} [properties] Properties to set
         */
        function TouchBalloonRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * TouchBalloonRes balloon.
         * @member {Balloon.IBalloonInfo|null|undefined} balloon
         * @memberof Balloon.TouchBalloonRes
         * @instance
         */
        TouchBalloonRes.prototype.balloon = null;

        /**
         * TouchBalloonRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Balloon.TouchBalloonRes
         * @instance
         */
        TouchBalloonRes.prototype.rewards = null;

        /**
         * Creates a new TouchBalloonRes instance using the specified properties.
         * @function create
         * @memberof Balloon.TouchBalloonRes
         * @static
         * @param {Balloon.ITouchBalloonRes=} [properties] Properties to set
         * @returns {Balloon.TouchBalloonRes} TouchBalloonRes instance
         */
        TouchBalloonRes.create = function create(properties) {
            return new TouchBalloonRes(properties);
        };

        /**
         * Encodes the specified TouchBalloonRes message. Does not implicitly {@link Balloon.TouchBalloonRes.verify|verify} messages.
         * @function encode
         * @memberof Balloon.TouchBalloonRes
         * @static
         * @param {Balloon.ITouchBalloonRes} message TouchBalloonRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TouchBalloonRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.balloon != null && message.hasOwnProperty("balloon"))
                $root.Balloon.BalloonInfo.encode(message.balloon, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified TouchBalloonRes message, length delimited. Does not implicitly {@link Balloon.TouchBalloonRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Balloon.TouchBalloonRes
         * @static
         * @param {Balloon.ITouchBalloonRes} message TouchBalloonRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TouchBalloonRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a TouchBalloonRes message from the specified reader or buffer.
         * @function decode
         * @memberof Balloon.TouchBalloonRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Balloon.TouchBalloonRes} TouchBalloonRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TouchBalloonRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Balloon.TouchBalloonRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.balloon = $root.Balloon.BalloonInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a TouchBalloonRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Balloon.TouchBalloonRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Balloon.TouchBalloonRes} TouchBalloonRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TouchBalloonRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a TouchBalloonRes message.
         * @function verify
         * @memberof Balloon.TouchBalloonRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        TouchBalloonRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.balloon != null && message.hasOwnProperty("balloon")) {
                var error = $root.Balloon.BalloonInfo.verify(message.balloon);
                if (error)
                    return "balloon." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            return null;
        };

        return TouchBalloonRes;
    })();

    Balloon.GetBalloonInfoReq = (function() {

        /**
         * Properties of a GetBalloonInfoReq.
         * @memberof Balloon
         * @interface IGetBalloonInfoReq
         */

        /**
         * Constructs a new GetBalloonInfoReq.
         * @memberof Balloon
         * @classdesc Represents a GetBalloonInfoReq.
         * @implements IGetBalloonInfoReq
         * @constructor
         * @param {Balloon.IGetBalloonInfoReq=} [properties] Properties to set
         */
        function GetBalloonInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetBalloonInfoReq instance using the specified properties.
         * @function create
         * @memberof Balloon.GetBalloonInfoReq
         * @static
         * @param {Balloon.IGetBalloonInfoReq=} [properties] Properties to set
         * @returns {Balloon.GetBalloonInfoReq} GetBalloonInfoReq instance
         */
        GetBalloonInfoReq.create = function create(properties) {
            return new GetBalloonInfoReq(properties);
        };

        /**
         * Encodes the specified GetBalloonInfoReq message. Does not implicitly {@link Balloon.GetBalloonInfoReq.verify|verify} messages.
         * @function encode
         * @memberof Balloon.GetBalloonInfoReq
         * @static
         * @param {Balloon.IGetBalloonInfoReq} message GetBalloonInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetBalloonInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetBalloonInfoReq message, length delimited. Does not implicitly {@link Balloon.GetBalloonInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Balloon.GetBalloonInfoReq
         * @static
         * @param {Balloon.IGetBalloonInfoReq} message GetBalloonInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetBalloonInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetBalloonInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof Balloon.GetBalloonInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Balloon.GetBalloonInfoReq} GetBalloonInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetBalloonInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Balloon.GetBalloonInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetBalloonInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Balloon.GetBalloonInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Balloon.GetBalloonInfoReq} GetBalloonInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetBalloonInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetBalloonInfoReq message.
         * @function verify
         * @memberof Balloon.GetBalloonInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetBalloonInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetBalloonInfoReq;
    })();

    Balloon.GetBalloonInfoRes = (function() {

        /**
         * Properties of a GetBalloonInfoRes.
         * @memberof Balloon
         * @interface IGetBalloonInfoRes
         * @property {BaseInfo.IRewards|null} [rewards] GetBalloonInfoRes rewards
         */

        /**
         * Constructs a new GetBalloonInfoRes.
         * @memberof Balloon
         * @classdesc Represents a GetBalloonInfoRes.
         * @implements IGetBalloonInfoRes
         * @constructor
         * @param {Balloon.IGetBalloonInfoRes=} [properties] Properties to set
         */
        function GetBalloonInfoRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetBalloonInfoRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Balloon.GetBalloonInfoRes
         * @instance
         */
        GetBalloonInfoRes.prototype.rewards = null;

        /**
         * Creates a new GetBalloonInfoRes instance using the specified properties.
         * @function create
         * @memberof Balloon.GetBalloonInfoRes
         * @static
         * @param {Balloon.IGetBalloonInfoRes=} [properties] Properties to set
         * @returns {Balloon.GetBalloonInfoRes} GetBalloonInfoRes instance
         */
        GetBalloonInfoRes.create = function create(properties) {
            return new GetBalloonInfoRes(properties);
        };

        /**
         * Encodes the specified GetBalloonInfoRes message. Does not implicitly {@link Balloon.GetBalloonInfoRes.verify|verify} messages.
         * @function encode
         * @memberof Balloon.GetBalloonInfoRes
         * @static
         * @param {Balloon.IGetBalloonInfoRes} message GetBalloonInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetBalloonInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetBalloonInfoRes message, length delimited. Does not implicitly {@link Balloon.GetBalloonInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Balloon.GetBalloonInfoRes
         * @static
         * @param {Balloon.IGetBalloonInfoRes} message GetBalloonInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetBalloonInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetBalloonInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof Balloon.GetBalloonInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Balloon.GetBalloonInfoRes} GetBalloonInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetBalloonInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Balloon.GetBalloonInfoRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetBalloonInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Balloon.GetBalloonInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Balloon.GetBalloonInfoRes} GetBalloonInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetBalloonInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetBalloonInfoRes message.
         * @function verify
         * @memberof Balloon.GetBalloonInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetBalloonInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            return null;
        };

        return GetBalloonInfoRes;
    })();

    return Balloon;
})();

$root.LuckyBag = (function() {

    /**
     * Namespace LuckyBag.
     * @exports LuckyBag
     * @namespace
     */
    var LuckyBag = {};

    LuckyBag.LuckyBagInfo = (function() {

        /**
         * Properties of a LuckyBagInfo.
         * @memberof LuckyBag
         * @interface ILuckyBagInfo
         * @property {number|null} [receiveTimes] LuckyBagInfo receiveTimes
         * @property {number|Long|null} [fishAmount] LuckyBagInfo fishAmount
         */

        /**
         * Constructs a new LuckyBagInfo.
         * @memberof LuckyBag
         * @classdesc Represents a LuckyBagInfo.
         * @implements ILuckyBagInfo
         * @constructor
         * @param {LuckyBag.ILuckyBagInfo=} [properties] Properties to set
         */
        function LuckyBagInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * LuckyBagInfo receiveTimes.
         * @member {number} receiveTimes
         * @memberof LuckyBag.LuckyBagInfo
         * @instance
         */
        LuckyBagInfo.prototype.receiveTimes = 0;

        /**
         * LuckyBagInfo fishAmount.
         * @member {number|Long} fishAmount
         * @memberof LuckyBag.LuckyBagInfo
         * @instance
         */
        LuckyBagInfo.prototype.fishAmount = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new LuckyBagInfo instance using the specified properties.
         * @function create
         * @memberof LuckyBag.LuckyBagInfo
         * @static
         * @param {LuckyBag.ILuckyBagInfo=} [properties] Properties to set
         * @returns {LuckyBag.LuckyBagInfo} LuckyBagInfo instance
         */
        LuckyBagInfo.create = function create(properties) {
            return new LuckyBagInfo(properties);
        };

        /**
         * Encodes the specified LuckyBagInfo message. Does not implicitly {@link LuckyBag.LuckyBagInfo.verify|verify} messages.
         * @function encode
         * @memberof LuckyBag.LuckyBagInfo
         * @static
         * @param {LuckyBag.ILuckyBagInfo} message LuckyBagInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LuckyBagInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.receiveTimes != null && message.hasOwnProperty("receiveTimes"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.receiveTimes);
            if (message.fishAmount != null && message.hasOwnProperty("fishAmount"))
                writer.uint32(/* id 2, wireType 0 =*/16).int64(message.fishAmount);
            return writer;
        };

        /**
         * Encodes the specified LuckyBagInfo message, length delimited. Does not implicitly {@link LuckyBag.LuckyBagInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyBag.LuckyBagInfo
         * @static
         * @param {LuckyBag.ILuckyBagInfo} message LuckyBagInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LuckyBagInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a LuckyBagInfo message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyBag.LuckyBagInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyBag.LuckyBagInfo} LuckyBagInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LuckyBagInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyBag.LuckyBagInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.receiveTimes = reader.int32();
                    break;
                case 2:
                    message.fishAmount = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a LuckyBagInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyBag.LuckyBagInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyBag.LuckyBagInfo} LuckyBagInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LuckyBagInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a LuckyBagInfo message.
         * @function verify
         * @memberof LuckyBag.LuckyBagInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        LuckyBagInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.receiveTimes != null && message.hasOwnProperty("receiveTimes"))
                if (!$util.isInteger(message.receiveTimes))
                    return "receiveTimes: integer expected";
            if (message.fishAmount != null && message.hasOwnProperty("fishAmount"))
                if (!$util.isInteger(message.fishAmount) && !(message.fishAmount && $util.isInteger(message.fishAmount.low) && $util.isInteger(message.fishAmount.high)))
                    return "fishAmount: integer|Long expected";
            return null;
        };

        return LuckyBagInfo;
    })();

    LuckyBag.QueryLuckyBagInfoReq = (function() {

        /**
         * Properties of a QueryLuckyBagInfoReq.
         * @memberof LuckyBag
         * @interface IQueryLuckyBagInfoReq
         */

        /**
         * Constructs a new QueryLuckyBagInfoReq.
         * @memberof LuckyBag
         * @classdesc Represents a QueryLuckyBagInfoReq.
         * @implements IQueryLuckyBagInfoReq
         * @constructor
         * @param {LuckyBag.IQueryLuckyBagInfoReq=} [properties] Properties to set
         */
        function QueryLuckyBagInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new QueryLuckyBagInfoReq instance using the specified properties.
         * @function create
         * @memberof LuckyBag.QueryLuckyBagInfoReq
         * @static
         * @param {LuckyBag.IQueryLuckyBagInfoReq=} [properties] Properties to set
         * @returns {LuckyBag.QueryLuckyBagInfoReq} QueryLuckyBagInfoReq instance
         */
        QueryLuckyBagInfoReq.create = function create(properties) {
            return new QueryLuckyBagInfoReq(properties);
        };

        /**
         * Encodes the specified QueryLuckyBagInfoReq message. Does not implicitly {@link LuckyBag.QueryLuckyBagInfoReq.verify|verify} messages.
         * @function encode
         * @memberof LuckyBag.QueryLuckyBagInfoReq
         * @static
         * @param {LuckyBag.IQueryLuckyBagInfoReq} message QueryLuckyBagInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        QueryLuckyBagInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified QueryLuckyBagInfoReq message, length delimited. Does not implicitly {@link LuckyBag.QueryLuckyBagInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyBag.QueryLuckyBagInfoReq
         * @static
         * @param {LuckyBag.IQueryLuckyBagInfoReq} message QueryLuckyBagInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        QueryLuckyBagInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a QueryLuckyBagInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyBag.QueryLuckyBagInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyBag.QueryLuckyBagInfoReq} QueryLuckyBagInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        QueryLuckyBagInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyBag.QueryLuckyBagInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a QueryLuckyBagInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyBag.QueryLuckyBagInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyBag.QueryLuckyBagInfoReq} QueryLuckyBagInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        QueryLuckyBagInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a QueryLuckyBagInfoReq message.
         * @function verify
         * @memberof LuckyBag.QueryLuckyBagInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        QueryLuckyBagInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return QueryLuckyBagInfoReq;
    })();

    LuckyBag.QueryLuckyBagInfoRes = (function() {

        /**
         * Properties of a QueryLuckyBagInfoRes.
         * @memberof LuckyBag
         * @interface IQueryLuckyBagInfoRes
         * @property {LuckyBag.ILuckyBagInfo|null} [luckyBagInfo] QueryLuckyBagInfoRes luckyBagInfo
         */

        /**
         * Constructs a new QueryLuckyBagInfoRes.
         * @memberof LuckyBag
         * @classdesc Represents a QueryLuckyBagInfoRes.
         * @implements IQueryLuckyBagInfoRes
         * @constructor
         * @param {LuckyBag.IQueryLuckyBagInfoRes=} [properties] Properties to set
         */
        function QueryLuckyBagInfoRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * QueryLuckyBagInfoRes luckyBagInfo.
         * @member {LuckyBag.ILuckyBagInfo|null|undefined} luckyBagInfo
         * @memberof LuckyBag.QueryLuckyBagInfoRes
         * @instance
         */
        QueryLuckyBagInfoRes.prototype.luckyBagInfo = null;

        /**
         * Creates a new QueryLuckyBagInfoRes instance using the specified properties.
         * @function create
         * @memberof LuckyBag.QueryLuckyBagInfoRes
         * @static
         * @param {LuckyBag.IQueryLuckyBagInfoRes=} [properties] Properties to set
         * @returns {LuckyBag.QueryLuckyBagInfoRes} QueryLuckyBagInfoRes instance
         */
        QueryLuckyBagInfoRes.create = function create(properties) {
            return new QueryLuckyBagInfoRes(properties);
        };

        /**
         * Encodes the specified QueryLuckyBagInfoRes message. Does not implicitly {@link LuckyBag.QueryLuckyBagInfoRes.verify|verify} messages.
         * @function encode
         * @memberof LuckyBag.QueryLuckyBagInfoRes
         * @static
         * @param {LuckyBag.IQueryLuckyBagInfoRes} message QueryLuckyBagInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        QueryLuckyBagInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.luckyBagInfo != null && message.hasOwnProperty("luckyBagInfo"))
                $root.LuckyBag.LuckyBagInfo.encode(message.luckyBagInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified QueryLuckyBagInfoRes message, length delimited. Does not implicitly {@link LuckyBag.QueryLuckyBagInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyBag.QueryLuckyBagInfoRes
         * @static
         * @param {LuckyBag.IQueryLuckyBagInfoRes} message QueryLuckyBagInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        QueryLuckyBagInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a QueryLuckyBagInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyBag.QueryLuckyBagInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyBag.QueryLuckyBagInfoRes} QueryLuckyBagInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        QueryLuckyBagInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyBag.QueryLuckyBagInfoRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.luckyBagInfo = $root.LuckyBag.LuckyBagInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a QueryLuckyBagInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyBag.QueryLuckyBagInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyBag.QueryLuckyBagInfoRes} QueryLuckyBagInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        QueryLuckyBagInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a QueryLuckyBagInfoRes message.
         * @function verify
         * @memberof LuckyBag.QueryLuckyBagInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        QueryLuckyBagInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.luckyBagInfo != null && message.hasOwnProperty("luckyBagInfo")) {
                var error = $root.LuckyBag.LuckyBagInfo.verify(message.luckyBagInfo);
                if (error)
                    return "luckyBagInfo." + error;
            }
            return null;
        };

        return QueryLuckyBagInfoRes;
    })();

    LuckyBag.ReceiveLuckyBagReq = (function() {

        /**
         * Properties of a ReceiveLuckyBagReq.
         * @memberof LuckyBag
         * @interface IReceiveLuckyBagReq
         * @property {BaseInfo.FetchType|null} [fetchType] ReceiveLuckyBagReq fetchType
         */

        /**
         * Constructs a new ReceiveLuckyBagReq.
         * @memberof LuckyBag
         * @classdesc Represents a ReceiveLuckyBagReq.
         * @implements IReceiveLuckyBagReq
         * @constructor
         * @param {LuckyBag.IReceiveLuckyBagReq=} [properties] Properties to set
         */
        function ReceiveLuckyBagReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReceiveLuckyBagReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof LuckyBag.ReceiveLuckyBagReq
         * @instance
         */
        ReceiveLuckyBagReq.prototype.fetchType = 0;

        /**
         * Creates a new ReceiveLuckyBagReq instance using the specified properties.
         * @function create
         * @memberof LuckyBag.ReceiveLuckyBagReq
         * @static
         * @param {LuckyBag.IReceiveLuckyBagReq=} [properties] Properties to set
         * @returns {LuckyBag.ReceiveLuckyBagReq} ReceiveLuckyBagReq instance
         */
        ReceiveLuckyBagReq.create = function create(properties) {
            return new ReceiveLuckyBagReq(properties);
        };

        /**
         * Encodes the specified ReceiveLuckyBagReq message. Does not implicitly {@link LuckyBag.ReceiveLuckyBagReq.verify|verify} messages.
         * @function encode
         * @memberof LuckyBag.ReceiveLuckyBagReq
         * @static
         * @param {LuckyBag.IReceiveLuckyBagReq} message ReceiveLuckyBagReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveLuckyBagReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified ReceiveLuckyBagReq message, length delimited. Does not implicitly {@link LuckyBag.ReceiveLuckyBagReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyBag.ReceiveLuckyBagReq
         * @static
         * @param {LuckyBag.IReceiveLuckyBagReq} message ReceiveLuckyBagReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveLuckyBagReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveLuckyBagReq message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyBag.ReceiveLuckyBagReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyBag.ReceiveLuckyBagReq} ReceiveLuckyBagReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveLuckyBagReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyBag.ReceiveLuckyBagReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveLuckyBagReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyBag.ReceiveLuckyBagReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyBag.ReceiveLuckyBagReq} ReceiveLuckyBagReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveLuckyBagReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveLuckyBagReq message.
         * @function verify
         * @memberof LuckyBag.ReceiveLuckyBagReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveLuckyBagReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return ReceiveLuckyBagReq;
    })();

    LuckyBag.ReceiveLuckyBagRes = (function() {

        /**
         * Properties of a ReceiveLuckyBagRes.
         * @memberof LuckyBag
         * @interface IReceiveLuckyBagRes
         * @property {LuckyBag.ILuckyBagInfo|null} [luckyBagInfo] ReceiveLuckyBagRes luckyBagInfo
         * @property {BaseInfo.IRewards|null} [rewards] ReceiveLuckyBagRes rewards
         */

        /**
         * Constructs a new ReceiveLuckyBagRes.
         * @memberof LuckyBag
         * @classdesc Represents a ReceiveLuckyBagRes.
         * @implements IReceiveLuckyBagRes
         * @constructor
         * @param {LuckyBag.IReceiveLuckyBagRes=} [properties] Properties to set
         */
        function ReceiveLuckyBagRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReceiveLuckyBagRes luckyBagInfo.
         * @member {LuckyBag.ILuckyBagInfo|null|undefined} luckyBagInfo
         * @memberof LuckyBag.ReceiveLuckyBagRes
         * @instance
         */
        ReceiveLuckyBagRes.prototype.luckyBagInfo = null;

        /**
         * ReceiveLuckyBagRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof LuckyBag.ReceiveLuckyBagRes
         * @instance
         */
        ReceiveLuckyBagRes.prototype.rewards = null;

        /**
         * Creates a new ReceiveLuckyBagRes instance using the specified properties.
         * @function create
         * @memberof LuckyBag.ReceiveLuckyBagRes
         * @static
         * @param {LuckyBag.IReceiveLuckyBagRes=} [properties] Properties to set
         * @returns {LuckyBag.ReceiveLuckyBagRes} ReceiveLuckyBagRes instance
         */
        ReceiveLuckyBagRes.create = function create(properties) {
            return new ReceiveLuckyBagRes(properties);
        };

        /**
         * Encodes the specified ReceiveLuckyBagRes message. Does not implicitly {@link LuckyBag.ReceiveLuckyBagRes.verify|verify} messages.
         * @function encode
         * @memberof LuckyBag.ReceiveLuckyBagRes
         * @static
         * @param {LuckyBag.IReceiveLuckyBagRes} message ReceiveLuckyBagRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveLuckyBagRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.luckyBagInfo != null && message.hasOwnProperty("luckyBagInfo"))
                $root.LuckyBag.LuckyBagInfo.encode(message.luckyBagInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified ReceiveLuckyBagRes message, length delimited. Does not implicitly {@link LuckyBag.ReceiveLuckyBagRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyBag.ReceiveLuckyBagRes
         * @static
         * @param {LuckyBag.IReceiveLuckyBagRes} message ReceiveLuckyBagRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveLuckyBagRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveLuckyBagRes message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyBag.ReceiveLuckyBagRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyBag.ReceiveLuckyBagRes} ReceiveLuckyBagRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveLuckyBagRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyBag.ReceiveLuckyBagRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.luckyBagInfo = $root.LuckyBag.LuckyBagInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveLuckyBagRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyBag.ReceiveLuckyBagRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyBag.ReceiveLuckyBagRes} ReceiveLuckyBagRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveLuckyBagRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveLuckyBagRes message.
         * @function verify
         * @memberof LuckyBag.ReceiveLuckyBagRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveLuckyBagRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.luckyBagInfo != null && message.hasOwnProperty("luckyBagInfo")) {
                var error = $root.LuckyBag.LuckyBagInfo.verify(message.luckyBagInfo);
                if (error)
                    return "luckyBagInfo." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            return null;
        };

        return ReceiveLuckyBagRes;
    })();

    return LuckyBag;
})();

$root.Staff = (function() {

    /**
     * Namespace Staff.
     * @exports Staff
     * @namespace
     */
    var Staff = {};

    Staff.GetStaffSkillGroupReq = (function() {

        /**
         * Properties of a GetStaffSkillGroupReq.
         * @memberof Staff
         * @interface IGetStaffSkillGroupReq
         * @property {string|null} [staffGroupId] GetStaffSkillGroupReq staffGroupId
         */

        /**
         * Constructs a new GetStaffSkillGroupReq.
         * @memberof Staff
         * @classdesc Represents a GetStaffSkillGroupReq.
         * @implements IGetStaffSkillGroupReq
         * @constructor
         * @param {Staff.IGetStaffSkillGroupReq=} [properties] Properties to set
         */
        function GetStaffSkillGroupReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetStaffSkillGroupReq staffGroupId.
         * @member {string} staffGroupId
         * @memberof Staff.GetStaffSkillGroupReq
         * @instance
         */
        GetStaffSkillGroupReq.prototype.staffGroupId = "";

        /**
         * Creates a new GetStaffSkillGroupReq instance using the specified properties.
         * @function create
         * @memberof Staff.GetStaffSkillGroupReq
         * @static
         * @param {Staff.IGetStaffSkillGroupReq=} [properties] Properties to set
         * @returns {Staff.GetStaffSkillGroupReq} GetStaffSkillGroupReq instance
         */
        GetStaffSkillGroupReq.create = function create(properties) {
            return new GetStaffSkillGroupReq(properties);
        };

        /**
         * Encodes the specified GetStaffSkillGroupReq message. Does not implicitly {@link Staff.GetStaffSkillGroupReq.verify|verify} messages.
         * @function encode
         * @memberof Staff.GetStaffSkillGroupReq
         * @static
         * @param {Staff.IGetStaffSkillGroupReq} message GetStaffSkillGroupReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetStaffSkillGroupReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.staffGroupId != null && message.hasOwnProperty("staffGroupId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.staffGroupId);
            return writer;
        };

        /**
         * Encodes the specified GetStaffSkillGroupReq message, length delimited. Does not implicitly {@link Staff.GetStaffSkillGroupReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Staff.GetStaffSkillGroupReq
         * @static
         * @param {Staff.IGetStaffSkillGroupReq} message GetStaffSkillGroupReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetStaffSkillGroupReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetStaffSkillGroupReq message from the specified reader or buffer.
         * @function decode
         * @memberof Staff.GetStaffSkillGroupReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Staff.GetStaffSkillGroupReq} GetStaffSkillGroupReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetStaffSkillGroupReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Staff.GetStaffSkillGroupReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.staffGroupId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetStaffSkillGroupReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Staff.GetStaffSkillGroupReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Staff.GetStaffSkillGroupReq} GetStaffSkillGroupReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetStaffSkillGroupReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetStaffSkillGroupReq message.
         * @function verify
         * @memberof Staff.GetStaffSkillGroupReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetStaffSkillGroupReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.staffGroupId != null && message.hasOwnProperty("staffGroupId"))
                if (!$util.isString(message.staffGroupId))
                    return "staffGroupId: string expected";
            return null;
        };

        return GetStaffSkillGroupReq;
    })();

    Staff.GetStaffSkillGroupRes = (function() {

        /**
         * Properties of a GetStaffSkillGroupRes.
         * @memberof Staff
         * @interface IGetStaffSkillGroupRes
         * @property {BaseInfo.IStaffSkillGroup|null} [group] GetStaffSkillGroupRes group
         * @property {BaseInfo.IStaffSkillEndTimeStamp|null} [endTimeStamp] GetStaffSkillGroupRes endTimeStamp
         */

        /**
         * Constructs a new GetStaffSkillGroupRes.
         * @memberof Staff
         * @classdesc Represents a GetStaffSkillGroupRes.
         * @implements IGetStaffSkillGroupRes
         * @constructor
         * @param {Staff.IGetStaffSkillGroupRes=} [properties] Properties to set
         */
        function GetStaffSkillGroupRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetStaffSkillGroupRes group.
         * @member {BaseInfo.IStaffSkillGroup|null|undefined} group
         * @memberof Staff.GetStaffSkillGroupRes
         * @instance
         */
        GetStaffSkillGroupRes.prototype.group = null;

        /**
         * GetStaffSkillGroupRes endTimeStamp.
         * @member {BaseInfo.IStaffSkillEndTimeStamp|null|undefined} endTimeStamp
         * @memberof Staff.GetStaffSkillGroupRes
         * @instance
         */
        GetStaffSkillGroupRes.prototype.endTimeStamp = null;

        /**
         * Creates a new GetStaffSkillGroupRes instance using the specified properties.
         * @function create
         * @memberof Staff.GetStaffSkillGroupRes
         * @static
         * @param {Staff.IGetStaffSkillGroupRes=} [properties] Properties to set
         * @returns {Staff.GetStaffSkillGroupRes} GetStaffSkillGroupRes instance
         */
        GetStaffSkillGroupRes.create = function create(properties) {
            return new GetStaffSkillGroupRes(properties);
        };

        /**
         * Encodes the specified GetStaffSkillGroupRes message. Does not implicitly {@link Staff.GetStaffSkillGroupRes.verify|verify} messages.
         * @function encode
         * @memberof Staff.GetStaffSkillGroupRes
         * @static
         * @param {Staff.IGetStaffSkillGroupRes} message GetStaffSkillGroupRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetStaffSkillGroupRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.group != null && message.hasOwnProperty("group"))
                $root.BaseInfo.StaffSkillGroup.encode(message.group, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp"))
                $root.BaseInfo.StaffSkillEndTimeStamp.encode(message.endTimeStamp, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetStaffSkillGroupRes message, length delimited. Does not implicitly {@link Staff.GetStaffSkillGroupRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Staff.GetStaffSkillGroupRes
         * @static
         * @param {Staff.IGetStaffSkillGroupRes} message GetStaffSkillGroupRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetStaffSkillGroupRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetStaffSkillGroupRes message from the specified reader or buffer.
         * @function decode
         * @memberof Staff.GetStaffSkillGroupRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Staff.GetStaffSkillGroupRes} GetStaffSkillGroupRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetStaffSkillGroupRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Staff.GetStaffSkillGroupRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.group = $root.BaseInfo.StaffSkillGroup.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.endTimeStamp = $root.BaseInfo.StaffSkillEndTimeStamp.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetStaffSkillGroupRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Staff.GetStaffSkillGroupRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Staff.GetStaffSkillGroupRes} GetStaffSkillGroupRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetStaffSkillGroupRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetStaffSkillGroupRes message.
         * @function verify
         * @memberof Staff.GetStaffSkillGroupRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetStaffSkillGroupRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.group != null && message.hasOwnProperty("group")) {
                var error = $root.BaseInfo.StaffSkillGroup.verify(message.group);
                if (error)
                    return "group." + error;
            }
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp")) {
                var error = $root.BaseInfo.StaffSkillEndTimeStamp.verify(message.endTimeStamp);
                if (error)
                    return "endTimeStamp." + error;
            }
            return null;
        };

        return GetStaffSkillGroupRes;
    })();

    Staff.SkillLevelUpReq = (function() {

        /**
         * Properties of a SkillLevelUpReq.
         * @memberof Staff
         * @interface ISkillLevelUpReq
         * @property {string|null} [skillGroupId] SkillLevelUpReq skillGroupId
         * @property {string|null} [staffGroupId] SkillLevelUpReq staffGroupId
         * @property {BaseInfo.FetchType|null} [fetchType] SkillLevelUpReq fetchType
         */

        /**
         * Constructs a new SkillLevelUpReq.
         * @memberof Staff
         * @classdesc Represents a SkillLevelUpReq.
         * @implements ISkillLevelUpReq
         * @constructor
         * @param {Staff.ISkillLevelUpReq=} [properties] Properties to set
         */
        function SkillLevelUpReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * SkillLevelUpReq skillGroupId.
         * @member {string} skillGroupId
         * @memberof Staff.SkillLevelUpReq
         * @instance
         */
        SkillLevelUpReq.prototype.skillGroupId = "";

        /**
         * SkillLevelUpReq staffGroupId.
         * @member {string} staffGroupId
         * @memberof Staff.SkillLevelUpReq
         * @instance
         */
        SkillLevelUpReq.prototype.staffGroupId = "";

        /**
         * SkillLevelUpReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof Staff.SkillLevelUpReq
         * @instance
         */
        SkillLevelUpReq.prototype.fetchType = 0;

        /**
         * Creates a new SkillLevelUpReq instance using the specified properties.
         * @function create
         * @memberof Staff.SkillLevelUpReq
         * @static
         * @param {Staff.ISkillLevelUpReq=} [properties] Properties to set
         * @returns {Staff.SkillLevelUpReq} SkillLevelUpReq instance
         */
        SkillLevelUpReq.create = function create(properties) {
            return new SkillLevelUpReq(properties);
        };

        /**
         * Encodes the specified SkillLevelUpReq message. Does not implicitly {@link Staff.SkillLevelUpReq.verify|verify} messages.
         * @function encode
         * @memberof Staff.SkillLevelUpReq
         * @static
         * @param {Staff.ISkillLevelUpReq} message SkillLevelUpReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SkillLevelUpReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.skillGroupId != null && message.hasOwnProperty("skillGroupId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.skillGroupId);
            if (message.staffGroupId != null && message.hasOwnProperty("staffGroupId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.staffGroupId);
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified SkillLevelUpReq message, length delimited. Does not implicitly {@link Staff.SkillLevelUpReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Staff.SkillLevelUpReq
         * @static
         * @param {Staff.ISkillLevelUpReq} message SkillLevelUpReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SkillLevelUpReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a SkillLevelUpReq message from the specified reader or buffer.
         * @function decode
         * @memberof Staff.SkillLevelUpReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Staff.SkillLevelUpReq} SkillLevelUpReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SkillLevelUpReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Staff.SkillLevelUpReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.skillGroupId = reader.string();
                    break;
                case 2:
                    message.staffGroupId = reader.string();
                    break;
                case 3:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a SkillLevelUpReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Staff.SkillLevelUpReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Staff.SkillLevelUpReq} SkillLevelUpReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SkillLevelUpReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a SkillLevelUpReq message.
         * @function verify
         * @memberof Staff.SkillLevelUpReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        SkillLevelUpReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.skillGroupId != null && message.hasOwnProperty("skillGroupId"))
                if (!$util.isString(message.skillGroupId))
                    return "skillGroupId: string expected";
            if (message.staffGroupId != null && message.hasOwnProperty("staffGroupId"))
                if (!$util.isString(message.staffGroupId))
                    return "staffGroupId: string expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return SkillLevelUpReq;
    })();

    Staff.SkillLevelUpRes = (function() {

        /**
         * Properties of a SkillLevelUpRes.
         * @memberof Staff
         * @interface ISkillLevelUpRes
         * @property {BaseInfo.IStaffSkillGroup|null} [group] SkillLevelUpRes group
         * @property {BaseInfo.ICurrencyBag|null} [bag] SkillLevelUpRes bag
         * @property {number|Long|null} [endTimeStamp] SkillLevelUpRes endTimeStamp
         */

        /**
         * Constructs a new SkillLevelUpRes.
         * @memberof Staff
         * @classdesc Represents a SkillLevelUpRes.
         * @implements ISkillLevelUpRes
         * @constructor
         * @param {Staff.ISkillLevelUpRes=} [properties] Properties to set
         */
        function SkillLevelUpRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * SkillLevelUpRes group.
         * @member {BaseInfo.IStaffSkillGroup|null|undefined} group
         * @memberof Staff.SkillLevelUpRes
         * @instance
         */
        SkillLevelUpRes.prototype.group = null;

        /**
         * SkillLevelUpRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Staff.SkillLevelUpRes
         * @instance
         */
        SkillLevelUpRes.prototype.bag = null;

        /**
         * SkillLevelUpRes endTimeStamp.
         * @member {number|Long} endTimeStamp
         * @memberof Staff.SkillLevelUpRes
         * @instance
         */
        SkillLevelUpRes.prototype.endTimeStamp = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new SkillLevelUpRes instance using the specified properties.
         * @function create
         * @memberof Staff.SkillLevelUpRes
         * @static
         * @param {Staff.ISkillLevelUpRes=} [properties] Properties to set
         * @returns {Staff.SkillLevelUpRes} SkillLevelUpRes instance
         */
        SkillLevelUpRes.create = function create(properties) {
            return new SkillLevelUpRes(properties);
        };

        /**
         * Encodes the specified SkillLevelUpRes message. Does not implicitly {@link Staff.SkillLevelUpRes.verify|verify} messages.
         * @function encode
         * @memberof Staff.SkillLevelUpRes
         * @static
         * @param {Staff.ISkillLevelUpRes} message SkillLevelUpRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SkillLevelUpRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.group != null && message.hasOwnProperty("group"))
                $root.BaseInfo.StaffSkillGroup.encode(message.group, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp"))
                writer.uint32(/* id 3, wireType 0 =*/24).int64(message.endTimeStamp);
            return writer;
        };

        /**
         * Encodes the specified SkillLevelUpRes message, length delimited. Does not implicitly {@link Staff.SkillLevelUpRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Staff.SkillLevelUpRes
         * @static
         * @param {Staff.ISkillLevelUpRes} message SkillLevelUpRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SkillLevelUpRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a SkillLevelUpRes message from the specified reader or buffer.
         * @function decode
         * @memberof Staff.SkillLevelUpRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Staff.SkillLevelUpRes} SkillLevelUpRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SkillLevelUpRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Staff.SkillLevelUpRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.group = $root.BaseInfo.StaffSkillGroup.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.endTimeStamp = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a SkillLevelUpRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Staff.SkillLevelUpRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Staff.SkillLevelUpRes} SkillLevelUpRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SkillLevelUpRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a SkillLevelUpRes message.
         * @function verify
         * @memberof Staff.SkillLevelUpRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        SkillLevelUpRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.group != null && message.hasOwnProperty("group")) {
                var error = $root.BaseInfo.StaffSkillGroup.verify(message.group);
                if (error)
                    return "group." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp"))
                if (!$util.isInteger(message.endTimeStamp) && !(message.endTimeStamp && $util.isInteger(message.endTimeStamp.low) && $util.isInteger(message.endTimeStamp.high)))
                    return "endTimeStamp: integer|Long expected";
            return null;
        };

        return SkillLevelUpRes;
    })();

    Staff.StaffLevelUpReq = (function() {

        /**
         * Properties of a StaffLevelUpReq.
         * @memberof Staff
         * @interface IStaffLevelUpReq
         * @property {string|null} [staffGroupId] StaffLevelUpReq staffGroupId
         */

        /**
         * Constructs a new StaffLevelUpReq.
         * @memberof Staff
         * @classdesc Represents a StaffLevelUpReq.
         * @implements IStaffLevelUpReq
         * @constructor
         * @param {Staff.IStaffLevelUpReq=} [properties] Properties to set
         */
        function StaffLevelUpReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * StaffLevelUpReq staffGroupId.
         * @member {string} staffGroupId
         * @memberof Staff.StaffLevelUpReq
         * @instance
         */
        StaffLevelUpReq.prototype.staffGroupId = "";

        /**
         * Creates a new StaffLevelUpReq instance using the specified properties.
         * @function create
         * @memberof Staff.StaffLevelUpReq
         * @static
         * @param {Staff.IStaffLevelUpReq=} [properties] Properties to set
         * @returns {Staff.StaffLevelUpReq} StaffLevelUpReq instance
         */
        StaffLevelUpReq.create = function create(properties) {
            return new StaffLevelUpReq(properties);
        };

        /**
         * Encodes the specified StaffLevelUpReq message. Does not implicitly {@link Staff.StaffLevelUpReq.verify|verify} messages.
         * @function encode
         * @memberof Staff.StaffLevelUpReq
         * @static
         * @param {Staff.IStaffLevelUpReq} message StaffLevelUpReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StaffLevelUpReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.staffGroupId != null && message.hasOwnProperty("staffGroupId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.staffGroupId);
            return writer;
        };

        /**
         * Encodes the specified StaffLevelUpReq message, length delimited. Does not implicitly {@link Staff.StaffLevelUpReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Staff.StaffLevelUpReq
         * @static
         * @param {Staff.IStaffLevelUpReq} message StaffLevelUpReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StaffLevelUpReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a StaffLevelUpReq message from the specified reader or buffer.
         * @function decode
         * @memberof Staff.StaffLevelUpReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Staff.StaffLevelUpReq} StaffLevelUpReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StaffLevelUpReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Staff.StaffLevelUpReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.staffGroupId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a StaffLevelUpReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Staff.StaffLevelUpReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Staff.StaffLevelUpReq} StaffLevelUpReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StaffLevelUpReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a StaffLevelUpReq message.
         * @function verify
         * @memberof Staff.StaffLevelUpReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        StaffLevelUpReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.staffGroupId != null && message.hasOwnProperty("staffGroupId"))
                if (!$util.isString(message.staffGroupId))
                    return "staffGroupId: string expected";
            return null;
        };

        return StaffLevelUpReq;
    })();

    Staff.StaffLevelUpRes = (function() {

        /**
         * Properties of a StaffLevelUpRes.
         * @memberof Staff
         * @interface IStaffLevelUpRes
         * @property {BaseInfo.IStaffGroup|null} [group] StaffLevelUpRes group
         * @property {BaseInfo.ICurrencyBag|null} [bag] StaffLevelUpRes bag
         */

        /**
         * Constructs a new StaffLevelUpRes.
         * @memberof Staff
         * @classdesc Represents a StaffLevelUpRes.
         * @implements IStaffLevelUpRes
         * @constructor
         * @param {Staff.IStaffLevelUpRes=} [properties] Properties to set
         */
        function StaffLevelUpRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * StaffLevelUpRes group.
         * @member {BaseInfo.IStaffGroup|null|undefined} group
         * @memberof Staff.StaffLevelUpRes
         * @instance
         */
        StaffLevelUpRes.prototype.group = null;

        /**
         * StaffLevelUpRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Staff.StaffLevelUpRes
         * @instance
         */
        StaffLevelUpRes.prototype.bag = null;

        /**
         * Creates a new StaffLevelUpRes instance using the specified properties.
         * @function create
         * @memberof Staff.StaffLevelUpRes
         * @static
         * @param {Staff.IStaffLevelUpRes=} [properties] Properties to set
         * @returns {Staff.StaffLevelUpRes} StaffLevelUpRes instance
         */
        StaffLevelUpRes.create = function create(properties) {
            return new StaffLevelUpRes(properties);
        };

        /**
         * Encodes the specified StaffLevelUpRes message. Does not implicitly {@link Staff.StaffLevelUpRes.verify|verify} messages.
         * @function encode
         * @memberof Staff.StaffLevelUpRes
         * @static
         * @param {Staff.IStaffLevelUpRes} message StaffLevelUpRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StaffLevelUpRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.group != null && message.hasOwnProperty("group"))
                $root.BaseInfo.StaffGroup.encode(message.group, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified StaffLevelUpRes message, length delimited. Does not implicitly {@link Staff.StaffLevelUpRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Staff.StaffLevelUpRes
         * @static
         * @param {Staff.IStaffLevelUpRes} message StaffLevelUpRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        StaffLevelUpRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a StaffLevelUpRes message from the specified reader or buffer.
         * @function decode
         * @memberof Staff.StaffLevelUpRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Staff.StaffLevelUpRes} StaffLevelUpRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StaffLevelUpRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Staff.StaffLevelUpRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.group = $root.BaseInfo.StaffGroup.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a StaffLevelUpRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Staff.StaffLevelUpRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Staff.StaffLevelUpRes} StaffLevelUpRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        StaffLevelUpRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a StaffLevelUpRes message.
         * @function verify
         * @memberof Staff.StaffLevelUpRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        StaffLevelUpRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.group != null && message.hasOwnProperty("group")) {
                var error = $root.BaseInfo.StaffGroup.verify(message.group);
                if (error)
                    return "group." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return StaffLevelUpRes;
    })();

    Staff.SelectSkillReq = (function() {

        /**
         * Properties of a SelectSkillReq.
         * @memberof Staff
         * @interface ISelectSkillReq
         * @property {string|null} [skillGroupId] SelectSkillReq skillGroupId
         * @property {string|null} [staffGroupId] SelectSkillReq staffGroupId
         */

        /**
         * Constructs a new SelectSkillReq.
         * @memberof Staff
         * @classdesc Represents a SelectSkillReq.
         * @implements ISelectSkillReq
         * @constructor
         * @param {Staff.ISelectSkillReq=} [properties] Properties to set
         */
        function SelectSkillReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * SelectSkillReq skillGroupId.
         * @member {string} skillGroupId
         * @memberof Staff.SelectSkillReq
         * @instance
         */
        SelectSkillReq.prototype.skillGroupId = "";

        /**
         * SelectSkillReq staffGroupId.
         * @member {string} staffGroupId
         * @memberof Staff.SelectSkillReq
         * @instance
         */
        SelectSkillReq.prototype.staffGroupId = "";

        /**
         * Creates a new SelectSkillReq instance using the specified properties.
         * @function create
         * @memberof Staff.SelectSkillReq
         * @static
         * @param {Staff.ISelectSkillReq=} [properties] Properties to set
         * @returns {Staff.SelectSkillReq} SelectSkillReq instance
         */
        SelectSkillReq.create = function create(properties) {
            return new SelectSkillReq(properties);
        };

        /**
         * Encodes the specified SelectSkillReq message. Does not implicitly {@link Staff.SelectSkillReq.verify|verify} messages.
         * @function encode
         * @memberof Staff.SelectSkillReq
         * @static
         * @param {Staff.ISelectSkillReq} message SelectSkillReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SelectSkillReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.skillGroupId != null && message.hasOwnProperty("skillGroupId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.skillGroupId);
            if (message.staffGroupId != null && message.hasOwnProperty("staffGroupId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.staffGroupId);
            return writer;
        };

        /**
         * Encodes the specified SelectSkillReq message, length delimited. Does not implicitly {@link Staff.SelectSkillReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Staff.SelectSkillReq
         * @static
         * @param {Staff.ISelectSkillReq} message SelectSkillReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SelectSkillReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a SelectSkillReq message from the specified reader or buffer.
         * @function decode
         * @memberof Staff.SelectSkillReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Staff.SelectSkillReq} SelectSkillReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SelectSkillReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Staff.SelectSkillReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.skillGroupId = reader.string();
                    break;
                case 2:
                    message.staffGroupId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a SelectSkillReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Staff.SelectSkillReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Staff.SelectSkillReq} SelectSkillReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SelectSkillReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a SelectSkillReq message.
         * @function verify
         * @memberof Staff.SelectSkillReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        SelectSkillReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.skillGroupId != null && message.hasOwnProperty("skillGroupId"))
                if (!$util.isString(message.skillGroupId))
                    return "skillGroupId: string expected";
            if (message.staffGroupId != null && message.hasOwnProperty("staffGroupId"))
                if (!$util.isString(message.staffGroupId))
                    return "staffGroupId: string expected";
            return null;
        };

        return SelectSkillReq;
    })();

    Staff.SelectSkillRes = (function() {

        /**
         * Properties of a SelectSkillRes.
         * @memberof Staff
         * @interface ISelectSkillRes
         * @property {BaseInfo.IStaffGroup|null} [staff] SelectSkillRes staff
         * @property {BaseInfo.IStaffSkillGroup|null} [skill] SelectSkillRes skill
         * @property {BaseInfo.IStaffSkillAmount|null} [skillAmount] SelectSkillRes skillAmount
         * @property {number|Long|null} [endTimeStamp] SelectSkillRes endTimeStamp
         */

        /**
         * Constructs a new SelectSkillRes.
         * @memberof Staff
         * @classdesc Represents a SelectSkillRes.
         * @implements ISelectSkillRes
         * @constructor
         * @param {Staff.ISelectSkillRes=} [properties] Properties to set
         */
        function SelectSkillRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * SelectSkillRes staff.
         * @member {BaseInfo.IStaffGroup|null|undefined} staff
         * @memberof Staff.SelectSkillRes
         * @instance
         */
        SelectSkillRes.prototype.staff = null;

        /**
         * SelectSkillRes skill.
         * @member {BaseInfo.IStaffSkillGroup|null|undefined} skill
         * @memberof Staff.SelectSkillRes
         * @instance
         */
        SelectSkillRes.prototype.skill = null;

        /**
         * SelectSkillRes skillAmount.
         * @member {BaseInfo.IStaffSkillAmount|null|undefined} skillAmount
         * @memberof Staff.SelectSkillRes
         * @instance
         */
        SelectSkillRes.prototype.skillAmount = null;

        /**
         * SelectSkillRes endTimeStamp.
         * @member {number|Long} endTimeStamp
         * @memberof Staff.SelectSkillRes
         * @instance
         */
        SelectSkillRes.prototype.endTimeStamp = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new SelectSkillRes instance using the specified properties.
         * @function create
         * @memberof Staff.SelectSkillRes
         * @static
         * @param {Staff.ISelectSkillRes=} [properties] Properties to set
         * @returns {Staff.SelectSkillRes} SelectSkillRes instance
         */
        SelectSkillRes.create = function create(properties) {
            return new SelectSkillRes(properties);
        };

        /**
         * Encodes the specified SelectSkillRes message. Does not implicitly {@link Staff.SelectSkillRes.verify|verify} messages.
         * @function encode
         * @memberof Staff.SelectSkillRes
         * @static
         * @param {Staff.ISelectSkillRes} message SelectSkillRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SelectSkillRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.staff != null && message.hasOwnProperty("staff"))
                $root.BaseInfo.StaffGroup.encode(message.staff, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.skill != null && message.hasOwnProperty("skill"))
                $root.BaseInfo.StaffSkillGroup.encode(message.skill, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.skillAmount != null && message.hasOwnProperty("skillAmount"))
                $root.BaseInfo.StaffSkillAmount.encode(message.skillAmount, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp"))
                writer.uint32(/* id 4, wireType 0 =*/32).int64(message.endTimeStamp);
            return writer;
        };

        /**
         * Encodes the specified SelectSkillRes message, length delimited. Does not implicitly {@link Staff.SelectSkillRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Staff.SelectSkillRes
         * @static
         * @param {Staff.ISelectSkillRes} message SelectSkillRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SelectSkillRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a SelectSkillRes message from the specified reader or buffer.
         * @function decode
         * @memberof Staff.SelectSkillRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Staff.SelectSkillRes} SelectSkillRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SelectSkillRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Staff.SelectSkillRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.staff = $root.BaseInfo.StaffGroup.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.skill = $root.BaseInfo.StaffSkillGroup.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.skillAmount = $root.BaseInfo.StaffSkillAmount.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.endTimeStamp = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a SelectSkillRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Staff.SelectSkillRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Staff.SelectSkillRes} SelectSkillRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SelectSkillRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a SelectSkillRes message.
         * @function verify
         * @memberof Staff.SelectSkillRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        SelectSkillRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.staff != null && message.hasOwnProperty("staff")) {
                var error = $root.BaseInfo.StaffGroup.verify(message.staff);
                if (error)
                    return "staff." + error;
            }
            if (message.skill != null && message.hasOwnProperty("skill")) {
                var error = $root.BaseInfo.StaffSkillGroup.verify(message.skill);
                if (error)
                    return "skill." + error;
            }
            if (message.skillAmount != null && message.hasOwnProperty("skillAmount")) {
                var error = $root.BaseInfo.StaffSkillAmount.verify(message.skillAmount);
                if (error)
                    return "skillAmount." + error;
            }
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp"))
                if (!$util.isInteger(message.endTimeStamp) && !(message.endTimeStamp && $util.isInteger(message.endTimeStamp.low) && $util.isInteger(message.endTimeStamp.high)))
                    return "endTimeStamp: integer|Long expected";
            return null;
        };

        return SelectSkillRes;
    })();

    Staff.GetStaffGroupReq = (function() {

        /**
         * Properties of a GetStaffGroupReq.
         * @memberof Staff
         * @interface IGetStaffGroupReq
         */

        /**
         * Constructs a new GetStaffGroupReq.
         * @memberof Staff
         * @classdesc Represents a GetStaffGroupReq.
         * @implements IGetStaffGroupReq
         * @constructor
         * @param {Staff.IGetStaffGroupReq=} [properties] Properties to set
         */
        function GetStaffGroupReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetStaffGroupReq instance using the specified properties.
         * @function create
         * @memberof Staff.GetStaffGroupReq
         * @static
         * @param {Staff.IGetStaffGroupReq=} [properties] Properties to set
         * @returns {Staff.GetStaffGroupReq} GetStaffGroupReq instance
         */
        GetStaffGroupReq.create = function create(properties) {
            return new GetStaffGroupReq(properties);
        };

        /**
         * Encodes the specified GetStaffGroupReq message. Does not implicitly {@link Staff.GetStaffGroupReq.verify|verify} messages.
         * @function encode
         * @memberof Staff.GetStaffGroupReq
         * @static
         * @param {Staff.IGetStaffGroupReq} message GetStaffGroupReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetStaffGroupReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetStaffGroupReq message, length delimited. Does not implicitly {@link Staff.GetStaffGroupReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Staff.GetStaffGroupReq
         * @static
         * @param {Staff.IGetStaffGroupReq} message GetStaffGroupReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetStaffGroupReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetStaffGroupReq message from the specified reader or buffer.
         * @function decode
         * @memberof Staff.GetStaffGroupReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Staff.GetStaffGroupReq} GetStaffGroupReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetStaffGroupReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Staff.GetStaffGroupReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetStaffGroupReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Staff.GetStaffGroupReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Staff.GetStaffGroupReq} GetStaffGroupReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetStaffGroupReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetStaffGroupReq message.
         * @function verify
         * @memberof Staff.GetStaffGroupReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetStaffGroupReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetStaffGroupReq;
    })();

    Staff.GetStaffGroupRes = (function() {

        /**
         * Properties of a GetStaffGroupRes.
         * @memberof Staff
         * @interface IGetStaffGroupRes
         * @property {BaseInfo.IStaffGroup|null} [group] GetStaffGroupRes group
         * @property {BaseInfo.IStaffSkillAmount|null} [skillAmount] GetStaffGroupRes skillAmount
         */

        /**
         * Constructs a new GetStaffGroupRes.
         * @memberof Staff
         * @classdesc Represents a GetStaffGroupRes.
         * @implements IGetStaffGroupRes
         * @constructor
         * @param {Staff.IGetStaffGroupRes=} [properties] Properties to set
         */
        function GetStaffGroupRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetStaffGroupRes group.
         * @member {BaseInfo.IStaffGroup|null|undefined} group
         * @memberof Staff.GetStaffGroupRes
         * @instance
         */
        GetStaffGroupRes.prototype.group = null;

        /**
         * GetStaffGroupRes skillAmount.
         * @member {BaseInfo.IStaffSkillAmount|null|undefined} skillAmount
         * @memberof Staff.GetStaffGroupRes
         * @instance
         */
        GetStaffGroupRes.prototype.skillAmount = null;

        /**
         * Creates a new GetStaffGroupRes instance using the specified properties.
         * @function create
         * @memberof Staff.GetStaffGroupRes
         * @static
         * @param {Staff.IGetStaffGroupRes=} [properties] Properties to set
         * @returns {Staff.GetStaffGroupRes} GetStaffGroupRes instance
         */
        GetStaffGroupRes.create = function create(properties) {
            return new GetStaffGroupRes(properties);
        };

        /**
         * Encodes the specified GetStaffGroupRes message. Does not implicitly {@link Staff.GetStaffGroupRes.verify|verify} messages.
         * @function encode
         * @memberof Staff.GetStaffGroupRes
         * @static
         * @param {Staff.IGetStaffGroupRes} message GetStaffGroupRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetStaffGroupRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.group != null && message.hasOwnProperty("group"))
                $root.BaseInfo.StaffGroup.encode(message.group, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.skillAmount != null && message.hasOwnProperty("skillAmount"))
                $root.BaseInfo.StaffSkillAmount.encode(message.skillAmount, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetStaffGroupRes message, length delimited. Does not implicitly {@link Staff.GetStaffGroupRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Staff.GetStaffGroupRes
         * @static
         * @param {Staff.IGetStaffGroupRes} message GetStaffGroupRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetStaffGroupRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetStaffGroupRes message from the specified reader or buffer.
         * @function decode
         * @memberof Staff.GetStaffGroupRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Staff.GetStaffGroupRes} GetStaffGroupRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetStaffGroupRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Staff.GetStaffGroupRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.group = $root.BaseInfo.StaffGroup.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.skillAmount = $root.BaseInfo.StaffSkillAmount.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetStaffGroupRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Staff.GetStaffGroupRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Staff.GetStaffGroupRes} GetStaffGroupRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetStaffGroupRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetStaffGroupRes message.
         * @function verify
         * @memberof Staff.GetStaffGroupRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetStaffGroupRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.group != null && message.hasOwnProperty("group")) {
                var error = $root.BaseInfo.StaffGroup.verify(message.group);
                if (error)
                    return "group." + error;
            }
            if (message.skillAmount != null && message.hasOwnProperty("skillAmount")) {
                var error = $root.BaseInfo.StaffSkillAmount.verify(message.skillAmount);
                if (error)
                    return "skillAmount." + error;
            }
            return null;
        };

        return GetStaffGroupRes;
    })();

    Staff.ReduceCDTimeReq = (function() {

        /**
         * Properties of a ReduceCDTimeReq.
         * @memberof Staff
         * @interface IReduceCDTimeReq
         * @property {string|null} [skillGroupId] ReduceCDTimeReq skillGroupId
         * @property {string|null} [staffGroupId] ReduceCDTimeReq staffGroupId
         */

        /**
         * Constructs a new ReduceCDTimeReq.
         * @memberof Staff
         * @classdesc Represents a ReduceCDTimeReq.
         * @implements IReduceCDTimeReq
         * @constructor
         * @param {Staff.IReduceCDTimeReq=} [properties] Properties to set
         */
        function ReduceCDTimeReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReduceCDTimeReq skillGroupId.
         * @member {string} skillGroupId
         * @memberof Staff.ReduceCDTimeReq
         * @instance
         */
        ReduceCDTimeReq.prototype.skillGroupId = "";

        /**
         * ReduceCDTimeReq staffGroupId.
         * @member {string} staffGroupId
         * @memberof Staff.ReduceCDTimeReq
         * @instance
         */
        ReduceCDTimeReq.prototype.staffGroupId = "";

        /**
         * Creates a new ReduceCDTimeReq instance using the specified properties.
         * @function create
         * @memberof Staff.ReduceCDTimeReq
         * @static
         * @param {Staff.IReduceCDTimeReq=} [properties] Properties to set
         * @returns {Staff.ReduceCDTimeReq} ReduceCDTimeReq instance
         */
        ReduceCDTimeReq.create = function create(properties) {
            return new ReduceCDTimeReq(properties);
        };

        /**
         * Encodes the specified ReduceCDTimeReq message. Does not implicitly {@link Staff.ReduceCDTimeReq.verify|verify} messages.
         * @function encode
         * @memberof Staff.ReduceCDTimeReq
         * @static
         * @param {Staff.IReduceCDTimeReq} message ReduceCDTimeReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReduceCDTimeReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.skillGroupId != null && message.hasOwnProperty("skillGroupId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.skillGroupId);
            if (message.staffGroupId != null && message.hasOwnProperty("staffGroupId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.staffGroupId);
            return writer;
        };

        /**
         * Encodes the specified ReduceCDTimeReq message, length delimited. Does not implicitly {@link Staff.ReduceCDTimeReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Staff.ReduceCDTimeReq
         * @static
         * @param {Staff.IReduceCDTimeReq} message ReduceCDTimeReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReduceCDTimeReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReduceCDTimeReq message from the specified reader or buffer.
         * @function decode
         * @memberof Staff.ReduceCDTimeReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Staff.ReduceCDTimeReq} ReduceCDTimeReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReduceCDTimeReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Staff.ReduceCDTimeReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.skillGroupId = reader.string();
                    break;
                case 2:
                    message.staffGroupId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReduceCDTimeReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Staff.ReduceCDTimeReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Staff.ReduceCDTimeReq} ReduceCDTimeReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReduceCDTimeReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReduceCDTimeReq message.
         * @function verify
         * @memberof Staff.ReduceCDTimeReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReduceCDTimeReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.skillGroupId != null && message.hasOwnProperty("skillGroupId"))
                if (!$util.isString(message.skillGroupId))
                    return "skillGroupId: string expected";
            if (message.staffGroupId != null && message.hasOwnProperty("staffGroupId"))
                if (!$util.isString(message.staffGroupId))
                    return "staffGroupId: string expected";
            return null;
        };

        return ReduceCDTimeReq;
    })();

    Staff.ReduceCDTimeRes = (function() {

        /**
         * Properties of a ReduceCDTimeRes.
         * @memberof Staff
         * @interface IReduceCDTimeRes
         * @property {number|Long|null} [endTimeStamp] ReduceCDTimeRes endTimeStamp
         */

        /**
         * Constructs a new ReduceCDTimeRes.
         * @memberof Staff
         * @classdesc Represents a ReduceCDTimeRes.
         * @implements IReduceCDTimeRes
         * @constructor
         * @param {Staff.IReduceCDTimeRes=} [properties] Properties to set
         */
        function ReduceCDTimeRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReduceCDTimeRes endTimeStamp.
         * @member {number|Long} endTimeStamp
         * @memberof Staff.ReduceCDTimeRes
         * @instance
         */
        ReduceCDTimeRes.prototype.endTimeStamp = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new ReduceCDTimeRes instance using the specified properties.
         * @function create
         * @memberof Staff.ReduceCDTimeRes
         * @static
         * @param {Staff.IReduceCDTimeRes=} [properties] Properties to set
         * @returns {Staff.ReduceCDTimeRes} ReduceCDTimeRes instance
         */
        ReduceCDTimeRes.create = function create(properties) {
            return new ReduceCDTimeRes(properties);
        };

        /**
         * Encodes the specified ReduceCDTimeRes message. Does not implicitly {@link Staff.ReduceCDTimeRes.verify|verify} messages.
         * @function encode
         * @memberof Staff.ReduceCDTimeRes
         * @static
         * @param {Staff.IReduceCDTimeRes} message ReduceCDTimeRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReduceCDTimeRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp"))
                writer.uint32(/* id 1, wireType 0 =*/8).int64(message.endTimeStamp);
            return writer;
        };

        /**
         * Encodes the specified ReduceCDTimeRes message, length delimited. Does not implicitly {@link Staff.ReduceCDTimeRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Staff.ReduceCDTimeRes
         * @static
         * @param {Staff.IReduceCDTimeRes} message ReduceCDTimeRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReduceCDTimeRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReduceCDTimeRes message from the specified reader or buffer.
         * @function decode
         * @memberof Staff.ReduceCDTimeRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Staff.ReduceCDTimeRes} ReduceCDTimeRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReduceCDTimeRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Staff.ReduceCDTimeRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.endTimeStamp = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReduceCDTimeRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Staff.ReduceCDTimeRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Staff.ReduceCDTimeRes} ReduceCDTimeRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReduceCDTimeRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReduceCDTimeRes message.
         * @function verify
         * @memberof Staff.ReduceCDTimeRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReduceCDTimeRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.endTimeStamp != null && message.hasOwnProperty("endTimeStamp"))
                if (!$util.isInteger(message.endTimeStamp) && !(message.endTimeStamp && $util.isInteger(message.endTimeStamp.low) && $util.isInteger(message.endTimeStamp.high)))
                    return "endTimeStamp: integer|Long expected";
            return null;
        };

        return ReduceCDTimeRes;
    })();

    return Staff;
})();

$root.Sign = (function() {

    /**
     * Namespace Sign.
     * @exports Sign
     * @namespace
     */
    var Sign = {};

    Sign.GetSignInfoReq = (function() {

        /**
         * Properties of a GetSignInfoReq.
         * @memberof Sign
         * @interface IGetSignInfoReq
         */

        /**
         * Constructs a new GetSignInfoReq.
         * @memberof Sign
         * @classdesc Represents a GetSignInfoReq.
         * @implements IGetSignInfoReq
         * @constructor
         * @param {Sign.IGetSignInfoReq=} [properties] Properties to set
         */
        function GetSignInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetSignInfoReq instance using the specified properties.
         * @function create
         * @memberof Sign.GetSignInfoReq
         * @static
         * @param {Sign.IGetSignInfoReq=} [properties] Properties to set
         * @returns {Sign.GetSignInfoReq} GetSignInfoReq instance
         */
        GetSignInfoReq.create = function create(properties) {
            return new GetSignInfoReq(properties);
        };

        /**
         * Encodes the specified GetSignInfoReq message. Does not implicitly {@link Sign.GetSignInfoReq.verify|verify} messages.
         * @function encode
         * @memberof Sign.GetSignInfoReq
         * @static
         * @param {Sign.IGetSignInfoReq} message GetSignInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetSignInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetSignInfoReq message, length delimited. Does not implicitly {@link Sign.GetSignInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Sign.GetSignInfoReq
         * @static
         * @param {Sign.IGetSignInfoReq} message GetSignInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetSignInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetSignInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof Sign.GetSignInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Sign.GetSignInfoReq} GetSignInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetSignInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Sign.GetSignInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetSignInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Sign.GetSignInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Sign.GetSignInfoReq} GetSignInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetSignInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetSignInfoReq message.
         * @function verify
         * @memberof Sign.GetSignInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetSignInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetSignInfoReq;
    })();

    Sign.GetSignInfoRes = (function() {

        /**
         * Properties of a GetSignInfoRes.
         * @memberof Sign
         * @interface IGetSignInfoRes
         * @property {BaseInfo.ISignInfo|null} [signInfo] GetSignInfoRes signInfo
         */

        /**
         * Constructs a new GetSignInfoRes.
         * @memberof Sign
         * @classdesc Represents a GetSignInfoRes.
         * @implements IGetSignInfoRes
         * @constructor
         * @param {Sign.IGetSignInfoRes=} [properties] Properties to set
         */
        function GetSignInfoRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetSignInfoRes signInfo.
         * @member {BaseInfo.ISignInfo|null|undefined} signInfo
         * @memberof Sign.GetSignInfoRes
         * @instance
         */
        GetSignInfoRes.prototype.signInfo = null;

        /**
         * Creates a new GetSignInfoRes instance using the specified properties.
         * @function create
         * @memberof Sign.GetSignInfoRes
         * @static
         * @param {Sign.IGetSignInfoRes=} [properties] Properties to set
         * @returns {Sign.GetSignInfoRes} GetSignInfoRes instance
         */
        GetSignInfoRes.create = function create(properties) {
            return new GetSignInfoRes(properties);
        };

        /**
         * Encodes the specified GetSignInfoRes message. Does not implicitly {@link Sign.GetSignInfoRes.verify|verify} messages.
         * @function encode
         * @memberof Sign.GetSignInfoRes
         * @static
         * @param {Sign.IGetSignInfoRes} message GetSignInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetSignInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.signInfo != null && message.hasOwnProperty("signInfo"))
                $root.BaseInfo.SignInfo.encode(message.signInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetSignInfoRes message, length delimited. Does not implicitly {@link Sign.GetSignInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Sign.GetSignInfoRes
         * @static
         * @param {Sign.IGetSignInfoRes} message GetSignInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetSignInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetSignInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof Sign.GetSignInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Sign.GetSignInfoRes} GetSignInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetSignInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Sign.GetSignInfoRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.signInfo = $root.BaseInfo.SignInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetSignInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Sign.GetSignInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Sign.GetSignInfoRes} GetSignInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetSignInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetSignInfoRes message.
         * @function verify
         * @memberof Sign.GetSignInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetSignInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.signInfo != null && message.hasOwnProperty("signInfo")) {
                var error = $root.BaseInfo.SignInfo.verify(message.signInfo);
                if (error)
                    return "signInfo." + error;
            }
            return null;
        };

        return GetSignInfoRes;
    })();

    Sign.GetSignRewardReq = (function() {

        /**
         * Properties of a GetSignRewardReq.
         * @memberof Sign
         * @interface IGetSignRewardReq
         */

        /**
         * Constructs a new GetSignRewardReq.
         * @memberof Sign
         * @classdesc Represents a GetSignRewardReq.
         * @implements IGetSignRewardReq
         * @constructor
         * @param {Sign.IGetSignRewardReq=} [properties] Properties to set
         */
        function GetSignRewardReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetSignRewardReq instance using the specified properties.
         * @function create
         * @memberof Sign.GetSignRewardReq
         * @static
         * @param {Sign.IGetSignRewardReq=} [properties] Properties to set
         * @returns {Sign.GetSignRewardReq} GetSignRewardReq instance
         */
        GetSignRewardReq.create = function create(properties) {
            return new GetSignRewardReq(properties);
        };

        /**
         * Encodes the specified GetSignRewardReq message. Does not implicitly {@link Sign.GetSignRewardReq.verify|verify} messages.
         * @function encode
         * @memberof Sign.GetSignRewardReq
         * @static
         * @param {Sign.IGetSignRewardReq} message GetSignRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetSignRewardReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetSignRewardReq message, length delimited. Does not implicitly {@link Sign.GetSignRewardReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Sign.GetSignRewardReq
         * @static
         * @param {Sign.IGetSignRewardReq} message GetSignRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetSignRewardReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetSignRewardReq message from the specified reader or buffer.
         * @function decode
         * @memberof Sign.GetSignRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Sign.GetSignRewardReq} GetSignRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetSignRewardReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Sign.GetSignRewardReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetSignRewardReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Sign.GetSignRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Sign.GetSignRewardReq} GetSignRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetSignRewardReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetSignRewardReq message.
         * @function verify
         * @memberof Sign.GetSignRewardReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetSignRewardReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetSignRewardReq;
    })();

    Sign.GetSignRewardRes = (function() {

        /**
         * Properties of a GetSignRewardRes.
         * @memberof Sign
         * @interface IGetSignRewardRes
         * @property {BaseInfo.ICurrencyBag|null} [bag] GetSignRewardRes bag
         * @property {BaseInfo.IStaffGroup|null} [staff] GetSignRewardRes staff
         * @property {BaseInfo.ISignInfo|null} [signInfo] GetSignRewardRes signInfo
         */

        /**
         * Constructs a new GetSignRewardRes.
         * @memberof Sign
         * @classdesc Represents a GetSignRewardRes.
         * @implements IGetSignRewardRes
         * @constructor
         * @param {Sign.IGetSignRewardRes=} [properties] Properties to set
         */
        function GetSignRewardRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetSignRewardRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Sign.GetSignRewardRes
         * @instance
         */
        GetSignRewardRes.prototype.bag = null;

        /**
         * GetSignRewardRes staff.
         * @member {BaseInfo.IStaffGroup|null|undefined} staff
         * @memberof Sign.GetSignRewardRes
         * @instance
         */
        GetSignRewardRes.prototype.staff = null;

        /**
         * GetSignRewardRes signInfo.
         * @member {BaseInfo.ISignInfo|null|undefined} signInfo
         * @memberof Sign.GetSignRewardRes
         * @instance
         */
        GetSignRewardRes.prototype.signInfo = null;

        /**
         * Creates a new GetSignRewardRes instance using the specified properties.
         * @function create
         * @memberof Sign.GetSignRewardRes
         * @static
         * @param {Sign.IGetSignRewardRes=} [properties] Properties to set
         * @returns {Sign.GetSignRewardRes} GetSignRewardRes instance
         */
        GetSignRewardRes.create = function create(properties) {
            return new GetSignRewardRes(properties);
        };

        /**
         * Encodes the specified GetSignRewardRes message. Does not implicitly {@link Sign.GetSignRewardRes.verify|verify} messages.
         * @function encode
         * @memberof Sign.GetSignRewardRes
         * @static
         * @param {Sign.IGetSignRewardRes} message GetSignRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetSignRewardRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.staff != null && message.hasOwnProperty("staff"))
                $root.BaseInfo.StaffGroup.encode(message.staff, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.signInfo != null && message.hasOwnProperty("signInfo"))
                $root.BaseInfo.SignInfo.encode(message.signInfo, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetSignRewardRes message, length delimited. Does not implicitly {@link Sign.GetSignRewardRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Sign.GetSignRewardRes
         * @static
         * @param {Sign.IGetSignRewardRes} message GetSignRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetSignRewardRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetSignRewardRes message from the specified reader or buffer.
         * @function decode
         * @memberof Sign.GetSignRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Sign.GetSignRewardRes} GetSignRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetSignRewardRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Sign.GetSignRewardRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.staff = $root.BaseInfo.StaffGroup.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.signInfo = $root.BaseInfo.SignInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetSignRewardRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Sign.GetSignRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Sign.GetSignRewardRes} GetSignRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetSignRewardRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetSignRewardRes message.
         * @function verify
         * @memberof Sign.GetSignRewardRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetSignRewardRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.staff != null && message.hasOwnProperty("staff")) {
                var error = $root.BaseInfo.StaffGroup.verify(message.staff);
                if (error)
                    return "staff." + error;
            }
            if (message.signInfo != null && message.hasOwnProperty("signInfo")) {
                var error = $root.BaseInfo.SignInfo.verify(message.signInfo);
                if (error)
                    return "signInfo." + error;
            }
            return null;
        };

        return GetSignRewardRes;
    })();

    return Sign;
})();

$root.Wharf = (function() {

    /**
     * Namespace Wharf.
     * @exports Wharf
     * @namespace
     */
    var Wharf = {};

    Wharf.GetWharfInfoReq = (function() {

        /**
         * Properties of a GetWharfInfoReq.
         * @memberof Wharf
         * @interface IGetWharfInfoReq
         */

        /**
         * Constructs a new GetWharfInfoReq.
         * @memberof Wharf
         * @classdesc Represents a GetWharfInfoReq.
         * @implements IGetWharfInfoReq
         * @constructor
         * @param {Wharf.IGetWharfInfoReq=} [properties] Properties to set
         */
        function GetWharfInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetWharfInfoReq instance using the specified properties.
         * @function create
         * @memberof Wharf.GetWharfInfoReq
         * @static
         * @param {Wharf.IGetWharfInfoReq=} [properties] Properties to set
         * @returns {Wharf.GetWharfInfoReq} GetWharfInfoReq instance
         */
        GetWharfInfoReq.create = function create(properties) {
            return new GetWharfInfoReq(properties);
        };

        /**
         * Encodes the specified GetWharfInfoReq message. Does not implicitly {@link Wharf.GetWharfInfoReq.verify|verify} messages.
         * @function encode
         * @memberof Wharf.GetWharfInfoReq
         * @static
         * @param {Wharf.IGetWharfInfoReq} message GetWharfInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetWharfInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetWharfInfoReq message, length delimited. Does not implicitly {@link Wharf.GetWharfInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.GetWharfInfoReq
         * @static
         * @param {Wharf.IGetWharfInfoReq} message GetWharfInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetWharfInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetWharfInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.GetWharfInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.GetWharfInfoReq} GetWharfInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetWharfInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.GetWharfInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetWharfInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.GetWharfInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.GetWharfInfoReq} GetWharfInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetWharfInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetWharfInfoReq message.
         * @function verify
         * @memberof Wharf.GetWharfInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetWharfInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetWharfInfoReq;
    })();

    Wharf.GetWharfInfoRes = (function() {

        /**
         * Properties of a GetWharfInfoRes.
         * @memberof Wharf
         * @interface IGetWharfInfoRes
         * @property {BaseInfo.INauticalProjectGroup|null} [nauticalProjectGroup] GetWharfInfoRes nauticalProjectGroup
         * @property {BaseInfo.IWharfLetterBox|null} [wharfLetterBox] GetWharfInfoRes wharfLetterBox
         * @property {BaseInfo.IAidedGroupInfo|null} [aidedGroupInfo] GetWharfInfoRes aidedGroupInfo
         */

        /**
         * Constructs a new GetWharfInfoRes.
         * @memberof Wharf
         * @classdesc Represents a GetWharfInfoRes.
         * @implements IGetWharfInfoRes
         * @constructor
         * @param {Wharf.IGetWharfInfoRes=} [properties] Properties to set
         */
        function GetWharfInfoRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetWharfInfoRes nauticalProjectGroup.
         * @member {BaseInfo.INauticalProjectGroup|null|undefined} nauticalProjectGroup
         * @memberof Wharf.GetWharfInfoRes
         * @instance
         */
        GetWharfInfoRes.prototype.nauticalProjectGroup = null;

        /**
         * GetWharfInfoRes wharfLetterBox.
         * @member {BaseInfo.IWharfLetterBox|null|undefined} wharfLetterBox
         * @memberof Wharf.GetWharfInfoRes
         * @instance
         */
        GetWharfInfoRes.prototype.wharfLetterBox = null;

        /**
         * GetWharfInfoRes aidedGroupInfo.
         * @member {BaseInfo.IAidedGroupInfo|null|undefined} aidedGroupInfo
         * @memberof Wharf.GetWharfInfoRes
         * @instance
         */
        GetWharfInfoRes.prototype.aidedGroupInfo = null;

        /**
         * Creates a new GetWharfInfoRes instance using the specified properties.
         * @function create
         * @memberof Wharf.GetWharfInfoRes
         * @static
         * @param {Wharf.IGetWharfInfoRes=} [properties] Properties to set
         * @returns {Wharf.GetWharfInfoRes} GetWharfInfoRes instance
         */
        GetWharfInfoRes.create = function create(properties) {
            return new GetWharfInfoRes(properties);
        };

        /**
         * Encodes the specified GetWharfInfoRes message. Does not implicitly {@link Wharf.GetWharfInfoRes.verify|verify} messages.
         * @function encode
         * @memberof Wharf.GetWharfInfoRes
         * @static
         * @param {Wharf.IGetWharfInfoRes} message GetWharfInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetWharfInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.nauticalProjectGroup != null && message.hasOwnProperty("nauticalProjectGroup"))
                $root.BaseInfo.NauticalProjectGroup.encode(message.nauticalProjectGroup, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.wharfLetterBox != null && message.hasOwnProperty("wharfLetterBox"))
                $root.BaseInfo.WharfLetterBox.encode(message.wharfLetterBox, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo"))
                $root.BaseInfo.AidedGroupInfo.encode(message.aidedGroupInfo, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetWharfInfoRes message, length delimited. Does not implicitly {@link Wharf.GetWharfInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.GetWharfInfoRes
         * @static
         * @param {Wharf.IGetWharfInfoRes} message GetWharfInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetWharfInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetWharfInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.GetWharfInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.GetWharfInfoRes} GetWharfInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetWharfInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.GetWharfInfoRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.nauticalProjectGroup = $root.BaseInfo.NauticalProjectGroup.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.wharfLetterBox = $root.BaseInfo.WharfLetterBox.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.aidedGroupInfo = $root.BaseInfo.AidedGroupInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetWharfInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.GetWharfInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.GetWharfInfoRes} GetWharfInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetWharfInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetWharfInfoRes message.
         * @function verify
         * @memberof Wharf.GetWharfInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetWharfInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.nauticalProjectGroup != null && message.hasOwnProperty("nauticalProjectGroup")) {
                var error = $root.BaseInfo.NauticalProjectGroup.verify(message.nauticalProjectGroup);
                if (error)
                    return "nauticalProjectGroup." + error;
            }
            if (message.wharfLetterBox != null && message.hasOwnProperty("wharfLetterBox")) {
                var error = $root.BaseInfo.WharfLetterBox.verify(message.wharfLetterBox);
                if (error)
                    return "wharfLetterBox." + error;
            }
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo")) {
                var error = $root.BaseInfo.AidedGroupInfo.verify(message.aidedGroupInfo);
                if (error)
                    return "aidedGroupInfo." + error;
            }
            return null;
        };

        return GetWharfInfoRes;
    })();

    Wharf.GetNauticalProjectGroupReq = (function() {

        /**
         * Properties of a GetNauticalProjectGroupReq.
         * @memberof Wharf
         * @interface IGetNauticalProjectGroupReq
         */

        /**
         * Constructs a new GetNauticalProjectGroupReq.
         * @memberof Wharf
         * @classdesc Represents a GetNauticalProjectGroupReq.
         * @implements IGetNauticalProjectGroupReq
         * @constructor
         * @param {Wharf.IGetNauticalProjectGroupReq=} [properties] Properties to set
         */
        function GetNauticalProjectGroupReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetNauticalProjectGroupReq instance using the specified properties.
         * @function create
         * @memberof Wharf.GetNauticalProjectGroupReq
         * @static
         * @param {Wharf.IGetNauticalProjectGroupReq=} [properties] Properties to set
         * @returns {Wharf.GetNauticalProjectGroupReq} GetNauticalProjectGroupReq instance
         */
        GetNauticalProjectGroupReq.create = function create(properties) {
            return new GetNauticalProjectGroupReq(properties);
        };

        /**
         * Encodes the specified GetNauticalProjectGroupReq message. Does not implicitly {@link Wharf.GetNauticalProjectGroupReq.verify|verify} messages.
         * @function encode
         * @memberof Wharf.GetNauticalProjectGroupReq
         * @static
         * @param {Wharf.IGetNauticalProjectGroupReq} message GetNauticalProjectGroupReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetNauticalProjectGroupReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetNauticalProjectGroupReq message, length delimited. Does not implicitly {@link Wharf.GetNauticalProjectGroupReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.GetNauticalProjectGroupReq
         * @static
         * @param {Wharf.IGetNauticalProjectGroupReq} message GetNauticalProjectGroupReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetNauticalProjectGroupReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetNauticalProjectGroupReq message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.GetNauticalProjectGroupReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.GetNauticalProjectGroupReq} GetNauticalProjectGroupReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetNauticalProjectGroupReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.GetNauticalProjectGroupReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetNauticalProjectGroupReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.GetNauticalProjectGroupReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.GetNauticalProjectGroupReq} GetNauticalProjectGroupReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetNauticalProjectGroupReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetNauticalProjectGroupReq message.
         * @function verify
         * @memberof Wharf.GetNauticalProjectGroupReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetNauticalProjectGroupReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetNauticalProjectGroupReq;
    })();

    Wharf.GetNauticalProjectGroupRes = (function() {

        /**
         * Properties of a GetNauticalProjectGroupRes.
         * @memberof Wharf
         * @interface IGetNauticalProjectGroupRes
         * @property {BaseInfo.INauticalProjectGroup|null} [group] GetNauticalProjectGroupRes group
         */

        /**
         * Constructs a new GetNauticalProjectGroupRes.
         * @memberof Wharf
         * @classdesc Represents a GetNauticalProjectGroupRes.
         * @implements IGetNauticalProjectGroupRes
         * @constructor
         * @param {Wharf.IGetNauticalProjectGroupRes=} [properties] Properties to set
         */
        function GetNauticalProjectGroupRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetNauticalProjectGroupRes group.
         * @member {BaseInfo.INauticalProjectGroup|null|undefined} group
         * @memberof Wharf.GetNauticalProjectGroupRes
         * @instance
         */
        GetNauticalProjectGroupRes.prototype.group = null;

        /**
         * Creates a new GetNauticalProjectGroupRes instance using the specified properties.
         * @function create
         * @memberof Wharf.GetNauticalProjectGroupRes
         * @static
         * @param {Wharf.IGetNauticalProjectGroupRes=} [properties] Properties to set
         * @returns {Wharf.GetNauticalProjectGroupRes} GetNauticalProjectGroupRes instance
         */
        GetNauticalProjectGroupRes.create = function create(properties) {
            return new GetNauticalProjectGroupRes(properties);
        };

        /**
         * Encodes the specified GetNauticalProjectGroupRes message. Does not implicitly {@link Wharf.GetNauticalProjectGroupRes.verify|verify} messages.
         * @function encode
         * @memberof Wharf.GetNauticalProjectGroupRes
         * @static
         * @param {Wharf.IGetNauticalProjectGroupRes} message GetNauticalProjectGroupRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetNauticalProjectGroupRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.group != null && message.hasOwnProperty("group"))
                $root.BaseInfo.NauticalProjectGroup.encode(message.group, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetNauticalProjectGroupRes message, length delimited. Does not implicitly {@link Wharf.GetNauticalProjectGroupRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.GetNauticalProjectGroupRes
         * @static
         * @param {Wharf.IGetNauticalProjectGroupRes} message GetNauticalProjectGroupRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetNauticalProjectGroupRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetNauticalProjectGroupRes message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.GetNauticalProjectGroupRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.GetNauticalProjectGroupRes} GetNauticalProjectGroupRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetNauticalProjectGroupRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.GetNauticalProjectGroupRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.group = $root.BaseInfo.NauticalProjectGroup.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetNauticalProjectGroupRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.GetNauticalProjectGroupRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.GetNauticalProjectGroupRes} GetNauticalProjectGroupRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetNauticalProjectGroupRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetNauticalProjectGroupRes message.
         * @function verify
         * @memberof Wharf.GetNauticalProjectGroupRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetNauticalProjectGroupRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.group != null && message.hasOwnProperty("group")) {
                var error = $root.BaseInfo.NauticalProjectGroup.verify(message.group);
                if (error)
                    return "group." + error;
            }
            return null;
        };

        return GetNauticalProjectGroupRes;
    })();

    Wharf.ProjectLevelUpReq = (function() {

        /**
         * Properties of a ProjectLevelUpReq.
         * @memberof Wharf
         * @interface IProjectLevelUpReq
         * @property {string|null} [projectGroupId] ProjectLevelUpReq projectGroupId
         */

        /**
         * Constructs a new ProjectLevelUpReq.
         * @memberof Wharf
         * @classdesc Represents a ProjectLevelUpReq.
         * @implements IProjectLevelUpReq
         * @constructor
         * @param {Wharf.IProjectLevelUpReq=} [properties] Properties to set
         */
        function ProjectLevelUpReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ProjectLevelUpReq projectGroupId.
         * @member {string} projectGroupId
         * @memberof Wharf.ProjectLevelUpReq
         * @instance
         */
        ProjectLevelUpReq.prototype.projectGroupId = "";

        /**
         * Creates a new ProjectLevelUpReq instance using the specified properties.
         * @function create
         * @memberof Wharf.ProjectLevelUpReq
         * @static
         * @param {Wharf.IProjectLevelUpReq=} [properties] Properties to set
         * @returns {Wharf.ProjectLevelUpReq} ProjectLevelUpReq instance
         */
        ProjectLevelUpReq.create = function create(properties) {
            return new ProjectLevelUpReq(properties);
        };

        /**
         * Encodes the specified ProjectLevelUpReq message. Does not implicitly {@link Wharf.ProjectLevelUpReq.verify|verify} messages.
         * @function encode
         * @memberof Wharf.ProjectLevelUpReq
         * @static
         * @param {Wharf.IProjectLevelUpReq} message ProjectLevelUpReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ProjectLevelUpReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.projectGroupId != null && message.hasOwnProperty("projectGroupId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.projectGroupId);
            return writer;
        };

        /**
         * Encodes the specified ProjectLevelUpReq message, length delimited. Does not implicitly {@link Wharf.ProjectLevelUpReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.ProjectLevelUpReq
         * @static
         * @param {Wharf.IProjectLevelUpReq} message ProjectLevelUpReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ProjectLevelUpReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ProjectLevelUpReq message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.ProjectLevelUpReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.ProjectLevelUpReq} ProjectLevelUpReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ProjectLevelUpReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.ProjectLevelUpReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.projectGroupId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ProjectLevelUpReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.ProjectLevelUpReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.ProjectLevelUpReq} ProjectLevelUpReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ProjectLevelUpReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ProjectLevelUpReq message.
         * @function verify
         * @memberof Wharf.ProjectLevelUpReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ProjectLevelUpReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.projectGroupId != null && message.hasOwnProperty("projectGroupId"))
                if (!$util.isString(message.projectGroupId))
                    return "projectGroupId: string expected";
            return null;
        };

        return ProjectLevelUpReq;
    })();

    Wharf.ProjectLevelUpRes = (function() {

        /**
         * Properties of a ProjectLevelUpRes.
         * @memberof Wharf
         * @interface IProjectLevelUpRes
         * @property {BaseInfo.INauticalProjectGroup|null} [group] ProjectLevelUpRes group
         * @property {BaseInfo.ICurrencyBag|null} [bag] ProjectLevelUpRes bag
         */

        /**
         * Constructs a new ProjectLevelUpRes.
         * @memberof Wharf
         * @classdesc Represents a ProjectLevelUpRes.
         * @implements IProjectLevelUpRes
         * @constructor
         * @param {Wharf.IProjectLevelUpRes=} [properties] Properties to set
         */
        function ProjectLevelUpRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ProjectLevelUpRes group.
         * @member {BaseInfo.INauticalProjectGroup|null|undefined} group
         * @memberof Wharf.ProjectLevelUpRes
         * @instance
         */
        ProjectLevelUpRes.prototype.group = null;

        /**
         * ProjectLevelUpRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Wharf.ProjectLevelUpRes
         * @instance
         */
        ProjectLevelUpRes.prototype.bag = null;

        /**
         * Creates a new ProjectLevelUpRes instance using the specified properties.
         * @function create
         * @memberof Wharf.ProjectLevelUpRes
         * @static
         * @param {Wharf.IProjectLevelUpRes=} [properties] Properties to set
         * @returns {Wharf.ProjectLevelUpRes} ProjectLevelUpRes instance
         */
        ProjectLevelUpRes.create = function create(properties) {
            return new ProjectLevelUpRes(properties);
        };

        /**
         * Encodes the specified ProjectLevelUpRes message. Does not implicitly {@link Wharf.ProjectLevelUpRes.verify|verify} messages.
         * @function encode
         * @memberof Wharf.ProjectLevelUpRes
         * @static
         * @param {Wharf.IProjectLevelUpRes} message ProjectLevelUpRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ProjectLevelUpRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.group != null && message.hasOwnProperty("group"))
                $root.BaseInfo.NauticalProjectGroup.encode(message.group, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified ProjectLevelUpRes message, length delimited. Does not implicitly {@link Wharf.ProjectLevelUpRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.ProjectLevelUpRes
         * @static
         * @param {Wharf.IProjectLevelUpRes} message ProjectLevelUpRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ProjectLevelUpRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ProjectLevelUpRes message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.ProjectLevelUpRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.ProjectLevelUpRes} ProjectLevelUpRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ProjectLevelUpRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.ProjectLevelUpRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.group = $root.BaseInfo.NauticalProjectGroup.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ProjectLevelUpRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.ProjectLevelUpRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.ProjectLevelUpRes} ProjectLevelUpRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ProjectLevelUpRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ProjectLevelUpRes message.
         * @function verify
         * @memberof Wharf.ProjectLevelUpRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ProjectLevelUpRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.group != null && message.hasOwnProperty("group")) {
                var error = $root.BaseInfo.NauticalProjectGroup.verify(message.group);
                if (error)
                    return "group." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return ProjectLevelUpRes;
    })();

    Wharf.GetWharfLetterBoxReq = (function() {

        /**
         * Properties of a GetWharfLetterBoxReq.
         * @memberof Wharf
         * @interface IGetWharfLetterBoxReq
         */

        /**
         * Constructs a new GetWharfLetterBoxReq.
         * @memberof Wharf
         * @classdesc Represents a GetWharfLetterBoxReq.
         * @implements IGetWharfLetterBoxReq
         * @constructor
         * @param {Wharf.IGetWharfLetterBoxReq=} [properties] Properties to set
         */
        function GetWharfLetterBoxReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetWharfLetterBoxReq instance using the specified properties.
         * @function create
         * @memberof Wharf.GetWharfLetterBoxReq
         * @static
         * @param {Wharf.IGetWharfLetterBoxReq=} [properties] Properties to set
         * @returns {Wharf.GetWharfLetterBoxReq} GetWharfLetterBoxReq instance
         */
        GetWharfLetterBoxReq.create = function create(properties) {
            return new GetWharfLetterBoxReq(properties);
        };

        /**
         * Encodes the specified GetWharfLetterBoxReq message. Does not implicitly {@link Wharf.GetWharfLetterBoxReq.verify|verify} messages.
         * @function encode
         * @memberof Wharf.GetWharfLetterBoxReq
         * @static
         * @param {Wharf.IGetWharfLetterBoxReq} message GetWharfLetterBoxReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetWharfLetterBoxReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetWharfLetterBoxReq message, length delimited. Does not implicitly {@link Wharf.GetWharfLetterBoxReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.GetWharfLetterBoxReq
         * @static
         * @param {Wharf.IGetWharfLetterBoxReq} message GetWharfLetterBoxReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetWharfLetterBoxReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetWharfLetterBoxReq message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.GetWharfLetterBoxReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.GetWharfLetterBoxReq} GetWharfLetterBoxReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetWharfLetterBoxReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.GetWharfLetterBoxReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetWharfLetterBoxReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.GetWharfLetterBoxReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.GetWharfLetterBoxReq} GetWharfLetterBoxReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetWharfLetterBoxReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetWharfLetterBoxReq message.
         * @function verify
         * @memberof Wharf.GetWharfLetterBoxReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetWharfLetterBoxReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetWharfLetterBoxReq;
    })();

    Wharf.GetWharfLetterBoxRes = (function() {

        /**
         * Properties of a GetWharfLetterBoxRes.
         * @memberof Wharf
         * @interface IGetWharfLetterBoxRes
         * @property {BaseInfo.IWharfLetterBox|null} [wharfLetterBox] GetWharfLetterBoxRes wharfLetterBox
         * @property {BaseInfo.IAidedGroupInfo|null} [aidedGroupInfo] GetWharfLetterBoxRes aidedGroupInfo
         */

        /**
         * Constructs a new GetWharfLetterBoxRes.
         * @memberof Wharf
         * @classdesc Represents a GetWharfLetterBoxRes.
         * @implements IGetWharfLetterBoxRes
         * @constructor
         * @param {Wharf.IGetWharfLetterBoxRes=} [properties] Properties to set
         */
        function GetWharfLetterBoxRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetWharfLetterBoxRes wharfLetterBox.
         * @member {BaseInfo.IWharfLetterBox|null|undefined} wharfLetterBox
         * @memberof Wharf.GetWharfLetterBoxRes
         * @instance
         */
        GetWharfLetterBoxRes.prototype.wharfLetterBox = null;

        /**
         * GetWharfLetterBoxRes aidedGroupInfo.
         * @member {BaseInfo.IAidedGroupInfo|null|undefined} aidedGroupInfo
         * @memberof Wharf.GetWharfLetterBoxRes
         * @instance
         */
        GetWharfLetterBoxRes.prototype.aidedGroupInfo = null;

        /**
         * Creates a new GetWharfLetterBoxRes instance using the specified properties.
         * @function create
         * @memberof Wharf.GetWharfLetterBoxRes
         * @static
         * @param {Wharf.IGetWharfLetterBoxRes=} [properties] Properties to set
         * @returns {Wharf.GetWharfLetterBoxRes} GetWharfLetterBoxRes instance
         */
        GetWharfLetterBoxRes.create = function create(properties) {
            return new GetWharfLetterBoxRes(properties);
        };

        /**
         * Encodes the specified GetWharfLetterBoxRes message. Does not implicitly {@link Wharf.GetWharfLetterBoxRes.verify|verify} messages.
         * @function encode
         * @memberof Wharf.GetWharfLetterBoxRes
         * @static
         * @param {Wharf.IGetWharfLetterBoxRes} message GetWharfLetterBoxRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetWharfLetterBoxRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.wharfLetterBox != null && message.hasOwnProperty("wharfLetterBox"))
                $root.BaseInfo.WharfLetterBox.encode(message.wharfLetterBox, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo"))
                $root.BaseInfo.AidedGroupInfo.encode(message.aidedGroupInfo, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetWharfLetterBoxRes message, length delimited. Does not implicitly {@link Wharf.GetWharfLetterBoxRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.GetWharfLetterBoxRes
         * @static
         * @param {Wharf.IGetWharfLetterBoxRes} message GetWharfLetterBoxRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetWharfLetterBoxRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetWharfLetterBoxRes message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.GetWharfLetterBoxRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.GetWharfLetterBoxRes} GetWharfLetterBoxRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetWharfLetterBoxRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.GetWharfLetterBoxRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.wharfLetterBox = $root.BaseInfo.WharfLetterBox.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.aidedGroupInfo = $root.BaseInfo.AidedGroupInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetWharfLetterBoxRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.GetWharfLetterBoxRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.GetWharfLetterBoxRes} GetWharfLetterBoxRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetWharfLetterBoxRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetWharfLetterBoxRes message.
         * @function verify
         * @memberof Wharf.GetWharfLetterBoxRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetWharfLetterBoxRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.wharfLetterBox != null && message.hasOwnProperty("wharfLetterBox")) {
                var error = $root.BaseInfo.WharfLetterBox.verify(message.wharfLetterBox);
                if (error)
                    return "wharfLetterBox." + error;
            }
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo")) {
                var error = $root.BaseInfo.AidedGroupInfo.verify(message.aidedGroupInfo);
                if (error)
                    return "aidedGroupInfo." + error;
            }
            return null;
        };

        return GetWharfLetterBoxRes;
    })();

    Wharf.FetchWharfLetterBoxReq = (function() {

        /**
         * Properties of a FetchWharfLetterBoxReq.
         * @memberof Wharf
         * @interface IFetchWharfLetterBoxReq
         * @property {BaseInfo.FetchType|null} [fetchType] FetchWharfLetterBoxReq fetchType
         */

        /**
         * Constructs a new FetchWharfLetterBoxReq.
         * @memberof Wharf
         * @classdesc Represents a FetchWharfLetterBoxReq.
         * @implements IFetchWharfLetterBoxReq
         * @constructor
         * @param {Wharf.IFetchWharfLetterBoxReq=} [properties] Properties to set
         */
        function FetchWharfLetterBoxReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchWharfLetterBoxReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof Wharf.FetchWharfLetterBoxReq
         * @instance
         */
        FetchWharfLetterBoxReq.prototype.fetchType = 0;

        /**
         * Creates a new FetchWharfLetterBoxReq instance using the specified properties.
         * @function create
         * @memberof Wharf.FetchWharfLetterBoxReq
         * @static
         * @param {Wharf.IFetchWharfLetterBoxReq=} [properties] Properties to set
         * @returns {Wharf.FetchWharfLetterBoxReq} FetchWharfLetterBoxReq instance
         */
        FetchWharfLetterBoxReq.create = function create(properties) {
            return new FetchWharfLetterBoxReq(properties);
        };

        /**
         * Encodes the specified FetchWharfLetterBoxReq message. Does not implicitly {@link Wharf.FetchWharfLetterBoxReq.verify|verify} messages.
         * @function encode
         * @memberof Wharf.FetchWharfLetterBoxReq
         * @static
         * @param {Wharf.IFetchWharfLetterBoxReq} message FetchWharfLetterBoxReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchWharfLetterBoxReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified FetchWharfLetterBoxReq message, length delimited. Does not implicitly {@link Wharf.FetchWharfLetterBoxReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.FetchWharfLetterBoxReq
         * @static
         * @param {Wharf.IFetchWharfLetterBoxReq} message FetchWharfLetterBoxReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchWharfLetterBoxReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchWharfLetterBoxReq message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.FetchWharfLetterBoxReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.FetchWharfLetterBoxReq} FetchWharfLetterBoxReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchWharfLetterBoxReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.FetchWharfLetterBoxReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchWharfLetterBoxReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.FetchWharfLetterBoxReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.FetchWharfLetterBoxReq} FetchWharfLetterBoxReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchWharfLetterBoxReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchWharfLetterBoxReq message.
         * @function verify
         * @memberof Wharf.FetchWharfLetterBoxReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchWharfLetterBoxReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return FetchWharfLetterBoxReq;
    })();

    Wharf.FetchWharfLetterBoxRes = (function() {

        /**
         * Properties of a FetchWharfLetterBoxRes.
         * @memberof Wharf
         * @interface IFetchWharfLetterBoxRes
         * @property {BaseInfo.IWharfLetterBox|null} [wharfLetterBox] FetchWharfLetterBoxRes wharfLetterBox
         * @property {BaseInfo.IAidedGroupInfo|null} [aidedGroupInfo] FetchWharfLetterBoxRes aidedGroupInfo
         * @property {BaseInfo.ICurrencyBag|null} [bag] FetchWharfLetterBoxRes bag
         */

        /**
         * Constructs a new FetchWharfLetterBoxRes.
         * @memberof Wharf
         * @classdesc Represents a FetchWharfLetterBoxRes.
         * @implements IFetchWharfLetterBoxRes
         * @constructor
         * @param {Wharf.IFetchWharfLetterBoxRes=} [properties] Properties to set
         */
        function FetchWharfLetterBoxRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchWharfLetterBoxRes wharfLetterBox.
         * @member {BaseInfo.IWharfLetterBox|null|undefined} wharfLetterBox
         * @memberof Wharf.FetchWharfLetterBoxRes
         * @instance
         */
        FetchWharfLetterBoxRes.prototype.wharfLetterBox = null;

        /**
         * FetchWharfLetterBoxRes aidedGroupInfo.
         * @member {BaseInfo.IAidedGroupInfo|null|undefined} aidedGroupInfo
         * @memberof Wharf.FetchWharfLetterBoxRes
         * @instance
         */
        FetchWharfLetterBoxRes.prototype.aidedGroupInfo = null;

        /**
         * FetchWharfLetterBoxRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Wharf.FetchWharfLetterBoxRes
         * @instance
         */
        FetchWharfLetterBoxRes.prototype.bag = null;

        /**
         * Creates a new FetchWharfLetterBoxRes instance using the specified properties.
         * @function create
         * @memberof Wharf.FetchWharfLetterBoxRes
         * @static
         * @param {Wharf.IFetchWharfLetterBoxRes=} [properties] Properties to set
         * @returns {Wharf.FetchWharfLetterBoxRes} FetchWharfLetterBoxRes instance
         */
        FetchWharfLetterBoxRes.create = function create(properties) {
            return new FetchWharfLetterBoxRes(properties);
        };

        /**
         * Encodes the specified FetchWharfLetterBoxRes message. Does not implicitly {@link Wharf.FetchWharfLetterBoxRes.verify|verify} messages.
         * @function encode
         * @memberof Wharf.FetchWharfLetterBoxRes
         * @static
         * @param {Wharf.IFetchWharfLetterBoxRes} message FetchWharfLetterBoxRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchWharfLetterBoxRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.wharfLetterBox != null && message.hasOwnProperty("wharfLetterBox"))
                $root.BaseInfo.WharfLetterBox.encode(message.wharfLetterBox, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo"))
                $root.BaseInfo.AidedGroupInfo.encode(message.aidedGroupInfo, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FetchWharfLetterBoxRes message, length delimited. Does not implicitly {@link Wharf.FetchWharfLetterBoxRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.FetchWharfLetterBoxRes
         * @static
         * @param {Wharf.IFetchWharfLetterBoxRes} message FetchWharfLetterBoxRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchWharfLetterBoxRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchWharfLetterBoxRes message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.FetchWharfLetterBoxRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.FetchWharfLetterBoxRes} FetchWharfLetterBoxRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchWharfLetterBoxRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.FetchWharfLetterBoxRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.wharfLetterBox = $root.BaseInfo.WharfLetterBox.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.aidedGroupInfo = $root.BaseInfo.AidedGroupInfo.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchWharfLetterBoxRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.FetchWharfLetterBoxRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.FetchWharfLetterBoxRes} FetchWharfLetterBoxRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchWharfLetterBoxRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchWharfLetterBoxRes message.
         * @function verify
         * @memberof Wharf.FetchWharfLetterBoxRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchWharfLetterBoxRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.wharfLetterBox != null && message.hasOwnProperty("wharfLetterBox")) {
                var error = $root.BaseInfo.WharfLetterBox.verify(message.wharfLetterBox);
                if (error)
                    return "wharfLetterBox." + error;
            }
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo")) {
                var error = $root.BaseInfo.AidedGroupInfo.verify(message.aidedGroupInfo);
                if (error)
                    return "aidedGroupInfo." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return FetchWharfLetterBoxRes;
    })();

    Wharf.AidPlayerReq = (function() {

        /**
         * Properties of an AidPlayerReq.
         * @memberof Wharf
         * @interface IAidPlayerReq
         * @property {string|null} [targetRId] AidPlayerReq targetRId
         */

        /**
         * Constructs a new AidPlayerReq.
         * @memberof Wharf
         * @classdesc Represents an AidPlayerReq.
         * @implements IAidPlayerReq
         * @constructor
         * @param {Wharf.IAidPlayerReq=} [properties] Properties to set
         */
        function AidPlayerReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AidPlayerReq targetRId.
         * @member {string} targetRId
         * @memberof Wharf.AidPlayerReq
         * @instance
         */
        AidPlayerReq.prototype.targetRId = "";

        /**
         * Creates a new AidPlayerReq instance using the specified properties.
         * @function create
         * @memberof Wharf.AidPlayerReq
         * @static
         * @param {Wharf.IAidPlayerReq=} [properties] Properties to set
         * @returns {Wharf.AidPlayerReq} AidPlayerReq instance
         */
        AidPlayerReq.create = function create(properties) {
            return new AidPlayerReq(properties);
        };

        /**
         * Encodes the specified AidPlayerReq message. Does not implicitly {@link Wharf.AidPlayerReq.verify|verify} messages.
         * @function encode
         * @memberof Wharf.AidPlayerReq
         * @static
         * @param {Wharf.IAidPlayerReq} message AidPlayerReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AidPlayerReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.targetRId != null && message.hasOwnProperty("targetRId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.targetRId);
            return writer;
        };

        /**
         * Encodes the specified AidPlayerReq message, length delimited. Does not implicitly {@link Wharf.AidPlayerReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.AidPlayerReq
         * @static
         * @param {Wharf.IAidPlayerReq} message AidPlayerReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AidPlayerReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AidPlayerReq message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.AidPlayerReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.AidPlayerReq} AidPlayerReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AidPlayerReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.AidPlayerReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.targetRId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AidPlayerReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.AidPlayerReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.AidPlayerReq} AidPlayerReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AidPlayerReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AidPlayerReq message.
         * @function verify
         * @memberof Wharf.AidPlayerReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AidPlayerReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.targetRId != null && message.hasOwnProperty("targetRId"))
                if (!$util.isString(message.targetRId))
                    return "targetRId: string expected";
            return null;
        };

        return AidPlayerReq;
    })();

    Wharf.AidPlayerRes = (function() {

        /**
         * Properties of an AidPlayerRes.
         * @memberof Wharf
         * @interface IAidPlayerRes
         * @property {BaseInfo.IAidedGroupInfo|null} [aidedGroupInfo] AidPlayerRes aidedGroupInfo
         * @property {number|null} [tips] AidPlayerRes tips
         */

        /**
         * Constructs a new AidPlayerRes.
         * @memberof Wharf
         * @classdesc Represents an AidPlayerRes.
         * @implements IAidPlayerRes
         * @constructor
         * @param {Wharf.IAidPlayerRes=} [properties] Properties to set
         */
        function AidPlayerRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * AidPlayerRes aidedGroupInfo.
         * @member {BaseInfo.IAidedGroupInfo|null|undefined} aidedGroupInfo
         * @memberof Wharf.AidPlayerRes
         * @instance
         */
        AidPlayerRes.prototype.aidedGroupInfo = null;

        /**
         * AidPlayerRes tips.
         * @member {number} tips
         * @memberof Wharf.AidPlayerRes
         * @instance
         */
        AidPlayerRes.prototype.tips = 0;

        /**
         * Creates a new AidPlayerRes instance using the specified properties.
         * @function create
         * @memberof Wharf.AidPlayerRes
         * @static
         * @param {Wharf.IAidPlayerRes=} [properties] Properties to set
         * @returns {Wharf.AidPlayerRes} AidPlayerRes instance
         */
        AidPlayerRes.create = function create(properties) {
            return new AidPlayerRes(properties);
        };

        /**
         * Encodes the specified AidPlayerRes message. Does not implicitly {@link Wharf.AidPlayerRes.verify|verify} messages.
         * @function encode
         * @memberof Wharf.AidPlayerRes
         * @static
         * @param {Wharf.IAidPlayerRes} message AidPlayerRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AidPlayerRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo"))
                $root.BaseInfo.AidedGroupInfo.encode(message.aidedGroupInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.tips != null && message.hasOwnProperty("tips"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.tips);
            return writer;
        };

        /**
         * Encodes the specified AidPlayerRes message, length delimited. Does not implicitly {@link Wharf.AidPlayerRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.AidPlayerRes
         * @static
         * @param {Wharf.IAidPlayerRes} message AidPlayerRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        AidPlayerRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an AidPlayerRes message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.AidPlayerRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.AidPlayerRes} AidPlayerRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AidPlayerRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.AidPlayerRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.aidedGroupInfo = $root.BaseInfo.AidedGroupInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.tips = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an AidPlayerRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.AidPlayerRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.AidPlayerRes} AidPlayerRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        AidPlayerRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an AidPlayerRes message.
         * @function verify
         * @memberof Wharf.AidPlayerRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        AidPlayerRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo")) {
                var error = $root.BaseInfo.AidedGroupInfo.verify(message.aidedGroupInfo);
                if (error)
                    return "aidedGroupInfo." + error;
            }
            if (message.tips != null && message.hasOwnProperty("tips"))
                if (!$util.isInteger(message.tips))
                    return "tips: integer expected";
            return null;
        };

        return AidPlayerRes;
    })();

    Wharf.ReceiveAidSalaryReq = (function() {

        /**
         * Properties of a ReceiveAidSalaryReq.
         * @memberof Wharf
         * @interface IReceiveAidSalaryReq
         */

        /**
         * Constructs a new ReceiveAidSalaryReq.
         * @memberof Wharf
         * @classdesc Represents a ReceiveAidSalaryReq.
         * @implements IReceiveAidSalaryReq
         * @constructor
         * @param {Wharf.IReceiveAidSalaryReq=} [properties] Properties to set
         */
        function ReceiveAidSalaryReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new ReceiveAidSalaryReq instance using the specified properties.
         * @function create
         * @memberof Wharf.ReceiveAidSalaryReq
         * @static
         * @param {Wharf.IReceiveAidSalaryReq=} [properties] Properties to set
         * @returns {Wharf.ReceiveAidSalaryReq} ReceiveAidSalaryReq instance
         */
        ReceiveAidSalaryReq.create = function create(properties) {
            return new ReceiveAidSalaryReq(properties);
        };

        /**
         * Encodes the specified ReceiveAidSalaryReq message. Does not implicitly {@link Wharf.ReceiveAidSalaryReq.verify|verify} messages.
         * @function encode
         * @memberof Wharf.ReceiveAidSalaryReq
         * @static
         * @param {Wharf.IReceiveAidSalaryReq} message ReceiveAidSalaryReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveAidSalaryReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified ReceiveAidSalaryReq message, length delimited. Does not implicitly {@link Wharf.ReceiveAidSalaryReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.ReceiveAidSalaryReq
         * @static
         * @param {Wharf.IReceiveAidSalaryReq} message ReceiveAidSalaryReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveAidSalaryReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveAidSalaryReq message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.ReceiveAidSalaryReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.ReceiveAidSalaryReq} ReceiveAidSalaryReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveAidSalaryReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.ReceiveAidSalaryReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveAidSalaryReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.ReceiveAidSalaryReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.ReceiveAidSalaryReq} ReceiveAidSalaryReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveAidSalaryReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveAidSalaryReq message.
         * @function verify
         * @memberof Wharf.ReceiveAidSalaryReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveAidSalaryReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return ReceiveAidSalaryReq;
    })();

    Wharf.ReceiveAidSalaryRes = (function() {

        /**
         * Properties of a ReceiveAidSalaryRes.
         * @memberof Wharf
         * @interface IReceiveAidSalaryRes
         * @property {BaseInfo.IAidedGroupInfo|null} [aidedGroupInfo] ReceiveAidSalaryRes aidedGroupInfo
         * @property {BaseInfo.ICurrencyBag|null} [bag] ReceiveAidSalaryRes bag
         */

        /**
         * Constructs a new ReceiveAidSalaryRes.
         * @memberof Wharf
         * @classdesc Represents a ReceiveAidSalaryRes.
         * @implements IReceiveAidSalaryRes
         * @constructor
         * @param {Wharf.IReceiveAidSalaryRes=} [properties] Properties to set
         */
        function ReceiveAidSalaryRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReceiveAidSalaryRes aidedGroupInfo.
         * @member {BaseInfo.IAidedGroupInfo|null|undefined} aidedGroupInfo
         * @memberof Wharf.ReceiveAidSalaryRes
         * @instance
         */
        ReceiveAidSalaryRes.prototype.aidedGroupInfo = null;

        /**
         * ReceiveAidSalaryRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Wharf.ReceiveAidSalaryRes
         * @instance
         */
        ReceiveAidSalaryRes.prototype.bag = null;

        /**
         * Creates a new ReceiveAidSalaryRes instance using the specified properties.
         * @function create
         * @memberof Wharf.ReceiveAidSalaryRes
         * @static
         * @param {Wharf.IReceiveAidSalaryRes=} [properties] Properties to set
         * @returns {Wharf.ReceiveAidSalaryRes} ReceiveAidSalaryRes instance
         */
        ReceiveAidSalaryRes.create = function create(properties) {
            return new ReceiveAidSalaryRes(properties);
        };

        /**
         * Encodes the specified ReceiveAidSalaryRes message. Does not implicitly {@link Wharf.ReceiveAidSalaryRes.verify|verify} messages.
         * @function encode
         * @memberof Wharf.ReceiveAidSalaryRes
         * @static
         * @param {Wharf.IReceiveAidSalaryRes} message ReceiveAidSalaryRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveAidSalaryRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo"))
                $root.BaseInfo.AidedGroupInfo.encode(message.aidedGroupInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified ReceiveAidSalaryRes message, length delimited. Does not implicitly {@link Wharf.ReceiveAidSalaryRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.ReceiveAidSalaryRes
         * @static
         * @param {Wharf.IReceiveAidSalaryRes} message ReceiveAidSalaryRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveAidSalaryRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveAidSalaryRes message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.ReceiveAidSalaryRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.ReceiveAidSalaryRes} ReceiveAidSalaryRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveAidSalaryRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.ReceiveAidSalaryRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.aidedGroupInfo = $root.BaseInfo.AidedGroupInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveAidSalaryRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.ReceiveAidSalaryRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.ReceiveAidSalaryRes} ReceiveAidSalaryRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveAidSalaryRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveAidSalaryRes message.
         * @function verify
         * @memberof Wharf.ReceiveAidSalaryRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveAidSalaryRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.aidedGroupInfo != null && message.hasOwnProperty("aidedGroupInfo")) {
                var error = $root.BaseInfo.AidedGroupInfo.verify(message.aidedGroupInfo);
                if (error)
                    return "aidedGroupInfo." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return ReceiveAidSalaryRes;
    })();

    Wharf.FetchDailyShellReq = (function() {

        /**
         * Properties of a FetchDailyShellReq.
         * @memberof Wharf
         * @interface IFetchDailyShellReq
         */

        /**
         * Constructs a new FetchDailyShellReq.
         * @memberof Wharf
         * @classdesc Represents a FetchDailyShellReq.
         * @implements IFetchDailyShellReq
         * @constructor
         * @param {Wharf.IFetchDailyShellReq=} [properties] Properties to set
         */
        function FetchDailyShellReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new FetchDailyShellReq instance using the specified properties.
         * @function create
         * @memberof Wharf.FetchDailyShellReq
         * @static
         * @param {Wharf.IFetchDailyShellReq=} [properties] Properties to set
         * @returns {Wharf.FetchDailyShellReq} FetchDailyShellReq instance
         */
        FetchDailyShellReq.create = function create(properties) {
            return new FetchDailyShellReq(properties);
        };

        /**
         * Encodes the specified FetchDailyShellReq message. Does not implicitly {@link Wharf.FetchDailyShellReq.verify|verify} messages.
         * @function encode
         * @memberof Wharf.FetchDailyShellReq
         * @static
         * @param {Wharf.IFetchDailyShellReq} message FetchDailyShellReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchDailyShellReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified FetchDailyShellReq message, length delimited. Does not implicitly {@link Wharf.FetchDailyShellReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.FetchDailyShellReq
         * @static
         * @param {Wharf.IFetchDailyShellReq} message FetchDailyShellReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchDailyShellReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchDailyShellReq message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.FetchDailyShellReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.FetchDailyShellReq} FetchDailyShellReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchDailyShellReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.FetchDailyShellReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchDailyShellReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.FetchDailyShellReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.FetchDailyShellReq} FetchDailyShellReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchDailyShellReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchDailyShellReq message.
         * @function verify
         * @memberof Wharf.FetchDailyShellReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchDailyShellReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return FetchDailyShellReq;
    })();

    Wharf.FetchDailyShellRes = (function() {

        /**
         * Properties of a FetchDailyShellRes.
         * @memberof Wharf
         * @interface IFetchDailyShellRes
         * @property {BaseInfo.ICurrencyBag|null} [bag] FetchDailyShellRes bag
         * @property {BaseInfo.IWharfLetterBox|null} [wharfLetterBox] FetchDailyShellRes wharfLetterBox
         */

        /**
         * Constructs a new FetchDailyShellRes.
         * @memberof Wharf
         * @classdesc Represents a FetchDailyShellRes.
         * @implements IFetchDailyShellRes
         * @constructor
         * @param {Wharf.IFetchDailyShellRes=} [properties] Properties to set
         */
        function FetchDailyShellRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchDailyShellRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof Wharf.FetchDailyShellRes
         * @instance
         */
        FetchDailyShellRes.prototype.bag = null;

        /**
         * FetchDailyShellRes wharfLetterBox.
         * @member {BaseInfo.IWharfLetterBox|null|undefined} wharfLetterBox
         * @memberof Wharf.FetchDailyShellRes
         * @instance
         */
        FetchDailyShellRes.prototype.wharfLetterBox = null;

        /**
         * Creates a new FetchDailyShellRes instance using the specified properties.
         * @function create
         * @memberof Wharf.FetchDailyShellRes
         * @static
         * @param {Wharf.IFetchDailyShellRes=} [properties] Properties to set
         * @returns {Wharf.FetchDailyShellRes} FetchDailyShellRes instance
         */
        FetchDailyShellRes.create = function create(properties) {
            return new FetchDailyShellRes(properties);
        };

        /**
         * Encodes the specified FetchDailyShellRes message. Does not implicitly {@link Wharf.FetchDailyShellRes.verify|verify} messages.
         * @function encode
         * @memberof Wharf.FetchDailyShellRes
         * @static
         * @param {Wharf.IFetchDailyShellRes} message FetchDailyShellRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchDailyShellRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.wharfLetterBox != null && message.hasOwnProperty("wharfLetterBox"))
                $root.BaseInfo.WharfLetterBox.encode(message.wharfLetterBox, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FetchDailyShellRes message, length delimited. Does not implicitly {@link Wharf.FetchDailyShellRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Wharf.FetchDailyShellRes
         * @static
         * @param {Wharf.IFetchDailyShellRes} message FetchDailyShellRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchDailyShellRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchDailyShellRes message from the specified reader or buffer.
         * @function decode
         * @memberof Wharf.FetchDailyShellRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Wharf.FetchDailyShellRes} FetchDailyShellRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchDailyShellRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Wharf.FetchDailyShellRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.wharfLetterBox = $root.BaseInfo.WharfLetterBox.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchDailyShellRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Wharf.FetchDailyShellRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Wharf.FetchDailyShellRes} FetchDailyShellRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchDailyShellRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchDailyShellRes message.
         * @function verify
         * @memberof Wharf.FetchDailyShellRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchDailyShellRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            if (message.wharfLetterBox != null && message.hasOwnProperty("wharfLetterBox")) {
                var error = $root.BaseInfo.WharfLetterBox.verify(message.wharfLetterBox);
                if (error)
                    return "wharfLetterBox." + error;
            }
            return null;
        };

        return FetchDailyShellRes;
    })();

    return Wharf;
})();

$root.Collect = (function() {

    /**
     * Namespace Collect.
     * @exports Collect
     * @namespace
     */
    var Collect = {};

    Collect.GetCollectGiftInfoReq = (function() {

        /**
         * Properties of a GetCollectGiftInfoReq.
         * @memberof Collect
         * @interface IGetCollectGiftInfoReq
         */

        /**
         * Constructs a new GetCollectGiftInfoReq.
         * @memberof Collect
         * @classdesc Represents a GetCollectGiftInfoReq.
         * @implements IGetCollectGiftInfoReq
         * @constructor
         * @param {Collect.IGetCollectGiftInfoReq=} [properties] Properties to set
         */
        function GetCollectGiftInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetCollectGiftInfoReq instance using the specified properties.
         * @function create
         * @memberof Collect.GetCollectGiftInfoReq
         * @static
         * @param {Collect.IGetCollectGiftInfoReq=} [properties] Properties to set
         * @returns {Collect.GetCollectGiftInfoReq} GetCollectGiftInfoReq instance
         */
        GetCollectGiftInfoReq.create = function create(properties) {
            return new GetCollectGiftInfoReq(properties);
        };

        /**
         * Encodes the specified GetCollectGiftInfoReq message. Does not implicitly {@link Collect.GetCollectGiftInfoReq.verify|verify} messages.
         * @function encode
         * @memberof Collect.GetCollectGiftInfoReq
         * @static
         * @param {Collect.IGetCollectGiftInfoReq} message GetCollectGiftInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetCollectGiftInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetCollectGiftInfoReq message, length delimited. Does not implicitly {@link Collect.GetCollectGiftInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Collect.GetCollectGiftInfoReq
         * @static
         * @param {Collect.IGetCollectGiftInfoReq} message GetCollectGiftInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetCollectGiftInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetCollectGiftInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof Collect.GetCollectGiftInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Collect.GetCollectGiftInfoReq} GetCollectGiftInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetCollectGiftInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Collect.GetCollectGiftInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetCollectGiftInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Collect.GetCollectGiftInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Collect.GetCollectGiftInfoReq} GetCollectGiftInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetCollectGiftInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetCollectGiftInfoReq message.
         * @function verify
         * @memberof Collect.GetCollectGiftInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetCollectGiftInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetCollectGiftInfoReq;
    })();

    Collect.GetCollectGiftInfoRes = (function() {

        /**
         * Properties of a GetCollectGiftInfoRes.
         * @memberof Collect
         * @interface IGetCollectGiftInfoRes
         * @property {Array.<string>|null} [unlockPetToys] GetCollectGiftInfoRes unlockPetToys
         * @property {Array.<string>|null} [unlockBaits] GetCollectGiftInfoRes unlockBaits
         * @property {Array.<string>|null} [unlockNauticalTools] GetCollectGiftInfoRes unlockNauticalTools
         * @property {Object.<string,BaseInfo.ILevelToy>|null} [levelToyMap] GetCollectGiftInfoRes levelToyMap
         */

        /**
         * Constructs a new GetCollectGiftInfoRes.
         * @memberof Collect
         * @classdesc Represents a GetCollectGiftInfoRes.
         * @implements IGetCollectGiftInfoRes
         * @constructor
         * @param {Collect.IGetCollectGiftInfoRes=} [properties] Properties to set
         */
        function GetCollectGiftInfoRes(properties) {
            this.unlockPetToys = [];
            this.unlockBaits = [];
            this.unlockNauticalTools = [];
            this.levelToyMap = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetCollectGiftInfoRes unlockPetToys.
         * @member {Array.<string>} unlockPetToys
         * @memberof Collect.GetCollectGiftInfoRes
         * @instance
         */
        GetCollectGiftInfoRes.prototype.unlockPetToys = $util.emptyArray;

        /**
         * GetCollectGiftInfoRes unlockBaits.
         * @member {Array.<string>} unlockBaits
         * @memberof Collect.GetCollectGiftInfoRes
         * @instance
         */
        GetCollectGiftInfoRes.prototype.unlockBaits = $util.emptyArray;

        /**
         * GetCollectGiftInfoRes unlockNauticalTools.
         * @member {Array.<string>} unlockNauticalTools
         * @memberof Collect.GetCollectGiftInfoRes
         * @instance
         */
        GetCollectGiftInfoRes.prototype.unlockNauticalTools = $util.emptyArray;

        /**
         * GetCollectGiftInfoRes levelToyMap.
         * @member {Object.<string,BaseInfo.ILevelToy>} levelToyMap
         * @memberof Collect.GetCollectGiftInfoRes
         * @instance
         */
        GetCollectGiftInfoRes.prototype.levelToyMap = $util.emptyObject;

        /**
         * Creates a new GetCollectGiftInfoRes instance using the specified properties.
         * @function create
         * @memberof Collect.GetCollectGiftInfoRes
         * @static
         * @param {Collect.IGetCollectGiftInfoRes=} [properties] Properties to set
         * @returns {Collect.GetCollectGiftInfoRes} GetCollectGiftInfoRes instance
         */
        GetCollectGiftInfoRes.create = function create(properties) {
            return new GetCollectGiftInfoRes(properties);
        };

        /**
         * Encodes the specified GetCollectGiftInfoRes message. Does not implicitly {@link Collect.GetCollectGiftInfoRes.verify|verify} messages.
         * @function encode
         * @memberof Collect.GetCollectGiftInfoRes
         * @static
         * @param {Collect.IGetCollectGiftInfoRes} message GetCollectGiftInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetCollectGiftInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.unlockPetToys != null && message.unlockPetToys.length)
                for (var i = 0; i < message.unlockPetToys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.unlockPetToys[i]);
            if (message.unlockBaits != null && message.unlockBaits.length)
                for (var i = 0; i < message.unlockBaits.length; ++i)
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.unlockBaits[i]);
            if (message.unlockNauticalTools != null && message.unlockNauticalTools.length)
                for (var i = 0; i < message.unlockNauticalTools.length; ++i)
                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.unlockNauticalTools[i]);
            if (message.levelToyMap != null && message.hasOwnProperty("levelToyMap"))
                for (var keys = Object.keys(message.levelToyMap), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 4, wireType 2 =*/34).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.BaseInfo.LevelToy.encode(message.levelToyMap[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified GetCollectGiftInfoRes message, length delimited. Does not implicitly {@link Collect.GetCollectGiftInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Collect.GetCollectGiftInfoRes
         * @static
         * @param {Collect.IGetCollectGiftInfoRes} message GetCollectGiftInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetCollectGiftInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetCollectGiftInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof Collect.GetCollectGiftInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Collect.GetCollectGiftInfoRes} GetCollectGiftInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetCollectGiftInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Collect.GetCollectGiftInfoRes(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.unlockPetToys && message.unlockPetToys.length))
                        message.unlockPetToys = [];
                    message.unlockPetToys.push(reader.string());
                    break;
                case 2:
                    if (!(message.unlockBaits && message.unlockBaits.length))
                        message.unlockBaits = [];
                    message.unlockBaits.push(reader.string());
                    break;
                case 3:
                    if (!(message.unlockNauticalTools && message.unlockNauticalTools.length))
                        message.unlockNauticalTools = [];
                    message.unlockNauticalTools.push(reader.string());
                    break;
                case 4:
                    reader.skip().pos++;
                    if (message.levelToyMap === $util.emptyObject)
                        message.levelToyMap = {};
                    key = reader.string();
                    reader.pos++;
                    message.levelToyMap[key] = $root.BaseInfo.LevelToy.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetCollectGiftInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Collect.GetCollectGiftInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Collect.GetCollectGiftInfoRes} GetCollectGiftInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetCollectGiftInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetCollectGiftInfoRes message.
         * @function verify
         * @memberof Collect.GetCollectGiftInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetCollectGiftInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.unlockPetToys != null && message.hasOwnProperty("unlockPetToys")) {
                if (!Array.isArray(message.unlockPetToys))
                    return "unlockPetToys: array expected";
                for (var i = 0; i < message.unlockPetToys.length; ++i)
                    if (!$util.isString(message.unlockPetToys[i]))
                        return "unlockPetToys: string[] expected";
            }
            if (message.unlockBaits != null && message.hasOwnProperty("unlockBaits")) {
                if (!Array.isArray(message.unlockBaits))
                    return "unlockBaits: array expected";
                for (var i = 0; i < message.unlockBaits.length; ++i)
                    if (!$util.isString(message.unlockBaits[i]))
                        return "unlockBaits: string[] expected";
            }
            if (message.unlockNauticalTools != null && message.hasOwnProperty("unlockNauticalTools")) {
                if (!Array.isArray(message.unlockNauticalTools))
                    return "unlockNauticalTools: array expected";
                for (var i = 0; i < message.unlockNauticalTools.length; ++i)
                    if (!$util.isString(message.unlockNauticalTools[i]))
                        return "unlockNauticalTools: string[] expected";
            }
            if (message.levelToyMap != null && message.hasOwnProperty("levelToyMap")) {
                if (!$util.isObject(message.levelToyMap))
                    return "levelToyMap: object expected";
                var key = Object.keys(message.levelToyMap);
                for (var i = 0; i < key.length; ++i) {
                    var error = $root.BaseInfo.LevelToy.verify(message.levelToyMap[key[i]]);
                    if (error)
                        return "levelToyMap." + error;
                }
            }
            return null;
        };

        return GetCollectGiftInfoRes;
    })();

    return Collect;
})();

$root.Milestone = (function() {

    /**
     * Namespace Milestone.
     * @exports Milestone
     * @namespace
     */
    var Milestone = {};

    Milestone.FetchMilestoneRewardReq = (function() {

        /**
         * Properties of a FetchMilestoneRewardReq.
         * @memberof Milestone
         * @interface IFetchMilestoneRewardReq
         * @property {string|null} [milestoneId] FetchMilestoneRewardReq milestoneId
         * @property {BaseInfo.FetchType|null} [fetchType] FetchMilestoneRewardReq fetchType
         */

        /**
         * Constructs a new FetchMilestoneRewardReq.
         * @memberof Milestone
         * @classdesc Represents a FetchMilestoneRewardReq.
         * @implements IFetchMilestoneRewardReq
         * @constructor
         * @param {Milestone.IFetchMilestoneRewardReq=} [properties] Properties to set
         */
        function FetchMilestoneRewardReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchMilestoneRewardReq milestoneId.
         * @member {string} milestoneId
         * @memberof Milestone.FetchMilestoneRewardReq
         * @instance
         */
        FetchMilestoneRewardReq.prototype.milestoneId = "";

        /**
         * FetchMilestoneRewardReq fetchType.
         * @member {BaseInfo.FetchType} fetchType
         * @memberof Milestone.FetchMilestoneRewardReq
         * @instance
         */
        FetchMilestoneRewardReq.prototype.fetchType = 0;

        /**
         * Creates a new FetchMilestoneRewardReq instance using the specified properties.
         * @function create
         * @memberof Milestone.FetchMilestoneRewardReq
         * @static
         * @param {Milestone.IFetchMilestoneRewardReq=} [properties] Properties to set
         * @returns {Milestone.FetchMilestoneRewardReq} FetchMilestoneRewardReq instance
         */
        FetchMilestoneRewardReq.create = function create(properties) {
            return new FetchMilestoneRewardReq(properties);
        };

        /**
         * Encodes the specified FetchMilestoneRewardReq message. Does not implicitly {@link Milestone.FetchMilestoneRewardReq.verify|verify} messages.
         * @function encode
         * @memberof Milestone.FetchMilestoneRewardReq
         * @static
         * @param {Milestone.IFetchMilestoneRewardReq} message FetchMilestoneRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchMilestoneRewardReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.milestoneId != null && message.hasOwnProperty("milestoneId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.milestoneId);
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.fetchType);
            return writer;
        };

        /**
         * Encodes the specified FetchMilestoneRewardReq message, length delimited. Does not implicitly {@link Milestone.FetchMilestoneRewardReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Milestone.FetchMilestoneRewardReq
         * @static
         * @param {Milestone.IFetchMilestoneRewardReq} message FetchMilestoneRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchMilestoneRewardReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchMilestoneRewardReq message from the specified reader or buffer.
         * @function decode
         * @memberof Milestone.FetchMilestoneRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Milestone.FetchMilestoneRewardReq} FetchMilestoneRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchMilestoneRewardReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Milestone.FetchMilestoneRewardReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.milestoneId = reader.string();
                    break;
                case 2:
                    message.fetchType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchMilestoneRewardReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Milestone.FetchMilestoneRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Milestone.FetchMilestoneRewardReq} FetchMilestoneRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchMilestoneRewardReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchMilestoneRewardReq message.
         * @function verify
         * @memberof Milestone.FetchMilestoneRewardReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchMilestoneRewardReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.milestoneId != null && message.hasOwnProperty("milestoneId"))
                if (!$util.isString(message.milestoneId))
                    return "milestoneId: string expected";
            if (message.fetchType != null && message.hasOwnProperty("fetchType"))
                switch (message.fetchType) {
                default:
                    return "fetchType: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            return null;
        };

        return FetchMilestoneRewardReq;
    })();

    Milestone.FetchMilestoneRewardRes = (function() {

        /**
         * Properties of a FetchMilestoneRewardRes.
         * @memberof Milestone
         * @interface IFetchMilestoneRewardRes
         * @property {BaseInfo.IRewards|null} [milestoneRewards] FetchMilestoneRewardRes milestoneRewards
         * @property {Array.<string>|null} [finishedMilestone] FetchMilestoneRewardRes finishedMilestone
         */

        /**
         * Constructs a new FetchMilestoneRewardRes.
         * @memberof Milestone
         * @classdesc Represents a FetchMilestoneRewardRes.
         * @implements IFetchMilestoneRewardRes
         * @constructor
         * @param {Milestone.IFetchMilestoneRewardRes=} [properties] Properties to set
         */
        function FetchMilestoneRewardRes(properties) {
            this.finishedMilestone = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchMilestoneRewardRes milestoneRewards.
         * @member {BaseInfo.IRewards|null|undefined} milestoneRewards
         * @memberof Milestone.FetchMilestoneRewardRes
         * @instance
         */
        FetchMilestoneRewardRes.prototype.milestoneRewards = null;

        /**
         * FetchMilestoneRewardRes finishedMilestone.
         * @member {Array.<string>} finishedMilestone
         * @memberof Milestone.FetchMilestoneRewardRes
         * @instance
         */
        FetchMilestoneRewardRes.prototype.finishedMilestone = $util.emptyArray;

        /**
         * Creates a new FetchMilestoneRewardRes instance using the specified properties.
         * @function create
         * @memberof Milestone.FetchMilestoneRewardRes
         * @static
         * @param {Milestone.IFetchMilestoneRewardRes=} [properties] Properties to set
         * @returns {Milestone.FetchMilestoneRewardRes} FetchMilestoneRewardRes instance
         */
        FetchMilestoneRewardRes.create = function create(properties) {
            return new FetchMilestoneRewardRes(properties);
        };

        /**
         * Encodes the specified FetchMilestoneRewardRes message. Does not implicitly {@link Milestone.FetchMilestoneRewardRes.verify|verify} messages.
         * @function encode
         * @memberof Milestone.FetchMilestoneRewardRes
         * @static
         * @param {Milestone.IFetchMilestoneRewardRes} message FetchMilestoneRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchMilestoneRewardRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.milestoneRewards != null && message.hasOwnProperty("milestoneRewards"))
                $root.BaseInfo.Rewards.encode(message.milestoneRewards, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.finishedMilestone != null && message.finishedMilestone.length)
                for (var i = 0; i < message.finishedMilestone.length; ++i)
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.finishedMilestone[i]);
            return writer;
        };

        /**
         * Encodes the specified FetchMilestoneRewardRes message, length delimited. Does not implicitly {@link Milestone.FetchMilestoneRewardRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Milestone.FetchMilestoneRewardRes
         * @static
         * @param {Milestone.IFetchMilestoneRewardRes} message FetchMilestoneRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchMilestoneRewardRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchMilestoneRewardRes message from the specified reader or buffer.
         * @function decode
         * @memberof Milestone.FetchMilestoneRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Milestone.FetchMilestoneRewardRes} FetchMilestoneRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchMilestoneRewardRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Milestone.FetchMilestoneRewardRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.milestoneRewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 2:
                    if (!(message.finishedMilestone && message.finishedMilestone.length))
                        message.finishedMilestone = [];
                    message.finishedMilestone.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchMilestoneRewardRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Milestone.FetchMilestoneRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Milestone.FetchMilestoneRewardRes} FetchMilestoneRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchMilestoneRewardRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchMilestoneRewardRes message.
         * @function verify
         * @memberof Milestone.FetchMilestoneRewardRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchMilestoneRewardRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.milestoneRewards != null && message.hasOwnProperty("milestoneRewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.milestoneRewards);
                if (error)
                    return "milestoneRewards." + error;
            }
            if (message.finishedMilestone != null && message.hasOwnProperty("finishedMilestone")) {
                if (!Array.isArray(message.finishedMilestone))
                    return "finishedMilestone: array expected";
                for (var i = 0; i < message.finishedMilestone.length; ++i)
                    if (!$util.isString(message.finishedMilestone[i]))
                        return "finishedMilestone: string[] expected";
            }
            return null;
        };

        return FetchMilestoneRewardRes;
    })();

    return Milestone;
})();

$root.LuckyDraw = (function() {

    /**
     * Namespace LuckyDraw.
     * @exports LuckyDraw
     * @namespace
     */
    var LuckyDraw = {};

    LuckyDraw.FetchLuckyDrawRewardReq = (function() {

        /**
         * Properties of a FetchLuckyDrawRewardReq.
         * @memberof LuckyDraw
         * @interface IFetchLuckyDrawRewardReq
         * @property {number|null} [type] FetchLuckyDrawRewardReq type
         * @property {LuckyDraw.ILuckyDrawRewardInfo|null} [rewardInfo] FetchLuckyDrawRewardReq rewardInfo
         */

        /**
         * Constructs a new FetchLuckyDrawRewardReq.
         * @memberof LuckyDraw
         * @classdesc Represents a FetchLuckyDrawRewardReq.
         * @implements IFetchLuckyDrawRewardReq
         * @constructor
         * @param {LuckyDraw.IFetchLuckyDrawRewardReq=} [properties] Properties to set
         */
        function FetchLuckyDrawRewardReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchLuckyDrawRewardReq type.
         * @member {number} type
         * @memberof LuckyDraw.FetchLuckyDrawRewardReq
         * @instance
         */
        FetchLuckyDrawRewardReq.prototype.type = 0;

        /**
         * FetchLuckyDrawRewardReq rewardInfo.
         * @member {LuckyDraw.ILuckyDrawRewardInfo|null|undefined} rewardInfo
         * @memberof LuckyDraw.FetchLuckyDrawRewardReq
         * @instance
         */
        FetchLuckyDrawRewardReq.prototype.rewardInfo = null;

        /**
         * Creates a new FetchLuckyDrawRewardReq instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.FetchLuckyDrawRewardReq
         * @static
         * @param {LuckyDraw.IFetchLuckyDrawRewardReq=} [properties] Properties to set
         * @returns {LuckyDraw.FetchLuckyDrawRewardReq} FetchLuckyDrawRewardReq instance
         */
        FetchLuckyDrawRewardReq.create = function create(properties) {
            return new FetchLuckyDrawRewardReq(properties);
        };

        /**
         * Encodes the specified FetchLuckyDrawRewardReq message. Does not implicitly {@link LuckyDraw.FetchLuckyDrawRewardReq.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.FetchLuckyDrawRewardReq
         * @static
         * @param {LuckyDraw.IFetchLuckyDrawRewardReq} message FetchLuckyDrawRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchLuckyDrawRewardReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.type);
            if (message.rewardInfo != null && message.hasOwnProperty("rewardInfo"))
                $root.LuckyDraw.LuckyDrawRewardInfo.encode(message.rewardInfo, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FetchLuckyDrawRewardReq message, length delimited. Does not implicitly {@link LuckyDraw.FetchLuckyDrawRewardReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.FetchLuckyDrawRewardReq
         * @static
         * @param {LuckyDraw.IFetchLuckyDrawRewardReq} message FetchLuckyDrawRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchLuckyDrawRewardReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchLuckyDrawRewardReq message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.FetchLuckyDrawRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.FetchLuckyDrawRewardReq} FetchLuckyDrawRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchLuckyDrawRewardReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.FetchLuckyDrawRewardReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.type = reader.int32();
                    break;
                case 2:
                    message.rewardInfo = $root.LuckyDraw.LuckyDrawRewardInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchLuckyDrawRewardReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.FetchLuckyDrawRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.FetchLuckyDrawRewardReq} FetchLuckyDrawRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchLuckyDrawRewardReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchLuckyDrawRewardReq message.
         * @function verify
         * @memberof LuckyDraw.FetchLuckyDrawRewardReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchLuckyDrawRewardReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isInteger(message.type))
                    return "type: integer expected";
            if (message.rewardInfo != null && message.hasOwnProperty("rewardInfo")) {
                var error = $root.LuckyDraw.LuckyDrawRewardInfo.verify(message.rewardInfo);
                if (error)
                    return "rewardInfo." + error;
            }
            return null;
        };

        return FetchLuckyDrawRewardReq;
    })();

    LuckyDraw.FetchLuckyDrawRewardRes = (function() {

        /**
         * Properties of a FetchLuckyDrawRewardRes.
         * @memberof LuckyDraw
         * @interface IFetchLuckyDrawRewardRes
         * @property {BaseInfo.ILuckyDraw|null} [luckyDraw] FetchLuckyDrawRewardRes luckyDraw
         * @property {BaseInfo.IRewards|null} [rewards] FetchLuckyDrawRewardRes rewards
         * @property {BaseInfo.IRewards|null} [onlyRewards] FetchLuckyDrawRewardRes onlyRewards
         * @property {LuckyDraw.INewItem|null} [newItem] FetchLuckyDrawRewardRes newItem
         * @property {BaseInfo.ILevelToy|null} [levelToy] FetchLuckyDrawRewardRes levelToy
         * @property {number|null} [addToyExp] FetchLuckyDrawRewardRes addToyExp
         * @property {Array.<LuckyDraw.ITicketBuildingInfo>|null} [ticketBuildingInfos] FetchLuckyDrawRewardRes ticketBuildingInfos
         */

        /**
         * Constructs a new FetchLuckyDrawRewardRes.
         * @memberof LuckyDraw
         * @classdesc Represents a FetchLuckyDrawRewardRes.
         * @implements IFetchLuckyDrawRewardRes
         * @constructor
         * @param {LuckyDraw.IFetchLuckyDrawRewardRes=} [properties] Properties to set
         */
        function FetchLuckyDrawRewardRes(properties) {
            this.ticketBuildingInfos = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchLuckyDrawRewardRes luckyDraw.
         * @member {BaseInfo.ILuckyDraw|null|undefined} luckyDraw
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @instance
         */
        FetchLuckyDrawRewardRes.prototype.luckyDraw = null;

        /**
         * FetchLuckyDrawRewardRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @instance
         */
        FetchLuckyDrawRewardRes.prototype.rewards = null;

        /**
         * FetchLuckyDrawRewardRes onlyRewards.
         * @member {BaseInfo.IRewards|null|undefined} onlyRewards
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @instance
         */
        FetchLuckyDrawRewardRes.prototype.onlyRewards = null;

        /**
         * FetchLuckyDrawRewardRes newItem.
         * @member {LuckyDraw.INewItem|null|undefined} newItem
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @instance
         */
        FetchLuckyDrawRewardRes.prototype.newItem = null;

        /**
         * FetchLuckyDrawRewardRes levelToy.
         * @member {BaseInfo.ILevelToy|null|undefined} levelToy
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @instance
         */
        FetchLuckyDrawRewardRes.prototype.levelToy = null;

        /**
         * FetchLuckyDrawRewardRes addToyExp.
         * @member {number} addToyExp
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @instance
         */
        FetchLuckyDrawRewardRes.prototype.addToyExp = 0;

        /**
         * FetchLuckyDrawRewardRes ticketBuildingInfos.
         * @member {Array.<LuckyDraw.ITicketBuildingInfo>} ticketBuildingInfos
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @instance
         */
        FetchLuckyDrawRewardRes.prototype.ticketBuildingInfos = $util.emptyArray;

        /**
         * Creates a new FetchLuckyDrawRewardRes instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @static
         * @param {LuckyDraw.IFetchLuckyDrawRewardRes=} [properties] Properties to set
         * @returns {LuckyDraw.FetchLuckyDrawRewardRes} FetchLuckyDrawRewardRes instance
         */
        FetchLuckyDrawRewardRes.create = function create(properties) {
            return new FetchLuckyDrawRewardRes(properties);
        };

        /**
         * Encodes the specified FetchLuckyDrawRewardRes message. Does not implicitly {@link LuckyDraw.FetchLuckyDrawRewardRes.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @static
         * @param {LuckyDraw.IFetchLuckyDrawRewardRes} message FetchLuckyDrawRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchLuckyDrawRewardRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.luckyDraw != null && message.hasOwnProperty("luckyDraw"))
                $root.BaseInfo.LuckyDraw.encode(message.luckyDraw, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.onlyRewards != null && message.hasOwnProperty("onlyRewards"))
                $root.BaseInfo.Rewards.encode(message.onlyRewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.newItem != null && message.hasOwnProperty("newItem"))
                $root.LuckyDraw.NewItem.encode(message.newItem, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            if (message.levelToy != null && message.hasOwnProperty("levelToy"))
                $root.BaseInfo.LevelToy.encode(message.levelToy, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
            if (message.addToyExp != null && message.hasOwnProperty("addToyExp"))
                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.addToyExp);
            if (message.ticketBuildingInfos != null && message.ticketBuildingInfos.length)
                for (var i = 0; i < message.ticketBuildingInfos.length; ++i)
                    $root.LuckyDraw.TicketBuildingInfo.encode(message.ticketBuildingInfos[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FetchLuckyDrawRewardRes message, length delimited. Does not implicitly {@link LuckyDraw.FetchLuckyDrawRewardRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @static
         * @param {LuckyDraw.IFetchLuckyDrawRewardRes} message FetchLuckyDrawRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchLuckyDrawRewardRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchLuckyDrawRewardRes message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.FetchLuckyDrawRewardRes} FetchLuckyDrawRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchLuckyDrawRewardRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.FetchLuckyDrawRewardRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.luckyDraw = $root.BaseInfo.LuckyDraw.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.onlyRewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.newItem = $root.LuckyDraw.NewItem.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.levelToy = $root.BaseInfo.LevelToy.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.addToyExp = reader.int32();
                    break;
                case 7:
                    if (!(message.ticketBuildingInfos && message.ticketBuildingInfos.length))
                        message.ticketBuildingInfos = [];
                    message.ticketBuildingInfos.push($root.LuckyDraw.TicketBuildingInfo.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchLuckyDrawRewardRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.FetchLuckyDrawRewardRes} FetchLuckyDrawRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchLuckyDrawRewardRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchLuckyDrawRewardRes message.
         * @function verify
         * @memberof LuckyDraw.FetchLuckyDrawRewardRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchLuckyDrawRewardRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.luckyDraw != null && message.hasOwnProperty("luckyDraw")) {
                var error = $root.BaseInfo.LuckyDraw.verify(message.luckyDraw);
                if (error)
                    return "luckyDraw." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.onlyRewards != null && message.hasOwnProperty("onlyRewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.onlyRewards);
                if (error)
                    return "onlyRewards." + error;
            }
            if (message.newItem != null && message.hasOwnProperty("newItem")) {
                var error = $root.LuckyDraw.NewItem.verify(message.newItem);
                if (error)
                    return "newItem." + error;
            }
            if (message.levelToy != null && message.hasOwnProperty("levelToy")) {
                var error = $root.BaseInfo.LevelToy.verify(message.levelToy);
                if (error)
                    return "levelToy." + error;
            }
            if (message.addToyExp != null && message.hasOwnProperty("addToyExp"))
                if (!$util.isInteger(message.addToyExp))
                    return "addToyExp: integer expected";
            if (message.ticketBuildingInfos != null && message.hasOwnProperty("ticketBuildingInfos")) {
                if (!Array.isArray(message.ticketBuildingInfos))
                    return "ticketBuildingInfos: array expected";
                for (var i = 0; i < message.ticketBuildingInfos.length; ++i) {
                    var error = $root.LuckyDraw.TicketBuildingInfo.verify(message.ticketBuildingInfos[i]);
                    if (error)
                        return "ticketBuildingInfos." + error;
                }
            }
            return null;
        };

        return FetchLuckyDrawRewardRes;
    })();

    LuckyDraw.GetLuckyDrawInfoReq = (function() {

        /**
         * Properties of a GetLuckyDrawInfoReq.
         * @memberof LuckyDraw
         * @interface IGetLuckyDrawInfoReq
         */

        /**
         * Constructs a new GetLuckyDrawInfoReq.
         * @memberof LuckyDraw
         * @classdesc Represents a GetLuckyDrawInfoReq.
         * @implements IGetLuckyDrawInfoReq
         * @constructor
         * @param {LuckyDraw.IGetLuckyDrawInfoReq=} [properties] Properties to set
         */
        function GetLuckyDrawInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetLuckyDrawInfoReq instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.GetLuckyDrawInfoReq
         * @static
         * @param {LuckyDraw.IGetLuckyDrawInfoReq=} [properties] Properties to set
         * @returns {LuckyDraw.GetLuckyDrawInfoReq} GetLuckyDrawInfoReq instance
         */
        GetLuckyDrawInfoReq.create = function create(properties) {
            return new GetLuckyDrawInfoReq(properties);
        };

        /**
         * Encodes the specified GetLuckyDrawInfoReq message. Does not implicitly {@link LuckyDraw.GetLuckyDrawInfoReq.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.GetLuckyDrawInfoReq
         * @static
         * @param {LuckyDraw.IGetLuckyDrawInfoReq} message GetLuckyDrawInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetLuckyDrawInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetLuckyDrawInfoReq message, length delimited. Does not implicitly {@link LuckyDraw.GetLuckyDrawInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.GetLuckyDrawInfoReq
         * @static
         * @param {LuckyDraw.IGetLuckyDrawInfoReq} message GetLuckyDrawInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetLuckyDrawInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetLuckyDrawInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.GetLuckyDrawInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.GetLuckyDrawInfoReq} GetLuckyDrawInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetLuckyDrawInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.GetLuckyDrawInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetLuckyDrawInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.GetLuckyDrawInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.GetLuckyDrawInfoReq} GetLuckyDrawInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetLuckyDrawInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetLuckyDrawInfoReq message.
         * @function verify
         * @memberof LuckyDraw.GetLuckyDrawInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetLuckyDrawInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetLuckyDrawInfoReq;
    })();

    LuckyDraw.GetLuckyDrawInfoRes = (function() {

        /**
         * Properties of a GetLuckyDrawInfoRes.
         * @memberof LuckyDraw
         * @interface IGetLuckyDrawInfoRes
         * @property {BaseInfo.ILuckyDraw|null} [luckyDraw] GetLuckyDrawInfoRes luckyDraw
         */

        /**
         * Constructs a new GetLuckyDrawInfoRes.
         * @memberof LuckyDraw
         * @classdesc Represents a GetLuckyDrawInfoRes.
         * @implements IGetLuckyDrawInfoRes
         * @constructor
         * @param {LuckyDraw.IGetLuckyDrawInfoRes=} [properties] Properties to set
         */
        function GetLuckyDrawInfoRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetLuckyDrawInfoRes luckyDraw.
         * @member {BaseInfo.ILuckyDraw|null|undefined} luckyDraw
         * @memberof LuckyDraw.GetLuckyDrawInfoRes
         * @instance
         */
        GetLuckyDrawInfoRes.prototype.luckyDraw = null;

        /**
         * Creates a new GetLuckyDrawInfoRes instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.GetLuckyDrawInfoRes
         * @static
         * @param {LuckyDraw.IGetLuckyDrawInfoRes=} [properties] Properties to set
         * @returns {LuckyDraw.GetLuckyDrawInfoRes} GetLuckyDrawInfoRes instance
         */
        GetLuckyDrawInfoRes.create = function create(properties) {
            return new GetLuckyDrawInfoRes(properties);
        };

        /**
         * Encodes the specified GetLuckyDrawInfoRes message. Does not implicitly {@link LuckyDraw.GetLuckyDrawInfoRes.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.GetLuckyDrawInfoRes
         * @static
         * @param {LuckyDraw.IGetLuckyDrawInfoRes} message GetLuckyDrawInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetLuckyDrawInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.luckyDraw != null && message.hasOwnProperty("luckyDraw"))
                $root.BaseInfo.LuckyDraw.encode(message.luckyDraw, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetLuckyDrawInfoRes message, length delimited. Does not implicitly {@link LuckyDraw.GetLuckyDrawInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.GetLuckyDrawInfoRes
         * @static
         * @param {LuckyDraw.IGetLuckyDrawInfoRes} message GetLuckyDrawInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetLuckyDrawInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetLuckyDrawInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.GetLuckyDrawInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.GetLuckyDrawInfoRes} GetLuckyDrawInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetLuckyDrawInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.GetLuckyDrawInfoRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.luckyDraw = $root.BaseInfo.LuckyDraw.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetLuckyDrawInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.GetLuckyDrawInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.GetLuckyDrawInfoRes} GetLuckyDrawInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetLuckyDrawInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetLuckyDrawInfoRes message.
         * @function verify
         * @memberof LuckyDraw.GetLuckyDrawInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetLuckyDrawInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.luckyDraw != null && message.hasOwnProperty("luckyDraw")) {
                var error = $root.BaseInfo.LuckyDraw.verify(message.luckyDraw);
                if (error)
                    return "luckyDraw." + error;
            }
            return null;
        };

        return GetLuckyDrawInfoRes;
    })();

    LuckyDraw.FetchBuildingTicketRewardReq = (function() {

        /**
         * Properties of a FetchBuildingTicketRewardReq.
         * @memberof LuckyDraw
         * @interface IFetchBuildingTicketRewardReq
         * @property {number|null} [ticketIndex] FetchBuildingTicketRewardReq ticketIndex
         * @property {string|null} [posId] FetchBuildingTicketRewardReq posId
         */

        /**
         * Constructs a new FetchBuildingTicketRewardReq.
         * @memberof LuckyDraw
         * @classdesc Represents a FetchBuildingTicketRewardReq.
         * @implements IFetchBuildingTicketRewardReq
         * @constructor
         * @param {LuckyDraw.IFetchBuildingTicketRewardReq=} [properties] Properties to set
         */
        function FetchBuildingTicketRewardReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchBuildingTicketRewardReq ticketIndex.
         * @member {number} ticketIndex
         * @memberof LuckyDraw.FetchBuildingTicketRewardReq
         * @instance
         */
        FetchBuildingTicketRewardReq.prototype.ticketIndex = 0;

        /**
         * FetchBuildingTicketRewardReq posId.
         * @member {string} posId
         * @memberof LuckyDraw.FetchBuildingTicketRewardReq
         * @instance
         */
        FetchBuildingTicketRewardReq.prototype.posId = "";

        /**
         * Creates a new FetchBuildingTicketRewardReq instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.FetchBuildingTicketRewardReq
         * @static
         * @param {LuckyDraw.IFetchBuildingTicketRewardReq=} [properties] Properties to set
         * @returns {LuckyDraw.FetchBuildingTicketRewardReq} FetchBuildingTicketRewardReq instance
         */
        FetchBuildingTicketRewardReq.create = function create(properties) {
            return new FetchBuildingTicketRewardReq(properties);
        };

        /**
         * Encodes the specified FetchBuildingTicketRewardReq message. Does not implicitly {@link LuckyDraw.FetchBuildingTicketRewardReq.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.FetchBuildingTicketRewardReq
         * @static
         * @param {LuckyDraw.IFetchBuildingTicketRewardReq} message FetchBuildingTicketRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchBuildingTicketRewardReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.ticketIndex != null && message.hasOwnProperty("ticketIndex"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.ticketIndex);
            if (message.posId != null && message.hasOwnProperty("posId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.posId);
            return writer;
        };

        /**
         * Encodes the specified FetchBuildingTicketRewardReq message, length delimited. Does not implicitly {@link LuckyDraw.FetchBuildingTicketRewardReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.FetchBuildingTicketRewardReq
         * @static
         * @param {LuckyDraw.IFetchBuildingTicketRewardReq} message FetchBuildingTicketRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchBuildingTicketRewardReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchBuildingTicketRewardReq message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.FetchBuildingTicketRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.FetchBuildingTicketRewardReq} FetchBuildingTicketRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchBuildingTicketRewardReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.FetchBuildingTicketRewardReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.ticketIndex = reader.int32();
                    break;
                case 2:
                    message.posId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchBuildingTicketRewardReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.FetchBuildingTicketRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.FetchBuildingTicketRewardReq} FetchBuildingTicketRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchBuildingTicketRewardReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchBuildingTicketRewardReq message.
         * @function verify
         * @memberof LuckyDraw.FetchBuildingTicketRewardReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchBuildingTicketRewardReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.ticketIndex != null && message.hasOwnProperty("ticketIndex"))
                if (!$util.isInteger(message.ticketIndex))
                    return "ticketIndex: integer expected";
            if (message.posId != null && message.hasOwnProperty("posId"))
                if (!$util.isString(message.posId))
                    return "posId: string expected";
            return null;
        };

        return FetchBuildingTicketRewardReq;
    })();

    LuckyDraw.FetchBuildingTicketRewardRes = (function() {

        /**
         * Properties of a FetchBuildingTicketRewardRes.
         * @memberof LuckyDraw
         * @interface IFetchBuildingTicketRewardRes
         * @property {LuckyDraw.ILotteryBag|null} [lotteryBag] FetchBuildingTicketRewardRes lotteryBag
         * @property {BaseInfo.ICurrencyBag|null} [currencyBag] FetchBuildingTicketRewardRes currencyBag
         */

        /**
         * Constructs a new FetchBuildingTicketRewardRes.
         * @memberof LuckyDraw
         * @classdesc Represents a FetchBuildingTicketRewardRes.
         * @implements IFetchBuildingTicketRewardRes
         * @constructor
         * @param {LuckyDraw.IFetchBuildingTicketRewardRes=} [properties] Properties to set
         */
        function FetchBuildingTicketRewardRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchBuildingTicketRewardRes lotteryBag.
         * @member {LuckyDraw.ILotteryBag|null|undefined} lotteryBag
         * @memberof LuckyDraw.FetchBuildingTicketRewardRes
         * @instance
         */
        FetchBuildingTicketRewardRes.prototype.lotteryBag = null;

        /**
         * FetchBuildingTicketRewardRes currencyBag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} currencyBag
         * @memberof LuckyDraw.FetchBuildingTicketRewardRes
         * @instance
         */
        FetchBuildingTicketRewardRes.prototype.currencyBag = null;

        /**
         * Creates a new FetchBuildingTicketRewardRes instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.FetchBuildingTicketRewardRes
         * @static
         * @param {LuckyDraw.IFetchBuildingTicketRewardRes=} [properties] Properties to set
         * @returns {LuckyDraw.FetchBuildingTicketRewardRes} FetchBuildingTicketRewardRes instance
         */
        FetchBuildingTicketRewardRes.create = function create(properties) {
            return new FetchBuildingTicketRewardRes(properties);
        };

        /**
         * Encodes the specified FetchBuildingTicketRewardRes message. Does not implicitly {@link LuckyDraw.FetchBuildingTicketRewardRes.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.FetchBuildingTicketRewardRes
         * @static
         * @param {LuckyDraw.IFetchBuildingTicketRewardRes} message FetchBuildingTicketRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchBuildingTicketRewardRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.lotteryBag != null && message.hasOwnProperty("lotteryBag"))
                $root.LuckyDraw.LotteryBag.encode(message.lotteryBag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag"))
                $root.BaseInfo.CurrencyBag.encode(message.currencyBag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FetchBuildingTicketRewardRes message, length delimited. Does not implicitly {@link LuckyDraw.FetchBuildingTicketRewardRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.FetchBuildingTicketRewardRes
         * @static
         * @param {LuckyDraw.IFetchBuildingTicketRewardRes} message FetchBuildingTicketRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchBuildingTicketRewardRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchBuildingTicketRewardRes message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.FetchBuildingTicketRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.FetchBuildingTicketRewardRes} FetchBuildingTicketRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchBuildingTicketRewardRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.FetchBuildingTicketRewardRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.lotteryBag = $root.LuckyDraw.LotteryBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.currencyBag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchBuildingTicketRewardRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.FetchBuildingTicketRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.FetchBuildingTicketRewardRes} FetchBuildingTicketRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchBuildingTicketRewardRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchBuildingTicketRewardRes message.
         * @function verify
         * @memberof LuckyDraw.FetchBuildingTicketRewardRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchBuildingTicketRewardRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.lotteryBag != null && message.hasOwnProperty("lotteryBag")) {
                var error = $root.LuckyDraw.LotteryBag.verify(message.lotteryBag);
                if (error)
                    return "lotteryBag." + error;
            }
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.currencyBag);
                if (error)
                    return "currencyBag." + error;
            }
            return null;
        };

        return FetchBuildingTicketRewardRes;
    })();

    LuckyDraw.FinishBuildingCouponReq = (function() {

        /**
         * Properties of a FinishBuildingCouponReq.
         * @memberof LuckyDraw
         * @interface IFinishBuildingCouponReq
         */

        /**
         * Constructs a new FinishBuildingCouponReq.
         * @memberof LuckyDraw
         * @classdesc Represents a FinishBuildingCouponReq.
         * @implements IFinishBuildingCouponReq
         * @constructor
         * @param {LuckyDraw.IFinishBuildingCouponReq=} [properties] Properties to set
         */
        function FinishBuildingCouponReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new FinishBuildingCouponReq instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.FinishBuildingCouponReq
         * @static
         * @param {LuckyDraw.IFinishBuildingCouponReq=} [properties] Properties to set
         * @returns {LuckyDraw.FinishBuildingCouponReq} FinishBuildingCouponReq instance
         */
        FinishBuildingCouponReq.create = function create(properties) {
            return new FinishBuildingCouponReq(properties);
        };

        /**
         * Encodes the specified FinishBuildingCouponReq message. Does not implicitly {@link LuckyDraw.FinishBuildingCouponReq.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.FinishBuildingCouponReq
         * @static
         * @param {LuckyDraw.IFinishBuildingCouponReq} message FinishBuildingCouponReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishBuildingCouponReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified FinishBuildingCouponReq message, length delimited. Does not implicitly {@link LuckyDraw.FinishBuildingCouponReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.FinishBuildingCouponReq
         * @static
         * @param {LuckyDraw.IFinishBuildingCouponReq} message FinishBuildingCouponReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishBuildingCouponReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FinishBuildingCouponReq message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.FinishBuildingCouponReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.FinishBuildingCouponReq} FinishBuildingCouponReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishBuildingCouponReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.FinishBuildingCouponReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FinishBuildingCouponReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.FinishBuildingCouponReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.FinishBuildingCouponReq} FinishBuildingCouponReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishBuildingCouponReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FinishBuildingCouponReq message.
         * @function verify
         * @memberof LuckyDraw.FinishBuildingCouponReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FinishBuildingCouponReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return FinishBuildingCouponReq;
    })();

    LuckyDraw.FinishBuildingCouponRes = (function() {

        /**
         * Properties of a FinishBuildingCouponRes.
         * @memberof LuckyDraw
         * @interface IFinishBuildingCouponRes
         */

        /**
         * Constructs a new FinishBuildingCouponRes.
         * @memberof LuckyDraw
         * @classdesc Represents a FinishBuildingCouponRes.
         * @implements IFinishBuildingCouponRes
         * @constructor
         * @param {LuckyDraw.IFinishBuildingCouponRes=} [properties] Properties to set
         */
        function FinishBuildingCouponRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new FinishBuildingCouponRes instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.FinishBuildingCouponRes
         * @static
         * @param {LuckyDraw.IFinishBuildingCouponRes=} [properties] Properties to set
         * @returns {LuckyDraw.FinishBuildingCouponRes} FinishBuildingCouponRes instance
         */
        FinishBuildingCouponRes.create = function create(properties) {
            return new FinishBuildingCouponRes(properties);
        };

        /**
         * Encodes the specified FinishBuildingCouponRes message. Does not implicitly {@link LuckyDraw.FinishBuildingCouponRes.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.FinishBuildingCouponRes
         * @static
         * @param {LuckyDraw.IFinishBuildingCouponRes} message FinishBuildingCouponRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishBuildingCouponRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified FinishBuildingCouponRes message, length delimited. Does not implicitly {@link LuckyDraw.FinishBuildingCouponRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.FinishBuildingCouponRes
         * @static
         * @param {LuckyDraw.IFinishBuildingCouponRes} message FinishBuildingCouponRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishBuildingCouponRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FinishBuildingCouponRes message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.FinishBuildingCouponRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.FinishBuildingCouponRes} FinishBuildingCouponRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishBuildingCouponRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.FinishBuildingCouponRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FinishBuildingCouponRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.FinishBuildingCouponRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.FinishBuildingCouponRes} FinishBuildingCouponRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishBuildingCouponRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FinishBuildingCouponRes message.
         * @function verify
         * @memberof LuckyDraw.FinishBuildingCouponRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FinishBuildingCouponRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return FinishBuildingCouponRes;
    })();

    LuckyDraw.UseAdCouponReq = (function() {

        /**
         * Properties of a UseAdCouponReq.
         * @memberof LuckyDraw
         * @interface IUseAdCouponReq
         * @property {number|null} [adCouponType] UseAdCouponReq adCouponType
         */

        /**
         * Constructs a new UseAdCouponReq.
         * @memberof LuckyDraw
         * @classdesc Represents a UseAdCouponReq.
         * @implements IUseAdCouponReq
         * @constructor
         * @param {LuckyDraw.IUseAdCouponReq=} [properties] Properties to set
         */
        function UseAdCouponReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * UseAdCouponReq adCouponType.
         * @member {number} adCouponType
         * @memberof LuckyDraw.UseAdCouponReq
         * @instance
         */
        UseAdCouponReq.prototype.adCouponType = 0;

        /**
         * Creates a new UseAdCouponReq instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.UseAdCouponReq
         * @static
         * @param {LuckyDraw.IUseAdCouponReq=} [properties] Properties to set
         * @returns {LuckyDraw.UseAdCouponReq} UseAdCouponReq instance
         */
        UseAdCouponReq.create = function create(properties) {
            return new UseAdCouponReq(properties);
        };

        /**
         * Encodes the specified UseAdCouponReq message. Does not implicitly {@link LuckyDraw.UseAdCouponReq.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.UseAdCouponReq
         * @static
         * @param {LuckyDraw.IUseAdCouponReq} message UseAdCouponReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        UseAdCouponReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.adCouponType != null && message.hasOwnProperty("adCouponType"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.adCouponType);
            return writer;
        };

        /**
         * Encodes the specified UseAdCouponReq message, length delimited. Does not implicitly {@link LuckyDraw.UseAdCouponReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.UseAdCouponReq
         * @static
         * @param {LuckyDraw.IUseAdCouponReq} message UseAdCouponReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        UseAdCouponReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a UseAdCouponReq message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.UseAdCouponReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.UseAdCouponReq} UseAdCouponReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        UseAdCouponReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.UseAdCouponReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.adCouponType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a UseAdCouponReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.UseAdCouponReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.UseAdCouponReq} UseAdCouponReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        UseAdCouponReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a UseAdCouponReq message.
         * @function verify
         * @memberof LuckyDraw.UseAdCouponReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        UseAdCouponReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.adCouponType != null && message.hasOwnProperty("adCouponType"))
                if (!$util.isInteger(message.adCouponType))
                    return "adCouponType: integer expected";
            return null;
        };

        return UseAdCouponReq;
    })();

    LuckyDraw.UseAdCouponRes = (function() {

        /**
         * Properties of a UseAdCouponRes.
         * @memberof LuckyDraw
         * @interface IUseAdCouponRes
         * @property {LuckyDraw.ILotteryBag|null} [lotteryBag] UseAdCouponRes lotteryBag
         */

        /**
         * Constructs a new UseAdCouponRes.
         * @memberof LuckyDraw
         * @classdesc Represents a UseAdCouponRes.
         * @implements IUseAdCouponRes
         * @constructor
         * @param {LuckyDraw.IUseAdCouponRes=} [properties] Properties to set
         */
        function UseAdCouponRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * UseAdCouponRes lotteryBag.
         * @member {LuckyDraw.ILotteryBag|null|undefined} lotteryBag
         * @memberof LuckyDraw.UseAdCouponRes
         * @instance
         */
        UseAdCouponRes.prototype.lotteryBag = null;

        /**
         * Creates a new UseAdCouponRes instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.UseAdCouponRes
         * @static
         * @param {LuckyDraw.IUseAdCouponRes=} [properties] Properties to set
         * @returns {LuckyDraw.UseAdCouponRes} UseAdCouponRes instance
         */
        UseAdCouponRes.create = function create(properties) {
            return new UseAdCouponRes(properties);
        };

        /**
         * Encodes the specified UseAdCouponRes message. Does not implicitly {@link LuckyDraw.UseAdCouponRes.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.UseAdCouponRes
         * @static
         * @param {LuckyDraw.IUseAdCouponRes} message UseAdCouponRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        UseAdCouponRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.lotteryBag != null && message.hasOwnProperty("lotteryBag"))
                $root.LuckyDraw.LotteryBag.encode(message.lotteryBag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified UseAdCouponRes message, length delimited. Does not implicitly {@link LuckyDraw.UseAdCouponRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.UseAdCouponRes
         * @static
         * @param {LuckyDraw.IUseAdCouponRes} message UseAdCouponRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        UseAdCouponRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a UseAdCouponRes message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.UseAdCouponRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.UseAdCouponRes} UseAdCouponRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        UseAdCouponRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.UseAdCouponRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.lotteryBag = $root.LuckyDraw.LotteryBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a UseAdCouponRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.UseAdCouponRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.UseAdCouponRes} UseAdCouponRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        UseAdCouponRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a UseAdCouponRes message.
         * @function verify
         * @memberof LuckyDraw.UseAdCouponRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        UseAdCouponRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.lotteryBag != null && message.hasOwnProperty("lotteryBag")) {
                var error = $root.LuckyDraw.LotteryBag.verify(message.lotteryBag);
                if (error)
                    return "lotteryBag." + error;
            }
            return null;
        };

        return UseAdCouponRes;
    })();

    LuckyDraw.GetLotteryBagReq = (function() {

        /**
         * Properties of a GetLotteryBagReq.
         * @memberof LuckyDraw
         * @interface IGetLotteryBagReq
         */

        /**
         * Constructs a new GetLotteryBagReq.
         * @memberof LuckyDraw
         * @classdesc Represents a GetLotteryBagReq.
         * @implements IGetLotteryBagReq
         * @constructor
         * @param {LuckyDraw.IGetLotteryBagReq=} [properties] Properties to set
         */
        function GetLotteryBagReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetLotteryBagReq instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.GetLotteryBagReq
         * @static
         * @param {LuckyDraw.IGetLotteryBagReq=} [properties] Properties to set
         * @returns {LuckyDraw.GetLotteryBagReq} GetLotteryBagReq instance
         */
        GetLotteryBagReq.create = function create(properties) {
            return new GetLotteryBagReq(properties);
        };

        /**
         * Encodes the specified GetLotteryBagReq message. Does not implicitly {@link LuckyDraw.GetLotteryBagReq.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.GetLotteryBagReq
         * @static
         * @param {LuckyDraw.IGetLotteryBagReq} message GetLotteryBagReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetLotteryBagReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetLotteryBagReq message, length delimited. Does not implicitly {@link LuckyDraw.GetLotteryBagReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.GetLotteryBagReq
         * @static
         * @param {LuckyDraw.IGetLotteryBagReq} message GetLotteryBagReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetLotteryBagReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetLotteryBagReq message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.GetLotteryBagReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.GetLotteryBagReq} GetLotteryBagReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetLotteryBagReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.GetLotteryBagReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetLotteryBagReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.GetLotteryBagReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.GetLotteryBagReq} GetLotteryBagReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetLotteryBagReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetLotteryBagReq message.
         * @function verify
         * @memberof LuckyDraw.GetLotteryBagReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetLotteryBagReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetLotteryBagReq;
    })();

    LuckyDraw.GetLotteryBagRes = (function() {

        /**
         * Properties of a GetLotteryBagRes.
         * @memberof LuckyDraw
         * @interface IGetLotteryBagRes
         * @property {LuckyDraw.ILotteryBag|null} [lotteryBag] GetLotteryBagRes lotteryBag
         */

        /**
         * Constructs a new GetLotteryBagRes.
         * @memberof LuckyDraw
         * @classdesc Represents a GetLotteryBagRes.
         * @implements IGetLotteryBagRes
         * @constructor
         * @param {LuckyDraw.IGetLotteryBagRes=} [properties] Properties to set
         */
        function GetLotteryBagRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetLotteryBagRes lotteryBag.
         * @member {LuckyDraw.ILotteryBag|null|undefined} lotteryBag
         * @memberof LuckyDraw.GetLotteryBagRes
         * @instance
         */
        GetLotteryBagRes.prototype.lotteryBag = null;

        /**
         * Creates a new GetLotteryBagRes instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.GetLotteryBagRes
         * @static
         * @param {LuckyDraw.IGetLotteryBagRes=} [properties] Properties to set
         * @returns {LuckyDraw.GetLotteryBagRes} GetLotteryBagRes instance
         */
        GetLotteryBagRes.create = function create(properties) {
            return new GetLotteryBagRes(properties);
        };

        /**
         * Encodes the specified GetLotteryBagRes message. Does not implicitly {@link LuckyDraw.GetLotteryBagRes.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.GetLotteryBagRes
         * @static
         * @param {LuckyDraw.IGetLotteryBagRes} message GetLotteryBagRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetLotteryBagRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.lotteryBag != null && message.hasOwnProperty("lotteryBag"))
                $root.LuckyDraw.LotteryBag.encode(message.lotteryBag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetLotteryBagRes message, length delimited. Does not implicitly {@link LuckyDraw.GetLotteryBagRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.GetLotteryBagRes
         * @static
         * @param {LuckyDraw.IGetLotteryBagRes} message GetLotteryBagRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetLotteryBagRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetLotteryBagRes message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.GetLotteryBagRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.GetLotteryBagRes} GetLotteryBagRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetLotteryBagRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.GetLotteryBagRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.lotteryBag = $root.LuckyDraw.LotteryBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetLotteryBagRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.GetLotteryBagRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.GetLotteryBagRes} GetLotteryBagRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetLotteryBagRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetLotteryBagRes message.
         * @function verify
         * @memberof LuckyDraw.GetLotteryBagRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetLotteryBagRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.lotteryBag != null && message.hasOwnProperty("lotteryBag")) {
                var error = $root.LuckyDraw.LotteryBag.verify(message.lotteryBag);
                if (error)
                    return "lotteryBag." + error;
            }
            return null;
        };

        return GetLotteryBagRes;
    })();

    LuckyDraw.LotteryBag = (function() {

        /**
         * Properties of a LotteryBag.
         * @memberof LuckyDraw
         * @interface ILotteryBag
         * @property {number|null} [fishingTicketNum] LotteryBag fishingTicketNum
         * @property {Array.<LuckyDraw.ITicketBuildingInfo>|null} [ticketBuildingInfos] LotteryBag ticketBuildingInfos
         * @property {number|null} [nauticalSpeedUpNum] LotteryBag nauticalSpeedUpNum
         * @property {number|null} [skipAdInviteNum] LotteryBag skipAdInviteNum
         * @property {number|null} [catFoodNum] LotteryBag catFoodNum
         */

        /**
         * Constructs a new LotteryBag.
         * @memberof LuckyDraw
         * @classdesc Represents a LotteryBag.
         * @implements ILotteryBag
         * @constructor
         * @param {LuckyDraw.ILotteryBag=} [properties] Properties to set
         */
        function LotteryBag(properties) {
            this.ticketBuildingInfos = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * LotteryBag fishingTicketNum.
         * @member {number} fishingTicketNum
         * @memberof LuckyDraw.LotteryBag
         * @instance
         */
        LotteryBag.prototype.fishingTicketNum = 0;

        /**
         * LotteryBag ticketBuildingInfos.
         * @member {Array.<LuckyDraw.ITicketBuildingInfo>} ticketBuildingInfos
         * @memberof LuckyDraw.LotteryBag
         * @instance
         */
        LotteryBag.prototype.ticketBuildingInfos = $util.emptyArray;

        /**
         * LotteryBag nauticalSpeedUpNum.
         * @member {number} nauticalSpeedUpNum
         * @memberof LuckyDraw.LotteryBag
         * @instance
         */
        LotteryBag.prototype.nauticalSpeedUpNum = 0;

        /**
         * LotteryBag skipAdInviteNum.
         * @member {number} skipAdInviteNum
         * @memberof LuckyDraw.LotteryBag
         * @instance
         */
        LotteryBag.prototype.skipAdInviteNum = 0;

        /**
         * LotteryBag catFoodNum.
         * @member {number} catFoodNum
         * @memberof LuckyDraw.LotteryBag
         * @instance
         */
        LotteryBag.prototype.catFoodNum = 0;

        /**
         * Creates a new LotteryBag instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.LotteryBag
         * @static
         * @param {LuckyDraw.ILotteryBag=} [properties] Properties to set
         * @returns {LuckyDraw.LotteryBag} LotteryBag instance
         */
        LotteryBag.create = function create(properties) {
            return new LotteryBag(properties);
        };

        /**
         * Encodes the specified LotteryBag message. Does not implicitly {@link LuckyDraw.LotteryBag.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.LotteryBag
         * @static
         * @param {LuckyDraw.ILotteryBag} message LotteryBag message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LotteryBag.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.fishingTicketNum != null && message.hasOwnProperty("fishingTicketNum"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.fishingTicketNum);
            if (message.ticketBuildingInfos != null && message.ticketBuildingInfos.length)
                for (var i = 0; i < message.ticketBuildingInfos.length; ++i)
                    $root.LuckyDraw.TicketBuildingInfo.encode(message.ticketBuildingInfos[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.nauticalSpeedUpNum != null && message.hasOwnProperty("nauticalSpeedUpNum"))
                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.nauticalSpeedUpNum);
            if (message.skipAdInviteNum != null && message.hasOwnProperty("skipAdInviteNum"))
                writer.uint32(/* id 5, wireType 0 =*/40).int32(message.skipAdInviteNum);
            if (message.catFoodNum != null && message.hasOwnProperty("catFoodNum"))
                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.catFoodNum);
            return writer;
        };

        /**
         * Encodes the specified LotteryBag message, length delimited. Does not implicitly {@link LuckyDraw.LotteryBag.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.LotteryBag
         * @static
         * @param {LuckyDraw.ILotteryBag} message LotteryBag message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LotteryBag.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a LotteryBag message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.LotteryBag
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.LotteryBag} LotteryBag
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LotteryBag.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.LotteryBag();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.fishingTicketNum = reader.int32();
                    break;
                case 2:
                    if (!(message.ticketBuildingInfos && message.ticketBuildingInfos.length))
                        message.ticketBuildingInfos = [];
                    message.ticketBuildingInfos.push($root.LuckyDraw.TicketBuildingInfo.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.nauticalSpeedUpNum = reader.int32();
                    break;
                case 5:
                    message.skipAdInviteNum = reader.int32();
                    break;
                case 6:
                    message.catFoodNum = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a LotteryBag message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.LotteryBag
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.LotteryBag} LotteryBag
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LotteryBag.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a LotteryBag message.
         * @function verify
         * @memberof LuckyDraw.LotteryBag
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        LotteryBag.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.fishingTicketNum != null && message.hasOwnProperty("fishingTicketNum"))
                if (!$util.isInteger(message.fishingTicketNum))
                    return "fishingTicketNum: integer expected";
            if (message.ticketBuildingInfos != null && message.hasOwnProperty("ticketBuildingInfos")) {
                if (!Array.isArray(message.ticketBuildingInfos))
                    return "ticketBuildingInfos: array expected";
                for (var i = 0; i < message.ticketBuildingInfos.length; ++i) {
                    var error = $root.LuckyDraw.TicketBuildingInfo.verify(message.ticketBuildingInfos[i]);
                    if (error)
                        return "ticketBuildingInfos." + error;
                }
            }
            if (message.nauticalSpeedUpNum != null && message.hasOwnProperty("nauticalSpeedUpNum"))
                if (!$util.isInteger(message.nauticalSpeedUpNum))
                    return "nauticalSpeedUpNum: integer expected";
            if (message.skipAdInviteNum != null && message.hasOwnProperty("skipAdInviteNum"))
                if (!$util.isInteger(message.skipAdInviteNum))
                    return "skipAdInviteNum: integer expected";
            if (message.catFoodNum != null && message.hasOwnProperty("catFoodNum"))
                if (!$util.isInteger(message.catFoodNum))
                    return "catFoodNum: integer expected";
            return null;
        };

        return LotteryBag;
    })();

    LuckyDraw.TicketBuildingInfo = (function() {

        /**
         * Properties of a TicketBuildingInfo.
         * @memberof LuckyDraw
         * @interface ITicketBuildingInfo
         * @property {string|null} [buildingId] TicketBuildingInfo buildingId
         * @property {number|null} [star] TicketBuildingInfo star
         * @property {boolean|null} [alreadyGet] TicketBuildingInfo alreadyGet
         */

        /**
         * Constructs a new TicketBuildingInfo.
         * @memberof LuckyDraw
         * @classdesc Represents a TicketBuildingInfo.
         * @implements ITicketBuildingInfo
         * @constructor
         * @param {LuckyDraw.ITicketBuildingInfo=} [properties] Properties to set
         */
        function TicketBuildingInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * TicketBuildingInfo buildingId.
         * @member {string} buildingId
         * @memberof LuckyDraw.TicketBuildingInfo
         * @instance
         */
        TicketBuildingInfo.prototype.buildingId = "";

        /**
         * TicketBuildingInfo star.
         * @member {number} star
         * @memberof LuckyDraw.TicketBuildingInfo
         * @instance
         */
        TicketBuildingInfo.prototype.star = 0;

        /**
         * TicketBuildingInfo alreadyGet.
         * @member {boolean} alreadyGet
         * @memberof LuckyDraw.TicketBuildingInfo
         * @instance
         */
        TicketBuildingInfo.prototype.alreadyGet = false;

        /**
         * Creates a new TicketBuildingInfo instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.TicketBuildingInfo
         * @static
         * @param {LuckyDraw.ITicketBuildingInfo=} [properties] Properties to set
         * @returns {LuckyDraw.TicketBuildingInfo} TicketBuildingInfo instance
         */
        TicketBuildingInfo.create = function create(properties) {
            return new TicketBuildingInfo(properties);
        };

        /**
         * Encodes the specified TicketBuildingInfo message. Does not implicitly {@link LuckyDraw.TicketBuildingInfo.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.TicketBuildingInfo
         * @static
         * @param {LuckyDraw.ITicketBuildingInfo} message TicketBuildingInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TicketBuildingInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.buildingId != null && message.hasOwnProperty("buildingId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.buildingId);
            if (message.star != null && message.hasOwnProperty("star"))
                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.star);
            if (message.alreadyGet != null && message.hasOwnProperty("alreadyGet"))
                writer.uint32(/* id 4, wireType 0 =*/32).bool(message.alreadyGet);
            return writer;
        };

        /**
         * Encodes the specified TicketBuildingInfo message, length delimited. Does not implicitly {@link LuckyDraw.TicketBuildingInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.TicketBuildingInfo
         * @static
         * @param {LuckyDraw.ITicketBuildingInfo} message TicketBuildingInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        TicketBuildingInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a TicketBuildingInfo message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.TicketBuildingInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.TicketBuildingInfo} TicketBuildingInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TicketBuildingInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.TicketBuildingInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 2:
                    message.buildingId = reader.string();
                    break;
                case 3:
                    message.star = reader.int32();
                    break;
                case 4:
                    message.alreadyGet = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a TicketBuildingInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.TicketBuildingInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.TicketBuildingInfo} TicketBuildingInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        TicketBuildingInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a TicketBuildingInfo message.
         * @function verify
         * @memberof LuckyDraw.TicketBuildingInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        TicketBuildingInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.buildingId != null && message.hasOwnProperty("buildingId"))
                if (!$util.isString(message.buildingId))
                    return "buildingId: string expected";
            if (message.star != null && message.hasOwnProperty("star"))
                if (!$util.isInteger(message.star))
                    return "star: integer expected";
            if (message.alreadyGet != null && message.hasOwnProperty("alreadyGet"))
                if (typeof message.alreadyGet !== "boolean")
                    return "alreadyGet: boolean expected";
            return null;
        };

        return TicketBuildingInfo;
    })();

    LuckyDraw.LuckyDrawRewardInfo = (function() {

        /**
         * Properties of a LuckyDrawRewardInfo.
         * @memberof LuckyDraw
         * @interface ILuckyDrawRewardInfo
         * @property {string|null} [type] LuckyDrawRewardInfo type
         * @property {number|null} [maxCatValue] LuckyDrawRewardInfo maxCatValue
         * @property {string|null} [json] LuckyDrawRewardInfo json
         */

        /**
         * Constructs a new LuckyDrawRewardInfo.
         * @memberof LuckyDraw
         * @classdesc Represents a LuckyDrawRewardInfo.
         * @implements ILuckyDrawRewardInfo
         * @constructor
         * @param {LuckyDraw.ILuckyDrawRewardInfo=} [properties] Properties to set
         */
        function LuckyDrawRewardInfo(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * LuckyDrawRewardInfo type.
         * @member {string} type
         * @memberof LuckyDraw.LuckyDrawRewardInfo
         * @instance
         */
        LuckyDrawRewardInfo.prototype.type = "";

        /**
         * LuckyDrawRewardInfo maxCatValue.
         * @member {number} maxCatValue
         * @memberof LuckyDraw.LuckyDrawRewardInfo
         * @instance
         */
        LuckyDrawRewardInfo.prototype.maxCatValue = 0;

        /**
         * LuckyDrawRewardInfo json.
         * @member {string} json
         * @memberof LuckyDraw.LuckyDrawRewardInfo
         * @instance
         */
        LuckyDrawRewardInfo.prototype.json = "";

        /**
         * Creates a new LuckyDrawRewardInfo instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.LuckyDrawRewardInfo
         * @static
         * @param {LuckyDraw.ILuckyDrawRewardInfo=} [properties] Properties to set
         * @returns {LuckyDraw.LuckyDrawRewardInfo} LuckyDrawRewardInfo instance
         */
        LuckyDrawRewardInfo.create = function create(properties) {
            return new LuckyDrawRewardInfo(properties);
        };

        /**
         * Encodes the specified LuckyDrawRewardInfo message. Does not implicitly {@link LuckyDraw.LuckyDrawRewardInfo.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.LuckyDrawRewardInfo
         * @static
         * @param {LuckyDraw.ILuckyDrawRewardInfo} message LuckyDrawRewardInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LuckyDrawRewardInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.type);
            if (message.maxCatValue != null && message.hasOwnProperty("maxCatValue"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.maxCatValue);
            if (message.json != null && message.hasOwnProperty("json"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.json);
            return writer;
        };

        /**
         * Encodes the specified LuckyDrawRewardInfo message, length delimited. Does not implicitly {@link LuckyDraw.LuckyDrawRewardInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.LuckyDrawRewardInfo
         * @static
         * @param {LuckyDraw.ILuckyDrawRewardInfo} message LuckyDrawRewardInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LuckyDrawRewardInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a LuckyDrawRewardInfo message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.LuckyDrawRewardInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.LuckyDrawRewardInfo} LuckyDrawRewardInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LuckyDrawRewardInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.LuckyDrawRewardInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.type = reader.string();
                    break;
                case 2:
                    message.maxCatValue = reader.int32();
                    break;
                case 3:
                    message.json = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a LuckyDrawRewardInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.LuckyDrawRewardInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.LuckyDrawRewardInfo} LuckyDrawRewardInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LuckyDrawRewardInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a LuckyDrawRewardInfo message.
         * @function verify
         * @memberof LuckyDraw.LuckyDrawRewardInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        LuckyDrawRewardInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isString(message.type))
                    return "type: string expected";
            if (message.maxCatValue != null && message.hasOwnProperty("maxCatValue"))
                if (!$util.isInteger(message.maxCatValue))
                    return "maxCatValue: integer expected";
            if (message.json != null && message.hasOwnProperty("json"))
                if (!$util.isString(message.json))
                    return "json: string expected";
            return null;
        };

        return LuckyDrawRewardInfo;
    })();

    LuckyDraw.NewItem = (function() {

        /**
         * Properties of a NewItem.
         * @memberof LuckyDraw
         * @interface INewItem
         * @property {boolean|null} [newCatToy] NewItem newCatToy
         */

        /**
         * Constructs a new NewItem.
         * @memberof LuckyDraw
         * @classdesc Represents a NewItem.
         * @implements INewItem
         * @constructor
         * @param {LuckyDraw.INewItem=} [properties] Properties to set
         */
        function NewItem(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * NewItem newCatToy.
         * @member {boolean} newCatToy
         * @memberof LuckyDraw.NewItem
         * @instance
         */
        NewItem.prototype.newCatToy = false;

        /**
         * Creates a new NewItem instance using the specified properties.
         * @function create
         * @memberof LuckyDraw.NewItem
         * @static
         * @param {LuckyDraw.INewItem=} [properties] Properties to set
         * @returns {LuckyDraw.NewItem} NewItem instance
         */
        NewItem.create = function create(properties) {
            return new NewItem(properties);
        };

        /**
         * Encodes the specified NewItem message. Does not implicitly {@link LuckyDraw.NewItem.verify|verify} messages.
         * @function encode
         * @memberof LuckyDraw.NewItem
         * @static
         * @param {LuckyDraw.INewItem} message NewItem message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        NewItem.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.newCatToy != null && message.hasOwnProperty("newCatToy"))
                writer.uint32(/* id 1, wireType 0 =*/8).bool(message.newCatToy);
            return writer;
        };

        /**
         * Encodes the specified NewItem message, length delimited. Does not implicitly {@link LuckyDraw.NewItem.verify|verify} messages.
         * @function encodeDelimited
         * @memberof LuckyDraw.NewItem
         * @static
         * @param {LuckyDraw.INewItem} message NewItem message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        NewItem.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a NewItem message from the specified reader or buffer.
         * @function decode
         * @memberof LuckyDraw.NewItem
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {LuckyDraw.NewItem} NewItem
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        NewItem.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.LuckyDraw.NewItem();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.newCatToy = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a NewItem message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof LuckyDraw.NewItem
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {LuckyDraw.NewItem} NewItem
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        NewItem.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a NewItem message.
         * @function verify
         * @memberof LuckyDraw.NewItem
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        NewItem.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.newCatToy != null && message.hasOwnProperty("newCatToy"))
                if (typeof message.newCatToy !== "boolean")
                    return "newCatToy: boolean expected";
            return null;
        };

        return NewItem;
    })();

    return LuckyDraw;
})();

$root.CatMission = (function() {

    /**
     * Namespace CatMission.
     * @exports CatMission
     * @namespace
     */
    var CatMission = {};

    CatMission.GetCatMissionInfoReq = (function() {

        /**
         * Properties of a GetCatMissionInfoReq.
         * @memberof CatMission
         * @interface IGetCatMissionInfoReq
         */

        /**
         * Constructs a new GetCatMissionInfoReq.
         * @memberof CatMission
         * @classdesc Represents a GetCatMissionInfoReq.
         * @implements IGetCatMissionInfoReq
         * @constructor
         * @param {CatMission.IGetCatMissionInfoReq=} [properties] Properties to set
         */
        function GetCatMissionInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new GetCatMissionInfoReq instance using the specified properties.
         * @function create
         * @memberof CatMission.GetCatMissionInfoReq
         * @static
         * @param {CatMission.IGetCatMissionInfoReq=} [properties] Properties to set
         * @returns {CatMission.GetCatMissionInfoReq} GetCatMissionInfoReq instance
         */
        GetCatMissionInfoReq.create = function create(properties) {
            return new GetCatMissionInfoReq(properties);
        };

        /**
         * Encodes the specified GetCatMissionInfoReq message. Does not implicitly {@link CatMission.GetCatMissionInfoReq.verify|verify} messages.
         * @function encode
         * @memberof CatMission.GetCatMissionInfoReq
         * @static
         * @param {CatMission.IGetCatMissionInfoReq} message GetCatMissionInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetCatMissionInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified GetCatMissionInfoReq message, length delimited. Does not implicitly {@link CatMission.GetCatMissionInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof CatMission.GetCatMissionInfoReq
         * @static
         * @param {CatMission.IGetCatMissionInfoReq} message GetCatMissionInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetCatMissionInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetCatMissionInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof CatMission.GetCatMissionInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {CatMission.GetCatMissionInfoReq} GetCatMissionInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetCatMissionInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.CatMission.GetCatMissionInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetCatMissionInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof CatMission.GetCatMissionInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {CatMission.GetCatMissionInfoReq} GetCatMissionInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetCatMissionInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetCatMissionInfoReq message.
         * @function verify
         * @memberof CatMission.GetCatMissionInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetCatMissionInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return GetCatMissionInfoReq;
    })();

    CatMission.GetCatMissionInfoRes = (function() {

        /**
         * Properties of a GetCatMissionInfoRes.
         * @memberof CatMission
         * @interface IGetCatMissionInfoRes
         * @property {CatMission.ICatMissionInfo|null} [catMissionInfo] GetCatMissionInfoRes catMissionInfo
         * @property {CatMission.ICatMissionPetInfo|null} [catMissionPetInfo] GetCatMissionInfoRes catMissionPetInfo
         */

        /**
         * Constructs a new GetCatMissionInfoRes.
         * @memberof CatMission
         * @classdesc Represents a GetCatMissionInfoRes.
         * @implements IGetCatMissionInfoRes
         * @constructor
         * @param {CatMission.IGetCatMissionInfoRes=} [properties] Properties to set
         */
        function GetCatMissionInfoRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * GetCatMissionInfoRes catMissionInfo.
         * @member {CatMission.ICatMissionInfo|null|undefined} catMissionInfo
         * @memberof CatMission.GetCatMissionInfoRes
         * @instance
         */
        GetCatMissionInfoRes.prototype.catMissionInfo = null;

        /**
         * GetCatMissionInfoRes catMissionPetInfo.
         * @member {CatMission.ICatMissionPetInfo|null|undefined} catMissionPetInfo
         * @memberof CatMission.GetCatMissionInfoRes
         * @instance
         */
        GetCatMissionInfoRes.prototype.catMissionPetInfo = null;

        /**
         * Creates a new GetCatMissionInfoRes instance using the specified properties.
         * @function create
         * @memberof CatMission.GetCatMissionInfoRes
         * @static
         * @param {CatMission.IGetCatMissionInfoRes=} [properties] Properties to set
         * @returns {CatMission.GetCatMissionInfoRes} GetCatMissionInfoRes instance
         */
        GetCatMissionInfoRes.create = function create(properties) {
            return new GetCatMissionInfoRes(properties);
        };

        /**
         * Encodes the specified GetCatMissionInfoRes message. Does not implicitly {@link CatMission.GetCatMissionInfoRes.verify|verify} messages.
         * @function encode
         * @memberof CatMission.GetCatMissionInfoRes
         * @static
         * @param {CatMission.IGetCatMissionInfoRes} message GetCatMissionInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetCatMissionInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.catMissionInfo != null && message.hasOwnProperty("catMissionInfo"))
                $root.CatMission.CatMissionInfo.encode(message.catMissionInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.catMissionPetInfo != null && message.hasOwnProperty("catMissionPetInfo"))
                $root.CatMission.CatMissionPetInfo.encode(message.catMissionPetInfo, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified GetCatMissionInfoRes message, length delimited. Does not implicitly {@link CatMission.GetCatMissionInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof CatMission.GetCatMissionInfoRes
         * @static
         * @param {CatMission.IGetCatMissionInfoRes} message GetCatMissionInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        GetCatMissionInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a GetCatMissionInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof CatMission.GetCatMissionInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {CatMission.GetCatMissionInfoRes} GetCatMissionInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetCatMissionInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.CatMission.GetCatMissionInfoRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.catMissionInfo = $root.CatMission.CatMissionInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.catMissionPetInfo = $root.CatMission.CatMissionPetInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a GetCatMissionInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof CatMission.GetCatMissionInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {CatMission.GetCatMissionInfoRes} GetCatMissionInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        GetCatMissionInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a GetCatMissionInfoRes message.
         * @function verify
         * @memberof CatMission.GetCatMissionInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        GetCatMissionInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.catMissionInfo != null && message.hasOwnProperty("catMissionInfo")) {
                var error = $root.CatMission.CatMissionInfo.verify(message.catMissionInfo);
                if (error)
                    return "catMissionInfo." + error;
            }
            if (message.catMissionPetInfo != null && message.hasOwnProperty("catMissionPetInfo")) {
                var error = $root.CatMission.CatMissionPetInfo.verify(message.catMissionPetInfo);
                if (error)
                    return "catMissionPetInfo." + error;
            }
            return null;
        };

        return GetCatMissionInfoRes;
    })();

    CatMission.PlayerRefreshReq = (function() {

        /**
         * Properties of a PlayerRefreshReq.
         * @memberof CatMission
         * @interface IPlayerRefreshReq
         */

        /**
         * Constructs a new PlayerRefreshReq.
         * @memberof CatMission
         * @classdesc Represents a PlayerRefreshReq.
         * @implements IPlayerRefreshReq
         * @constructor
         * @param {CatMission.IPlayerRefreshReq=} [properties] Properties to set
         */
        function PlayerRefreshReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new PlayerRefreshReq instance using the specified properties.
         * @function create
         * @memberof CatMission.PlayerRefreshReq
         * @static
         * @param {CatMission.IPlayerRefreshReq=} [properties] Properties to set
         * @returns {CatMission.PlayerRefreshReq} PlayerRefreshReq instance
         */
        PlayerRefreshReq.create = function create(properties) {
            return new PlayerRefreshReq(properties);
        };

        /**
         * Encodes the specified PlayerRefreshReq message. Does not implicitly {@link CatMission.PlayerRefreshReq.verify|verify} messages.
         * @function encode
         * @memberof CatMission.PlayerRefreshReq
         * @static
         * @param {CatMission.IPlayerRefreshReq} message PlayerRefreshReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayerRefreshReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified PlayerRefreshReq message, length delimited. Does not implicitly {@link CatMission.PlayerRefreshReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof CatMission.PlayerRefreshReq
         * @static
         * @param {CatMission.IPlayerRefreshReq} message PlayerRefreshReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayerRefreshReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PlayerRefreshReq message from the specified reader or buffer.
         * @function decode
         * @memberof CatMission.PlayerRefreshReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {CatMission.PlayerRefreshReq} PlayerRefreshReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayerRefreshReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.CatMission.PlayerRefreshReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PlayerRefreshReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof CatMission.PlayerRefreshReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {CatMission.PlayerRefreshReq} PlayerRefreshReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayerRefreshReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PlayerRefreshReq message.
         * @function verify
         * @memberof CatMission.PlayerRefreshReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PlayerRefreshReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return PlayerRefreshReq;
    })();

    CatMission.PlayerRefreshRes = (function() {

        /**
         * Properties of a PlayerRefreshRes.
         * @memberof CatMission
         * @interface IPlayerRefreshRes
         * @property {CatMission.ICatMissionInfo|null} [catMissionInfo] PlayerRefreshRes catMissionInfo
         */

        /**
         * Constructs a new PlayerRefreshRes.
         * @memberof CatMission
         * @classdesc Represents a PlayerRefreshRes.
         * @implements IPlayerRefreshRes
         * @constructor
         * @param {CatMission.IPlayerRefreshRes=} [properties] Properties to set
         */
        function PlayerRefreshRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PlayerRefreshRes catMissionInfo.
         * @member {CatMission.ICatMissionInfo|null|undefined} catMissionInfo
         * @memberof CatMission.PlayerRefreshRes
         * @instance
         */
        PlayerRefreshRes.prototype.catMissionInfo = null;

        /**
         * Creates a new PlayerRefreshRes instance using the specified properties.
         * @function create
         * @memberof CatMission.PlayerRefreshRes
         * @static
         * @param {CatMission.IPlayerRefreshRes=} [properties] Properties to set
         * @returns {CatMission.PlayerRefreshRes} PlayerRefreshRes instance
         */
        PlayerRefreshRes.create = function create(properties) {
            return new PlayerRefreshRes(properties);
        };

        /**
         * Encodes the specified PlayerRefreshRes message. Does not implicitly {@link CatMission.PlayerRefreshRes.verify|verify} messages.
         * @function encode
         * @memberof CatMission.PlayerRefreshRes
         * @static
         * @param {CatMission.IPlayerRefreshRes} message PlayerRefreshRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayerRefreshRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.catMissionInfo != null && message.hasOwnProperty("catMissionInfo"))
                $root.CatMission.CatMissionInfo.encode(message.catMissionInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified PlayerRefreshRes message, length delimited. Does not implicitly {@link CatMission.PlayerRefreshRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof CatMission.PlayerRefreshRes
         * @static
         * @param {CatMission.IPlayerRefreshRes} message PlayerRefreshRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PlayerRefreshRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PlayerRefreshRes message from the specified reader or buffer.
         * @function decode
         * @memberof CatMission.PlayerRefreshRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {CatMission.PlayerRefreshRes} PlayerRefreshRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayerRefreshRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.CatMission.PlayerRefreshRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.catMissionInfo = $root.CatMission.CatMissionInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PlayerRefreshRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof CatMission.PlayerRefreshRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {CatMission.PlayerRefreshRes} PlayerRefreshRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PlayerRefreshRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PlayerRefreshRes message.
         * @function verify
         * @memberof CatMission.PlayerRefreshRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PlayerRefreshRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.catMissionInfo != null && message.hasOwnProperty("catMissionInfo")) {
                var error = $root.CatMission.CatMissionInfo.verify(message.catMissionInfo);
                if (error)
                    return "catMissionInfo." + error;
            }
            return null;
        };

        return PlayerRefreshRes;
    })();

    CatMission.ChangeRefreshLevelReq = (function() {

        /**
         * Properties of a ChangeRefreshLevelReq.
         * @memberof CatMission
         * @interface IChangeRefreshLevelReq
         * @property {number|null} [level] ChangeRefreshLevelReq level
         */

        /**
         * Constructs a new ChangeRefreshLevelReq.
         * @memberof CatMission
         * @classdesc Represents a ChangeRefreshLevelReq.
         * @implements IChangeRefreshLevelReq
         * @constructor
         * @param {CatMission.IChangeRefreshLevelReq=} [properties] Properties to set
         */
        function ChangeRefreshLevelReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ChangeRefreshLevelReq level.
         * @member {number} level
         * @memberof CatMission.ChangeRefreshLevelReq
         * @instance
         */
        ChangeRefreshLevelReq.prototype.level = 0;

        /**
         * Creates a new ChangeRefreshLevelReq instance using the specified properties.
         * @function create
         * @memberof CatMission.ChangeRefreshLevelReq
         * @static
         * @param {CatMission.IChangeRefreshLevelReq=} [properties] Properties to set
         * @returns {CatMission.ChangeRefreshLevelReq} ChangeRefreshLevelReq instance
         */
        ChangeRefreshLevelReq.create = function create(properties) {
            return new ChangeRefreshLevelReq(properties);
        };

        /**
         * Encodes the specified ChangeRefreshLevelReq message. Does not implicitly {@link CatMission.ChangeRefreshLevelReq.verify|verify} messages.
         * @function encode
         * @memberof CatMission.ChangeRefreshLevelReq
         * @static
         * @param {CatMission.IChangeRefreshLevelReq} message ChangeRefreshLevelReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ChangeRefreshLevelReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.level != null && message.hasOwnProperty("level"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.level);
            return writer;
        };

        /**
         * Encodes the specified ChangeRefreshLevelReq message, length delimited. Does not implicitly {@link CatMission.ChangeRefreshLevelReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof CatMission.ChangeRefreshLevelReq
         * @static
         * @param {CatMission.IChangeRefreshLevelReq} message ChangeRefreshLevelReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ChangeRefreshLevelReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ChangeRefreshLevelReq message from the specified reader or buffer.
         * @function decode
         * @memberof CatMission.ChangeRefreshLevelReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {CatMission.ChangeRefreshLevelReq} ChangeRefreshLevelReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ChangeRefreshLevelReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.CatMission.ChangeRefreshLevelReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.level = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ChangeRefreshLevelReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof CatMission.ChangeRefreshLevelReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {CatMission.ChangeRefreshLevelReq} ChangeRefreshLevelReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ChangeRefreshLevelReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ChangeRefreshLevelReq message.
         * @function verify
         * @memberof CatMission.ChangeRefreshLevelReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ChangeRefreshLevelReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.level != null && message.hasOwnProperty("level"))
                if (!$util.isInteger(message.level))
                    return "level: integer expected";
            return null;
        };

        return ChangeRefreshLevelReq;
    })();

    CatMission.ChangeRefreshLevelRes = (function() {

        /**
         * Properties of a ChangeRefreshLevelRes.
         * @memberof CatMission
         * @interface IChangeRefreshLevelRes
         */

        /**
         * Constructs a new ChangeRefreshLevelRes.
         * @memberof CatMission
         * @classdesc Represents a ChangeRefreshLevelRes.
         * @implements IChangeRefreshLevelRes
         * @constructor
         * @param {CatMission.IChangeRefreshLevelRes=} [properties] Properties to set
         */
        function ChangeRefreshLevelRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new ChangeRefreshLevelRes instance using the specified properties.
         * @function create
         * @memberof CatMission.ChangeRefreshLevelRes
         * @static
         * @param {CatMission.IChangeRefreshLevelRes=} [properties] Properties to set
         * @returns {CatMission.ChangeRefreshLevelRes} ChangeRefreshLevelRes instance
         */
        ChangeRefreshLevelRes.create = function create(properties) {
            return new ChangeRefreshLevelRes(properties);
        };

        /**
         * Encodes the specified ChangeRefreshLevelRes message. Does not implicitly {@link CatMission.ChangeRefreshLevelRes.verify|verify} messages.
         * @function encode
         * @memberof CatMission.ChangeRefreshLevelRes
         * @static
         * @param {CatMission.IChangeRefreshLevelRes} message ChangeRefreshLevelRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ChangeRefreshLevelRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified ChangeRefreshLevelRes message, length delimited. Does not implicitly {@link CatMission.ChangeRefreshLevelRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof CatMission.ChangeRefreshLevelRes
         * @static
         * @param {CatMission.IChangeRefreshLevelRes} message ChangeRefreshLevelRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ChangeRefreshLevelRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ChangeRefreshLevelRes message from the specified reader or buffer.
         * @function decode
         * @memberof CatMission.ChangeRefreshLevelRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {CatMission.ChangeRefreshLevelRes} ChangeRefreshLevelRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ChangeRefreshLevelRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.CatMission.ChangeRefreshLevelRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ChangeRefreshLevelRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof CatMission.ChangeRefreshLevelRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {CatMission.ChangeRefreshLevelRes} ChangeRefreshLevelRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ChangeRefreshLevelRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ChangeRefreshLevelRes message.
         * @function verify
         * @memberof CatMission.ChangeRefreshLevelRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ChangeRefreshLevelRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return ChangeRefreshLevelRes;
    })();

    CatMission.ReceiveMissionRewardReq = (function() {

        /**
         * Properties of a ReceiveMissionRewardReq.
         * @memberof CatMission
         * @interface IReceiveMissionRewardReq
         * @property {number|null} [missionIndex] ReceiveMissionRewardReq missionIndex
         * @property {Array.<string>|null} [roleIds] ReceiveMissionRewardReq roleIds
         */

        /**
         * Constructs a new ReceiveMissionRewardReq.
         * @memberof CatMission
         * @classdesc Represents a ReceiveMissionRewardReq.
         * @implements IReceiveMissionRewardReq
         * @constructor
         * @param {CatMission.IReceiveMissionRewardReq=} [properties] Properties to set
         */
        function ReceiveMissionRewardReq(properties) {
            this.roleIds = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReceiveMissionRewardReq missionIndex.
         * @member {number} missionIndex
         * @memberof CatMission.ReceiveMissionRewardReq
         * @instance
         */
        ReceiveMissionRewardReq.prototype.missionIndex = 0;

        /**
         * ReceiveMissionRewardReq roleIds.
         * @member {Array.<string>} roleIds
         * @memberof CatMission.ReceiveMissionRewardReq
         * @instance
         */
        ReceiveMissionRewardReq.prototype.roleIds = $util.emptyArray;

        /**
         * Creates a new ReceiveMissionRewardReq instance using the specified properties.
         * @function create
         * @memberof CatMission.ReceiveMissionRewardReq
         * @static
         * @param {CatMission.IReceiveMissionRewardReq=} [properties] Properties to set
         * @returns {CatMission.ReceiveMissionRewardReq} ReceiveMissionRewardReq instance
         */
        ReceiveMissionRewardReq.create = function create(properties) {
            return new ReceiveMissionRewardReq(properties);
        };

        /**
         * Encodes the specified ReceiveMissionRewardReq message. Does not implicitly {@link CatMission.ReceiveMissionRewardReq.verify|verify} messages.
         * @function encode
         * @memberof CatMission.ReceiveMissionRewardReq
         * @static
         * @param {CatMission.IReceiveMissionRewardReq} message ReceiveMissionRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveMissionRewardReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.missionIndex != null && message.hasOwnProperty("missionIndex"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.missionIndex);
            if (message.roleIds != null && message.roleIds.length)
                for (var i = 0; i < message.roleIds.length; ++i)
                    writer.uint32(/* id 2, wireType 2 =*/18).string(message.roleIds[i]);
            return writer;
        };

        /**
         * Encodes the specified ReceiveMissionRewardReq message, length delimited. Does not implicitly {@link CatMission.ReceiveMissionRewardReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof CatMission.ReceiveMissionRewardReq
         * @static
         * @param {CatMission.IReceiveMissionRewardReq} message ReceiveMissionRewardReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveMissionRewardReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveMissionRewardReq message from the specified reader or buffer.
         * @function decode
         * @memberof CatMission.ReceiveMissionRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {CatMission.ReceiveMissionRewardReq} ReceiveMissionRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveMissionRewardReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.CatMission.ReceiveMissionRewardReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.missionIndex = reader.int32();
                    break;
                case 2:
                    if (!(message.roleIds && message.roleIds.length))
                        message.roleIds = [];
                    message.roleIds.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveMissionRewardReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof CatMission.ReceiveMissionRewardReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {CatMission.ReceiveMissionRewardReq} ReceiveMissionRewardReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveMissionRewardReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveMissionRewardReq message.
         * @function verify
         * @memberof CatMission.ReceiveMissionRewardReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveMissionRewardReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.missionIndex != null && message.hasOwnProperty("missionIndex"))
                if (!$util.isInteger(message.missionIndex))
                    return "missionIndex: integer expected";
            if (message.roleIds != null && message.hasOwnProperty("roleIds")) {
                if (!Array.isArray(message.roleIds))
                    return "roleIds: array expected";
                for (var i = 0; i < message.roleIds.length; ++i)
                    if (!$util.isString(message.roleIds[i]))
                        return "roleIds: string[] expected";
            }
            return null;
        };

        return ReceiveMissionRewardReq;
    })();

    CatMission.ReceiveMissionRewardRes = (function() {

        /**
         * Properties of a ReceiveMissionRewardRes.
         * @memberof CatMission
         * @interface IReceiveMissionRewardRes
         * @property {CatMission.ICatMissionInfo|null} [catMissionInfo] ReceiveMissionRewardRes catMissionInfo
         * @property {CatMission.ICatMissionPetInfo|null} [catMissionPetInfo] ReceiveMissionRewardRes catMissionPetInfo
         * @property {BaseInfo.IRewards|null} [rewards] ReceiveMissionRewardRes rewards
         * @property {BaseInfo.ICurrencyBag|null} [bag] ReceiveMissionRewardRes bag
         */

        /**
         * Constructs a new ReceiveMissionRewardRes.
         * @memberof CatMission
         * @classdesc Represents a ReceiveMissionRewardRes.
         * @implements IReceiveMissionRewardRes
         * @constructor
         * @param {CatMission.IReceiveMissionRewardRes=} [properties] Properties to set
         */
        function ReceiveMissionRewardRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReceiveMissionRewardRes catMissionInfo.
         * @member {CatMission.ICatMissionInfo|null|undefined} catMissionInfo
         * @memberof CatMission.ReceiveMissionRewardRes
         * @instance
         */
        ReceiveMissionRewardRes.prototype.catMissionInfo = null;

        /**
         * ReceiveMissionRewardRes catMissionPetInfo.
         * @member {CatMission.ICatMissionPetInfo|null|undefined} catMissionPetInfo
         * @memberof CatMission.ReceiveMissionRewardRes
         * @instance
         */
        ReceiveMissionRewardRes.prototype.catMissionPetInfo = null;

        /**
         * ReceiveMissionRewardRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof CatMission.ReceiveMissionRewardRes
         * @instance
         */
        ReceiveMissionRewardRes.prototype.rewards = null;

        /**
         * ReceiveMissionRewardRes bag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} bag
         * @memberof CatMission.ReceiveMissionRewardRes
         * @instance
         */
        ReceiveMissionRewardRes.prototype.bag = null;

        /**
         * Creates a new ReceiveMissionRewardRes instance using the specified properties.
         * @function create
         * @memberof CatMission.ReceiveMissionRewardRes
         * @static
         * @param {CatMission.IReceiveMissionRewardRes=} [properties] Properties to set
         * @returns {CatMission.ReceiveMissionRewardRes} ReceiveMissionRewardRes instance
         */
        ReceiveMissionRewardRes.create = function create(properties) {
            return new ReceiveMissionRewardRes(properties);
        };

        /**
         * Encodes the specified ReceiveMissionRewardRes message. Does not implicitly {@link CatMission.ReceiveMissionRewardRes.verify|verify} messages.
         * @function encode
         * @memberof CatMission.ReceiveMissionRewardRes
         * @static
         * @param {CatMission.IReceiveMissionRewardRes} message ReceiveMissionRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveMissionRewardRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.catMissionInfo != null && message.hasOwnProperty("catMissionInfo"))
                $root.CatMission.CatMissionInfo.encode(message.catMissionInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.catMissionPetInfo != null && message.hasOwnProperty("catMissionPetInfo"))
                $root.CatMission.CatMissionPetInfo.encode(message.catMissionPetInfo, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.bag != null && message.hasOwnProperty("bag"))
                $root.BaseInfo.CurrencyBag.encode(message.bag, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified ReceiveMissionRewardRes message, length delimited. Does not implicitly {@link CatMission.ReceiveMissionRewardRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof CatMission.ReceiveMissionRewardRes
         * @static
         * @param {CatMission.IReceiveMissionRewardRes} message ReceiveMissionRewardRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveMissionRewardRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveMissionRewardRes message from the specified reader or buffer.
         * @function decode
         * @memberof CatMission.ReceiveMissionRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {CatMission.ReceiveMissionRewardRes} ReceiveMissionRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveMissionRewardRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.CatMission.ReceiveMissionRewardRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.catMissionInfo = $root.CatMission.CatMissionInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.catMissionPetInfo = $root.CatMission.CatMissionPetInfo.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.bag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveMissionRewardRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof CatMission.ReceiveMissionRewardRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {CatMission.ReceiveMissionRewardRes} ReceiveMissionRewardRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveMissionRewardRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveMissionRewardRes message.
         * @function verify
         * @memberof CatMission.ReceiveMissionRewardRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveMissionRewardRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.catMissionInfo != null && message.hasOwnProperty("catMissionInfo")) {
                var error = $root.CatMission.CatMissionInfo.verify(message.catMissionInfo);
                if (error)
                    return "catMissionInfo." + error;
            }
            if (message.catMissionPetInfo != null && message.hasOwnProperty("catMissionPetInfo")) {
                var error = $root.CatMission.CatMissionPetInfo.verify(message.catMissionPetInfo);
                if (error)
                    return "catMissionPetInfo." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.bag != null && message.hasOwnProperty("bag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.bag);
                if (error)
                    return "bag." + error;
            }
            return null;
        };

        return ReceiveMissionRewardRes;
    })();

    CatMission.CatMissionInfo = (function() {

        /**
         * Properties of a CatMissionInfo.
         * @memberof CatMission
         * @interface ICatMissionInfo
         * @property {Array.<CatMission.ICatMission>|null} [missionList] CatMissionInfo missionList
         * @property {number|null} [level] CatMissionInfo level
         * @property {number|null} [exp] CatMissionInfo exp
         * @property {number|null} [refreshLevel] CatMissionInfo refreshLevel
         * @property {number|null} [dailyRefreshTimes] CatMissionInfo dailyRefreshTimes
         * @property {number|Long|null} [nextResetTs] CatMissionInfo nextResetTs
         */

        /**
         * Constructs a new CatMissionInfo.
         * @memberof CatMission
         * @classdesc Represents a CatMissionInfo.
         * @implements ICatMissionInfo
         * @constructor
         * @param {CatMission.ICatMissionInfo=} [properties] Properties to set
         */
        function CatMissionInfo(properties) {
            this.missionList = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CatMissionInfo missionList.
         * @member {Array.<CatMission.ICatMission>} missionList
         * @memberof CatMission.CatMissionInfo
         * @instance
         */
        CatMissionInfo.prototype.missionList = $util.emptyArray;

        /**
         * CatMissionInfo level.
         * @member {number} level
         * @memberof CatMission.CatMissionInfo
         * @instance
         */
        CatMissionInfo.prototype.level = 0;

        /**
         * CatMissionInfo exp.
         * @member {number} exp
         * @memberof CatMission.CatMissionInfo
         * @instance
         */
        CatMissionInfo.prototype.exp = 0;

        /**
         * CatMissionInfo refreshLevel.
         * @member {number} refreshLevel
         * @memberof CatMission.CatMissionInfo
         * @instance
         */
        CatMissionInfo.prototype.refreshLevel = 0;

        /**
         * CatMissionInfo dailyRefreshTimes.
         * @member {number} dailyRefreshTimes
         * @memberof CatMission.CatMissionInfo
         * @instance
         */
        CatMissionInfo.prototype.dailyRefreshTimes = 0;

        /**
         * CatMissionInfo nextResetTs.
         * @member {number|Long} nextResetTs
         * @memberof CatMission.CatMissionInfo
         * @instance
         */
        CatMissionInfo.prototype.nextResetTs = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new CatMissionInfo instance using the specified properties.
         * @function create
         * @memberof CatMission.CatMissionInfo
         * @static
         * @param {CatMission.ICatMissionInfo=} [properties] Properties to set
         * @returns {CatMission.CatMissionInfo} CatMissionInfo instance
         */
        CatMissionInfo.create = function create(properties) {
            return new CatMissionInfo(properties);
        };

        /**
         * Encodes the specified CatMissionInfo message. Does not implicitly {@link CatMission.CatMissionInfo.verify|verify} messages.
         * @function encode
         * @memberof CatMission.CatMissionInfo
         * @static
         * @param {CatMission.ICatMissionInfo} message CatMissionInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatMissionInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.missionList != null && message.missionList.length)
                for (var i = 0; i < message.missionList.length; ++i)
                    $root.CatMission.CatMission.encode(message.missionList[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.level != null && message.hasOwnProperty("level"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.level);
            if (message.refreshLevel != null && message.hasOwnProperty("refreshLevel"))
                writer.uint32(/* id 3, wireType 0 =*/24).int32(message.refreshLevel);
            if (message.dailyRefreshTimes != null && message.hasOwnProperty("dailyRefreshTimes"))
                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.dailyRefreshTimes);
            if (message.nextResetTs != null && message.hasOwnProperty("nextResetTs"))
                writer.uint32(/* id 5, wireType 0 =*/40).int64(message.nextResetTs);
            if (message.exp != null && message.hasOwnProperty("exp"))
                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.exp);
            return writer;
        };

        /**
         * Encodes the specified CatMissionInfo message, length delimited. Does not implicitly {@link CatMission.CatMissionInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof CatMission.CatMissionInfo
         * @static
         * @param {CatMission.ICatMissionInfo} message CatMissionInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatMissionInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CatMissionInfo message from the specified reader or buffer.
         * @function decode
         * @memberof CatMission.CatMissionInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {CatMission.CatMissionInfo} CatMissionInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatMissionInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.CatMission.CatMissionInfo();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.missionList && message.missionList.length))
                        message.missionList = [];
                    message.missionList.push($root.CatMission.CatMission.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.level = reader.int32();
                    break;
                case 6:
                    message.exp = reader.int32();
                    break;
                case 3:
                    message.refreshLevel = reader.int32();
                    break;
                case 4:
                    message.dailyRefreshTimes = reader.int32();
                    break;
                case 5:
                    message.nextResetTs = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CatMissionInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof CatMission.CatMissionInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {CatMission.CatMissionInfo} CatMissionInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatMissionInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CatMissionInfo message.
         * @function verify
         * @memberof CatMission.CatMissionInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CatMissionInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.missionList != null && message.hasOwnProperty("missionList")) {
                if (!Array.isArray(message.missionList))
                    return "missionList: array expected";
                for (var i = 0; i < message.missionList.length; ++i) {
                    var error = $root.CatMission.CatMission.verify(message.missionList[i]);
                    if (error)
                        return "missionList." + error;
                }
            }
            if (message.level != null && message.hasOwnProperty("level"))
                if (!$util.isInteger(message.level))
                    return "level: integer expected";
            if (message.exp != null && message.hasOwnProperty("exp"))
                if (!$util.isInteger(message.exp))
                    return "exp: integer expected";
            if (message.refreshLevel != null && message.hasOwnProperty("refreshLevel"))
                if (!$util.isInteger(message.refreshLevel))
                    return "refreshLevel: integer expected";
            if (message.dailyRefreshTimes != null && message.hasOwnProperty("dailyRefreshTimes"))
                if (!$util.isInteger(message.dailyRefreshTimes))
                    return "dailyRefreshTimes: integer expected";
            if (message.nextResetTs != null && message.hasOwnProperty("nextResetTs"))
                if (!$util.isInteger(message.nextResetTs) && !(message.nextResetTs && $util.isInteger(message.nextResetTs.low) && $util.isInteger(message.nextResetTs.high)))
                    return "nextResetTs: integer|Long expected";
            return null;
        };

        return CatMissionInfo;
    })();

    CatMission.CatMission = (function() {

        /**
         * Properties of a CatMission.
         * @memberof CatMission
         * @interface ICatMission
         * @property {string|null} [missionId] CatMission missionId
         * @property {number|Long|null} [resetTime] CatMission resetTime
         */

        /**
         * Constructs a new CatMission.
         * @memberof CatMission
         * @classdesc Represents a CatMission.
         * @implements ICatMission
         * @constructor
         * @param {CatMission.ICatMission=} [properties] Properties to set
         */
        function CatMission(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CatMission missionId.
         * @member {string} missionId
         * @memberof CatMission.CatMission
         * @instance
         */
        CatMission.prototype.missionId = "";

        /**
         * CatMission resetTime.
         * @member {number|Long} resetTime
         * @memberof CatMission.CatMission
         * @instance
         */
        CatMission.prototype.resetTime = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Creates a new CatMission instance using the specified properties.
         * @function create
         * @memberof CatMission.CatMission
         * @static
         * @param {CatMission.ICatMission=} [properties] Properties to set
         * @returns {CatMission.CatMission} CatMission instance
         */
        CatMission.create = function create(properties) {
            return new CatMission(properties);
        };

        /**
         * Encodes the specified CatMission message. Does not implicitly {@link CatMission.CatMission.verify|verify} messages.
         * @function encode
         * @memberof CatMission.CatMission
         * @static
         * @param {CatMission.ICatMission} message CatMission message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatMission.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.missionId != null && message.hasOwnProperty("missionId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.missionId);
            if (message.resetTime != null && message.hasOwnProperty("resetTime"))
                writer.uint32(/* id 2, wireType 0 =*/16).int64(message.resetTime);
            return writer;
        };

        /**
         * Encodes the specified CatMission message, length delimited. Does not implicitly {@link CatMission.CatMission.verify|verify} messages.
         * @function encodeDelimited
         * @memberof CatMission.CatMission
         * @static
         * @param {CatMission.ICatMission} message CatMission message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatMission.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CatMission message from the specified reader or buffer.
         * @function decode
         * @memberof CatMission.CatMission
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {CatMission.CatMission} CatMission
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatMission.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.CatMission.CatMission();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.missionId = reader.string();
                    break;
                case 2:
                    message.resetTime = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CatMission message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof CatMission.CatMission
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {CatMission.CatMission} CatMission
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatMission.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CatMission message.
         * @function verify
         * @memberof CatMission.CatMission
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CatMission.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.missionId != null && message.hasOwnProperty("missionId"))
                if (!$util.isString(message.missionId))
                    return "missionId: string expected";
            if (message.resetTime != null && message.hasOwnProperty("resetTime"))
                if (!$util.isInteger(message.resetTime) && !(message.resetTime && $util.isInteger(message.resetTime.low) && $util.isInteger(message.resetTime.high)))
                    return "resetTime: integer|Long expected";
            return null;
        };

        return CatMission;
    })();

    CatMission.CatMissionPetInfo = (function() {

        /**
         * Properties of a CatMissionPetInfo.
         * @memberof CatMission
         * @interface ICatMissionPetInfo
         * @property {Object.<string,number|Long>|null} [petResetTsMap] CatMissionPetInfo petResetTsMap
         */

        /**
         * Constructs a new CatMissionPetInfo.
         * @memberof CatMission
         * @classdesc Represents a CatMissionPetInfo.
         * @implements ICatMissionPetInfo
         * @constructor
         * @param {CatMission.ICatMissionPetInfo=} [properties] Properties to set
         */
        function CatMissionPetInfo(properties) {
            this.petResetTsMap = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CatMissionPetInfo petResetTsMap.
         * @member {Object.<string,number|Long>} petResetTsMap
         * @memberof CatMission.CatMissionPetInfo
         * @instance
         */
        CatMissionPetInfo.prototype.petResetTsMap = $util.emptyObject;

        /**
         * Creates a new CatMissionPetInfo instance using the specified properties.
         * @function create
         * @memberof CatMission.CatMissionPetInfo
         * @static
         * @param {CatMission.ICatMissionPetInfo=} [properties] Properties to set
         * @returns {CatMission.CatMissionPetInfo} CatMissionPetInfo instance
         */
        CatMissionPetInfo.create = function create(properties) {
            return new CatMissionPetInfo(properties);
        };

        /**
         * Encodes the specified CatMissionPetInfo message. Does not implicitly {@link CatMission.CatMissionPetInfo.verify|verify} messages.
         * @function encode
         * @memberof CatMission.CatMissionPetInfo
         * @static
         * @param {CatMission.ICatMissionPetInfo} message CatMissionPetInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatMissionPetInfo.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.petResetTsMap != null && message.hasOwnProperty("petResetTsMap"))
                for (var keys = Object.keys(message.petResetTsMap), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 0 =*/16).int64(message.petResetTsMap[keys[i]]).ldelim();
            return writer;
        };

        /**
         * Encodes the specified CatMissionPetInfo message, length delimited. Does not implicitly {@link CatMission.CatMissionPetInfo.verify|verify} messages.
         * @function encodeDelimited
         * @memberof CatMission.CatMissionPetInfo
         * @static
         * @param {CatMission.ICatMissionPetInfo} message CatMissionPetInfo message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CatMissionPetInfo.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CatMissionPetInfo message from the specified reader or buffer.
         * @function decode
         * @memberof CatMission.CatMissionPetInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {CatMission.CatMissionPetInfo} CatMissionPetInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatMissionPetInfo.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.CatMission.CatMissionPetInfo(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.petResetTsMap === $util.emptyObject)
                        message.petResetTsMap = {};
                    key = reader.string();
                    reader.pos++;
                    message.petResetTsMap[key] = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CatMissionPetInfo message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof CatMission.CatMissionPetInfo
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {CatMission.CatMissionPetInfo} CatMissionPetInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CatMissionPetInfo.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CatMissionPetInfo message.
         * @function verify
         * @memberof CatMission.CatMissionPetInfo
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CatMissionPetInfo.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.petResetTsMap != null && message.hasOwnProperty("petResetTsMap")) {
                if (!$util.isObject(message.petResetTsMap))
                    return "petResetTsMap: object expected";
                var key = Object.keys(message.petResetTsMap);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isInteger(message.petResetTsMap[key[i]]) && !(message.petResetTsMap[key[i]] && $util.isInteger(message.petResetTsMap[key[i]].low) && $util.isInteger(message.petResetTsMap[key[i]].high)))
                        return "petResetTsMap: integer|Long{k:string} expected";
            }
            return null;
        };

        return CatMissionPetInfo;
    })();

    return CatMission;
})();

$root.Pay = (function() {

    /**
     * Namespace Pay.
     * @exports Pay
     * @namespace
     */
    var Pay = {};

    Pay.CreateOrderReq = (function() {

        /**
         * Properties of a CreateOrderReq.
         * @memberof Pay
         * @interface ICreateOrderReq
         * @property {string|null} [orderId] CreateOrderReq orderId
         * @property {string|null} [purchaseId] CreateOrderReq purchaseId
         */

        /**
         * Constructs a new CreateOrderReq.
         * @memberof Pay
         * @classdesc Represents a CreateOrderReq.
         * @implements ICreateOrderReq
         * @constructor
         * @param {Pay.ICreateOrderReq=} [properties] Properties to set
         */
        function CreateOrderReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * CreateOrderReq orderId.
         * @member {string} orderId
         * @memberof Pay.CreateOrderReq
         * @instance
         */
        CreateOrderReq.prototype.orderId = "";

        /**
         * CreateOrderReq purchaseId.
         * @member {string} purchaseId
         * @memberof Pay.CreateOrderReq
         * @instance
         */
        CreateOrderReq.prototype.purchaseId = "";

        /**
         * Creates a new CreateOrderReq instance using the specified properties.
         * @function create
         * @memberof Pay.CreateOrderReq
         * @static
         * @param {Pay.ICreateOrderReq=} [properties] Properties to set
         * @returns {Pay.CreateOrderReq} CreateOrderReq instance
         */
        CreateOrderReq.create = function create(properties) {
            return new CreateOrderReq(properties);
        };

        /**
         * Encodes the specified CreateOrderReq message. Does not implicitly {@link Pay.CreateOrderReq.verify|verify} messages.
         * @function encode
         * @memberof Pay.CreateOrderReq
         * @static
         * @param {Pay.ICreateOrderReq} message CreateOrderReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CreateOrderReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.orderId != null && message.hasOwnProperty("orderId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.orderId);
            if (message.purchaseId != null && message.hasOwnProperty("purchaseId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.purchaseId);
            return writer;
        };

        /**
         * Encodes the specified CreateOrderReq message, length delimited. Does not implicitly {@link Pay.CreateOrderReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pay.CreateOrderReq
         * @static
         * @param {Pay.ICreateOrderReq} message CreateOrderReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CreateOrderReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CreateOrderReq message from the specified reader or buffer.
         * @function decode
         * @memberof Pay.CreateOrderReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pay.CreateOrderReq} CreateOrderReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CreateOrderReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pay.CreateOrderReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.orderId = reader.string();
                    break;
                case 2:
                    message.purchaseId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CreateOrderReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pay.CreateOrderReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pay.CreateOrderReq} CreateOrderReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CreateOrderReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CreateOrderReq message.
         * @function verify
         * @memberof Pay.CreateOrderReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CreateOrderReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.orderId != null && message.hasOwnProperty("orderId"))
                if (!$util.isString(message.orderId))
                    return "orderId: string expected";
            if (message.purchaseId != null && message.hasOwnProperty("purchaseId"))
                if (!$util.isString(message.purchaseId))
                    return "purchaseId: string expected";
            return null;
        };

        return CreateOrderReq;
    })();

    Pay.CreateOrderRes = (function() {

        /**
         * Properties of a CreateOrderRes.
         * @memberof Pay
         * @interface ICreateOrderRes
         */

        /**
         * Constructs a new CreateOrderRes.
         * @memberof Pay
         * @classdesc Represents a CreateOrderRes.
         * @implements ICreateOrderRes
         * @constructor
         * @param {Pay.ICreateOrderRes=} [properties] Properties to set
         */
        function CreateOrderRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new CreateOrderRes instance using the specified properties.
         * @function create
         * @memberof Pay.CreateOrderRes
         * @static
         * @param {Pay.ICreateOrderRes=} [properties] Properties to set
         * @returns {Pay.CreateOrderRes} CreateOrderRes instance
         */
        CreateOrderRes.create = function create(properties) {
            return new CreateOrderRes(properties);
        };

        /**
         * Encodes the specified CreateOrderRes message. Does not implicitly {@link Pay.CreateOrderRes.verify|verify} messages.
         * @function encode
         * @memberof Pay.CreateOrderRes
         * @static
         * @param {Pay.ICreateOrderRes} message CreateOrderRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CreateOrderRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified CreateOrderRes message, length delimited. Does not implicitly {@link Pay.CreateOrderRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pay.CreateOrderRes
         * @static
         * @param {Pay.ICreateOrderRes} message CreateOrderRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        CreateOrderRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a CreateOrderRes message from the specified reader or buffer.
         * @function decode
         * @memberof Pay.CreateOrderRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pay.CreateOrderRes} CreateOrderRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CreateOrderRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pay.CreateOrderRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a CreateOrderRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pay.CreateOrderRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pay.CreateOrderRes} CreateOrderRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        CreateOrderRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a CreateOrderRes message.
         * @function verify
         * @memberof Pay.CreateOrderRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        CreateOrderRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return CreateOrderRes;
    })();

    Pay.FinishOrderReq = (function() {

        /**
         * Properties of a FinishOrderReq.
         * @memberof Pay
         * @interface IFinishOrderReq
         * @property {string|null} [orderId] FinishOrderReq orderId
         * @property {string|null} [purchaseId] FinishOrderReq purchaseId
         */

        /**
         * Constructs a new FinishOrderReq.
         * @memberof Pay
         * @classdesc Represents a FinishOrderReq.
         * @implements IFinishOrderReq
         * @constructor
         * @param {Pay.IFinishOrderReq=} [properties] Properties to set
         */
        function FinishOrderReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FinishOrderReq orderId.
         * @member {string} orderId
         * @memberof Pay.FinishOrderReq
         * @instance
         */
        FinishOrderReq.prototype.orderId = "";

        /**
         * FinishOrderReq purchaseId.
         * @member {string} purchaseId
         * @memberof Pay.FinishOrderReq
         * @instance
         */
        FinishOrderReq.prototype.purchaseId = "";

        /**
         * Creates a new FinishOrderReq instance using the specified properties.
         * @function create
         * @memberof Pay.FinishOrderReq
         * @static
         * @param {Pay.IFinishOrderReq=} [properties] Properties to set
         * @returns {Pay.FinishOrderReq} FinishOrderReq instance
         */
        FinishOrderReq.create = function create(properties) {
            return new FinishOrderReq(properties);
        };

        /**
         * Encodes the specified FinishOrderReq message. Does not implicitly {@link Pay.FinishOrderReq.verify|verify} messages.
         * @function encode
         * @memberof Pay.FinishOrderReq
         * @static
         * @param {Pay.IFinishOrderReq} message FinishOrderReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishOrderReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.orderId != null && message.hasOwnProperty("orderId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.orderId);
            if (message.purchaseId != null && message.hasOwnProperty("purchaseId"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.purchaseId);
            return writer;
        };

        /**
         * Encodes the specified FinishOrderReq message, length delimited. Does not implicitly {@link Pay.FinishOrderReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pay.FinishOrderReq
         * @static
         * @param {Pay.IFinishOrderReq} message FinishOrderReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishOrderReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FinishOrderReq message from the specified reader or buffer.
         * @function decode
         * @memberof Pay.FinishOrderReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pay.FinishOrderReq} FinishOrderReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishOrderReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pay.FinishOrderReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.orderId = reader.string();
                    break;
                case 2:
                    message.purchaseId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FinishOrderReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pay.FinishOrderReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pay.FinishOrderReq} FinishOrderReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishOrderReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FinishOrderReq message.
         * @function verify
         * @memberof Pay.FinishOrderReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FinishOrderReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.orderId != null && message.hasOwnProperty("orderId"))
                if (!$util.isString(message.orderId))
                    return "orderId: string expected";
            if (message.purchaseId != null && message.hasOwnProperty("purchaseId"))
                if (!$util.isString(message.purchaseId))
                    return "purchaseId: string expected";
            return null;
        };

        return FinishOrderReq;
    })();

    Pay.FinishOrderRes = (function() {

        /**
         * Properties of a FinishOrderRes.
         * @memberof Pay
         * @interface IFinishOrderRes
         * @property {BaseInfo.ICurrencyBag|null} [currencyBag] FinishOrderRes currencyBag
         * @property {BaseInfo.IPayInfo|null} [payInfo] FinishOrderRes payInfo
         * @property {BaseInfo.IRewards|null} [rewards] FinishOrderRes rewards
         * @property {LuckyDraw.ILotteryBag|null} [lotteryBag] FinishOrderRes lotteryBag
         */

        /**
         * Constructs a new FinishOrderRes.
         * @memberof Pay
         * @classdesc Represents a FinishOrderRes.
         * @implements IFinishOrderRes
         * @constructor
         * @param {Pay.IFinishOrderRes=} [properties] Properties to set
         */
        function FinishOrderRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FinishOrderRes currencyBag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} currencyBag
         * @memberof Pay.FinishOrderRes
         * @instance
         */
        FinishOrderRes.prototype.currencyBag = null;

        /**
         * FinishOrderRes payInfo.
         * @member {BaseInfo.IPayInfo|null|undefined} payInfo
         * @memberof Pay.FinishOrderRes
         * @instance
         */
        FinishOrderRes.prototype.payInfo = null;

        /**
         * FinishOrderRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Pay.FinishOrderRes
         * @instance
         */
        FinishOrderRes.prototype.rewards = null;

        /**
         * FinishOrderRes lotteryBag.
         * @member {LuckyDraw.ILotteryBag|null|undefined} lotteryBag
         * @memberof Pay.FinishOrderRes
         * @instance
         */
        FinishOrderRes.prototype.lotteryBag = null;

        /**
         * Creates a new FinishOrderRes instance using the specified properties.
         * @function create
         * @memberof Pay.FinishOrderRes
         * @static
         * @param {Pay.IFinishOrderRes=} [properties] Properties to set
         * @returns {Pay.FinishOrderRes} FinishOrderRes instance
         */
        FinishOrderRes.create = function create(properties) {
            return new FinishOrderRes(properties);
        };

        /**
         * Encodes the specified FinishOrderRes message. Does not implicitly {@link Pay.FinishOrderRes.verify|verify} messages.
         * @function encode
         * @memberof Pay.FinishOrderRes
         * @static
         * @param {Pay.IFinishOrderRes} message FinishOrderRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishOrderRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag"))
                $root.BaseInfo.CurrencyBag.encode(message.currencyBag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.payInfo != null && message.hasOwnProperty("payInfo"))
                $root.BaseInfo.PayInfo.encode(message.payInfo, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.lotteryBag != null && message.hasOwnProperty("lotteryBag"))
                $root.LuckyDraw.LotteryBag.encode(message.lotteryBag, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FinishOrderRes message, length delimited. Does not implicitly {@link Pay.FinishOrderRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pay.FinishOrderRes
         * @static
         * @param {Pay.IFinishOrderRes} message FinishOrderRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FinishOrderRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FinishOrderRes message from the specified reader or buffer.
         * @function decode
         * @memberof Pay.FinishOrderRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pay.FinishOrderRes} FinishOrderRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishOrderRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pay.FinishOrderRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.currencyBag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.payInfo = $root.BaseInfo.PayInfo.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.lotteryBag = $root.LuckyDraw.LotteryBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FinishOrderRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pay.FinishOrderRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pay.FinishOrderRes} FinishOrderRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FinishOrderRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FinishOrderRes message.
         * @function verify
         * @memberof Pay.FinishOrderRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FinishOrderRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.currencyBag);
                if (error)
                    return "currencyBag." + error;
            }
            if (message.payInfo != null && message.hasOwnProperty("payInfo")) {
                var error = $root.BaseInfo.PayInfo.verify(message.payInfo);
                if (error)
                    return "payInfo." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.lotteryBag != null && message.hasOwnProperty("lotteryBag")) {
                var error = $root.LuckyDraw.LotteryBag.verify(message.lotteryBag);
                if (error)
                    return "lotteryBag." + error;
            }
            return null;
        };

        return FinishOrderRes;
    })();

    Pay.ReceiveFreeDiamondReq = (function() {

        /**
         * Properties of a ReceiveFreeDiamondReq.
         * @memberof Pay
         * @interface IReceiveFreeDiamondReq
         */

        /**
         * Constructs a new ReceiveFreeDiamondReq.
         * @memberof Pay
         * @classdesc Represents a ReceiveFreeDiamondReq.
         * @implements IReceiveFreeDiamondReq
         * @constructor
         * @param {Pay.IReceiveFreeDiamondReq=} [properties] Properties to set
         */
        function ReceiveFreeDiamondReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new ReceiveFreeDiamondReq instance using the specified properties.
         * @function create
         * @memberof Pay.ReceiveFreeDiamondReq
         * @static
         * @param {Pay.IReceiveFreeDiamondReq=} [properties] Properties to set
         * @returns {Pay.ReceiveFreeDiamondReq} ReceiveFreeDiamondReq instance
         */
        ReceiveFreeDiamondReq.create = function create(properties) {
            return new ReceiveFreeDiamondReq(properties);
        };

        /**
         * Encodes the specified ReceiveFreeDiamondReq message. Does not implicitly {@link Pay.ReceiveFreeDiamondReq.verify|verify} messages.
         * @function encode
         * @memberof Pay.ReceiveFreeDiamondReq
         * @static
         * @param {Pay.IReceiveFreeDiamondReq} message ReceiveFreeDiamondReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveFreeDiamondReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified ReceiveFreeDiamondReq message, length delimited. Does not implicitly {@link Pay.ReceiveFreeDiamondReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pay.ReceiveFreeDiamondReq
         * @static
         * @param {Pay.IReceiveFreeDiamondReq} message ReceiveFreeDiamondReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveFreeDiamondReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveFreeDiamondReq message from the specified reader or buffer.
         * @function decode
         * @memberof Pay.ReceiveFreeDiamondReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pay.ReceiveFreeDiamondReq} ReceiveFreeDiamondReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveFreeDiamondReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pay.ReceiveFreeDiamondReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveFreeDiamondReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pay.ReceiveFreeDiamondReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pay.ReceiveFreeDiamondReq} ReceiveFreeDiamondReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveFreeDiamondReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveFreeDiamondReq message.
         * @function verify
         * @memberof Pay.ReceiveFreeDiamondReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveFreeDiamondReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return ReceiveFreeDiamondReq;
    })();

    Pay.ReceiveFreeDiamondRes = (function() {

        /**
         * Properties of a ReceiveFreeDiamondRes.
         * @memberof Pay
         * @interface IReceiveFreeDiamondRes
         * @property {BaseInfo.ICurrencyBag|null} [currencyBag] ReceiveFreeDiamondRes currencyBag
         * @property {BaseInfo.IPayInfo|null} [payInfo] ReceiveFreeDiamondRes payInfo
         * @property {BaseInfo.IRewards|null} [rewards] ReceiveFreeDiamondRes rewards
         */

        /**
         * Constructs a new ReceiveFreeDiamondRes.
         * @memberof Pay
         * @classdesc Represents a ReceiveFreeDiamondRes.
         * @implements IReceiveFreeDiamondRes
         * @constructor
         * @param {Pay.IReceiveFreeDiamondRes=} [properties] Properties to set
         */
        function ReceiveFreeDiamondRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReceiveFreeDiamondRes currencyBag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} currencyBag
         * @memberof Pay.ReceiveFreeDiamondRes
         * @instance
         */
        ReceiveFreeDiamondRes.prototype.currencyBag = null;

        /**
         * ReceiveFreeDiamondRes payInfo.
         * @member {BaseInfo.IPayInfo|null|undefined} payInfo
         * @memberof Pay.ReceiveFreeDiamondRes
         * @instance
         */
        ReceiveFreeDiamondRes.prototype.payInfo = null;

        /**
         * ReceiveFreeDiamondRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Pay.ReceiveFreeDiamondRes
         * @instance
         */
        ReceiveFreeDiamondRes.prototype.rewards = null;

        /**
         * Creates a new ReceiveFreeDiamondRes instance using the specified properties.
         * @function create
         * @memberof Pay.ReceiveFreeDiamondRes
         * @static
         * @param {Pay.IReceiveFreeDiamondRes=} [properties] Properties to set
         * @returns {Pay.ReceiveFreeDiamondRes} ReceiveFreeDiamondRes instance
         */
        ReceiveFreeDiamondRes.create = function create(properties) {
            return new ReceiveFreeDiamondRes(properties);
        };

        /**
         * Encodes the specified ReceiveFreeDiamondRes message. Does not implicitly {@link Pay.ReceiveFreeDiamondRes.verify|verify} messages.
         * @function encode
         * @memberof Pay.ReceiveFreeDiamondRes
         * @static
         * @param {Pay.IReceiveFreeDiamondRes} message ReceiveFreeDiamondRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveFreeDiamondRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag"))
                $root.BaseInfo.CurrencyBag.encode(message.currencyBag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.payInfo != null && message.hasOwnProperty("payInfo"))
                $root.BaseInfo.PayInfo.encode(message.payInfo, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified ReceiveFreeDiamondRes message, length delimited. Does not implicitly {@link Pay.ReceiveFreeDiamondRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pay.ReceiveFreeDiamondRes
         * @static
         * @param {Pay.IReceiveFreeDiamondRes} message ReceiveFreeDiamondRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveFreeDiamondRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveFreeDiamondRes message from the specified reader or buffer.
         * @function decode
         * @memberof Pay.ReceiveFreeDiamondRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pay.ReceiveFreeDiamondRes} ReceiveFreeDiamondRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveFreeDiamondRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pay.ReceiveFreeDiamondRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.currencyBag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.payInfo = $root.BaseInfo.PayInfo.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveFreeDiamondRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pay.ReceiveFreeDiamondRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pay.ReceiveFreeDiamondRes} ReceiveFreeDiamondRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveFreeDiamondRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveFreeDiamondRes message.
         * @function verify
         * @memberof Pay.ReceiveFreeDiamondRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveFreeDiamondRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.currencyBag);
                if (error)
                    return "currencyBag." + error;
            }
            if (message.payInfo != null && message.hasOwnProperty("payInfo")) {
                var error = $root.BaseInfo.PayInfo.verify(message.payInfo);
                if (error)
                    return "payInfo." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            return null;
        };

        return ReceiveFreeDiamondRes;
    })();

    Pay.PayCardBonusReq = (function() {

        /**
         * Properties of a PayCardBonusReq.
         * @memberof Pay
         * @interface IPayCardBonusReq
         * @property {BaseInfo.PayCardType|null} [cardType] PayCardBonusReq cardType
         */

        /**
         * Constructs a new PayCardBonusReq.
         * @memberof Pay
         * @classdesc Represents a PayCardBonusReq.
         * @implements IPayCardBonusReq
         * @constructor
         * @param {Pay.IPayCardBonusReq=} [properties] Properties to set
         */
        function PayCardBonusReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PayCardBonusReq cardType.
         * @member {BaseInfo.PayCardType} cardType
         * @memberof Pay.PayCardBonusReq
         * @instance
         */
        PayCardBonusReq.prototype.cardType = 0;

        /**
         * Creates a new PayCardBonusReq instance using the specified properties.
         * @function create
         * @memberof Pay.PayCardBonusReq
         * @static
         * @param {Pay.IPayCardBonusReq=} [properties] Properties to set
         * @returns {Pay.PayCardBonusReq} PayCardBonusReq instance
         */
        PayCardBonusReq.create = function create(properties) {
            return new PayCardBonusReq(properties);
        };

        /**
         * Encodes the specified PayCardBonusReq message. Does not implicitly {@link Pay.PayCardBonusReq.verify|verify} messages.
         * @function encode
         * @memberof Pay.PayCardBonusReq
         * @static
         * @param {Pay.IPayCardBonusReq} message PayCardBonusReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PayCardBonusReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.cardType != null && message.hasOwnProperty("cardType"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.cardType);
            return writer;
        };

        /**
         * Encodes the specified PayCardBonusReq message, length delimited. Does not implicitly {@link Pay.PayCardBonusReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pay.PayCardBonusReq
         * @static
         * @param {Pay.IPayCardBonusReq} message PayCardBonusReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PayCardBonusReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PayCardBonusReq message from the specified reader or buffer.
         * @function decode
         * @memberof Pay.PayCardBonusReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pay.PayCardBonusReq} PayCardBonusReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PayCardBonusReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pay.PayCardBonusReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.cardType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PayCardBonusReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pay.PayCardBonusReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pay.PayCardBonusReq} PayCardBonusReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PayCardBonusReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PayCardBonusReq message.
         * @function verify
         * @memberof Pay.PayCardBonusReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PayCardBonusReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.cardType != null && message.hasOwnProperty("cardType"))
                switch (message.cardType) {
                default:
                    return "cardType: enum value expected";
                case 0:
                case 1:
                    break;
                }
            return null;
        };

        return PayCardBonusReq;
    })();

    Pay.PayCardBonusRes = (function() {

        /**
         * Properties of a PayCardBonusRes.
         * @memberof Pay
         * @interface IPayCardBonusRes
         * @property {BaseInfo.ICurrencyBag|null} [currencyBag] PayCardBonusRes currencyBag
         * @property {BaseInfo.IPayInfo|null} [payInfo] PayCardBonusRes payInfo
         * @property {BaseInfo.IRewards|null} [rewards] PayCardBonusRes rewards
         * @property {LuckyDraw.ILotteryBag|null} [lotteryBag] PayCardBonusRes lotteryBag
         */

        /**
         * Constructs a new PayCardBonusRes.
         * @memberof Pay
         * @classdesc Represents a PayCardBonusRes.
         * @implements IPayCardBonusRes
         * @constructor
         * @param {Pay.IPayCardBonusRes=} [properties] Properties to set
         */
        function PayCardBonusRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PayCardBonusRes currencyBag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} currencyBag
         * @memberof Pay.PayCardBonusRes
         * @instance
         */
        PayCardBonusRes.prototype.currencyBag = null;

        /**
         * PayCardBonusRes payInfo.
         * @member {BaseInfo.IPayInfo|null|undefined} payInfo
         * @memberof Pay.PayCardBonusRes
         * @instance
         */
        PayCardBonusRes.prototype.payInfo = null;

        /**
         * PayCardBonusRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Pay.PayCardBonusRes
         * @instance
         */
        PayCardBonusRes.prototype.rewards = null;

        /**
         * PayCardBonusRes lotteryBag.
         * @member {LuckyDraw.ILotteryBag|null|undefined} lotteryBag
         * @memberof Pay.PayCardBonusRes
         * @instance
         */
        PayCardBonusRes.prototype.lotteryBag = null;

        /**
         * Creates a new PayCardBonusRes instance using the specified properties.
         * @function create
         * @memberof Pay.PayCardBonusRes
         * @static
         * @param {Pay.IPayCardBonusRes=} [properties] Properties to set
         * @returns {Pay.PayCardBonusRes} PayCardBonusRes instance
         */
        PayCardBonusRes.create = function create(properties) {
            return new PayCardBonusRes(properties);
        };

        /**
         * Encodes the specified PayCardBonusRes message. Does not implicitly {@link Pay.PayCardBonusRes.verify|verify} messages.
         * @function encode
         * @memberof Pay.PayCardBonusRes
         * @static
         * @param {Pay.IPayCardBonusRes} message PayCardBonusRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PayCardBonusRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag"))
                $root.BaseInfo.CurrencyBag.encode(message.currencyBag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.payInfo != null && message.hasOwnProperty("payInfo"))
                $root.BaseInfo.PayInfo.encode(message.payInfo, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.lotteryBag != null && message.hasOwnProperty("lotteryBag"))
                $root.LuckyDraw.LotteryBag.encode(message.lotteryBag, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified PayCardBonusRes message, length delimited. Does not implicitly {@link Pay.PayCardBonusRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Pay.PayCardBonusRes
         * @static
         * @param {Pay.IPayCardBonusRes} message PayCardBonusRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PayCardBonusRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PayCardBonusRes message from the specified reader or buffer.
         * @function decode
         * @memberof Pay.PayCardBonusRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Pay.PayCardBonusRes} PayCardBonusRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PayCardBonusRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Pay.PayCardBonusRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.currencyBag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.payInfo = $root.BaseInfo.PayInfo.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.lotteryBag = $root.LuckyDraw.LotteryBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PayCardBonusRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Pay.PayCardBonusRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Pay.PayCardBonusRes} PayCardBonusRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PayCardBonusRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PayCardBonusRes message.
         * @function verify
         * @memberof Pay.PayCardBonusRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PayCardBonusRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.currencyBag);
                if (error)
                    return "currencyBag." + error;
            }
            if (message.payInfo != null && message.hasOwnProperty("payInfo")) {
                var error = $root.BaseInfo.PayInfo.verify(message.payInfo);
                if (error)
                    return "payInfo." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.lotteryBag != null && message.hasOwnProperty("lotteryBag")) {
                var error = $root.LuckyDraw.LotteryBag.verify(message.lotteryBag);
                if (error)
                    return "lotteryBag." + error;
            }
            return null;
        };

        return PayCardBonusRes;
    })();

    return Pay;
})();

$root.Shop = (function() {

    /**
     * Namespace Shop.
     * @exports Shop
     * @namespace
     */
    var Shop = {};

    Shop.ResourceShopReq = (function() {

        /**
         * Properties of a ResourceShopReq.
         * @memberof Shop
         * @interface IResourceShopReq
         * @property {string|null} [purchaseId] ResourceShopReq purchaseId
         */

        /**
         * Constructs a new ResourceShopReq.
         * @memberof Shop
         * @classdesc Represents a ResourceShopReq.
         * @implements IResourceShopReq
         * @constructor
         * @param {Shop.IResourceShopReq=} [properties] Properties to set
         */
        function ResourceShopReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ResourceShopReq purchaseId.
         * @member {string} purchaseId
         * @memberof Shop.ResourceShopReq
         * @instance
         */
        ResourceShopReq.prototype.purchaseId = "";

        /**
         * Creates a new ResourceShopReq instance using the specified properties.
         * @function create
         * @memberof Shop.ResourceShopReq
         * @static
         * @param {Shop.IResourceShopReq=} [properties] Properties to set
         * @returns {Shop.ResourceShopReq} ResourceShopReq instance
         */
        ResourceShopReq.create = function create(properties) {
            return new ResourceShopReq(properties);
        };

        /**
         * Encodes the specified ResourceShopReq message. Does not implicitly {@link Shop.ResourceShopReq.verify|verify} messages.
         * @function encode
         * @memberof Shop.ResourceShopReq
         * @static
         * @param {Shop.IResourceShopReq} message ResourceShopReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ResourceShopReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.purchaseId != null && message.hasOwnProperty("purchaseId"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.purchaseId);
            return writer;
        };

        /**
         * Encodes the specified ResourceShopReq message, length delimited. Does not implicitly {@link Shop.ResourceShopReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Shop.ResourceShopReq
         * @static
         * @param {Shop.IResourceShopReq} message ResourceShopReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ResourceShopReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ResourceShopReq message from the specified reader or buffer.
         * @function decode
         * @memberof Shop.ResourceShopReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Shop.ResourceShopReq} ResourceShopReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ResourceShopReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Shop.ResourceShopReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.purchaseId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ResourceShopReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Shop.ResourceShopReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Shop.ResourceShopReq} ResourceShopReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ResourceShopReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ResourceShopReq message.
         * @function verify
         * @memberof Shop.ResourceShopReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ResourceShopReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.purchaseId != null && message.hasOwnProperty("purchaseId"))
                if (!$util.isString(message.purchaseId))
                    return "purchaseId: string expected";
            return null;
        };

        return ResourceShopReq;
    })();

    Shop.ResourceShopRes = (function() {

        /**
         * Properties of a ResourceShopRes.
         * @memberof Shop
         * @interface IResourceShopRes
         * @property {BaseInfo.ICurrencyBag|null} [currencyBag] ResourceShopRes currencyBag
         * @property {BaseInfo.IPayInfo|null} [payInfo] ResourceShopRes payInfo
         * @property {BaseInfo.IRewards|null} [rewards] ResourceShopRes rewards
         */

        /**
         * Constructs a new ResourceShopRes.
         * @memberof Shop
         * @classdesc Represents a ResourceShopRes.
         * @implements IResourceShopRes
         * @constructor
         * @param {Shop.IResourceShopRes=} [properties] Properties to set
         */
        function ResourceShopRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ResourceShopRes currencyBag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} currencyBag
         * @memberof Shop.ResourceShopRes
         * @instance
         */
        ResourceShopRes.prototype.currencyBag = null;

        /**
         * ResourceShopRes payInfo.
         * @member {BaseInfo.IPayInfo|null|undefined} payInfo
         * @memberof Shop.ResourceShopRes
         * @instance
         */
        ResourceShopRes.prototype.payInfo = null;

        /**
         * ResourceShopRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Shop.ResourceShopRes
         * @instance
         */
        ResourceShopRes.prototype.rewards = null;

        /**
         * Creates a new ResourceShopRes instance using the specified properties.
         * @function create
         * @memberof Shop.ResourceShopRes
         * @static
         * @param {Shop.IResourceShopRes=} [properties] Properties to set
         * @returns {Shop.ResourceShopRes} ResourceShopRes instance
         */
        ResourceShopRes.create = function create(properties) {
            return new ResourceShopRes(properties);
        };

        /**
         * Encodes the specified ResourceShopRes message. Does not implicitly {@link Shop.ResourceShopRes.verify|verify} messages.
         * @function encode
         * @memberof Shop.ResourceShopRes
         * @static
         * @param {Shop.IResourceShopRes} message ResourceShopRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ResourceShopRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag"))
                $root.BaseInfo.CurrencyBag.encode(message.currencyBag, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.payInfo != null && message.hasOwnProperty("payInfo"))
                $root.BaseInfo.PayInfo.encode(message.payInfo, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified ResourceShopRes message, length delimited. Does not implicitly {@link Shop.ResourceShopRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Shop.ResourceShopRes
         * @static
         * @param {Shop.IResourceShopRes} message ResourceShopRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ResourceShopRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ResourceShopRes message from the specified reader or buffer.
         * @function decode
         * @memberof Shop.ResourceShopRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Shop.ResourceShopRes} ResourceShopRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ResourceShopRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Shop.ResourceShopRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.currencyBag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.payInfo = $root.BaseInfo.PayInfo.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ResourceShopRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Shop.ResourceShopRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Shop.ResourceShopRes} ResourceShopRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ResourceShopRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ResourceShopRes message.
         * @function verify
         * @memberof Shop.ResourceShopRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ResourceShopRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.currencyBag);
                if (error)
                    return "currencyBag." + error;
            }
            if (message.payInfo != null && message.hasOwnProperty("payInfo")) {
                var error = $root.BaseInfo.PayInfo.verify(message.payInfo);
                if (error)
                    return "payInfo." + error;
            }
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            return null;
        };

        return ResourceShopRes;
    })();

    return Shop;
})();

$root.Takeout = (function() {

    /**
     * Namespace Takeout.
     * @exports Takeout
     * @namespace
     */
    var Takeout = {};

    Takeout.FetchTakeoutInfoReq = (function() {

        /**
         * Properties of a FetchTakeoutInfoReq.
         * @memberof Takeout
         * @interface IFetchTakeoutInfoReq
         */

        /**
         * Constructs a new FetchTakeoutInfoReq.
         * @memberof Takeout
         * @classdesc Represents a FetchTakeoutInfoReq.
         * @implements IFetchTakeoutInfoReq
         * @constructor
         * @param {Takeout.IFetchTakeoutInfoReq=} [properties] Properties to set
         */
        function FetchTakeoutInfoReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new FetchTakeoutInfoReq instance using the specified properties.
         * @function create
         * @memberof Takeout.FetchTakeoutInfoReq
         * @static
         * @param {Takeout.IFetchTakeoutInfoReq=} [properties] Properties to set
         * @returns {Takeout.FetchTakeoutInfoReq} FetchTakeoutInfoReq instance
         */
        FetchTakeoutInfoReq.create = function create(properties) {
            return new FetchTakeoutInfoReq(properties);
        };

        /**
         * Encodes the specified FetchTakeoutInfoReq message. Does not implicitly {@link Takeout.FetchTakeoutInfoReq.verify|verify} messages.
         * @function encode
         * @memberof Takeout.FetchTakeoutInfoReq
         * @static
         * @param {Takeout.IFetchTakeoutInfoReq} message FetchTakeoutInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchTakeoutInfoReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified FetchTakeoutInfoReq message, length delimited. Does not implicitly {@link Takeout.FetchTakeoutInfoReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.FetchTakeoutInfoReq
         * @static
         * @param {Takeout.IFetchTakeoutInfoReq} message FetchTakeoutInfoReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchTakeoutInfoReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchTakeoutInfoReq message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.FetchTakeoutInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.FetchTakeoutInfoReq} FetchTakeoutInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchTakeoutInfoReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.FetchTakeoutInfoReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchTakeoutInfoReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.FetchTakeoutInfoReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.FetchTakeoutInfoReq} FetchTakeoutInfoReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchTakeoutInfoReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchTakeoutInfoReq message.
         * @function verify
         * @memberof Takeout.FetchTakeoutInfoReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchTakeoutInfoReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return FetchTakeoutInfoReq;
    })();

    Takeout.FetchTakeoutInfoRes = (function() {

        /**
         * Properties of a FetchTakeoutInfoRes.
         * @memberof Takeout
         * @interface IFetchTakeoutInfoRes
         * @property {BaseInfo.ITakeoutInfo|null} [takeoutInfo] FetchTakeoutInfoRes takeoutInfo
         */

        /**
         * Constructs a new FetchTakeoutInfoRes.
         * @memberof Takeout
         * @classdesc Represents a FetchTakeoutInfoRes.
         * @implements IFetchTakeoutInfoRes
         * @constructor
         * @param {Takeout.IFetchTakeoutInfoRes=} [properties] Properties to set
         */
        function FetchTakeoutInfoRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FetchTakeoutInfoRes takeoutInfo.
         * @member {BaseInfo.ITakeoutInfo|null|undefined} takeoutInfo
         * @memberof Takeout.FetchTakeoutInfoRes
         * @instance
         */
        FetchTakeoutInfoRes.prototype.takeoutInfo = null;

        /**
         * Creates a new FetchTakeoutInfoRes instance using the specified properties.
         * @function create
         * @memberof Takeout.FetchTakeoutInfoRes
         * @static
         * @param {Takeout.IFetchTakeoutInfoRes=} [properties] Properties to set
         * @returns {Takeout.FetchTakeoutInfoRes} FetchTakeoutInfoRes instance
         */
        FetchTakeoutInfoRes.create = function create(properties) {
            return new FetchTakeoutInfoRes(properties);
        };

        /**
         * Encodes the specified FetchTakeoutInfoRes message. Does not implicitly {@link Takeout.FetchTakeoutInfoRes.verify|verify} messages.
         * @function encode
         * @memberof Takeout.FetchTakeoutInfoRes
         * @static
         * @param {Takeout.IFetchTakeoutInfoRes} message FetchTakeoutInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchTakeoutInfoRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo"))
                $root.BaseInfo.TakeoutInfo.encode(message.takeoutInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FetchTakeoutInfoRes message, length delimited. Does not implicitly {@link Takeout.FetchTakeoutInfoRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.FetchTakeoutInfoRes
         * @static
         * @param {Takeout.IFetchTakeoutInfoRes} message FetchTakeoutInfoRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FetchTakeoutInfoRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FetchTakeoutInfoRes message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.FetchTakeoutInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.FetchTakeoutInfoRes} FetchTakeoutInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchTakeoutInfoRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.FetchTakeoutInfoRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.takeoutInfo = $root.BaseInfo.TakeoutInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FetchTakeoutInfoRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.FetchTakeoutInfoRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.FetchTakeoutInfoRes} FetchTakeoutInfoRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FetchTakeoutInfoRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FetchTakeoutInfoRes message.
         * @function verify
         * @memberof Takeout.FetchTakeoutInfoRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FetchTakeoutInfoRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo")) {
                var error = $root.BaseInfo.TakeoutInfo.verify(message.takeoutInfo);
                if (error)
                    return "takeoutInfo." + error;
            }
            return null;
        };

        return FetchTakeoutInfoRes;
    })();

    Takeout.DeliveryReq = (function() {

        /**
         * Properties of a DeliveryReq.
         * @memberof Takeout
         * @interface IDeliveryReq
         * @property {Array.<string>|null} [pets] DeliveryReq pets
         * @property {boolean|null} [free] DeliveryReq free
         */

        /**
         * Constructs a new DeliveryReq.
         * @memberof Takeout
         * @classdesc Represents a DeliveryReq.
         * @implements IDeliveryReq
         * @constructor
         * @param {Takeout.IDeliveryReq=} [properties] Properties to set
         */
        function DeliveryReq(properties) {
            this.pets = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * DeliveryReq pets.
         * @member {Array.<string>} pets
         * @memberof Takeout.DeliveryReq
         * @instance
         */
        DeliveryReq.prototype.pets = $util.emptyArray;

        /**
         * DeliveryReq free.
         * @member {boolean} free
         * @memberof Takeout.DeliveryReq
         * @instance
         */
        DeliveryReq.prototype.free = false;

        /**
         * Creates a new DeliveryReq instance using the specified properties.
         * @function create
         * @memberof Takeout.DeliveryReq
         * @static
         * @param {Takeout.IDeliveryReq=} [properties] Properties to set
         * @returns {Takeout.DeliveryReq} DeliveryReq instance
         */
        DeliveryReq.create = function create(properties) {
            return new DeliveryReq(properties);
        };

        /**
         * Encodes the specified DeliveryReq message. Does not implicitly {@link Takeout.DeliveryReq.verify|verify} messages.
         * @function encode
         * @memberof Takeout.DeliveryReq
         * @static
         * @param {Takeout.IDeliveryReq} message DeliveryReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DeliveryReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.pets != null && message.pets.length)
                for (var i = 0; i < message.pets.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.pets[i]);
            if (message.free != null && message.hasOwnProperty("free"))
                writer.uint32(/* id 2, wireType 0 =*/16).bool(message.free);
            return writer;
        };

        /**
         * Encodes the specified DeliveryReq message, length delimited. Does not implicitly {@link Takeout.DeliveryReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.DeliveryReq
         * @static
         * @param {Takeout.IDeliveryReq} message DeliveryReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DeliveryReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a DeliveryReq message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.DeliveryReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.DeliveryReq} DeliveryReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DeliveryReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.DeliveryReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.pets && message.pets.length))
                        message.pets = [];
                    message.pets.push(reader.string());
                    break;
                case 2:
                    message.free = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a DeliveryReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.DeliveryReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.DeliveryReq} DeliveryReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DeliveryReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a DeliveryReq message.
         * @function verify
         * @memberof Takeout.DeliveryReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        DeliveryReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.pets != null && message.hasOwnProperty("pets")) {
                if (!Array.isArray(message.pets))
                    return "pets: array expected";
                for (var i = 0; i < message.pets.length; ++i)
                    if (!$util.isString(message.pets[i]))
                        return "pets: string[] expected";
            }
            if (message.free != null && message.hasOwnProperty("free"))
                if (typeof message.free !== "boolean")
                    return "free: boolean expected";
            return null;
        };

        return DeliveryReq;
    })();

    Takeout.DeliveryRes = (function() {

        /**
         * Properties of a DeliveryRes.
         * @memberof Takeout
         * @interface IDeliveryRes
         * @property {BaseInfo.ITakeoutInfo|null} [takeoutInfo] DeliveryRes takeoutInfo
         */

        /**
         * Constructs a new DeliveryRes.
         * @memberof Takeout
         * @classdesc Represents a DeliveryRes.
         * @implements IDeliveryRes
         * @constructor
         * @param {Takeout.IDeliveryRes=} [properties] Properties to set
         */
        function DeliveryRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * DeliveryRes takeoutInfo.
         * @member {BaseInfo.ITakeoutInfo|null|undefined} takeoutInfo
         * @memberof Takeout.DeliveryRes
         * @instance
         */
        DeliveryRes.prototype.takeoutInfo = null;

        /**
         * Creates a new DeliveryRes instance using the specified properties.
         * @function create
         * @memberof Takeout.DeliveryRes
         * @static
         * @param {Takeout.IDeliveryRes=} [properties] Properties to set
         * @returns {Takeout.DeliveryRes} DeliveryRes instance
         */
        DeliveryRes.create = function create(properties) {
            return new DeliveryRes(properties);
        };

        /**
         * Encodes the specified DeliveryRes message. Does not implicitly {@link Takeout.DeliveryRes.verify|verify} messages.
         * @function encode
         * @memberof Takeout.DeliveryRes
         * @static
         * @param {Takeout.IDeliveryRes} message DeliveryRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DeliveryRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo"))
                $root.BaseInfo.TakeoutInfo.encode(message.takeoutInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified DeliveryRes message, length delimited. Does not implicitly {@link Takeout.DeliveryRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.DeliveryRes
         * @static
         * @param {Takeout.IDeliveryRes} message DeliveryRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DeliveryRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a DeliveryRes message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.DeliveryRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.DeliveryRes} DeliveryRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DeliveryRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.DeliveryRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.takeoutInfo = $root.BaseInfo.TakeoutInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a DeliveryRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.DeliveryRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.DeliveryRes} DeliveryRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DeliveryRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a DeliveryRes message.
         * @function verify
         * @memberof Takeout.DeliveryRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        DeliveryRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo")) {
                var error = $root.BaseInfo.TakeoutInfo.verify(message.takeoutInfo);
                if (error)
                    return "takeoutInfo." + error;
            }
            return null;
        };

        return DeliveryRes;
    })();

    Takeout.ReceiveRewardsReq = (function() {

        /**
         * Properties of a ReceiveRewardsReq.
         * @memberof Takeout
         * @interface IReceiveRewardsReq
         */

        /**
         * Constructs a new ReceiveRewardsReq.
         * @memberof Takeout
         * @classdesc Represents a ReceiveRewardsReq.
         * @implements IReceiveRewardsReq
         * @constructor
         * @param {Takeout.IReceiveRewardsReq=} [properties] Properties to set
         */
        function ReceiveRewardsReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new ReceiveRewardsReq instance using the specified properties.
         * @function create
         * @memberof Takeout.ReceiveRewardsReq
         * @static
         * @param {Takeout.IReceiveRewardsReq=} [properties] Properties to set
         * @returns {Takeout.ReceiveRewardsReq} ReceiveRewardsReq instance
         */
        ReceiveRewardsReq.create = function create(properties) {
            return new ReceiveRewardsReq(properties);
        };

        /**
         * Encodes the specified ReceiveRewardsReq message. Does not implicitly {@link Takeout.ReceiveRewardsReq.verify|verify} messages.
         * @function encode
         * @memberof Takeout.ReceiveRewardsReq
         * @static
         * @param {Takeout.IReceiveRewardsReq} message ReceiveRewardsReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveRewardsReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified ReceiveRewardsReq message, length delimited. Does not implicitly {@link Takeout.ReceiveRewardsReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.ReceiveRewardsReq
         * @static
         * @param {Takeout.IReceiveRewardsReq} message ReceiveRewardsReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveRewardsReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveRewardsReq message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.ReceiveRewardsReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.ReceiveRewardsReq} ReceiveRewardsReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveRewardsReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.ReceiveRewardsReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveRewardsReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.ReceiveRewardsReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.ReceiveRewardsReq} ReceiveRewardsReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveRewardsReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveRewardsReq message.
         * @function verify
         * @memberof Takeout.ReceiveRewardsReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveRewardsReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return ReceiveRewardsReq;
    })();

    Takeout.ReceiveRewardsRes = (function() {

        /**
         * Properties of a ReceiveRewardsRes.
         * @memberof Takeout
         * @interface IReceiveRewardsRes
         * @property {BaseInfo.IRewards|null} [rewards] ReceiveRewardsRes rewards
         * @property {BaseInfo.ICurrencyBag|null} [currencyBag] ReceiveRewardsRes currencyBag
         * @property {BaseInfo.ITakeoutInfo|null} [takeoutInfo] ReceiveRewardsRes takeoutInfo
         */

        /**
         * Constructs a new ReceiveRewardsRes.
         * @memberof Takeout
         * @classdesc Represents a ReceiveRewardsRes.
         * @implements IReceiveRewardsRes
         * @constructor
         * @param {Takeout.IReceiveRewardsRes=} [properties] Properties to set
         */
        function ReceiveRewardsRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * ReceiveRewardsRes rewards.
         * @member {BaseInfo.IRewards|null|undefined} rewards
         * @memberof Takeout.ReceiveRewardsRes
         * @instance
         */
        ReceiveRewardsRes.prototype.rewards = null;

        /**
         * ReceiveRewardsRes currencyBag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} currencyBag
         * @memberof Takeout.ReceiveRewardsRes
         * @instance
         */
        ReceiveRewardsRes.prototype.currencyBag = null;

        /**
         * ReceiveRewardsRes takeoutInfo.
         * @member {BaseInfo.ITakeoutInfo|null|undefined} takeoutInfo
         * @memberof Takeout.ReceiveRewardsRes
         * @instance
         */
        ReceiveRewardsRes.prototype.takeoutInfo = null;

        /**
         * Creates a new ReceiveRewardsRes instance using the specified properties.
         * @function create
         * @memberof Takeout.ReceiveRewardsRes
         * @static
         * @param {Takeout.IReceiveRewardsRes=} [properties] Properties to set
         * @returns {Takeout.ReceiveRewardsRes} ReceiveRewardsRes instance
         */
        ReceiveRewardsRes.create = function create(properties) {
            return new ReceiveRewardsRes(properties);
        };

        /**
         * Encodes the specified ReceiveRewardsRes message. Does not implicitly {@link Takeout.ReceiveRewardsRes.verify|verify} messages.
         * @function encode
         * @memberof Takeout.ReceiveRewardsRes
         * @static
         * @param {Takeout.IReceiveRewardsRes} message ReceiveRewardsRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveRewardsRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.rewards != null && message.hasOwnProperty("rewards"))
                $root.BaseInfo.Rewards.encode(message.rewards, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag"))
                $root.BaseInfo.CurrencyBag.encode(message.currencyBag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo"))
                $root.BaseInfo.TakeoutInfo.encode(message.takeoutInfo, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified ReceiveRewardsRes message, length delimited. Does not implicitly {@link Takeout.ReceiveRewardsRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.ReceiveRewardsRes
         * @static
         * @param {Takeout.IReceiveRewardsRes} message ReceiveRewardsRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        ReceiveRewardsRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a ReceiveRewardsRes message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.ReceiveRewardsRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.ReceiveRewardsRes} ReceiveRewardsRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveRewardsRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.ReceiveRewardsRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.rewards = $root.BaseInfo.Rewards.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.currencyBag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.takeoutInfo = $root.BaseInfo.TakeoutInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a ReceiveRewardsRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.ReceiveRewardsRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.ReceiveRewardsRes} ReceiveRewardsRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        ReceiveRewardsRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a ReceiveRewardsRes message.
         * @function verify
         * @memberof Takeout.ReceiveRewardsRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        ReceiveRewardsRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.rewards != null && message.hasOwnProperty("rewards")) {
                var error = $root.BaseInfo.Rewards.verify(message.rewards);
                if (error)
                    return "rewards." + error;
            }
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.currencyBag);
                if (error)
                    return "currencyBag." + error;
            }
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo")) {
                var error = $root.BaseInfo.TakeoutInfo.verify(message.takeoutInfo);
                if (error)
                    return "takeoutInfo." + error;
            }
            return null;
        };

        return ReceiveRewardsRes;
    })();

    Takeout.SpeedUpDeliveryReq = (function() {

        /**
         * Properties of a SpeedUpDeliveryReq.
         * @memberof Takeout
         * @interface ISpeedUpDeliveryReq
         * @property {boolean|null} [free] SpeedUpDeliveryReq free
         */

        /**
         * Constructs a new SpeedUpDeliveryReq.
         * @memberof Takeout
         * @classdesc Represents a SpeedUpDeliveryReq.
         * @implements ISpeedUpDeliveryReq
         * @constructor
         * @param {Takeout.ISpeedUpDeliveryReq=} [properties] Properties to set
         */
        function SpeedUpDeliveryReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * SpeedUpDeliveryReq free.
         * @member {boolean} free
         * @memberof Takeout.SpeedUpDeliveryReq
         * @instance
         */
        SpeedUpDeliveryReq.prototype.free = false;

        /**
         * Creates a new SpeedUpDeliveryReq instance using the specified properties.
         * @function create
         * @memberof Takeout.SpeedUpDeliveryReq
         * @static
         * @param {Takeout.ISpeedUpDeliveryReq=} [properties] Properties to set
         * @returns {Takeout.SpeedUpDeliveryReq} SpeedUpDeliveryReq instance
         */
        SpeedUpDeliveryReq.create = function create(properties) {
            return new SpeedUpDeliveryReq(properties);
        };

        /**
         * Encodes the specified SpeedUpDeliveryReq message. Does not implicitly {@link Takeout.SpeedUpDeliveryReq.verify|verify} messages.
         * @function encode
         * @memberof Takeout.SpeedUpDeliveryReq
         * @static
         * @param {Takeout.ISpeedUpDeliveryReq} message SpeedUpDeliveryReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SpeedUpDeliveryReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.free != null && message.hasOwnProperty("free"))
                writer.uint32(/* id 1, wireType 0 =*/8).bool(message.free);
            return writer;
        };

        /**
         * Encodes the specified SpeedUpDeliveryReq message, length delimited. Does not implicitly {@link Takeout.SpeedUpDeliveryReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.SpeedUpDeliveryReq
         * @static
         * @param {Takeout.ISpeedUpDeliveryReq} message SpeedUpDeliveryReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SpeedUpDeliveryReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a SpeedUpDeliveryReq message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.SpeedUpDeliveryReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.SpeedUpDeliveryReq} SpeedUpDeliveryReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SpeedUpDeliveryReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.SpeedUpDeliveryReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.free = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a SpeedUpDeliveryReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.SpeedUpDeliveryReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.SpeedUpDeliveryReq} SpeedUpDeliveryReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SpeedUpDeliveryReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a SpeedUpDeliveryReq message.
         * @function verify
         * @memberof Takeout.SpeedUpDeliveryReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        SpeedUpDeliveryReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.free != null && message.hasOwnProperty("free"))
                if (typeof message.free !== "boolean")
                    return "free: boolean expected";
            return null;
        };

        return SpeedUpDeliveryReq;
    })();

    Takeout.SpeedUpDeliveryRes = (function() {

        /**
         * Properties of a SpeedUpDeliveryRes.
         * @memberof Takeout
         * @interface ISpeedUpDeliveryRes
         * @property {BaseInfo.ITakeoutInfo|null} [takeoutInfo] SpeedUpDeliveryRes takeoutInfo
         * @property {BaseInfo.ICurrencyBag|null} [currencyBag] SpeedUpDeliveryRes currencyBag
         */

        /**
         * Constructs a new SpeedUpDeliveryRes.
         * @memberof Takeout
         * @classdesc Represents a SpeedUpDeliveryRes.
         * @implements ISpeedUpDeliveryRes
         * @constructor
         * @param {Takeout.ISpeedUpDeliveryRes=} [properties] Properties to set
         */
        function SpeedUpDeliveryRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * SpeedUpDeliveryRes takeoutInfo.
         * @member {BaseInfo.ITakeoutInfo|null|undefined} takeoutInfo
         * @memberof Takeout.SpeedUpDeliveryRes
         * @instance
         */
        SpeedUpDeliveryRes.prototype.takeoutInfo = null;

        /**
         * SpeedUpDeliveryRes currencyBag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} currencyBag
         * @memberof Takeout.SpeedUpDeliveryRes
         * @instance
         */
        SpeedUpDeliveryRes.prototype.currencyBag = null;

        /**
         * Creates a new SpeedUpDeliveryRes instance using the specified properties.
         * @function create
         * @memberof Takeout.SpeedUpDeliveryRes
         * @static
         * @param {Takeout.ISpeedUpDeliveryRes=} [properties] Properties to set
         * @returns {Takeout.SpeedUpDeliveryRes} SpeedUpDeliveryRes instance
         */
        SpeedUpDeliveryRes.create = function create(properties) {
            return new SpeedUpDeliveryRes(properties);
        };

        /**
         * Encodes the specified SpeedUpDeliveryRes message. Does not implicitly {@link Takeout.SpeedUpDeliveryRes.verify|verify} messages.
         * @function encode
         * @memberof Takeout.SpeedUpDeliveryRes
         * @static
         * @param {Takeout.ISpeedUpDeliveryRes} message SpeedUpDeliveryRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SpeedUpDeliveryRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo"))
                $root.BaseInfo.TakeoutInfo.encode(message.takeoutInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag"))
                $root.BaseInfo.CurrencyBag.encode(message.currencyBag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified SpeedUpDeliveryRes message, length delimited. Does not implicitly {@link Takeout.SpeedUpDeliveryRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.SpeedUpDeliveryRes
         * @static
         * @param {Takeout.ISpeedUpDeliveryRes} message SpeedUpDeliveryRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        SpeedUpDeliveryRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a SpeedUpDeliveryRes message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.SpeedUpDeliveryRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.SpeedUpDeliveryRes} SpeedUpDeliveryRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SpeedUpDeliveryRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.SpeedUpDeliveryRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.takeoutInfo = $root.BaseInfo.TakeoutInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.currencyBag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a SpeedUpDeliveryRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.SpeedUpDeliveryRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.SpeedUpDeliveryRes} SpeedUpDeliveryRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        SpeedUpDeliveryRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a SpeedUpDeliveryRes message.
         * @function verify
         * @memberof Takeout.SpeedUpDeliveryRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        SpeedUpDeliveryRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo")) {
                var error = $root.BaseInfo.TakeoutInfo.verify(message.takeoutInfo);
                if (error)
                    return "takeoutInfo." + error;
            }
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.currencyBag);
                if (error)
                    return "currencyBag." + error;
            }
            return null;
        };

        return SpeedUpDeliveryRes;
    })();

    Takeout.LeveUpTakeoutReq = (function() {

        /**
         * Properties of a LeveUpTakeoutReq.
         * @memberof Takeout
         * @interface ILeveUpTakeoutReq
         */

        /**
         * Constructs a new LeveUpTakeoutReq.
         * @memberof Takeout
         * @classdesc Represents a LeveUpTakeoutReq.
         * @implements ILeveUpTakeoutReq
         * @constructor
         * @param {Takeout.ILeveUpTakeoutReq=} [properties] Properties to set
         */
        function LeveUpTakeoutReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new LeveUpTakeoutReq instance using the specified properties.
         * @function create
         * @memberof Takeout.LeveUpTakeoutReq
         * @static
         * @param {Takeout.ILeveUpTakeoutReq=} [properties] Properties to set
         * @returns {Takeout.LeveUpTakeoutReq} LeveUpTakeoutReq instance
         */
        LeveUpTakeoutReq.create = function create(properties) {
            return new LeveUpTakeoutReq(properties);
        };

        /**
         * Encodes the specified LeveUpTakeoutReq message. Does not implicitly {@link Takeout.LeveUpTakeoutReq.verify|verify} messages.
         * @function encode
         * @memberof Takeout.LeveUpTakeoutReq
         * @static
         * @param {Takeout.ILeveUpTakeoutReq} message LeveUpTakeoutReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LeveUpTakeoutReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified LeveUpTakeoutReq message, length delimited. Does not implicitly {@link Takeout.LeveUpTakeoutReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.LeveUpTakeoutReq
         * @static
         * @param {Takeout.ILeveUpTakeoutReq} message LeveUpTakeoutReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LeveUpTakeoutReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a LeveUpTakeoutReq message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.LeveUpTakeoutReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.LeveUpTakeoutReq} LeveUpTakeoutReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LeveUpTakeoutReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.LeveUpTakeoutReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a LeveUpTakeoutReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.LeveUpTakeoutReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.LeveUpTakeoutReq} LeveUpTakeoutReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LeveUpTakeoutReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a LeveUpTakeoutReq message.
         * @function verify
         * @memberof Takeout.LeveUpTakeoutReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        LeveUpTakeoutReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return LeveUpTakeoutReq;
    })();

    Takeout.LevelUpTakeoutRes = (function() {

        /**
         * Properties of a LevelUpTakeoutRes.
         * @memberof Takeout
         * @interface ILevelUpTakeoutRes
         * @property {BaseInfo.ITakeoutInfo|null} [takeoutInfo] LevelUpTakeoutRes takeoutInfo
         * @property {BaseInfo.ICurrencyBag|null} [currencyBag] LevelUpTakeoutRes currencyBag
         */

        /**
         * Constructs a new LevelUpTakeoutRes.
         * @memberof Takeout
         * @classdesc Represents a LevelUpTakeoutRes.
         * @implements ILevelUpTakeoutRes
         * @constructor
         * @param {Takeout.ILevelUpTakeoutRes=} [properties] Properties to set
         */
        function LevelUpTakeoutRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * LevelUpTakeoutRes takeoutInfo.
         * @member {BaseInfo.ITakeoutInfo|null|undefined} takeoutInfo
         * @memberof Takeout.LevelUpTakeoutRes
         * @instance
         */
        LevelUpTakeoutRes.prototype.takeoutInfo = null;

        /**
         * LevelUpTakeoutRes currencyBag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} currencyBag
         * @memberof Takeout.LevelUpTakeoutRes
         * @instance
         */
        LevelUpTakeoutRes.prototype.currencyBag = null;

        /**
         * Creates a new LevelUpTakeoutRes instance using the specified properties.
         * @function create
         * @memberof Takeout.LevelUpTakeoutRes
         * @static
         * @param {Takeout.ILevelUpTakeoutRes=} [properties] Properties to set
         * @returns {Takeout.LevelUpTakeoutRes} LevelUpTakeoutRes instance
         */
        LevelUpTakeoutRes.create = function create(properties) {
            return new LevelUpTakeoutRes(properties);
        };

        /**
         * Encodes the specified LevelUpTakeoutRes message. Does not implicitly {@link Takeout.LevelUpTakeoutRes.verify|verify} messages.
         * @function encode
         * @memberof Takeout.LevelUpTakeoutRes
         * @static
         * @param {Takeout.ILevelUpTakeoutRes} message LevelUpTakeoutRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LevelUpTakeoutRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo"))
                $root.BaseInfo.TakeoutInfo.encode(message.takeoutInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag"))
                $root.BaseInfo.CurrencyBag.encode(message.currencyBag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified LevelUpTakeoutRes message, length delimited. Does not implicitly {@link Takeout.LevelUpTakeoutRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.LevelUpTakeoutRes
         * @static
         * @param {Takeout.ILevelUpTakeoutRes} message LevelUpTakeoutRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        LevelUpTakeoutRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a LevelUpTakeoutRes message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.LevelUpTakeoutRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.LevelUpTakeoutRes} LevelUpTakeoutRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LevelUpTakeoutRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.LevelUpTakeoutRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.takeoutInfo = $root.BaseInfo.TakeoutInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.currencyBag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a LevelUpTakeoutRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.LevelUpTakeoutRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.LevelUpTakeoutRes} LevelUpTakeoutRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        LevelUpTakeoutRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a LevelUpTakeoutRes message.
         * @function verify
         * @memberof Takeout.LevelUpTakeoutRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        LevelUpTakeoutRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo")) {
                var error = $root.BaseInfo.TakeoutInfo.verify(message.takeoutInfo);
                if (error)
                    return "takeoutInfo." + error;
            }
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.currencyBag);
                if (error)
                    return "currencyBag." + error;
            }
            return null;
        };

        return LevelUpTakeoutRes;
    })();

    Takeout.PutAdvertiserCatsReq = (function() {

        /**
         * Properties of a PutAdvertiserCatsReq.
         * @memberof Takeout
         * @interface IPutAdvertiserCatsReq
         * @property {Array.<string>|null} [pets] PutAdvertiserCatsReq pets
         */

        /**
         * Constructs a new PutAdvertiserCatsReq.
         * @memberof Takeout
         * @classdesc Represents a PutAdvertiserCatsReq.
         * @implements IPutAdvertiserCatsReq
         * @constructor
         * @param {Takeout.IPutAdvertiserCatsReq=} [properties] Properties to set
         */
        function PutAdvertiserCatsReq(properties) {
            this.pets = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PutAdvertiserCatsReq pets.
         * @member {Array.<string>} pets
         * @memberof Takeout.PutAdvertiserCatsReq
         * @instance
         */
        PutAdvertiserCatsReq.prototype.pets = $util.emptyArray;

        /**
         * Creates a new PutAdvertiserCatsReq instance using the specified properties.
         * @function create
         * @memberof Takeout.PutAdvertiserCatsReq
         * @static
         * @param {Takeout.IPutAdvertiserCatsReq=} [properties] Properties to set
         * @returns {Takeout.PutAdvertiserCatsReq} PutAdvertiserCatsReq instance
         */
        PutAdvertiserCatsReq.create = function create(properties) {
            return new PutAdvertiserCatsReq(properties);
        };

        /**
         * Encodes the specified PutAdvertiserCatsReq message. Does not implicitly {@link Takeout.PutAdvertiserCatsReq.verify|verify} messages.
         * @function encode
         * @memberof Takeout.PutAdvertiserCatsReq
         * @static
         * @param {Takeout.IPutAdvertiserCatsReq} message PutAdvertiserCatsReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutAdvertiserCatsReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.pets != null && message.pets.length)
                for (var i = 0; i < message.pets.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.pets[i]);
            return writer;
        };

        /**
         * Encodes the specified PutAdvertiserCatsReq message, length delimited. Does not implicitly {@link Takeout.PutAdvertiserCatsReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.PutAdvertiserCatsReq
         * @static
         * @param {Takeout.IPutAdvertiserCatsReq} message PutAdvertiserCatsReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutAdvertiserCatsReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PutAdvertiserCatsReq message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.PutAdvertiserCatsReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.PutAdvertiserCatsReq} PutAdvertiserCatsReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutAdvertiserCatsReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.PutAdvertiserCatsReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.pets && message.pets.length))
                        message.pets = [];
                    message.pets.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PutAdvertiserCatsReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.PutAdvertiserCatsReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.PutAdvertiserCatsReq} PutAdvertiserCatsReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutAdvertiserCatsReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PutAdvertiserCatsReq message.
         * @function verify
         * @memberof Takeout.PutAdvertiserCatsReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PutAdvertiserCatsReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.pets != null && message.hasOwnProperty("pets")) {
                if (!Array.isArray(message.pets))
                    return "pets: array expected";
                for (var i = 0; i < message.pets.length; ++i)
                    if (!$util.isString(message.pets[i]))
                        return "pets: string[] expected";
            }
            return null;
        };

        return PutAdvertiserCatsReq;
    })();

    Takeout.PutAdvertiserCatsRes = (function() {

        /**
         * Properties of a PutAdvertiserCatsRes.
         * @memberof Takeout
         * @interface IPutAdvertiserCatsRes
         * @property {BaseInfo.ITakeoutInfo|null} [takeoutInfo] PutAdvertiserCatsRes takeoutInfo
         */

        /**
         * Constructs a new PutAdvertiserCatsRes.
         * @memberof Takeout
         * @classdesc Represents a PutAdvertiserCatsRes.
         * @implements IPutAdvertiserCatsRes
         * @constructor
         * @param {Takeout.IPutAdvertiserCatsRes=} [properties] Properties to set
         */
        function PutAdvertiserCatsRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PutAdvertiserCatsRes takeoutInfo.
         * @member {BaseInfo.ITakeoutInfo|null|undefined} takeoutInfo
         * @memberof Takeout.PutAdvertiserCatsRes
         * @instance
         */
        PutAdvertiserCatsRes.prototype.takeoutInfo = null;

        /**
         * Creates a new PutAdvertiserCatsRes instance using the specified properties.
         * @function create
         * @memberof Takeout.PutAdvertiserCatsRes
         * @static
         * @param {Takeout.IPutAdvertiserCatsRes=} [properties] Properties to set
         * @returns {Takeout.PutAdvertiserCatsRes} PutAdvertiserCatsRes instance
         */
        PutAdvertiserCatsRes.create = function create(properties) {
            return new PutAdvertiserCatsRes(properties);
        };

        /**
         * Encodes the specified PutAdvertiserCatsRes message. Does not implicitly {@link Takeout.PutAdvertiserCatsRes.verify|verify} messages.
         * @function encode
         * @memberof Takeout.PutAdvertiserCatsRes
         * @static
         * @param {Takeout.IPutAdvertiserCatsRes} message PutAdvertiserCatsRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutAdvertiserCatsRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo"))
                $root.BaseInfo.TakeoutInfo.encode(message.takeoutInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified PutAdvertiserCatsRes message, length delimited. Does not implicitly {@link Takeout.PutAdvertiserCatsRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.PutAdvertiserCatsRes
         * @static
         * @param {Takeout.IPutAdvertiserCatsRes} message PutAdvertiserCatsRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PutAdvertiserCatsRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PutAdvertiserCatsRes message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.PutAdvertiserCatsRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.PutAdvertiserCatsRes} PutAdvertiserCatsRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutAdvertiserCatsRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.PutAdvertiserCatsRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.takeoutInfo = $root.BaseInfo.TakeoutInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PutAdvertiserCatsRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.PutAdvertiserCatsRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.PutAdvertiserCatsRes} PutAdvertiserCatsRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PutAdvertiserCatsRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PutAdvertiserCatsRes message.
         * @function verify
         * @memberof Takeout.PutAdvertiserCatsRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PutAdvertiserCatsRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo")) {
                var error = $root.BaseInfo.TakeoutInfo.verify(message.takeoutInfo);
                if (error)
                    return "takeoutInfo." + error;
            }
            return null;
        };

        return PutAdvertiserCatsRes;
    })();

    Takeout.BuyOrderReq = (function() {

        /**
         * Properties of a BuyOrderReq.
         * @memberof Takeout
         * @interface IBuyOrderReq
         */

        /**
         * Constructs a new BuyOrderReq.
         * @memberof Takeout
         * @classdesc Represents a BuyOrderReq.
         * @implements IBuyOrderReq
         * @constructor
         * @param {Takeout.IBuyOrderReq=} [properties] Properties to set
         */
        function BuyOrderReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new BuyOrderReq instance using the specified properties.
         * @function create
         * @memberof Takeout.BuyOrderReq
         * @static
         * @param {Takeout.IBuyOrderReq=} [properties] Properties to set
         * @returns {Takeout.BuyOrderReq} BuyOrderReq instance
         */
        BuyOrderReq.create = function create(properties) {
            return new BuyOrderReq(properties);
        };

        /**
         * Encodes the specified BuyOrderReq message. Does not implicitly {@link Takeout.BuyOrderReq.verify|verify} messages.
         * @function encode
         * @memberof Takeout.BuyOrderReq
         * @static
         * @param {Takeout.IBuyOrderReq} message BuyOrderReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        BuyOrderReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified BuyOrderReq message, length delimited. Does not implicitly {@link Takeout.BuyOrderReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.BuyOrderReq
         * @static
         * @param {Takeout.IBuyOrderReq} message BuyOrderReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        BuyOrderReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a BuyOrderReq message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.BuyOrderReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.BuyOrderReq} BuyOrderReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        BuyOrderReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.BuyOrderReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a BuyOrderReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.BuyOrderReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.BuyOrderReq} BuyOrderReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        BuyOrderReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a BuyOrderReq message.
         * @function verify
         * @memberof Takeout.BuyOrderReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        BuyOrderReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return BuyOrderReq;
    })();

    Takeout.BuyOrderRes = (function() {

        /**
         * Properties of a BuyOrderRes.
         * @memberof Takeout
         * @interface IBuyOrderRes
         * @property {BaseInfo.ITakeoutInfo|null} [takeoutInfo] BuyOrderRes takeoutInfo
         * @property {BaseInfo.ICurrencyBag|null} [currencyBag] BuyOrderRes currencyBag
         */

        /**
         * Constructs a new BuyOrderRes.
         * @memberof Takeout
         * @classdesc Represents a BuyOrderRes.
         * @implements IBuyOrderRes
         * @constructor
         * @param {Takeout.IBuyOrderRes=} [properties] Properties to set
         */
        function BuyOrderRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * BuyOrderRes takeoutInfo.
         * @member {BaseInfo.ITakeoutInfo|null|undefined} takeoutInfo
         * @memberof Takeout.BuyOrderRes
         * @instance
         */
        BuyOrderRes.prototype.takeoutInfo = null;

        /**
         * BuyOrderRes currencyBag.
         * @member {BaseInfo.ICurrencyBag|null|undefined} currencyBag
         * @memberof Takeout.BuyOrderRes
         * @instance
         */
        BuyOrderRes.prototype.currencyBag = null;

        /**
         * Creates a new BuyOrderRes instance using the specified properties.
         * @function create
         * @memberof Takeout.BuyOrderRes
         * @static
         * @param {Takeout.IBuyOrderRes=} [properties] Properties to set
         * @returns {Takeout.BuyOrderRes} BuyOrderRes instance
         */
        BuyOrderRes.create = function create(properties) {
            return new BuyOrderRes(properties);
        };

        /**
         * Encodes the specified BuyOrderRes message. Does not implicitly {@link Takeout.BuyOrderRes.verify|verify} messages.
         * @function encode
         * @memberof Takeout.BuyOrderRes
         * @static
         * @param {Takeout.IBuyOrderRes} message BuyOrderRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        BuyOrderRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo"))
                $root.BaseInfo.TakeoutInfo.encode(message.takeoutInfo, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag"))
                $root.BaseInfo.CurrencyBag.encode(message.currencyBag, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified BuyOrderRes message, length delimited. Does not implicitly {@link Takeout.BuyOrderRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Takeout.BuyOrderRes
         * @static
         * @param {Takeout.IBuyOrderRes} message BuyOrderRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        BuyOrderRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a BuyOrderRes message from the specified reader or buffer.
         * @function decode
         * @memberof Takeout.BuyOrderRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Takeout.BuyOrderRes} BuyOrderRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        BuyOrderRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Takeout.BuyOrderRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.takeoutInfo = $root.BaseInfo.TakeoutInfo.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.currencyBag = $root.BaseInfo.CurrencyBag.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a BuyOrderRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Takeout.BuyOrderRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Takeout.BuyOrderRes} BuyOrderRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        BuyOrderRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a BuyOrderRes message.
         * @function verify
         * @memberof Takeout.BuyOrderRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        BuyOrderRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.takeoutInfo != null && message.hasOwnProperty("takeoutInfo")) {
                var error = $root.BaseInfo.TakeoutInfo.verify(message.takeoutInfo);
                if (error)
                    return "takeoutInfo." + error;
            }
            if (message.currencyBag != null && message.hasOwnProperty("currencyBag")) {
                var error = $root.BaseInfo.CurrencyBag.verify(message.currencyBag);
                if (error)
                    return "currencyBag." + error;
            }
            return null;
        };

        return BuyOrderRes;
    })();

    return Takeout;
})();

$root.Event = (function() {

    /**
     * Namespace Event.
     * @exports Event
     * @namespace
     */
    var Event = {};

    Event.FireEventReq = (function() {

        /**
         * Properties of a FireEventReq.
         * @memberof Event
         * @interface IFireEventReq
         * @property {Event.IEvent|null} [event] FireEventReq event
         */

        /**
         * Constructs a new FireEventReq.
         * @memberof Event
         * @classdesc Represents a FireEventReq.
         * @implements IFireEventReq
         * @constructor
         * @param {Event.IFireEventReq=} [properties] Properties to set
         */
        function FireEventReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * FireEventReq event.
         * @member {Event.IEvent|null|undefined} event
         * @memberof Event.FireEventReq
         * @instance
         */
        FireEventReq.prototype.event = null;

        /**
         * Creates a new FireEventReq instance using the specified properties.
         * @function create
         * @memberof Event.FireEventReq
         * @static
         * @param {Event.IFireEventReq=} [properties] Properties to set
         * @returns {Event.FireEventReq} FireEventReq instance
         */
        FireEventReq.create = function create(properties) {
            return new FireEventReq(properties);
        };

        /**
         * Encodes the specified FireEventReq message. Does not implicitly {@link Event.FireEventReq.verify|verify} messages.
         * @function encode
         * @memberof Event.FireEventReq
         * @static
         * @param {Event.IFireEventReq} message FireEventReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FireEventReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.event != null && message.hasOwnProperty("event"))
                $root.Event.Event.encode(message.event, writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified FireEventReq message, length delimited. Does not implicitly {@link Event.FireEventReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Event.FireEventReq
         * @static
         * @param {Event.IFireEventReq} message FireEventReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FireEventReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FireEventReq message from the specified reader or buffer.
         * @function decode
         * @memberof Event.FireEventReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Event.FireEventReq} FireEventReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FireEventReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Event.FireEventReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.event = $root.Event.Event.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FireEventReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Event.FireEventReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Event.FireEventReq} FireEventReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FireEventReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FireEventReq message.
         * @function verify
         * @memberof Event.FireEventReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FireEventReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.event != null && message.hasOwnProperty("event")) {
                var error = $root.Event.Event.verify(message.event);
                if (error)
                    return "event." + error;
            }
            return null;
        };

        return FireEventReq;
    })();

    Event.FireEventRes = (function() {

        /**
         * Properties of a FireEventRes.
         * @memberof Event
         * @interface IFireEventRes
         */

        /**
         * Constructs a new FireEventRes.
         * @memberof Event
         * @classdesc Represents a FireEventRes.
         * @implements IFireEventRes
         * @constructor
         * @param {Event.IFireEventRes=} [properties] Properties to set
         */
        function FireEventRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Creates a new FireEventRes instance using the specified properties.
         * @function create
         * @memberof Event.FireEventRes
         * @static
         * @param {Event.IFireEventRes=} [properties] Properties to set
         * @returns {Event.FireEventRes} FireEventRes instance
         */
        FireEventRes.create = function create(properties) {
            return new FireEventRes(properties);
        };

        /**
         * Encodes the specified FireEventRes message. Does not implicitly {@link Event.FireEventRes.verify|verify} messages.
         * @function encode
         * @memberof Event.FireEventRes
         * @static
         * @param {Event.IFireEventRes} message FireEventRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FireEventRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            return writer;
        };

        /**
         * Encodes the specified FireEventRes message, length delimited. Does not implicitly {@link Event.FireEventRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Event.FireEventRes
         * @static
         * @param {Event.IFireEventRes} message FireEventRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        FireEventRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a FireEventRes message from the specified reader or buffer.
         * @function decode
         * @memberof Event.FireEventRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Event.FireEventRes} FireEventRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FireEventRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Event.FireEventRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a FireEventRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Event.FireEventRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Event.FireEventRes} FireEventRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        FireEventRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a FireEventRes message.
         * @function verify
         * @memberof Event.FireEventRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        FireEventRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            return null;
        };

        return FireEventRes;
    })();

    Event.Event = (function() {

        /**
         * Properties of an Event.
         * @memberof Event
         * @interface IEvent
         * @property {string|null} [type] Event type
         * @property {number|null} [value] Event value
         * @property {string|null} [extraInfo] Event extraInfo
         */

        /**
         * Constructs a new Event.
         * @memberof Event
         * @classdesc Represents an Event.
         * @implements IEvent
         * @constructor
         * @param {Event.IEvent=} [properties] Properties to set
         */
        function Event(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Event type.
         * @member {string} type
         * @memberof Event.Event
         * @instance
         */
        Event.prototype.type = "";

        /**
         * Event value.
         * @member {number} value
         * @memberof Event.Event
         * @instance
         */
        Event.prototype.value = 0;

        /**
         * Event extraInfo.
         * @member {string} extraInfo
         * @memberof Event.Event
         * @instance
         */
        Event.prototype.extraInfo = "";

        /**
         * Creates a new Event instance using the specified properties.
         * @function create
         * @memberof Event.Event
         * @static
         * @param {Event.IEvent=} [properties] Properties to set
         * @returns {Event.Event} Event instance
         */
        Event.create = function create(properties) {
            return new Event(properties);
        };

        /**
         * Encodes the specified Event message. Does not implicitly {@link Event.Event.verify|verify} messages.
         * @function encode
         * @memberof Event.Event
         * @static
         * @param {Event.IEvent} message Event message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Event.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.type);
            if (message.value != null && message.hasOwnProperty("value"))
                writer.uint32(/* id 2, wireType 0 =*/16).int32(message.value);
            if (message.extraInfo != null && message.hasOwnProperty("extraInfo"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.extraInfo);
            return writer;
        };

        /**
         * Encodes the specified Event message, length delimited. Does not implicitly {@link Event.Event.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Event.Event
         * @static
         * @param {Event.IEvent} message Event message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Event.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an Event message from the specified reader or buffer.
         * @function decode
         * @memberof Event.Event
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Event.Event} Event
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Event.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Event.Event();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.type = reader.string();
                    break;
                case 2:
                    message.value = reader.int32();
                    break;
                case 3:
                    message.extraInfo = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an Event message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Event.Event
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Event.Event} Event
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Event.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an Event message.
         * @function verify
         * @memberof Event.Event
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Event.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isString(message.type))
                    return "type: string expected";
            if (message.value != null && message.hasOwnProperty("value"))
                if (!$util.isInteger(message.value))
                    return "value: integer expected";
            if (message.extraInfo != null && message.hasOwnProperty("extraInfo"))
                if (!$util.isString(message.extraInfo))
                    return "extraInfo: string expected";
            return null;
        };

        return Event;
    })();

    return Event;
})();

$root.Debug = (function() {

    /**
     * Namespace Debug.
     * @exports Debug
     * @namespace
     */
    var Debug = {};

    Debug.DebugReq = (function() {

        /**
         * Properties of a DebugReq.
         * @memberof Debug
         * @interface IDebugReq
         * @property {number|null} [code] DebugReq code
         * @property {string|null} [param] DebugReq param
         */

        /**
         * Constructs a new DebugReq.
         * @memberof Debug
         * @classdesc Represents a DebugReq.
         * @implements IDebugReq
         * @constructor
         * @param {Debug.IDebugReq=} [properties] Properties to set
         */
        function DebugReq(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * DebugReq code.
         * @member {number} code
         * @memberof Debug.DebugReq
         * @instance
         */
        DebugReq.prototype.code = 0;

        /**
         * DebugReq param.
         * @member {string} param
         * @memberof Debug.DebugReq
         * @instance
         */
        DebugReq.prototype.param = "";

        /**
         * Creates a new DebugReq instance using the specified properties.
         * @function create
         * @memberof Debug.DebugReq
         * @static
         * @param {Debug.IDebugReq=} [properties] Properties to set
         * @returns {Debug.DebugReq} DebugReq instance
         */
        DebugReq.create = function create(properties) {
            return new DebugReq(properties);
        };

        /**
         * Encodes the specified DebugReq message. Does not implicitly {@link Debug.DebugReq.verify|verify} messages.
         * @function encode
         * @memberof Debug.DebugReq
         * @static
         * @param {Debug.IDebugReq} message DebugReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DebugReq.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.code != null && message.hasOwnProperty("code"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.code);
            if (message.param != null && message.hasOwnProperty("param"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.param);
            return writer;
        };

        /**
         * Encodes the specified DebugReq message, length delimited. Does not implicitly {@link Debug.DebugReq.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Debug.DebugReq
         * @static
         * @param {Debug.IDebugReq} message DebugReq message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DebugReq.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a DebugReq message from the specified reader or buffer.
         * @function decode
         * @memberof Debug.DebugReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Debug.DebugReq} DebugReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DebugReq.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Debug.DebugReq();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.code = reader.int32();
                    break;
                case 2:
                    message.param = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a DebugReq message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Debug.DebugReq
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Debug.DebugReq} DebugReq
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DebugReq.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a DebugReq message.
         * @function verify
         * @memberof Debug.DebugReq
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        DebugReq.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.code != null && message.hasOwnProperty("code"))
                if (!$util.isInteger(message.code))
                    return "code: integer expected";
            if (message.param != null && message.hasOwnProperty("param"))
                if (!$util.isString(message.param))
                    return "param: string expected";
            return null;
        };

        return DebugReq;
    })();

    Debug.DebugRes = (function() {

        /**
         * Properties of a DebugRes.
         * @memberof Debug
         * @interface IDebugRes
         * @property {string|null} [ret] DebugRes ret
         * @property {Player.ILoginRes|null} [loginRes] DebugRes loginRes
         */

        /**
         * Constructs a new DebugRes.
         * @memberof Debug
         * @classdesc Represents a DebugRes.
         * @implements IDebugRes
         * @constructor
         * @param {Debug.IDebugRes=} [properties] Properties to set
         */
        function DebugRes(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * DebugRes ret.
         * @member {string} ret
         * @memberof Debug.DebugRes
         * @instance
         */
        DebugRes.prototype.ret = "";

        /**
         * DebugRes loginRes.
         * @member {Player.ILoginRes|null|undefined} loginRes
         * @memberof Debug.DebugRes
         * @instance
         */
        DebugRes.prototype.loginRes = null;

        /**
         * Creates a new DebugRes instance using the specified properties.
         * @function create
         * @memberof Debug.DebugRes
         * @static
         * @param {Debug.IDebugRes=} [properties] Properties to set
         * @returns {Debug.DebugRes} DebugRes instance
         */
        DebugRes.create = function create(properties) {
            return new DebugRes(properties);
        };

        /**
         * Encodes the specified DebugRes message. Does not implicitly {@link Debug.DebugRes.verify|verify} messages.
         * @function encode
         * @memberof Debug.DebugRes
         * @static
         * @param {Debug.IDebugRes} message DebugRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DebugRes.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.ret != null && message.hasOwnProperty("ret"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.ret);
            if (message.loginRes != null && message.hasOwnProperty("loginRes"))
                $root.Player.LoginRes.encode(message.loginRes, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified DebugRes message, length delimited. Does not implicitly {@link Debug.DebugRes.verify|verify} messages.
         * @function encodeDelimited
         * @memberof Debug.DebugRes
         * @static
         * @param {Debug.IDebugRes} message DebugRes message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DebugRes.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a DebugRes message from the specified reader or buffer.
         * @function decode
         * @memberof Debug.DebugRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {Debug.DebugRes} DebugRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DebugRes.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.Debug.DebugRes();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.ret = reader.string();
                    break;
                case 2:
                    message.loginRes = $root.Player.LoginRes.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a DebugRes message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof Debug.DebugRes
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {Debug.DebugRes} DebugRes
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DebugRes.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a DebugRes message.
         * @function verify
         * @memberof Debug.DebugRes
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        DebugRes.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.ret != null && message.hasOwnProperty("ret"))
                if (!$util.isString(message.ret))
                    return "ret: string expected";
            if (message.loginRes != null && message.hasOwnProperty("loginRes")) {
                var error = $root.Player.LoginRes.verify(message.loginRes);
                if (error)
                    return "loginRes." + error;
            }
            return null;
        };

        return DebugRes;
    })();

    return Debug;
})();